var ripple =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _Object$keys = __webpack_require__(28)['default'];

	exports.Remote = __webpack_require__(1).Remote;
	exports.Request = __webpack_require__(2).Request;
	exports.Amount = __webpack_require__(3).Amount;
	exports.Account = __webpack_require__(4).Account;
	exports.Transaction = __webpack_require__(5).Transaction;
	exports.Currency = __webpack_require__(6).Currency;
	exports.Base = __webpack_require__(7).Base;
	exports.UInt128 = __webpack_require__(8).UInt128;
	exports.UInt160 = __webpack_require__(9).UInt160;
	exports.UInt256 = __webpack_require__(10).UInt256;
	exports.Seed = __webpack_require__(11).Seed;
	exports.Meta = __webpack_require__(12).Meta;
	exports.SerializedObject = __webpack_require__(13).SerializedObject;
	exports.RippleError = __webpack_require__(14).RippleError;
	exports.Message = __webpack_require__(15).Message;
	exports.binformat = __webpack_require__(16);
	exports.utils = __webpack_require__(17);
	exports.Server = __webpack_require__(18).Server;
	exports.Ledger = __webpack_require__(19).Ledger;
	exports.TransactionQueue = __webpack_require__(20).TransactionQueue;
	exports.RangeSet = __webpack_require__(21).RangeSet;
	exports.convertBase = __webpack_require__(22);

	exports._test = {
	  Log: __webpack_require__(23),
	  PathFind: __webpack_require__(24).PathFind,
	  TransactionManager: __webpack_require__(25).TransactionManager
	};

	// Important: We do not guarantee any specific version of SJCL or for any
	// specific features to be included. The version and configuration may change at
	// any time without warning.
	//
	// However, for programs that are tied to a specific version of ripple.js like
	// the official client, it makes sense to expose the SJCL instance so we don't
	// have to include it twice.
	exports.sjcl = __webpack_require__(17).sjcl;
	exports.Wallet = __webpack_require__(27)({ sjcl: exports.sjcl });
	exports.types = __webpack_require__(26);

	// camelCase to under_scored API conversion
	function attachUnderscored(name) {
	  var o = exports[name];

	  _Object$keys(o.prototype).forEach(function (key) {
	    var UPPERCASE = /([A-Z]{1})[a-z]+/g;

	    if (!UPPERCASE.test(key)) {
	      return;
	    }

	    var underscored = key.replace(UPPERCASE, function (c) {
	      return '_' + c.toLowerCase();
	    });

	    o.prototype[underscored] = o.prototype[key];
	  });
	}

	['Remote', 'Request', 'Transaction', 'Account', 'Server'].forEach(attachUnderscored);

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	// Interface to manage connections to rippled servers
	//
	// - We never send binary data.
	// - We use the W3C interface for node and browser compatibility:
	//   http://www.w3.org/TR/websockets/#the-websocket-interface
	//
	// This class is intended for both browser and Node.js use.
	//
	// This class is designed to work via peer protocol via either the public or
	// private WebSocket interfaces. The JavaScript class for the peer protocol
	// has not yet been implemented. However, this class has been designed for it
	// to be a very simple drop option.

	var _Object$keys = __webpack_require__(28)['default'];

	var EventEmitter = __webpack_require__(40).EventEmitter;
	var util = __webpack_require__(41);
	var assert = __webpack_require__(38);
	var LRU = __webpack_require__(50);
	var async = __webpack_require__(51);
	var lodash = __webpack_require__(42);
	var Server = __webpack_require__(18).Server;
	var Request = __webpack_require__(2).Request;
	var Amount = __webpack_require__(3).Amount;
	var Currency = __webpack_require__(6).Currency;
	var UInt160 = __webpack_require__(9).UInt160;
	var UInt256 = __webpack_require__(10).UInt256;
	var Transaction = __webpack_require__(5).Transaction;
	var Account = __webpack_require__(4).Account;
	var Meta = __webpack_require__(12).Meta;
	var OrderBook = __webpack_require__(29).OrderBook;
	var PathFind = __webpack_require__(24).PathFind;
	var SerializedObject = __webpack_require__(13).SerializedObject;
	var RippleError = __webpack_require__(14).RippleError;
	var utils = __webpack_require__(17);
	var hashprefixes = __webpack_require__(30);
	var log = __webpack_require__(23).internal.sub('remote');

	/**
	 * Interface to manage connections to rippled servers
	 *
	 * @param {Object} Options
	 */

	function Remote() {
	  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

	  EventEmitter.call(this);

	  var self = this;

	  lodash.merge(this, lodash.defaults(options, Remote.DEFAULTS));

	  this.state = 'offline'; // 'online', 'offline'
	  this._server_fatal = false; // server exited
	  this._stand_alone = undefined;
	  this._testnet = undefined;

	  this._ledger_current_index = undefined;
	  this._ledger_hash = undefined;
	  this._ledger_time = undefined;

	  this._connection_count = 0;
	  this._connected = false;
	  this._should_connect = true;

	  this._transaction_listeners = 0;
	  this._received_tx = new LRU({ max: 100 });
	  this._cur_path_find = null;

	  if (this.local_signing) {
	    // Local signing implies local fees and sequences
	    this.local_sequence = true;
	    this.local_fee = true;
	  }

	  this._servers = [];
	  this._primary_server = undefined;

	  // Cache information for accounts.
	  // DEPRECATED, will be removed
	  // Consider sequence numbers stable if you know you're not generating bad
	  // transactions.
	  // Otherwise, clear it to have it automatically refreshed from the network.
	  // account : { seq : __ }
	  this.accounts = {};

	  // Account objects by AccountId.
	  this._accounts = {};

	  // OrderBook objects
	  this._books = {};

	  // Secrets that we know about.
	  // Secrets can be set by calling set_secret(account, secret).
	  // account : secret
	  this.secrets = {};

	  // Cache for various ledgers.
	  // XXX Clear when ledger advances.
	  this.ledgers = {
	    current: {
	      account_root: {}
	    }
	  };

	  if (typeof this.trusted !== 'boolean') {
	    throw new TypeError('trusted must be a boolean');
	  }
	  if (typeof this.trace !== 'boolean') {
	    throw new TypeError('trace must be a boolean');
	  }
	  if (typeof this.allow_partial_history !== 'boolean') {
	    throw new TypeError('allow_partial_history must be a boolean');
	  }
	  if (typeof this.max_fee !== 'number') {
	    throw new TypeError('max_fee must be a number');
	  }
	  if (typeof this.max_attempts !== 'number') {
	    throw new TypeError('max_attempts must be a number');
	  }
	  if (typeof this.fee_cushion !== 'number') {
	    throw new TypeError('fee_cushion must be a number');
	  }
	  if (typeof this.local_signing !== 'boolean') {
	    throw new TypeError('local_signing must be a boolean');
	  }
	  if (typeof this.local_fee !== 'boolean') {
	    throw new TypeError('local_fee must be a boolean');
	  }
	  if (typeof this.local_sequence !== 'boolean') {
	    throw new TypeError('local_sequence must be a boolean');
	  }
	  if (typeof this.canonical_signing !== 'boolean') {
	    throw new TypeError('canonical_signing must be a boolean');
	  }
	  if (typeof this.submission_timeout !== 'number') {
	    throw new TypeError('submission_timeout must be a number');
	  }
	  if (typeof this.last_ledger_offset !== 'number') {
	    throw new TypeError('last_ledger_offset must be a number');
	  }
	  if (!Array.isArray(this.servers)) {
	    throw new TypeError('servers must be an array');
	  }

	  this.setMaxListeners(this.max_listeners);

	  this.servers.forEach(function (serverOptions) {
	    var server = self.addServer(serverOptions);
	    server.setMaxListeners(self.max_listeners);
	  });

	  function listenersModified(action, event) {
	    // Automatically subscribe and unsubscribe to orderbook
	    // on the basis of existing event listeners
	    if (lodash.contains(Remote.TRANSACTION_EVENTS, event)) {
	      switch (action) {
	        case 'add':
	          if (++self._transaction_listeners === 1) {
	            self.requestSubscribe('transactions').request();
	          }
	          break;
	        case 'remove':
	          if (--self._transaction_listeners === 0) {
	            self.requestUnsubscribe('transactions').request();
	          }
	          break;
	      }
	    }
	  }

	  this.on('newListener', function (event) {
	    listenersModified('add', event);
	  });

	  this.on('removeListener', function (event) {
	    listenersModified('remove', event);
	  });
	}

	util.inherits(Remote, EventEmitter);

	Remote.DEFAULTS = {
	  trusted: false,
	  trace: false,
	  allow_partial_history: true,
	  local_sequence: true,
	  local_fee: true,
	  local_signing: true,
	  canonical_signing: true,
	  fee_cushion: 1.2,
	  max_fee: 1000000, // 1 XRP
	  max_attempts: 10,
	  submission_timeout: 1000 * 20,
	  last_ledger_offset: 3,
	  servers: [],
	  max_listeners: 0 // remove Node EventEmitter warnings
	};

	Remote.TRANSACTION_EVENTS = ['transaction', 'transaction_all'];

	// Flags for ledger entries. In support of account_root().
	Remote.flags = {
	  // AccountRoot
	  account_root: {
	    PasswordSpent: 0x00010000, // password set fee is spent
	    RequireDestTag: 0x00020000, // require a DestinationTag for payments
	    RequireAuth: 0x00040000, // require a authorization to hold IOUs
	    DisallowXRP: 0x00080000, // disallow sending XRP
	    DisableMaster: 0x00100000, // force regular key
	    DefaultRipple: 0x00800000,
	    NoFreeze: 0x00200000, // permanently disallowed freezing trustlines
	    GlobalFreeze: 0x00400000 // trustlines globally frozen
	  },
	  // Offer
	  offer: {
	    Passive: 0x00010000,
	    Sell: 0x00020000 // offer was placed as a sell
	  },
	  // Ripple tate
	  state: {
	    LowReserve: 0x00010000, // entry counts toward reserve
	    HighReserve: 0x00020000,
	    LowAuth: 0x00040000,
	    HighAuth: 0x00080000,
	    LowNoRipple: 0x00100000,
	    HighNoRipple: 0x00200000
	  }
	};

	/**
	 * Check that server message is valid
	 *
	 * @param {Object} message
	 * @return Boolean
	 */

	Remote.isValidMessage = function (message) {
	  return typeof message === 'object' && typeof message.type === 'string';
	};

	/**
	 * Check that server message contains valid
	 * ledger data
	 *
	 * @param {Object} message
	 * @return {Boolean}
	 */

	Remote.isValidLedgerData = function (message) {
	  return typeof message === 'object' && typeof message.fee_base === 'number' && typeof message.fee_ref === 'number' && typeof message.ledger_hash === 'string' && typeof message.ledger_index === 'number' && typeof message.ledger_time === 'number' && typeof message.reserve_base === 'number' && typeof message.reserve_inc === 'number';
	};

	/**
	 * Check that server message contains valid
	 * load status data
	 *
	 * @param {Object} message
	 * @return {Boolean}
	 */

	Remote.isValidLoadStatus = function (message) {
	  return typeof message.load_base === 'number' && typeof message.load_factor === 'number';
	};

	/**
	 * Check that provided ledger is validated
	 *
	 * @param {Object} ledger
	 * @return {Boolean}
	 */

	Remote.isValidated = function (message) {
	  return message && typeof message === 'object' && message.validated === true;
	};

	/**
	 * Set the emitted state: 'online' or 'offline'
	 *
	 * @param {String} state
	 */

	Remote.prototype._setState = function (state) {
	  if (this.state !== state) {
	    if (this.trace) {
	      log.info('set_state:', state);
	    }

	    this.state = state;
	    this.emit('state', state);

	    switch (state) {
	      case 'online':
	        this._online_state = 'open';
	        this._connected = true;
	        this.emit('connect');
	        this.emit('connected');
	        break;
	      case 'offline':
	        this._online_state = 'closed';
	        this._connected = false;
	        this.emit('disconnect');
	        this.emit('disconnected');
	        break;
	    }
	  }
	};

	/**
	 * Inform remote that the remote server is not comming back.
	 */

	Remote.prototype.setServerFatal = function () {
	  this._server_fatal = true;
	};

	/**
	 * Enable debug output
	 *
	 * @param {Boolean} trace
	 */

	Remote.prototype.setTrace = function (trace) {
	  this.trace = trace === undefined || trace;
	  return this;
	};

	Remote.prototype._trace = function () {
	  if (this.trace) {
	    log.info.apply(log, arguments);
	  }
	};

	/**
	 * Store a secret - allows the Remote to automatically fill
	 * out auth information.
	 *
	 * @param {String} account
	 * @param {String} secret
	 */

	Remote.prototype.setSecret = function (account, secret) {
	  this.secrets[account] = secret;
	};

	Remote.prototype.addServer = function (options) {
	  var self = this;
	  var server = new Server(this, options);

	  function serverMessage(data) {
	    self._handleMessage(data, server);
	  }

	  server.on('message', serverMessage);

	  function serverConnect() {
	    self._connection_count += 1;

	    if (options.primary) {
	      self._setPrimaryServer(server);
	    }
	    if (self._connection_count === 1) {
	      self._setState('online');
	    }
	    if (self._connection_count === self._servers.length) {
	      self.emit('ready');
	    }
	  }

	  server.on('connect', serverConnect);

	  function serverDisconnect() {
	    self._connection_count--;
	    if (self._connection_count === 0) {
	      self._setState('offline');
	    }
	  }

	  server.on('disconnect', serverDisconnect);

	  this._servers.push(server);

	  return server;
	};

	/**
	 * Reconnect to Ripple network
	 */

	Remote.prototype.reconnect = function () {
	  if (!this._should_connect) {
	    return;
	  }

	  log.info('reconnecting');

	  this._servers.forEach(function (server) {
	    server.reconnect();
	  });
	};

	/**
	 * Connect to the Ripple network
	 *
	 * @param {Function} callback
	 * @api public
	 */

	Remote.prototype.connect = function (callback) {
	  if (!this._servers.length) {
	    throw new Error('No servers available.');
	  }

	  if (typeof callback === 'function') {
	    this.once('connect', callback);
	  }

	  this._should_connect = true;

	  this._servers.forEach(function (server) {
	    server.connect();
	  });

	  return this;
	};

	/**
	 * Disconnect from the Ripple network.
	 *
	 * @param {Function} callback
	 * @api public
	 */

	Remote.prototype.disconnect = function (callback_) {
	  if (!this._servers.length) {
	    throw new Error('No servers available, not disconnecting');
	  }

	  var callback = lodash.isFunction(callback_) ? callback_ : function () {};

	  this._should_connect = false;

	  if (!this.isConnected()) {
	    callback();
	    return this;
	  }

	  this.once('disconnect', callback);

	  this._servers.forEach(function (server) {
	    server.disconnect();
	  });

	  this._set_state('offline');

	  return this;
	};

	/**
	 * Handle server message. Server messages are proxied to
	 * the Remote, such that global events can be handled
	 *
	 * It is possible for messages to be dispatched after the
	 * connection is closed.
	 *
	 * @param {JSON} message
	 * @param {Server} server
	 */

	Remote.prototype._handleMessage = function (message, server) {
	  if (!Remote.isValidMessage(message)) {
	    // Unexpected response from remote.
	    var error = new RippleError('remoteUnexpected', 'Unexpected response from remote: ' + JSON.stringify(message));

	    this.emit('error', error);
	    log.error(error);
	    return;
	  }

	  switch (message.type) {
	    case 'ledgerClosed':
	      this._handleLedgerClosed(message, server);
	      break;
	    case 'serverStatus':
	      this._handleServerStatus(message, server);
	      break;
	    case 'transaction':
	      this._handleTransaction(message, server);
	      break;
	    case 'path_find':
	      this._handlePathFind(message, server);
	      break;
	    default:
	      if (this.trace) {
	        log.info(message.type + ': ', message);
	      }
	      break;
	  }
	};

	Remote.prototype.getLedgerSequence = function () {
	  if (!this._ledger_current_index) {
	    throw new Error('Ledger sequence has not yet been initialized');
	  }
	  return this._ledger_current_index;
	};

	/**
	 * Handle server ledger_closed event
	 *
	 * @param {Object} message
	 */

	Remote.prototype._handleLedgerClosed = function (message, server) {
	  var self = this;

	  // XXX If not trusted, need to verify we consider ledger closed.
	  // XXX Also need to consider a slow server or out of order response.
	  // XXX Be more defensive fields could be missing or of wrong type.
	  // YYY Might want to do some cache management.
	  if (!Remote.isValidLedgerData(message)) {
	    return;
	  }

	  var ledgerAdvanced = message.ledger_index >= this._ledger_current_index;

	  if (isNaN(this._ledger_current_index) || ledgerAdvanced) {
	    this._ledger_time = message.ledger_time;
	    this._ledger_hash = message.ledger_hash;
	    this._ledger_current_index = message.ledger_index + 1;

	    if (this.isConnected()) {
	      this.emit('ledger_closed', message, server);
	    } else {
	      this.once('connect', function () {
	        // Delay until server is 'online'
	        self.emit('ledger_closed', message, server);
	      });
	    }
	  }
	};

	/**
	 * Handle server server_status event
	 *
	 * @param {Object} message
	 */

	Remote.prototype._handleServerStatus = function (message, server) {
	  this.emit('server_status', message, server);
	};

	/**
	 * Handle server transaction event
	 *
	 * @param {Object} message
	 */

	Remote.prototype._handleTransaction = function (message, server) {
	  // XXX If not trusted, need proof.
	  var transactionHash = message.transaction.hash;

	  if (this._received_tx.get(transactionHash)) {
	    // De-duplicate transactions
	    return;
	  }

	  if (message.validated) {
	    this._received_tx.set(transactionHash, true);
	  }

	  if (this.trace) {
	    log.info('tx:', message);
	  }

	  var metadata = message.meta || message.metadata;

	  if (metadata) {
	    // Process metadata
	    message.mmeta = new Meta(metadata);

	    // Pass the event on to any related Account objects
	    message.mmeta.getAffectedAccounts().forEach(function (account) {
	      if (this._accounts[account]) {
	        this._accounts[account].notify(message);
	      }
	    }, this);

	    // Pass the event on to any related OrderBooks
	    message.mmeta.getAffectedBooks().forEach(function (book) {
	      if (this._books[book]) {
	        this._books[book].notify(message);
	      }
	    }, this);
	  } else {
	    // Transaction could be from proposed transaction stream
	    // XX
	    ['Account', 'Destination'].forEach(function (prop) {
	      if (this._accounts[message.transaction[prop]]) {
	        this._accounts[message.transaction[prop]].notify(message);
	      }
	    }, this);
	  }

	  this.emit('transaction', message, server);
	  this.emit('transaction_all', message, server);
	};

	/**
	 * Handle server path_find event
	 *
	 * @param {Object} message
	 */

	Remote.prototype._handlePathFind = function (message, server) {
	  // Pass the event to the currently open PathFind object
	  if (this._cur_path_find) {
	    this._cur_path_find.notify_update(message);
	  }

	  this.emit('path_find_all', message, server);
	};

	/**
	 * Returns the current ledger hash
	 *
	 * @return {String} ledger hash
	 */

	Remote.prototype.getLedgerHash = function () {
	  return this._ledger_hash;
	};

	/**
	 * Set primary server. Primary server will be selected
	 * to handle requested regardless of its internally-tracked
	 * priority score
	 *
	 * @param {Server} server
	 */

	Remote.prototype._setPrimaryServer = Remote.prototype.setPrimaryServer = function (server) {
	  if (this._primary_server) {
	    this._primary_server._primary = false;
	  }
	  this._primary_server = server;
	  this._primary_server._primary = true;
	};

	/**
	 * Get connected state
	 *
	 * @return {Boolean} connected
	 */

	Remote.prototype.isConnected = function () {
	  return this._connected;
	};

	/**
	 * Get array of connected servers
	 */

	Remote.prototype.getConnectedServers = function () {
	  return this._servers.filter(function (server) {
	    return server.isConnected();
	  });
	};

	/**
	 * Select a server to handle a request. Servers are
	 * automatically prioritized
	 */

	Remote.prototype._getServer = Remote.prototype.getServer = function () {
	  if (this._primary_server && this._primary_server.isConnected()) {
	    return this._primary_server;
	  }

	  if (!this._servers.length) {
	    return null;
	  }

	  var connectedServers = this.getConnectedServers();
	  if (connectedServers.length === 0 || !connectedServers[0]) {
	    return null;
	  }

	  var server = connectedServers[0];
	  var cScore = server._score + server._fee;

	  for (var i = 1; i < connectedServers.length; i++) {
	    var _server = connectedServers[i];
	    var bScore = _server._score + _server._fee;
	    if (bScore < cScore) {
	      server = _server;
	      cScore = bScore;
	    }
	  }

	  return server;
	};

	/**
	 * Send a request. This method is called internally by Request
	 * objects. Each Request contains a reference to Remote, and
	 * Request.request calls Request.remote.request
	 *
	 * @param {Request} request
	 */

	Remote.prototype.request = function (request_) {
	  var request = request_;

	  if (typeof request === 'string') {
	    if (!/^request_/.test(request)) {
	      request = 'request_' + request;
	    }

	    if (typeof this[request] === 'function') {
	      var args = Array.prototype.slice.call(arguments, 1);
	      return this[request].apply(this, args);
	    }

	    throw new Error('Command does not exist: ' + request);
	  }

	  if (!(request instanceof Request)) {
	    throw new Error('Argument is not a Request');
	  }

	  if (!this._servers.length) {
	    return request.emit('error', new Error('No servers available'));
	  }
	  if (!this.isConnected()) {
	    return this.once('connect', this.request.bind(this, request));
	  }
	  if (request.server === null) {
	    return request.emit('error', new Error('Server does not exist'));
	  }

	  var server = request.server || this.getServer();
	  if (server) {
	    server._request(request);
	  } else {
	    request.emit('error', new Error('No servers available'));
	  }
	};

	/**
	 * Request ping
	 *
	 * @param [String] server host
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.ping = Remote.prototype.requestPing = function (host, callback_) {
	  var request = new Request(this, 'ping');
	  var callback = callback_;

	  switch (typeof host) {
	    case 'function':
	      callback = host;
	      break;
	    case 'string':
	      request.setServer(host);
	      break;
	  }

	  var then = Date.now();

	  request.once('success', function () {
	    request.emit('pong', Date.now() - then);
	  });

	  request.callback(callback, 'pong');

	  return request;
	};

	/**
	 * Request server_info
	 *
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestServerInfo = function (callback) {
	  return new Request(this, 'server_info').callback(callback);
	};

	/**
	 * Request ledger
	 *
	 * @return {Request} request
	 */

	Remote.prototype.requestLedger = function (options, callback_) {
	  // XXX This is a bad command. Some variants don't scale.
	  // XXX Require the server to be trusted.
	  // utils.assert(this.trusted);

	  var request = new Request(this, 'ledger');
	  var callback = callback_;

	  switch (typeof options) {
	    case 'undefined':
	      break;
	    case 'function':
	      callback = options;
	      break;

	    case 'object':
	      if (!options) {
	        break;
	      }

	      _Object$keys(options).forEach(function (o) {
	        switch (o) {
	          case 'full':
	          case 'expand':
	          case 'transactions':
	          case 'accounts':
	            request.message[o] = options[o] ? true : false;
	            break;
	          case 'ledger':
	            request.selectLedger(options.ledger);
	            break;
	          case 'ledger_index':
	          case 'ledger_hash':
	            request.message[o] = options[o];
	            break;
	          case 'closed':
	          case 'current':
	          case 'validated':
	            request.message.ledger_index = o;
	            break;
	        }
	      }, options);
	      break;

	    default:
	      request.selectLedger(options);
	      break;
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request ledger_closed
	 *
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestLedgerClosed = Remote.prototype.requestLedgerHash = function (callback) {
	  // utils.assert(this.trusted);   // If not trusted, need to check proof.
	  return new Request(this, 'ledger_closed').callback(callback);
	};

	/**
	 * Request ledger_header
	 *
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestLedgerHeader = function (callback) {
	  return new Request(this, 'ledger_header').callback(callback);
	};

	/**
	 * Request ledger_current
	 *
	 * Get the current proposed ledger entry. May be closed (and revised)
	 * at any time (even before returning).
	 *
	 * Only for unit testing.
	 *
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestLedgerCurrent = function (callback) {
	  return new Request(this, 'ledger_current').callback(callback);
	};

	/**
	 * Request ledger_data
	 *
	 * Get the contents of a specified ledger
	 *
	 * @param {Object} options
	 * @property {Boolean} [options.binary]- Flag which determines if rippled
	 * returns binary or parsed JSON
	 * @property {String|Number} [options.ledger] - Hash or sequence of a ledger
	 * to get contents for
	 * @property {Number} [options.limit] - Number of contents to retrieve
	 * from the ledger
	 * @property {Function} callback
	 *
	 * @callback
	 * @param {Error} error
	 * @param {LedgerData} ledgerData
	 *
	 * @return {Request} request
	 */

	Remote.prototype.requestLedgerData = function (options, callback) {
	  var request = new Request(this, 'ledger_data');

	  request.message.binary = options.binary !== false;
	  request.selectLedger(options.ledger);
	  request.message.limit = options.limit;

	  request.once('success', function (res) {
	    if (options.binary === false) {
	      request.emit('state', res);
	      return;
	    }

	    function iterator(ledgerData, next) {
	      async.setImmediate(function () {
	        next(null, Remote.parseBinaryLedgerData(ledgerData));
	      });
	    }

	    function complete(err, state) {
	      if (err) {
	        request.emit('error', err);
	      } else {
	        res.state = state;
	        request.emit('state', res);
	      }
	    }

	    async.mapSeries(res.state, iterator, complete);
	  });

	  request.callback(callback, 'state');

	  return request;
	};

	/**
	 * Request ledger_entry
	 *
	 * @param [String] type
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestLedgerEntry = function (type, callback_) {
	  // utils.assert(this.trusted);
	  // If not trusted, need to check proof, maybe talk packet protocol.

	  var self = this;

	  var request = new Request(this, 'ledger_entry');
	  var callback = lodash.isFunction(type) ? type : callback_;

	  // Transparent caching. When .request() is invoked, look in the Remote object
	  // for the result.  If not found, listen, cache result, and emit it.
	  //
	  // Transparent caching:
	  if (type === 'account_root') {
	    request.request_default = request.request;

	    request.request = function () {
	      // Intercept default request.
	      var bDefault = true;

	      if (!self._ledger_hash && type === 'account_root') {
	        var cache = self.ledgers.current.account_root;

	        if (!cache) {
	          cache = self.ledgers.current.account_root = {};
	        }

	        var node = self.ledgers.current.account_root[request.message.account_root];

	        if (node) {
	          // Emulate fetch of ledger entry.
	          // console.log('request_ledger_entry: emulating');
	          // YYY Missing lots of fields.
	          request.emit('success', { node: node });
	          bDefault = false;
	        } else {
	          // Was not cached.
	          // XXX Only allow with trusted mode.  Must sync response with advance
	          switch (type) {
	            case 'account_root':
	              request.once('success', function (message) {
	                // Cache node.
	                // console.log('request_ledger_entry: caching');
	                self.ledgers.current.account_root[message.node.Account] = message.node;
	              });
	              break;

	            default:
	            // This type not cached.
	            // console.log('request_ledger_entry: non-cached type');
	          }
	        }
	      }

	      if (bDefault) {
	        // console.log('request_ledger_entry: invoking');
	        request.request_default();
	      }
	    };
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request subscribe
	 *
	 * @param {Array} streams
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestSubscribe = function (streams, callback) {
	  var request = new Request(this, 'subscribe');

	  if (streams) {
	    request.message.streams = Array.isArray(streams) ? streams : [streams];
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request usubscribe
	 *
	 * @param {Array} streams
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestUnsubscribe = function (streams, callback) {
	  var request = new Request(this, 'unsubscribe');

	  if (streams) {
	    request.message.streams = Array.isArray(streams) ? streams : [streams];
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request transaction_entry
	 *
	 * @param {String} transaction hash
	 * @param {String|Number} ledger hash or sequence
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestTransactionEntry = function (options_, callback_) {
	  // If not trusted, need to check proof, maybe talk packet protocol.
	  // utils.assert(this.trusted);
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({
	      ledger: options_.ledger_index || options_.ledger_hash
	    }, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      hash: args.shift(),
	      ledger: args.shift()
	    };
	  }

	  var request = new Request(this, 'transaction_entry');
	  request.txHash(options.hash);

	  switch (typeof options.ledger) {
	    case 'string':
	    case 'number':
	      request.selectLedger(options.ledger);
	      break;
	    case 'undefined':
	      request.ledgerIndex('validated');
	      break;
	    default:
	      throw new Error('ledger must be a ledger index or hash');
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request tx
	 *
	 * @param {Object|String} hash
	 * @property {String} hash.hash           - Transaction hash
	 * @property {Boolean} [hash.binary=true] - Flag which determines if rippled
	 * returns binary or parsed JSON
	 * @param [Function] callback
	 * @return {Request} request
	 */

	Remote.prototype.requestTransaction = Remote.prototype.requestTx = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      hash: args.shift(),
	      binary: args.shift()
	    };
	  }

	  var request = new Request(this, 'tx');
	  request.message.binary = options.binary !== false;
	  request.message.transaction = options.hash;

	  request.once('success', function (res) {
	    if (options.binary === false) {
	      request.emit('transaction', res);
	      return;
	    }

	    request.emit('transaction', Remote.parseBinaryTransaction(res));
	  });

	  request.callback(callback, 'transaction');

	  return request;
	};

	/**
	 * Account Request
	 *
	 * Optional paging with limit and marker options
	 * supported in rippled for 'account_lines' and 'account_offers'
	 *
	 * The paged responses aren't guaranteed to be reliable between
	 * ledger closes. You have to supply a ledger_index or ledger_hash
	 * when paging to ensure a complete response
	 *
	 * @param {String} type - request name, e.g. 'account_lines'
	 * @param {Object} options - all optional
	 *   @param {String} account - ripple address
	 *   @param {String} peer - ripple address
	 *   @param [String|Number] ledger identifier
	 *   @param [Number] limit - max results per response
	 *   @param {String} marker - start position in response paging
	 * @param [Function] callback
	 * @return {Request}
	 * @throws {Error} if a marker is provided, but no ledger_index or ledger_hash
	 */

	Remote.accountRequest = function (command, options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      account: args.shift(),
	      peer: args.shift(),
	      ledger: args.shift(),
	      limit: args.shift(),
	      marker: args.shift()
	    };
	  }

	  var _options = options;

	  // if a marker is given, we need a ledger
	  // check if a valid ledger_index or ledger_hash is provided
	  var account = _options.account;
	  var ledger = _options.ledger;
	  var peer = _options.peer;
	  var limit = _options.limit;
	  var marker = _options.marker;
	  if (marker) {
	    if (!(Number(ledger) > 0) && !UInt256.is_valid(ledger)) {
	      throw new Error('A ledger_index or ledger_hash must be provided when using a marker');
	    }
	  }

	  var request = new Request(this, command);

	  if (account) {
	    account = UInt160.json_rewrite(account);
	    request.message.account = account;
	  }

	  request.selectLedger(ledger);

	  if (UInt160.is_valid(peer)) {
	    request.message.peer = UInt160.json_rewrite(peer);
	  }

	  if (!isNaN(limit)) {
	    limit = Number(limit);

	    // max for 32-bit unsigned int is 4294967295
	    // we'll clamp to 1e9
	    if (limit > 1e9) {
	      limit = 1e9;
	    }
	    // min for 32-bit unsigned int is 0
	    // we'll clamp to 0
	    if (limit < 0) {
	      limit = 0;
	    }

	    request.message.limit = limit;
	  }

	  if (marker) {
	    request.message.marker = marker;
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request account_info
	 *
	 * @param {Object} options
	 *   @param {String} account - ripple address
	 *   @param {String} peer - ripple address
	 *   @param [String|Number] ledger identifier
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountInfo = function () {
	  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	    args[_key] = arguments[_key];
	  }

	  var options = ['account_info'].concat(args);
	  return Remote.accountRequest.apply(this, options);
	};

	/**
	 * Request account_currencies
	 *
	 * @param {Object} options
	 *   @param {String} account - ripple address
	 *   @param {String} peer - ripple address
	 *   @param [String|Number] ledger identifier
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountCurrencies = function () {
	  for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
	    args[_key2] = arguments[_key2];
	  }

	  var options = ['account_currencies'].concat(args);
	  return Remote.accountRequest.apply(this, options);
	};

	/**
	 * Request account_lines
	 *
	 * Requests for account_lines support paging, provide a limit and marker
	 * to page through responses.
	 *
	 * The paged responses aren't guaranteed to be reliable between
	 * ledger closes. You have to supply a ledger_index or ledger_hash
	 * when paging to ensure a complete response
	 *
	 * @param {Object} options
	 *   @param {String} account - ripple address
	 *   @param {String} peer - ripple address
	 *   @param [String|Number] ledger identifier
	 *   @param [Number] limit - max results per response
	 *   @param {String} marker - start position in response paging
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountLines = function () {
	  for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
	    args[_key3] = arguments[_key3];
	  }

	  // XXX Does this require the server to be trusted?
	  // utils.assert(this.trusted);
	  var options = ['account_lines'].concat(args);
	  return Remote.accountRequest.apply(this, options);
	};

	/**
	 * Request account_offers
	 *
	 * Requests for account_offers support paging, provide a limit and marker
	 * to page through responses.
	 *
	 * The paged responses aren't guaranteed to be reliable between
	 * ledger closes. You have to supply a ledger_index or ledger_hash
	 * when paging to ensure a complete response
	 *
	 * @param {Object} options
	 *   @param {String} account - ripple address
	 *   @param [String|Number] ledger identifier
	 *   @param [Number] limit - max results per response
	 *   @param {String} marker - start position in response paging
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountOffers = function () {
	  for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
	    args[_key4] = arguments[_key4];
	  }

	  var options = ['account_offers'].concat(args);
	  return Remote.accountRequest.apply(this, options);
	};

	/**
	 * Request account_tx
	 *
	 * @param {Object} options
	 *
	 *    @param {String} account
	 *    @param [Number] ledger_index_min defaults to -1
	 *    @param [Number] ledger_index_max defaults to -1
	 *    @param [Boolean] binary, defaults to true
	 *    @param [Boolean] parseBinary, defaults to true
	 *    @param [Boolean] count, defaults to false
	 *    @param [Boolean] descending, defaults to false
	 *    @param [Number] offset, defaults to 0
	 *    @param [Number] limit
	 *
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountTransactions = Remote.prototype.requestAccountTx = function (options, callback) {
	  // XXX Does this require the server to be trusted?
	  // utils.assert(this.trusted);

	  var request = new Request(this, 'account_tx');

	  options.binary = options.binary !== false;

	  if (options.min_ledger !== undefined) {
	    options.ledger_index_min = options.min_ledger;
	  }

	  if (options.max_ledger !== undefined) {
	    options.ledger_index_max = options.max_ledger;
	  }

	  if (options.binary && options.parseBinary === undefined) {
	    options.parseBinary = true;
	  }

	  _Object$keys(options).forEach(function (o) {
	    switch (o) {
	      case 'account':
	      case 'ledger_index_min': // earliest
	      case 'ledger_index_max': // latest
	      case 'binary': // false
	      case 'count': // false
	      case 'descending': // false
	      case 'offset': // 0
	      case 'limit':

	      // extended account_tx
	      case 'forward': // false
	      case 'marker':
	        request.message[o] = this[o];
	        break;
	    }
	  }, options);

	  request.once('success', function (res) {
	    if (!options.parseBinary) {
	      request.emit('transactions', res);
	      return;
	    }

	    function iterator(transaction, next) {
	      async.setImmediate(function () {
	        next(null, Remote.parseBinaryAccountTransaction(transaction));
	      });
	    }

	    function complete(err, transactions) {
	      if (err) {
	        request.emit('error', err);
	      } else {
	        res.transactions = transactions;
	        request.emit('transactions', res);
	      }
	    }

	    async.mapSeries(res.transactions, iterator, complete);
	  });

	  request.callback(callback, 'transactions');

	  return request;
	};

	/**
	 * @param {Object} transaction
	 * @return {Transaction}
	 */

	Remote.parseBinaryAccountTransaction = function (transaction) {
	  var tx_obj = new SerializedObject(transaction.tx_blob);
	  var tx_obj_json = tx_obj.to_json();
	  var meta = new SerializedObject(transaction.meta).to_json();

	  var tx_result = {
	    validated: transaction.validated
	  };

	  tx_result.meta = meta;
	  tx_result.tx = tx_obj_json;
	  tx_result.tx.hash = tx_obj.hash(hashprefixes.HASH_TX_ID).to_hex();
	  tx_result.tx.ledger_index = transaction.ledger_index;
	  tx_result.tx.inLedger = transaction.ledger_index;

	  if (typeof meta.DeliveredAmount === 'object') {
	    tx_result.meta.delivered_amount = meta.DeliveredAmount;
	  } else {
	    switch (typeof tx_obj_json.Amount) {
	      case 'string':
	      case 'object':
	        tx_result.meta.delivered_amount = tx_obj_json.Amount;
	        break;
	    }
	  }

	  return tx_result;
	};

	Remote.parseBinaryTransaction = function (transaction) {
	  var tx_obj = new SerializedObject(transaction.tx).to_json();
	  var meta = new SerializedObject(transaction.meta).to_json();

	  var tx_result = tx_obj;

	  tx_result.date = transaction.date;
	  tx_result.hash = transaction.hash;
	  tx_result.inLedger = transaction.inLedger;
	  tx_result.ledger_index = transaction.ledger_index;
	  tx_result.meta = meta;
	  tx_result.validated = transaction.validated;

	  switch (typeof meta.DeliveredAmount) {
	    case 'string':
	    case 'object':
	      tx_result.meta.delivered_amount = meta.DeliveredAmount;
	      break;
	    default:
	      switch (typeof tx_obj.Amount) {
	        case 'string':
	        case 'object':
	          tx_result.meta.delivered_amount = tx_obj.Amount;
	          break;
	      }
	  }

	  return tx_result;
	};

	/**
	 * Parse binary ledger state data
	 *
	 * @param {Object} ledgerData
	 * @property {String} ledgerData.data
	 * @property {String} ledgerData.index
	 *
	 * @return {State}
	 */

	Remote.parseBinaryLedgerData = function (ledgerData) {
	  var data = new SerializedObject(ledgerData.data).to_json();
	  data.index = ledgerData.index;
	  return data;
	};

	/**
	 * Request the overall transaction history.
	 *
	 * Returns a list of transactions that happened recently on the network. The
	 * default number of transactions to be returned is 20.
	 *
	 * @param [Number] start
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestTransactionHistory = Remote.prototype.requestTxHistory = function (start_, callback_) {
	  // XXX Does this require the server to be trusted?
	  // utils.assert(this.trusted);

	  var request = new Request(this, 'tx_history');
	  var start = start_;
	  var callback = callback_;

	  if (lodash.isPlainObject(start)) {
	    start = start.start;
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');
	  }

	  request.message.start = start;
	  request.callback(callback);

	  return request;
	};

	/**
	 * Request book_offers
	 *
	 * @param {Object} options
	 *   @param {Object} options.gets - taker_gets with issuer and currency
	 *   @param {Object} options.pays - taker_pays with issuer and currency
	 *   @param {String} [options.taker]
	 *   @param {String} [options.ledger]
	 *   @param {String|Number} [options.limit]
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestBookOffers = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (options_.gets || options_.taker_gets) {
	    options = lodash.merge({
	      pays: options_.taker_pays,
	      gets: options_.taker_gets
	    }, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      gets: args.shift(),
	      pays: args.shift(),
	      taker: args.shift(),
	      ledger: args.shift(),
	      limit: args.shift()
	    };
	  }

	  var _options2 = options;
	  var gets = _options2.gets;
	  var pays = _options2.pays;
	  var taker = _options2.taker;
	  var ledger = _options2.ledger;
	  var limit = _options2.limit;

	  var request = new Request(this, 'book_offers');

	  request.message.taker_gets = {
	    currency: Currency.json_rewrite(gets.currency, { force_hex: true })
	  };

	  if (!Currency.from_json(request.message.taker_gets.currency).is_native()) {
	    request.message.taker_gets.issuer = UInt160.json_rewrite(gets.issuer);
	  }

	  request.message.taker_pays = {
	    currency: Currency.json_rewrite(pays.currency, { force_hex: true })
	  };

	  if (!Currency.from_json(request.message.taker_pays.currency).is_native()) {
	    request.message.taker_pays.issuer = UInt160.json_rewrite(pays.issuer);
	  }

	  request.message.taker = taker ? taker : UInt160.ACCOUNT_ONE;
	  request.selectLedger(ledger);

	  if (!isNaN(limit)) {
	    limit = Number(limit);

	    // max for 32-bit unsigned int is 4294967295
	    // we'll clamp to 1e9
	    if (limit > 1e9) {
	      limit = 1e9;
	    }
	    // min for 32-bit unsigned int is 0
	    // we'll clamp to 0
	    if (limit < 0) {
	      limit = 0;
	    }

	    request.message.limit = limit;
	  }

	  request.callback(callback);
	  return request;
	};

	/**
	 * Request wallet_accounts
	 *
	 * @param {String} seed
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestWalletAccounts = function (options_, callback_) {
	  utils.assert(this.trusted); // Don't send secrets.

	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    options = {
	      seed: arguments[0]
	    };
	  }

	  var request = new Request(this, 'wallet_accounts');
	  request.message.seed = options.seed;
	  request.callback(callback);

	  return request;
	};

	/**
	 * Request sign
	 *
	 * @param {String} secret
	 * @param {Object} tx_json
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestSign = function (options_, callback_) {
	  utils.assert(this.trusted); // Don't send secrets.

	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    options = {
	      secret: arguments[0],
	      tx_json: arguments[1]
	    };

	    callback = arguments[2];
	  }

	  var request = new Request(this, 'sign');
	  request.message.secret = options.secret;
	  request.message.tx_json = options.tx_json;
	  request.callback(callback);

	  return request;
	};

	/**
	 * Request submit
	 *
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestSubmit = function (callback) {
	  return new Request(this, 'submit').callback(callback);
	};

	/**
	 * Create a subscribe request with current subscriptions.
	 *
	 * Other classes can add their own subscriptions to this request by listening
	 * to the server_subscribe event.
	 *
	 * This function will create and return the request, but not submit it.
	 *
	 * @param [Function] callback
	 * @api private
	 */

	Remote.prototype._serverPrepareSubscribe = function (server, callback_) {
	  var self = this;
	  var feeds = ['ledger', 'server'];
	  var callback = lodash.isFunction(server) ? server : callback_;

	  if (this._transaction_listeners) {
	    feeds.push('transactions');
	  }

	  var request = this.requestSubscribe(feeds);

	  function serverSubscribed(message) {
	    self._stand_alone = !!message.stand_alone;
	    self._testnet = !!message.testnet;
	    self._handleLedgerClosed(message, server);
	    self.emit('subscribed');
	  }

	  request.on('error', function (err) {
	    if (self.trace) {
	      log.info('Initial server subscribe failed', err);
	    }
	  });

	  request.once('success', serverSubscribed);

	  self.emit('prepare_subscribe', request);

	  request.callback(callback, 'subscribed');

	  return request;
	};

	/**
	 * For unit testing: ask the remote to accept the current ledger.
	 * To be notified when the ledger is accepted, server_subscribe() then listen
	 * to 'ledger_hash' events. A good way to be notified of the result of this is:
	 * remote.on('ledger_closed', function(ledger_closed, ledger_index) { ... } );
	 *
	 * @param [Function] callback
	 */

	Remote.prototype.ledgerAccept = Remote.prototype.requestLedgerAccept = function (callback) {
	  /* eslint-disable consistent-return */
	  var request = new Request(this, 'ledger_accept');

	  if (!this._stand_alone) {
	    // XXX This should emit error on the request
	    this.emit('error', new RippleError('notStandAlone'));
	    return;
	  }

	  this.once('ledger_closed', function (ledger) {
	    request.emit('ledger_closed', ledger);
	  });

	  request.callback(callback, 'ledger_closed');
	  request.request();

	  return request;
	  /* eslint-enable consistent-return */
	};

	/**
	 * Account root request abstraction
	 *
	 * @this Remote
	 * @api private
	 */

	Remote.accountRootRequest = function (command, filter, options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      account: args.shift(),
	      ledger: args.shift()
	    };
	  }

	  var request = this.requestLedgerEntry('account_root');
	  request.accountRoot(options.account);
	  request.selectLedger(options.ledger);

	  request.once('success', function (message) {
	    request.emit(command, filter(message));
	  });

	  request.callback(callback, command);

	  return request;
	};

	/**
	 * Request account balance
	 *
	 * @param {String} account
	 * @param [String|Number] ledger
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountBalance = function () {
	  function responseFilter(message) {
	    return Amount.from_json(message.node.Balance);
	  }

	  for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
	    args[_key5] = arguments[_key5];
	  }

	  var options = ['account_balance', responseFilter].concat(args);
	  return Remote.accountRootRequest.apply(this, options);
	};

	/**
	 * Request account flags
	 *
	 * @param {String} account
	 * @param [String|Number] ledger
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestAccountFlags = function () {
	  function responseFilter(message) {
	    return message.node.Flags;
	  }

	  for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
	    args[_key6] = arguments[_key6];
	  }

	  var options = ['account_flags', responseFilter].concat(args);
	  return Remote.accountRootRequest.apply(this, options);
	};

	/**
	 * Request owner count
	 *
	 * @param {String} account
	 * @param [String|Number] ledger
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestOwnerCount = function () {
	  function responseFilter(message) {
	    return message.node.OwnerCount;
	  }

	  for (var _len7 = arguments.length, args = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
	    args[_key7] = arguments[_key7];
	  }

	  var options = ['owner_count', responseFilter].concat(args);
	  return Remote.accountRootRequest.apply(this, options);
	};

	/**
	 * Get an account by accountID (address)
	 *
	 *
	 * @param {String} account
	 * @return {Account}
	 */

	Remote.prototype.getAccount = function (accountID) {
	  return this._accounts[UInt160.json_rewrite(accountID)];
	};

	/**
	 * Add an account by accountID (address)
	 *
	 * @param {String} account
	 * @return {Account}
	 */

	Remote.prototype.addAccount = function (accountID) {
	  var account = new Account(this, accountID);

	  if (account.isValid()) {
	    this._accounts[accountID] = account;
	  }

	  return account;
	};

	/**
	 * Add an account if it does not exist, return the
	 * account by accountID (address)
	 *
	 * @param {String} account
	 * @return {Account}
	 */

	Remote.prototype.account = Remote.prototype.findAccount = function (accountID) {
	  var account = this.getAccount(accountID);
	  return account ? account : this.addAccount(accountID);
	};

	/**
	 * Create a pathfind
	 *
	 * @param {Object} options
	 * @return {PathFind}
	 */

	function createPathFind(options_) {
	  var options = undefined;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    options = {
	      src_account: arguments[0],
	      dst_account: arguments[1],
	      dst_amount: arguments[2],
	      src_currencies: arguments[3]
	    };
	  }

	  var pathFind = new PathFind(this, options.src_account, options.dst_account, options.dst_amount, options.src_currencies);

	  if (this._cur_path_find) {
	    this._cur_path_find.notify_superceded();
	  }

	  pathFind.create();

	  this._cur_path_find = pathFind;

	  return pathFind;
	}

	Remote.prototype.pathFind = Remote.prototype.createPathFind = createPathFind;

	Remote.prepareTrade = function (currency, issuer) {
	  var suffix = Currency.from_json(currency).is_native() ? '' : '/' + issuer;
	  return currency + suffix;
	};

	/**
	 * Create an OrderBook if it does not exist, return
	 * the order book
	 *
	 * @param {Object} options
	 * @return {OrderBook}
	 */

	Remote.prototype.book = Remote.prototype.createOrderBook = function (options_) {
	  var options = undefined;

	  if (arguments.length === 1) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');
	    options = {
	      currency_gets: arguments[0],
	      issuer_gets: arguments[1],
	      currency_pays: arguments[2],
	      issuer_pays: arguments[3]
	    };
	  }

	  var gets = Remote.prepareTrade(options.currency_gets, options.issuer_gets);
	  var pays = Remote.prepareTrade(options.currency_pays, options.issuer_pays);
	  var key = gets + ':' + pays;

	  if (this._books.hasOwnProperty(key)) {
	    return this._books[key];
	  }

	  var book = new OrderBook(this, options.currency_gets, options.issuer_gets, options.currency_pays, options.issuer_pays, key);

	  if (book.is_valid()) {
	    this._books[key] = book;
	  }

	  return book;
	};

	/**
	 * Return the next account sequence
	 *
	 * @param {String} account
	 * @param {String} sequence modifier (ADVANCE or REWIND)
	 * @return {Number} sequence
	 */

	Remote.prototype.accountSeq = Remote.prototype.getAccountSequence = function (account_, advance) {
	  var account = UInt160.json_rewrite(account_);
	  var accountInfo = this.accounts[account];

	  if (!accountInfo) {
	    return NaN;
	  }

	  var seq = accountInfo.seq;
	  var change = ({ ADVANCE: 1, REWIND: -1 })[advance.toUpperCase()] || 0;

	  accountInfo.seq += change;

	  return seq;
	};

	/**
	 * Set account sequence
	 *
	 * @param {String} account
	 * @param {Number} sequence
	 */

	Remote.prototype.setAccountSequence = Remote.prototype.setAccountSeq = function (account_, sequence) {
	  var account = UInt160.json_rewrite(account_);

	  if (!this.accounts.hasOwnProperty(account)) {
	    this.accounts[account] = {};
	  }

	  this.accounts[account].seq = sequence;
	};

	/**
	 * Refresh an account's sequence from server
	 *
	 * @param {String} account
	 * @param [String|Number] ledger
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.accountSeqCache = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      account: args.shift(),
	      ledger: args.shift()
	    };
	  }

	  if (!this.accounts.hasOwnProperty(options.account)) {
	    this.accounts[options.account] = {};
	  }

	  var account_info = this.accounts[options.account];
	  var request = account_info.caching_seq_request;

	  function accountRootSuccess(message) {
	    delete account_info.caching_seq_request;

	    var seq = message.node.Sequence;
	    account_info.seq = seq;

	    request.emit('success_cache', message);
	  }

	  function accountRootError(message) {
	    delete account_info.caching_seq_request;

	    request.emit('error_cache', message);
	  }

	  if (!request) {
	    request = this.requestLedgerEntry('account_root');
	    request.accountRoot(options.account);

	    if (!lodash.isUndefined(options.ledger)) {
	      request.selectLedger(options.ledger);
	    }

	    request.once('success', accountRootSuccess);
	    request.once('error', accountRootError);

	    account_info.caching_seq_request = request;
	  }

	  request.callback(callback, 'success_cache', 'error_cache');

	  return request;
	};

	/**
	 * Mark an account's root node as dirty.
	 *
	 * @param {String} account
	 */

	Remote.prototype.dirtyAccountRoot = function (account_) {
	  var account = UInt160.json_rewrite(account_);
	  delete this.ledgers.current.account_root[account];
	};

	/**
	 * Get an Offer from the ledger
	 *
	 * @param {Object} options
	 *   @param {String|Number} options.ledger
	 *   @param {String} [options.account]  - Required unless using options.index
	 *   @param {Number} [options.sequence] - Required unless using options.index
	 *   @param {String} [options.index]    - Required only if options.account and
	 *   options.sequence not provided
	 *
	 * @callback
	 * @param {Error} error
	 * @param {Object} message
	 *
	 * @return {Request}
	 */

	Remote.prototype.requestOffer = function (options, callback) {
	  var request = this.requestLedgerEntry('offer');

	  if (options.account && options.sequence) {
	    request.offerId(options.account, options.sequence);
	  } else if (options.index) {
	    request.offerIndex(options.index);
	  }

	  request.ledgerSelect(options.ledger);

	  request.once('success', function (res) {
	    request.emit('offer', res);
	  });

	  request.callback(callback, 'offer');

	  return request;
	};

	/**
	 * Get an account's balance
	 *
	 * @param {String} account
	 * @param [String] issuer
	 * @param [String] currency
	 * @param [String|Number] ledger
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestRippleBalance = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({}, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      account: args.shift(),
	      issuer: args.shift(),
	      currency: args.shift(),
	      ledger: args.shift()
	    };
	  }

	  // YYY Could be cached per ledger.
	  var request = this.requestLedgerEntry('ripple_state');
	  request.rippleState(options.account, options.issuer, options.currency);

	  if (!lodash.isUndefined(options.ledger)) {
	    request.selectLedger(options.ledger);
	  }

	  function rippleState(message) {
	    var node = message.node;
	    var lowLimit = Amount.from_json(node.LowLimit);
	    var highLimit = Amount.from_json(node.HighLimit);

	    // The amount the low account holds of issuer.
	    var balance = Amount.from_json(node.Balance);

	    // accountHigh implies for account: balance is negated.  highLimit is the
	    // limit set by account.
	    var accountHigh = UInt160.from_json(options.account).equals(highLimit.issuer());

	    request.emit('ripple_state', {
	      account_balance: (accountHigh ? balance.negate() : balance.clone()).parse_issuer(options.account),
	      peer_balance: (!accountHigh ? balance.negate() : balance.clone()).parse_issuer(options.issuer),
	      account_limit: (accountHigh ? highLimit : lowLimit).clone().parse_issuer(options.issuer),
	      peer_limit: (!accountHigh ? highLimit : lowLimit).clone().parse_issuer(options.account),
	      account_quality_in: accountHigh ? node.HighQualityIn : node.LowQualityIn,
	      peer_quality_in: !accountHigh ? node.HighQualityIn : node.LowQualityIn,
	      account_quality_out: accountHigh ? node.HighQualityOut : node.LowQualityOut,
	      peer_quality_out: !accountHigh ? node.HighQualityOut : node.LowQualityOut
	    });
	  }

	  request.once('success', rippleState);
	  request.callback(callback, 'ripple_state');

	  return request;
	};

	Remote.prepareCurrency = Remote.prepareCurrencies = function (currency) {
	  var newCurrency = {};

	  if (currency.hasOwnProperty('issuer')) {
	    newCurrency.issuer = UInt160.json_rewrite(currency.issuer);
	  }

	  if (currency.hasOwnProperty('currency')) {
	    newCurrency.currency = Currency.json_rewrite(currency.currency, { force_hex: true });
	  }

	  return newCurrency;
	};

	/**
	 * Request ripple_path_find
	 *
	 * @param {Object} options
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestRipplePathFind = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({
	      source_account: options_.src_account,
	      destination_account: options_.dst_account,
	      destination_amount: options_.dst_amount,
	      source_currencies: options_.src_currencies
	    }, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      source_account: args.shift(),
	      destination_account: args.shift(),
	      destination_amount: args.shift(),
	      source_currencies: args.shift()
	    };
	  }

	  var request = new Request(this, 'ripple_path_find');

	  request.message.source_account = UInt160.json_rewrite(options.source_account);

	  request.message.destination_account = UInt160.json_rewrite(options.destination_account);

	  request.message.destination_amount = Amount.json_rewrite(options.destination_amount);

	  if (Array.isArray(options.source_currencies)) {
	    request.message.source_currencies = options.source_currencies.map(Remote.prepareCurrency);
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request path_find/create
	 *
	 * @param {Object} options
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestPathFindCreate = function (options_, callback_) {
	  var options = undefined,
	      callback = callback_;

	  if (lodash.isPlainObject(options_)) {
	    options = lodash.merge({
	      source_account: options_.src_account,
	      destination_account: options_.dst_account,
	      destination_amount: options_.dst_amount,
	      source_currencies: options_.src_currencies
	    }, options_);
	  } else {
	    log.warn('DEPRECATED: First argument to request constructor should be' + ' an object containing request properties');

	    var args = Array.prototype.slice.call(arguments);

	    if (lodash.isFunction(lodash.last(args))) {
	      callback = args.pop();
	    }

	    options = {
	      source_account: args.shift(),
	      destination_account: args.shift(),
	      destination_amount: args.shift(),
	      source_currencies: args.shift()
	    };
	  }

	  var request = new Request(this, 'path_find');
	  request.message.subcommand = 'create';

	  request.message.source_account = UInt160.json_rewrite(options.source_account);

	  request.message.destination_account = UInt160.json_rewrite(options.destination_account);

	  request.message.destination_amount = Amount.json_rewrite(options.destination_amount);

	  if (Array.isArray(options.source_currencies)) {
	    request.message.source_currencies = options.source_currencies.map(Remote.prepareCurrency);
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request path_find/close
	 *
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestPathFindClose = function (callback) {
	  var request = new Request(this, 'path_find');

	  request.message.subcommand = 'close';
	  request.callback(callback);

	  return request;
	};

	/**
	 * Request unl_list
	 *
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestUnlList = function (callback) {
	  return new Request(this, 'unl_list').callback(callback);
	};

	/**
	 * Request unl_add
	 *
	 * @param {String} address
	 * @param {String} comment
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestUnlAdd = function (address, comment, callback) {
	  var request = new Request(this, 'unl_add');

	  request.message.node = address;

	  if (comment) {
	    // note is not specified anywhere, should remove?
	    request.message.comment = undefined;
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Request unl_delete
	 *
	 * @param {String} node
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestUnlDelete = function (node, callback) {
	  var request = new Request(this, 'unl_delete');

	  request.message.node = node;
	  request.callback(callback);

	  return request;
	};

	/**
	 * Request peers
	 *
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestPeers = function (callback) {
	  return new Request(this, 'peers').callback(callback);
	};

	/**
	 * Request connect
	 *
	 * @param {String} ip
	 * @param {Number} port
	 * @param [Function] callback
	 * @return {Request}
	 */

	Remote.prototype.requestConnect = function (ip, port, callback) {
	  var request = new Request(this, 'connect');

	  request.message.ip = ip;

	  if (port) {
	    request.message.port = port;
	  }

	  request.callback(callback);

	  return request;
	};

	/**
	 * Create a Transaction
	 *
	 * @param {String} TransactionType
	 * @param {Object} options
	 * @return {Transaction}
	 */

	Remote.prototype.transaction = Remote.prototype.createTransaction = function (type) {
	  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

	  var transaction = new Transaction(this);

	  if (arguments.length === 0) {
	    // Fallback
	    return transaction;
	  }

	  assert.strictEqual(typeof type, 'string', 'TransactionType must be a string');

	  var constructorMap = {
	    Payment: transaction.payment,
	    AccountSet: transaction.accountSet,
	    TrustSet: transaction.trustSet,
	    OfferCreate: transaction.offerCreate,
	    OfferCancel: transaction.offerCancel,
	    SetRegularkey: transaction.setRegularKey
	  };

	  var transactionConstructor = constructorMap[type];

	  if (!transactionConstructor) {
	    throw new Error('TransactionType must be a valid transaction type');
	  }

	  return transactionConstructor.call(transaction, options);
	};

	/**
	 * Calculate a transaction fee for a number of tx fee units.
	 *
	 * This takes into account the last known network and local load fees.
	 *
	 * @param {Number} fee units
	 * @return {Amount} Final fee in XRP for specified number of fee units.
	 */

	Remote.prototype.feeTx = function (units) {
	  var server = this.getServer();

	  if (!server) {
	    throw new Error('No connected servers');
	  }

	  return server._feeTx(units);
	};

	/**
	 * Get the current recommended transaction fee unit.
	 *
	 * Multiply this value with the number of fee units in order to calculate the
	 * recommended fee for the transaction you are trying to submit.
	 *
	 * @return {Number} Recommended amount for one fee unit as float.
	 */

	Remote.prototype.feeTxUnit = function () {
	  var server = this.getServer();

	  if (!server) {
	    throw new Error('No connected servers');
	  }

	  return server._feeTxUnit();
	};

	/**
	 * Get the current recommended reserve base.
	 *
	 * Returns the base reserve with load fees and safety margin applied.
	 *
	 * @param {Number} owner count
	 * @return {Amount}
	 */

	Remote.prototype.reserve = function (owner_count) {
	  var server = this.getServer();

	  if (!server) {
	    throw new Error('No connected servers');
	  }

	  return server._reserve(owner_count);
	};

	exports.Remote = Remote;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var EventEmitter = __webpack_require__(40).EventEmitter;
	var util = __webpack_require__(41);
	var async = __webpack_require__(51);
	var UInt160 = __webpack_require__(9).UInt160;
	var Currency = __webpack_require__(6).Currency;
	var RippleError = __webpack_require__(14).RippleError;

	// Request events emitted:
	//  'success' : Request successful.
	//  'error'   : Request failed.
	//  'remoteError'
	//  'remoteUnexpected'
	//  'remoteDisconnected'

	/**
	 * Request
	 *
	 * @param {Remote} remote
	 * @param {String} command
	 */

	function Request(remote, command) {
	  EventEmitter.call(this);

	  this.remote = remote;
	  this.requested = false;
	  this.reconnectTimeout = 1000 * 3;
	  this.successEvent = 'success';
	  this.errorEvent = 'error';
	  this.message = {
	    command: command,
	    id: undefined
	  };
	}

	util.inherits(Request, EventEmitter);

	// Send the request to a remote.
	Request.prototype.request = function (servers, callback) {
	  this.emit('before');
	  this.callback(callback);

	  if (this.requested) {
	    return this;
	  }

	  this.requested = true;
	  this.on('error', function () {});
	  this.emit('request', this.remote);

	  if (Array.isArray(servers)) {
	    servers.forEach(function (server) {
	      this.setServer(server);
	      this.remote.request(this);
	    }, this);
	  } else {
	    this.remote.request(this);
	  }

	  return this;
	};

	/**
	 * Broadcast request to all servers, filter responses if a function is
	 * provided. Return first response that satisfies the filter. Pre-filter
	 * requests by ledger_index (if a ledger_index is set on the request), and
	 * automatically retry servers when they reconnect--if they are expected to
	 *
	 * Whew
	 *
	 * @param [Function] fn
	 */

	Request.prototype.filter = Request.prototype.addFilter = Request.prototype.broadcast = function () {
	  var filterFn = arguments.length <= 0 || arguments[0] === undefined ? Boolean : arguments[0];

	  var self = this;

	  if (!this.requested) {
	    // Defer until requested, and prevent the normal request() from executing
	    this.once('before', function () {
	      self.requested = true;
	      self.broadcast(filterFn);
	    });
	    return this;
	  }

	  var lastResponse = new Error('No servers available');
	  var connectTimeouts = {};
	  var emit = this.emit;

	  this.emit = function (event, a, b) {
	    // Proxy success/error events
	    switch (event) {
	      case 'success':
	      case 'error':
	        emit.call(self, 'proposed', a, b);
	        break;
	      default:
	        emit.apply(self, arguments);
	    }
	  };

	  function iterator(server, callback) {
	    // Iterator is called in parallel

	    if (server.isConnected()) {
	      // Listen for proxied success/error event and apply filter
	      self.once('proposed', function (res) {
	        lastResponse = res;
	        callback(filterFn(res));
	      });

	      return server._request(self);
	    }

	    // Server is disconnected but should reconnect. Wait for it to reconnect,
	    // and abort after a timeout
	    var serverID = server.getServerID();

	    function serverReconnected() {
	      clearTimeout(connectTimeouts[serverID]);
	      connectTimeouts[serverID] = null;
	      iterator(server, callback);
	    }

	    connectTimeouts[serverID] = setTimeout(function () {
	      server.removeListener('connect', serverReconnected);
	      callback(false);
	    }, self.reconnectTimeout);

	    server.once('connect', serverReconnected);
	  }

	  function complete(success) {
	    // Emit success if the filter is satisfied by any server
	    // Emit error if the filter is not satisfied by any server
	    // Include the last response
	    emit.call(self, success ? 'success' : 'error', lastResponse);
	  }

	  var servers = this.remote._servers.filter(function (server) {
	    // Pre-filter servers that are disconnected and should not reconnect
	    return (server.isConnected() || server._shouldConnect) && (
	    // Pre-filter servers that do not contain the ledger in request
	    !self.message.hasOwnProperty('ledger_index') || server.hasLedger(self.message.ledger_index)) && (!self.message.hasOwnProperty('ledger_index_min') || self.message.ledger_index_min === -1 || server.hasLedger(self.message.ledger_index_min)) && (!self.message.hasOwnProperty('ledger_index_max') || self.message.ledger_index_max === -1 || server.hasLedger(self.message.ledger_index_max));
	  });

	  // Apply iterator in parallel to connected servers, complete when the
	  // supplied filter function is satisfied once by a server's response
	  async.some(servers, iterator, complete);

	  return this;
	};

	Request.prototype.cancel = function () {
	  this.removeAllListeners();
	  this.on('error', function () {});

	  return this;
	};

	Request.prototype.setCallback = function (fn) {
	  if (typeof fn === 'function') {
	    this.callback(fn);
	  }

	  return this;
	};

	Request.prototype.setReconnectTimeout = function (timeout) {
	  if (typeof timeout === 'number' && !isNaN(timeout)) {
	    this.reconnectTimeout = timeout;
	  }

	  return this;
	};

	Request.prototype.callback = function (callback, successEvent, errorEvent) {
	  var self = this;

	  if (typeof callback !== 'function') {
	    return this;
	  }

	  if (typeof successEvent === 'string') {
	    this.successEvent = successEvent;
	  }
	  if (typeof errorEvent === 'string') {
	    this.errorEvent = errorEvent;
	  }

	  var called = false;

	  function requestSuccess(message) {
	    if (!called) {
	      called = true;
	      callback.call(self, null, message);
	    }
	  }

	  function requestError(error) {
	    if (!called) {
	      called = true;

	      if (!(error instanceof RippleError)) {
	        callback.call(self, new RippleError(error));
	      } else {
	        callback.call(self, error);
	      }
	    }
	  }

	  this.once(this.successEvent, requestSuccess);
	  this.once(this.errorEvent, requestError);
	  this.request();

	  return this;
	};

	Request.prototype.timeout = function (duration, callback) {
	  var self = this;

	  function requested() {
	    self.timeout(duration, callback);
	  }

	  if (!this.requested) {
	    // Defer until requested
	    return this.once('request', requested);
	  }

	  var emit = this.emit;
	  var timed_out = false;

	  var timeout = setTimeout(function () {
	    timed_out = true;

	    if (typeof callback === 'function') {
	      callback();
	    }

	    emit.call(self, 'timeout');
	    self.cancel();
	  }, duration);

	  this.emit = function () {
	    if (!timed_out) {
	      clearTimeout(timeout);
	      emit.apply(self, arguments);
	    }
	  };

	  return this;
	};

	Request.prototype.setServer = function (server) {
	  var selected = null;

	  switch (typeof server) {
	    case 'object':
	      selected = server;
	      break;

	    case 'string':
	      // Find server by URL
	      var servers = this.remote._servers;

	      for (var i = 0, s = undefined; s = servers[i]; i++) {
	        if (s._url === server) {
	          selected = s;
	          break;
	        }
	      }
	      break;
	  }

	  this.server = selected;

	  return this;
	};

	Request.prototype.buildPath = function (build) {
	  if (this.remote.local_signing) {
	    throw new Error('`build_path` is completely ignored when doing local signing as ' + '`Paths` is a component of the signed blob. The `tx_blob` is signed,' + 'sealed and delivered, and the txn unmodified after');
	  }

	  if (build) {
	    this.message.build_path = true;
	  } else {
	    // ND: rippled currently intreprets the mere presence of `build_path` as the
	    // value being `truthy`
	    delete this.message.build_path;
	  }

	  return this;
	};

	Request.prototype.ledgerChoose = function (current) {
	  if (current) {
	    this.message.ledger_index = this.remote._ledger_current_index;
	  } else {
	    this.message.ledger_hash = this.remote._ledger_hash;
	  }

	  return this;
	};

	// Set the ledger for a request.
	// - ledger_entry
	// - transaction_entry
	Request.prototype.ledgerHash = function (hash) {
	  this.message.ledger_hash = hash;
	  return this;
	};

	// Set the ledger_index for a request.
	// - ledger_entry
	Request.prototype.ledgerIndex = function (ledger_index) {
	  this.message.ledger_index = ledger_index;
	  return this;
	};

	/**
	 * Set either ledger_index or ledger_hash based on heuristic
	 *
	 * @param {Number|String} ledger identifier
	 */

	Request.prototype.selectLedger = Request.prototype.ledgerSelect = function (ledger) {
	  switch (ledger) {
	    case 'current':
	    case 'closed':
	    case 'validated':
	      this.message.ledger_index = ledger;
	      break;
	    default:
	      if (Number(ledger) && isFinite(Number(ledger))) {
	        this.message.ledger_index = Number(ledger);
	      } else if (/^[A-F0-9]{64}$/.test(ledger)) {
	        this.message.ledger_hash = ledger;
	      }
	      break;
	  }

	  return this;
	};

	Request.prototype.accountRoot = function (account) {
	  this.message.account_root = UInt160.json_rewrite(account);
	  return this;
	};

	Request.prototype.index = function (index) {
	  this.message.index = index;
	  return this;
	};

	// Provide the information id an offer.
	// --> account
	// --> seq : sequence number of transaction creating offer (integer)
	Request.prototype.offerId = function (account, sequence) {
	  this.message.offer = {
	    account: UInt160.json_rewrite(account),
	    seq: sequence
	  };
	  return this;
	};

	// --> index : ledger entry index.
	Request.prototype.offerIndex = function (index) {
	  this.message.offer = index;
	  return this;
	};

	Request.prototype.secret = function (secret) {
	  if (secret) {
	    this.message.secret = secret;
	  }
	  return this;
	};

	Request.prototype.txHash = function (hash) {
	  this.message.tx_hash = hash;
	  return this;
	};

	Request.prototype.txJson = function (json) {
	  this.message.tx_json = json;
	  return this;
	};

	Request.prototype.txBlob = function (json) {
	  this.message.tx_blob = json;
	  return this;
	};

	Request.prototype.rippleState = function (account, issuer, currency) {
	  this.message.ripple_state = {
	    currency: currency,
	    accounts: [UInt160.json_rewrite(account), UInt160.json_rewrite(issuer)]
	  };
	  return this;
	};

	Request.prototype.setAccounts = Request.prototype.accounts = function (accountsIn, proposed) {
	  var accounts = Array.isArray(accountsIn) ? accountsIn : [accountsIn];

	  // Process accounts parameters
	  var processedAccounts = accounts.map(function (account) {
	    return UInt160.json_rewrite(account);
	  });

	  if (proposed) {
	    this.message.accounts_proposed = processedAccounts;
	  } else {
	    this.message.accounts = processedAccounts;
	  }

	  return this;
	};

	Request.prototype.addAccount = function (account, proposed) {
	  if (Array.isArray(account)) {
	    account.forEach(this.addAccount, this);
	    return this;
	  }

	  var processedAccount = UInt160.json_rewrite(account);
	  var prop = proposed === true ? 'accounts_proposed' : 'accounts';
	  this.message[prop] = (this.message[prop] || []).concat(processedAccount);

	  return this;
	};

	Request.prototype.setAccountsProposed = Request.prototype.rtAccounts = Request.prototype.accountsProposed = function (accounts) {
	  return this.accounts(accounts, true);
	};

	Request.prototype.addAccountProposed = function (account) {
	  if (Array.isArray(account)) {
	    account.forEach(this.addAccountProposed, this);
	    return this;
	  }

	  return this.addAccount(account, true);
	};

	Request.prototype.setBooks = Request.prototype.books = function (books, snapshot) {
	  // Reset list of books (this method overwrites the current list)
	  this.message.books = [];

	  for (var i = 0, l = books.length; i < l; i++) {
	    var book = books[i];
	    this.addBook(book, snapshot);
	  }

	  return this;
	};

	Request.prototype.addBook = function (book, snapshot) {
	  if (Array.isArray(book)) {
	    book.forEach(this.addBook, this);
	    return this;
	  }

	  var json = {};

	  function processSide(side) {
	    if (!book[side]) {
	      throw new Error('Missing ' + side);
	    }

	    var obj = json[side] = {
	      currency: Currency.json_rewrite(book[side].currency, {
	        force_hex: true
	      })
	    };

	    if (!Currency.from_json(obj.currency).is_native()) {
	      obj.issuer = UInt160.json_rewrite(book[side].issuer);
	    }
	  }

	  ['taker_gets', 'taker_pays'].forEach(processSide);

	  if (typeof snapshot !== 'boolean') {
	    json.snapshot = true;
	  } else if (snapshot) {
	    json.snapshot = true;
	  } else {
	    delete json.snapshot;
	  }

	  if (book.both) {
	    json.both = true;
	  }

	  this.message.books = (this.message.books || []).concat(json);

	  return this;
	};

	Request.prototype.addStream = function (stream, values) {
	  if (Array.isArray(values)) {
	    switch (stream) {
	      case 'accounts':
	        this.addAccount(values);
	        break;
	      case 'accounts_proposed':
	        this.addAccountProposed(values);
	        break;
	      case 'books':
	        this.addBook(values);
	        break;
	    }
	  } else if (arguments.length > 1) {
	    for (var arg in arguments) {
	      this.addStream(arguments[arg]);
	    }
	    return this;
	  }

	  if (!Array.isArray(this.message.streams)) {
	    this.message.streams = [];
	  }

	  if (this.message.streams.indexOf(stream) === -1) {
	    this.message.streams.push(stream);
	  }

	  return this;
	};

	exports.Request = Request;

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	// Represent Ripple amounts and currencies.
	// - Numbers in hex are big-endian.

	var assert = __webpack_require__(38);
	var extend = __webpack_require__(39);
	var utils = __webpack_require__(17);
	var UInt160 = __webpack_require__(9).UInt160;
	var Seed = __webpack_require__(11).Seed;
	var Currency = __webpack_require__(6).Currency;
	var GlobalBigNumber = __webpack_require__(49);

	var BigNumber = GlobalBigNumber.another({
	  ROUNDING_MODE: GlobalBigNumber.ROUND_HALF_UP,
	  DECIMAL_PLACES: 40
	});

	function inverse(number) {
	  return new BigNumber(number).toPower(-1);
	}

	function Amount() {
	  // Json format:
	  //  integer : XRP
	  //  { 'value' : ..., 'currency' : ..., 'issuer' : ...}

	  this._value = new BigNumber(NaN);
	  this._is_native = true; // Default to XRP. Only valid if value is not NaN.
	  this._currency = new Currency();
	  this._issuer = new UInt160();
	}

	/**
	 * Set strict_mode = false to disable amount range checking
	 */

	Amount.strict_mode = true;

	var consts = {
	  currency_xns: 0,
	  currency_one: 1,
	  xns_precision: 6,

	  // bi_ prefix refers to "big integer"
	  // TODO: we shouldn't expose our BigNumber library publicly
	  bi_5: new BigNumber(5),
	  bi_7: new BigNumber(7),
	  bi_10: new BigNumber(10),
	  bi_1e14: new BigNumber(1e14),
	  bi_1e16: new BigNumber(1e16),
	  bi_1e17: new BigNumber(1e17),
	  bi_1e32: new BigNumber(1e32),
	  bi_man_max_value: new BigNumber('9999999999999999'),
	  bi_man_min_value: new BigNumber(1e15),
	  bi_xns_max: new BigNumber(1e17),
	  bi_xns_min: new BigNumber(-1e17),
	  bi_xns_unit: new BigNumber(1e6),

	  cMinOffset: -96,
	  cMaxOffset: 80,

	  // Maximum possible amount for non-XRP currencies using the maximum mantissa
	  // with maximum exponent. Corresponds to hex 0xEC6386F26FC0FFFF.
	  max_value: '9999999999999999e80',
	  // Minimum possible amount for non-XRP currencies.
	  min_value: '-1000000000000000e-96'
	};

	var MAX_XRP_VALUE = new BigNumber(1e11);
	var MAX_IOU_VALUE = new BigNumber(consts.max_value);
	var MIN_IOU_VALUE = new BigNumber(consts.min_value).abs();

	// Add constants to Amount class
	extend(Amount, consts);

	// DEPRECATED: Use Amount instead, e.g. Amount.currency_xns
	exports.consts = consts;

	// Given '100/USD/ISSUER' return the a string with ISSUER remapped.
	Amount.text_full_rewrite = function (j) {
	  return Amount.from_json(j).to_text_full();
	};

	// Given '100/USD/ISSUER' return the json.
	Amount.json_rewrite = function (j) {
	  return Amount.from_json(j).to_json();
	};

	Amount.from_number = function (n) {
	  return new Amount().parse_number(n);
	};

	Amount.from_json = function (j) {
	  return new Amount().parse_json(j);
	};

	Amount.from_quality = function (quality, currency, issuer, opts) {
	  return new Amount().parse_quality(quality, currency, issuer, opts);
	};

	Amount.from_human = function (j, opts) {
	  return new Amount().parse_human(j, opts);
	};

	Amount.is_valid = function (j) {
	  return Amount.from_json(j).is_valid();
	};

	Amount.is_valid_full = function (j) {
	  return Amount.from_json(j).is_valid_full();
	};

	Amount.NaN = function () {
	  var result = new Amount();
	  result._value = new BigNumber(NaN); // should have no effect
	  return result; // but let's be careful
	};

	// be sure that _is_native is set properly BEFORE calling _set_value
	Amount.prototype._set_value = function (value, roundingMode) {
	  assert(value instanceof BigNumber);
	  this._value = value.isZero() && value.isNegative() ? value.negated() : value;
	  this.canonicalize(roundingMode);
	  this._check_limits();
	};

	// Returns a new value which is the absolute value of this.
	Amount.prototype.abs = function () {
	  return this.clone(this.is_negative());
	};

	Amount.prototype.add = function (addend) {
	  var addendAmount = Amount.from_json(addend);

	  if (!this.is_comparable(addendAmount)) {
	    return new Amount(NaN);
	  }

	  return this._copy(this._value.plus(addendAmount._value));
	};

	Amount.prototype.subtract = function (subtrahend) {
	  // Correctness over speed, less code has less bugs, reuse add code.
	  return this.add(Amount.from_json(subtrahend).negate());
	};

	// XXX Diverges from cpp.
	Amount.prototype.multiply = function (multiplicand) {
	  var multiplicandAmount = Amount.from_json(multiplicand);
	  // TODO: probably should just multiply by multiplicandAmount._value
	  var multiplyBy = multiplicandAmount.is_native() ? multiplicandAmount._value.times(Amount.bi_xns_unit) : multiplicandAmount._value;
	  return this._copy(this._value.times(multiplyBy));
	};

	Amount.prototype.scale = function (scaleFactor) {
	  return this._copy(this._value.times(scaleFactor));
	};

	Amount.prototype.divide = function (divisor) {
	  var divisorAmount = Amount.from_json(divisor);
	  if (!this.is_valid()) {
	    throw new Error('Invalid dividend');
	  }
	  if (!divisorAmount.is_valid()) {
	    throw new Error('Invalid divisor');
	  }
	  if (divisorAmount.is_zero()) {
	    throw new Error('divide by zero');
	  }
	  // TODO: probably should just divide by divisorAmount._value
	  var divideBy = divisorAmount.is_native() ? divisorAmount._value.times(Amount.bi_xns_unit) : divisorAmount._value;
	  return this._copy(this._value.dividedBy(divideBy));
	};

	/**
	 * This function calculates a ratio - such as a price - between two Amount
	 * objects.
	 *
	 * The return value will have the same type (currency) as the numerator. This is
	 * a simplification, which should be sane in most cases. For example, a USD/XRP
	 * price would be rendered as USD.
	 *
	 * @example
	 *   var price = buy_amount.ratio_human(sell_amount);
	 *
	 * @this {Amount} The numerator (top half) of the fraction.
	 * @param {Amount} denominator The denominator (bottom half) of the fraction.
	 * @param opts Options for the calculation.
	 * @param opts.reference_date {Date|Number} Date based on which
	 * demurrage/interest should be applied. Can be given as JavaScript Date or int
	 * for Ripple epoch.
	 * @return {Amount} The resulting ratio. Unit will be the same as numerator.
	 */

	Amount.prototype.ratio_human = function (denominator, opts) {
	  opts = extend({}, opts);

	  var numerator = this.clone();

	  denominator = Amount.from_json(denominator);

	  // If either operand is NaN, the result is NaN.
	  if (!numerator.is_valid() || !denominator.is_valid()) {
	    return new Amount(NaN);
	  }

	  if (denominator.is_zero()) {
	    return new Amount(NaN);
	  }

	  // Apply interest/demurrage
	  //
	  // We only need to apply it to the second factor, because the currency unit of
	  // the first factor will carry over into the result.
	  if (opts.reference_date) {
	    denominator = denominator.applyInterest(opts.reference_date);
	  }

	  // Special case: The denominator is a native (XRP) amount.
	  //
	  // In that case, it's going to be expressed as base units (1 XRP =
	  // 10^xns_precision base units).
	  //
	  // However, the unit of the denominator is lost, so when the resulting ratio
	  // is printed, the ratio is going to be too small by a factor of
	  // 10^xns_precision.
	  //
	  // To compensate, we multiply the numerator by 10^xns_precision.
	  if (denominator._is_native) {
	    numerator._set_value(numerator._value.times(Amount.bi_xns_unit));
	  }

	  return numerator.divide(denominator);
	};

	/**
	 * Calculate a product of two amounts.
	 *
	 * This function allows you to calculate a product between two amounts which
	 * retains XRPs human/external interpretation (i.e. 1 XRP = 1,000,000 base
	 * units).
	 *
	 * Intended use is to calculate something like: 10 USD * 10 XRP/USD = 100 XRP
	 *
	 * @example
	 *   var sell_amount = buy_amount.product_human(price);
	 *
	 * @see Amount#ratio_human
	 *
	 * @param {Amount} factor The second factor of the product.
	 * @param {Object} opts Options for the calculation.
	 * @param {Date|Number} opts.reference_date Date based on which
	 * demurrage/interest should be applied. Can be given as JavaScript Date or int
	 * for Ripple epoch.
	 * @return {Amount} The product. Unit will be the same as the first factor.
	 */
	Amount.prototype.product_human = function (factor, opts) {
	  opts = opts || {};

	  factor = Amount.from_json(factor);

	  // If either operand is NaN, the result is NaN.
	  if (!this.is_valid() || !factor.is_valid()) {
	    return new Amount(NaN);
	  }

	  // Apply interest/demurrage
	  //
	  // We only need to apply it to the second factor, because the currency unit of
	  // the first factor will carry over into the result.
	  if (opts.reference_date) {
	    factor = factor.applyInterest(opts.reference_date);
	  }

	  var product = this.multiply(factor);

	  // Special case: The second factor is a native (XRP) amount expressed as base
	  // units (1 XRP = 10^xns_precision base units).
	  //
	  // See also Amount#ratio_human.
	  if (factor._is_native) {
	    product._set_value(product._value.dividedBy(Amount.bi_xns_unit));
	  }

	  return product;
	};

	/**
	 * Turn this amount into its inverse.
	 *
	 * @return {Amount} self
	 * @private
	 */
	Amount.prototype._invert = function () {
	  this._set_value(inverse(this._value));
	  return this;
	};

	/**
	 * Return the inverse of this amount.
	 *
	 * @return {Amount} New Amount object with same currency and issuer, but the
	 *   inverse of the value.
	 */
	Amount.prototype.invert = function () {
	  return this.clone()._invert();
	};

	/**
	 * Canonicalize amount value
	 *
	 * Mirrors rippled's internal Amount representation
	 * From https://github.com/ripple/rippled/blob/develop/src/ripple/data
	 * /protocol/STAmount.h#L31-L40
	 *
	 * Internal form:
	 * 1: If amount is zero, then value is zero and offset is -100
	 * 2: Otherwise:
	 *    legal offset range is -96 to +80 inclusive
	 *    value range is 10^15 to (10^16 - 1) inclusive
	 *    amount = value * [10 ^ offset]
	 *
	 * -------------------
	 *
	 * The amount can be epxresses as A x 10^B
	 * Where:
	 * - A must be an integer between 10^15 and (10^16)-1 inclusive
	 * - B must be between -96 and 80 inclusive
	 *
	 * This results
	 * - minumum: 10^15 x 10^-96 -> 10^-81 -> -1e-81
	 * - maximum: (10^16)-1 x 10^80 -> 9999999999999999e80
	 *
	 * @returns {Amount}
	 * @throws {Error} if offset exceeds legal ranges, meaning the amount value is
	 * bigger than supported
	 */

	Amount.prototype.canonicalize = function (roundingMode) {
	  if (this._is_native) {
	    this._value = this._value.round(6, BigNumber.ROUND_DOWN);
	  } else if (roundingMode) {
	    this._value = new BigNumber(this._value.toPrecision(16, roundingMode));
	  } else {
	    this._value = new BigNumber(this._value.toPrecision(16));
	  }
	};

	Amount.prototype._check_limits = function () {
	  if (!Amount.strict_mode) {
	    return this;
	  }
	  if (this._value.isNaN() || this._value.isZero()) {
	    return this;
	  }
	  var absval = this._value.absoluteValue();
	  if (this._is_native) {
	    if (absval.greaterThan(MAX_XRP_VALUE)) {
	      throw new Error('Exceeding max value of ' + MAX_XRP_VALUE.toString());
	    }
	  } else {
	    if (absval.lessThan(MIN_IOU_VALUE)) {
	      throw new Error('Exceeding min value of ' + MIN_IOU_VALUE.toString());
	    }
	    if (absval.greaterThan(MAX_IOU_VALUE)) {
	      throw new Error('Exceeding max value of ' + MAX_IOU_VALUE.toString());
	    }
	  }
	  return this;
	};

	Amount.prototype.clone = function (negate) {
	  return this.copyTo(new Amount(), negate);
	};

	Amount.prototype._copy = function (value) {
	  var copy = this.clone();
	  copy._set_value(value);
	  return copy;
	};

	Amount.prototype.compareTo = function (to) {
	  var toAmount = Amount.from_json(to);
	  if (!this.is_comparable(toAmount)) {
	    return new Amount(NaN);
	  }
	  return this._value.comparedTo(toAmount._value);
	};

	// Make d a copy of this. Returns d.
	// Modification of objects internally refered to is not allowed.
	Amount.prototype.copyTo = function (d, negate) {
	  d._value = negate ? this._value.negated() : this._value;
	  d._is_native = this._is_native;
	  d._currency = this._currency;
	  d._issuer = this._issuer;
	  return d;
	};

	Amount.prototype.currency = function () {
	  return this._currency;
	};

	Amount.prototype.equals = function (d, ignore_issuer) {
	  if (!(d instanceof Amount)) {
	    return this.equals(Amount.from_json(d));
	  }

	  return this.is_valid() && d.is_valid() && this._is_native === d._is_native && this._value.equals(d._value) && (this._is_native || this._currency.equals(d._currency) && (ignore_issuer || this._issuer.equals(d._issuer)));
	};

	// True if Amounts are valid and both native or non-native.
	Amount.prototype.is_comparable = function (v) {
	  return this.is_valid() && v.is_valid() && this._is_native === v._is_native;
	};

	Amount.prototype.is_native = function () {
	  return this._is_native;
	};

	Amount.prototype.is_negative = function () {
	  return this._value.isNegative();
	};

	Amount.prototype.is_positive = function () {
	  return !this.is_zero() && !this.is_negative();
	};

	// Only checks the value. Not the currency and issuer.
	Amount.prototype.is_valid = function () {
	  return !this._value.isNaN();
	};

	Amount.prototype.is_valid_full = function () {
	  return this.is_valid() && this._currency.is_valid() && this._issuer.is_valid();
	};

	Amount.prototype.is_zero = function () {
	  return this._value.isZero();
	};

	Amount.prototype.issuer = function () {
	  return this._issuer;
	};

	// Return a new value.
	Amount.prototype.negate = function () {
	  return this.clone('NEGATE');
	};

	/**
	 * Tries to correctly interpret an amount as entered by a user.
	 *
	 * Examples:
	 *
	 *   XRP 250     => 250000000/XRP
	 *   25.2 XRP    => 25200000/XRP
	 *   USD 100.40  => 100.4/USD/?
	 *   100         => 100000000/XRP
	 *
	 *
	 * The regular expression below matches above cases, broken down for better
	 * understanding:
	 *
	 * // either 3 letter alphabetic currency-code or 3 digit numeric currency-code.
	 * // See ISO 4217
	 * ([A-z]{3}|[0-9]{3})
	 *
	 * // end of string
	 * $
	 */

	Amount.prototype.parse_human = function (j, opts) {
	  opts = opts || {};

	  var hex_RE = /^[a-fA-F0-9]{40}$/;
	  var currency_RE = /^([a-zA-Z]{3}|[0-9]{3})$/;

	  var value;
	  var currency;

	  var words = j.split(' ').filter(function (word) {
	    return word !== '';
	  });

	  function isNumber(s) {
	    return isFinite(s) && s !== '' && s !== null;
	  }

	  if (words.length === 1) {
	    if (isNumber(words[0])) {
	      value = words[0];
	      currency = 'XRP';
	    } else {
	      value = words[0].slice(0, -3);
	      currency = words[0].slice(-3);
	      if (!(isNumber(value) && currency.match(currency_RE))) {
	        return new Amount(NaN);
	      }
	    }
	  } else if (words.length === 2) {
	    if (isNumber(words[0]) && words[1].match(hex_RE)) {
	      value = words[0];
	      currency = words[1];
	    } else if (words[0].match(currency_RE) && isNumber(words[1])) {
	      value = words[1];
	      currency = words[0];
	    } else if (isNumber(words[0]) && words[1].match(currency_RE)) {
	      value = words[0];
	      currency = words[1];
	    } else {
	      return new Amount(NaN);
	    }
	  } else {
	    return new Amount(NaN);
	  }

	  currency = currency.toUpperCase();
	  this.set_currency(currency);
	  this._is_native = currency === 'XRP';
	  this._set_value(new BigNumber(value));

	  // Apply interest/demurrage
	  if (opts.reference_date && this._currency.has_interest()) {
	    var interest = this._currency.get_interest_at(opts.reference_date);
	    this._set_value(this._value.dividedBy(interest.toString()));
	  }

	  return this;
	};

	Amount.prototype.parse_issuer = function (issuer) {
	  this._issuer = UInt160.from_json(issuer);
	  return this;
	};

	/**
	 * Decode a price from a BookDirectory index.
	 *
	 * BookDirectory ledger entries each encode the offer price in their index. This
	 * method can decode that information and populate an Amount object with it.
	 *
	 * It is possible not to provide a currency or issuer, but be aware that Amount
	 * objects behave differently based on the currency, so you may get incorrect
	 * results.
	 *
	 * Prices involving demurraging currencies are tricky, since they depend on the
	 * base and counter currencies.
	 *
	 * @param {String} quality 8 hex bytes quality or 32 hex bytes BookDirectory
	 *   index.
	 * @param {Currency|String} counterCurrency currency of the resulting Amount
	 *   object.
	 * @param {Issuer|String} counterIssuer Issuer of the resulting Amount object.
	 * @param {Object} opts Additional options
	 * @param {Boolean} opts.inverse If true, return the inverse of the price
	 *   encoded in the quality.
	 * @param {Currency|String} opts.base_currency The other currency. This plays a
	 *   role with interest-bearing or demurrage currencies. In that case the
	 *   demurrage has to be applied when the quality is decoded, otherwise the
	 *   price will be false.
	 * @param {Date|Number} opts.reference_date Date based on which
	 * demurrage/interest should be applied. Can be given as JavaScript Date or int
	 * for Ripple epoch.
	 * @param {Boolean} opts.xrp_as_drops Whether XRP amount should be treated as
	 *   drops. When the base currency is XRP, the quality is calculated in drops.
	 *   For human use however, we want to think of 1000000 drops as 1 XRP and
	 *   prices as per-XRP instead of per-drop.
	 * @return {Amount} self
	 */
	Amount.prototype.parse_quality = function (quality, counterCurrency, counterIssuer, opts) {
	  opts = opts || {};

	  var baseCurrency = Currency.from_json(opts.base_currency);

	  var mantissa_hex = quality.substring(quality.length - 14);
	  var offset_hex = quality.substring(quality.length - 16, quality.length - 14);
	  var mantissa = new BigNumber(mantissa_hex, 16);
	  var offset = parseInt(offset_hex, 16) - 100;

	  var value = new BigNumber(mantissa.toString() + 'e' + offset.toString());

	  this._currency = Currency.from_json(counterCurrency);
	  this._issuer = UInt160.from_json(counterIssuer);
	  this._is_native = this._currency.is_native();

	  if (this._is_native && baseCurrency.is_native()) {
	    throw new Error('XRP/XRP quality is not allowed');
	  }

	  /*
	  The quality, as stored in the last 64 bits of a directory index, is stored as
	  the quotient of TakerPays/TakerGets.
	   When `opts.inverse` is true we are looking at a quality used for determining a
	  `bid` price and it must first be inverted, before our declared base/counter
	  currencies are in line with the price.
	   For example:
	     quality as stored :  5 USD          /  3000000 drops
	    inverted          :  3000000 drops  /          5 USD
	  */
	  var adjusted = opts.inverse ? inverse(value) : value;
	  var nativeAdjusted = adjusted;

	  if (!opts.xrp_as_drops) {
	    // `In a currency exchange, the exchange rate is quoted as the units of the
	    //  counter currency in terms of a single unit of a base currency`. A
	    //  quality is how much taker must `pay` to get ONE `gets` unit thus:
	    //    pays ~= counterCurrency
	    //    gets ~= baseCurrency.
	    if (this._is_native) {
	      // pay:$price              drops  get:1 X
	      // pay:($price / 1,000,000)  XRP  get:1 X
	      nativeAdjusted = adjusted.div(Amount.bi_xns_unit);
	    } else if (baseCurrency.is_valid() && baseCurrency.is_native()) {
	      // pay:$price X                   get:1 drop
	      // pay:($price * 1,000,000) X     get:1 XRP
	      nativeAdjusted = adjusted.times(Amount.bi_xns_unit);
	    }
	  }

	  this._set_value(nativeAdjusted);

	  if (opts.reference_date && baseCurrency.is_valid() && baseCurrency.has_interest()) {
	    var interest = baseCurrency.get_interest_at(opts.reference_date);
	    this._set_value(this._value.dividedBy(interest.toString()));
	  }

	  return this;
	};

	Amount.prototype.parse_number = function (n) {
	  this._is_native = false;
	  this._currency = Currency.from_json(1);
	  this._issuer = UInt160.from_json(1);
	  this._set_value(new BigNumber(n));
	  return this;
	};

	// <-> j
	Amount.prototype.parse_json = function (j) {
	  switch (typeof j) {
	    case 'string':
	      // .../.../... notation is not a wire format.  But allowed for easier
	      // testing.
	      var m = j.match(/^([^/]+)\/([^/]+)(?:\/(.+))?$/);

	      if (m) {
	        this._currency = Currency.from_json(m[2]);
	        if (m[3]) {
	          this._issuer = UInt160.from_json(m[3]);
	        } else {
	          this._issuer = UInt160.from_json('1');
	        }
	        this.parse_value(m[1]);
	      } else {
	        this.parse_native(j);
	        this._currency = Currency.from_json('0');
	        this._issuer = UInt160.from_json('0');
	      }
	      break;

	    case 'number':
	      this.parse_json(String(j));
	      break;

	    case 'object':
	      if (j === null) {
	        break;
	      }

	      if (j instanceof Amount) {
	        j.copyTo(this);
	      } else if (j.hasOwnProperty('value')) {
	        // Parse the passed value to sanitize and copy it.
	        this._currency.parse_json(j.currency, true); // Never XRP.

	        if (typeof j.issuer === 'string') {
	          this._issuer.parse_json(j.issuer);
	        }

	        this.parse_value(j.value);
	      }
	      break;

	    default:
	      this._set_value(new BigNumber(NaN));
	  }

	  return this;
	};

	// Parse a XRP value from untrusted input.
	// - integer = raw units
	// - float = with precision 6
	// XXX Improvements: disallow leading zeros.
	Amount.prototype.parse_native = function (j) {
	  if (j && typeof j === 'string' && !isNaN(j)) {
	    if (j.indexOf('.') >= 0) {
	      throw new Error('Native amounts must be specified in integer drops');
	    }
	    var value = new BigNumber(j);
	    this._is_native = true;
	    this._set_value(value.dividedBy(Amount.bi_xns_unit));
	  } else {
	    this._set_value(new BigNumber(NaN));
	  }

	  return this;
	};

	// Parse a non-native value for the json wire format.
	// Requires _currency to be set!
	Amount.prototype.parse_value = function (j) {
	  this._is_native = false;
	  this._set_value(new BigNumber(j), BigNumber.ROUND_DOWN);
	  return this;
	};

	Amount.prototype.set_currency = function (c) {
	  this._currency = Currency.from_json(c);
	  this._is_native = this._currency.is_native();
	  return this;
	};

	Amount.prototype.set_issuer = function (issuer) {
	  if (issuer instanceof UInt160) {
	    this._issuer = issuer;
	  } else {
	    this._issuer = UInt160.from_json(issuer);
	  }

	  return this;
	};

	Amount.prototype.to_number = function () {
	  return Number(this.to_text());
	};

	// Convert only value to JSON wire format.
	Amount.prototype.to_text = function () {
	  if (!this.is_valid()) {
	    return 'NaN';
	  }

	  if (this._is_native) {
	    return this._value.times(Amount.bi_xns_unit).toString();
	  }

	  // not native
	  var offset = this._value.e - 15;
	  var sign = this._value.isNegative() ? '-' : '';
	  var mantissa = utils.getMantissaDecimalString(this._value.absoluteValue());
	  if (offset !== 0 && (offset < -25 || offset > -4)) {
	    // Use e notation.
	    // XXX Clamp output.
	    return sign + mantissa.toString() + 'e' + offset.toString();
	  }

	  var val = '000000000000000000000000000' + mantissa.toString() + '00000000000000000000000';
	  var pre = val.substring(0, offset + 43);
	  var post = val.substring(offset + 43);
	  var s_pre = pre.match(/[1-9].*$/); // Everything but leading zeros.
	  var s_post = post.match(/[1-9]0*$/); // Last non-zero plus trailing zeros.

	  return sign + (s_pre ? s_pre[0] : '0') + (s_post ? '.' + post.substring(0, 1 + post.length - s_post[0].length) : '');
	};

	/**
	 * Calculate present value based on currency and a reference date.
	 *
	 * This only affects demurraging and interest-bearing currencies.
	 *
	 * User should not store amount objects after the interest is applied. This is
	 * intended by display functions such as toHuman().
	 *
	 * @param {Date|Number} referenceDate Date based on which demurrage/interest
	 *   should be applied. Can be given as JavaScript Date or int for Ripple epoch.
	 * @return {Amount} The amount with interest applied.
	 */
	Amount.prototype.applyInterest = function (referenceDate) {
	  if (!this._currency.has_interest()) {
	    return this;
	  }
	  var interest = this._currency.get_interest_at(referenceDate);
	  return this._copy(this._value.times(interest.toString()));
	};

	/**
	 * Format only value in a human-readable format.
	 *
	 * @example
	 *   var pretty = amount.to_human({precision: 2});
	 *
	 * @param {Object} opts Options for formatter.
	 * @param {Number} opts.precision Max. number of digits after decimal point.
	 * @param {Number} opts.min_precision Min. number of digits after dec. point.
	 * @param {Boolean} opts.skip_empty_fraction Don't show fraction if it is zero,
	 *   even if min_precision is set.
	 * @param {Number} opts.max_sig_digits Maximum number of significant digits.
	 *   Will cut fractional part, but never integer part.
	 * @param {Boolean|String} opts.group_sep Whether to show a separator every n
	 *   digits, if a string, that value will be used as the separator. Default: ','
	 * @param {Number} opts.group_width How many numbers will be grouped together,
	 *   default: 3.
	 * @param {Boolean|String} opts.signed Whether negative numbers will have a
	 *   prefix. If String, that string will be used as the prefix. Default: '-'
	 * @param {Date|Number} opts.reference_date Date based on which
	 * demurrage/interest should be applied. Can be given as JavaScript Date or int
	 * for Ripple epoch.
	 * @return {String} amount string
	 */
	Amount.prototype.to_human = function (opts) {
	  opts = opts || {};

	  if (!this.is_valid()) {
	    return 'NaN';
	  }

	  /* eslint-disable consistent-this */
	  // Apply demurrage/interest
	  var ref = this;
	  /* eslint-enable consistent-this */

	  if (opts.reference_date) {
	    ref = this.applyInterest(opts.reference_date);
	  }

	  var isNegative = ref._value.isNegative();
	  var valueString = ref._value.abs().toFixed();
	  var parts = valueString.split('.');
	  var int_part = parts[0];
	  var fraction_part = parts.length === 2 ? parts[1] : '';

	  int_part = int_part.replace(/^0*/, '');
	  fraction_part = fraction_part.replace(/0*$/, '');

	  if (fraction_part.length || !opts.skip_empty_fraction) {
	    // Enforce the maximum number of decimal digits (precision)
	    if (typeof opts.precision === 'number') {
	      var precision = Math.max(0, opts.precision);
	      precision = Math.min(precision, fraction_part.length);
	      var rounded = Number('0.' + fraction_part).toFixed(precision);

	      if (rounded < 1) {
	        fraction_part = rounded.substring(2);
	      } else {
	        int_part = (Number(int_part) + 1).toString();
	        fraction_part = '';
	      }

	      while (fraction_part.length < precision) {
	        fraction_part = '0' + fraction_part;
	      }
	    }

	    // Limit the number of significant digits (max_sig_digits)
	    if (typeof opts.max_sig_digits === 'number') {
	      // First, we count the significant digits we have.
	      // A zero in the integer part does not count.
	      var int_is_zero = Number(int_part) === 0;
	      var digits = int_is_zero ? 0 : int_part.length;

	      // Don't count leading zeros in the fractional part if the integer part is
	      // zero.
	      var sig_frac = int_is_zero ? fraction_part.replace(/^0*/, '') : fraction_part;
	      digits += sig_frac.length;

	      // Now we calculate where we are compared to the maximum
	      var rounding = digits - opts.max_sig_digits;

	      // If we're under the maximum we want to cut no (=0) digits
	      rounding = Math.max(rounding, 0);

	      // If we're over the maximum we still only want to cut digits from the
	      // fractional part, not from the integer part.
	      rounding = Math.min(rounding, fraction_part.length);

	      // Now we cut `rounding` digits off the right.
	      if (rounding > 0) {
	        fraction_part = fraction_part.slice(0, -rounding);
	      }
	    }

	    // Enforce the minimum number of decimal digits (min_precision)
	    if (typeof opts.min_precision === 'number') {
	      opts.min_precision = Math.max(0, opts.min_precision);
	      while (fraction_part.length < opts.min_precision) {
	        fraction_part += '0';
	      }
	    }
	  }

	  if (opts.group_sep !== false) {
	    var sep = typeof opts.group_sep === 'string' ? opts.group_sep : ',';
	    var groups = utils.chunkString(int_part, opts.group_width || 3, true);
	    int_part = groups.join(sep);
	  }

	  var formatted = '';
	  if (isNegative && opts.signed !== false) {
	    formatted += '-';
	  }

	  formatted += int_part.length ? int_part : '0';
	  formatted += fraction_part.length ? '.' + fraction_part : '';

	  return formatted;
	};

	Amount.prototype.to_human_full = function (opts) {
	  opts = opts || {};
	  var value = this.to_human(opts);
	  var currency = this._currency.to_human();
	  var issuer = this._issuer.to_json(opts);
	  var base = value + '/' + currency;
	  return this.is_native() ? base : base + '/' + issuer;
	};

	Amount.prototype.to_json = function () {
	  if (this._is_native) {
	    return this.to_text();
	  }

	  var amount_json = {
	    value: this.to_text(),
	    currency: this._currency.has_interest() ? this._currency.to_hex() : this._currency.to_json()
	  };

	  if (this._issuer.is_valid()) {
	    amount_json.issuer = this._issuer.to_json();
	  }

	  return amount_json;
	};

	Amount.prototype.to_text_full = function (opts) {
	  if (!this.is_valid()) {
	    return 'NaN';
	  }
	  return this._is_native ? this.to_human() + '/XRP' : this.to_text() + '/' + this._currency.to_json() + '/' + this._issuer.to_json(opts);
	};

	// For debugging.
	Amount.prototype.not_equals_why = function (d, ignore_issuer) {
	  if (typeof d === 'string') {
	    return this.not_equals_why(Amount.from_json(d));
	  }
	  if (!(d instanceof Amount)) {
	    return 'Not an Amount';
	  }
	  if (!this.is_valid() || !d.is_valid()) {
	    return 'Invalid amount.';
	  }
	  if (this._is_native !== d._is_native) {
	    return 'Native mismatch.';
	  }

	  var type = this._is_native ? 'XRP' : 'Non-XRP';
	  if (!this._value.isZero() && this._value.negated().equals(d._value)) {
	    return type + ' sign differs.';
	  }
	  if (!this._value.equals(d._value)) {
	    return type + ' value differs.';
	  }
	  if (!this._is_native) {
	    if (!this._currency.equals(d._currency)) {
	      return 'Non-XRP currency differs.';
	    }
	    if (!ignore_issuer && !this._issuer.equals(d._issuer)) {
	      return 'Non-XRP issuer differs: ' + d._issuer.to_json() + '/' + this._issuer.to_json();
	    }
	  }
	};

	exports.Amount = Amount;

	// DEPRECATED: Include the corresponding files instead.
	exports.Currency = Currency;
	exports.Seed = Seed;
	exports.UInt160 = UInt160;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	// Routines for working with an account.
	//
	// You should not instantiate this class yourself, instead use Remote#account.
	//
	// Events:
	//   wallet_clean :  True, iff the wallet has been updated.
	//   wallet_dirty :  True, iff the wallet needs to be updated.
	//   balance:        The current stamp balance.
	//   balance_proposed
	//

	// var network = require('./network.js');
	'use strict';

	var async = __webpack_require__(51);
	var util = __webpack_require__(41);
	var extend = __webpack_require__(39);
	var EventEmitter = __webpack_require__(40).EventEmitter;
	var Amount = __webpack_require__(3).Amount;
	var UInt160 = __webpack_require__(9).UInt160;
	var TransactionManager = __webpack_require__(25).TransactionManager;
	var sjcl = __webpack_require__(17).sjcl;
	var Base = __webpack_require__(7).Base;

	/**
	 * @constructor Account
	 * @param {Remote} remote
	 * @param {String} account
	 */

	function Account(remote, account) {
	  EventEmitter.call(this);

	  var self = this;

	  this._remote = remote;
	  this._account = UInt160.from_json(account);
	  this._account_id = this._account.to_json();
	  this._subs = 0;

	  // Ledger entry object
	  // Important: This must never be overwritten, only extend()-ed
	  this._entry = {};

	  function listenerAdded(type, listener) {
	    if (~Account.subscribeEvents.indexOf(type)) {
	      if (!self._subs && self._remote._connected) {
	        self._remote.request_subscribe().add_account(self._account_id).broadcast().request();
	      }
	      self._subs += 1;
	    }
	  };

	  this.on('newListener', listenerAdded);

	  function listenerRemoved(type, listener) {
	    if (~Account.subscribeEvents.indexOf(type)) {
	      self._subs -= 1;
	      if (!self._subs && self._remote._connected) {
	        self._remote.request_unsubscribe().add_account(self._account_id).broadcast().request();
	      }
	    }
	  };

	  this.on('removeListener', listenerRemoved);

	  function attachAccount(request) {
	    if (self._account.is_valid() && self._subs) {
	      request.add_account(self._account_id);
	    }
	  };

	  this._remote.on('prepare_subscribe', attachAccount);

	  function handleTransaction(transaction) {
	    if (!transaction.mmeta) {
	      return;
	    }

	    var changed = false;

	    transaction.mmeta.each(function (an) {
	      var isAccount = an.fields.Account === self._account_id;
	      var isAccountRoot = isAccount && an.entryType === 'AccountRoot';

	      if (isAccountRoot) {
	        extend(self._entry, an.fieldsNew, an.fieldsFinal);
	        changed = true;
	      }
	    });

	    if (changed) {
	      self.emit('entry', self._entry);
	    }
	  };

	  this.on('transaction', handleTransaction);

	  this._transactionManager = new TransactionManager(this);

	  return this;
	};

	util.inherits(Account, EventEmitter);

	/**
	 * List of events that require a remote subscription to the account.
	 */

	Account.subscribeEvents = ['transaction', 'entry'];

	Account.prototype.toJson = function () {
	  return this._account.to_json();
	};

	/**
	 * Whether the AccountId is valid.
	 *
	 * Note: This does not tell you whether the account exists in the ledger.
	 */

	Account.prototype.isValid = function () {
	  return this._account.is_valid();
	};

	/**
	 * Request account info
	 *
	 * @param {Function} callback
	 */

	Account.prototype.getInfo = function (callback) {
	  return this._remote.requestAccountInfo({ account: this._account_id }, callback);
	};

	/**
	 * Retrieve the current AccountRoot entry.
	 *
	 * To keep up-to-date with changes to the AccountRoot entry, subscribe to the
	 * 'entry' event.
	 *
	 * @param {Function} callback
	 */

	Account.prototype.entry = function (callback) {
	  var self = this;
	  var callback = typeof callback === 'function' ? callback : function () {};

	  function accountInfo(err, info) {
	    if (err) {
	      callback(err);
	    } else {
	      extend(self._entry, info.account_data);
	      self.emit('entry', self._entry);
	      callback(null, info);
	    }
	  };

	  this.getInfo(accountInfo);

	  return this;
	};

	Account.prototype.getNextSequence = function (callback) {
	  var callback = typeof callback === 'function' ? callback : function () {};

	  function isNotFound(err) {
	    return err && typeof err === 'object' && typeof err.remote === 'object' && err.remote.error === 'actNotFound';
	  };

	  function accountInfo(err, info) {
	    if (isNotFound(err)) {
	      // New accounts will start out as sequence one
	      callback(null, 1);
	    } else if (err) {
	      callback(err);
	    } else {
	      callback(null, info.account_data.Sequence);
	    }
	  };

	  this.getInfo(accountInfo);

	  return this;
	};

	/**
	 * Retrieve this account's Ripple trust lines.
	 *
	 * To keep up-to-date with changes to the AccountRoot entry, subscribe to the
	 * 'lines' event. (Not yet implemented.)
	 *
	 * @param {function(err, lines)} callback Called with the result
	 */

	Account.prototype.lines = function (callback) {
	  var self = this;
	  var callback = typeof callback === 'function' ? callback : function () {};

	  function accountLines(err, res) {
	    if (err) {
	      callback(err);
	    } else {
	      self._lines = res.lines;
	      self.emit('lines', self._lines);
	      callback(null, res);
	    }
	  }

	  this._remote.requestAccountLines({ account: this._account_id }, accountLines);

	  return this;
	};

	/**
	 * Retrieve this account's single trust line.
	 *
	 * @param {string} currency Currency
	 * @param {string} address Ripple address
	 * @param {function(err, line)} callback Called with the result
	 * @returns {Account}
	 */

	Account.prototype.line = function (currency, address, callback) {
	  var self = this;
	  var callback = typeof callback === 'function' ? callback : function () {};

	  self.lines(function (err, data) {
	    if (err) {
	      return callback(err);
	    }

	    var line;

	    top: for (var i = 0; i < data.lines.length; i++) {
	      var l = data.lines[i];
	      if (l.account === address && l.currency === currency) {
	        line = l;
	        break top;
	      }
	    }

	    callback(null, line);
	  });

	  return this;
	};

	/**
	 * Notify object of a relevant transaction.
	 *
	 * This is only meant to be called by the Remote class. You should never have to
	 * call this yourself.
	 *
	 * @param {Object} message
	 */

	Account.prototype.notify = Account.prototype.notifyTx = function (transaction) {
	  // Only trigger the event if the account object is actually
	  // subscribed - this prevents some weird phantom events from
	  // occurring.
	  if (!this._subs) {
	    return;
	  }

	  this.emit('transaction', transaction);

	  var account = transaction.transaction.Account;

	  if (!account) {
	    return;
	  }

	  var isThisAccount = account === this._account_id;

	  this.emit(isThisAccount ? 'transaction-outbound' : 'transaction-inbound', transaction);
	};

	/**
	 * Submit a transaction to an account's
	 * transaction manager
	 *
	 * @param {Transaction} transaction
	 */

	Account.prototype.submit = function (transaction) {
	  this._transactionManager.submit(transaction);
	};

	/**
	 *  Check whether the given public key is valid for this account
	 *
	 *  @param {Hex-encoded String|RippleAddress} public_key
	 *  @param {Function} callback
	 *
	 *  @callback
	 *  @param {Error} err
	 *  @param {Boolean} true if the public key is valid and active, false otherwise
	 */
	Account.prototype.publicKeyIsActive = function (public_key, callback) {
	  var self = this;
	  var public_key_as_uint160;

	  try {
	    public_key_as_uint160 = Account._publicKeyToAddress(public_key);
	  } catch (err) {
	    return callback(err);
	  }

	  function getAccountInfo(async_callback) {
	    self.getInfo(function (err, account_info_res) {

	      // If the remote responds with an Account Not Found error then the account
	      // is unfunded and thus we can assume that the master key is active
	      if (err && err.remote && err.remote.error === 'actNotFound') {
	        async_callback(null, null);
	      } else {
	        async_callback(err, account_info_res);
	      }
	    });
	  };

	  function publicKeyIsValid(account_info_res, async_callback) {
	    // Catch the case of unfunded accounts
	    if (!account_info_res) {

	      if (public_key_as_uint160 === self._account_id) {
	        async_callback(null, true);
	      } else {
	        async_callback(null, false);
	      }

	      return;
	    }

	    var account_info = account_info_res.account_data;

	    // Respond with true if the RegularKey is set and matches the given public key or
	    // if the public key matches the account address and the lsfDisableMaster is not set
	    if (account_info.RegularKey && account_info.RegularKey === public_key_as_uint160) {
	      async_callback(null, true);
	    } else if (account_info.Account === public_key_as_uint160 && (account_info.Flags & 0x00100000) === 0) {
	      async_callback(null, true);
	    } else {
	      async_callback(null, false);
	    }
	  };

	  var steps = [getAccountInfo, publicKeyIsValid];

	  async.waterfall(steps, callback);
	};

	/**
	 *  Convert a hex-encoded public key to a Ripple Address
	 *
	 *  @static
	 *
	 *  @param {Hex-encoded string|RippleAddress} public_key
	 *  @returns {RippleAddress}
	 */
	Account._publicKeyToAddress = function (public_key) {
	  // Based on functions in /src/js/ripple/keypair.js
	  function hexToUInt160(public_key) {
	    var bits = sjcl.codec.hex.toBits(public_key);
	    var hash = sjcl.hash.ripemd160.hash(sjcl.hash.sha256.hash(bits));
	    var address = UInt160.from_bits(hash);
	    address.set_version(Base.VER_ACCOUNT_ID);

	    return address.to_json();
	  };

	  if (UInt160.is_valid(public_key)) {
	    return public_key;
	  } else if (/^[0-9a-fA-F]+$/.test(public_key)) {
	    return hexToUInt160(public_key);
	  } else {
	    throw new Error('Public key is invalid. Must be a UInt160 or a hex string');
	  }
	};

	exports.Account = Account;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var util = __webpack_require__(41);
	var lodash = __webpack_require__(42);
	var EventEmitter = __webpack_require__(40).EventEmitter;
	var utils = __webpack_require__(17);
	var sjcl = __webpack_require__(17).sjcl;
	var Amount = __webpack_require__(3).Amount;
	var Currency = __webpack_require__(3).Currency;
	var UInt160 = __webpack_require__(3).UInt160;
	var Seed = __webpack_require__(11).Seed;
	var SerializedObject = __webpack_require__(13).SerializedObject;
	var RippleError = __webpack_require__(14).RippleError;
	var hashprefixes = __webpack_require__(30);
	var log = __webpack_require__(23).internal.sub('transaction');

	/**
	 * @constructor Transaction
	 *
	 * Notes:
	 * All transactions including those with local and malformed errors may be
	 * forwarded anyway.
	 *
	 * A malicous server can:
	 *  - may or may not forward
	 *  - give any result
	 *    + it may declare something correct as incorrect or something incorrect
	 *      as correct
	 *    + it may not communicate with the rest of the network
	 */

	function Transaction(remote) {
	  EventEmitter.call(this);

	  var self = this;
	  var remoteExists = typeof remote === 'object';

	  this.remote = remote;
	  this.tx_json = { Flags: 0 };
	  this._secret = undefined;
	  this._build_path = false;
	  this._maxFee = remoteExists ? this.remote.max_fee : undefined;
	  this.state = 'unsubmitted';
	  this.finalized = false;
	  this.previousSigningHash = undefined;
	  this.submitIndex = undefined;
	  this.canonical = remoteExists ? this.remote.canonical_signing : true;
	  this.submittedIDs = [];
	  this.attempts = 0;
	  this.submissions = 0;
	  this.responses = 0;

	  this.once('success', function (message) {
	    // Transaction definitively succeeded
	    self.setState('validated');
	    self.finalize(message);
	    if (self._successHandler) {
	      self._successHandler(message);
	    }
	  });

	  this.once('error', function (message) {
	    // Transaction definitively failed
	    self.setState('failed');
	    self.finalize(message);
	    if (self._errorHandler) {
	      self._errorHandler(message);
	    }
	  });

	  this.once('submitted', function () {
	    // Transaction was submitted to the network
	    self.setState('submitted');
	  });

	  this.once('proposed', function () {
	    // Transaction was submitted successfully to the network
	    self.setState('pending');
	  });
	}

	util.inherits(Transaction, EventEmitter);

	// This is currently a constant in rippled known as the "base reference"
	// https://wiki.ripple.com/Transaction_Fee#Base_Fees
	Transaction.fee_units = {
	  'default': 10
	};

	Transaction.flags = {
	  // Universal flags can apply to any transaction type
	  Universal: {
	    FullyCanonicalSig: 0x80000000
	  },

	  AccountSet: {
	    RequireDestTag: 0x00010000,
	    OptionalDestTag: 0x00020000,
	    RequireAuth: 0x00040000,
	    OptionalAuth: 0x00080000,
	    DisallowXRP: 0x00100000,
	    AllowXRP: 0x00200000
	  },

	  TrustSet: {
	    SetAuth: 0x00010000,
	    NoRipple: 0x00020000,
	    SetNoRipple: 0x00020000,
	    ClearNoRipple: 0x00040000,
	    SetFreeze: 0x00100000,
	    ClearFreeze: 0x00200000
	  },

	  OfferCreate: {
	    Passive: 0x00010000,
	    ImmediateOrCancel: 0x00020000,
	    FillOrKill: 0x00040000,
	    Sell: 0x00080000
	  },

	  Payment: {
	    NoRippleDirect: 0x00010000,
	    PartialPayment: 0x00020000,
	    LimitQuality: 0x00040000
	  }
	};

	// The following are integer (as opposed to bit) flags
	// that can be set for particular transactions in the
	// SetFlag or ClearFlag field
	Transaction.set_clear_flags = {
	  AccountSet: {
	    asfRequireDest: 1,
	    asfRequireAuth: 2,
	    asfDisallowXRP: 3,
	    asfDisableMaster: 4,
	    asfAccountTxnID: 5,
	    asfNoFreeze: 6,
	    asfGlobalFreeze: 7,
	    asfDefaultRipple: 8
	  }
	};

	Transaction.MEMO_TYPES = {};

	/* eslint-disable max-len */

	// URL characters per RFC 3986
	Transaction.MEMO_REGEX = /^[0-9a-zA-Z-\.\_\~\:\/\?\#\[\]\@\!\$\&\'\(\)\*\+\,\;\=\%]+$/;
	/* eslint-enable max-len */

	Transaction.formats = __webpack_require__(16).tx;

	Transaction.prototype.consts = {
	  telLOCAL_ERROR: -399,
	  temMALFORMED: -299,
	  tefFAILURE: -199,
	  terRETRY: -99,
	  tesSUCCESS: 0,
	  tecCLAIMED: 100
	};

	Transaction.prototype.isTelLocal = function (ter) {
	  return ter >= this.consts.telLOCAL_ERROR && ter < this.consts.temMALFORMED;
	};

	Transaction.prototype.isTemMalformed = function (ter) {
	  return ter >= this.consts.temMALFORMED && ter < this.consts.tefFAILURE;
	};

	Transaction.prototype.isTefFailure = function (ter) {
	  return ter >= this.consts.tefFAILURE && ter < this.consts.terRETRY;
	};

	Transaction.prototype.isTerRetry = function (ter) {
	  return ter >= this.consts.terRETRY && ter < this.consts.tesSUCCESS;
	};

	Transaction.prototype.isTepSuccess = function (ter) {
	  return ter >= this.consts.tesSUCCESS;
	};

	Transaction.prototype.isTecClaimed = function (ter) {
	  return ter >= this.consts.tecCLAIMED;
	};

	Transaction.prototype.isRejected = function (ter) {
	  return this.isTelLocal(ter) || this.isTemMalformed(ter) || this.isTefFailure(ter);
	};

	Transaction.from_json = function (j) {
	  return new Transaction().parseJson(j);
	};

	Transaction.prototype.parseJson = function (v) {
	  this.tx_json = v;
	  return this;
	};

	/**
	 * Set state on the condition that the state is different
	 *
	 * @param {String} state
	 */

	Transaction.prototype.setState = function (state) {
	  if (this.state !== state) {
	    this.state = state;
	    this.emit('state', state);
	  }
	};

	/**
	 * Finalize transaction. This will prevent future activity
	 *
	 * @param {Object} message
	 * @api private
	 */

	Transaction.prototype.finalize = function (message) {
	  this.finalized = true;

	  if (this.result) {
	    this.result.ledger_index = message.ledger_index;
	    this.result.ledger_hash = message.ledger_hash;
	  } else {
	    this.result = message;
	    this.result.tx_json = this.tx_json;
	  }

	  this.emit('cleanup');
	  this.emit('final', message);

	  if (this.remote && this.remote.trace) {
	    log.info('transaction finalized:', this.tx_json, this.getManager()._pending.getLength());
	  }

	  return this;
	};

	/**
	 * Get transaction Account
	 *
	 * @return {Account}
	 */

	Transaction.prototype.getAccount = function () {
	  return this.tx_json.Account;
	};

	/**
	 * Get TransactionType
	 *
	 * @return {String}
	 */

	Transaction.prototype.getType = Transaction.prototype.getTransactionType = function () {
	  return this.tx_json.TransactionType;
	};

	/**
	 * Get transaction TransactionManager
	 *
	 * @param [String] account
	 * @return {TransactionManager]
	 */

	Transaction.prototype.getManager = function (account_) {
	  if (!this.remote) {
	    return undefined;
	  }

	  var account = account_ || this.tx_json.Account;
	  return this.remote.account(account)._transactionManager;
	};

	/**
	 * Get transaction secret
	 *
	 * @param [String] account
	 */

	Transaction.prototype.getSecret = Transaction.prototype._accountSecret = function (account_) {
	  if (!this.remote) {
	    return undefined;
	  }

	  var account = account_ || this.tx_json.Account;
	  return this.remote.secrets[account];
	};

	/**
	 * Returns the number of fee units this transaction will cost.
	 *
	 * Each Ripple transaction based on its type and makeup costs a certain number
	 * of fee units. The fee units are calculated on a per-server basis based on the
	 * current load on both the network and the server.
	 *
	 * @see https://ripple.com/wiki/Transaction_Fee
	 *
	 * @return {Number} Number of fee units for this transaction.
	 */

	Transaction.prototype._getFeeUnits = Transaction.prototype.feeUnits = function () {
	  return Transaction.fee_units['default'];
	};

	/**
	 * Compute median server fee
	 *
	 * @return {String} median fee
	 */

	Transaction.prototype._computeFee = function () {
	  if (!this.remote) {
	    return undefined;
	  }

	  var servers = this.remote._servers;
	  var fees = [];

	  for (var i = 0; i < servers.length; i++) {
	    var server = servers[i];
	    if (server.isConnected()) {
	      fees.push(Number(server._computeFee(this._getFeeUnits())));
	    }
	  }

	  switch (fees.length) {
	    case 0:
	      return undefined;
	    case 1:
	      return String(fees[0]);
	  }

	  fees.sort(function ascending(a, b) {
	    if (a > b) {
	      return 1;
	    } else if (a < b) {
	      return -1;
	    }
	    return 0;
	  });

	  var midInd = Math.floor(fees.length / 2);

	  var median = fees.length % 2 === 0 ? Math.floor(0.5 + (fees[midInd] + fees[midInd - 1]) / 2) : fees[midInd];

	  return String(median);
	};

	/**
	 * Attempts to complete the transaction for submission.
	 *
	 * This function seeks to fill out certain fields, such as Fee and
	 * SigningPubKey, which can be determined by the library based on network
	 * information and other fields.
	 *
	 * @return {Boolean|Transaction} If succeeded, return transaction. Otherwise
	 * return `false`
	 */

	Transaction.prototype.complete = function () {
	  if (this.remote) {
	    if (!this.remote.trusted && !this.remote.local_signing) {
	      this.emit('error', new RippleError('tejServerUntrusted', 'Attempt to give secret to untrusted server'));
	      return false;
	    }
	  }

	  if (!this._secret) {
	    this._secret = this.getSecret();
	  }

	  // Try to auto-fill the secret
	  if (!this._secret) {
	    this.emit('error', new RippleError('tejSecretUnknown', 'Missing secret'));
	    return false;
	  }

	  if (typeof this.tx_json.SigningPubKey === 'undefined') {
	    try {
	      var seed = Seed.from_json(this._secret);
	      var key = seed.get_key(this.tx_json.Account);
	      this.tx_json.SigningPubKey = key.to_hex_pub();
	    } catch (e) {
	      this.emit('error', new RippleError('tejSecretInvalid', 'Invalid secret'));
	      return false;
	    }
	  }

	  // If the Fee hasn't been set, one needs to be computed by
	  // an assigned server
	  if (this.remote && typeof this.tx_json.Fee === 'undefined') {
	    if (this.remote.local_fee || !this.remote.trusted) {
	      this.tx_json.Fee = this._computeFee();
	      if (!this.tx_json.Fee) {
	        this.emit('error', new RippleError('tejUnconnected'));
	        return false;
	      }
	    }
	  }

	  if (Number(this.tx_json.Fee) > this._maxFee) {
	    this.emit('error', new RippleError('tejMaxFeeExceeded', 'Max fee exceeded'));
	    return false;
	  }

	  // Set canonical flag - this enables canonicalized signature checking
	  if (this.remote && this.remote.local_signing && this.canonical) {
	    this.tx_json.Flags |= Transaction.flags.Universal.FullyCanonicalSig;

	    // JavaScript converts operands to 32-bit signed ints before doing bitwise
	    // operations. We need to convert it back to an unsigned int.
	    this.tx_json.Flags = this.tx_json.Flags >>> 0;
	  }

	  return this.tx_json;
	};

	Transaction.prototype.serialize = function () {
	  return SerializedObject.from_json(this.tx_json);
	};

	Transaction.prototype.signingHash = function (testnet) {
	  return this.hash(testnet ? 'HASH_TX_SIGN_TESTNET' : 'HASH_TX_SIGN');
	};

	Transaction.prototype.hash = function (prefix_, asUINT256, serialized) {
	  var prefix = undefined;

	  if (typeof prefix_ !== 'string') {
	    prefix = hashprefixes.HASH_TX_ID;
	  } else if (!hashprefixes.hasOwnProperty(prefix_)) {
	    throw new Error('Unknown hashing prefix requested: ' + prefix_);
	  } else {
	    prefix = hashprefixes[prefix_];
	  }

	  var hash = (serialized || this.serialize()).hash(prefix);

	  return asUINT256 ? hash : hash.to_hex();
	};

	Transaction.prototype.sign = function (testnet) {
	  var seed = Seed.from_json(this._secret);
	  var prev_sig = this.tx_json.TxnSignature;

	  delete this.tx_json.TxnSignature;

	  var hash = this.signingHash(testnet);

	  // If the hash is the same, we can re-use the previous signature
	  if (prev_sig && hash === this.previousSigningHash) {
	    this.tx_json.TxnSignature = prev_sig;
	    return this;
	  }

	  var key = seed.get_key(this.tx_json.Account);
	  var sig = key.sign(hash);
	  var hex = sjcl.codec.hex.fromBits(sig).toUpperCase();

	  this.tx_json.TxnSignature = hex;
	  this.previousSigningHash = hash;

	  return this;
	};

	/**
	 * Add an ID to cached list of submitted IDs
	 *
	 * @param {String} transaction id
	 * @api private
	 */

	Transaction.prototype.addId = function (id) {
	  if (!lodash.contains(this.submittedIDs, id)) {
	    this.submittedIDs.unshift(id);
	  }
	};

	/**
	 * Find ID within cached received (validated) IDs. If this transaction has
	 * an ID that is within the cache, it has been seen validated, so return the
	 * received message
	 *
	 * @param {Object} cache
	 * @return {Object} message
	 * @api private
	 */

	Transaction.prototype.findId = function (cache) {
	  var cachedTransactionID = lodash.detect(this.submittedIDs, function (id) {
	    return cache.hasOwnProperty(id);
	  });
	  return cache[cachedTransactionID];
	};

	/**
	 * Set client ID. This is an identifier specified by the user of the API to
	 * identify a transaction in the event of a disconnect. It is not currently
	 * persisted in the transaction itself, but used offline for identification.
	 * In applications that require high reliability, client-specified ID should
	 * be persisted such that one could map it to submitted transactions. Use
	 * .summary() for a consistent transaction summary output for persisitng. In
	 * the future, this ID may be stored in the transaction itself (in the ledger)
	 *
	 * @param {String} id
	 */

	Transaction.prototype.setClientID = Transaction.prototype.clientID = function (id) {
	  if (typeof id === 'string') {
	    this._clientID = id;
	  }
	  return this;
	};

	/**
	 * Set LastLedgerSequence as the absolute last ledger sequence the transaction
	 * is valid for. LastLedgerSequence is set automatically if not set using this
	 * method
	 *
	 * @param {Number} ledger index
	 */

	Transaction.prototype.setLastLedgerSequence = Transaction.prototype.setLastLedger = Transaction.prototype.lastLedger = function (sequence) {
	  this._setUInt32('LastLedgerSequence', sequence);
	  this._setLastLedger = true;
	  return this;
	};

	/**
	 * Set max fee. Submission will abort if this is exceeded. Specified fee must
	 * be >= 0.
	 *
	 * @param {Number} fee The proposed fee
	 */

	Transaction.prototype.setMaxFee = Transaction.prototype.maxFee = function (fee) {
	  if (typeof fee === 'number' && fee >= 0) {
	    this._setMaxFee = true;
	    this._maxFee = fee;
	  }
	  return this;
	};

	/*
	 * Set the fee user will pay to the network for submitting this transaction.
	 * Specified fee must be >= 0.
	 *
	 * @param {Number} fee The proposed fee
	 *
	 * @returns {Transaction} calling instance for chaining
	 */
	Transaction.prototype.setFixedFee = function (fee) {
	  if (typeof fee === 'number' && fee >= 0) {
	    this._setFixedFee = true;
	    this.tx_json.Fee = String(fee);
	  }

	  return this;
	};

	/**
	 * Set secret If the secret has been set with Remote.setSecret, it does not
	 * need to be provided
	 *
	 * @param {String} secret
	 */

	Transaction.prototype.setSecret = Transaction.prototype.secret = function (secret) {
	  if (typeof secret === 'string') {
	    this._secret = secret;
	  }
	  return this;
	};

	Transaction.prototype.setType = function (type) {
	  if (lodash.isUndefined(Transaction.formats, type)) {
	    throw new Error('TransactionType must be a valid transaction type');
	  }

	  this.tx_json.TransactionType = type;

	  return this;
	};

	Transaction.prototype._setUInt32 = function (name, value, options_) {
	  var options = lodash.merge({}, options_);
	  var isValidUInt32 = typeof value === 'number' && value >= 0 && value < Math.pow(256, 4);

	  if (!isValidUInt32) {
	    throw new Error(name + ' must be a valid UInt32');
	  }
	  if (!lodash.isUndefined(options.min_value) && value < options.min_value) {
	    throw new Error(name + ' must be >= ' + options.min_value);
	  }

	  this.tx_json[name] = value;

	  return this;
	};

	/**
	 * Set SourceTag
	 *
	 * @param {Number} source tag
	 */

	Transaction.prototype.setSourceTag = Transaction.prototype.sourceTag = function (tag) {
	  return this._setUInt32('SourceTag', tag);
	};

	Transaction.prototype._setAccount = function (name, value) {
	  var uInt160 = UInt160.from_json(value);

	  if (!uInt160.is_valid()) {
	    throw new Error(name + ' must be a valid account');
	  }

	  this.tx_json[name] = uInt160.to_json();

	  return this;
	};

	Transaction.prototype.setAccount = function (account) {
	  return this._setAccount('Account', account);
	};

	Transaction.prototype._setAmount = function (name, amount, options_) {
	  var options = lodash.merge({ no_native: false }, options_);
	  var parsedAmount = Amount.from_json(amount);

	  if (parsedAmount.is_negative()) {
	    throw new Error(name + ' value must be non-negative');
	  }

	  var isNative = parsedAmount.currency().is_native();

	  if (isNative && options.no_native) {
	    throw new Error(name + ' must be a non-native amount');
	  }
	  if (!(isNative || parsedAmount.currency().is_valid())) {
	    throw new Error(name + ' must have a valid currency');
	  }
	  if (!(isNative || parsedAmount.issuer().is_valid())) {
	    throw new Error(name + ' must have a valid issuer');
	  }

	  this.tx_json[name] = parsedAmount.to_json();

	  return this;
	};

	Transaction.prototype._setHash256 = function (name, value, options_) {
	  if (typeof value !== 'string') {
	    throw new Error(name + ' must be a valid Hash256');
	  }

	  var options = lodash.merge({ pad: false }, options_);
	  var hash256 = value;

	  if (options.pad) {
	    while (hash256.length < 64) {
	      hash256 += '0';
	    }
	  }

	  if (!/^[0-9A-Fa-f]{64}$/.test(hash256)) {
	    throw new Error(name + ' must be a valid Hash256');
	  }

	  this.tx_json[name] = hash256;

	  return this;
	};

	Transaction.prototype.setAccountTxnID = Transaction.prototype.accountTxnID = function (id) {
	  return this._setHash256('AccountTxnID', id);
	};

	/**
	 * Set Flags. You may specify flags as a number, as the string name of the
	 * flag, or as an array of strings.
	 *
	 * setFlags(Transaction.flags.AccountSet.RequireDestTag)
	 * setFlags('RequireDestTag')
	 * setFlags('RequireDestTag', 'RequireAuth')
	 * setFlags([ 'RequireDestTag', 'RequireAuth' ])
	 *
	 * @param {Number|String|Array} flags
	 */

	Transaction.prototype.setFlags = function (flags) {
	  if (flags === undefined) {
	    return this;
	  }

	  if (typeof flags === 'number') {
	    this.tx_json.Flags = flags;
	    return this;
	  }

	  var transaction_flags = Transaction.flags[this.getType()] || {};
	  var flag_set = Array.isArray(flags) ? flags : [].slice.call(arguments);

	  for (var i = 0, l = flag_set.length; i < l; i++) {
	    var flag = flag_set[i];

	    if (transaction_flags.hasOwnProperty(flag)) {
	      this.tx_json.Flags += transaction_flags[flag];
	    } else {
	      // XXX Should throw?
	      this.emit('error', new RippleError('tejInvalidFlag'));
	      return this;
	    }
	  }

	  return this;
	};

	/**
	 * Add a Memo to transaction.
	 *
	 * @param [String] memoType
	 * - describes what the data represents, must contain valid URL characters
	 * @param [String] memoFormat
	 * - describes what format the data is in, MIME type, must contain valid URL
	 * - characters
	 * @param [String] memoData
	 * - data for the memo, can be any JS object. Any object other than string will
	 *   be stringified (JSON) for transport
	 */

	Transaction.prototype.addMemo = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);
	  } else {
	    options = {
	      memoType: arguments[0],
	      memoFormat: arguments[1],
	      memoData: arguments[2]
	    };
	  }

	  function convertStringToHex(string) {
	    var utf8String = sjcl.codec.utf8String.toBits(string);
	    return sjcl.codec.hex.fromBits(utf8String).toUpperCase();
	  }

	  var memo = {};
	  var memoRegex = Transaction.MEMO_REGEX;
	  var memoType = options.memoType;
	  var memoFormat = options.memoFormat;
	  var memoData = options.memoData;

	  if (memoType) {
	    if (!(lodash.isString(memoType) && memoRegex.test(memoType))) {
	      throw new Error('MemoType must be a string containing only valid URL characters');
	    }
	    if (Transaction.MEMO_TYPES[memoType]) {
	      // XXX Maybe in the future we want a schema validator for
	      // memo types
	      memoType = Transaction.MEMO_TYPES[memoType];
	    }
	    memo.MemoType = convertStringToHex(memoType);
	  }

	  if (memoFormat) {
	    if (!(lodash.isString(memoFormat) && memoRegex.test(memoFormat))) {
	      throw new Error('MemoFormat must be a string containing only valid URL characters');
	    }

	    memo.MemoFormat = convertStringToHex(memoFormat);
	  }

	  if (memoData) {
	    if (typeof memoData !== 'string') {
	      if (memoFormat.toLowerCase() === 'json') {
	        try {
	          memoData = JSON.stringify(memoData);
	        } catch (e) {
	          throw new Error('MemoFormat json with invalid JSON in MemoData field');
	        }
	      } else {
	        throw new Error('MemoData can only be a JSON object with a valid json MemoFormat');
	      }
	    }

	    memo.MemoData = convertStringToHex(memoData);
	  }

	  this.tx_json.Memos = (this.tx_json.Memos || []).concat({ Memo: memo });

	  return this;
	};

	/**
	 * Construct an 'AccountSet' transaction
	 *
	 * Note that bit flags can be set using the .setFlags() method but for
	 * 'AccountSet' transactions there is an additional way to modify AccountRoot
	 * flags. The values available for the SetFlag and ClearFlag are as follows:
	 *
	 * asfRequireDest:    Require a destination tag
	 * asfRequireAuth:    Authorization is required to extend trust
	 * asfDisallowXRP:    XRP should not be sent to this account
	 * asfDisableMaster:  Disallow use of the master key
	 * asfNoFreeze:       Permanently give up the ability to freeze individual
	 *                    trust lines. This flag can never be cleared.
	 * asfGlobalFreeze:   Freeze all assets issued by this account
	 *
	 * @param [String] set flag
	 * @param [String] clear flag
	 */

	Transaction.prototype.accountSet = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src;
	    }
	    if (lodash.isUndefined(options.set_flag)) {
	      options.set_flag = options.set;
	    }
	    if (lodash.isUndefined(options.clear_flag)) {
	      options.clear_flag = options.clear;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      set_flag: arguments[1],
	      clear_flag: arguments[2]
	    };
	  }

	  this.setType('AccountSet');
	  this.setAccount(options.account);

	  if (!lodash.isUndefined(options.set_flag)) {
	    this.setSetFlag(options.set_flag);
	  }
	  if (!lodash.isUndefined(options.clear_flag)) {
	    this.setClearFlag(options.clear_flag);
	  }

	  return this;
	};

	Transaction.prototype.setAccountSetFlag = function (name, value) {
	  // if (this.getType() !== 'AccountSet') {
	  // throw new Error('TransactionType must be AccountSet to use ' + name);
	  // }

	  var accountSetFlags = Transaction.set_clear_flags.AccountSet;
	  var flagValue = value;

	  if (typeof flagValue === 'string') {
	    flagValue = /^asf/.test(flagValue) ? accountSetFlags[flagValue] : accountSetFlags['asf' + flagValue];
	  }

	  if (!lodash.contains(lodash.values(accountSetFlags), flagValue)) {
	    throw new Error(name + ' must be a valid AccountSet flag');
	  }

	  this.tx_json[name] = flagValue;

	  return this;
	};

	Transaction.prototype.setSetFlag = function (flag) {
	  return this.setAccountSetFlag('SetFlag', flag);
	};

	Transaction.prototype.setClearFlag = function (flag) {
	  return this.setAccountSetFlag('ClearFlag', flag);
	};

	/**
	 * Set TransferRate for AccountSet
	 *
	 * @param {Number} transfer rate
	 */

	Transaction.prototype.setTransferRate = Transaction.prototype.transferRate = function (rate) {
	  /* eslint-disable max-len */
	  // if (this.getType() !== 'AccountSet') {
	  // throw new Error('TransactionType must be AccountSet to use TransferRate');
	  // }
	  /* eslint-enable max-len */

	  var transferRate = rate;

	  if (transferRate === 0) {
	    // Clear TransferRate
	    this.tx_json.TransferRate = transferRate;
	    return this;
	  }

	  // if (rate >= 1 && rate < 2) {
	  // transferRate *= 1e9;
	  // }

	  return this._setUInt32('TransferRate', transferRate, { min_value: 1e9 });
	};

	/**
	 * Construct a 'SetRegularKey' transaction
	 *
	 * If the RegularKey is set, the private key that corresponds to it can be
	 * used to sign transactions instead of the master key
	 *
	 * The RegularKey must be a valid Ripple Address, or a Hash160 of the public
	 * key corresponding to the new private signing key.
	 *
	 * @param {String} account
	 * @param {String} regular key
	 */

	Transaction.prototype.setRegularKey = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      regular_key: arguments[1]
	    };
	  }

	  this.setType('SetRegularKey');
	  this.setAccount(options.account);

	  if (!lodash.isUndefined(options.regular_key)) {
	    this._setAccount('RegularKey', options.regular_key);
	  }

	  return this;
	};

	/**
	 * Construct a 'TrustSet' transaction
	 *
	 * @param {String} account
	 * @param [Amount] limit
	 * @param [Number] quality in
	 * @param [Number] quality out
	 */

	Transaction.prototype.trustSet = Transaction.prototype.rippleLineSet = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      limit: arguments[1],
	      quality_in: arguments[2],
	      quality_out: arguments[3]
	    };
	  }

	  this.setType('TrustSet');
	  this.setAccount(options.account);

	  if (!lodash.isUndefined(options.limit)) {
	    this.setLimit(options.limit);
	  }
	  if (!lodash.isUndefined(options.quality_in)) {
	    this.setQualityIn(options.quality_in);
	  }
	  if (!lodash.isUndefined(options.quality_out)) {
	    this.setQualityOut(options.quality_out);
	  }

	  // XXX Throw an error if nothing is set.

	  return this;
	};

	Transaction.prototype.setLimit = function (amount) {
	  // if (this.getType() !== 'TrustSet') {
	  // throw new Error('TransactionType must be TrustSet to use LimitAmount');
	  // }

	  return this._setAmount('LimitAmount', amount, { no_native: true });
	};

	Transaction.prototype.setQualityIn = function (quality) {
	  // if (this.getType() !== 'TrustSet') {
	  // throw new Error('TransactionType must be TrustSet to use QualityIn');
	  // }

	  return this._setUInt32('QualityIn', quality);
	};

	Transaction.prototype.setQualityOut = function (quality) {
	  // if (this.getType() !== 'TrustSet') {
	  // throw new Error('TransactionType must be TrustSet to use QualityOut');
	  // }

	  return this._setUInt32('QualityOut', quality);
	};

	/**
	 * Construct a 'Payment' transaction
	 *
	 * Relevant setters:
	 *  - setPaths()
	 *  - setBuildPath()
	 *  - addPath()
	 *  - setSourceTag()
	 *  - setDestinationTag()
	 *  - setSendMax()
	 *  - setFlags()
	 *
	 *  @param {String} source account
	 *  @param {String} destination account
	 *  @param {Amount} payment amount
	 */

	Transaction.prototype.payment = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src || options.from;
	    }
	    if (lodash.isUndefined(options.destination)) {
	      options.destination = options.dst || options.to;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      destination: arguments[1],
	      amount: arguments[2]
	    };
	  }

	  this.setType('Payment');
	  this.setAccount(options.account);
	  this.setDestination(options.destination);
	  this.setAmount(options.amount);

	  return this;
	};

	Transaction.prototype.setAmount = function (amount) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use SendMax');
	  // }

	  return this._setAmount('Amount', amount);
	};

	Transaction.prototype.setDestination = function (destination) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use Destination');
	  // }

	  return this._setAccount('Destination', destination);
	};

	/**
	 * Set SendMax for Payment
	 *
	 * @param {String|Object} send max amount
	 */

	Transaction.prototype.setSendMax = Transaction.prototype.sendMax = function (send_max) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use SendMax');
	  // }

	  return this._setAmount('SendMax', send_max);
	};

	/**
	 * Filter invalid properties from path objects in a path array
	 *
	 * Valid properties are:
	 * - account
	 * - currency
	 * - issuer
	 * - type_hex
	 *
	 * @param {Array} path
	 * @return {Array} filtered path
	 */

	Transaction._rewritePath = function (path) {
	  var newPath = path.map(function (node) {
	    var newNode = {};

	    if (node.hasOwnProperty('account')) {
	      newNode.account = UInt160.json_rewrite(node.account);
	    }

	    if (node.hasOwnProperty('issuer')) {
	      newNode.issuer = UInt160.json_rewrite(node.issuer);
	    }

	    if (node.hasOwnProperty('currency')) {
	      newNode.currency = Currency.json_rewrite(node.currency);
	    }

	    if (node.hasOwnProperty('type_hex')) {
	      newNode.type_hex = node.type_hex;
	    }

	    return newNode;
	  });

	  return newPath;
	};

	/**
	 * Add a path for Payment transaction
	 *
	 * @param {Array} path
	 */

	Transaction.prototype.addPath = Transaction.prototype.pathAdd = function (path) {
	  if (!Array.isArray(path)) {
	    throw new Error('Path must be an array');
	  }
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use Paths');
	  // }

	  this.tx_json.Paths = this.tx_json.Paths || [];
	  this.tx_json.Paths.push(Transaction._rewritePath(path));

	  return this;
	};

	/**
	 * Set paths for Payment transaction
	 *
	 * @param {Array} paths
	 */

	Transaction.prototype.setPaths = Transaction.prototype.paths = function (paths) {
	  if (!Array.isArray(paths)) {
	    throw new Error('Paths must be an array');
	  }
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use Paths');
	  // }

	  this.tx_json.Paths = [];
	  paths.forEach(this.addPath, this);

	  return this;
	};

	/**
	 * Set build_path to have server blindly construct a path for Payment
	 *
	 *  "blindly" because the sender has no idea of the actual cost must be less
	 *  than send max.
	 *
	 *  @param {Boolean} build path
	 */

	Transaction.prototype.setBuildPath = Transaction.prototype.buildPath = function (build) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use build_path');
	  // }

	  this._build_path = build === undefined || build;

	  return this;
	};

	/**
	 * Set DestinationTag for Payment transaction
	 *
	 * @param {Number} destination tag
	 */

	Transaction.prototype.setDestinationTag = Transaction.prototype.destinationTag = function (tag) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use DestinationTag');
	  // }

	  return this._setUInt32('DestinationTag', tag);
	};

	/**
	 * Set InvoiceID for Payment transaction
	 *
	 * @param {String} id
	 */

	Transaction.prototype.setInvoiceID = Transaction.prototype.invoiceID = function (id) {
	  // if (this.getType() !== 'Payment') {
	  // throw new Error('TransactionType must be Payment to use InvoiceID');
	  // }

	  return this._setHash256('InvoiceID', id, { pad: true });
	};

	/**
	 * Construct an 'OfferCreate transaction
	 *
	 * @param {String} account
	 * @param {Amount} taker pays amount
	 * @param {Amount} taker gets amount
	 * @param [Number|Date] expiration
	 * @param [Number] sequence of an existing offer to replace
	 */

	Transaction.prototype.offerCreate = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src;
	    }
	    if (lodash.isUndefined(options.taker_pays)) {
	      options.taker_pays = options.buy;
	    }
	    if (lodash.isUndefined(options.taker_gets)) {
	      options.taker_gets = options.sell;
	    }
	    if (lodash.isUndefined(options.offer_sequence)) {
	      options.offer_sequence = options.cancel_sequence || options.sequence;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      taker_pays: arguments[1],
	      taker_gets: arguments[2],
	      expiration: arguments[3],
	      offer_sequence: arguments[4]
	    };
	  }

	  this.setType('OfferCreate');
	  this.setAccount(options.account);
	  this.setTakerGets(options.taker_gets);
	  this.setTakerPays(options.taker_pays);

	  if (!lodash.isUndefined(options.expiration)) {
	    this.setExpiration(options.expiration);
	  }
	  if (!lodash.isUndefined(options.offer_sequence)) {
	    this.setOfferSequence(options.offer_sequence);
	  }

	  return this;
	};

	Transaction.prototype.setTakerGets = function (amount) {
	  // if (this.getType() !== 'OfferCreate') {
	  // throw new Error('TransactionType must be OfferCreate to use TakerGets');
	  // }

	  return this._setAmount('TakerGets', amount);
	};

	Transaction.prototype.setTakerPays = function (amount) {
	  // if (this.getType() !== 'OfferCreate') {
	  // throw new Error('TransactionType must be OfferCreate to use TakerPays');
	  // }

	  return this._setAmount('TakerPays', amount);
	};

	Transaction.prototype.setExpiration = function (expiration) {
	  // if (this.getType() !== 'OfferCreate') {
	  // throw new Error('TransactionType must be OfferCreate to use Expiration');
	  // }

	  var timeOffset = expiration instanceof Date ? expiration.getTime() : expiration;

	  return this._setUInt32('Expiration', utils.time.toRipple(timeOffset));
	};

	Transaction.prototype.setOfferSequence = function (offerSequence) {
	  /* eslint-disable max-len */
	  // if (!/^Offer(Cancel|Create)$/.test(this.getType())) {
	  // throw new Error(
	  // 'TransactionType must be OfferCreate or OfferCancel to use OfferSequence'
	  // );
	  // }
	  /* eslint-enable max-len */

	  return this._setUInt32('OfferSequence', offerSequence);
	};

	/**
	 * Construct an 'OfferCancel' transaction
	 *
	 * @param {String} account
	 * @param [Number] sequence of an existing offer
	 */

	Transaction.prototype.offerCancel = function (options_) {
	  var options = undefined;

	  if (typeof options_ === 'object') {
	    options = lodash.merge({}, options_);

	    if (lodash.isUndefined(options.account)) {
	      options.account = options.src;
	    }
	    if (lodash.isUndefined(options.offer_sequence)) {
	      options.offer_sequence = options.sequence || options.cancel_sequence;
	    }
	  } else {
	    options = {
	      account: arguments[0],
	      offer_sequence: arguments[1]
	    };
	  }

	  this.setType('OfferCancel');
	  this.setAccount(options.account);
	  this.setOfferSequence(options.offer_sequence);

	  return this;
	};

	/**
	 * Submit transaction to the network
	 *
	 * @param [Function] callback
	 */

	Transaction.prototype.submit = function (callback) {
	  var self = this;

	  this.callback = typeof callback === 'function' ? callback : function () {};

	  this._errorHandler = function transactionError(error_, message) {
	    var error = error_;

	    if (!(error instanceof RippleError)) {
	      error = new RippleError(error, message);
	    }

	    self.callback(error);
	  };

	  this._successHandler = function transactionSuccess(message) {
	    self.callback(null, message);
	  };

	  if (!this.remote) {
	    this.emit('error', new Error('No remote found'));
	    return this;
	  }

	  /* eslint-disable max-len */
	  // if (this.state !== 'unsubmitted') {
	  // this.emit('error', new Error('Attempt to submit transaction more than once'));
	  // return;
	  // }
	  /* eslint-enable max-len */

	  this.getManager().submit(this);

	  return this;
	};

	Transaction.prototype.abort = function () {
	  if (!this.finalized) {
	    this.emit('error', new RippleError('tejAbort', 'Transaction aborted'));
	  }

	  return this;
	};

	/**
	 * Return summary object containing important information for persistence
	 *
	 * @return {Object} transaction summary
	 */

	Transaction.prototype.getSummary = Transaction.prototype.summary = function () {
	  var txSummary = {
	    tx_json: this.tx_json,
	    clientID: this._clientID,
	    submittedIDs: this.submittedIDs,
	    submissionAttempts: this.attempts,
	    submitIndex: this.submitIndex,
	    initialSubmitIndex: this.initialSubmitIndex,
	    lastLedgerSequence: this.lastLedgerSequence,
	    state: this.state,
	    finalized: this.finalized
	  };

	  if (this.result) {
	    var transaction_hash = this.result.tx_json ? this.result.tx_json.hash : undefined;

	    txSummary.result = {
	      engine_result: this.result.engine_result,
	      engine_result_message: this.result.engine_result_message,
	      ledger_hash: this.result.ledger_hash,
	      ledger_index: this.result.ledger_index,
	      transaction_hash: transaction_hash
	    };
	  }

	  return txSummary;
	};

	exports.Transaction = Transaction;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var extend = __webpack_require__(39);
	var UInt160 = __webpack_require__(9).UInt160;
	var utils = __webpack_require__(17);
	var Float = __webpack_require__(31).Float;

	//
	// Currency support
	//

	var Currency = extend(function () {
	  // Internal form: 0 = XRP. 3 letter-code.
	  // XXX Internal should be 0 or hex with three letter annotation when valid.

	  // Json form:
	  //  '', 'XRP', '0': 0
	  //  3-letter code: ...
	  // XXX Should support hex, C++ doesn't currently allow it.

	  this._value = NaN;
	  this._update();
	}, UInt160);

	Currency.prototype = extend({}, UInt160.prototype);
	Currency.prototype.constructor = Currency;

	Currency.HEX_CURRENCY_BAD = '0000000000000000000000005852500000000000';

	/**
	 * Tries to correctly interpret a Currency as entered by a user.
	 *
	 * Examples:
	 *
	 *  USD                               => currency
	 *  USD - Dollar                      => currency with optional full currency
	 *                                       name
	 *  XAU (-0.5%pa)                     => XAU with 0.5% effective demurrage rate
	 *                                       per year
	 *  XAU - Gold (-0.5%pa)              => Optionally allowed full currency name
	 *  USD (1%pa)                        => US dollars with 1% effective interest
	 *                                       per year
	 *  INR - Indian Rupees               => Optional full currency name with spaces
	 *  TYX - 30-Year Treasuries          => Optional full currency with numbers
	 *                                       and a dash
	 *  TYX - 30-Year Treasuries (1.5%pa) => Optional full currency with numbers,
	 *                                       dash and interest rate
	 *
	 *  The regular expression below matches above cases, broken down for better
	 *  understanding:
	 *
	 *  ^\s*                      // start with any amount of whitespace
	 *  ([a-zA-Z]{3}|[0-9]{3})    // either 3 letter alphabetic currency-code or 3
	 *                               digit numeric currency-code. See ISO 4217
	 *  (\s*-\s*[- \w]+)          // optional full currency name following the dash
	 *                               after currency code, full currency code can
	 *                               contain letters, numbers and dashes
	 *  (\s*\(-?\d+\.?\d*%pa\))?  // optional demurrage rate, has optional - and
	 *                               . notation (-0.5%pa)
	 *  \s*$                      // end with any amount of whitespace
	 *
	 */

	/*eslint-disable max-len*/
	Currency.prototype.human_RE = /^\s*([a-zA-Z0-9\<\>\(\)\{\}\[\]\|\?\!\@\#\$\%\^\&]{3})(\s*-\s*[- \w]+)?(\s*\(-?\d+\.?\d*%pa\))?\s*$/;
	/*eslint-enable max-len*/

	Currency.from_json = function (j, shouldInterpretXrpAsIou) {
	  return new Currency().parse_json(j, shouldInterpretXrpAsIou);
	};

	Currency.from_human = function (j, opts) {
	  return new Currency().parse_human(j, opts);
	};

	// this._value = NaN on error.
	Currency.prototype.parse_json = function (j, shouldInterpretXrpAsIou) {
	  this._value = NaN;

	  if (j instanceof Currency) {
	    this._value = j.copyTo({})._value;
	    this._update();
	    return this;
	  }

	  switch (typeof j) {
	    case 'number':
	      if (!isNaN(j)) {
	        this.parse_number(j);
	      }
	      break;
	    case 'string':
	      if (!j || j === '0') {
	        // Empty string or XRP
	        this.parse_hex(shouldInterpretXrpAsIou ? Currency.HEX_CURRENCY_BAD : Currency.HEX_ZERO);
	        break;
	      }

	      if (j === '1') {
	        // 'no currency'
	        this.parse_hex(Currency.HEX_ONE);
	        break;
	      }

	      if (/^[A-F0-9]{40}$/.test(j)) {
	        // Hex format
	        this.parse_hex(j);
	        break;
	      }

	      // match the given string to see if it's in an allowed format
	      var matches = j.match(this.human_RE);

	      if (matches) {
	        var currencyCode = matches[1];

	        // for the currency 'XRP' case
	        // we drop everything else that could have been provided
	        // e.g. 'XRP - Ripple'
	        if (!currencyCode || /^(0|XRP)$/.test(currencyCode)) {
	          this.parse_hex(shouldInterpretXrpAsIou ? Currency.HEX_CURRENCY_BAD : Currency.HEX_ZERO);

	          // early break, we can't have interest on XRP
	          break;
	        }

	        // the full currency is matched as it is part of the valid currency
	        // format, but not stored
	        // var full_currency = matches[2] || '';
	        var interest = matches[3] || '';

	        // interest is defined as interest per year, per annum (pa)
	        var percentage = interest.match(/(-?\d+\.?\d+)/);

	        currencyCode = currencyCode.toUpperCase();

	        var currencyData = utils.arraySet(20, 0);

	        if (percentage) {
	          /*
	           * 20 byte layout of a interest bearing currency
	           *
	           * 01 __ __ __ __ __ __ __ __ __ __ __ __ __ __ __ __ __ __ __
	           *    CURCODE- DATE------- RATE------------------- RESERVED---
	           */

	          // byte 1 for type, use '1' to denote demurrage currency
	          currencyData[0] = 1;

	          // byte 2-4 for currency code
	          currencyData[1] = currencyCode.charCodeAt(0) & 0xff;
	          currencyData[2] = currencyCode.charCodeAt(1) & 0xff;
	          currencyData[3] = currencyCode.charCodeAt(2) & 0xff;

	          // byte 5-8 are for reference date, but should always be 0 so we
	          // won't fill it

	          // byte 9-16 are for the interest
	          percentage = parseFloat(percentage[0]);

	          // the interest or demurrage is expressed as a yearly (per annum)
	          // value
	          var secondsPerYear = 31536000; // 60 * 60 * 24 * 365

	          // Calculating the interest e-fold
	          // 0.5% demurrage is expressed 0.995, 0.005 less than 1
	          // 0.5% interest is expressed as 1.005, 0.005 more than 1
	          var interestEfold = secondsPerYear / Math.log(1 + percentage / 100);
	          var bytes = Float.toIEEE754Double(interestEfold);

	          for (var i = 0; i <= bytes.length; i++) {
	            currencyData[8 + i] = bytes[i] & 0xff;
	          }

	          // the last 4 bytes are reserved for future use, so we won't fill
	          // those
	        } else {
	            currencyData[12] = currencyCode.charCodeAt(0) & 0xff;
	            currencyData[13] = currencyCode.charCodeAt(1) & 0xff;
	            currencyData[14] = currencyCode.charCodeAt(2) & 0xff;
	          }

	        this.parse_bytes(currencyData);
	      }
	      break;
	  }

	  return this;
	};

	Currency.prototype.parse_human = function (j) {
	  return this.parse_json(j);
	};

	/**
	 * Recalculate internal representation.
	 *
	 * You should never need to call this.
	 */

	Currency.prototype._update = function () {
	  var bytes = this.to_bytes();

	  // is it 0 everywhere except 12, 13, 14?
	  var isZeroExceptInStandardPositions = true;

	  if (!bytes) {
	    return;
	  }

	  this._native = false;
	  this._type = -1;
	  this._interest_start = NaN;
	  this._interest_period = NaN;
	  this._iso_code = '';

	  for (var i = 0; i < 20; i++) {
	    isZeroExceptInStandardPositions = isZeroExceptInStandardPositions && (i === 12 || i === 13 || i === 14 || bytes[i] === 0);
	  }

	  if (isZeroExceptInStandardPositions) {
	    this._iso_code = String.fromCharCode(bytes[12]) + String.fromCharCode(bytes[13]) + String.fromCharCode(bytes[14]);

	    if (this._iso_code === '\u0000\u0000\u0000') {
	      this._native = true;
	      this._iso_code = 'XRP';
	    }

	    this._type = 0;
	  } else if (bytes[0] === 0x01) {
	    // Demurrage currency
	    this._iso_code = String.fromCharCode(bytes[1]) + String.fromCharCode(bytes[2]) + String.fromCharCode(bytes[3]);

	    this._type = 1;
	    this._interest_start = (bytes[4] << 24) + (bytes[5] << 16) + (bytes[6] << 8) + bytes[7];
	    this._interest_period = Float.fromIEEE754Double(bytes.slice(8, 16));
	  }
	};

	// XXX Probably not needed anymore?
	/*
	Currency.prototype.parse_bytes = function(byte_array) {
	  if (Array.isArray(byte_array) && byte_array.length === 20) {
	    var result;
	    // is it 0 everywhere except 12, 13, 14?
	    var isZeroExceptInStandardPositions = true;

	    for (var i=0; i<20; i++) {
	      isZeroExceptInStandardPositions = isZeroExceptInStandardPositions
	      && (i===12 || i===13 || i===14 || byte_array[0]===0)
	    }

	    if (isZeroExceptInStandardPositions) {
	      var currencyCode = String.fromCharCode(byte_array[12])
	      + String.fromCharCode(byte_array[13])
	      + String.fromCharCode(byte_array[14]);
	      if (/^[A-Z0-9]{3}$/.test(currencyCode) && currencyCode !== 'XRP' ) {
	        this._value = currencyCode;
	      } else if (currencyCode === '\0\0\0') {
	        this._value = 0;
	      } else {
	        this._value = NaN;
	      }
	    } else {
	      // XXX Should support non-standard currency codes
	      this._value = NaN;
	    }
	  } else {
	    this._value = NaN;
	  }
	  return this;
	};
	*/

	Currency.prototype.is_native = function () {
	  return this._native;
	};

	/**
	 * @return {Boolean} whether this currency is an interest-bearing currency
	 */

	Currency.prototype.has_interest = function () {
	  return this._type === 1 && !isNaN(this._interest_start) && !isNaN(this._interest_period);
	};

	/**
	 *
	 * @param {number} referenceDate number of seconds since the Ripple Epoch
	 * (0:00 on January 1, 2000 UTC) used to calculate the
	 * interest over provided interval pass in one years
	 * worth of seconds to ge the yearly interest
	 * @returns {number} interest for provided interval, can be negative for
	 * demurred currencies
	 */
	Currency.prototype.get_interest_at = function (referenceDate) {
	  if (!this.has_interest()) {
	    return 0;
	  }

	  // use one year as a default period
	  if (!referenceDate) {
	    referenceDate = this._interest_start + 3600 * 24 * 365;
	  }

	  if (referenceDate instanceof Date) {
	    referenceDate = utils.fromTimestamp(referenceDate.getTime());
	  }

	  // calculate interest by e-fold number
	  return Math.exp((referenceDate - this._interest_start) / this._interest_period);
	};

	Currency.prototype.get_interest_percentage_at = function (referenceDate, decimals) {
	  var interest = this.get_interest_at(referenceDate, decimals);

	  // convert to percentage
	  interest = interest * 100 - 100;
	  var decimalMultiplier = decimals ? Math.pow(10, decimals) : 100;

	  // round to two decimals behind the dot
	  return Math.round(interest * decimalMultiplier) / decimalMultiplier;
	};

	// XXX Currently we inherit UInt.prototype.is_valid, which is mostly fine.
	//
	//     We could be doing further checks into the internal format of the
	//     currency data, since there are some values that are invalid.
	//
	// Currency.prototype.is_valid = function() {
	//  return UInt.prototype.is_valid() && ...;
	// };

	Currency.prototype.to_json = function (opts) {
	  if (!this.is_valid()) {
	    // XXX This is backwards compatible behavior, but probably not very good.
	    return 'XRP';
	  }

	  if (!opts) {
	    opts = {};
	  }

	  var currency;
	  var fullName = opts && opts.full_name ? ' - ' + opts.full_name : '';
	  opts.show_interest = opts.show_interest !== undefined ? opts.show_interest : this.has_interest();

	  if (!opts.force_hex && /^[A-Z0-9]{3}$/.test(this._iso_code)) {
	    currency = this._iso_code + fullName;
	    if (opts.show_interest) {
	      var decimals = !isNaN(opts.decimals) ? opts.decimals : undefined;
	      var interestPercentage = this.has_interest() ? this.get_interest_percentage_at(this._interest_start + 3600 * 24 * 365, decimals) : 0;
	      currency += ' (' + interestPercentage + '%pa)';
	    }
	  } else {
	    // Fallback to returning the raw currency hex
	    currency = this.to_hex();

	    // XXX This is to maintain backwards compatibility, but it is very, very
	    // odd behavior, so we should deprecate it and get rid of it as soon as
	    //  possible.
	    if (currency === Currency.HEX_ONE) {
	      currency = 1;
	    }
	  }

	  return currency;
	};

	Currency.prototype.to_human = function (opts) {
	  // to_human() will always print the human-readable currency code if available.
	  return this.to_json(opts);
	};

	Currency.prototype.get_iso = function () {
	  return this._iso_code;
	};

	exports.Currency = Currency;

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _Object$keys = __webpack_require__(28)['default'];

	var _ = __webpack_require__(42);
	var sjcl = __webpack_require__(17).sjcl;
	var utils = __webpack_require__(17);
	var extend = __webpack_require__(39);
	var convertBase = __webpack_require__(22);

	var Base = {};

	var alphabets = Base.alphabets = {
	  ripple: 'rpshnaf39wBUDNEGHJKLM4PQRST7VWXYZ2bcdeCg65jkm8oFqi1tuvAxyz',
	  tipple: 'RPShNAF39wBUDnEGHJKLM4pQrsT7VWXYZ2bcdeCg65jkm8ofqi1tuvaxyz',
	  bitcoin: '123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz'
	};

	extend(Base, {
	  VER_NONE: 1,
	  VER_NODE_PUBLIC: 28,
	  VER_NODE_PRIVATE: 32,
	  VER_ACCOUNT_ID: 0,
	  VER_ACCOUNT_PUBLIC: 35,
	  VER_ACCOUNT_PRIVATE: 34,
	  VER_FAMILY_GENERATOR: 41,
	  VER_FAMILY_SEED: 33
	});

	function sha256(bytes) {
	  return sjcl.codec.bytes.fromBits(sjcl.hash.sha256.hash(sjcl.codec.bytes.toBits(bytes)));
	}

	function encodeString(alphabet, input) {
	  if (input.length === 0) {
	    return '';
	  }

	  var leadingZeros = _.takeWhile(input, function (d) {
	    return d === 0;
	  });
	  var out = convertBase(input, 256, 58).map(function (digit) {
	    if (digit < 0 || digit >= alphabet.length) {
	      throw new Error('Value ' + digit + ' is out of bounds for encoding');
	    }
	    return alphabet[digit];
	  });
	  var prefix = leadingZeros.map(function () {
	    return alphabet[0];
	  });
	  return prefix.concat(out).join('');
	}

	function decodeString(indexes, input) {
	  if (input.length === 0) {
	    return [];
	  }

	  var input58 = input.split('').map(function (c) {
	    var charCode = c.charCodeAt(0);
	    if (charCode >= indexes.length || indexes[charCode] === -1) {
	      throw new Error('Character ' + c + ' is not valid for encoding');
	    }
	    return indexes[charCode];
	  });
	  var leadingZeros = _.takeWhile(input58, function (d) {
	    return d === 0;
	  });
	  var out = convertBase(input58, 58, 256);
	  return leadingZeros.concat(out);
	}

	function Base58(alphabet) {
	  var indexes = utils.arraySet(128, -1);
	  for (var i = 0; i < alphabet.length; i++) {
	    indexes[alphabet.charCodeAt(i)] = i;
	  }
	  return {
	    decode: decodeString.bind(null, indexes),
	    encode: encodeString.bind(null, alphabet)
	  };
	}

	Base.encoders = {};
	_Object$keys(alphabets).forEach(function (alphabet) {
	  Base.encoders[alphabet] = new Base58(alphabets[alphabet]);
	});

	// --> input: big-endian array of bytes.
	// <-- string at least as long as input.
	Base.encode = function (input, alpha) {
	  return this.encoders[alpha || 'ripple'].encode(input);
	};

	// --> input: String
	// <-- array of bytes or undefined.
	Base.decode = function (input, alpha) {
	  if (typeof input !== 'string') {
	    return undefined;
	  }
	  try {
	    return this.encoders[alpha || 'ripple'].decode(input);
	  } catch (e) {
	    return undefined;
	  }
	};

	Base.verify_checksum = function (bytes) {
	  var computed = sha256(sha256(bytes.slice(0, -4))).slice(0, 4);
	  var checksum = bytes.slice(-4);
	  return _.isEqual(computed, checksum);
	};

	// --> input: Array
	// <-- String
	Base.encode_check = function (version, input, alphabet) {
	  var buffer = [].concat(version, input);
	  var check = sha256(sha256(buffer)).slice(0, 4);

	  return Base.encode([].concat(buffer, check), alphabet);
	};

	// --> input : String
	// <-- NaN || sjcl.bn
	Base.decode_check = function (version, input, alphabet) {
	  var buffer = Base.decode(input, alphabet);

	  if (!buffer || buffer.length < 5) {
	    return NaN;
	  }

	  // Single valid version
	  if (typeof version === 'number' && buffer[0] !== version) {
	    return NaN;
	  }

	  // Multiple allowed versions
	  if (Array.isArray(version) && _.every(version, function (v) {
	    return v !== buffer[0];
	  })) {
	    return NaN;
	  }

	  if (!Base.verify_checksum(buffer)) {
	    return NaN;
	  }

	  // We'll use the version byte to add a leading zero, this ensures JSBN doesn't
	  // intrepret the value as a negative number
	  buffer[0] = 0;

	  return sjcl.bn.fromBits(sjcl.codec.bytes.toBits(buffer.slice(0, -4)));
	};

	exports.Base = Base;

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var utils = __webpack_require__(17);
	var extend = __webpack_require__(39);
	var UInt = __webpack_require__(32).UInt;

	//
	// UInt128 support
	//

	var UInt128 = extend(function () {
	  this._value = NaN;
	}, UInt);

	UInt128.width = 16;
	UInt128.prototype = extend({}, UInt.prototype);
	UInt128.prototype.constructor = UInt128;

	var HEX_ZERO = UInt128.HEX_ZERO = '00000000000000000000000000000000';
	var HEX_ONE = UInt128.HEX_ONE = '00000000000000000000000000000000';

	UInt128.STR_ZERO = utils.hexToString(HEX_ZERO);
	UInt128.STR_ONE = utils.hexToString(HEX_ONE);

	exports.UInt128 = UInt128;

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var utils = __webpack_require__(17);
	var extend = __webpack_require__(39);

	var UInt = __webpack_require__(32).UInt;
	var Base = __webpack_require__(7).Base;

	//
	// UInt160 support
	//

	var UInt160 = extend(function () {
	  this._value = NaN;
	  this._version_byte = undefined;
	  this._update();
	}, UInt);

	UInt160.width = 20;
	UInt160.prototype = extend({}, UInt.prototype);
	UInt160.prototype.constructor = UInt160;

	var HEX_ZERO = UInt160.HEX_ZERO = '0000000000000000000000000000000000000000';
	var HEX_ONE = UInt160.HEX_ONE = '0000000000000000000000000000000000000001';

	UInt160.ACCOUNT_ZERO = 'rrrrrrrrrrrrrrrrrrrrrhoLvTp';
	UInt160.ACCOUNT_ONE = 'rrrrrrrrrrrrrrrrrrrrBZbvji';
	UInt160.STR_ZERO = utils.hexToString(HEX_ZERO);
	UInt160.STR_ONE = utils.hexToString(HEX_ONE);

	UInt160.prototype.set_version = function (j) {
	  this._version_byte = j;
	  return this;
	};

	UInt160.prototype.get_version = function () {
	  return this._version_byte;
	};

	// value = NaN on error.
	UInt160.prototype.parse_json = function (j) {
	  if (typeof j === 'number' && !isNaN(j)) {
	    // Allow raw numbers - DEPRECATED
	    // This is used mostly by the test suite and is supported
	    // as a legacy feature only. DO NOT RELY ON THIS BEHAVIOR.
	    this.parse_number(j);
	    this._version_byte = Base.VER_ACCOUNT_ID;
	  } else if (typeof j !== 'string') {
	    this._value = NaN;
	  } else if (j[0] === 'r') {
	    this._value = Base.decode_check(Base.VER_ACCOUNT_ID, j);
	    this._version_byte = Base.VER_ACCOUNT_ID;
	  } else {
	    this.parse_hex(j);
	  }

	  this._update();

	  return this;
	};

	UInt160.prototype.parse_generic = function (j) {
	  UInt.prototype.parse_generic.call(this, j);

	  if (isNaN(this._value)) {
	    if (typeof j === 'string' && j[0] === 'r') {
	      this._value = Base.decode_check(Base.VER_ACCOUNT_ID, j);
	    }
	  }

	  this._update();

	  return this;
	};

	// XXX Json form should allow 0 and 1, C++ doesn't currently allow it.
	UInt160.prototype.to_json = function (opts) {
	  opts = opts || {};

	  if (this.is_valid()) {
	    // If this value has a type, return a Base58 encoded string.
	    if (typeof this._version_byte === 'number') {
	      var output = Base.encode_check(this._version_byte, this.to_bytes());

	      if (opts.gateways && output in opts.gateways) {
	        output = opts.gateways[output];
	      }

	      return output;
	    }
	    return this.to_hex();
	  }
	  return NaN;
	};

	exports.UInt160 = UInt160;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var utils = __webpack_require__(17);
	var extend = __webpack_require__(39);
	var UInt = __webpack_require__(32).UInt;

	//
	// UInt256 support
	//

	var UInt256 = extend(function () {
	  this._value = NaN;
	}, UInt);

	UInt256.width = 32;
	UInt256.prototype = extend({}, UInt.prototype);
	UInt256.prototype.constructor = UInt256;

	var HEX_ZERO = UInt256.HEX_ZERO = '00000000000000000000000000000000' + '00000000000000000000000000000000';

	var HEX_ONE = UInt256.HEX_ONE = '00000000000000000000000000000000' + '00000000000000000000000000000001';

	UInt256.STR_ZERO = utils.hexToString(HEX_ZERO);
	UInt256.STR_ONE = utils.hexToString(HEX_ONE);

	exports.UInt256 = UInt256;

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	//
	// Seed support
	//

	var extend = __webpack_require__(39);
	var utils = __webpack_require__(17);
	var sjcl = utils.sjcl;

	var Base = __webpack_require__(7).Base;
	var UInt = __webpack_require__(32).UInt;
	var UInt160 = __webpack_require__(9).UInt160;
	var KeyPair = __webpack_require__(33).KeyPair;

	var Seed = extend(function () {
	  this._curve = sjcl.ecc.curves.k256;
	  this._value = NaN;
	}, UInt);

	Seed.width = 16;
	Seed.prototype = extend({}, UInt.prototype);
	Seed.prototype.constructor = Seed;

	// value = NaN on error.
	// One day this will support rfc1751 too.
	Seed.prototype.parse_json = function (j) {
	  if (typeof j === 'string') {
	    if (!j.length) {
	      this._value = NaN;
	      // XXX Should actually always try and continue if it failed.
	    } else if (j[0] === 's') {
	        this._value = Base.decode_check(Base.VER_FAMILY_SEED, j);
	      } else if (/^[0-9a-fA-f]{32}$/.test(j)) {
	        this.parse_hex(j);
	        // XXX Should also try 1751
	      } else {
	          this.parse_passphrase(j);
	        }
	  } else {
	    this._value = NaN;
	  }

	  return this;
	};

	Seed.prototype.parse_passphrase = function (j) {
	  if (typeof j !== 'string') {
	    throw new Error('Passphrase must be a string');
	  }

	  var hash = sjcl.hash.sha512.hash(sjcl.codec.utf8String.toBits(j));
	  var bits = sjcl.bitArray.bitSlice(hash, 0, 128);

	  this.parse_bits(bits);

	  return this;
	};

	Seed.prototype.to_json = function () {
	  if (!this.is_valid()) {
	    return NaN;
	  }

	  var output = Base.encode_check(Base.VER_FAMILY_SEED, this.to_bytes());

	  return output;
	};

	function append_int(a, i) {
	  return [].concat(a, i >> 24, i >> 16 & 0xff, i >> 8 & 0xff, i & 0xff);
	}

	function firstHalfOfSHA512(bytes) {
	  return sjcl.bitArray.bitSlice(sjcl.hash.sha512.hash(sjcl.codec.bytes.toBits(bytes)), 0, 256);
	}

	// Removed a `*` so this JSDoc-ish syntax is ignored.
	// This will soon all change anyway.
	/*
	* @param account
	*        {undefined}                 take first, default, KeyPair
	*
	*        {Number}                    specifies the account number of the KeyPair
	*                                    desired.
	*
	*        {Uint160} (from_json able), specifies the address matching the KeyPair
	*                                    that is desired.
	*
	* @param maxLoops (optional)
	*        {Number}                    specifies the amount of attempts taken
	*                                    to generate a matching KeyPair
	*
	*/
	Seed.prototype.get_key = function (account, maxLoops) {
	  var account_number = 0,
	      address = undefined;
	  var max_loops = maxLoops || 1;

	  if (!this.is_valid()) {
	    throw new Error('Cannot generate keys from invalid seed!');
	  }
	  if (account) {
	    if (typeof account === 'number') {
	      account_number = account;
	      max_loops = account_number + 1;
	    } else {
	      address = UInt160.from_json(account);
	    }
	  }

	  var private_gen = undefined,
	      public_gen = undefined;
	  var curve = this._curve;
	  var i = 0;

	  do {
	    private_gen = sjcl.bn.fromBits(firstHalfOfSHA512(append_int(this.to_bytes(), i)));
	    i++;
	  } while (!curve.r.greaterEquals(private_gen));

	  public_gen = curve.G.mult(private_gen);

	  var sec = undefined;
	  var key_pair = undefined;

	  do {

	    i = 0;

	    do {
	      sec = sjcl.bn.fromBits(firstHalfOfSHA512(append_int(append_int(public_gen.toBytesCompressed(), account_number), i)));
	      i++;
	    } while (!curve.r.greaterEquals(sec));

	    account_number++;
	    sec = sec.add(private_gen).mod(curve.r);
	    key_pair = KeyPair.from_bn_secret(sec);

	    if (max_loops-- <= 0) {
	      // We are almost certainly looking for an account that would take same
	      // value of $too_long {forever, ...}
	      throw new Error('Too many loops looking for KeyPair yielding ' + address.to_json() + ' from ' + this.to_json());
	    }
	  } while (address && !key_pair.get_address().equals(address));

	  return key_pair;
	};

	exports.Seed = Seed;

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var extend = __webpack_require__(39);
	var utils = __webpack_require__(17);
	var UInt160 = __webpack_require__(9).UInt160;
	var Amount = __webpack_require__(3).Amount;

	/**
	 * Meta data processing facility
	 *
	 * @constructor
	 * @param {Object} transaction metadata
	 */

	function Meta(data) {
	  var self = this;

	  this.nodes = [];

	  if (typeof data !== 'object') {
	    throw new TypeError('Missing metadata');
	  }

	  if (!Array.isArray(data.AffectedNodes)) {
	    throw new TypeError('Metadata missing AffectedNodes');
	  }

	  data.AffectedNodes.forEach(this.addNode, this);
	};

	Meta.NODE_TYPES = ['CreatedNode', 'ModifiedNode', 'DeletedNode'];

	Meta.AMOUNT_FIELDS_AFFECTING_ISSUER = ['LowLimit', 'HighLimit', 'TakerPays', 'TakerGets'];

	Meta.ACCOUNT_FIELDS = ['Account', 'Owner', 'Destination', 'Issuer', 'Target'];

	/**
	 * @param {Object} node
	 * @api private
	 */

	Meta.prototype.getNodeType = function (node) {
	  var result = null;

	  for (var i = 0; i < Meta.NODE_TYPES.length; i++) {
	    var type = Meta.NODE_TYPES[i];
	    if (node.hasOwnProperty(type)) {
	      result = type;
	      break;
	    }
	  }

	  return result;
	};

	/**
	 * @param {String} field
	 * @api private
	 */

	Meta.prototype.isAccountField = function (field) {
	  return Meta.ACCOUNT_FIELDS.indexOf(field) !== -1;
	};

	/**
	 * Add node to metadata
	 *
	 * @param {Object} node
	 * @api private
	 */

	Meta.prototype.addNode = function (node) {
	  this._affectedAccounts = void 0;
	  this._affectedBooks = void 0;

	  var result = {};

	  if (result.nodeType = this.getNodeType(node)) {
	    node = node[result.nodeType];
	    result.diffType = result.nodeType;
	    result.entryType = node.LedgerEntryType;
	    result.ledgerIndex = node.LedgerIndex;
	    result.fields = extend({}, node.PreviousFields, node.NewFields, node.FinalFields);
	    result.fieldsPrev = node.PreviousFields || {};
	    result.fieldsNew = node.NewFields || {};
	    result.fieldsFinal = node.FinalFields || {};

	    // getAffectedBooks will set this
	    // result.bookKey   = undefined;

	    this.nodes.push(result);
	  }
	};

	/**
	 * Get affected nodes array
	 *
	 * @param {Object} filter options
	 * @return {Array} nodes
	 */

	Meta.prototype.getNodes = function (options) {
	  if (typeof options === 'object') {
	    return this.nodes.filter(function (node) {
	      if (options.nodeType && options.nodeType !== node.nodeType) {
	        return false;
	      }
	      if (options.entryType && options.entryType !== node.entryType) {
	        return false;
	      }
	      if (options.bookKey && options.bookKey !== node.bookKey) {
	        return false;
	      }
	      return true;
	    });
	  } else {
	    return this.nodes;
	  }
	};

	Meta.prototype.getAffectedAccounts = function (from) {
	  if (this._affectedAccounts) {
	    return this._affectedAccounts;
	  }

	  var accounts = [];

	  // This code should match the behavior of the C++ method:
	  // TransactionMetaSet::getAffectedAccounts
	  for (var i = 0; i < this.nodes.length; i++) {
	    var node = this.nodes[i];
	    var fields = node.nodeType === 'CreatedNode' ? node.fieldsNew : node.fieldsFinal;

	    for (var fieldName in fields) {
	      var field = fields[fieldName];

	      if (this.isAccountField(fieldName) && UInt160.is_valid(field)) {
	        accounts.push(field);
	      } else if (~Meta.AMOUNT_FIELDS_AFFECTING_ISSUER.indexOf(fieldName)) {
	        var amount = Amount.from_json(field);
	        var issuer = amount.issuer();
	        if (issuer.is_valid() && !issuer.is_zero()) {
	          accounts.push(issuer.to_json());
	        }
	      }
	    }
	  }

	  this._affectedAccounts = utils.arrayUnique(accounts);

	  return this._affectedAccounts;
	};

	Meta.prototype.getAffectedBooks = function () {
	  if (this._affectedBooks) {
	    return this._affectedBooks;
	  }

	  var books = [];

	  for (var i = 0; i < this.nodes.length; i++) {
	    var node = this.nodes[i];

	    if (node.entryType !== 'Offer') {
	      continue;
	    }

	    var gets = Amount.from_json(node.fields.TakerGets);
	    var pays = Amount.from_json(node.fields.TakerPays);
	    var getsKey = gets.currency().to_json();
	    var paysKey = pays.currency().to_json();

	    if (getsKey !== 'XRP') {
	      getsKey += '/' + gets.issuer().to_json();
	    }

	    if (paysKey !== 'XRP') {
	      paysKey += '/' + pays.issuer().to_json();
	    }

	    var key = getsKey + ':' + paysKey;

	    // Hell of a lot of work, so we are going to cache this. We can use this
	    // later to good effect in OrderBook.notify to make sure we only process
	    // pertinent offers.
	    node.bookKey = key;

	    books.push(key);
	  }

	  this._affectedBooks = utils.arrayUnique(books);

	  return this._affectedBooks;
	};

	/**
	 * Execute a function on each affected node.
	 *
	 * The callback is passed two parameters. The first is a node object which looks
	 * like this:
	 *
	 *   {
	 *     // Type of diff, e.g. CreatedNode, ModifiedNode
	 *     nodeType: 'CreatedNode'
	 *
	 *     // Type of node affected, e.g. RippleState, AccountRoot
	 *     entryType: 'RippleState',
	 *
	 *     // Index of the ledger this change occurred in
	 *     ledgerIndex: '01AB01AB...',
	 *
	 *     // Contains all fields with later versions taking precedence
	 *     //
	 *     // This is a shorthand for doing things like checking which account
	 *     // this affected without having to check the nodeType.
	 *     fields: {...},
	 *
	 *     // Old fields (before the change)
	 *     fieldsPrev: {...},
	 *
	 *     // New fields (that have been added)
	 *     fieldsNew: {...},
	 *
	 *     // Changed fields
	 *     fieldsFinal: {...}
	 *   }
	 */

	['forEach', 'map', 'filter', 'every', 'some', 'reduce'].forEach(function (fn) {
	  Meta.prototype[fn] = function () {
	    return Array.prototype[fn].apply(this.nodes, arguments);
	  };
	});

	Meta.prototype.each = Meta.prototype.forEach;

	exports.Meta = Meta;

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {'use strict';

	var _Object$keys = __webpack_require__(28)['default'];

	var _ = __webpack_require__(42);
	var assert = __webpack_require__(38);
	var extend = __webpack_require__(39);
	var binformat = __webpack_require__(16);
	var stypes = __webpack_require__(26);
	var utils = __webpack_require__(17);
	var UInt256 = __webpack_require__(10).UInt256;

	var sjcl = utils.sjcl;

	var TRANSACTION_TYPES = {};

	_Object$keys(binformat.tx).forEach(function (key) {
	  TRANSACTION_TYPES[binformat.tx[key][0]] = key;
	});

	var LEDGER_ENTRY_TYPES = {};

	_Object$keys(binformat.ledger).forEach(function (key) {
	  LEDGER_ENTRY_TYPES[binformat.ledger[key][0]] = key;
	});

	var TRANSACTION_RESULTS = {};

	_Object$keys(binformat.ter).forEach(function (key) {
	  TRANSACTION_RESULTS[binformat.ter[key]] = key;
	});

	function normalize_sjcl_bn_hex(string) {
	  var hex = string.slice(2); // remove '0x' prefix
	  // now strip leading zeros
	  var i = _.findIndex(hex, function (c) {
	    return c !== '0';
	  });
	  return i >= 0 ? hex.slice(i) : '0';
	}

	function SerializedObject(buf) {
	  if (Array.isArray(buf) || Buffer && Buffer.isBuffer(buf)) {
	    this.buffer = buf;
	  } else if (typeof buf === 'string') {
	    this.buffer = sjcl.codec.bytes.fromBits(sjcl.codec.hex.toBits(buf));
	  } else if (!buf) {
	    this.buffer = [];
	  } else {
	    throw new Error('Invalid buffer passed.');
	  }
	  this.pointer = 0;
	}

	SerializedObject.from_json = function (obj_) {
	  // Create a copy of the object so we don't modify it
	  var obj = extend(true, {}, obj_);

	  var so = new SerializedObject();
	  var typedef = undefined;

	  if (typeof obj.TransactionType === 'number') {
	    obj.TransactionType = SerializedObject.lookup_type_tx(obj.TransactionType);
	    if (!obj.TransactionType) {
	      throw new Error('Transaction type ID is invalid.');
	    }
	  }

	  if (typeof obj.LedgerEntryType === 'number') {
	    obj.LedgerEntryType = SerializedObject.lookup_type_le(obj.LedgerEntryType);

	    if (!obj.LedgerEntryType) {
	      throw new Error('LedgerEntryType ID is invalid.');
	    }
	  }

	  if (typeof obj.TransactionType === 'string') {
	    typedef = binformat.tx[obj.TransactionType];
	    if (!Array.isArray(typedef)) {
	      throw new Error('Transaction type is invalid');
	    }

	    typedef = typedef.slice();
	    obj.TransactionType = typedef.shift();
	  } else if (typeof obj.LedgerEntryType === 'string') {
	    typedef = binformat.ledger[obj.LedgerEntryType];

	    if (!Array.isArray(typedef)) {
	      throw new Error('LedgerEntryType is invalid');
	    }

	    typedef = typedef.slice();
	    obj.LedgerEntryType = typedef.shift();
	  } else if (typeof obj.AffectedNodes === 'object') {
	    typedef = binformat.metadata;
	  } else {
	    throw new Error('Object to be serialized must contain either' + ' TransactionType, LedgerEntryType or AffectedNodes.');
	  }

	  // ND: This from_*json* seems a reasonable place to put validation of `json`
	  SerializedObject.check_fields(typedef, obj);
	  so.serialize(typedef, obj);

	  return so;
	};

	SerializedObject.check_fields = function (typedef, obj) {
	  var missingFields = [];
	  var unknownFields = [];
	  var fieldsMap = {};

	  // Get missing required fields
	  typedef.forEach(function (field) {
	    var fieldName = field[0];
	    var isRequired = field[1] === binformat.REQUIRED;

	    if (isRequired && obj[fieldName] === undefined) {
	      missingFields.push(fieldName);
	    } else {
	      fieldsMap[fieldName] = true;
	    }
	  });

	  // Get fields that are not specified in format
	  _Object$keys(obj).forEach(function (key) {
	    if (!fieldsMap[key] && /^[A-Z]/.test(key)) {
	      unknownFields.push(key);
	    }
	  });

	  if (!(missingFields.length || unknownFields.length)) {
	    // No missing or unknown fields
	    return;
	  }

	  var errorMessage = undefined;

	  if (obj.TransactionType !== undefined) {
	    errorMessage = SerializedObject.lookup_type_tx(obj.TransactionType);
	  } else if (obj.LedgerEntryType !== undefined) {
	    errorMessage = SerializedObject.lookup_type_le(obj.LedgerEntryType);
	  } else {
	    errorMessage = 'TransactionMetaData';
	  }

	  if (missingFields.length > 0) {
	    errorMessage += ' is missing fields: ' + JSON.stringify(missingFields);
	  }
	  if (unknownFields.length > 0) {
	    errorMessage += (missingFields.length ? ' and' : '') + ' has unknown fields: ' + JSON.stringify(unknownFields);
	  }

	  throw new Error(errorMessage);
	};

	SerializedObject.prototype.append = function (bytes_) {
	  var bytes = bytes_ instanceof SerializedObject ? bytes_.buffer : bytes_;

	  // Make sure both buffer and bytes are Array. Either could be a Buffer.
	  if (Array.isArray(this.buffer) && Array.isArray(bytes)) {
	    // `this.buffer = this.buffer.concat(bytes)` can be unbearably slow for
	    // large bytes length and acceptable bytes length is limited for
	    // `Array.prototype.push.apply(this.buffer, bytes)` as every element in the
	    // bytes array is pushed onto the stack, potentially causing a RangeError
	    // exception. Both of these solutions are known to be problematic for
	    // ledger 7501326. KISS instead

	    for (var i = 0; i < bytes.length; i++) {
	      this.buffer.push(bytes[i]);
	    }
	  } else {
	    this.buffer = this.buffer.concat(bytes);
	  }

	  this.pointer += bytes.length;
	};

	SerializedObject.prototype.resetPointer = function () {
	  this.pointer = 0;
	};

	function readOrPeek(advance) {
	  return function (bytes) {
	    var start = this.pointer;
	    var end = start + bytes;

	    if (end > this.buffer.length) {
	      throw new Error('Buffer length exceeded');
	    }

	    var result = this.buffer.slice(start, end);

	    if (advance) {
	      this.pointer = end;
	    }

	    return result;
	  };
	}

	SerializedObject.prototype.read = readOrPeek(true);

	SerializedObject.prototype.peek = readOrPeek(false);

	SerializedObject.prototype.to_bits = function () {
	  return sjcl.codec.bytes.toBits(this.buffer);
	};

	SerializedObject.prototype.to_hex = function () {
	  return sjcl.codec.hex.fromBits(this.to_bits()).toUpperCase();
	};

	SerializedObject.prototype.to_json = function () {
	  var old_pointer = this.pointer;

	  this.resetPointer();

	  var output = {};

	  while (this.pointer < this.buffer.length) {
	    var key_and_value = stypes.parse(this);
	    var key = key_and_value[0];
	    var value = key_and_value[1];
	    output[key] = SerializedObject.jsonify_structure(value, key);
	  }

	  this.pointer = old_pointer;

	  return output;
	};

	SerializedObject.jsonify_structure = function (structure, field_name) {
	  var output = undefined;

	  switch (typeof structure) {
	    case 'number':
	      switch (field_name) {
	        case 'LedgerEntryType':
	          output = LEDGER_ENTRY_TYPES[structure];
	          break;
	        case 'TransactionResult':
	          output = TRANSACTION_RESULTS[structure];
	          break;
	        case 'TransactionType':
	          output = TRANSACTION_TYPES[structure];
	          break;
	        default:
	          output = structure;
	      }
	      break;
	    case 'object':
	      if (structure === null) {
	        break;
	      }

	      if (typeof structure.to_json === 'function') {
	        output = structure.to_json();
	      } else if (structure instanceof sjcl.bn) {
	        output = ('0000000000000000' + normalize_sjcl_bn_hex(structure.toString()).toUpperCase()).slice(-16);
	      } else {
	        // new Array or Object
	        output = new structure.constructor();

	        var keys = _Object$keys(structure);

	        for (var i = 0, l = keys.length; i < l; i++) {
	          var key = keys[i];
	          output[key] = SerializedObject.jsonify_structure(structure[key], key);
	        }
	      }
	      break;
	    default:
	      output = structure;
	  }

	  return output;
	};

	SerializedObject.prototype.serialize = function (typedef, obj) {
	  // Serialize object without end marker
	  stypes.Object.serialize(this, obj, true);

	  // ST: Old serialization
	  /*
	  // Ensure canonical order
	  typedef = SerializedObject.sort_typedef(typedef);
	   // Serialize fields
	  for (let i=0, l=typedef.length; i<l; i++) {
	    this.serialize_field(typedef[i], obj);
	  }
	  */
	};

	SerializedObject.prototype.hash = function (prefix) {
	  var sign_buffer = new SerializedObject();

	  // Add hashing prefix
	  if (typeof prefix !== 'undefined') {
	    stypes.Int32.serialize(sign_buffer, prefix);
	  }

	  // Copy buffer to temporary buffer
	  sign_buffer.append(this.buffer);

	  var bits = sjcl.codec.bytes.toBits(sign_buffer.buffer);
	  var sha512hex = sjcl.codec.hex.fromBits(sjcl.hash.sha512.hash(bits));

	  return UInt256.from_hex(sha512hex.substr(0, 64));
	};

	// DEPRECATED
	SerializedObject.prototype.signing_hash = SerializedObject.prototype.hash;

	SerializedObject.prototype.serialize_field = function (spec, obj) {
	  var name = spec[0];
	  var presence = spec[1];

	  if (typeof obj[name] !== 'undefined') {
	    try {
	      stypes.serialize(this, name, obj[name]);
	    } catch (e) {
	      // Add field name to message and rethrow
	      e.message = 'Error serializing "' + name + '": ' + e.message;
	      throw e;
	    }
	  } else if (presence === binformat.REQUIRED) {
	    throw new Error('Missing required field ' + name);
	  }
	};

	SerializedObject.get_field_header = function (type_id, field_id) {
	  var buffer = [0];

	  if (type_id > 0xF) {
	    buffer.push(type_id & 0xFF);
	  } else {
	    buffer[0] += (type_id & 0xF) << 4;
	  }

	  if (field_id > 0xF) {
	    buffer.push(field_id & 0xFF);
	  } else {
	    buffer[0] += field_id & 0xF;
	  }

	  return buffer;
	};

	SerializedObject.sort_typedef = function (typedef) {
	  assert(Array.isArray(typedef));

	  function sort_field_compare(a, b) {
	    // Sort by type id first, then by field id
	    return a[3] !== b[3] ? stypes[a[3]].id - stypes[b[3]].id : a[2] - b[2];
	  }

	  return typedef.sort(sort_field_compare);
	};

	SerializedObject.lookup_type_tx = function (id) {
	  assert.strictEqual(typeof id, 'number');
	  return TRANSACTION_TYPES[id];
	};

	SerializedObject.lookup_type_le = function (id) {
	  assert(typeof id === 'number');
	  return LEDGER_ENTRY_TYPES[id];
	};

	exports.SerializedObject = SerializedObject;
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var util = __webpack_require__(41);
	var extend = __webpack_require__(39);

	function RippleError(code, message) {
	  switch (typeof code) {
	    case 'object':
	      extend(this, code);
	      break;

	    case 'string':
	      this.result = code;
	      this.result_message = message;
	      break;
	  }

	  this.engine_result = this.result = this.result || this.engine_result || this.error || 'Error';
	  this.engine_result_message = this.result_message = this.result_message || this.engine_result_message || this.error_message || 'Error';
	  this.result_message = this.message = this.result_message;

	  var stack;

	  if (!!Error.captureStackTrace) {
	    Error.captureStackTrace(this, code || this);
	  } else if (stack = new Error().stack) {
	    this.stack = stack;
	  }
	};

	util.inherits(RippleError, Error);

	RippleError.prototype.name = 'RippleError';

	exports.RippleError = RippleError;

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint-disable valid-jsdoc */
	'use strict';
	var async = __webpack_require__(51);
	var sjcl = __webpack_require__(17).sjcl;
	var Remote = __webpack_require__(1).Remote;
	var Seed = __webpack_require__(11).Seed;
	var KeyPair = __webpack_require__(33).KeyPair;
	var Account = __webpack_require__(4).Account;
	var UInt160 = __webpack_require__(9).UInt160;

	// Message class (static)
	var Message = {};

	Message.hashFunction = sjcl.hash.sha512.hash;
	Message.MAGIC_BYTES = 'Ripple Signed Message:\n';

	var REGEX_HEX = /^[0-9a-fA-F]+$/;
	var REGEX_BASE64 = /^([A-Za-z0-9\+]{4})*([A-Za-z0-9\+]{2}==)|([A-Za-z0-9\+]{3}=)?$/;

	/**
	 *  Produce a Base64-encoded signature on the given message with
	 *  the string 'Ripple Signed Message:\n' prepended.
	 *
	 *  Note that this signature uses the signing function that includes
	 *  a recovery_factor to be able to extract the public key from the signature
	 *  without having to pass the public key along with the signature.
	 *
	 *  @static
	 *
	 *  @param {String} message
	 *  @param {sjcl.ecc.ecdsa.secretKey|Any format accepted by Seed.from_json}
	 *         secret_key
	 *  @param {RippleAddress} [The first key] account Field to specify the signing
	 *      account. If this is omitted the first account produced by the secret
	 *      generator will be used.
	 *  @return {Base64-encoded String} signature
	 */
	Message.signMessage = function (message, secret_key, account) {
	  return Message.signHash(Message.hashFunction(Message.MAGIC_BYTES + message), secret_key, account);
	};

	/**
	 *  Produce a Base64-encoded signature on the given hex-encoded hash.
	 *
	 *  Note that this signature uses the signing function that includes
	 *  a recovery_factor to be able to extract the public key from the signature
	 *  without having to pass the public key along with the signature.
	 *
	 *  @static
	 *
	 *  @param {bitArray|Hex-encoded String} hash
	 *  @param {sjcl.ecc.ecdsa.secretKey|Any format accepted by Seed.from_json}
	 *          secret_key
	 *  @param {RippleAddress} [The first key] account Field to specify the
	 *          signing account. If this is omitted the first account produced by
	 *          the secret generator will be used.
	 *  @returns {Base64-encoded String} signature
	 */
	Message.signHash = function (_hash, secret_key_, account) {

	  var hash = typeof _hash === 'string' && /^[0-9a-fA-F]+$/.test(_hash) ? sjcl.codec.hex.toBits(_hash) : _hash;

	  if (typeof hash !== 'object' || typeof hash[0] !== 'number' || hash.length <= 0) {
	    throw new Error('Hash must be a bitArray or hex-encoded string');
	  }

	  var secret_key = !(secret_key_ instanceof sjcl.ecc.ecdsa.secretKey) ? Seed.from_json(secret_key_).get_key(account)._secret : secret_key_;

	  var PARANOIA_256_BITS = 6; // sjcl constant for ensuring 256 bits of entropy
	  var signature_bits = secret_key.signWithRecoverablePublicKey(hash, PARANOIA_256_BITS);
	  var signature_base64 = sjcl.codec.base64.fromBits(signature_bits);

	  return signature_base64;
	};

	/**
	 *  Verify the signature on a given message.
	 *
	 *  Note that this function is asynchronous.
	 *  The ripple-lib remote is used to check that the public
	 *  key extracted from the signature corresponds to one that is currently
	 *  active for the given account.
	 *
	 *  @static
	 *
	 *  @param {String} data.message
	 *  @param {RippleAddress} data.account
	 *  @param {Base64-encoded String} data.signature
	 *  @param {ripple-lib Remote} remote
	 *  @param {Function} callback
	 *
	 *  @callback callback
	 *  @param {Error} error
	 *  @param {boolean} is_valid true if the signature is valid, false otherwise
	 */
	Message.verifyMessageSignature = function (data, remote, callback) {

	  if (typeof data.message === 'string') {
	    data.hash = Message.hashFunction(Message.MAGIC_BYTES + data.message);
	  } else {
	    return callback(new Error('Data object must contain message field to verify signature'));
	  }

	  return Message.verifyHashSignature(data, remote, callback);
	};

	/**
	 *  Verify the signature on a given hash.
	 *
	 *  Note that this function is asynchronous.
	 *  The ripple-lib remote is used to check that the public
	 *  key extracted from the signature corresponds to one that is currently
	 *  active for the given account.
	 *
	 *  @static
	 *
	 *  @param {bitArray|Hex-encoded String} data.hash
	 *  @param {RippleAddress} data.account
	 *  @param {Base64-encoded String} data.signature
	 *  @param {ripple-lib Remote} remote
	 *  @param {Function} callback
	 *
	 *  @callback callback
	 *  @param {Error} error
	 *  @param {boolean} is_valid true if the signature is valid, false otherwise
	 */
	Message.verifyHashSignature = function (data, remote, callback) {

	  if (typeof callback !== 'function') {
	    throw new Error('Must supply callback function');
	  }

	  var hash = REGEX_HEX.test(data.hash) ? sjcl.codec.hex.toBits(data.hash) : data.hash;

	  if (typeof hash !== 'object' || hash.length <= 0 || typeof hash[0] !== 'number') {
	    return callback(new Error('Hash must be a bitArray or hex-encoded string'));
	  }

	  var account = data.account || data.address;
	  if (!account || !UInt160.from_json(account).is_valid()) {
	    return callback(new Error('Account must be a valid ripple address'));
	  }

	  var signature = data.signature;
	  if (typeof signature !== 'string' || !REGEX_BASE64.test(signature)) {
	    return callback(new Error('Signature must be a Base64-encoded string'));
	  }

	  var signature_bits = sjcl.codec.base64.toBits(signature);

	  if (!(remote instanceof Remote) || remote.state !== 'online') {
	    return callback(new Error('Must supply connected Remote to verify signature'));
	  }

	  function recoverPublicKey(async_callback) {
	    var public_key = undefined;
	    try {
	      public_key = sjcl.ecc.ecdsa.publicKey.recoverFromSignature(hash, signature_bits);
	    } catch (err) {
	      return async_callback(err);
	    }

	    if (public_key) {
	      async_callback(null, public_key);
	    } else {
	      async_callback(new Error('Could not recover public key from signature'));
	    }
	  }

	  function checkPublicKeyIsValid(public_key, async_callback) {

	    // Get hex-encoded public key
	    var key_pair = new KeyPair();
	    key_pair._pubkey = public_key;
	    var public_key_hex = key_pair.to_hex_pub();

	    var account_class_instance = new Account(remote, account);
	    account_class_instance.publicKeyIsActive(public_key_hex, async_callback);
	  }

	  var steps = [recoverPublicKey, checkPublicKeyIsValid];

	  async.waterfall(steps, callback);
	};

	exports.Message = Message;

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	/*eslint no-multi-spaces:0,space-in-brackets:0,key-spacing:0,comma-spacing:0*/

	/**
	 * Data type map.
	 *
	 * Mapping of type ids to data types. The type id is specified by the high
	 *
	 * For reference, see rippled's definition:
	 * https://github.com/ripple/rippled/blob/develop/src/ripple/data/protocol
	 *                                                              /SField.cpp
	 */

	var _Object$keys = __webpack_require__(28)['default'];

	exports.types = [undefined,

	// Common
	'Int16', // 1
	'Int32', // 2
	'Int64', // 3
	'Hash128', // 4
	'Hash256', // 5
	'Amount', // 6
	'VL', // 7
	'Account', // 8

	// 9-13 reserved
	undefined, // 9
	undefined, // 10
	undefined, // 11
	undefined, // 12
	undefined, // 13

	'Object', // 14
	'Array', // 15

	// Uncommon
	'Int8', // 16
	'Hash160', // 17
	'PathSet', // 18
	'Vector256' // 19
	];

	/**
	 * Field type map.
	 *
	 * Mapping of field type id to field type name.
	 */

	var FIELDS_MAP = exports.fields = {
	  // Common types
	  1: { // Int16
	    1: 'LedgerEntryType',
	    2: 'TransactionType'
	  },
	  2: { // Int32
	    2: 'Flags',
	    3: 'SourceTag',
	    4: 'Sequence',
	    5: 'PreviousTxnLgrSeq',
	    6: 'LedgerSequence',
	    7: 'CloseTime',
	    8: 'ParentCloseTime',
	    9: 'SigningTime',
	    10: 'Expiration',
	    11: 'TransferRate',
	    12: 'WalletSize',
	    13: 'OwnerCount',
	    14: 'DestinationTag',
	    // Skip 15
	    16: 'HighQualityIn',
	    17: 'HighQualityOut',
	    18: 'LowQualityIn',
	    19: 'LowQualityOut',
	    20: 'QualityIn',
	    21: 'QualityOut',
	    22: 'StampEscrow',
	    23: 'BondAmount',
	    24: 'LoadFee',
	    25: 'OfferSequence',
	    26: 'FirstLedgerSequence',
	    27: 'LastLedgerSequence',
	    28: 'TransactionIndex',
	    29: 'OperationLimit',
	    30: 'ReferenceFeeUnits',
	    31: 'ReserveBase',
	    32: 'ReserveIncrement',
	    33: 'SetFlag',
	    34: 'ClearFlag'
	  },
	  3: { // Int64
	    1: 'IndexNext',
	    2: 'IndexPrevious',
	    3: 'BookNode',
	    4: 'OwnerNode',
	    5: 'BaseFee',
	    6: 'ExchangeRate',
	    7: 'LowNode',
	    8: 'HighNode'
	  },
	  4: { // Hash128
	    1: 'EmailHash'
	  },
	  5: { // Hash256
	    1: 'LedgerHash',
	    2: 'ParentHash',
	    3: 'TransactionHash',
	    4: 'AccountHash',
	    5: 'PreviousTxnID',
	    6: 'LedgerIndex',
	    7: 'WalletLocator',
	    8: 'RootIndex',
	    9: 'AccountTxnID',
	    16: 'BookDirectory',
	    17: 'InvoiceID',
	    18: 'Nickname',
	    19: 'Amendment',
	    20: 'TicketID'
	  },
	  6: { // Amount
	    1: 'Amount',
	    2: 'Balance',
	    3: 'LimitAmount',
	    4: 'TakerPays',
	    5: 'TakerGets',
	    6: 'LowLimit',
	    7: 'HighLimit',
	    8: 'Fee',
	    9: 'SendMax',
	    16: 'MinimumOffer',
	    17: 'RippleEscrow',
	    18: 'DeliveredAmount'
	  },
	  7: { // VL
	    1: 'PublicKey',
	    2: 'MessageKey',
	    3: 'SigningPubKey',
	    4: 'TxnSignature',
	    5: 'Generator',
	    6: 'Signature',
	    7: 'Domain',
	    8: 'FundCode',
	    9: 'RemoveCode',
	    10: 'ExpireCode',
	    11: 'CreateCode',
	    12: 'MemoType',
	    13: 'MemoData',
	    14: 'MemoFormat'
	  },
	  8: { // Account
	    1: 'Account',
	    2: 'Owner',
	    3: 'Destination',
	    4: 'Issuer',
	    7: 'Target',
	    8: 'RegularKey'
	  },
	  14: { // Object
	    1: undefined, // end of Object
	    2: 'TransactionMetaData',
	    3: 'CreatedNode',
	    4: 'DeletedNode',
	    5: 'ModifiedNode',
	    6: 'PreviousFields',
	    7: 'FinalFields',
	    8: 'NewFields',
	    9: 'TemplateEntry',
	    10: 'Memo'
	  },
	  15: { // Array
	    1: undefined, // end of Array
	    2: 'SigningAccounts',
	    3: 'TxnSignatures',
	    4: 'Signatures',
	    5: 'Template',
	    6: 'Necessary',
	    7: 'Sufficient',
	    8: 'AffectedNodes',
	    9: 'Memos'
	  },

	  // Uncommon types
	  16: { // Int8
	    1: 'CloseResolution',
	    2: 'TemplateEntryType',
	    3: 'TransactionResult'
	  },
	  17: { // Hash160
	    1: 'TakerPaysCurrency',
	    2: 'TakerPaysIssuer',
	    3: 'TakerGetsCurrency',
	    4: 'TakerGetsIssuer'
	  },
	  18: { // PathSet
	    1: 'Paths'
	  },
	  19: { // Vector256
	    1: 'Indexes',
	    2: 'Hashes',
	    3: 'Amendments'
	  }
	};

	var INVERSE_FIELDS_MAP = exports.fieldsInverseMap = {};

	_Object$keys(FIELDS_MAP).forEach(function (k1) {
	  _Object$keys(FIELDS_MAP[k1]).forEach(function (k2) {
	    INVERSE_FIELDS_MAP[FIELDS_MAP[k1][k2]] = [Number(k1), Number(k2)];
	  });
	});

	var REQUIRED = exports.REQUIRED = 0,
	    OPTIONAL = exports.OPTIONAL = 1,
	    DEFAULT = exports.DEFAULT = 2;

	var base = [['TransactionType', REQUIRED], ['Flags', OPTIONAL], ['SourceTag', OPTIONAL], ['LastLedgerSequence', OPTIONAL], ['Account', REQUIRED], ['Sequence', REQUIRED], ['Fee', REQUIRED], ['OperationLimit', OPTIONAL], ['SigningPubKey', REQUIRED], ['TxnSignature', OPTIONAL], ['AccountTxnID', OPTIONAL], ['Memos', OPTIONAL]];

	exports.tx = {
	  AccountSet: [3].concat(base, [['EmailHash', OPTIONAL], ['WalletLocator', OPTIONAL], ['WalletSize', OPTIONAL], ['MessageKey', OPTIONAL], ['Domain', OPTIONAL], ['TransferRate', OPTIONAL], ['SetFlag', OPTIONAL], ['ClearFlag', OPTIONAL]]),
	  TrustSet: [20].concat(base, [['LimitAmount', OPTIONAL], ['QualityIn', OPTIONAL], ['QualityOut', OPTIONAL]]),
	  OfferCreate: [7].concat(base, [['TakerPays', REQUIRED], ['TakerGets', REQUIRED], ['Expiration', OPTIONAL], ['OfferSequence', OPTIONAL]]),
	  OfferCancel: [8].concat(base, [['OfferSequence', REQUIRED]]),
	  SetRegularKey: [5].concat(base, [['RegularKey', OPTIONAL]]),
	  Payment: [0].concat(base, [['Destination', REQUIRED], ['Amount', REQUIRED], ['SendMax', OPTIONAL], ['Paths', DEFAULT], ['InvoiceID', OPTIONAL], ['DestinationTag', OPTIONAL]]),
	  Contract: [9].concat(base, [['Expiration', REQUIRED], ['BondAmount', REQUIRED], ['StampEscrow', REQUIRED], ['RippleEscrow', REQUIRED], ['CreateCode', OPTIONAL], ['FundCode', OPTIONAL], ['RemoveCode', OPTIONAL], ['ExpireCode', OPTIONAL]]),
	  RemoveContract: [10].concat(base, [['Target', REQUIRED]]),
	  EnableFeature: [100].concat(base, [['Feature', REQUIRED]]),
	  EnableAmendment: [100].concat(base, [['Amendment', REQUIRED]]),
	  SetFee: [101].concat(base, [['BaseFee', REQUIRED], ['ReferenceFeeUnits', REQUIRED], ['ReserveBase', REQUIRED], ['ReserveIncrement', REQUIRED]]),
	  TicketCreate: [10].concat(base, [['Target', OPTIONAL], ['Expiration', OPTIONAL]]),
	  TicketCancel: [11].concat(base, [['TicketID', REQUIRED]])
	};

	var sleBase = [['LedgerIndex', OPTIONAL], ['LedgerEntryType', REQUIRED], ['Flags', REQUIRED]];

	exports.ledger = {
	  AccountRoot: [97].concat(sleBase, [['Sequence', REQUIRED], ['PreviousTxnLgrSeq', REQUIRED], ['TransferRate', OPTIONAL], ['WalletSize', OPTIONAL], ['OwnerCount', REQUIRED], ['EmailHash', OPTIONAL], ['PreviousTxnID', REQUIRED], ['AccountTxnID', OPTIONAL], ['WalletLocator', OPTIONAL], ['Balance', REQUIRED], ['MessageKey', OPTIONAL], ['Domain', OPTIONAL], ['Account', REQUIRED], ['RegularKey', OPTIONAL]]),
	  Contract: [99].concat(sleBase, [['PreviousTxnLgrSeq', REQUIRED], ['Expiration', REQUIRED], ['BondAmount', REQUIRED], ['PreviousTxnID', REQUIRED], ['Balance', REQUIRED], ['FundCode', OPTIONAL], ['RemoveCode', OPTIONAL], ['ExpireCode', OPTIONAL], ['CreateCode', OPTIONAL], ['Account', REQUIRED], ['Owner', REQUIRED], ['Issuer', REQUIRED]]),
	  DirectoryNode: [100].concat(sleBase, [['IndexNext', OPTIONAL], ['IndexPrevious', OPTIONAL], ['ExchangeRate', OPTIONAL], ['RootIndex', REQUIRED], ['Owner', OPTIONAL], ['TakerPaysCurrency', OPTIONAL], ['TakerPaysIssuer', OPTIONAL], ['TakerGetsCurrency', OPTIONAL], ['TakerGetsIssuer', OPTIONAL], ['Indexes', REQUIRED]]),
	  EnabledFeatures: [102].concat(sleBase, [['Features', REQUIRED]]),
	  FeeSettings: [115].concat(sleBase, [['ReferenceFeeUnits', REQUIRED], ['ReserveBase', REQUIRED], ['ReserveIncrement', REQUIRED], ['BaseFee', REQUIRED], ['LedgerIndex', OPTIONAL]]),
	  GeneratorMap: [103].concat(sleBase, [['Generator', REQUIRED]]),
	  LedgerHashes: [104].concat(sleBase, [['LedgerEntryType', REQUIRED], ['Flags', REQUIRED], ['FirstLedgerSequence', OPTIONAL], ['LastLedgerSequence', OPTIONAL], ['LedgerIndex', OPTIONAL], ['Hashes', REQUIRED]]),
	  Nickname: [110].concat(sleBase, [['LedgerEntryType', REQUIRED], ['Flags', REQUIRED], ['LedgerIndex', OPTIONAL], ['MinimumOffer', OPTIONAL], ['Account', REQUIRED]]),
	  Offer: [111].concat(sleBase, [['LedgerEntryType', REQUIRED], ['Flags', REQUIRED], ['Sequence', REQUIRED], ['PreviousTxnLgrSeq', REQUIRED], ['Expiration', OPTIONAL], ['BookNode', REQUIRED], ['OwnerNode', REQUIRED], ['PreviousTxnID', REQUIRED], ['LedgerIndex', OPTIONAL], ['BookDirectory', REQUIRED], ['TakerPays', REQUIRED], ['TakerGets', REQUIRED], ['Account', REQUIRED]]),
	  RippleState: [114].concat(sleBase, [['LedgerEntryType', REQUIRED], ['Flags', REQUIRED], ['PreviousTxnLgrSeq', REQUIRED], ['HighQualityIn', OPTIONAL], ['HighQualityOut', OPTIONAL], ['LowQualityIn', OPTIONAL], ['LowQualityOut', OPTIONAL], ['LowNode', OPTIONAL], ['HighNode', OPTIONAL], ['PreviousTxnID', REQUIRED], ['LedgerIndex', OPTIONAL], ['Balance', REQUIRED], ['LowLimit', REQUIRED], ['HighLimit', REQUIRED]])
	};

	exports.metadata = [['TransactionIndex', REQUIRED], ['TransactionResult', REQUIRED], ['AffectedNodes', REQUIRED]];

	exports.ter = {
	  tesSUCCESS: 0,
	  tecCLAIM: 100,
	  tecPATH_PARTIAL: 101,
	  tecUNFUNDED_ADD: 102,
	  tecUNFUNDED_OFFER: 103,
	  tecUNFUNDED_PAYMENT: 104,
	  tecFAILED_PROCESSING: 105,
	  tecDIR_FULL: 121,
	  tecINSUF_RESERVE_LINE: 122,
	  tecINSUF_RESERVE_OFFER: 123,
	  tecNO_DST: 124,
	  tecNO_DST_INSUF_XRP: 125,
	  tecNO_LINE_INSUF_RESERVE: 126,
	  tecNO_LINE_REDUNDANT: 127,
	  tecPATH_DRY: 128,
	  tecUNFUNDED: 129, // Deprecated, old ambiguous unfunded.
	  tecMASTER_DISABLED: 130,
	  tecNO_REGULAR_KEY: 131,
	  tecOWNERS: 132,
	  tecNO_ISSUER: 133,
	  tecNO_AUTH: 134,
	  tecNO_LINE: 135,
	  tecINSUFF_FEE: 136,
	  tecFROZEN: 137,
	  tecNO_TARGET: 138,
	  tecNO_PERMISSION: 139,
	  tecNO_ENTRY: 140,
	  tecINSUFFICIENT_RESERVE: 141,
	  tecNEED_MASTER_KEY: 142,
	  tecDST_TAG_NEEDED: 143,
	  tecINTERNAL: 144
	};

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	function getMantissaDecimalString(bignum) {
	  var mantissa = bignum.toPrecision(16).replace(/\./, '') // remove decimal point
	  .replace(/e.*/, '') // remove scientific notation
	  .replace(/^0*/, ''); // remove leading zeroes
	  while (mantissa.length < 16) {
	    mantissa += '0'; // add trailing zeroes until length is 16
	  }
	  return mantissa;
	}

	function trace(comment, func) {
	  return function () {
	    console.log('%s: %s', trace, arguments.toString);
	    func(arguments);
	  };
	}

	function arraySet(count, value) {
	  var a = new Array(count);

	  for (var i = 0; i < count; i++) {
	    a[i] = value;
	  }

	  return a;
	}

	function hexToString(h) {
	  var a = [];
	  var i = 0;

	  if (h.length % 2) {
	    a.push(String.fromCharCode(parseInt(h.substring(0, 1), 16)));
	    i = 1;
	  }

	  for (; i < h.length; i += 2) {
	    a.push(String.fromCharCode(parseInt(h.substring(i, i + 2), 16)));
	  }

	  return a.join('');
	}

	function stringToHex(s) {
	  var result = '';
	  for (var i = 0; i < s.length; i++) {
	    var b = s.charCodeAt(i);
	    result += b < 16 ? '0' + b.toString(16) : b.toString(16);
	  }
	  return result;
	}

	function stringToArray(s) {
	  var a = new Array(s.length);

	  for (var i = 0; i < a.length; i += 1) {
	    a[i] = s.charCodeAt(i);
	  }

	  return a;
	}

	function hexToArray(h) {
	  return stringToArray(hexToString(h));
	}

	function arrayToHex(a) {
	  return a.map(function (byteValue) {
	    var hex = byteValue.toString(16);
	    return hex.length > 1 ? hex : '0' + hex;
	  }).join('');
	}

	function chunkString(str, n, leftAlign) {
	  var ret = [];
	  var i = 0;
	  var len = str.length;

	  if (leftAlign) {
	    i = str.length % n;
	    if (i) {
	      ret.push(str.slice(0, i));
	    }
	  }

	  for (; i < len; i += n) {
	    ret.push(str.slice(i, n + i));
	  }

	  return ret;
	}

	function assert(assertion, msg) {
	  if (!assertion) {
	    throw new Error('Assertion failed' + (msg ? ': ' + msg : '.'));
	  }
	}

	/**
	 * @param {Array} arr (values)
	 * @return {Array} unique values (for string representation of value) in `arr`
	 */
	function arrayUnique(arr) {
	  var u = {},
	      a = [];

	  for (var i = 0, l = arr.length; i < l; i++) {
	    var k = arr[i];
	    if (u[k]) {
	      continue;
	    }
	    a.push(k);
	    u[k] = true;
	  }

	  return a;
	}

	/**
	 * @param {Number} rpepoch (seconds since 1/1/2000 GMT)
	 * @return {Number} ms since unix epoch
	 *
	 */
	function toTimestamp(rpepoch) {
	  return (rpepoch + 0x386D4380) * 1000;
	}

	/**
	 * @param {Number|Date} timestamp (ms since unix epoch)
	 * @return {Number} seconds since ripple epoch ( 1/1/2000 GMT)
	 */
	function fromTimestamp(timestamp) {
	  var timestamp_ = timestamp instanceof Date ? timestamp.getTime() : timestamp;
	  return Math.round(timestamp_ / 1000) - 0x386D4380;
	}

	exports.time = {
	  fromRipple: toTimestamp,
	  toRipple: fromTimestamp
	};

	exports.trace = trace;
	exports.arraySet = arraySet;
	exports.hexToString = hexToString;
	exports.hexToArray = hexToArray;
	exports.stringToArray = stringToArray;
	exports.stringToHex = stringToHex;
	exports.arrayToHex = arrayToHex;
	exports.chunkString = chunkString;
	exports.assert = assert;
	exports.arrayUnique = arrayUnique;
	exports.toTimestamp = toTimestamp;
	exports.fromTimestamp = fromTimestamp;
	exports.getMantissaDecimalString = getMantissaDecimalString;

	exports.sjcl = __webpack_require__(52);
	__webpack_require__(37);

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _ = __webpack_require__(42);
	var util = __webpack_require__(41);
	var url = __webpack_require__(44);
	var LRU = __webpack_require__(50);
	var EventEmitter = __webpack_require__(40).EventEmitter;
	var RippleError = __webpack_require__(14).RippleError;
	var Amount = __webpack_require__(3).Amount;
	var RangeSet = __webpack_require__(21).RangeSet;
	var log = __webpack_require__(23).internal.sub('server');

	/**
	 *  @constructor Server
	 *
	 *  @param {Remote} Reference to a Remote object
	 *  @param {Object} Options
	 *    @param {String} host
	 *    @param {Number|String} port
	 *    @param [Boolean] securec
	 */

	function Server(remote, opts_) {
	  EventEmitter.call(this);

	  var self = this;
	  var opts = undefined;

	  if (typeof opts_ === 'string') {
	    var parsedUrl = url.parse(opts_);
	    opts = {
	      host: parsedUrl.hostname,
	      port: parsedUrl.port,
	      secure: parsedUrl.protocol === 'ws:' ? false : true
	    };
	  } else {
	    opts = opts_;
	  }

	  if (typeof opts !== 'object') {
	    throw new TypeError('Server configuration is not an Object');
	  }

	  if (!Server.DOMAIN_RE.test(opts.host)) {
	    throw new Error('Server host is malformed, use "host" and "port" server configuration');
	  }

	  // We want to allow integer strings as valid port numbers for backward
	  // compatibility
	  opts.port = Number(opts.port);
	  if (isNaN(opts.port)) {
	    throw new TypeError('Server port must be a number');
	  }

	  if (opts.port < 1 || opts.port > 65535) {
	    throw new TypeError('Server "port" must be an integer in range 1-65535');
	  }

	  if (typeof opts.secure !== 'boolean') {
	    opts.secure = true;
	  }

	  this._remote = remote;
	  this._opts = opts;
	  this._ws = undefined;

	  this._connected = false;
	  this._shouldConnect = false;
	  this._state = 'offline';
	  this._ledgerRanges = new RangeSet();
	  this._ledgerMap = new LRU({ max: 200 });

	  this._id = 0; // request ID
	  this._retry = 0;
	  this._requests = {};

	  this._load_base = 256;
	  this._load_factor = 256;

	  this._fee = 10;
	  this._fee_ref = 10;
	  this._fee_base = 10;
	  this._reserve_base = undefined;
	  this._reserve_inc = undefined;
	  this._fee_cushion = this._remote.fee_cushion;

	  this._lastLedgerIndex = NaN;
	  this._lastLedgerClose = NaN;

	  this._score = 0;
	  this._scoreWeights = {
	    ledgerclose: 5,
	    response: 1
	  };

	  this._pubkey_node = '';

	  this._url = this._opts.url = (this._opts.secure ? 'wss://' : 'ws://') + this._opts.host + ':' + this._opts.port;

	  this.on('message', function onMessage(message) {
	    self._handleMessage(message);
	  });

	  this.on('response_subscribe', function onSubscribe(message) {
	    self._handleResponseSubscribe(message);
	  });

	  function setActivityInterval() {
	    var interval = self._checkActivity.bind(self);
	    self._activityInterval = setInterval(interval, 1000);
	  }

	  this.on('disconnect', function onDisconnect() {
	    clearInterval(self._activityInterval);
	    self.once('ledger_closed', setActivityInterval);
	  });

	  this.once('ledger_closed', setActivityInterval);

	  this._remote.on('ledger_closed', function onRemoteLedgerClose(ledger) {
	    self._updateScore('ledgerclose', ledger);
	  });

	  this.on('response_ping', function onPingResponse(message, request) {
	    self._updateScore('response', request);
	  });

	  this.on('load_changed', function onLoadChange(load) {
	    self._updateScore('loadchange', load);
	  });

	  this.on('connect', function () {
	    self.requestServerID();
	  });
	}

	util.inherits(Server, EventEmitter);

	/* eslint-disable max-len */
	Server.DOMAIN_RE = /^(?=.{1,255}$)[0-9A-Za-z](?:(?:[0-9A-Za-z]|[-_]){0,61}[0-9A-Za-z])?(?:\.[0-9A-Za-z](?:(?:[0-9A-Za-z]|[-_]){0,61}[0-9A-Za-z])?)*\.?$/;
	/* eslint-enable max-len */

	Server.TLS_ERRORS = ['UNABLE_TO_GET_ISSUER_CERT', 'UNABLE_TO_GET_CRL', 'UNABLE_TO_DECRYPT_CERT_SIGNATURE', 'UNABLE_TO_DECRYPT_CRL_SIGNATURE', 'UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY', 'CERT_SIGNATURE_FAILURE', 'CRL_SIGNATURE_FAILURE', 'CERT_NOT_YET_VALID', 'CERT_HAS_EXPIRED', 'CRL_NOT_YET_VALID', 'CRL_HAS_EXPIRED', 'ERROR_IN_CERT_NOT_BEFORE_FIELD', 'ERROR_IN_CERT_NOT_AFTER_FIELD', 'ERROR_IN_CRL_LAST_UPDATE_FIELD', 'ERROR_IN_CRL_NEXT_UPDATE_FIELD', 'OUT_OF_MEM', 'DEPTH_ZERO_SELF_SIGNED_CERT', 'SELF_SIGNED_CERT_IN_CHAIN', 'UNABLE_TO_GET_ISSUER_CERT_LOCALLY', 'UNABLE_TO_VERIFY_LEAF_SIGNATURE', 'CERT_CHAIN_TOO_LONG', 'CERT_REVOKED', 'INVALID_CA', 'PATH_LENGTH_EXCEEDED', 'INVALID_PURPOSE', 'CERT_UNTRUSTED', 'CERT_REJECTED'];

	/**
	 * Server states that we will treat as the server being online.
	 *
	 * Our requirements are that the server can process transactions and notify
	 * us of changes.
	 */

	Server.onlineStates = ['syncing', 'tracking', 'proposing', 'validating', 'full'];

	/**
	 * This is the final interface between client code and a socket connection to a
	 * `rippled` server. As such, this is a decent hook point to allow a WebSocket
	 * interface conforming object to be used as a basis to mock rippled. This
	 * avoids the need to bind a websocket server to a port and allows a more
	 * synchronous style of code to represent a client <-> server message sequence.
	 * We can also use this to log a message sequence to a buffer.
	 *
	 * @api private
	 */

	Server.websocketConstructor = function () {
	  // We require this late, because websocket shims may be loaded after
	  // ripple-lib in the browser
	  return __webpack_require__(34);
	};

	/**
	 * Set server state
	 *
	 * @param {String} state
	 * @api private
	 */

	Server.prototype._setState = function (state) {
	  if (state !== this._state) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'set_state:', state);
	    }

	    this._state = state;
	    this.emit('state', state);

	    switch (state) {
	      case 'online':
	        this._connected = true;
	        this._retry = 0;
	        this.emit('connect');
	        break;
	      case 'offline':
	        this._connected = false;
	        this.emit('disconnect');
	        break;
	    }
	  }
	};

	/**
	 * Check that server is still active.
	 *
	 * Server activity is determined by ledger_closed events.
	 * Maximum delay to receive a ledger_closed event is 20s.
	 *
	 * If server is inactive, reconnect
	 *
	 * @api private
	 */

	Server.prototype._checkActivity = function () {
	  if (!this.isConnected()) {
	    return;
	  }

	  if (isNaN(this._lastLedgerClose)) {
	    return;
	  }

	  var delta = Date.now() - this._lastLedgerClose;

	  if (delta > 1000 * 25) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'reconnect: activity delta:', delta);
	    }
	    this.reconnect();
	  }
	};

	/**
	 * If server is not up-to-date, request server_info for getting pubkey_node
	 * & hostid information. Otherwise this information is available on the
	 * initial server subscribe response
	 */

	Server.prototype.requestServerID = function () {
	  var self = this;

	  if (this._pubkey_node) {
	    return;
	  }

	  this.on('response_server_info', function setServerID(message) {
	    try {
	      self._pubkey_node = message.info.pubkey_node;
	    } catch (e) {
	      log.warn('Failed to get server pubkey_node', message);
	    }
	  });

	  var serverInfoRequest = this._remote.requestServerInfo();
	  serverInfoRequest.on('error', function () {});
	  this._request(serverInfoRequest);
	};

	/**
	 * Server maintains a score for request prioritization.
	 *
	 * The score is determined by various data including
	 * this server's lag to receive ledger_closed events,
	 * ping response time, and load(fee) change
	 *
	 * @param {String} type
	 * @param {Object} data
	 * @api private
	 */

	Server.prototype._updateScore = function (type, data) {
	  if (!this.isConnected()) {
	    return;
	  }

	  var weight = this._scoreWeights[type] || 1;
	  var delta = undefined;

	  switch (type) {
	    case 'ledgerclose':
	      // Ledger lag
	      delta = data.ledger_index - this._lastLedgerIndex;
	      if (delta > 0) {
	        this._score += weight * delta;
	      }
	      break;
	    case 'response':
	      // Ping lag
	      // Servers are not pinged by default
	      delta = Math.floor((Date.now() - data.time) / 200);
	      this._score += weight * delta;
	      break;
	    case 'loadchange':
	      // Load/fee change
	      this._fee = Number(this._computeFee(10));
	      break;
	  }

	  if (this._score > 1e3) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'reconnect: score:', this._score);
	    }
	    this.reconnect();
	  }
	};

	/**
	 * Get the server's remote address
	 *
	 * Incompatible with ripple-lib client build
	 */

	Server.prototype.getRemoteAddress = Server.prototype._remoteAddress = function () {
	  try {
	    return this._ws._socket.remoteAddress;
	  } catch (e) {
	    log.warn('Cannot get remote address. Does not work in browser');
	  }
	};

	/**
	 * Get the server's hostid
	 */

	Server.prototype.getHostID = Server.prototype.getServerID = function () {
	  return this._url + ' (' + (this._pubkey_node ? this._pubkey_node : '') + ')';
	};

	/**
	 * Disconnect from rippled WebSocket server
	 *
	 * @api public
	 */

	Server.prototype.disconnect = function () {
	  var self = this;

	  if (!this.isConnected()) {
	    this.once('socket_open', function () {
	      self.disconnect();
	    });
	    return;
	  }

	  // these need to be reset so that updateScore
	  // and checkActivity do not trigger reconnect
	  this._lastLedgerIndex = NaN;
	  this._lastLedgerClose = NaN;
	  this._score = 0;
	  this._shouldConnect = false;
	  this._ledgerRanges.reset();
	  this._ledgerMap.reset();
	  this._setState('offline');

	  if (this._ws) {
	    this._ws.close();
	  }
	};

	/**
	 * Reconnect to rippled WebSocket server
	 *
	 * @api public
	 */

	Server.prototype.reconnect = function () {
	  var self = this;

	  function reconnect() {
	    self._shouldConnect = true;
	    self._retry = 0;
	    self.connect();
	  }

	  if (this._ws && this._shouldConnect) {
	    if (this.isConnected()) {
	      this.once('disconnect', reconnect);
	      this.disconnect();
	    } else {
	      reconnect();
	    }
	  }
	};

	/**
	 * Connect to rippled WebSocket server and subscribe to events that are
	 * internally requisite. Automatically retry connections with a gradual
	 * back-off
	 *
	 * @api public
	 */

	Server.prototype.connect = function () {
	  var self = this;

	  var WebSocket = Server.websocketConstructor();

	  if (!WebSocket) {
	    throw new Error('No websocket support detected!');
	  }

	  // We don't connect if we believe we're already connected. This means we have
	  // recently received a message from the server and the WebSocket has not
	  // reported any issues either. If we do fail to ping or the connection drops,
	  // we will automatically reconnect.
	  if (this.isConnected()) {
	    return;
	  }

	  // Ensure any existing socket is given the command to close first.
	  if (this._ws) {
	    this._ws.close();
	  }

	  if (this._remote.trace) {
	    log.info(this.getServerID(), 'connect');
	  }

	  var ws = this._ws = new WebSocket(this._opts.url);

	  this._shouldConnect = true;

	  self.emit('connecting');

	  ws.onmessage = function onMessage(msg) {
	    var message = msg.data;

	    try {
	      message = JSON.parse(message);
	    } catch (e) {
	      var error = new RippleError('unexpected', 'Unexpected response from server: ' + JSON.stringify(message));

	      self.emit('unexpected', message);
	      log.error(error);
	      return;
	    }

	    self.emit('message', message);
	  };

	  ws.onopen = function onOpen() {
	    if (ws === self._ws) {
	      self.emit('socket_open');
	      // Subscribe to events
	      self._request(self._remote._serverPrepareSubscribe(self));
	    }
	  };

	  ws.onerror = function onError(e) {
	    if (ws === self._ws) {
	      self.emit('socket_error');

	      if (self._remote.trace) {
	        log.info(self.getServerID(), 'onerror:', e.data || e);
	      }

	      if (Server.TLS_ERRORS.indexOf(e.message) !== -1) {
	        // Unrecoverable
	        throw e;
	      }

	      // Most connection errors for WebSockets are conveyed as 'close'
	      // events with
	      // code 1006. This is done for security purposes and therefore unlikely to
	      // ever change.

	      // This means that this handler is hardly ever called in practice.
	      // If it is,
	      // it probably means the server's WebSocket implementation is corrupt, or
	      // the connection is somehow producing corrupt data.

	      // Most WebSocket applications simply log and ignore this error. Once we
	      // support for multiple servers, we may consider doing something like
	      // lowering this server's quality score.

	      // However, in Node.js this event may be triggered instead of the close
	      // event, so we need to handle it.
	      self._handleClose();
	    }
	  };

	  ws.onclose = function onClose() {
	    if (ws === self._ws) {
	      if (self._remote.trace) {
	        log.info(self.getServerID(), 'onclose:', ws.readyState);
	      }
	      self._handleClose();
	    }
	  };
	};

	/**
	 * Retry connection to rippled server
	 *
	 * @api private
	 */

	Server.prototype._retryConnect = function () {
	  var self = this;

	  this._retry += 1;

	  var retryTimeout = this._retry < 40 ?
	  // First, for 2 seconds: 20 times per second
	  1000 / 20 : this._retry < 40 + 60 ?
	  // Then, for 1 minute: once per second
	  1000 : this._retry < 40 + 60 + 60 ?
	  // Then, for 10 minutes: once every 10 seconds
	  10 * 1000 :
	  // Then: once every 30 seconds
	  30 * 1000;

	  function connectionRetry() {
	    if (self._shouldConnect) {
	      if (self._remote.trace) {
	        log.info(self.getServerID(), 'retry', self._retry);
	      }
	      self.connect();
	    }
	  }

	  this._retryTimer = setTimeout(connectionRetry, retryTimeout);
	};

	/**
	 * Handle connection closes
	 *
	 * @api private
	 */

	Server.prototype._handleClose = function () {
	  var ws = this._ws;

	  // Prevent additional events from this socket
	  ws.onopen = ws.onerror = ws.onclose = ws.onmessage = _.noop;

	  this.emit('socket_close');
	  this._setState('offline');

	  if (this._shouldConnect) {
	    this._retryConnect();
	  }
	};

	/**
	 * Handle incoming messages from rippled WebSocket server
	 *
	 * @param {JSON-parseable} message
	 * @api private
	 */

	Server.prototype._handleMessage = function (message) {
	  if (!Server.isValidMessage(message)) {
	    this.emit('unexpected', message);
	    return;
	  }

	  switch (message.type) {
	    case 'ledgerClosed':
	      this._handleLedgerClosed(message);
	      break;
	    case 'serverStatus':
	      this._handleServerStatus(message);
	      break;
	    case 'response':
	      this._handleResponse(message);
	      break;
	    case 'path_find':
	      this._handlePathFind(message);
	      break;
	  }
	};

	Server.prototype._handleLedgerClosed = function (message) {
	  this._lastLedgerIndex = message.ledger_index;
	  this._lastLedgerClose = Date.now();
	  this._ledgerRanges.add(message.ledger_index);
	  this._ledgerMap.set(message.ledger_hash, message.ledger_index);
	  this.emit('ledger_closed', message);
	};

	Server.prototype._handleServerStatus = function (message) {
	  // This message is only received when online.
	  // As we are connected, it is the definitive final state.
	  var isOnline = ~Server.onlineStates.indexOf(message.server_status);

	  this._setState(isOnline ? 'online' : 'offline');

	  if (!Server.isLoadStatus(message)) {
	    return;
	  }

	  this.emit('load', message, this);
	  this._remote.emit('load', message, this);

	  var loadChanged = message.load_base !== this._load_base || message.load_factor !== this._load_factor;

	  if (loadChanged) {
	    this._load_base = message.load_base;
	    this._load_factor = message.load_factor;
	    this.emit('load_changed', message, this);
	    this._remote.emit('load_changed', message, this);
	  }
	};

	Server.prototype._handleResponse = function (message) {
	  var _this = this;

	  // A response to a request.
	  var request = this._requests[message.id];

	  delete this._requests[message.id];

	  if (!request) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'UNEXPECTED:', message);
	    }
	    return;
	  }

	  if (message.status === 'success') {
	    (function () {
	      if (_this._remote.trace) {
	        log.info(_this.getServerID(), 'response:', message);
	      }

	      var command = request.message.command;
	      var result = message.result;
	      var responseEvent = 'response_' + command;

	      request.emit('success', result);

	      [_this, _this._remote].forEach(function (emitter) {
	        emitter.emit(responseEvent, result, request, message);
	      });
	    })();
	  } else if (message.error) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'error:', message);
	    }

	    request.emit('error', {
	      error: 'remoteError',
	      error_message: 'Remote reported an error.',
	      remote: message
	    });
	  }
	};

	Server.prototype._handlePathFind = function (message) {
	  if (this._remote.trace) {
	    log.info(this.getServerID(), 'path_find:', message);
	  }
	};

	/**
	 * Handle initial subscription response message. The server is considered
	 * `connected` after it has received a response to initial subscription to
	 * ledger and server streams
	 *
	 * @param {Object} message
	 * @api private
	 */

	Server.prototype._handleResponseSubscribe = function (message) {
	  if (this.isConnected()) {
	    // This function only concerns initializing the server's internal
	    // state after a connection
	    return;
	  }

	  if (!this._remote.allow_partial_history && !Server.hasFullLedgerHistory(message)) {
	    // Server has partial history and Remote has been configured to disallow
	    // servers with incomplete history
	    this.reconnect();
	    return;
	  }

	  if (message.pubkey_node) {
	    // pubkey_node is used to identify the server
	    this._pubkey_node = message.pubkey_node;
	  }

	  if (Server.isLoadStatus(message)) {
	    this._load_base = message.load_base || 256;
	    this._load_factor = message.load_factor || 256;
	    this._fee_ref = message.fee_ref || 10;
	    this._fee_base = message.fee_base || 10;
	    this._reserve_base = message.reserve_base;
	    this._reserve_inc = message.reserve_inc;
	  }

	  if (message.validated_ledgers) {
	    // Add validated ledgers to ledger range set
	    this._ledgerRanges.add(message.validated_ledgers);
	  }

	  if (~Server.onlineStates.indexOf(message.server_status)) {
	    this._setState('online');
	  }
	};

	/**
	 * Check that server message indicates that server has complete ledger history
	 *
	 * @param {Object} message
	 * @return {Boolean}
	 */

	Server.hasFullLedgerHistory = function (message) {
	  return typeof message === 'object' && message.server_status === 'full' && typeof message.validated_ledgers === 'string' && message.validated_ledgers.split('-').length === 2;
	};

	/**
	 * Check that received message from rippled is valid
	 *
	 * @param {Object} message
	 * @return {Boolean}
	 */

	Server.isValidMessage = function (message) {
	  return typeof message === 'object' && typeof message.type === 'string';
	};

	/**
	 * Check that received serverStatus message contains load status information
	 *
	 * @param {Object} message
	 * @return {Boolean}
	 */

	Server.isLoadStatus = function (message) {
	  return typeof message === 'object' && typeof message.load_base === 'number' && typeof message.load_factor === 'number';
	};

	/**
	 * Send JSON message to rippled WebSocket server
	 *
	 * @param {JSON-Stringifiable} message
	 * @api private
	 */

	Server.prototype._sendMessage = function (message) {
	  if (this._ws) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'request:', message);
	    }
	    this._ws.send(JSON.stringify(message));
	  }
	};

	/**
	 * Submit a Request object
	 *
	 * Requests are indexed by message ID, which is repeated in the response from
	 * rippled WebSocket server
	 *
	 * @param {Request} request
	 * @api private
	 */

	Server.prototype._request = function (request) {
	  var self = this;

	  // Only bother if we are still connected.
	  if (!this._ws) {
	    if (this._remote.trace) {
	      log.info(this.getServerID(), 'request: DROPPING:', request.message);
	    }
	    return;
	  }

	  request.server = this;
	  request.message.id = this._id;
	  request.time = Date.now();

	  this._requests[request.message.id] = request;

	  // Advance message ID
	  this._id++;

	  function sendRequest() {
	    self._sendMessage(request.message);
	  }

	  var isOpen = this._ws.readyState === 1;
	  var isSubscribeRequest = request && request.message.command === 'subscribe';

	  if (this.isConnected() || isOpen && isSubscribeRequest) {
	    sendRequest();
	  } else {
	    this.once('connect', sendRequest);
	  }
	};

	/**
	 * Get server connected status
	 *
	 * @return boolean
	 */

	Server.prototype.isConnected = Server.prototype._isConnected = function () {
	  return this._connected;
	};

	/**
	 * Calculate transaction fee
	 *
	 * @param {Transaction|Number} Fee units for a provided transaction
	 * @return {String} Final fee in XRP for specified number of fee units
	 * @api private
	 */

	Server.prototype._computeFee = function (feeUnits) {
	  if (isNaN(feeUnits)) {
	    throw new Error('Invalid argument');
	  }

	  return this._feeTx(Number(feeUnits)).to_json();
	};

	/**
	 * Calculate a transaction fee for a number of tx fee units.
	 *
	 * This takes into account the last known network and local load fees.
	 *
	 * @param {Number} Fee units for a provided transaction
	 * @return {Amount} Final fee in XRP for specified number of fee units.
	 */

	Server.prototype._feeTx = function (units) {
	  var fee_unit = this._feeTxUnit();
	  return Amount.from_json(String(Math.ceil(units * fee_unit)));
	};

	/**
	 * Get the current recommended transaction fee unit.
	 *
	 * Multiply this value with the number of fee units in order to calculate the
	 * recommended fee for the transaction you are trying to submit.
	 *
	 * @return {Number} Recommended amount for one fee unit as float.
	 */

	Server.prototype._feeTxUnit = function () {
	  var fee_unit = this._fee_base / this._fee_ref;

	  // Apply load fees
	  fee_unit *= this._load_factor / this._load_base;

	  // Apply fee cushion (a safety margin in case fees rise since
	  // we were last updated)
	  fee_unit *= this._fee_cushion;

	  return fee_unit;
	};

	/**
	 * Get the current recommended reserve base.
	 *
	 * Returns the base reserve with load fees and safety margin applied.
	 */

	Server.prototype._reserve = function (ownerCount) {
	  var reserve_base = Amount.from_json(String(this._reserve_base));
	  var reserve_inc = Amount.from_json(String(this._reserve_inc));
	  var owner_count = ownerCount || 0;

	  if (owner_count < 0) {
	    throw new Error('Owner count must not be negative.');
	  }

	  return reserve_base.add(reserve_inc.product_human(owner_count));
	};

	/**
	 * Check that server has seen closed ledger
	 *
	 * @param {string|number} ledger hash or index
	 * @return boolean
	 */

	Server.prototype.hasLedger = function (ledger) {
	  var result = false;

	  if (typeof ledger === 'string' && /^[A-F0-9]{64}$/.test(ledger)) {
	    result = this._ledgerMap.has(ledger);
	  } else if (ledger !== null && !isNaN(ledger)) {
	    result = this._ledgerRanges.has(ledger);
	  }

	  return result;
	};

	/**
	 * Get ledger index of last seen validated ledger
	 *
	 * @return number
	 */

	Server.prototype.getLastLedger = Server.prototype.getLastLedgerIndex = function () {
	  return this._lastLedgerIndex;
	};

	exports.Server = Server;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint-disable valid-jsdoc */
	'use strict';
	var Transaction = __webpack_require__(5).Transaction;
	var SHAMap = __webpack_require__(35).SHAMap;
	var SHAMapTreeNode = __webpack_require__(35).SHAMapTreeNode;
	var SerializedObject = __webpack_require__(13).SerializedObject;
	var stypes = __webpack_require__(26);
	var UInt160 = __webpack_require__(9).UInt160;
	var Currency = __webpack_require__(6).Currency;

	function Ledger() {
	  this.ledger_json = {};
	}

	Ledger.from_json = function (v) {
	  var ledger = new Ledger();
	  ledger.parse_json(v);
	  return ledger;
	};

	Ledger.space = __webpack_require__(36);

	/**
	 * Generate the key for an AccountRoot entry.
	 *
	 * @param {String|UInt160} account Ripple Account
	 * @return {UInt256}
	 */
	Ledger.calcAccountRootEntryHash = Ledger.prototype.calcAccountRootEntryHash = function (account) {
	  account = UInt160.from_json(account);

	  var index = new SerializedObject();

	  index.append([0, Ledger.space.account.charCodeAt(0)]);
	  index.append(account.to_bytes());

	  return index.hash();
	};

	/**
	 * Generate the key for an Offer entry.
	 *
	 * @param {String|UInt160} account Ripple Account
	 * @param {Number} sequence Sequence number of the OfferCreate transaction
	 *   that instantiated this offer.
	 * @return {UInt256}
	 */
	Ledger.calcOfferEntryHash = Ledger.prototype.calcOfferEntryHash = function (account, sequence) {
	  account = UInt160.from_json(account);
	  sequence = parseInt(sequence, 10);

	  var index = new SerializedObject();

	  index.append([0, Ledger.space.offer.charCodeAt(0)]);
	  index.append(account.to_bytes());
	  stypes.Int32.serialize(index, sequence);

	  return index.hash();
	};

	/**
	 * Generate the key for a RippleState entry.
	 *
	 * The ordering of the two account parameters does not matter.
	 *
	 * @param {String|UInt160} account1 First Ripple Account
	 * @param {String|UInt160} account2 Second Ripple Account
	 * @param {String|Currency} currency The currency code
	 * @return {UInt256}
	 */
	Ledger.calcRippleStateEntryHash = Ledger.prototype.calcRippleStateEntryHash = function (account1, account2, currency) {
	  currency = Currency.from_json(currency);
	  account1 = UInt160.from_json(account1);
	  account2 = UInt160.from_json(account2);

	  if (!account1.is_valid()) {
	    throw new Error('Invalid first account');
	  }
	  if (!account2.is_valid()) {
	    throw new Error('Invalid second account');
	  }
	  if (!currency.is_valid()) {
	    throw new Error('Invalid currency');
	  }

	  // The lower ID has to come first
	  if (account1.to_bn().greaterEquals(account2.to_bn())) {
	    var tmp = account2;
	    account2 = account1;
	    account1 = tmp;
	  }

	  var index = new SerializedObject();

	  index.append([0, Ledger.space.rippleState.charCodeAt(0)]);
	  index.append(account1.to_bytes());
	  index.append(account2.to_bytes());
	  index.append(currency.to_bytes());

	  return index.hash();
	};

	Ledger.prototype.parse_json = function (v) {
	  this.ledger_json = v;
	};

	Ledger.prototype.calc_tx_hash = function () {
	  var tx_map = new SHAMap();

	  this.ledger_json.transactions.forEach(function (tx_json) {
	    var tx = Transaction.from_json(tx_json);
	    var meta = SerializedObject.from_json(tx_json.metaData);

	    var data = new SerializedObject();
	    stypes.VariableLength.serialize(data, tx.serialize().to_hex());
	    stypes.VariableLength.serialize(data, meta.to_hex());
	    tx_map.add_item(tx.hash(), data, SHAMapTreeNode.TYPE_TRANSACTION_MD);
	  });

	  return tx_map.hash();
	};

	/**
	* @param options .sanity_test {Boolean}
	* @return hash of shamap
	*
	*   If `true`, will serialize each accountState item to binary and then back to
	*   json before finally serializing for hashing. This is mostly to expose any
	*   issues with ripple-lib's binary <--> json codecs.
	*
	*/
	Ledger.prototype.calc_account_hash = function (options) {
	  var account_map = new SHAMap();
	  var erred;

	  this.ledger_json.accountState.forEach(function (le) {
	    var data = SerializedObject.from_json(le);

	    var json;
	    if (options && options.sanity_test) {
	      try {
	        json = data.to_json();
	        data = SerializedObject.from_json(json);
	      } catch (e) {
	        console.log('account state item: ', le);
	        console.log('to_json() ', json);
	        console.log('exception: ', e);
	        erred = true;
	      }
	    }

	    account_map.add_item(le.index, data, SHAMapTreeNode.TYPE_ACCOUNT_STATE);
	  });

	  if (erred) {
	    throw new Error('There were errors with sanity_test'); // all logged above
	  }

	  return account_map.hash();
	};

	exports.Ledger = Ledger;

/***/ },
/* 20 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var lodash = __webpack_require__(42);
	var LRU = __webpack_require__(50);
	var Transaction = __webpack_require__(5).Transaction;

	/**
	 * Manager for pending transactions
	 */

	function TransactionQueue() {
	  this._queue = [];
	  this._idCache = new LRU({ max: 200 });
	  this._sequenceCache = new LRU({ max: 200 });
	}

	/**
	 * Store received (validated) sequence
	 *
	 * @param {Number} sequence
	 */

	TransactionQueue.prototype.addReceivedSequence = function (sequence) {
	  this._sequenceCache.set(String(sequence), true);
	};

	/**
	 * Check that sequence number has been consumed by a validated
	 * transaction
	 *
	 * @param {Number} sequence
	 * @return {Boolean}
	 */

	TransactionQueue.prototype.hasSequence = function (sequence) {
	  return this._sequenceCache.has(String(sequence));
	};

	/**
	 * Store received (validated) ID transaction
	 *
	 * @param {String} transaction id
	 * @param {Transaction} transaction
	 */

	TransactionQueue.prototype.addReceivedId = function (id, transaction) {
	  this._idCache.set(id, transaction);
	};

	/**
	 * Get received (validated) transaction by ID
	 *
	 * @param {String} transaction id
	 * @return {Object}
	 */

	TransactionQueue.prototype.getReceived = function (id) {
	  return this._idCache.get(id);
	};

	/**
	 * Get a submitted transaction by ID. Transactions
	 * may have multiple associated IDs.
	 *
	 * @param {String} transaction id
	 * @return {Transaction}
	 */

	TransactionQueue.prototype.getSubmission = function (id) {
	  return lodash.find(this._queue, function (tx) {
	    return lodash.contains(tx.submittedIDs, id);
	  });
	};

	/**
	 * Get earliest ledger in the pending queue
	 *
	 * @return {Number} ledger
	 */

	TransactionQueue.prototype.getMinLedger = function () {
	  if (this.length() < 1) {
	    return -1;
	  }

	  var result = Infinity;

	  for (var i = 0; i < this.length(); i++) {
	    if (this._queue[i].initialSubmitIndex < result) {
	      result = this._queue[i].initialSubmitIndex;
	    }
	  }

	  if (!isFinite(result)) {
	    result = -1;
	  }

	  return result;
	};

	/**
	 * Remove a transaction from the queue
	 *
	 * @param {String|Transaction} transaction or id
	 */

	TransactionQueue.prototype.remove = function (tx) {
	  // ND: We are just removing the Transaction by identity
	  var i = this._queue.length;

	  if (typeof tx === 'string') {
	    tx = this.getSubmission(tx);
	  }

	  if (!(tx instanceof Transaction)) {
	    return;
	  }

	  while (i--) {
	    if (this._queue[i] === tx) {
	      this._queue.splice(i, 1);
	      break;
	    }
	  }
	};

	/**
	 * Add a transaction to pending queue
	 *
	 * @param {Transaction} transaction
	 */

	TransactionQueue.prototype.push = function (tx) {
	  this._queue.push(tx);
	};

	/**
	 * Iterate over pending transactions
	 *
	 * @param {Function} iterator
	 */

	TransactionQueue.prototype.forEach = function (fn) {
	  this._queue.forEach(fn);
	};

	/**
	 * @return {Number} length of pending queue
	 */

	TransactionQueue.prototype.length = TransactionQueue.prototype.getLength = function () {
	  return this._queue.length;
	};

	/**
	 * @return {Array} pending queue
	 */

	TransactionQueue.prototype.getQueue = function () {
	  return this._queue;
	};

	exports.TransactionQueue = TransactionQueue;

/***/ },
/* 21 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var assert = __webpack_require__(38);
	var lodash = __webpack_require__(42);

	function RangeSet() {
	  this._ranges = [];
	};

	/**
	 * Add a ledger range
	 *
	 * @param {Number|String} range string (n-n2,n3-n4)
	 */

	RangeSet.prototype.add = function (range) {
	  assert(typeof range !== 'number' || !isNaN(range), 'Ledger range malformed');

	  range = String(range).split(',');

	  if (range.length > 1) {
	    return range.forEach(this.add, this);
	  }

	  range = range[0].split('-').map(Number);

	  var lRange = {
	    start: range[0],
	    end: range[range.length === 1 ? 0 : 1]
	  };

	  // Comparisons on NaN should be falsy
	  assert(lRange.start <= lRange.end, 'Ledger range malformed');

	  var insertionPoint = lodash.sortedIndex(this._ranges, lRange, function (r) {
	    return r.start;
	  });

	  this._ranges.splice(insertionPoint, 0, lRange);
	};

	/*
	 * Check presence of ledger in range
	 *
	 * @param {Number|String} ledger
	 * @return Boolean
	 */

	RangeSet.prototype.has = RangeSet.prototype.contains = function (ledger) {
	  assert(ledger != null && !isNaN(ledger), 'Ledger must be a number');

	  ledger = Number(ledger);

	  return this._ranges.some(function (r) {
	    return ledger >= r.start && ledger <= r.end;
	  });
	};

	/**
	 * Reset ledger ranges
	 */

	RangeSet.prototype.reset = function () {
	  this._ranges = [];
	};

	exports.RangeSet = RangeSet;

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	function normalize(digitArray) {
	  while (digitArray[0] === 0) {
	    digitArray.shift();
	  }
	  return digitArray;
	}

	function divmod(digitArray, base, divisor) {
	  var remainder = 0;
	  var quotient = [];
	  for (var j = 0; j < digitArray.length; j++) {
	    var temp = remainder * base + parseInt(digitArray[j], 10);
	    quotient.push(Math.floor(temp / divisor));
	    remainder = temp % divisor;
	  }
	  return { quotient: normalize(quotient), remainder: remainder };
	}

	function convertBase(digitArray, fromBase, toBase) {
	  var result = [];
	  var dividend = digitArray;
	  while (dividend.length > 0) {
	    var qr = divmod(dividend, fromBase, toBase);
	    result.unshift(qr.remainder);
	    dividend = qr.quotient;
	  }
	  return normalize(result);
	}

	module.exports = convertBase;

/***/ },
/* 23 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var assert = __webpack_require__(38);

	/**
	 * Logging functionality for ripple-lib and any applications built on it.
	 *
	 * @param {String} namespace logging prefix
	 * @return {Void} this function does not return...
	 */
	function Log(namespace) {
	  if (!namespace) {
	    this._namespace = [];
	  } else if (Array.isArray(namespace)) {
	    this._namespace = namespace;
	  } else {
	    this._namespace = [String(namespace)];
	  }

	  this._prefix = this._namespace.concat(['']).join(': ');
	}

	/**
	 * Create a sub-logger.
	 *
	 * You can have a hierarchy of loggers.
	 *
	 * @example
	 *
	 *   var log = require('ripple').log.sub('server');
	 *
	 *   log.info('connection successful');
	 *   // prints: 'server: connection successful'
	 *
	 * @param {String} namespace logging prefix
	 * @return {Log} sub logger
	 */
	Log.prototype.sub = function (namespace) {
	  var subNamespace = this._namespace.slice();

	  if (namespace && typeof namespace === 'string') {
	    subNamespace.push(namespace);
	  }

	  var subLogger = new Log(subNamespace);
	  subLogger._setParent(this);
	  return subLogger;
	};

	Log.prototype._setParent = function (parentLogger) {
	  this._parent = parentLogger;
	};

	Log.makeLevel = function (level) {
	  return function () {
	    var args = Array.prototype.slice.apply(arguments);
	    args[0] = this._prefix + args[0];
	    Log.engine.logObject.apply(Log, [level].concat(args[0], [args.slice(2)]));
	  };
	};

	Log.prototype.debug = Log.makeLevel(1);
	Log.prototype.info = Log.makeLevel(2);
	Log.prototype.warn = Log.makeLevel(3);
	Log.prototype.error = Log.makeLevel(4);

	/**
	 * @param {String} message
	 * @param {Array} details
	 * @return {Array} prepared log info
	 */

	function getLogInfo(message, args) {
	  var stack = new Error().stack;

	  return [
	  // Timestamp
	  '[' + new Date().toISOString() + ']', message, '--',
	  // Location
	  typeof stack === 'string' ? stack.split('\n')[4].replace(/^\s+/, '') : '', '\n'].concat(args);
	}

	/**
	 * @param {Number} log level
	 * @param {Array} log info
	 */

	function logMessage(logLevel, args) {
	  switch (logLevel) {
	    case 1:
	    case 2:
	      console.log.apply(console, args);
	      break;
	    case 3:
	      console.warn.apply(console, args);
	      break;
	    case 4:
	      console.error.apply(console, args);
	      break;
	  }
	}

	var engines = {};

	/**
	 * Basic logging connector.
	 *
	 * This engine has no formatting and works with the most basic of 'console.log'
	 * implementations. This is the logging engine used in Node.js.
	 */
	engines.basic = {
	  logObject: function logObject(level, message, args_) {
	    var args = args_.map(function (arg) {
	      return JSON.stringify(arg, null, 2);
	    });

	    logMessage(level, getLogInfo(message, args));
	  }
	};

	/**
	 * Log engine for browser consoles.
	 *
	 * Browsers tend to have better consoles that support nicely formatted
	 * JavaScript objects. This connector passes objects through to the logging
	 * function without any stringification.
	 */
	engines.interactive = {
	  logObject: function logObject(level, message, args_) {
	    var args = args_.map(function (arg) {
	      return /MSIE/.test(navigator.userAgent) ? JSON.stringify(arg, null, 2) : arg;
	    });

	    logMessage(level, getLogInfo(message, args));
	  }
	};

	/**
	 * Null logging connector.
	 *
	 * This engine simply swallows all messages. Used when console.log is not
	 * available.
	 */
	engines.none = {
	  logObject: function logObject() {}
	};

	Log.getEngine = Log.prototype.getEngine = function () {
	  return Log.engine;
	};

	Log.setEngine = Log.prototype.setEngine = function (engine) {
	  assert.strictEqual(typeof engine, 'object');
	  assert.strictEqual(typeof engine.logObject, 'function');
	  Log.engine = engine;
	};

	if (typeof window !== 'undefined' && typeof console !== 'undefined') {
	  Log.setEngine(engines.interactive);
	} else if (typeof console !== 'undefined' && console.log) {
	  Log.setEngine(engines.basic);
	} else {
	  Log.setEngine(engines.none);
	}

	/**
	 * Provide a root logger as our main export.
	 *
	 * This means you can use the logger easily on the fly:
	 *     ripple.log.debug('My object is', myObj);
	 */
	module.exports = new Log();

	/**
	 * This is the logger for ripple-lib internally.
	 */
	module.exports.internal = module.exports.sub();

	/**
	 * Expose the class as well.
	 */
	module.exports.Log = Log;

	/**
	 * Expose log engines
	 */
	module.exports.engines = engines;

/***/ },
/* 24 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var EventEmitter = __webpack_require__(40).EventEmitter;
	var util = __webpack_require__(41);
	var Amount = __webpack_require__(3).Amount;
	var extend = __webpack_require__(39);

	/**
	 * Represents a persistent path finding request.
	 *
	 * Only one path find request is allowed per connection, so when another path
	 * find request is triggered it will supercede the existing one, making it emit
	 * the 'end' and 'superceded' events.
	 */
	function PathFind(remote, src_account, dst_account, dst_amount, src_currencies) {
	  EventEmitter.call(this);

	  this.remote = remote;

	  this.src_account = src_account;
	  this.dst_account = dst_account;
	  this.dst_amount = dst_amount;
	  this.src_currencies = src_currencies;
	};

	util.inherits(PathFind, EventEmitter);

	/**
	 * Submits a path_find_create request to the network.
	 *
	 * This starts a path find request, superceding all previous path finds.
	 *
	 * This will be called automatically by Remote when this object is instantiated,
	 * so you should only have to call it if the path find was closed or superceded
	 * and you wish to restart it.
	 */
	PathFind.prototype.create = function () {
	  var self = this;

	  var req = this.remote.request_path_find_create(this.src_account, this.dst_account, this.dst_amount, this.src_currencies);

	  req.once('error', function (err) {
	    self.emit('error', err);
	  });
	  req.once('success', function (msg) {
	    self.notify_update(msg);
	  });

	  // XXX We should add ourselves to prepare_subscribe or a similar mechanism so
	  // that we can resubscribe after a reconnection.

	  req.broadcast().request();
	};

	PathFind.prototype.close = function () {
	  this.remote.request_path_find_close().broadcast().request();
	  this.emit('end');
	  this.emit('close');
	};

	PathFind.prototype.notify_update = function (message) {
	  var src_account = message.source_account;
	  var dst_account = message.destination_account;
	  var dst_amount = Amount.from_json(message.destination_amount);

	  // Only pass the event along if this path find response matches what we were
	  // looking for.
	  if (this.src_account === src_account && this.dst_account === dst_account && this.dst_amount.equals(dst_amount)) {
	    this.emit('update', message);
	  }
	};

	PathFind.prototype.notify_superceded = function () {
	  // XXX If we're set to re-subscribe whenever we connect to a new server, then
	  // we should cancel that behavior here. See PathFind#create.

	  this.emit('end');
	  this.emit('superceded');
	};

	exports.PathFind = PathFind;

/***/ },
/* 25 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _Object$keys = __webpack_require__(28)['default'];

	var util = __webpack_require__(41);
	var assert = __webpack_require__(38);
	var async = __webpack_require__(51);
	var EventEmitter = __webpack_require__(40).EventEmitter;
	var Transaction = __webpack_require__(5).Transaction;
	var RippleError = __webpack_require__(14).RippleError;
	var PendingQueue = __webpack_require__(20).TransactionQueue;
	var log = __webpack_require__(23).internal.sub('transactionmanager');

	/**
	 * @constructor TransactionManager
	 * @param {Account} account
	 */

	function TransactionManager(account) {
	  EventEmitter.call(this);

	  var self = this;

	  this._account = account;
	  this._accountID = account._account_id;
	  this._remote = account._remote;
	  this._nextSequence = undefined;
	  this._maxFee = this._remote.max_fee;
	  this._maxAttempts = this._remote.max_attempts;
	  this._submissionTimeout = this._remote.submission_timeout;
	  this._lastLedgerOffset = this._remote.last_ledger_offset;
	  this._pending = new PendingQueue();

	  this._account.on('transaction-outbound', function (res) {
	    self._transactionReceived(res);
	  });

	  this._remote.on('load_changed', function (load) {
	    self._adjustFees(load);
	  });

	  function updatePendingStatus(ledger) {
	    self._updatePendingStatus(ledger);
	  }

	  this._remote.on('ledger_closed', updatePendingStatus);

	  function handleReconnect() {
	    self._handleReconnect(function () {
	      // Handle reconnect, account_tx procedure first, before
	      // hooking back into ledger_closed
	      self._remote.on('ledger_closed', updatePendingStatus);
	    });
	  }

	  this._remote.on('disconnect', function () {
	    self._remote.removeListener('ledger_closed', updatePendingStatus);
	    self._remote.once('connect', handleReconnect);
	  });

	  // Query server for next account transaction sequence
	  this._loadSequence();
	}

	util.inherits(TransactionManager, EventEmitter);

	TransactionManager._isNoOp = function (transaction) {
	  return typeof transaction === 'object' && typeof transaction.tx_json === 'object' && transaction.tx_json.TransactionType === 'AccountSet' && transaction.tx_json.Flags === 0;
	};

	TransactionManager._isRemoteError = function (error) {
	  return typeof error === 'object' && error.error === 'remoteError' && typeof error.remote === 'object';
	};

	TransactionManager._isNotFound = function (error) {
	  return TransactionManager._isRemoteError(error) && /^(txnNotFound|transactionNotFound)$/.test(error.remote.error);
	};

	TransactionManager._isTooBusy = function (error) {
	  return TransactionManager._isRemoteError(error) && error.remote.error === 'tooBusy';
	};

	/**
	 * Normalize transactions received from account transaction stream and
	 * account_tx
	 *
	 * @param {Transaction}
	 * @return {Transaction} normalized
	 * @api private
	 */

	TransactionManager.normalizeTransaction = function (tx) {
	  var transaction = {};
	  var keys = _Object$keys(tx);

	  for (var i = 0; i < keys.length; i++) {
	    var k = keys[i];
	    switch (k) {
	      case 'transaction':
	        // Account transaction stream
	        transaction.tx_json = tx[k];
	        break;
	      case 'tx':
	        // account_tx response
	        transaction.engine_result = tx.meta.TransactionResult;
	        transaction.result = transaction.engine_result;
	        transaction.tx_json = tx[k];
	        transaction.hash = tx[k].hash;
	        transaction.ledger_index = tx[k].ledger_index;
	        transaction.type = 'transaction';
	        transaction.validated = tx.validated;
	        break;
	      case 'meta':
	      case 'metadata':
	        transaction.metadata = tx[k];
	        break;
	      case 'mmeta':
	        // Don't copy mmeta
	        break;
	      default:
	        transaction[k] = tx[k];
	    }
	  }

	  return transaction;
	};

	/**
	 * Handle received transaction from two possible sources
	 *
	 * + Account transaction stream (normal operation)
	 * + account_tx (after reconnect)
	 *
	 * @param {Object} transaction
	 * @api private
	 */

	TransactionManager.prototype._transactionReceived = function (tx) {
	  var transaction = TransactionManager.normalizeTransaction(tx);

	  if (!transaction.validated) {
	    // Transaction has not been validated
	    return;
	  }

	  if (transaction.tx_json.Account !== this._accountID) {
	    // Received transaction's account does not match
	    return;
	  }

	  if (this._remote.trace) {
	    log.info('transaction received:', transaction.tx_json);
	  }

	  this._pending.addReceivedSequence(transaction.tx_json.Sequence);

	  var hash = transaction.tx_json.hash;
	  var submission = this._pending.getSubmission(hash);

	  if (!(submission instanceof Transaction)) {
	    // The received transaction does not correlate to one submitted
	    this._pending.addReceivedId(hash, transaction);
	    return;
	  }

	  // ND: A `success` handler will `finalize` this later
	  switch (transaction.engine_result) {
	    case 'tesSUCCESS':
	      submission.emit('success', transaction);
	      break;
	    default:
	      submission.emit('error', transaction);
	  }
	};

	/**
	 * Adjust pending transactions' fees in real-time. This does not resubmit
	 * pending transactions; they will be resubmitted periodically with an updated
	 * fee (and as a consequence, a new transaction ID) if not already validated
	 *
	 * ND: note, that `Fee` is a component of a transactionID
	 *
	 * @api private
	 */

	TransactionManager.prototype._adjustFees = function () {
	  var self = this;

	  if (!this._remote.local_fee) {
	    return;
	  }

	  function maxFeeExceeded(transaction) {
	    // Don't err until attempting to resubmit
	    transaction.once('presubmit', function () {
	      transaction.emit('error', 'tejMaxFeeExceeded');
	    });
	  }

	  this._pending.forEach(function (transaction) {
	    if (transaction._setFixedFee) {
	      return;
	    }

	    var oldFee = transaction.tx_json.Fee;
	    var newFee = transaction._computeFee();

	    if (Number(newFee) > self._maxFee) {
	      // Max transaction fee exceeded, abort submission
	      maxFeeExceeded(transaction);
	      return;
	    }

	    transaction.tx_json.Fee = newFee;
	    transaction.emit('fee_adjusted', oldFee, newFee);

	    if (self._remote.trace) {
	      log.info('fee adjusted:', transaction.tx_json, oldFee, newFee);
	    }
	  });
	};

	/**
	 * Get pending transactions
	 *
	 * @return {Array} pending transactions
	 */

	TransactionManager.prototype.getPending = function () {
	  return this._pending;
	};

	/**
	 * Legacy code. Update transaction status after excessive ledgers pass. One of
	 * either "missing" or "lost"
	 *
	 * @param {Object} ledger data
	 * @api private
	 */

	TransactionManager.prototype._updatePendingStatus = function (ledger) {
	  assert.strictEqual(typeof ledger, 'object');
	  assert.strictEqual(typeof ledger.ledger_index, 'number');

	  this._pending.forEach(function (transaction) {
	    if (transaction.finalized) {
	      return;
	    }

	    switch (ledger.ledger_index - transaction.submitIndex) {
	      case 4:
	        transaction.emit('missing', ledger);
	        break;
	      case 8:
	        transaction.emit('lost', ledger);
	        break;
	    }

	    if (ledger.ledger_index > transaction.tx_json.LastLedgerSequence) {
	      // Transaction must fail
	      transaction.emit('error', new RippleError('tejMaxLedger', 'Transaction LastLedgerSequence exceeded'));
	    }
	  });
	};

	// Fill an account transaction sequence
	TransactionManager.prototype._fillSequence = function (tx, callback) {
	  var self = this;

	  function submitFill(sequence, fCallback) {
	    var fillTransaction = self._remote.createTransaction('AccountSet', {
	      account: self._accountID
	    });
	    fillTransaction.tx_json.Sequence = sequence;

	    // Secrets may be set on a per-transaction basis
	    if (tx._secret) {
	      fillTransaction.secret(tx._secret);
	    }

	    fillTransaction.once('submitted', fCallback);
	    fillTransaction.submit();
	  }

	  function sequenceLoaded(err, sequence) {
	    if (typeof sequence !== 'number') {
	      log.info('fill sequence: failed to fetch account transaction sequence');
	      return callback();
	    }

	    var sequenceDiff = tx.tx_json.Sequence - sequence;
	    var submitted = 0;

	    async.whilst(function () {
	      return submitted < sequenceDiff;
	    }, function (asyncCallback) {
	      submitFill(sequence, function (res) {
	        ++submitted;
	        if (res.engine_result === 'tesSUCCESS') {
	          self.emit('sequence_filled', err);
	        }
	        asyncCallback();
	      });
	    }, function () {
	      if (callback) {
	        callback();
	      }
	    });
	  }

	  this._loadSequence(sequenceLoaded);
	};

	/**
	 * Load account transaction sequence
	 *
	 * @param [Function] callback
	 * @api private
	 */

	TransactionManager.prototype._loadSequence = function (callback_) {
	  var self = this;
	  var callback = typeof callback_ === 'function' ? callback_ : function () {};

	  function sequenceLoaded(err, sequence) {
	    if (err || typeof sequence !== 'number') {
	      if (self._remote.trace) {
	        log.info('error requesting account transaction sequence', err);
	        return;
	      }
	    }

	    self._nextSequence = sequence;
	    self.emit('sequence_loaded', sequence);
	    callback(err, sequence);
	  }

	  this._account.getNextSequence(sequenceLoaded);
	};

	/**
	 * On reconnect, load account_tx in case a pending transaction succeeded while
	 * disconnected
	 *
	 * @param [Function] callback
	 * @api private
	 */

	TransactionManager.prototype._handleReconnect = function (callback_) {
	  var self = this;
	  var callback = typeof callback_ === 'function' ? callback_ : function () {};

	  if (!this._pending.length()) {
	    callback();
	    return;
	  }

	  function handleTransactions(err, transactions) {
	    if (err || typeof transactions !== 'object') {
	      if (self._remote.trace) {
	        log.info('error requesting account_tx', err);
	      }
	      callback();
	      return;
	    }

	    if (Array.isArray(transactions.transactions)) {
	      // Treat each transaction in account transaction history as received
	      transactions.transactions.forEach(self._transactionReceived, self);
	    }

	    callback();

	    self._loadSequence(function () {
	      // Resubmit pending transactions after sequence is loaded
	      self._resubmit();
	    });
	  }

	  var options = {
	    account: this._accountID,
	    ledger_index_min: this._pending.getMinLedger(),
	    ledger_index_max: -1,
	    binary: true,
	    parseBinary: true,
	    limit: 20
	  };

	  this._remote.requestAccountTx(options, handleTransactions);
	};

	/**
	 * Wait for specified number of ledgers to pass
	 *
	 * @param {Number} ledgers
	 * @param {Function} callback
	 * @api private
	 */

	TransactionManager.prototype._waitLedgers = function (ledgers, callback) {
	  assert.strictEqual(typeof ledgers, 'number');
	  assert.strictEqual(typeof callback, 'function');

	  if (ledgers < 1) {
	    return callback();
	  }

	  var self = this;
	  var closes = 0;

	  function ledgerClosed() {
	    if (++closes === ledgers) {
	      self._remote.removeListener('ledger_closed', ledgerClosed);
	      callback();
	    }
	  }

	  this._remote.on('ledger_closed', ledgerClosed);
	};

	/**
	 * Resubmit pending transactions. If a transaction is specified, it will be
	 * resubmitted. Otherwise, all pending transactions will be resubmitted
	 *
	 * @param [Number] ledgers to wait before resubmitting
	 * @param [Transaction] pending transactions to resubmit
	 * @api private
	 */

	TransactionManager.prototype._resubmit = function (ledgers_, pending_) {
	  var self = this;

	  var ledgers = ledgers_;
	  var pending = pending_;

	  if (arguments.length === 1) {
	    pending = ledgers;
	    ledgers = 0;
	  }

	  ledgers = ledgers || 0;
	  pending = pending instanceof Transaction ? [pending] : this.getPending().getQueue();

	  function resubmitTransaction(transaction, next) {
	    if (!transaction || transaction.finalized) {
	      // Transaction has been finalized, nothing to do
	      return;
	    }

	    // Find ID within cache of received (validated) transaction IDs
	    var received = transaction.findId(self._pending._idCache);

	    if (received) {
	      switch (received.engine_result) {
	        case 'tesSUCCESS':
	          transaction.emit('success', received);
	          break;
	        default:
	          transaction.emit('error', received);
	      }
	    }

	    while (self._pending.hasSequence(transaction.tx_json.Sequence)) {
	      // Sequence number has been consumed by another transaction
	      transaction.tx_json.Sequence += 1;

	      if (self._remote.trace) {
	        log.info('incrementing sequence:', transaction.tx_json);
	      }
	    }

	    if (self._remote.trace) {
	      log.info('resubmit:', transaction.tx_json);
	    }

	    transaction.once('submitted', function (m) {
	      transaction.emit('resubmitted', m);
	      next();
	    });

	    self._request(transaction);
	  }

	  this._waitLedgers(ledgers, function () {
	    async.eachSeries(pending, resubmitTransaction);
	  });
	};

	/**
	 * Prepare submit request
	 *
	 * @param {Transaction} transaction to submit
	 * @return {Request} submit request
	 * @api private
	 */

	TransactionManager.prototype._prepareRequest = function (tx) {
	  var submitRequest = this._remote.requestSubmit();

	  if (this._remote.local_signing) {
	    tx.sign();

	    var serialized = tx.serialize();
	    submitRequest.tx_blob(serialized.to_hex());

	    var hash = tx.hash(null, null, serialized);
	    tx.addId(hash);
	  } else {
	    // ND: `build_path` is completely ignored when doing local signing as
	    // `Paths` is a component of the signed blob, the `tx_blob` is signed,
	    // sealed and delivered, and the txn unmodified.
	    // TODO: perhaps an exception should be raised if build_path is attempted
	    // while local signing
	    submitRequest.build_path(tx._build_path);
	    submitRequest.secret(tx._secret);
	    submitRequest.tx_json(tx.tx_json);
	  }

	  return submitRequest;
	};

	/**
	 * Send `submit` request, handle response
	 *
	 * @param {Transaction} transaction to submit
	 * @api private
	 */

	TransactionManager.prototype._request = function (tx) {
	  var self = this;
	  var remote = this._remote;

	  if (tx.finalized) {
	    return;
	  }

	  if (tx.attempts > this._maxAttempts) {
	    tx.emit('error', new RippleError('tejAttemptsExceeded'));
	    return;
	  }

	  if (tx.attempts > 0 && !remote.local_signing) {
	    var errMessage = 'Automatic resubmission requires local signing';
	    tx.emit('error', new RippleError('tejLocalSigningRequired', errMessage));
	    return;
	  }

	  if (remote.trace) {
	    log.info('submit transaction:', tx.tx_json);
	  }

	  function transactionFailed(message) {
	    if (message.engine_result === 'tefPAST_SEQ') {
	      // Transaction may succeed after Sequence is updated
	      self._resubmit(1, tx);
	    }
	  }

	  function transactionRetry() {
	    // XXX This may no longer be necessary. Instead, update sequence numbers
	    // after a transaction fails definitively
	    self._fillSequence(tx, function () {
	      self._resubmit(1, tx);
	    });
	  }

	  function transactionFailedLocal(message) {
	    if (message.engine_result === 'telINSUF_FEE_P') {
	      // Transaction may succeed after Fee is updated
	      self._resubmit(1, tx);
	    }
	  }

	  function submissionError(error) {
	    // Either a tem-class error or generic server error such as tooBusy. This
	    // should be a definitive failure
	    if (TransactionManager._isTooBusy(error)) {
	      self._resubmit(1, tx);
	    } else {
	      self._nextSequence--;
	      tx.emit('error', error);
	    }
	  }

	  function submitted(message) {
	    if (tx.finalized) {
	      return;
	    }

	    // ND: If for some unknown reason our hash wasn't computed correctly this
	    // is an extra measure.
	    if (message.tx_json && message.tx_json.hash) {
	      tx.addId(message.tx_json.hash);
	    }

	    message.result = message.engine_result || '';

	    tx.result = message;
	    tx.responses += 1;

	    if (remote.trace) {
	      log.info('submit response:', message);
	    }

	    tx.emit('submitted', message);

	    switch (message.result.slice(0, 3)) {
	      case 'tes':
	        tx.emit('proposed', message);
	        break;
	      case 'tec':
	        break;
	      case 'ter':
	        transactionRetry(message);
	        break;
	      case 'tef':
	        transactionFailed(message);
	        break;
	      case 'tel':
	        transactionFailedLocal(message);
	        break;
	      default:
	        // tem
	        submissionError(message);
	    }
	  }

	  function requestTimeout() {
	    // ND: What if the response is just slow and we get a response that
	    // `submitted` above will cause to have concurrent resubmit logic streams?
	    // It's simpler to just mute handlers and look out for finalized
	    // `transaction` messages.
	    if (tx.finalized) {
	      return;
	    }

	    tx.emit('timeout');

	    if (remote.isConnected()) {
	      if (remote.trace) {
	        log.info('timeout:', tx.tx_json);
	      }
	      self._resubmit(1, tx);
	    }
	  }

	  tx.submitIndex = this._remote._ledger_current_index;

	  if (tx.attempts === 0) {
	    tx.initialSubmitIndex = tx.submitIndex;
	  }

	  if (!tx._setLastLedger) {
	    // Honor LastLedgerSequence set with tx.lastLedger()
	    tx.tx_json.LastLedgerSequence = tx.initialSubmitIndex + this._lastLedgerOffset;
	  }

	  tx.lastLedgerSequence = tx.tx_json.LastLedgerSequence;

	  if (remote.local_signing) {
	    tx.sign();
	  }

	  var submitRequest = this._prepareRequest(tx);
	  submitRequest.once('error', submitted);
	  submitRequest.once('success', submitted);

	  tx.emit('presubmit');

	  submitRequest.broadcast().request();
	  tx.attempts++;

	  tx.emit('postsubmit');

	  submitRequest.timeout(self._submissionTimeout, requestTimeout);
	};

	/**
	 * Entry point for TransactionManager submission
	 *
	 * @param {Transaction} tx
	 */

	TransactionManager.prototype.submit = function (tx) {
	  var self = this;

	  if (typeof this._nextSequence !== 'number') {
	    // If sequence number is not yet known, defer until it is.
	    this.once('sequence_loaded', function () {
	      self.submit(tx);
	    });
	    return;
	  }

	  if (tx.finalized) {
	    // Finalized transactions must stop all activity
	    return;
	  }

	  if (typeof tx.tx_json.Sequence !== 'number') {
	    // Honor manually-set sequences
	    tx.tx_json.Sequence = this._nextSequence++;
	  }

	  tx.once('cleanup', function () {
	    self.getPending().remove(tx);
	  });

	  if (!tx.complete()) {
	    this._nextSequence--;
	    return;
	  }

	  // ND: this is the ONLY place we put the tx into the queue. The
	  // TransactionQueue queue is merely a list, so any mutations to tx._hash
	  // will cause subsequent look ups (eg. inside 'transaction-outbound'
	  // validated transaction clearing) to fail.
	  this._pending.push(tx);
	  this._request(tx);
	};

	exports.TransactionManager = TransactionManager;

/***/ },
/* 26 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	/**
	 * Type definitions for binary format.
	 *
	 * This file should not be included directly. Instead, find the format you're
	 * trying to parse or serialize in binformat.js and pass that to
	 * SerializedObject.parse() or SerializedObject.serialize().
	 */

	var _Object$keys = __webpack_require__(28)['default'];

	var assert = __webpack_require__(38);
	var extend = __webpack_require__(39);
	var GlobalBigNumber = __webpack_require__(49);
	var Amount = __webpack_require__(3).Amount;
	var Currency = __webpack_require__(6).Currency;
	var binformat = __webpack_require__(16);
	var utils = __webpack_require__(17);
	var sjcl = utils.sjcl;
	var SJCL_BN = sjcl.bn;

	var UInt128 = __webpack_require__(8).UInt128;
	var UInt160 = __webpack_require__(9).UInt160;
	var UInt256 = __webpack_require__(10).UInt256;
	var Base = __webpack_require__(7).Base;

	var BigNumber = GlobalBigNumber.another({
	  ROUNDING_MODE: GlobalBigNumber.ROUND_HALF_UP,
	  DECIMAL_PLACES: 40
	});

	function SerializedType(methods) {
	  extend(this, methods);
	}

	function isNumber(val) {
	  return typeof val === 'number' && isFinite(val);
	}

	function isString(val) {
	  return typeof val === 'string';
	}

	function isHexInt64String(val) {
	  return isString(val) && /^[0-9A-F]{0,16}$/i.test(val);
	}

	function serializeBits(so, bits, noLength) {
	  var byteData = sjcl.codec.bytes.fromBits(bits);
	  if (!noLength) {
	    SerializedType.serialize_varint(so, byteData.length);
	  }
	  so.append(byteData);
	}

	function serializeHex(so, hexData, noLength) {
	  serializeBits(so, sjcl.codec.hex.toBits(hexData), noLength);
	}

	/**
	 * parses bytes as hex
	 *
	 * @param {Array} byte_array bytes
	 * @return {String} hex string
	 */
	function convertByteArrayToHex(byte_array) {
	  return sjcl.codec.hex.fromBits(sjcl.codec.bytes.toBits(byte_array)).toUpperCase();
	}

	function convertHexToString(hexString) {
	  var bits = sjcl.codec.hex.toBits(hexString);
	  return sjcl.codec.utf8String.fromBits(bits);
	}

	function sort_fields(keys) {
	  function sort_field_compare(a, b) {
	    var a_field_coordinates = binformat.fieldsInverseMap[a];
	    var a_type_bits = a_field_coordinates[0];
	    var a_field_bits = a_field_coordinates[1];
	    var b_field_coordinates = binformat.fieldsInverseMap[b];
	    var b_type_bits = b_field_coordinates[0];
	    var b_field_bits = b_field_coordinates[1];

	    // Sort by type id first, then by field id
	    return a_type_bits !== b_type_bits ? a_type_bits - b_type_bits : a_field_bits - b_field_bits;
	  }

	  return keys.sort(sort_field_compare);
	}

	SerializedType.serialize_varint = function (so, val) {
	  if (val < 0) {
	    throw new Error('Variable integers are unsigned.');
	  }

	  if (val <= 192) {
	    so.append([val]);
	  } else if (val <= 12480) {
	    val -= 193;
	    so.append([193 + (val >>> 8), val & 0xff]);
	  } else if (val <= 918744) {
	    val -= 12481;
	    so.append([241 + (val >>> 16), val >>> 8 & 0xff, val & 0xff]);
	  } else {
	    throw new Error('Variable integer overflow.');
	  }
	};

	SerializedType.prototype.parse_varint = function (so) {
	  var b1 = so.read(1)[0],
	      b2,
	      b3;
	  var result;

	  if (b1 > 254) {
	    throw new Error('Invalid varint length indicator');
	  }

	  if (b1 <= 192) {
	    result = b1;
	  } else if (b1 <= 240) {
	    b2 = so.read(1)[0];
	    result = 193 + (b1 - 193) * 256 + b2;
	  } else if (b1 <= 254) {
	    b2 = so.read(1)[0];
	    b3 = so.read(1)[0];
	    result = 12481 + (b1 - 241) * 65536 + b2 * 256 + b3;
	  }

	  return result;
	};

	// In the following, we assume that the inputs are in the proper range. Is this
	// correct?
	// Helper functions for 1-, 2-, and 4-byte integers.

	/**
	 * Convert an integer value into an array of bytes.
	 *
	 * The result is appended to the serialized object ('so').
	 *
	 * @param {Number} val value
	 * @param {Number} bytes byte size
	 * @return {Array} byte array
	 */
	function convertIntegerToByteArray(val, bytes) {
	  if (!isNumber(val)) {
	    throw new Error('Value is not a number', bytes);
	  }

	  if (val < 0 || val >= Math.pow(256, bytes)) {
	    throw new Error('Value out of bounds ');
	  }

	  var newBytes = [];

	  for (var i = 0; i < bytes; i++) {
	    newBytes.unshift(val >>> i * 8 & 0xff);
	  }

	  return newBytes;
	}

	// Convert a certain number of bytes from the serialized object ('so') into an
	// integer.
	function readAndSum(so, bytes) {
	  var sum = 0;

	  if (bytes > 4) {
	    throw new Error('This function only supports up to four bytes.');
	  }

	  for (var i = 0; i < bytes; i++) {
	    var byte = so.read(1)[0];
	    sum += byte << 8 * (bytes - i - 1);
	  }

	  // Convert to unsigned integer
	  return sum >>> 0;
	}

	var STInt8 = exports.Int8 = new SerializedType({
	  serialize: function serialize(so, val) {
	    so.append(convertIntegerToByteArray(val, 1));
	  },
	  parse: function parse(so) {
	    return readAndSum(so, 1);
	  }
	});

	STInt8.id = 16;

	function _serialize(so, field_name, value) {
	  // so: a byte-stream to serialize into.
	  // field_name: a string for the field name ('LedgerEntryType' etc.)
	  // value: the value of that field.
	  var field_coordinates = binformat.fieldsInverseMap[field_name];
	  var type_bits = field_coordinates[0];
	  var field_bits = field_coordinates[1];
	  var tag_byte = (type_bits < 16 ? type_bits << 4 : 0) | (field_bits < 16 ? field_bits : 0);

	  if (field_name === 'LedgerEntryType' && typeof value === 'string') {
	    value = binformat.ledger[value][0];
	  }

	  if (field_name === 'TransactionResult' && typeof value === 'string') {
	    value = binformat.ter[value];
	  }

	  STInt8.serialize(so, tag_byte);

	  if (type_bits >= 16) {
	    STInt8.serialize(so, type_bits);
	  }

	  if (field_bits >= 16) {
	    STInt8.serialize(so, field_bits);
	  }

	  // Get the serializer class (ST...)
	  var serialized_object_type;

	  if (field_name === 'Memo' && typeof value === 'object') {
	    // for Memo we override the default behavior with our STMemo serializer
	    serialized_object_type = exports.STMemo;
	  } else {
	    // for a field based on the type bits.
	    serialized_object_type = exports[binformat.types[type_bits]];
	  }

	  try {
	    serialized_object_type.serialize(so, value);
	  } catch (e) {
	    e.message += ' (' + field_name + ')';
	    throw e;
	  }
	}

	exports.serialize = exports.serialize_whatever = _serialize;

	// Take the serialized object, figure out what type/field it is, and return the
	// parsing of that.

	function _parse(so) {
	  var tag_byte = so.read(1)[0];
	  var type_bits = tag_byte >> 4;

	  if (type_bits === 0) {
	    type_bits = so.read(1)[0];
	  }

	  var field_bits = tag_byte & 0x0f;
	  var field_name = field_bits === 0 ? field_name = binformat.fields[type_bits][so.read(1)[0]] : field_name = binformat.fields[type_bits][field_bits];

	  assert(field_name, 'Unknown field - header byte is 0x' + tag_byte.toString(16));

	  // Get the parser class (ST...) for a field based on the type bits.
	  var type = field_name === 'Memo' ? exports.STMemo : exports[binformat.types[type_bits]];

	  assert(type, 'Unknown type - header byte is 0x' + tag_byte.toString(16));

	  return [field_name, type.parse(so)]; // key, value
	}

	exports.parse = exports.parse_whatever = _parse;

	var STInt16 = exports.Int16 = new SerializedType({
	  serialize: function serialize(so, val) {
	    so.append(convertIntegerToByteArray(val, 2));
	  },
	  parse: function parse(so) {
	    return readAndSum(so, 2);
	  }
	});

	STInt16.id = 1;

	var STInt32 = exports.Int32 = new SerializedType({
	  serialize: function serialize(so, val) {
	    so.append(convertIntegerToByteArray(val, 4));
	  },
	  parse: function parse(so) {
	    return readAndSum(so, 4);
	  }
	});

	STInt32.id = 2;

	var STInt64 = exports.Int64 = new SerializedType({
	  serialize: function serialize(so, val) {
	    var bigNumObject;

	    if (isNumber(val)) {
	      val = Math.floor(val);
	      if (val < 0) {
	        throw new Error('Negative value for unsigned Int64 is invalid.');
	      }
	      bigNumObject = new SJCL_BN(val, 10);
	    } else if (isString(val)) {
	      if (!isHexInt64String(val)) {
	        throw new Error('Not a valid hex Int64.');
	      }
	      bigNumObject = new SJCL_BN(val, 16);
	    } else if (val instanceof SJCL_BN) {
	      if (!val.greaterEquals(0)) {
	        throw new Error('Negative value for unsigned Int64 is invalid.');
	      }
	      bigNumObject = val;
	    } else {
	      throw new Error('Invalid type for Int64');
	    }
	    serializeBits(so, bigNumObject.toBits(64), true); // noLength = true
	  },
	  parse: function parse(so) {
	    var bytes = so.read(8);
	    return SJCL_BN.fromBits(sjcl.codec.bytes.toBits(bytes));
	  }
	});

	STInt64.id = 3;

	var STHash128 = exports.Hash128 = new SerializedType({
	  serialize: function serialize(so, val) {
	    var hash = UInt128.from_json(val);
	    if (!hash.is_valid()) {
	      throw new Error('Invalid Hash128');
	    }
	    serializeBits(so, hash.to_bits(), true); // noLength = true
	  },
	  parse: function parse(so) {
	    return UInt128.from_bytes(so.read(16));
	  }
	});

	STHash128.id = 4;

	var STHash256 = exports.Hash256 = new SerializedType({
	  serialize: function serialize(so, val) {
	    var hash = UInt256.from_json(val);
	    if (!hash.is_valid()) {
	      throw new Error('Invalid Hash256');
	    }
	    serializeBits(so, hash.to_bits(), true); // noLength = true
	  },
	  parse: function parse(so) {
	    return UInt256.from_bytes(so.read(32));
	  }
	});

	STHash256.id = 5;

	var STHash160 = exports.Hash160 = new SerializedType({
	  serialize: function serialize(so, val) {
	    var hash = UInt160.from_json(val);
	    if (!hash.is_valid()) {
	      throw new Error('Invalid Hash160');
	    }
	    serializeBits(so, hash.to_bits(), true); // noLength = true
	  },
	  parse: function parse(so) {
	    return UInt160.from_bytes(so.read(20));
	  }
	});

	STHash160.id = 17;

	// Internal
	var STCurrency = new SerializedType({
	  serialize: function serialize(so, val) {
	    var currencyData = val.to_bytes();

	    if (!currencyData) {
	      throw new Error('Tried to serialize invalid/unimplemented currency type.');
	    }

	    so.append(currencyData);
	  },
	  parse: function parse(so) {
	    var bytes = so.read(20);
	    var currency = Currency.from_bytes(bytes);
	    // XXX Disabled check. Theoretically, the Currency class should support any
	    //     UInt160 value and consider it valid. But it doesn't, so for the
	    //     deserialization to be usable, we need to allow invalid results for
	    //     now.
	    // if (!currency.is_valid()) {
	    //   throw new Error('Invalid currency: '+convertByteArrayToHex(bytes));
	    // }
	    return currency;
	  }
	});

	/**
	 * Quality is encoded into 64 bits:
	 * (8 bits offset) (56 bits mantissa)
	 *
	 * Quality differs from Amount because it does not need the first two bits
	 * to represent non-native and non-negative
	 */
	exports.Quality = new SerializedType({
	  serialize: function serialize(so, val) {
	    var amount = Amount.from_json(val);

	    if (!amount.is_valid()) {
	      throw new Error('Not a valid Amount object.');
	    }

	    var hi = 0,
	        lo = 0;
	    var value = new BigNumber(amount.to_text());
	    var offset = value.e - 15;

	    if (!amount.is_zero()) {
	      // First eight bits: offset/exponent
	      hi |= (100 + offset & 0xff) << 24;

	      // Remaining 56 bits: mantissa
	      var mantissaDecimal = utils.getMantissaDecimalString(value.abs());
	      var mantissaHex = new BigNumber(mantissaDecimal).toString(16);
	      assert(mantissaHex.length <= 16, 'Mantissa hex representation ' + mantissaHex + ' exceeds the maximum length of 16');
	      hi |= parseInt(mantissaHex.slice(0, -8), 16) & 0xffffff;
	      lo = parseInt(mantissaHex.slice(-8), 16);
	    }

	    var valueBytes = sjcl.codec.bytes.fromBits([hi, lo]);

	    so.append(valueBytes);
	  }
	});

	/*
	 * Amount is encoded into 64 bits:
	 * (1 bit non-native) (1 bit non-negative) (8 bits offset) (54 bits mantissa)
	 */
	var STAmount = exports.Amount = new SerializedType({
	  serialize: function serialize(so, val) {
	    var amount = Amount.from_json(val);

	    if (!amount.is_valid()) {
	      throw new Error('Not a valid Amount object.');
	    }

	    var value = new BigNumber(amount.to_text());
	    var offset = value.e - 15;

	    // Amount (64-bit integer)
	    var valueBytes = utils.arraySet(8, 0);

	    if (amount.is_native()) {
	      var valueHex = value.abs().toString(16);

	      if (Amount.strict_mode && value.abs().greaterThan(Amount.bi_xns_max)) {
	        throw new Error('Value out of bounds');
	      }

	      // Enforce correct length (64 bits)
	      if (Amount.strict_mode && valueHex.length > 16) {
	        throw new Error('Value out of bounds');
	      }

	      while (valueHex.length < 16) {
	        valueHex = '0' + valueHex;
	      }

	      valueBytes = sjcl.codec.bytes.fromBits(sjcl.codec.hex.toBits(valueHex));
	      // Clear most significant two bits - these bits should already be 0 if
	      // Amount enforces the range correctly, but we'll clear them anyway just
	      // so this code can make certain guarantees about the encoded value.
	      valueBytes[0] &= 0x3f;

	      if (!amount.is_negative()) {
	        valueBytes[0] |= 0x40;
	      }
	    } else {
	      var hi = 0,
	          lo = 0;

	      // First bit: non-native
	      hi |= 1 << 31;

	      if (!amount.is_zero()) {
	        // Second bit: non-negative?
	        if (!amount.is_negative()) {
	          hi |= 1 << 30;
	        }

	        // Next eight bits: offset/exponent
	        hi |= (97 + offset & 0xff) << 22;

	        // Remaining 54 bits: mantissa
	        var mantissaDecimal = utils.getMantissaDecimalString(value.abs());
	        var mantissaHex = new BigNumber(mantissaDecimal).toString(16);
	        assert(mantissaHex.length <= 16, 'Mantissa hex representation ' + mantissaHex + ' exceeds the maximum length of 16');
	        hi |= parseInt(mantissaHex.slice(0, -8), 16) & 0x3fffff;
	        lo = parseInt(mantissaHex.slice(-8), 16);
	      }

	      valueBytes = sjcl.codec.bytes.fromBits([hi, lo]);
	    }

	    so.append(valueBytes);

	    if (!amount.is_native()) {
	      // Currency (160-bit hash)
	      var currency = amount.currency();
	      STCurrency.serialize(so, currency, true);

	      // Issuer (160-bit hash)
	      so.append(amount.issuer().to_bytes());
	    }
	  },
	  parse: function parse(so) {
	    var value_bytes = so.read(8);
	    var is_zero = !(value_bytes[0] & 0x7f);

	    for (var i = 1; i < 8; i++) {
	      is_zero = is_zero && !value_bytes[i];
	    }

	    var is_negative = !is_zero && !(value_bytes[0] & 0x40);

	    if (value_bytes[0] & 0x80) {
	      // non-native
	      var currency = STCurrency.parse(so);
	      var issuer_bytes = so.read(20);
	      var issuer = UInt160.from_bytes(issuer_bytes);
	      issuer.set_version(Base.VER_ACCOUNT_ID);
	      var offset = ((value_bytes[0] & 0x3f) << 2) + (value_bytes[1] >>> 6) - 97;
	      var mantissa_bytes = value_bytes.slice(1);
	      mantissa_bytes[0] &= 0x3f;
	      var mantissa = new BigNumber(utils.arrayToHex(mantissa_bytes), 16);
	      var sign = is_negative ? '-' : '';
	      var valueString = sign + mantissa.toString() + 'e' + offset.toString();

	      return Amount.from_json({
	        currency: currency,
	        issuer: issuer.to_json(),
	        value: valueString
	      });
	    }

	    // native
	    var integer_bytes = value_bytes.slice();
	    integer_bytes[0] &= 0x3f;
	    var integer_hex = utils.arrayToHex(integer_bytes);
	    var value = new BigNumber(integer_hex, 16);
	    return Amount.from_json((is_negative ? '-' : '') + value.toString());
	  }
	});

	STAmount.id = 6;

	var STVL = exports.VariableLength = exports.VL = new SerializedType({
	  serialize: function serialize(so, val) {
	    if (typeof val === 'string') {
	      serializeHex(so, val);
	    } else {
	      throw new Error('Unknown datatype.');
	    }
	  },
	  parse: function parse(so) {
	    var len = this.parse_varint(so);
	    return convertByteArrayToHex(so.read(len));
	  }
	});

	STVL.id = 7;

	var STAccount = exports.Account = new SerializedType({
	  serialize: function serialize(so, val) {
	    var account = UInt160.from_json(val);
	    if (!account.is_valid()) {
	      throw new Error('Invalid account!');
	    }
	    serializeBits(so, account.to_bits());
	  },
	  parse: function parse(so) {
	    var len = this.parse_varint(so);

	    if (len !== 20) {
	      throw new Error('Non-standard-length account ID');
	    }

	    var result = UInt160.from_bytes(so.read(len));
	    result.set_version(Base.VER_ACCOUNT_ID);

	    if (false) {
	      throw new Error('Invalid Account');
	    }

	    return result;
	  }
	});

	STAccount.id = 8;

	var STPathSet = exports.PathSet = new SerializedType({
	  typeBoundary: 0xff,
	  typeEnd: 0x00,
	  typeAccount: 0x01,
	  typeCurrency: 0x10,
	  typeIssuer: 0x20,
	  serialize: function serialize(so, val) {
	    for (var i = 0, l = val.length; i < l; i++) {
	      // Boundary
	      if (i) {
	        STInt8.serialize(so, this.typeBoundary);
	      }

	      for (var j = 0, l2 = val[i].length; j < l2; j++) {
	        var entry = val[i][j];
	        // if (entry.hasOwnProperty('_value')) {entry = entry._value;}
	        var type = 0;

	        if (entry.account) {
	          type |= this.typeAccount;
	        }
	        if (entry.currency) {
	          type |= this.typeCurrency;
	        }
	        if (entry.issuer) {
	          type |= this.typeIssuer;
	        }

	        STInt8.serialize(so, type);

	        if (entry.account) {
	          STHash160.serialize(so, entry.account);
	        }

	        if (entry.currency) {
	          var currency = Currency.from_json(entry.currency, entry.non_native);
	          STCurrency.serialize(so, currency);
	        }

	        if (entry.issuer) {
	          STHash160.serialize(so, entry.issuer);
	        }
	      }
	    }

	    STInt8.serialize(so, this.typeEnd);
	  },
	  parse: function parse(so) {
	    // should return a list of lists:
	    /*
	       [
	       [entry, entry],
	       [entry, entry, entry],
	       [entry],
	       []
	       ]
	        each entry has one or more of the following attributes:
	       amount, currency, issuer.
	       */

	    var path_list = [];
	    var current_path = [];
	    var tag_byte;

	    /* eslint-disable no-cond-assign */

	    while ((tag_byte = so.read(1)[0]) !== this.typeEnd) {
	      // TODO: try/catch this loop, and catch when we run out of data without
	      // reaching the end of the data structure.
	      // Now determine: is this an end, boundary, or entry-begin-tag?
	      // console.log('Tag byte:', tag_byte);
	      if (tag_byte === this.typeBoundary) {
	        if (current_path) {
	          // close the current path, if there is one,
	          path_list.push(current_path);
	        }
	        current_path = []; // and start a new one.
	        continue;
	      }

	      // It's an entry-begin tag.
	      var entry = {};
	      var type = 0;

	      if (tag_byte & this.typeAccount) {
	        entry.account = STHash160.parse(so);
	        entry.account.set_version(Base.VER_ACCOUNT_ID);
	        type = type | this.typeAccount;
	      }
	      if (tag_byte & this.typeCurrency) {
	        entry.currency = STCurrency.parse(so);
	        if (entry.currency.to_json() === 'XRP' && !entry.currency.is_native()) {
	          entry.non_native = true;
	        }
	        type = type | this.typeCurrency;
	      }
	      if (tag_byte & this.typeIssuer) {
	        entry.issuer = STHash160.parse(so);
	        // Enable and set correct type of base-58 encoding
	        entry.issuer.set_version(Base.VER_ACCOUNT_ID);
	        type = type | this.typeIssuer;
	      }

	      if (entry.account || entry.currency || entry.issuer) {
	        entry.type = type;
	        entry.type_hex = ('000000000000000' + type.toString(16)).slice(-16);
	        current_path.push(entry);
	      } else {
	        // It must have at least something in it.
	        throw new Error('Invalid path entry');
	      }
	    }

	    if (current_path) {
	      // close the current path, if there is one,
	      path_list.push(current_path);
	    }

	    return path_list;
	  }
	});

	STPathSet.id = 18;

	var STVector256 = exports.Vector256 = new SerializedType({
	  serialize: function serialize(so, val) {
	    // Assume val is an array of STHash256 objects.
	    SerializedType.serialize_varint(so, val.length * 32);
	    for (var i = 0, l = val.length; i < l; i++) {
	      STHash256.serialize(so, val[i]);
	    }
	  },
	  parse: function parse(so) {
	    var length = this.parse_varint(so);
	    var output = [];
	    // length is number of bytes not number of Hash256
	    for (var i = 0; i < length / 32; i++) {
	      output.push(STHash256.parse(so));
	    }
	    return output;
	  }
	});

	STVector256.id = 19;

	// Internal
	exports.STMemo = new SerializedType({
	  serialize: function serialize(so, val, no_marker) {
	    var keys = [];

	    _Object$keys(val).forEach(function (key) {
	      // Ignore lowercase field names - they're non-serializable fields by
	      // convention.
	      if (key[0] === key[0].toLowerCase()) {
	        return;
	      }

	      if (typeof binformat.fieldsInverseMap[key] === 'undefined') {
	        throw new Error('JSON contains unknown field: "' + key + '"');
	      }

	      keys.push(key);
	    });

	    // Sort fields
	    keys = sort_fields(keys);

	    keys.forEach(function (key) {
	      _serialize(so, key, val[key]);
	    });

	    if (!no_marker) {
	      // Object ending marker
	      STInt8.serialize(so, 0xe1);
	    }
	  },
	  parse: function parse(so) {
	    var output = {};

	    while (so.peek(1)[0] !== 0xe1) {
	      var keyval = _parse(so);
	      output[keyval[0]] = keyval[1];
	    }

	    if (output.MemoType !== undefined) {
	      try {
	        var parsedType = convertHexToString(output.MemoType);

	        if (parsedType !== 'unformatted_memo') {
	          output.parsed_memo_type = parsedType;
	        }
	      } catch (e) {
	        // empty
	        // we don't know what's in the binary, apparently it's not a UTF-8
	        // string
	        // this is fine, we won't add the parsed_memo_type field
	      }
	    }

	    if (output.MemoFormat !== undefined) {
	      try {
	        output.parsed_memo_format = convertHexToString(output.MemoFormat);
	      } catch (e) {
	        // empty
	        // we don't know what's in the binary, apparently it's not a UTF-8
	        // string
	        // this is fine, we won't add the parsed_memo_format field
	      }
	    }

	    if (output.MemoData !== undefined) {

	      try {
	        if (output.parsed_memo_format === 'json') {
	          // see if we can parse JSON
	          output.parsed_memo_data = JSON.parse(convertHexToString(output.MemoData));
	        } else if (output.parsed_memo_format === 'text') {
	          // otherwise see if we can parse text
	          output.parsed_memo_data = convertHexToString(output.MemoData);
	        }
	      } catch (e) {
	        // empty
	        // we'll fail in case the content does not match what the MemoFormat
	        // described
	        // this is fine, we won't add the parsed_memo_data, the user has to
	        // parse themselves
	      }
	    }

	    so.read(1);
	    return output;
	  }

	});

	var STObject = exports.Object = new SerializedType({
	  serialize: function serialize(so, val, no_marker) {
	    var keys = [];

	    _Object$keys(val).forEach(function (key) {
	      // Ignore lowercase field names - they're non-serializable fields by
	      // convention.
	      if (key[0] === key[0].toLowerCase()) {
	        return;
	      }

	      if (typeof binformat.fieldsInverseMap[key] === 'undefined') {
	        throw new Error('JSON contains unknown field: "' + key + '"');
	      }

	      keys.push(key);
	    });

	    // Sort fields
	    keys = sort_fields(keys);

	    for (var i = 0; i < keys.length; i++) {
	      _serialize(so, keys[i], val[keys[i]]);
	    }

	    if (!no_marker) {
	      // Object ending marker
	      STInt8.serialize(so, 0xe1);
	    }
	  },

	  parse: function parse(so) {
	    var output = {};
	    while (so.peek(1)[0] !== 0xe1) {
	      var keyval = _parse(so);
	      output[keyval[0]] = keyval[1];
	    }
	    so.read(1);
	    return output;
	  }
	});

	STObject.id = 14;

	var STArray = exports.Array = new SerializedType({
	  serialize: function serialize(so, val) {
	    for (var i = 0, l = val.length; i < l; i++) {
	      var keys = _Object$keys(val[i]);

	      if (keys.length !== 1) {
	        throw new Error('Cannot serialize an array containing non-single-key objects');
	      }

	      var field_name = keys[0];
	      var value = val[i][field_name];
	      _serialize(so, field_name, value);
	    }

	    // Array ending marker
	    STInt8.serialize(so, 0xf1);
	  },

	  parse: function parse(so) {
	    var output = [];

	    while (so.peek(1)[0] !== 0xf1) {
	      var keyval = _parse(so);
	      var obj = {};
	      obj[keyval[0]] = keyval[1];
	      output.push(obj);
	    }

	    so.read(1);

	    return output;
	  }
	});

	STArray.id = 15;

/***/ },
/* 27 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function(options) {
	  var sjcl = options.sjcl; // inject sjcl dependency

	  var base58 = __webpack_require__(45)({ sjcl: options.sjcl });;
	  var MasterKey = __webpack_require__(46)({ sjcl: options.sjcl });
	  var RippleAddress = __webpack_require__(47)({ sjcl: options.sjcl });
	  var PublicGenerator = __webpack_require__(48)({ sjcl: options.sjcl });

	  function firstHalfOfSHA512(bytes) {
	    return sjcl.bitArray.bitSlice(
	      sjcl.hash.sha512.hash(sjcl.codec.bytes.toBits(bytes)),
	      0, 256
	    );
	  }

	  function append_int(a, i) {
	    return [].concat(a, i >> 24, (i >> 16) & 0xff, (i >> 8) & 0xff, i & 0xff)
	  }

	  function RippleWallet(secret){
	    this.secret = secret;

	    if (!this.secret) {
	      throw "Invalid secret."
	    }
	  }

	  RippleWallet.prototype = {

	    getPrivateKey: function(secret){
	      var self = this;
	      return base58.decode_base_check(33, self.secret);
	    },

	    getPrivateGenerator: function(privateKey){
	      var i = 0;
	      do {
	        // Compute the hash of the 128-bit privateKey and the sequenceuence number
	        privateGenerator = sjcl.bn.fromBits(firstHalfOfSHA512(append_int(privateKey, i)));
	        i++;
	        // If the hash is equal to or greater than the SECp256k1 order, increment sequenceuence and try agin
	      } while (!sjcl.ecc.curves.c256.r.greaterEquals(privateGenerator));
	      return privateGenerator; 
	    },

	    getPublicGenerator: function (){
	      var privateKey = this.getPrivateKey(this.secret);
	      var privateGenerator = this.getPrivateGenerator(privateKey);
	      return PublicGenerator.fromPrivateGenerator(privateGenerator);
	    },

	    getPublicKey: function(publicGenerator){
	      var sec;
	      var i = 0;
	      do {
	        // Compute the hash of the public generator with the sub-sequence number
	        sec = sjcl.bn.fromBits(firstHalfOfSHA512(append_int(append_int(publicGenerator.toBytesCompressed(), 0), i)));
	        i++;
	        // If the hash is equal to or greater than the SECp256k1 order, increment the sequenceuence and retry
	      } while (!sjcl.ecc.curves.c256.r.greaterEquals(sec));
	      // Treating this hash as a private key, compute the corresponding public key as an EC point. 
	      return sjcl.ecc.curves.c256.G.mult(sec).toJac().add(publicGenerator).toAffine();
	    },

	    getAddress: function(){
	      var privateKey = this.getPrivateKey(this.secret);
	      var privateGenerator = this.getPrivateGenerator(privateKey);
	      var publicGenerator = PublicGenerator.fromPrivateGenerator(privateGenerator).value;
	      var publicKey = this.getPublicKey(publicGenerator);
	      return RippleAddress.fromPublicKey(publicKey);
	    }
	  }

	  RippleWallet.getRandom = function(){
	    var secretKey = MasterKey.getRandom().value;
	    return new RippleWallet(secretKey);
	  };

	  RippleWallet.generate = function() {
	    /* Generate a 128-bit master key that can be used to make 
	       any number of private / public key pairs and accounts
	    */
	    var secretKey = MasterKey.getRandom().value;
	    var wallet = new RippleWallet(secretKey);
	    return {
	      address: wallet.getAddress().value,
	      secret: secretKey 
	    };
	  };

	  return RippleWallet;
	};


/***/ },
/* 28 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = { "default": __webpack_require__(69), __esModule: true };

/***/ },
/* 29 */
/***/ function(module, exports, __webpack_require__) {

	// Routines for working with an orderbook.
	//
	// One OrderBook object represents one half of an order book. (i.e. bids OR
	// asks) Which one depends on the ordering of the parameters.
	//
	// Events:
	//  - model
	//  - trade
	//  - transaction

	'use strict';

	var _Object$keys = __webpack_require__(28)['default'];

	var _ = __webpack_require__(42);
	var util = __webpack_require__(41);
	var extend = __webpack_require__(39);
	var assert = __webpack_require__(38);
	var async = __webpack_require__(51);
	var EventEmitter = __webpack_require__(40).EventEmitter;
	var Amount = __webpack_require__(3).Amount;
	var UInt160 = __webpack_require__(9).UInt160;
	var Currency = __webpack_require__(6).Currency;
	var AutobridgeCalculator = __webpack_require__(53);
	var OrderBookUtils = __webpack_require__(54);
	var log = __webpack_require__(23).internal.sub('orderbook');

	function assertValidNumber(number, message) {
	  assert(!_.isNull(number) && !isNaN(number), message);
	}

	/**
	 * @constructor OrderBook
	 * @param {Remote} remote
	 * @param {String} ask currency
	 * @param {String} ask issuer
	 * @param {String} bid currency
	 * @param {String} bid issuer
	 * @param {String} orderbook key
	 */

	function OrderBook(remote, currencyGets, issuerGets, currencyPays, issuerPays, key) {
	  EventEmitter.call(this);

	  var self = this;

	  this._remote = remote;
	  this._currencyGets = Currency.from_json(currencyGets);
	  this._issuerGets = issuerGets;
	  this._currencyPays = Currency.from_json(currencyPays);
	  this._issuerPays = issuerPays;
	  this._key = key;
	  this._subscribed = false;
	  this._shouldSubscribe = true;
	  this._listeners = 0;
	  this._offers = [];
	  this._offersAutobridged = [];
	  this._mergedOffers = [];
	  this._offerCounts = {};
	  this._ownerFundsUnadjusted = {};
	  this._ownerFunds = {};
	  this._ownerOffersTotal = {};

	  // We consider ourselves synchronized if we have a current
	  // copy of the offers, we are online and subscribed to updates
	  this._synchronized = false;

	  // Transfer rate of the taker gets currency issuer
	  this._issuerTransferRate = null;

	  // When orderbook is IOU/IOU, there will be IOU/XRP and XRP/IOU
	  // books that we must keep track of to compute autobridged offers
	  this._legOneBook = null;
	  this._legTwoBook = null;

	  this._isAutobridgeable = !this._currencyGets.is_native() && !this._currencyPays.is_native();

	  function computeAutobridgedOffersWrapper() {
	    self.computeAutobridgedOffers();
	    self.mergeDirectAndAutobridgedBooks();
	  }

	  if (this._isAutobridgeable) {
	    this._legOneBook = remote.createOrderBook({
	      currency_gets: 'XRP',
	      currency_pays: currencyPays,
	      issuer_pays: issuerPays
	    });

	    this._legOneBook.on('model', computeAutobridgedOffersWrapper);

	    this._legTwoBook = remote.createOrderBook({
	      currency_gets: currencyGets,
	      issuer_gets: issuerGets,
	      currency_pays: 'XRP'
	    });

	    this._legTwoBook.on('model', computeAutobridgedOffersWrapper);
	  }

	  function listenersModified(action, event) {
	    // Automatically subscribe and unsubscribe to orderbook
	    // on the basis of existing event listeners
	    if (_.contains(OrderBook.EVENTS, event)) {
	      switch (action) {
	        case 'add':
	          if (++self._listeners === 1) {
	            self.subscribe();
	          }
	          break;
	        case 'remove':
	          if (--self._listeners === 0) {
	            self.unsubscribe();
	          }
	          break;
	      }
	    }
	  }

	  function updateFundedAmountsWrapper(transaction) {
	    self.updateFundedAmounts(transaction);
	  }

	  this.on('newListener', function (event) {
	    listenersModified('add', event);
	  });

	  this.on('removeListener', function (event) {
	    listenersModified('remove', event);
	  });

	  this._remote.on('transaction', updateFundedAmountsWrapper);

	  this.on('unsubscribe', function () {
	    self.resetCache();

	    self._remote.removeListener('transaction', updateFundedAmountsWrapper);
	  });

	  this._remote.once('prepare_subscribe', function () {
	    self.subscribe();
	  });

	  this._remote.on('disconnect', function () {
	    self.resetCache();
	    self._remote.once('prepare_subscribe', function () {
	      self.subscribe();
	    });
	  });

	  return this;
	}

	util.inherits(OrderBook, EventEmitter);

	/**
	 * Events emitted from OrderBook
	 */

	OrderBook.EVENTS = ['transaction', 'model', 'trade', 'offer_added', 'offer_removed', 'offer_changed', 'offer_funds_changed'];

	OrderBook.DEFAULT_TRANSFER_RATE = 1000000000;

	/**
	 * Normalize offers from book_offers and transaction stream
	 *
	 * @param {Object} offer
	 * @return {Object} normalized
	 */

	OrderBook.offerRewrite = function (offer) {
	  var result = {};
	  var keys = _Object$keys(offer);

	  for (var i = 0, l = keys.length; i < l; i++) {
	    var key = keys[i];
	    switch (key) {
	      case 'PreviousTxnID':
	      case 'PreviousTxnLgrSeq':
	        break;
	      default:
	        result[key] = offer[key];
	    }
	  }

	  result.Flags = result.Flags || 0;
	  result.OwnerNode = result.OwnerNode || new Array(16 + 1).join('0');
	  result.BookNode = result.BookNode || new Array(16 + 1).join('0');

	  return result;
	};

	/**
	 * Initialize orderbook. Get orderbook offers and subscribe to transactions
	 */

	OrderBook.prototype.subscribe = function () {
	  var self = this;

	  if (!this._shouldSubscribe) {
	    return;
	  }

	  if (this._remote.trace) {
	    log.info('subscribing', this._key);
	  }

	  var steps = [function (callback) {
	    self.requestTransferRate(callback);
	  }, function (callback) {
	    self.requestOffers(callback);
	  }, function (callback) {
	    self.subscribeTransactions(callback);
	  }];

	  async.series(steps);
	};

	/**
	 * Unhook event listeners and prevent ripple-lib from further work on this
	 * orderbook. There is no more orderbook stream, so "unsubscribe" is nominal
	 */

	OrderBook.prototype.unsubscribe = function () {
	  var self = this;

	  if (this._remote.trace) {
	    log.info('unsubscribing', this._key);
	  }

	  this._subscribed = false;
	  this._shouldSubscribe = false;

	  OrderBook.EVENTS.forEach(function (event) {
	    if (self.listeners(event).length > 0) {
	      self.removeAllListeners(event);
	    }
	  });

	  this.emit('unsubscribe');
	};

	/**
	 * Request orderbook entries from server
	 *
	 * @param {Function} callback
	 */

	OrderBook.prototype.requestOffers = function (callback) {
	  var self = this;

	  if (!this._shouldSubscribe) {
	    return callback(new Error('Should not request offers'));
	  }

	  if (this._remote.trace) {
	    log.info('requesting offers', this._key);
	  }

	  function handleOffers(res) {
	    if (!Array.isArray(res.offers)) {
	      // XXX What now?
	      return callback(new Error('Invalid response'));
	    }

	    if (self._remote.trace) {
	      log.info('requested offers', self._key, 'offers: ' + res.offers.length);
	    }

	    self.setOffers(res.offers);
	    self._synchronized = true;
	    self.notifyDirectOffersChanged();

	    callback(null, self._offers);
	  }

	  function handleError(err) {
	    // XXX What now?
	    if (self._remote.trace) {
	      log.info('failed to request offers', self._key, err);
	    }

	    callback(err);
	  }

	  var request = this._remote.requestBookOffers(this.toJSON());
	  request.once('success', handleOffers);
	  request.once('error', handleError);
	  request.request();

	  return request;
	};

	/**
	 * Request transfer rate for this orderbook's issuer
	 *
	 * @param {Function} callback
	 */

	OrderBook.prototype.requestTransferRate = function (callback) {
	  assert.strictEqual(typeof callback, 'function');

	  var self = this;

	  if (this._currencyGets.is_native()) {
	    // Transfer rate is default for the native currency
	    this._issuerTransferRate = OrderBook.DEFAULT_TRANSFER_RATE;

	    return callback(null, OrderBook.DEFAULT_TRANSFER_RATE);
	  }

	  if (this._issuerTransferRate) {
	    // Transfer rate has already been cached
	    return callback(null, this._issuerTransferRate);
	  }

	  function handleAccountInfo(err, info) {
	    if (err) {
	      return callback(err);
	    }

	    // When transfer rate is not explicitly set on account, it implies the
	    // default transfer rate
	    self._issuerTransferRate = info.account_data.TransferRate || OrderBook.DEFAULT_TRANSFER_RATE;

	    callback(null, self._issuerTransferRate);
	  }

	  this._remote.requestAccountInfo({ account: this._issuerGets }, handleAccountInfo);
	};

	/**
	 * Subscribe to transactions stream
	 *
	 * @param {Function} callback
	 */

	OrderBook.prototype.subscribeTransactions = function (callback) {
	  var self = this;

	  if (!this._shouldSubscribe) {
	    return callback('Should not subscribe');
	  }

	  if (this._remote.trace) {
	    log.info('subscribing to transactions');
	  }

	  function handleSubscribed(res) {
	    if (self._remote.trace) {
	      log.info('subscribed to transactions');
	    }

	    self._subscribed = true;

	    callback(null, res);
	  }

	  function handleError(err) {
	    if (self._remote.trace) {
	      log.info('failed to subscribe to transactions', self._key, err);
	    }

	    callback(err);
	  }

	  var request = this._remote.requestSubscribe();
	  request.addStream('transactions');
	  request.once('success', handleSubscribed);
	  request.once('error', handleError);
	  request.request();

	  return request;
	};

	/**
	 * Handles notifying listeners that direct offers have changed. For autobridged
	 * books, an additional merge step is also performed
	 */

	OrderBook.prototype.notifyDirectOffersChanged = function () {
	  if (this._isAutobridgeable) {
	    this.mergeDirectAndAutobridgedBooks();
	  } else {
	    this.emit('model', this._offers);
	  }
	};

	/**
	 * Reset cached owner's funds, offer counts, and offer sums
	 */

	OrderBook.prototype.resetCache = function () {
	  this._ownerFunds = {};
	  this._ownerOffersTotal = {};
	  this._offerCounts = {};
	  this._synchronized = false;
	};

	/**
	 * Check whether owner's funds have been cached
	 *
	 * @param {String} account - owner's account address
	 */

	OrderBook.prototype.hasOwnerFunds = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  return this._ownerFunds[account] !== undefined;
	};

	/**
	 * Set owner's, transfer rate adjusted, funds in cache
	 *
	 * @param {String} account - owner's account address
	 * @param {String} fundedAmount
	 */

	OrderBook.prototype.setOwnerFunds = function (account, fundedAmount) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  assert(!isNaN(fundedAmount), 'Funded amount is invalid');

	  this._ownerFundsUnadjusted[account] = fundedAmount;
	  this._ownerFunds[account] = this.applyTransferRate(fundedAmount);
	};

	/**
	 * Compute adjusted balance that would be left after issuer's transfer fee is
	 * deducted
	 *
	 * @param {String} balance
	 * @return {String}
	 */

	OrderBook.prototype.applyTransferRate = function (balance) {
	  assert(!isNaN(balance), 'Balance is invalid');
	  assertValidNumber(this._issuerTransferRate, 'Transfer rate is invalid');

	  var adjustedBalance = OrderBookUtils.normalizeAmount(balance).divide(this._issuerTransferRate).multiply(Amount.from_json(OrderBook.DEFAULT_TRANSFER_RATE)).to_json().value;

	  return adjustedBalance;
	};

	/**
	 * Get owner's cached, transfer rate adjusted, funds
	 *
	 * @param {String} account - owner's account address
	 * @return {Amount}
	 */

	OrderBook.prototype.getOwnerFunds = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  if (this.hasOwnerFunds(account)) {
	    if (this._currencyGets.is_native()) {
	      return Amount.from_json(this._ownerFunds[account]);
	    }
	    return OrderBookUtils.normalizeAmount(this._ownerFunds[account]);
	  }
	};

	/**
	 * Get owner's cached unadjusted funds
	 *
	 * @param {String} account - owner's account address
	 * @return {String}
	 */

	OrderBook.prototype.getUnadjustedOwnerFunds = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  return this._ownerFundsUnadjusted[account];
	};

	/**
	 * Remove cached owner's funds
	 *
	 * @param {String} account - owner's account address
	 */

	OrderBook.prototype.deleteOwnerFunds = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  this._ownerFunds[account] = undefined;
	};

	/**
	 * Get offer count for owner
	 *
	 * @param {String} account - owner's account address
	 * @return {Number}
	 */

	OrderBook.prototype.getOwnerOfferCount = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  return this._offerCounts[account] || 0;
	};

	/**
	 * Increment offer count for owner
	 *
	 * @param {String} account - owner's account address
	 * @return {Number}
	 */

	OrderBook.prototype.incrementOwnerOfferCount = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  var result = (this._offerCounts[account] || 0) + 1;
	  this._offerCounts[account] = result;
	  return result;
	};

	/**
	 * Decrement offer count for owner
	 * When an account has no more orders, we also stop tracking their account funds
	 *
	 * @param {String} account - owner's account address
	 * @return {Number}
	 */

	OrderBook.prototype.decrementOwnerOfferCount = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  var result = (this._offerCounts[account] || 1) - 1;
	  this._offerCounts[account] = result;

	  if (result < 1) {
	    this.deleteOwnerFunds(account);
	  }

	  return result;
	};

	/**
	 * Add amount sum being offered for owner
	 *
	 * @param {String} account - owner's account address
	 * @param {Object|String} amount - offer amount as native string or IOU
	 *                                 currency format
	 * @return {Amount}
	 */

	OrderBook.prototype.addOwnerOfferTotal = function (account, amount) {
	  assert(UInt160.is_valid(account), 'Account is invalid');

	  var previousAmount = this.getOwnerOfferTotal(account);
	  var currentAmount = previousAmount.add(Amount.from_json(amount));

	  this._ownerOffersTotal[account] = currentAmount;

	  return currentAmount;
	};

	/**
	 * Subtract amount sum being offered for owner
	 *
	 * @param {String} account - owner's account address
	 * @param {Object|String} amount - offer amount as native string or IOU
	 *                                 currency format
	 * @return {Amount}
	 */

	OrderBook.prototype.subtractOwnerOfferTotal = function (account, amount) {
	  assert(UInt160.is_valid(account), 'Account is invalid');

	  var previousAmount = this.getOwnerOfferTotal(account);
	  var newAmount = previousAmount.subtract(Amount.from_json(amount));
	  this._ownerOffersTotal[account] = newAmount;

	  assert(!newAmount.is_negative(), 'Offer total cannot be negative');

	  return newAmount;
	};

	/**
	 * Get offers amount sum for owner
	 *
	 * @param {String} account - owner's account address
	 * @return {Amount}
	 */

	OrderBook.prototype.getOwnerOfferTotal = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  var amount = this._ownerOffersTotal[account];
	  if (amount) {
	    return amount;
	  }
	  if (this._currencyGets.is_native()) {
	    return Amount.from_json('0');
	  }
	  return OrderBookUtils.normalizeAmount('0');
	};

	/**
	 * Reset offers amount sum for owner to 0
	 *
	 * @param {String} account - owner's account address
	 * @return {Amount}
	 */

	OrderBook.prototype.resetOwnerOfferTotal = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  if (this._currencyGets.is_native()) {
	    this._ownerOffersTotal[account] = Amount.from_json('0');
	  } else {
	    this._ownerOffersTotal[account] = OrderBookUtils.normalizeAmount('0');
	  }
	};

	/**
	 * Set funded amount on offer with its owner's cached funds
	 *
	 * is_fully_funded indicates if these funds are sufficient for the offer placed.
	 * taker_gets_funded indicates the amount this account can afford to offer.
	 * taker_pays_funded indicates adjusted TakerPays for partially funded offer.
	 *
	 * @param {Object} offer
	 * @return offer
	 */

	OrderBook.prototype.setOfferFundedAmount = function (offer) {
	  assert.strictEqual(typeof offer, 'object', 'Offer is invalid');

	  var fundedAmount = this.getOwnerFunds(offer.Account);
	  var previousOfferSum = this.getOwnerOfferTotal(offer.Account);
	  var currentOfferSum = previousOfferSum.add(Amount.from_json(offer.TakerGets));

	  offer.owner_funds = this.getUnadjustedOwnerFunds(offer.Account);

	  offer.is_fully_funded = fundedAmount.compareTo(currentOfferSum) >= 0;

	  if (offer.is_fully_funded) {
	    offer.taker_gets_funded = Amount.from_json(offer.TakerGets).to_text();
	    offer.taker_pays_funded = Amount.from_json(offer.TakerPays).to_text();
	  } else if (previousOfferSum.compareTo(fundedAmount) < 0) {
	    offer.taker_gets_funded = fundedAmount.subtract(previousOfferSum).to_text();

	    var quality = OrderBookUtils.getOfferQuality(offer, this._currencyGets);
	    var takerPaysFunded = quality.multiply(OrderBookUtils.getOfferTakerGetsFunded(offer));

	    offer.taker_pays_funded = this._currencyPays.is_native() ? String(Math.floor(takerPaysFunded.to_number())) : takerPaysFunded.to_json().value;
	  } else {
	    offer.taker_gets_funded = '0';
	    offer.taker_pays_funded = '0';
	  }

	  return offer;
	};

	/**
	 * Get account and final balance of a meta node
	 *
	 * @param {Object} node - RippleState or AccountRoot meta node
	 * @return {Object}
	 */

	OrderBook.prototype.parseAccountBalanceFromNode = function (node) {
	  var result = {
	    account: undefined,
	    balance: undefined
	  };

	  switch (node.entryType) {
	    case 'AccountRoot':
	      result.account = node.fields.Account;
	      result.balance = node.fieldsFinal.Balance;
	      break;

	    case 'RippleState':
	      if (node.fields.HighLimit.issuer === this._issuerGets) {
	        result.account = node.fields.LowLimit.issuer;
	        result.balance = node.fieldsFinal.Balance.value;
	      } else if (node.fields.LowLimit.issuer === this._issuerGets) {
	        result.account = node.fields.HighLimit.issuer;

	        // Negate balance on the trust line
	        result.balance = Amount.from_json(node.fieldsFinal.Balance).negate().to_json().value;
	      }
	      break;
	  }

	  assert(!isNaN(result.balance), 'node has an invalid balance');
	  assert(UInt160.is_valid(result.account), 'node has an invalid account');

	  return result;
	};

	/**
	 * Check that affected meta node represents a balance change
	 *
	 * @param {Object} node - RippleState or AccountRoot meta node
	 * @return {Boolean}
	 */

	OrderBook.prototype.isBalanceChangeNode = function (node) {
	  // Check meta node has balance, previous balance, and final balance
	  if (!(node.fields && node.fields.Balance && node.fieldsPrev && node.fieldsFinal && node.fieldsPrev.Balance && node.fieldsFinal.Balance)) {
	    return false;
	  }

	  // Check if taker gets currency is native and balance is not a number
	  if (this._currencyGets.is_native()) {
	    return !isNaN(node.fields.Balance);
	  }

	  // Check if balance change is not for taker gets currency
	  if (node.fields.Balance.currency !== this._currencyGets.to_json()) {
	    return false;
	  }

	  // Check if trustline does not refer to the taker gets currency issuer
	  if (!(node.fields.HighLimit.issuer === this._issuerGets || node.fields.LowLimit.issuer === this._issuerGets)) {
	    return false;
	  }

	  return true;
	};

	/**
	 * Updates funded amounts/balances using modified balance nodes
	 *
	 * Update owner funds using modified AccountRoot and RippleState nodes
	 * Update funded amounts for offers in the orderbook using owner funds
	 *
	 * @param {Object} transaction - transaction that holds meta nodes
	 */

	OrderBook.prototype.updateFundedAmounts = function (transaction) {
	  var self = this;

	  if (!this._currencyGets.is_native() && !this._issuerTransferRate) {
	    if (this._remote.trace) {
	      log.info('waiting for transfer rate');
	    }

	    this.requestTransferRate(function () {
	      // Defer until transfer rate is requested
	      self.updateFundedAmounts(transaction);
	    });
	    return;
	  }

	  var affectedNodes = transaction.mmeta.getNodes({
	    nodeType: 'ModifiedNode',
	    entryType: this._currencyGets.is_native() ? 'AccountRoot' : 'RippleState'
	  });

	  _.each(affectedNodes, function (node) {
	    if (self.isBalanceChangeNode(node)) {
	      var result = self.parseAccountBalanceFromNode(node);

	      if (self.hasOwnerFunds(result.account)) {
	        // We are only updating owner funds that are already cached
	        self.setOwnerFunds(result.account, result.balance);

	        self.updateOwnerOffersFundedAmount(result.account);
	      }
	    }
	  });
	};

	/**
	 * Update offers' funded amount with their owner's funds
	 *
	 * @param {String} account - owner's account address
	 */

	OrderBook.prototype.updateOwnerOffersFundedAmount = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');

	  var self = this;

	  if (this._remote.trace) {
	    var ownerFunds = this.getOwnerFunds(account);
	    log.info('updating offer funds', this._key, account, ownerFunds ? ownerFunds.to_text() : 'undefined');
	  }

	  this.resetOwnerOfferTotal(account);

	  _.each(this._offers, function (offer) {
	    if (offer.Account !== account) {
	      return;
	    }

	    // Save a copy of the old offer so we can show how the offer has changed
	    var previousOffer = extend({}, offer);
	    var previousFundedGets = undefined;

	    if (_.isString(offer.taker_gets_funded)) {
	      // Offer is not new, so we should consider it for offer_changed and
	      // offer_funds_changed events
	      previousFundedGets = OrderBookUtils.getOfferTakerGetsFunded(offer);
	    }

	    self.setOfferFundedAmount(offer);
	    self.addOwnerOfferTotal(offer.Account, offer.TakerGets);

	    var takerGetsFunded = OrderBookUtils.getOfferTakerGetsFunded(offer);
	    var areFundsChanged = previousFundedGets && !takerGetsFunded.equals(previousFundedGets);

	    if (areFundsChanged) {
	      self.emit('offer_changed', previousOffer, offer);
	      self.emit('offer_funds_changed', offer, previousOffer.taker_gets_funded, offer.taker_gets_funded);
	    }
	  });
	};

	/**
	 * Notify orderbook of a relevant transaction
	 *
	 * @param {Object} transaction
	 * @api private
	 */

	OrderBook.prototype.notify = function (transaction) {
	  var self = this;

	  if (!this._subscribed) {
	    return;
	  }

	  if (this._remote.trace) {
	    log.info('notifying', this._key, transaction.transaction.hash);
	  }

	  var affectedNodes = transaction.mmeta.getNodes({
	    entryType: 'Offer',
	    bookKey: this._key
	  });

	  if (affectedNodes.length < 1) {
	    return;
	  }

	  var takerGetsTotal = Amount.from_json('0' + (Currency.from_json(this._currencyGets).is_native() ? '' : '/' + this._currencyGets.to_human() + '/' + this._issuerGets));

	  var takerPaysTotal = Amount.from_json('0' + (Currency.from_json(this._currencyPays).is_native() ? '' : '/' + this._currencyPays.to_human() + '/' + this._issuerPays));

	  var isOfferCancel = transaction.transaction.TransactionType === 'OfferCancel';
	  var transactionOwnerFunds = transaction.transaction.owner_funds;

	  function handleNode(node) {
	    switch (node.nodeType) {
	      case 'DeletedNode':
	        self.deleteOffer(node, isOfferCancel);

	        // We don't want to count an OfferCancel as a trade
	        if (!isOfferCancel) {
	          takerGetsTotal = takerGetsTotal.add(node.fieldsFinal.TakerGets);
	          takerPaysTotal = takerPaysTotal.add(node.fieldsFinal.TakerPays);
	        }
	        break;

	      case 'ModifiedNode':
	        self.modifyOffer(node);

	        takerGetsTotal = takerGetsTotal.add(node.fieldsPrev.TakerGets).subtract(node.fieldsFinal.TakerGets);

	        takerPaysTotal = takerPaysTotal.add(node.fieldsPrev.TakerPays).subtract(node.fieldsFinal.TakerPays);
	        break;

	      case 'CreatedNode':
	        // rippled does not set owner_funds if the order maker is the issuer
	        // because the value would be infinite
	        var fundedAmount = transactionOwnerFunds !== undefined ? transactionOwnerFunds : Infinity;
	        self.setOwnerFunds(node.fields.Account, fundedAmount);
	        self.insertOffer(node);
	        break;
	    }
	  }

	  _.each(affectedNodes, handleNode);

	  this.emit('transaction', transaction);
	  this.notifyDirectOffersChanged();
	  if (!takerGetsTotal.is_zero()) {
	    this.emit('trade', takerPaysTotal, takerGetsTotal);
	  }
	};

	/**
	 * Insert an offer into the orderbook
	 *
	 * NOTE: We *MUST* update offers' funded amounts when a new offer is placed
	 *       because funds go to the highest quality offers first.
	 *
	 * @param {Object} node - Offer node
	 */

	OrderBook.prototype.insertOffer = function (node) {
	  if (this._remote.trace) {
	    log.info('inserting offer', this._key, node.fields);
	  }

	  var offer = OrderBook.offerRewrite(node.fields);
	  var takerGets = this.normalizeAmount(this._currencyGets, offer.TakerGets);
	  var takerPays = this.normalizeAmount(this._currencyPays, offer.TakerPays);

	  offer.LedgerEntryType = node.entryType;
	  offer.index = node.ledgerIndex;

	  // We're safe to calculate quality for newly created offers
	  offer.quality = takerPays.divide(takerGets).to_text();

	  var originalLength = this._offers.length;

	  for (var i = 0; i < originalLength; i++) {
	    var quality = OrderBookUtils.getOfferQuality(offer, this._currencyGets);
	    var existingOfferQuality = OrderBookUtils.getOfferQuality(this._offers[i], this._currencyGets);

	    if (quality.compareTo(existingOfferQuality) <= 0) {
	      this._offers.splice(i, 0, offer);

	      break;
	    }
	  }

	  if (this._offers.length === originalLength) {
	    this._offers.push(offer);
	  }

	  this.incrementOwnerOfferCount(offer.Account);

	  this.updateOwnerOffersFundedAmount(offer.Account);

	  this.emit('offer_added', offer);
	};

	/**
	 * Convert any amount into default IOU
	 *
	 * NOTE: This is necessary in some places because Amount.js arithmetic
	 * does not deal with native and non-native amounts well.
	 *
	 * @param {Currency} currency
	 * @param {Object} amountObj
	 */

	OrderBook.prototype.normalizeAmount = function (currency, amountObj) {
	  var value = currency.is_native() ? amountObj : amountObj.value;

	  return OrderBookUtils.normalizeAmount(value);
	};

	/**
	 * Modify an existing offer in the orderbook
	 *
	 * @param {Object} node - Offer node
	 */

	OrderBook.prototype.modifyOffer = function (node) {
	  if (this._remote.trace) {
	    log.info('modifying offer', this._key, node.fields);
	  }

	  for (var i = 0; i < this._offers.length; i++) {
	    var offer = this._offers[i];

	    if (offer.index === node.ledgerIndex) {
	      // TODO: This assumes no fields are deleted, which is
	      // probably a safe assumption, but should be checked.
	      extend(offer, node.fieldsFinal);

	      break;
	    }
	  }

	  this.updateOwnerOffersFundedAmount(node.fields.Account);
	};

	/**
	 * Delete an existing offer in the orderbook
	 *
	 * NOTE: We only update funded amounts when the node comes from an OfferCancel
	 *       transaction because when offers are deleted, it frees up funds to fund
	 *       other existing offers in the book
	 *
	 * @param {Object} node - Offer node
	 * @param {Boolean} isOfferCancel - whether node came from an OfferCancel
	 */

	OrderBook.prototype.deleteOffer = function (node, isOfferCancel) {
	  if (this._remote.trace) {
	    log.info('deleting offer', this._key, node.fields);
	  }

	  for (var i = 0; i < this._offers.length; i++) {
	    var offer = this._offers[i];

	    if (offer.index === node.ledgerIndex) {
	      // Remove offer amount from sum for account
	      this.subtractOwnerOfferTotal(offer.Account, offer.TakerGets);

	      this._offers.splice(i, 1);
	      this.decrementOwnerOfferCount(offer.Account);

	      this.emit('offer_removed', offer);

	      break;
	    }
	  }

	  if (isOfferCancel) {
	    this.updateOwnerOffersFundedAmount(node.fields.Account);
	  }
	};

	/**
	 * Reset internal offers cache from book_offers request
	 *
	 * @param {Array} offers
	 * @api private
	 */

	OrderBook.prototype.setOffers = function (offers) {
	  assert(Array.isArray(offers), 'Offers is not an array');

	  var self = this;

	  this.resetCache();

	  var newOffers = _.map(offers, function (rawOffer) {
	    var offer = OrderBook.offerRewrite(rawOffer);

	    if (offer.hasOwnProperty('owner_funds')) {
	      // The first offer of each owner from book_offers contains owner balance
	      // of offer's output
	      self.setOwnerFunds(offer.Account, offer.owner_funds);
	    }

	    self.incrementOwnerOfferCount(offer.Account);

	    self.setOfferFundedAmount(offer);
	    self.addOwnerOfferTotal(offer.Account, offer.TakerGets);

	    return offer;
	  });

	  this._offers = newOffers;
	};

	/**
	 * Get offers model asynchronously
	 *
	 * This function takes a callback and calls it with an array containing the
	 * current set of offers in this order book.
	 *
	 * If the data is available immediately, the callback may be called
	 * synchronously
	 *
	 * @param {Function} callback
	 */

	OrderBook.prototype.offers = OrderBook.prototype.getOffers = function (callback) {
	  assert.strictEqual(typeof callback, 'function', 'Callback missing');

	  if (this._synchronized) {
	    callback(null, this._offers);
	  } else {
	    this.once('model', function (m) {
	      callback(null, m);
	    });
	  }

	  return this;
	};

	/**
	 * Return latest known offers
	 *
	 * Usually, this will just be an empty array if the order book hasn't been
	 * loaded yet. But this accessor may be convenient in some circumstances.
	 *
	 * @return {Array} offers
	 */

	OrderBook.prototype.offersSync = OrderBook.prototype.getOffersSync = function () {
	  return this._offers;
	};

	/**
	 * Get request-representation of orderbook
	 *
	 * @return {Object} json
	 */

	OrderBook.prototype.toJSON = OrderBook.prototype.to_json = function () {
	  var json = {
	    taker_gets: {
	      currency: this._currencyGets.to_hex()
	    },
	    taker_pays: {
	      currency: this._currencyPays.to_hex()
	    }
	  };

	  if (!this._currencyGets.is_native()) {
	    json.taker_gets.issuer = this._issuerGets;
	  }

	  if (!this._currencyPays.is_native()) {
	    json.taker_pays.issuer = this._issuerPays;
	  }

	  return json;
	};

	/**
	 * Whether the OrderBook is valid
	 *
	 * Note: This only checks whether the parameters (currencies and issuer) are
	 *       syntactically valid. It does not check anything against the ledger.
	 *
	 * @return {Boolean} is valid
	 */

	OrderBook.prototype.isValid = OrderBook.prototype.is_valid = function () {
	  // XXX Should check for same currency (non-native) && same issuer
	  return this._currencyPays && this._currencyPays.is_valid() && (this._currencyPays.is_native() || UInt160.is_valid(this._issuerPays)) && this._currencyGets && this._currencyGets.is_valid() && (this._currencyGets.is_native() || UInt160.is_valid(this._issuerGets)) && !(this._currencyPays.is_native() && this._currencyGets.is_native());
	};

	/**
	 * Compute autobridged offers for an IOU:IOU orderbook by merging offers from
	 * IOU:XRP and XRP:IOU books
	 */

	OrderBook.prototype.computeAutobridgedOffers = function () {
	  assert(!this._currencyGets.is_native() && !this._currencyPays.is_native(), 'Autobridging is only for IOU:IOU orderbooks');

	  var autobridgeCalculator = new AutobridgeCalculator(this._currencyGets, this._currencyPays, this._legOneBook.getOffersSync(), this._legTwoBook.getOffersSync(), this._issuerGets, this._issuerPays);

	  this._offersAutobridged = autobridgeCalculator.calculate();
	};

	/**
	 * Merge direct and autobridged offers into a combined orderbook
	 *
	 * @return [Array]
	 */

	OrderBook.prototype.mergeDirectAndAutobridgedBooks = function () {
	  var self = this;

	  if (_.isEmpty(this._offers) && _.isEmpty(this._offersAutobridged)) {
	    return;
	  }

	  this._mergedOffers = this._offers.concat(this._offersAutobridged).sort(function (a, b) {
	    var aQuality = OrderBookUtils.getOfferQuality(a, self._currencyGets);
	    var bQuality = OrderBookUtils.getOfferQuality(b, self._currencyGets);

	    return aQuality.compareTo(bQuality);
	  });

	  this.emit('model', this._mergedOffers);
	};

	exports.OrderBook = OrderBook;

/***/ },
/* 30 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Prefix for hashing functions.
	 *
	 * These prefixes are inserted before the source material used to
	 * generate various hashes. This is done to put each hash in its own
	 * "space." This way, two different types of objects with the
	 * same binary data will produce different hashes.
	 *
	 * Each prefix is a 4-byte value with the last byte set to zero
	 * and the first three bytes formed from the ASCII equivalent of
	 * some arbitrary string. For example "TXN".
	 */

	// transaction plus signature to give transaction ID
	"use strict";

	exports.HASH_TX_ID = 0x54584E00; // 'TXN'
	// transaction plus metadata
	exports.HASH_TX_NODE = 0x534E4400; // 'TND'
	// inner node in tree
	exports.HASH_INNER_NODE = 0x4D494E00; // 'MIN'
	// leaf node in tree
	exports.HASH_LEAF_NODE = 0x4D4C4E00; // 'MLN'
	// inner transaction to sign
	exports.HASH_TX_SIGN = 0x53545800; // 'STX'
	// inner transaction to sign (TESTNET)
	exports.HASH_TX_SIGN_TESTNET = 0x73747800; // 'stx'

/***/ },
/* 31 */
/***/ function(module, exports, __webpack_require__) {

	// Convert a JavaScript number to IEEE-754 Double Precision
	// value represented as an array of 8 bytes (octets)
	//
	// Based on:
	// http://cautionsingularityahead.blogspot.com/2010/04/javascript-and-ieee754-redux.html
	//
	// Found and modified from:
	// https://gist.github.com/bartaz/1119041

	'use strict';

	var Float = exports.Float = {};

	Float.toIEEE754 = function (v, ebits, fbits) {

	  var bias = (1 << ebits - 1) - 1;

	  // Compute sign, exponent, fraction
	  var s, e, f;
	  if (isNaN(v)) {
	    e = (1 << bias) - 1;f = 1;s = 0;
	  } else if (v === Infinity || v === -Infinity) {
	    e = (1 << bias) - 1;f = 0;s = v < 0 ? 1 : 0;
	  } else if (v === 0) {
	    e = 0;f = 0;s = 1 / v === -Infinity ? 1 : 0;
	  } else {
	    s = v < 0;
	    v = Math.abs(v);

	    if (v >= Math.pow(2, 1 - bias)) {
	      var ln = Math.min(Math.floor(Math.log(v) / Math.LN2), bias);
	      e = ln + bias;
	      f = v * Math.pow(2, fbits - ln) - Math.pow(2, fbits);
	    } else {
	      e = 0;
	      f = v / Math.pow(2, 1 - bias - fbits);
	    }
	  }

	  // Pack sign, exponent, fraction
	  var i,
	      bits = [];
	  for (i = fbits; i; i -= 1) {
	    bits.push(f % 2 ? 1 : 0);f = Math.floor(f / 2);
	  }
	  for (i = ebits; i; i -= 1) {
	    bits.push(e % 2 ? 1 : 0);e = Math.floor(e / 2);
	  }
	  bits.push(s ? 1 : 0);
	  bits.reverse();
	  var str = bits.join('');

	  // Bits to bytes
	  var bytes = [];
	  while (str.length) {
	    bytes.push(parseInt(str.substring(0, 8), 2));
	    str = str.substring(8);
	  }
	  return bytes;
	};

	Float.fromIEEE754 = function (bytes, ebits, fbits) {

	  // Bytes to bits
	  var bits = [];
	  for (var i = bytes.length; i; i -= 1) {
	    var byte = bytes[i - 1];
	    for (var j = 8; j; j -= 1) {
	      bits.push(byte % 2 ? 1 : 0);byte = byte >> 1;
	    }
	  }
	  bits.reverse();
	  var str = bits.join('');

	  // Unpack sign, exponent, fraction
	  var bias = (1 << ebits - 1) - 1;
	  var s = parseInt(str.substring(0, 1), 2) ? -1 : 1;
	  var e = parseInt(str.substring(1, 1 + ebits), 2);
	  var f = parseInt(str.substring(1 + ebits), 2);

	  // Produce number
	  if (e === (1 << ebits) - 1) {
	    return f !== 0 ? NaN : s * Infinity;
	  } else if (e > 0) {
	    return s * Math.pow(2, e - bias) * (1 + f / Math.pow(2, fbits));
	  } else if (f !== 0) {
	    return s * Math.pow(2, -(bias - 1)) * (f / Math.pow(2, fbits));
	  } else {
	    return s * 0;
	  }
	};

	Float.fromIEEE754Double = function (b) {
	  return Float.fromIEEE754(b, 11, 52);
	};
	Float.toIEEE754Double = function (v) {
	  return Float.toIEEE754(v, 11, 52);
	};
	Float.fromIEEE754Single = function (b) {
	  return Float.fromIEEE754(b, 8, 23);
	};
	Float.toIEEE754Single = function (v) {
	  return Float.toIEEE754(v, 8, 23);
	};

	// Convert array of octets to string binary representation
	// by bartaz

	Float.toIEEE754DoubleString = function (v) {
	  return exports.toIEEE754Double(v).map(function (n) {
	    for (n = n.toString(2); n.length < 8; n = "0" + n);return n;
	  }).join('').replace(/(.)(.{11})(.{52})/, "$1 $2 $3");
	};

/***/ },
/* 32 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	/*eslint new-cap: 1*/

	var utils = __webpack_require__(17);
	var sjcl = utils.sjcl;

	//
	// Abstract UInt class
	//
	// Base class for UInt classes
	//

	function UInt() {
	  // Internal form: NaN or sjcl.bn
	  this._value = NaN;
	  this._update();
	}

	UInt.json_rewrite = function (j, opts) {
	  return this.from_json(j).to_json(opts);
	};

	// Return a new UInt from j.
	UInt.from_generic = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_generic(j);
	};

	// Return a new UInt from j.
	UInt.from_hex = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_hex(j);
	};

	// Return a new UInt from j.
	UInt.from_json = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_json(j);
	};

	// Return a new UInt from j.
	UInt.from_bits = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_bits(j);
	};

	// Return a new UInt from j.
	UInt.from_bytes = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_bytes(j);
	};

	// Return a new UInt from j.
	UInt.from_bn = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_bn(j);
	};

	// Return a new UInt from j.
	UInt.from_number = function (j) {
	  if (j instanceof this) {
	    return j.clone();
	  }
	  return new this().parse_number(j);
	};

	UInt.is_valid = function (j) {
	  return this.from_json(j).is_valid();
	};

	UInt.prototype.clone = function () {
	  return this.copyTo(new this.constructor());
	};

	// Returns copy.
	UInt.prototype.copyTo = function (d) {
	  d._value = this._value;

	  if (this._version_byte !== undefined) {
	    d._version_byte = this._version_byte;
	  }

	  if (typeof d._update === 'function') {
	    d._update();
	  }

	  return d;
	};

	UInt.prototype.equals = function (d) {
	  return this.is_valid() && d.is_valid() && this._value.equals(d._value);
	};

	UInt.prototype.is_valid = function () {
	  return this._value instanceof sjcl.bn;
	};

	UInt.prototype.is_zero = function () {
	  return this.is_valid() && this._value.equals(new sjcl.bn(0));
	};

	/**
	 * Update any derivative values.
	 *
	 * This allows subclasses to maintain caches of any data that they derive from
	 * the main _value. For example, the Currency class keeps the currency type, the
	 * currency code and other information about the currency cached.
	 *
	 * The reason for keeping this mechanism in this class is so every subclass can
	 * call it whenever it modifies the internal state.
	 *
	 * @return {void}
	 */
	UInt.prototype._update = function () {
	  // Nothing to do by default. Subclasses will override this.
	};

	// value = NaN on error.
	UInt.prototype.parse_generic = function (j) {
	  switch (j) {
	    case undefined:
	    case '0':
	    case this.constructor.STR_ZERO:
	    case this.constructor.ACCOUNT_ZERO:
	    case this.constructor.HEX_ZERO:
	      this._value = new sjcl.bn(0);
	      break;

	    case '1':
	    case this.constructor.STR_ONE:
	    case this.constructor.ACCOUNT_ONE:
	    case this.constructor.HEX_ONE:
	      this._value = new sjcl.bn(1);
	      break;

	    default:
	      if (typeof j !== 'string') {
	        this._value = NaN;
	      } else if (this.constructor.width === j.length) {
	        var hex = utils.arrayToHex(utils.stringToArray(j));
	        this._value = new sjcl.bn(hex, 16);
	      } else if (this.constructor.width * 2 === j.length) {
	        // XXX Check char set!
	        this._value = new sjcl.bn(j, 16);
	      } else {
	        this._value = NaN;
	      }
	  }

	  this._update();

	  return this;
	};

	UInt.prototype.parse_hex = function (j) {
	  if (typeof j === 'string' && j.length === this.constructor.width * 2) {
	    this._value = new sjcl.bn(j, 16);
	  } else {
	    this._value = NaN;
	  }

	  this._update();

	  return this;
	};

	UInt.prototype.parse_bits = function (j) {
	  if (sjcl.bitArray.bitLength(j) !== this.constructor.width * 8) {
	    this._value = NaN;
	  } else {
	    this._value = sjcl.bn.fromBits(j);
	    // var bytes = sjcl.codec.bytes.fromBits(j);
	    // this.parse_bytes(bytes);
	  }

	  this._update();

	  return this;
	};

	UInt.prototype.parse_bytes = function (j) {
	  if (!Array.isArray(j) || j.length !== this.constructor.width) {
	    this._value = NaN;
	  } else {
	    var bits = sjcl.codec.bytes.toBits(j);
	    this._value = sjcl.bn.fromBits(bits);
	  }

	  this._update();

	  return this;
	};

	UInt.prototype.parse_json = UInt.prototype.parse_hex;

	UInt.prototype.parse_bn = function (j) {
	  if (j instanceof sjcl.bn && j.bitLength() <= this.constructor.width * 8) {
	    this._value = new sjcl.bn(j);
	  } else {
	    this._value = NaN;
	  }

	  this._update();

	  return this;
	};

	UInt.prototype.parse_number = function (j) {
	  this._value = NaN;

	  if (typeof j === 'number' && isFinite(j) && j >= 0) {
	    this._value = new sjcl.bn(j);
	  }

	  this._update();

	  return this;
	};

	// Convert from internal form.
	UInt.prototype.to_bytes = function () {
	  if (!this.is_valid()) {
	    return null;
	  }
	  return sjcl.codec.bytes.fromBits(this.to_bits());
	};

	UInt.prototype.to_hex = function () {
	  if (!this.is_valid()) {
	    return null;
	  }
	  return sjcl.codec.hex.fromBits(this.to_bits()).toUpperCase();
	};

	UInt.prototype.to_json = UInt.prototype.to_hex;

	UInt.prototype.to_bits = function () {
	  if (!this.is_valid()) {
	    return null;
	  }

	  return this._value.toBits(this.constructor.width * 8);
	};

	UInt.prototype.to_bn = function () {
	  if (!this.is_valid()) {
	    return null;
	  }

	  var bits = this.to_bits();

	  return sjcl.bn.fromBits(bits);
	};

	exports.UInt = UInt;

	// vim:sw=2:sts=2:ts=8:et

/***/ },
/* 33 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	/*eslint new-cap: 1*/

	var sjcl = __webpack_require__(17).sjcl;

	var UInt160 = __webpack_require__(9).UInt160;
	var UInt256 = __webpack_require__(10).UInt256;
	var Base = __webpack_require__(7).Base;

	function KeyPair() {
	  this._curve = sjcl.ecc.curves.k256;
	  this._secret = null;
	  this._pubkey = null;
	}

	KeyPair.from_bn_secret = function (j) {
	  return j instanceof this ? j.clone() : new this().parse_bn_secret(j);
	};

	KeyPair.prototype.parse_bn_secret = function (j) {
	  this._secret = new sjcl.ecc.ecdsa.secretKey(sjcl.ecc.curves.k256, j);
	  return this;
	};

	/**
	 * @private
	 *
	 * @return {sjcl.ecc.ecdsa.publicKey} public key
	 */
	KeyPair.prototype._pub = function () {
	  var curve = this._curve;

	  if (!this._pubkey && this._secret) {
	    var exponent = this._secret._exponent;

	    this._pubkey = new sjcl.ecc.ecdsa.publicKey(curve, curve.G.mult(exponent));
	  }

	  return this._pubkey;
	};

	/**
	 * @private
	 *
	 * @return {sjcl.bitArray} public key bits in compressed form
	 */
	KeyPair.prototype._pub_bits = function () {
	  var pub = this._pub();

	  if (!pub) {
	    return null;
	  }

	  var point = pub._point,
	      y_even = point.y.mod(2).equals(0);

	  return sjcl.bitArray.concat([sjcl.bitArray.partial(8, y_even ? 0x02 : 0x03)], point.x.toBits(this._curve.r.bitLength()));
	};

	/**
	 * @return {String} public key bytes in compressed form, hex encoded.
	 */
	KeyPair.prototype.to_hex_pub = function () {
	  var bits = this._pub_bits();

	  if (!bits) {
	    return null;
	  }

	  return sjcl.codec.hex.fromBits(bits).toUpperCase();
	};

	function sha256_ripemd160(bits) {
	  return sjcl.hash.ripemd160.hash(sjcl.hash.sha256.hash(bits));
	}

	KeyPair.prototype.get_address = function () {
	  var bits = this._pub_bits();

	  if (!bits) {
	    return null;
	  }

	  var hash = sha256_ripemd160(bits);

	  var address = UInt160.from_bits(hash);
	  address.set_version(Base.VER_ACCOUNT_ID);
	  return address;
	};

	KeyPair.prototype.sign = function (hash) {
	  var PARANOIA_256_BITS = 6; // sjcl constant for ensuring 256 bits of entropy
	  hash = UInt256.from_json(hash);
	  var sig = this._secret.sign(hash.to_bits(), PARANOIA_256_BITS);
	  sig = this._secret.canonicalizeSignature(sig);
	  return this._secret.encodeDER(sig);
	};

	exports.KeyPair = KeyPair;

/***/ },
/* 34 */
/***/ function(module, exports, __webpack_require__) {

	// If there is no WebSocket, try MozWebSocket (support for some old browsers)
	"use strict";

	try {
	  module.exports = WebSocket;
	} catch (err) {
	  module.exports = MozWebSocket;
	}

	// Some versions of Safari Mac 5 and Safari iOS 4 seem to support websockets,
	// but can't communicate with websocketpp, which is what rippled uses.
	//
	// Note that we check for both the WebSocket protocol version the browser seems
	// to implement as well as the user agent etc. The reason is that we want to err
	// on the side of trying to connect since we don't want to accidentally disable
	// a browser that would normally work fine.
	var match,
	    versionRegexp = /Version\/(\d+)\.(\d+)(?:\.(\d+))?.*Safari\//;
	if (
	// Is browser
	"object" === typeof navigator && "string" === typeof navigator.userAgent && (
	// Is Safari
	match = versionRegexp.exec(navigator.userAgent)) &&
	// And uses the old websocket protocol
	2 === window.WebSocket.CLOSED) {
	  // Is iOS
	  if (/iP(hone|od|ad)/.test(navigator.platform)) {
	    // Below version 5 is broken
	    if (+match[1] < 5) {
	      module.exports = void 0;
	    }
	    // Is any other Mac OS
	    // If you want to refactor this code, be careful, iOS user agents contain the
	    // string "like Mac OS X".
	  } else if (navigator.appVersion.indexOf("Mac") !== -1) {
	      // Below version 6 is broken
	      if (+match[1] < 6) {
	        module.exports = void 0;
	      }
	    }
	}

/***/ },
/* 35 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var util = __webpack_require__(41);
	var hashprefixes = __webpack_require__(30);

	var UInt256 = __webpack_require__(10).UInt256;
	var SerializedObject = __webpack_require__(13).SerializedObject;

	/**
	 * Abstract class representing a node in a SHAMap tree.
	 *
	 * Can be either SHAMapTreeNodeInner or SHAMapTreeNodeLeaf.
	 *
	 * @class
	 */
	function SHAMapTreeNode() {}

	SHAMapTreeNode.TYPE_INNER = 1;
	SHAMapTreeNode.TYPE_TRANSACTION_NM = 2;
	SHAMapTreeNode.TYPE_TRANSACTION_MD = 3;
	SHAMapTreeNode.TYPE_ACCOUNT_STATE = 4;

	/**
	* @param {String} tag (64 hexadecimal characters)
	* @param {SHAMapTreeNode} node
	* @return {void}
	* @virtual
	*/
	/*eslint-disable no-unused-vars*/
	SHAMapTreeNode.prototype.add_item = function (tag, node) {
	  throw new Error('Called unimplemented virtual method SHAMapTreeNode#add_item.');
	};
	/*eslint-enable no-unused-vars*/

	SHAMapTreeNode.prototype.hash = function () {
	  throw new Error('Called unimplemented virtual method SHAMapTreeNode#hash.');
	};

	/**
	 * Inner (non-leaf) node in a SHAMap tree.
	 * @param {Number} depth (i.e. how many parent inner nodes)
	 * @class
	 */
	function SHAMapTreeNodeInner(depth) {
	  SHAMapTreeNode.call(this);

	  this.leaves = {};

	  this.type = SHAMapTreeNode.INNER;
	  this.depth = depth === undefined ? 0 : depth;

	  this.empty = true;
	}

	util.inherits(SHAMapTreeNodeInner, SHAMapTreeNode);

	/**
	 * @param {String} tag (equates to a ledger entry `index`)
	 * @param {SHAMapTreeNode} node (to add)
	 * @return {void}
	 */
	SHAMapTreeNodeInner.prototype.add_item = function (tag, node) {
	  var depth = this.depth;
	  var existing_node = this.get_node(tag[depth]);

	  if (existing_node) {
	    // A node already exists in this slot
	    if (existing_node instanceof SHAMapTreeNodeInner) {
	      // There is an inner node, so we need to go deeper
	      existing_node.add_item(tag, node);
	    } else if (existing_node.tag === tag) {
	      // Collision
	      throw new Error('Tried to add a node to a SHAMap that was already in there.');
	    } else {
	      // Turn it into an inner node
	      var new_inner_node = new SHAMapTreeNodeInner(depth + 1);

	      // Parent new and existing node
	      new_inner_node.add_item(existing_node.tag, existing_node);
	      new_inner_node.add_item(tag, node);

	      // And place the newly created inner node in the slot
	      this.set_node(tag[depth], new_inner_node);
	    }
	  } else {
	    // Neat, we have a nice open spot for the new node
	    this.set_node(tag[depth], node);
	  }
	};

	/**
	 * Overwrite the node that is currently in a given slot.
	 * @param {String} slot (a character 0-F)
	 * @param {SHAMapTreeNode} node (to place)
	 * @return {void}
	 */
	SHAMapTreeNodeInner.prototype.set_node = function (slot, node) {
	  this.leaves[slot] = node;
	  this.empty = false;
	};

	SHAMapTreeNodeInner.prototype.get_node = function (slot) {
	  return this.leaves[slot];
	};

	SHAMapTreeNodeInner.prototype.hash = function () {
	  if (this.empty) {
	    return UInt256.from_hex(UInt256.HEX_ZERO);
	  }

	  var hash_buffer = new SerializedObject();

	  for (var i = 0; i < 16; i++) {
	    var leafHash = UInt256.from_hex(UInt256.HEX_ZERO);
	    var slot = i.toString(16).toUpperCase();

	    if (typeof this.leaves[slot] === 'object') {
	      leafHash = this.leaves[slot].hash();
	    }

	    hash_buffer.append(leafHash.to_bytes());
	  }

	  var hash = hash_buffer.hash(hashprefixes.HASH_INNER_NODE);

	  return UInt256.from_bits(hash);
	};

	/**
	 * Leaf node in a SHAMap tree.
	 * @param {String} tag (equates to a ledger entry `index`)
	 * @param {SerializedObject} node (bytes of account state, transaction etc)
	 * @param {Number} type (one of TYPE_ACCOUNT_STATE, TYPE_TRANSACTION_MD etc)
	 * @class
	 */
	function SHAMapTreeNodeLeaf(tag, node, type) {
	  SHAMapTreeNode.call(this);

	  if (typeof tag !== 'string') {
	    throw new Error('Tag is unexpected type.');
	  }

	  this.tag = tag;
	  this.tag_bytes = UInt256.from_hex(this.tag).to_bytes();
	  this.type = type;
	  this.node = node;
	}

	util.inherits(SHAMapTreeNodeLeaf, SHAMapTreeNode);

	SHAMapTreeNodeLeaf.prototype.hash = function () {
	  var buffer = new SerializedObject();
	  switch (this.type) {
	    case SHAMapTreeNode.TYPE_ACCOUNT_STATE:
	      buffer.append(this.node);
	      buffer.append(this.tag_bytes);
	      return buffer.hash(hashprefixes.HASH_LEAF_NODE);
	    case SHAMapTreeNode.TYPE_TRANSACTION_NM:
	      return this.tag_bytes;
	    case SHAMapTreeNode.TYPE_TRANSACTION_MD:
	      buffer.append(this.node);
	      buffer.append(this.tag_bytes);
	      return buffer.hash(hashprefixes.HASH_TX_NODE);
	    default:
	      throw new Error('Tried to hash a SHAMap node of unknown type.');
	  }
	};

	function SHAMap() {
	  this.root = new SHAMapTreeNodeInner(0);
	}

	SHAMap.prototype.add_item = function (tag, node, type) {
	  node = new SHAMapTreeNodeLeaf(tag, node, type);
	  this.root.add_item(tag, node);
	};

	SHAMap.prototype.hash = function () {
	  return this.root.hash();
	};

	exports.SHAMap = SHAMap;
	exports.SHAMapTreeNode = SHAMapTreeNode;
	exports.SHAMapTreeNodeInner = SHAMapTreeNodeInner;
	exports.SHAMapTreeNodeLeaf = SHAMapTreeNodeLeaf;

/***/ },
/* 36 */
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Ripple ledger namespace prefixes.
	 *
	 * The Ripple ledger is a key-value store. In order to avoid name collisions,
	 * names are partitioned into namespaces.
	 *
	 * Each namespace is just a single character prefix.
	 */
	'use strict';

	module.exports = {
	  account: 'a',
	  dirNode: 'd',
	  generatorMap: 'g',
	  nickname: 'n',
	  rippleState: 'r',
	  offer: 'o', // Entry for an offer.
	  ownerDir: 'O', // Directory of things owned by an account.
	  bookDir: 'B', // Directory of order books.
	  contract: 'c',
	  skipList: 's',
	  amendment: 'f',
	  feeSettings: 'e'
	};

/***/ },
/* 37 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	__webpack_require__(55);
	__webpack_require__(56);
	__webpack_require__(57);
	__webpack_require__(58);
	__webpack_require__(59);
	__webpack_require__(60);
	__webpack_require__(61);

/***/ },
/* 38 */
/***/ function(module, exports, __webpack_require__) {

	// http://wiki.commonjs.org/wiki/Unit_Testing/1.0
	//
	// THIS IS NOT TESTED NOR LIKELY TO WORK OUTSIDE V8!
	//
	// Originally from narwhal.js (http://narwhaljs.org)
	// Copyright (c) 2009 Thomas Robinson <280north.com>
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the 'Software'), to
	// deal in the Software without restriction, including without limitation the
	// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
	// sell copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:
	//
	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
	// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
	// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

	// when used in node, this will actually load the util module we depend on
	// versus loading the builtin util module as happens otherwise
	// this is a bug in node module loading as far as I am concerned
	var util = __webpack_require__(41);

	var pSlice = Array.prototype.slice;
	var hasOwn = Object.prototype.hasOwnProperty;

	// 1. The assert module provides functions that throw
	// AssertionError's when particular conditions are not met. The
	// assert module must conform to the following interface.

	var assert = module.exports = ok;

	// 2. The AssertionError is defined in assert.
	// new assert.AssertionError({ message: message,
	//                             actual: actual,
	//                             expected: expected })

	assert.AssertionError = function AssertionError(options) {
	  this.name = 'AssertionError';
	  this.actual = options.actual;
	  this.expected = options.expected;
	  this.operator = options.operator;
	  if (options.message) {
	    this.message = options.message;
	    this.generatedMessage = false;
	  } else {
	    this.message = getMessage(this);
	    this.generatedMessage = true;
	  }
	  var stackStartFunction = options.stackStartFunction || fail;

	  if (Error.captureStackTrace) {
	    Error.captureStackTrace(this, stackStartFunction);
	  }
	  else {
	    // non v8 browsers so we can have a stacktrace
	    var err = new Error();
	    if (err.stack) {
	      var out = err.stack;

	      // try to strip useless frames
	      var fn_name = stackStartFunction.name;
	      var idx = out.indexOf('\n' + fn_name);
	      if (idx >= 0) {
	        // once we have located the function frame
	        // we need to strip out everything before it (and its line)
	        var next_line = out.indexOf('\n', idx + 1);
	        out = out.substring(next_line + 1);
	      }

	      this.stack = out;
	    }
	  }
	};

	// assert.AssertionError instanceof Error
	util.inherits(assert.AssertionError, Error);

	function replacer(key, value) {
	  if (util.isUndefined(value)) {
	    return '' + value;
	  }
	  if (util.isNumber(value) && !isFinite(value)) {
	    return value.toString();
	  }
	  if (util.isFunction(value) || util.isRegExp(value)) {
	    return value.toString();
	  }
	  return value;
	}

	function truncate(s, n) {
	  if (util.isString(s)) {
	    return s.length < n ? s : s.slice(0, n);
	  } else {
	    return s;
	  }
	}

	function getMessage(self) {
	  return truncate(JSON.stringify(self.actual, replacer), 128) + ' ' +
	         self.operator + ' ' +
	         truncate(JSON.stringify(self.expected, replacer), 128);
	}

	// At present only the three keys mentioned above are used and
	// understood by the spec. Implementations or sub modules can pass
	// other keys to the AssertionError's constructor - they will be
	// ignored.

	// 3. All of the following functions must throw an AssertionError
	// when a corresponding condition is not met, with a message that
	// may be undefined if not provided.  All assertion methods provide
	// both the actual and expected values to the assertion error for
	// display purposes.

	function fail(actual, expected, message, operator, stackStartFunction) {
	  throw new assert.AssertionError({
	    message: message,
	    actual: actual,
	    expected: expected,
	    operator: operator,
	    stackStartFunction: stackStartFunction
	  });
	}

	// EXTENSION! allows for well behaved errors defined elsewhere.
	assert.fail = fail;

	// 4. Pure assertion tests whether a value is truthy, as determined
	// by !!guard.
	// assert.ok(guard, message_opt);
	// This statement is equivalent to assert.equal(true, !!guard,
	// message_opt);. To test strictly for the value true, use
	// assert.strictEqual(true, guard, message_opt);.

	function ok(value, message) {
	  if (!value) fail(value, true, message, '==', assert.ok);
	}
	assert.ok = ok;

	// 5. The equality assertion tests shallow, coercive equality with
	// ==.
	// assert.equal(actual, expected, message_opt);

	assert.equal = function equal(actual, expected, message) {
	  if (actual != expected) fail(actual, expected, message, '==', assert.equal);
	};

	// 6. The non-equality assertion tests for whether two objects are not equal
	// with != assert.notEqual(actual, expected, message_opt);

	assert.notEqual = function notEqual(actual, expected, message) {
	  if (actual == expected) {
	    fail(actual, expected, message, '!=', assert.notEqual);
	  }
	};

	// 7. The equivalence assertion tests a deep equality relation.
	// assert.deepEqual(actual, expected, message_opt);

	assert.deepEqual = function deepEqual(actual, expected, message) {
	  if (!_deepEqual(actual, expected)) {
	    fail(actual, expected, message, 'deepEqual', assert.deepEqual);
	  }
	};

	function _deepEqual(actual, expected) {
	  // 7.1. All identical values are equivalent, as determined by ===.
	  if (actual === expected) {
	    return true;

	  } else if (util.isBuffer(actual) && util.isBuffer(expected)) {
	    if (actual.length != expected.length) return false;

	    for (var i = 0; i < actual.length; i++) {
	      if (actual[i] !== expected[i]) return false;
	    }

	    return true;

	  // 7.2. If the expected value is a Date object, the actual value is
	  // equivalent if it is also a Date object that refers to the same time.
	  } else if (util.isDate(actual) && util.isDate(expected)) {
	    return actual.getTime() === expected.getTime();

	  // 7.3 If the expected value is a RegExp object, the actual value is
	  // equivalent if it is also a RegExp object with the same source and
	  // properties (`global`, `multiline`, `lastIndex`, `ignoreCase`).
	  } else if (util.isRegExp(actual) && util.isRegExp(expected)) {
	    return actual.source === expected.source &&
	           actual.global === expected.global &&
	           actual.multiline === expected.multiline &&
	           actual.lastIndex === expected.lastIndex &&
	           actual.ignoreCase === expected.ignoreCase;

	  // 7.4. Other pairs that do not both pass typeof value == 'object',
	  // equivalence is determined by ==.
	  } else if (!util.isObject(actual) && !util.isObject(expected)) {
	    return actual == expected;

	  // 7.5 For all other Object pairs, including Array objects, equivalence is
	  // determined by having the same number of owned properties (as verified
	  // with Object.prototype.hasOwnProperty.call), the same set of keys
	  // (although not necessarily the same order), equivalent values for every
	  // corresponding key, and an identical 'prototype' property. Note: this
	  // accounts for both named and indexed properties on Arrays.
	  } else {
	    return objEquiv(actual, expected);
	  }
	}

	function isArguments(object) {
	  return Object.prototype.toString.call(object) == '[object Arguments]';
	}

	function objEquiv(a, b) {
	  if (util.isNullOrUndefined(a) || util.isNullOrUndefined(b))
	    return false;
	  // an identical 'prototype' property.
	  if (a.prototype !== b.prototype) return false;
	  // if one is a primitive, the other must be same
	  if (util.isPrimitive(a) || util.isPrimitive(b)) {
	    return a === b;
	  }
	  var aIsArgs = isArguments(a),
	      bIsArgs = isArguments(b);
	  if ((aIsArgs && !bIsArgs) || (!aIsArgs && bIsArgs))
	    return false;
	  if (aIsArgs) {
	    a = pSlice.call(a);
	    b = pSlice.call(b);
	    return _deepEqual(a, b);
	  }
	  var ka = objectKeys(a),
	      kb = objectKeys(b),
	      key, i;
	  // having the same number of owned properties (keys incorporates
	  // hasOwnProperty)
	  if (ka.length != kb.length)
	    return false;
	  //the same set of keys (although not necessarily the same order),
	  ka.sort();
	  kb.sort();
	  //~~~cheap key test
	  for (i = ka.length - 1; i >= 0; i--) {
	    if (ka[i] != kb[i])
	      return false;
	  }
	  //equivalent values for every corresponding key, and
	  //~~~possibly expensive deep test
	  for (i = ka.length - 1; i >= 0; i--) {
	    key = ka[i];
	    if (!_deepEqual(a[key], b[key])) return false;
	  }
	  return true;
	}

	// 8. The non-equivalence assertion tests for any deep inequality.
	// assert.notDeepEqual(actual, expected, message_opt);

	assert.notDeepEqual = function notDeepEqual(actual, expected, message) {
	  if (_deepEqual(actual, expected)) {
	    fail(actual, expected, message, 'notDeepEqual', assert.notDeepEqual);
	  }
	};

	// 9. The strict equality assertion tests strict equality, as determined by ===.
	// assert.strictEqual(actual, expected, message_opt);

	assert.strictEqual = function strictEqual(actual, expected, message) {
	  if (actual !== expected) {
	    fail(actual, expected, message, '===', assert.strictEqual);
	  }
	};

	// 10. The strict non-equality assertion tests for strict inequality, as
	// determined by !==.  assert.notStrictEqual(actual, expected, message_opt);

	assert.notStrictEqual = function notStrictEqual(actual, expected, message) {
	  if (actual === expected) {
	    fail(actual, expected, message, '!==', assert.notStrictEqual);
	  }
	};

	function expectedException(actual, expected) {
	  if (!actual || !expected) {
	    return false;
	  }

	  if (Object.prototype.toString.call(expected) == '[object RegExp]') {
	    return expected.test(actual);
	  } else if (actual instanceof expected) {
	    return true;
	  } else if (expected.call({}, actual) === true) {
	    return true;
	  }

	  return false;
	}

	function _throws(shouldThrow, block, expected, message) {
	  var actual;

	  if (util.isString(expected)) {
	    message = expected;
	    expected = null;
	  }

	  try {
	    block();
	  } catch (e) {
	    actual = e;
	  }

	  message = (expected && expected.name ? ' (' + expected.name + ').' : '.') +
	            (message ? ' ' + message : '.');

	  if (shouldThrow && !actual) {
	    fail(actual, expected, 'Missing expected exception' + message);
	  }

	  if (!shouldThrow && expectedException(actual, expected)) {
	    fail(actual, expected, 'Got unwanted exception' + message);
	  }

	  if ((shouldThrow && actual && expected &&
	      !expectedException(actual, expected)) || (!shouldThrow && actual)) {
	    throw actual;
	  }
	}

	// 11. Expected to throw an error:
	// assert.throws(block, Error_opt, message_opt);

	assert.throws = function(block, /*optional*/error, /*optional*/message) {
	  _throws.apply(this, [true].concat(pSlice.call(arguments)));
	};

	// EXTENSION! This is annoying to write outside this module.
	assert.doesNotThrow = function(block, /*optional*/message) {
	  _throws.apply(this, [false].concat(pSlice.call(arguments)));
	};

	assert.ifError = function(err) { if (err) {throw err;}};

	var objectKeys = Object.keys || function (obj) {
	  var keys = [];
	  for (var key in obj) {
	    if (hasOwn.call(obj, key)) keys.push(key);
	  }
	  return keys;
	};


/***/ },
/* 39 */
/***/ function(module, exports, __webpack_require__) {

	var hasOwn = Object.prototype.hasOwnProperty;
	var toString = Object.prototype.toString;

	function isPlainObject(obj) {
		if (!obj || toString.call(obj) !== '[object Object]' || obj.nodeType || obj.setInterval)
			return false;

		var has_own_constructor = hasOwn.call(obj, 'constructor');
		var has_is_property_of_method = hasOwn.call(obj.constructor.prototype, 'isPrototypeOf');
		// Not own constructor property must be Object
		if (obj.constructor && !has_own_constructor && !has_is_property_of_method)
			return false;

		// Own properties are enumerated firstly, so to speed up,
		// if last one is own, then all properties are own.
		var key;
		for ( key in obj ) {}

		return key === undefined || hasOwn.call( obj, key );
	};

	module.exports = function extend() {
		var options, name, src, copy, copyIsArray, clone,
		    target = arguments[0] || {},
		    i = 1,
		    length = arguments.length,
		    deep = false;

		// Handle a deep copy situation
		if ( typeof target === "boolean" ) {
			deep = target;
			target = arguments[1] || {};
			// skip the boolean and the target
			i = 2;
		}

		// Handle case when target is a string or something (possible in deep copy)
		if ( typeof target !== "object" && typeof target !== "function") {
			target = {};
		}

		for ( ; i < length; i++ ) {
			// Only deal with non-null/undefined values
			if ( (options = arguments[ i ]) != null ) {
				// Extend the base object
				for ( name in options ) {
					src = target[ name ];
					copy = options[ name ];

					// Prevent never-ending loop
					if ( target === copy ) {
						continue;
					}

					// Recurse if we're merging plain objects or arrays
					if ( deep && copy && ( isPlainObject(copy) || (copyIsArray = Array.isArray(copy)) ) ) {
						if ( copyIsArray ) {
							copyIsArray = false;
							clone = src && Array.isArray(src) ? src : [];

						} else {
							clone = src && isPlainObject(src) ? src : {};
						}

						// Never move original objects, clone them
						target[ name ] = extend( deep, clone, copy );

					// Don't bring in undefined values
					} else if ( copy !== undefined ) {
						target[ name ] = copy;
					}
				}
			}
		}

		// Return the modified object
		return target;
	};


/***/ },
/* 40 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	function EventEmitter() {
	  this._events = this._events || {};
	  this._maxListeners = this._maxListeners || undefined;
	}
	module.exports = EventEmitter;

	// Backwards-compat with node 0.10.x
	EventEmitter.EventEmitter = EventEmitter;

	EventEmitter.prototype._events = undefined;
	EventEmitter.prototype._maxListeners = undefined;

	// By default EventEmitters will print a warning if more than 10 listeners are
	// added to it. This is a useful default which helps finding memory leaks.
	EventEmitter.defaultMaxListeners = 10;

	// Obviously not all Emitters should be limited to 10. This function allows
	// that to be increased. Set to zero for unlimited.
	EventEmitter.prototype.setMaxListeners = function(n) {
	  if (!isNumber(n) || n < 0 || isNaN(n))
	    throw TypeError('n must be a positive number');
	  this._maxListeners = n;
	  return this;
	};

	EventEmitter.prototype.emit = function(type) {
	  var er, handler, len, args, i, listeners;

	  if (!this._events)
	    this._events = {};

	  // If there is no 'error' event listener then throw.
	  if (type === 'error') {
	    if (!this._events.error ||
	        (isObject(this._events.error) && !this._events.error.length)) {
	      er = arguments[1];
	      if (er instanceof Error) {
	        throw er; // Unhandled 'error' event
	      }
	      throw TypeError('Uncaught, unspecified "error" event.');
	    }
	  }

	  handler = this._events[type];

	  if (isUndefined(handler))
	    return false;

	  if (isFunction(handler)) {
	    switch (arguments.length) {
	      // fast cases
	      case 1:
	        handler.call(this);
	        break;
	      case 2:
	        handler.call(this, arguments[1]);
	        break;
	      case 3:
	        handler.call(this, arguments[1], arguments[2]);
	        break;
	      // slower
	      default:
	        len = arguments.length;
	        args = new Array(len - 1);
	        for (i = 1; i < len; i++)
	          args[i - 1] = arguments[i];
	        handler.apply(this, args);
	    }
	  } else if (isObject(handler)) {
	    len = arguments.length;
	    args = new Array(len - 1);
	    for (i = 1; i < len; i++)
	      args[i - 1] = arguments[i];

	    listeners = handler.slice();
	    len = listeners.length;
	    for (i = 0; i < len; i++)
	      listeners[i].apply(this, args);
	  }

	  return true;
	};

	EventEmitter.prototype.addListener = function(type, listener) {
	  var m;

	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  if (!this._events)
	    this._events = {};

	  // To avoid recursion in the case that type === "newListener"! Before
	  // adding it to the listeners, first emit "newListener".
	  if (this._events.newListener)
	    this.emit('newListener', type,
	              isFunction(listener.listener) ?
	              listener.listener : listener);

	  if (!this._events[type])
	    // Optimize the case of one listener. Don't need the extra array object.
	    this._events[type] = listener;
	  else if (isObject(this._events[type]))
	    // If we've already got an array, just append.
	    this._events[type].push(listener);
	  else
	    // Adding the second element, need to change to array.
	    this._events[type] = [this._events[type], listener];

	  // Check for listener leak
	  if (isObject(this._events[type]) && !this._events[type].warned) {
	    var m;
	    if (!isUndefined(this._maxListeners)) {
	      m = this._maxListeners;
	    } else {
	      m = EventEmitter.defaultMaxListeners;
	    }

	    if (m && m > 0 && this._events[type].length > m) {
	      this._events[type].warned = true;
	      console.error('(node) warning: possible EventEmitter memory ' +
	                    'leak detected. %d listeners added. ' +
	                    'Use emitter.setMaxListeners() to increase limit.',
	                    this._events[type].length);
	      if (typeof console.trace === 'function') {
	        // not supported in IE 10
	        console.trace();
	      }
	    }
	  }

	  return this;
	};

	EventEmitter.prototype.on = EventEmitter.prototype.addListener;

	EventEmitter.prototype.once = function(type, listener) {
	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  var fired = false;

	  function g() {
	    this.removeListener(type, g);

	    if (!fired) {
	      fired = true;
	      listener.apply(this, arguments);
	    }
	  }

	  g.listener = listener;
	  this.on(type, g);

	  return this;
	};

	// emits a 'removeListener' event iff the listener was removed
	EventEmitter.prototype.removeListener = function(type, listener) {
	  var list, position, length, i;

	  if (!isFunction(listener))
	    throw TypeError('listener must be a function');

	  if (!this._events || !this._events[type])
	    return this;

	  list = this._events[type];
	  length = list.length;
	  position = -1;

	  if (list === listener ||
	      (isFunction(list.listener) && list.listener === listener)) {
	    delete this._events[type];
	    if (this._events.removeListener)
	      this.emit('removeListener', type, listener);

	  } else if (isObject(list)) {
	    for (i = length; i-- > 0;) {
	      if (list[i] === listener ||
	          (list[i].listener && list[i].listener === listener)) {
	        position = i;
	        break;
	      }
	    }

	    if (position < 0)
	      return this;

	    if (list.length === 1) {
	      list.length = 0;
	      delete this._events[type];
	    } else {
	      list.splice(position, 1);
	    }

	    if (this._events.removeListener)
	      this.emit('removeListener', type, listener);
	  }

	  return this;
	};

	EventEmitter.prototype.removeAllListeners = function(type) {
	  var key, listeners;

	  if (!this._events)
	    return this;

	  // not listening for removeListener, no need to emit
	  if (!this._events.removeListener) {
	    if (arguments.length === 0)
	      this._events = {};
	    else if (this._events[type])
	      delete this._events[type];
	    return this;
	  }

	  // emit removeListener for all listeners on all events
	  if (arguments.length === 0) {
	    for (key in this._events) {
	      if (key === 'removeListener') continue;
	      this.removeAllListeners(key);
	    }
	    this.removeAllListeners('removeListener');
	    this._events = {};
	    return this;
	  }

	  listeners = this._events[type];

	  if (isFunction(listeners)) {
	    this.removeListener(type, listeners);
	  } else {
	    // LIFO order
	    while (listeners.length)
	      this.removeListener(type, listeners[listeners.length - 1]);
	  }
	  delete this._events[type];

	  return this;
	};

	EventEmitter.prototype.listeners = function(type) {
	  var ret;
	  if (!this._events || !this._events[type])
	    ret = [];
	  else if (isFunction(this._events[type]))
	    ret = [this._events[type]];
	  else
	    ret = this._events[type].slice();
	  return ret;
	};

	EventEmitter.listenerCount = function(emitter, type) {
	  var ret;
	  if (!emitter._events || !emitter._events[type])
	    ret = 0;
	  else if (isFunction(emitter._events[type]))
	    ret = 1;
	  else
	    ret = emitter._events[type].length;
	  return ret;
	};

	function isFunction(arg) {
	  return typeof arg === 'function';
	}

	function isNumber(arg) {
	  return typeof arg === 'number';
	}

	function isObject(arg) {
	  return typeof arg === 'object' && arg !== null;
	}

	function isUndefined(arg) {
	  return arg === void 0;
	}


/***/ },
/* 41 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global, process) {// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	var formatRegExp = /%[sdj%]/g;
	exports.format = function(f) {
	  if (!isString(f)) {
	    var objects = [];
	    for (var i = 0; i < arguments.length; i++) {
	      objects.push(inspect(arguments[i]));
	    }
	    return objects.join(' ');
	  }

	  var i = 1;
	  var args = arguments;
	  var len = args.length;
	  var str = String(f).replace(formatRegExp, function(x) {
	    if (x === '%%') return '%';
	    if (i >= len) return x;
	    switch (x) {
	      case '%s': return String(args[i++]);
	      case '%d': return Number(args[i++]);
	      case '%j':
	        try {
	          return JSON.stringify(args[i++]);
	        } catch (_) {
	          return '[Circular]';
	        }
	      default:
	        return x;
	    }
	  });
	  for (var x = args[i]; i < len; x = args[++i]) {
	    if (isNull(x) || !isObject(x)) {
	      str += ' ' + x;
	    } else {
	      str += ' ' + inspect(x);
	    }
	  }
	  return str;
	};


	// Mark that a method should not be used.
	// Returns a modified function which warns once by default.
	// If --no-deprecation is set, then it is a no-op.
	exports.deprecate = function(fn, msg) {
	  // Allow for deprecating things in the process of starting up.
	  if (isUndefined(global.process)) {
	    return function() {
	      return exports.deprecate(fn, msg).apply(this, arguments);
	    };
	  }

	  if (process.noDeprecation === true) {
	    return fn;
	  }

	  var warned = false;
	  function deprecated() {
	    if (!warned) {
	      if (process.throwDeprecation) {
	        throw new Error(msg);
	      } else if (process.traceDeprecation) {
	        console.trace(msg);
	      } else {
	        console.error(msg);
	      }
	      warned = true;
	    }
	    return fn.apply(this, arguments);
	  }

	  return deprecated;
	};


	var debugs = {};
	var debugEnviron;
	exports.debuglog = function(set) {
	  if (isUndefined(debugEnviron))
	    debugEnviron = process.env.NODE_DEBUG || '';
	  set = set.toUpperCase();
	  if (!debugs[set]) {
	    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
	      var pid = process.pid;
	      debugs[set] = function() {
	        var msg = exports.format.apply(exports, arguments);
	        console.error('%s %d: %s', set, pid, msg);
	      };
	    } else {
	      debugs[set] = function() {};
	    }
	  }
	  return debugs[set];
	};


	/**
	 * Echos the value of a value. Trys to print the value out
	 * in the best way possible given the different types.
	 *
	 * @param {Object} obj The object to print out.
	 * @param {Object} opts Optional options object that alters the output.
	 */
	/* legacy: obj, showHidden, depth, colors*/
	function inspect(obj, opts) {
	  // default options
	  var ctx = {
	    seen: [],
	    stylize: stylizeNoColor
	  };
	  // legacy...
	  if (arguments.length >= 3) ctx.depth = arguments[2];
	  if (arguments.length >= 4) ctx.colors = arguments[3];
	  if (isBoolean(opts)) {
	    // legacy...
	    ctx.showHidden = opts;
	  } else if (opts) {
	    // got an "options" object
	    exports._extend(ctx, opts);
	  }
	  // set default options
	  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
	  if (isUndefined(ctx.depth)) ctx.depth = 2;
	  if (isUndefined(ctx.colors)) ctx.colors = false;
	  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
	  if (ctx.colors) ctx.stylize = stylizeWithColor;
	  return formatValue(ctx, obj, ctx.depth);
	}
	exports.inspect = inspect;


	// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
	inspect.colors = {
	  'bold' : [1, 22],
	  'italic' : [3, 23],
	  'underline' : [4, 24],
	  'inverse' : [7, 27],
	  'white' : [37, 39],
	  'grey' : [90, 39],
	  'black' : [30, 39],
	  'blue' : [34, 39],
	  'cyan' : [36, 39],
	  'green' : [32, 39],
	  'magenta' : [35, 39],
	  'red' : [31, 39],
	  'yellow' : [33, 39]
	};

	// Don't use 'blue' not visible on cmd.exe
	inspect.styles = {
	  'special': 'cyan',
	  'number': 'yellow',
	  'boolean': 'yellow',
	  'undefined': 'grey',
	  'null': 'bold',
	  'string': 'green',
	  'date': 'magenta',
	  // "name": intentionally not styling
	  'regexp': 'red'
	};


	function stylizeWithColor(str, styleType) {
	  var style = inspect.styles[styleType];

	  if (style) {
	    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
	           '\u001b[' + inspect.colors[style][1] + 'm';
	  } else {
	    return str;
	  }
	}


	function stylizeNoColor(str, styleType) {
	  return str;
	}


	function arrayToHash(array) {
	  var hash = {};

	  array.forEach(function(val, idx) {
	    hash[val] = true;
	  });

	  return hash;
	}


	function formatValue(ctx, value, recurseTimes) {
	  // Provide a hook for user-specified inspect functions.
	  // Check that value is an object with an inspect function on it
	  if (ctx.customInspect &&
	      value &&
	      isFunction(value.inspect) &&
	      // Filter out the util module, it's inspect function is special
	      value.inspect !== exports.inspect &&
	      // Also filter out any prototype objects using the circular check.
	      !(value.constructor && value.constructor.prototype === value)) {
	    var ret = value.inspect(recurseTimes, ctx);
	    if (!isString(ret)) {
	      ret = formatValue(ctx, ret, recurseTimes);
	    }
	    return ret;
	  }

	  // Primitive types cannot have properties
	  var primitive = formatPrimitive(ctx, value);
	  if (primitive) {
	    return primitive;
	  }

	  // Look up the keys of the object.
	  var keys = Object.keys(value);
	  var visibleKeys = arrayToHash(keys);

	  if (ctx.showHidden) {
	    keys = Object.getOwnPropertyNames(value);
	  }

	  // IE doesn't make error fields non-enumerable
	  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
	  if (isError(value)
	      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
	    return formatError(value);
	  }

	  // Some type of object without properties can be shortcutted.
	  if (keys.length === 0) {
	    if (isFunction(value)) {
	      var name = value.name ? ': ' + value.name : '';
	      return ctx.stylize('[Function' + name + ']', 'special');
	    }
	    if (isRegExp(value)) {
	      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
	    }
	    if (isDate(value)) {
	      return ctx.stylize(Date.prototype.toString.call(value), 'date');
	    }
	    if (isError(value)) {
	      return formatError(value);
	    }
	  }

	  var base = '', array = false, braces = ['{', '}'];

	  // Make Array say that they are Array
	  if (isArray(value)) {
	    array = true;
	    braces = ['[', ']'];
	  }

	  // Make functions say that they are functions
	  if (isFunction(value)) {
	    var n = value.name ? ': ' + value.name : '';
	    base = ' [Function' + n + ']';
	  }

	  // Make RegExps say that they are RegExps
	  if (isRegExp(value)) {
	    base = ' ' + RegExp.prototype.toString.call(value);
	  }

	  // Make dates with properties first say the date
	  if (isDate(value)) {
	    base = ' ' + Date.prototype.toUTCString.call(value);
	  }

	  // Make error with message first say the error
	  if (isError(value)) {
	    base = ' ' + formatError(value);
	  }

	  if (keys.length === 0 && (!array || value.length == 0)) {
	    return braces[0] + base + braces[1];
	  }

	  if (recurseTimes < 0) {
	    if (isRegExp(value)) {
	      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
	    } else {
	      return ctx.stylize('[Object]', 'special');
	    }
	  }

	  ctx.seen.push(value);

	  var output;
	  if (array) {
	    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
	  } else {
	    output = keys.map(function(key) {
	      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
	    });
	  }

	  ctx.seen.pop();

	  return reduceToSingleString(output, base, braces);
	}


	function formatPrimitive(ctx, value) {
	  if (isUndefined(value))
	    return ctx.stylize('undefined', 'undefined');
	  if (isString(value)) {
	    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
	                                             .replace(/'/g, "\\'")
	                                             .replace(/\\"/g, '"') + '\'';
	    return ctx.stylize(simple, 'string');
	  }
	  if (isNumber(value))
	    return ctx.stylize('' + value, 'number');
	  if (isBoolean(value))
	    return ctx.stylize('' + value, 'boolean');
	  // For some reason typeof null is "object", so special case here.
	  if (isNull(value))
	    return ctx.stylize('null', 'null');
	}


	function formatError(value) {
	  return '[' + Error.prototype.toString.call(value) + ']';
	}


	function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
	  var output = [];
	  for (var i = 0, l = value.length; i < l; ++i) {
	    if (hasOwnProperty(value, String(i))) {
	      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
	          String(i), true));
	    } else {
	      output.push('');
	    }
	  }
	  keys.forEach(function(key) {
	    if (!key.match(/^\d+$/)) {
	      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
	          key, true));
	    }
	  });
	  return output;
	}


	function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
	  var name, str, desc;
	  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
	  if (desc.get) {
	    if (desc.set) {
	      str = ctx.stylize('[Getter/Setter]', 'special');
	    } else {
	      str = ctx.stylize('[Getter]', 'special');
	    }
	  } else {
	    if (desc.set) {
	      str = ctx.stylize('[Setter]', 'special');
	    }
	  }
	  if (!hasOwnProperty(visibleKeys, key)) {
	    name = '[' + key + ']';
	  }
	  if (!str) {
	    if (ctx.seen.indexOf(desc.value) < 0) {
	      if (isNull(recurseTimes)) {
	        str = formatValue(ctx, desc.value, null);
	      } else {
	        str = formatValue(ctx, desc.value, recurseTimes - 1);
	      }
	      if (str.indexOf('\n') > -1) {
	        if (array) {
	          str = str.split('\n').map(function(line) {
	            return '  ' + line;
	          }).join('\n').substr(2);
	        } else {
	          str = '\n' + str.split('\n').map(function(line) {
	            return '   ' + line;
	          }).join('\n');
	        }
	      }
	    } else {
	      str = ctx.stylize('[Circular]', 'special');
	    }
	  }
	  if (isUndefined(name)) {
	    if (array && key.match(/^\d+$/)) {
	      return str;
	    }
	    name = JSON.stringify('' + key);
	    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
	      name = name.substr(1, name.length - 2);
	      name = ctx.stylize(name, 'name');
	    } else {
	      name = name.replace(/'/g, "\\'")
	                 .replace(/\\"/g, '"')
	                 .replace(/(^"|"$)/g, "'");
	      name = ctx.stylize(name, 'string');
	    }
	  }

	  return name + ': ' + str;
	}


	function reduceToSingleString(output, base, braces) {
	  var numLinesEst = 0;
	  var length = output.reduce(function(prev, cur) {
	    numLinesEst++;
	    if (cur.indexOf('\n') >= 0) numLinesEst++;
	    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
	  }, 0);

	  if (length > 60) {
	    return braces[0] +
	           (base === '' ? '' : base + '\n ') +
	           ' ' +
	           output.join(',\n  ') +
	           ' ' +
	           braces[1];
	  }

	  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
	}


	// NOTE: These type checking functions intentionally don't use `instanceof`
	// because it is fragile and can be easily faked with `Object.create()`.
	function isArray(ar) {
	  return Array.isArray(ar);
	}
	exports.isArray = isArray;

	function isBoolean(arg) {
	  return typeof arg === 'boolean';
	}
	exports.isBoolean = isBoolean;

	function isNull(arg) {
	  return arg === null;
	}
	exports.isNull = isNull;

	function isNullOrUndefined(arg) {
	  return arg == null;
	}
	exports.isNullOrUndefined = isNullOrUndefined;

	function isNumber(arg) {
	  return typeof arg === 'number';
	}
	exports.isNumber = isNumber;

	function isString(arg) {
	  return typeof arg === 'string';
	}
	exports.isString = isString;

	function isSymbol(arg) {
	  return typeof arg === 'symbol';
	}
	exports.isSymbol = isSymbol;

	function isUndefined(arg) {
	  return arg === void 0;
	}
	exports.isUndefined = isUndefined;

	function isRegExp(re) {
	  return isObject(re) && objectToString(re) === '[object RegExp]';
	}
	exports.isRegExp = isRegExp;

	function isObject(arg) {
	  return typeof arg === 'object' && arg !== null;
	}
	exports.isObject = isObject;

	function isDate(d) {
	  return isObject(d) && objectToString(d) === '[object Date]';
	}
	exports.isDate = isDate;

	function isError(e) {
	  return isObject(e) &&
	      (objectToString(e) === '[object Error]' || e instanceof Error);
	}
	exports.isError = isError;

	function isFunction(arg) {
	  return typeof arg === 'function';
	}
	exports.isFunction = isFunction;

	function isPrimitive(arg) {
	  return arg === null ||
	         typeof arg === 'boolean' ||
	         typeof arg === 'number' ||
	         typeof arg === 'string' ||
	         typeof arg === 'symbol' ||  // ES6 symbol
	         typeof arg === 'undefined';
	}
	exports.isPrimitive = isPrimitive;

	exports.isBuffer = __webpack_require__(62);

	function objectToString(o) {
	  return Object.prototype.toString.call(o);
	}


	function pad(n) {
	  return n < 10 ? '0' + n.toString(10) : n.toString(10);
	}


	var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
	              'Oct', 'Nov', 'Dec'];

	// 26 Feb 16:19:34
	function timestamp() {
	  var d = new Date();
	  var time = [pad(d.getHours()),
	              pad(d.getMinutes()),
	              pad(d.getSeconds())].join(':');
	  return [d.getDate(), months[d.getMonth()], time].join(' ');
	}


	// log is just a thin wrapper to console.log that prepends a timestamp
	exports.log = function() {
	  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
	};


	/**
	 * Inherit the prototype methods from one constructor into another.
	 *
	 * The Function.prototype.inherits from lang.js rewritten as a standalone
	 * function (not on Function.prototype). NOTE: If this file is to be loaded
	 * during bootstrapping this function needs to be rewritten using some native
	 * functions as prototype setup using normal JavaScript does not work as
	 * expected during bootstrapping (see mirror.js in r114903).
	 *
	 * @param {function} ctor Constructor function which needs to inherit the
	 *     prototype.
	 * @param {function} superCtor Constructor function to inherit prototype from.
	 */
	exports.inherits = __webpack_require__(72);

	exports._extend = function(origin, add) {
	  // Don't do anything if add isn't an object
	  if (!add || !isObject(add)) return origin;

	  var keys = Object.keys(add);
	  var i = keys.length;
	  while (i--) {
	    origin[keys[i]] = add[keys[i]];
	  }
	  return origin;
	};

	function hasOwnProperty(obj, prop) {
	  return Object.prototype.hasOwnProperty.call(obj, prop);
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }()), __webpack_require__(63)))

/***/ },
/* 42 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/* WEBPACK VAR INJECTION */(function(module, global) {/**
	 * @license
	 * lodash 3.10.0 (Custom Build) <https://lodash.com/>
	 * Build: `lodash modern -d -o ./index.js`
	 * Copyright 2012-2015 The Dojo Foundation <http://dojofoundation.org/>
	 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
	 * Copyright 2009-2015 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
	 * Available under MIT license <https://lodash.com/license>
	 */
	;(function() {

	  /** Used as a safe reference for `undefined` in pre-ES5 environments. */
	  var undefined;

	  /** Used as the semantic version number. */
	  var VERSION = '3.10.0';

	  /** Used to compose bitmasks for wrapper metadata. */
	  var BIND_FLAG = 1,
	      BIND_KEY_FLAG = 2,
	      CURRY_BOUND_FLAG = 4,
	      CURRY_FLAG = 8,
	      CURRY_RIGHT_FLAG = 16,
	      PARTIAL_FLAG = 32,
	      PARTIAL_RIGHT_FLAG = 64,
	      ARY_FLAG = 128,
	      REARG_FLAG = 256;

	  /** Used as default options for `_.trunc`. */
	  var DEFAULT_TRUNC_LENGTH = 30,
	      DEFAULT_TRUNC_OMISSION = '...';

	  /** Used to detect when a function becomes hot. */
	  var HOT_COUNT = 150,
	      HOT_SPAN = 16;

	  /** Used as the size to enable large array optimizations. */
	  var LARGE_ARRAY_SIZE = 200;

	  /** Used to indicate the type of lazy iteratees. */
	  var LAZY_FILTER_FLAG = 1,
	      LAZY_MAP_FLAG = 2;

	  /** Used as the `TypeError` message for "Functions" methods. */
	  var FUNC_ERROR_TEXT = 'Expected a function';

	  /** Used as the internal argument placeholder. */
	  var PLACEHOLDER = '__lodash_placeholder__';

	  /** `Object#toString` result references. */
	  var argsTag = '[object Arguments]',
	      arrayTag = '[object Array]',
	      boolTag = '[object Boolean]',
	      dateTag = '[object Date]',
	      errorTag = '[object Error]',
	      funcTag = '[object Function]',
	      mapTag = '[object Map]',
	      numberTag = '[object Number]',
	      objectTag = '[object Object]',
	      regexpTag = '[object RegExp]',
	      setTag = '[object Set]',
	      stringTag = '[object String]',
	      weakMapTag = '[object WeakMap]';

	  var arrayBufferTag = '[object ArrayBuffer]',
	      float32Tag = '[object Float32Array]',
	      float64Tag = '[object Float64Array]',
	      int8Tag = '[object Int8Array]',
	      int16Tag = '[object Int16Array]',
	      int32Tag = '[object Int32Array]',
	      uint8Tag = '[object Uint8Array]',
	      uint8ClampedTag = '[object Uint8ClampedArray]',
	      uint16Tag = '[object Uint16Array]',
	      uint32Tag = '[object Uint32Array]';

	  /** Used to match empty string literals in compiled template source. */
	  var reEmptyStringLeading = /\b__p \+= '';/g,
	      reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
	      reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

	  /** Used to match HTML entities and HTML characters. */
	  var reEscapedHtml = /&(?:amp|lt|gt|quot|#39|#96);/g,
	      reUnescapedHtml = /[&<>"'`]/g,
	      reHasEscapedHtml = RegExp(reEscapedHtml.source),
	      reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

	  /** Used to match template delimiters. */
	  var reEscape = /<%-([\s\S]+?)%>/g,
	      reEvaluate = /<%([\s\S]+?)%>/g,
	      reInterpolate = /<%=([\s\S]+?)%>/g;

	  /** Used to match property names within property paths. */
	  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\n\\]|\\.)*?\1)\]/,
	      reIsPlainProp = /^\w*$/,
	      rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\n\\]|\\.)*?)\2)\]/g;

	  /**
	   * Used to match `RegExp` [syntax characters](http://ecma-international.org/ecma-262/6.0/#sec-patterns)
	   * and those outlined by [`EscapeRegExpPattern`](http://ecma-international.org/ecma-262/6.0/#sec-escaperegexppattern).
	   */
	  var reRegExpChars = /^[:!,]|[\\^$.*+?()[\]{}|\/]|(^[0-9a-fA-Fnrtuvx])|([\n\r\u2028\u2029])/g,
	      reHasRegExpChars = RegExp(reRegExpChars.source);

	  /** Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks). */
	  var reComboMark = /[\u0300-\u036f\ufe20-\ufe23]/g;

	  /** Used to match backslashes in property paths. */
	  var reEscapeChar = /\\(\\)?/g;

	  /** Used to match [ES template delimiters](http://ecma-international.org/ecma-262/6.0/#sec-template-literal-lexical-components). */
	  var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

	  /** Used to match `RegExp` flags from their coerced string values. */
	  var reFlags = /\w*$/;

	  /** Used to detect hexadecimal string values. */
	  var reHasHexPrefix = /^0[xX]/;

	  /** Used to detect host constructors (Safari > 5). */
	  var reIsHostCtor = /^\[object .+?Constructor\]$/;

	  /** Used to detect unsigned integer values. */
	  var reIsUint = /^\d+$/;

	  /** Used to match latin-1 supplementary letters (excluding mathematical operators). */
	  var reLatin1 = /[\xc0-\xd6\xd8-\xde\xdf-\xf6\xf8-\xff]/g;

	  /** Used to ensure capturing order of template delimiters. */
	  var reNoMatch = /($^)/;

	  /** Used to match unescaped characters in compiled string literals. */
	  var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

	  /** Used to match words to create compound words. */
	  var reWords = (function() {
	    var upper = '[A-Z\\xc0-\\xd6\\xd8-\\xde]',
	        lower = '[a-z\\xdf-\\xf6\\xf8-\\xff]+';

	    return RegExp(upper + '+(?=' + upper + lower + ')|' + upper + '?' + lower + '|' + upper + '+|[0-9]+', 'g');
	  }());

	  /** Used to assign default `context` object properties. */
	  var contextProps = [
	    'Array', 'ArrayBuffer', 'Date', 'Error', 'Float32Array', 'Float64Array',
	    'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Math', 'Number',
	    'Object', 'RegExp', 'Set', 'String', '_', 'clearTimeout', 'isFinite',
	    'parseFloat', 'parseInt', 'setTimeout', 'TypeError', 'Uint8Array',
	    'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap'
	  ];

	  /** Used to make template sourceURLs easier to identify. */
	  var templateCounter = -1;

	  /** Used to identify `toStringTag` values of typed arrays. */
	  var typedArrayTags = {};
	  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
	  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
	  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
	  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
	  typedArrayTags[uint32Tag] = true;
	  typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
	  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
	  typedArrayTags[dateTag] = typedArrayTags[errorTag] =
	  typedArrayTags[funcTag] = typedArrayTags[mapTag] =
	  typedArrayTags[numberTag] = typedArrayTags[objectTag] =
	  typedArrayTags[regexpTag] = typedArrayTags[setTag] =
	  typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;

	  /** Used to identify `toStringTag` values supported by `_.clone`. */
	  var cloneableTags = {};
	  cloneableTags[argsTag] = cloneableTags[arrayTag] =
	  cloneableTags[arrayBufferTag] = cloneableTags[boolTag] =
	  cloneableTags[dateTag] = cloneableTags[float32Tag] =
	  cloneableTags[float64Tag] = cloneableTags[int8Tag] =
	  cloneableTags[int16Tag] = cloneableTags[int32Tag] =
	  cloneableTags[numberTag] = cloneableTags[objectTag] =
	  cloneableTags[regexpTag] = cloneableTags[stringTag] =
	  cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
	  cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
	  cloneableTags[errorTag] = cloneableTags[funcTag] =
	  cloneableTags[mapTag] = cloneableTags[setTag] =
	  cloneableTags[weakMapTag] = false;

	  /** Used to map latin-1 supplementary letters to basic latin letters. */
	  var deburredLetters = {
	    '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
	    '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
	    '\xc7': 'C',  '\xe7': 'c',
	    '\xd0': 'D',  '\xf0': 'd',
	    '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
	    '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
	    '\xcC': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
	    '\xeC': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
	    '\xd1': 'N',  '\xf1': 'n',
	    '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
	    '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
	    '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
	    '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
	    '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
	    '\xc6': 'Ae', '\xe6': 'ae',
	    '\xde': 'Th', '\xfe': 'th',
	    '\xdf': 'ss'
	  };

	  /** Used to map characters to HTML entities. */
	  var htmlEscapes = {
	    '&': '&amp;',
	    '<': '&lt;',
	    '>': '&gt;',
	    '"': '&quot;',
	    "'": '&#39;',
	    '`': '&#96;'
	  };

	  /** Used to map HTML entities to characters. */
	  var htmlUnescapes = {
	    '&amp;': '&',
	    '&lt;': '<',
	    '&gt;': '>',
	    '&quot;': '"',
	    '&#39;': "'",
	    '&#96;': '`'
	  };

	  /** Used to determine if values are of the language type `Object`. */
	  var objectTypes = {
	    'function': true,
	    'object': true
	  };

	  /** Used to escape characters for inclusion in compiled regexes. */
	  var regexpEscapes = {
	    '0': 'x30', '1': 'x31', '2': 'x32', '3': 'x33', '4': 'x34',
	    '5': 'x35', '6': 'x36', '7': 'x37', '8': 'x38', '9': 'x39',
	    'A': 'x41', 'B': 'x42', 'C': 'x43', 'D': 'x44', 'E': 'x45', 'F': 'x46',
	    'a': 'x61', 'b': 'x62', 'c': 'x63', 'd': 'x64', 'e': 'x65', 'f': 'x66',
	    'n': 'x6e', 'r': 'x72', 't': 'x74', 'u': 'x75', 'v': 'x76', 'x': 'x78'
	  };

	  /** Used to escape characters for inclusion in compiled string literals. */
	  var stringEscapes = {
	    '\\': '\\',
	    "'": "'",
	    '\n': 'n',
	    '\r': 'r',
	    '\u2028': 'u2028',
	    '\u2029': 'u2029'
	  };

	  /** Detect free variable `exports`. */
	  var freeExports = objectTypes[typeof exports] && exports && !exports.nodeType && exports;

	  /** Detect free variable `module`. */
	  var freeModule = objectTypes[typeof module] && module && !module.nodeType && module;

	  /** Detect free variable `global` from Node.js. */
	  var freeGlobal = freeExports && freeModule && typeof global == 'object' && global && global.Object && global;

	  /** Detect free variable `self`. */
	  var freeSelf = objectTypes[typeof self] && self && self.Object && self;

	  /** Detect free variable `window`. */
	  var freeWindow = objectTypes[typeof window] && window && window.Object && window;

	  /** Detect the popular CommonJS extension `module.exports`. */
	  var moduleExports = freeModule && freeModule.exports === freeExports && freeExports;

	  /**
	   * Used as a reference to the global object.
	   *
	   * The `this` value is used if it's the global object to avoid Greasemonkey's
	   * restricted `window` object, otherwise the `window` object is used.
	   */
	  var root = freeGlobal || ((freeWindow !== (this && this.window)) && freeWindow) || freeSelf || this;

	  /*--------------------------------------------------------------------------*/

	  /**
	   * The base implementation of `compareAscending` which compares values and
	   * sorts them in ascending order without guaranteeing a stable sort.
	   *
	   * @private
	   * @param {*} value The value to compare.
	   * @param {*} other The other value to compare.
	   * @returns {number} Returns the sort order indicator for `value`.
	   */
	  function baseCompareAscending(value, other) {
	    if (value !== other) {
	      var valIsNull = value === null,
	          valIsUndef = value === undefined,
	          valIsReflexive = value === value;

	      var othIsNull = other === null,
	          othIsUndef = other === undefined,
	          othIsReflexive = other === other;

	      if ((value > other && !othIsNull) || !valIsReflexive ||
	          (valIsNull && !othIsUndef && othIsReflexive) ||
	          (valIsUndef && othIsReflexive)) {
	        return 1;
	      }
	      if ((value < other && !valIsNull) || !othIsReflexive ||
	          (othIsNull && !valIsUndef && valIsReflexive) ||
	          (othIsUndef && valIsReflexive)) {
	        return -1;
	      }
	    }
	    return 0;
	  }

	  /**
	   * The base implementation of `_.findIndex` and `_.findLastIndex` without
	   * support for callback shorthands and `this` binding.
	   *
	   * @private
	   * @param {Array} array The array to search.
	   * @param {Function} predicate The function invoked per iteration.
	   * @param {boolean} [fromRight] Specify iterating from right to left.
	   * @returns {number} Returns the index of the matched value, else `-1`.
	   */
	  function baseFindIndex(array, predicate, fromRight) {
	    var length = array.length,
	        index = fromRight ? length : -1;

	    while ((fromRight ? index-- : ++index < length)) {
	      if (predicate(array[index], index, array)) {
	        return index;
	      }
	    }
	    return -1;
	  }

	  /**
	   * The base implementation of `_.indexOf` without support for binary searches.
	   *
	   * @private
	   * @param {Array} array The array to search.
	   * @param {*} value The value to search for.
	   * @param {number} fromIndex The index to search from.
	   * @returns {number} Returns the index of the matched value, else `-1`.
	   */
	  function baseIndexOf(array, value, fromIndex) {
	    if (value !== value) {
	      return indexOfNaN(array, fromIndex);
	    }
	    var index = fromIndex - 1,
	        length = array.length;

	    while (++index < length) {
	      if (array[index] === value) {
	        return index;
	      }
	    }
	    return -1;
	  }

	  /**
	   * The base implementation of `_.isFunction` without support for environments
	   * with incorrect `typeof` results.
	   *
	   * @private
	   * @param {*} value The value to check.
	   * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	   */
	  function baseIsFunction(value) {
	    // Avoid a Chakra JIT bug in compatibility modes of IE 11.
	    // See https://github.com/jashkenas/underscore/issues/1621 for more details.
	    return typeof value == 'function' || false;
	  }

	  /**
	   * Converts `value` to a string if it's not one. An empty string is returned
	   * for `null` or `undefined` values.
	   *
	   * @private
	   * @param {*} value The value to process.
	   * @returns {string} Returns the string.
	   */
	  function baseToString(value) {
	    return value == null ? '' : (value + '');
	  }

	  /**
	   * Used by `_.trim` and `_.trimLeft` to get the index of the first character
	   * of `string` that is not found in `chars`.
	   *
	   * @private
	   * @param {string} string The string to inspect.
	   * @param {string} chars The characters to find.
	   * @returns {number} Returns the index of the first character not found in `chars`.
	   */
	  function charsLeftIndex(string, chars) {
	    var index = -1,
	        length = string.length;

	    while (++index < length && chars.indexOf(string.charAt(index)) > -1) {}
	    return index;
	  }

	  /**
	   * Used by `_.trim` and `_.trimRight` to get the index of the last character
	   * of `string` that is not found in `chars`.
	   *
	   * @private
	   * @param {string} string The string to inspect.
	   * @param {string} chars The characters to find.
	   * @returns {number} Returns the index of the last character not found in `chars`.
	   */
	  function charsRightIndex(string, chars) {
	    var index = string.length;

	    while (index-- && chars.indexOf(string.charAt(index)) > -1) {}
	    return index;
	  }

	  /**
	   * Used by `_.sortBy` to compare transformed elements of a collection and stable
	   * sort them in ascending order.
	   *
	   * @private
	   * @param {Object} object The object to compare.
	   * @param {Object} other The other object to compare.
	   * @returns {number} Returns the sort order indicator for `object`.
	   */
	  function compareAscending(object, other) {
	    return baseCompareAscending(object.criteria, other.criteria) || (object.index - other.index);
	  }

	  /**
	   * Used by `_.sortByOrder` to compare multiple properties of a value to another
	   * and stable sort them.
	   *
	   * If `orders` is unspecified, all valuess are sorted in ascending order. Otherwise,
	   * a value is sorted in ascending order if its corresponding order is "asc", and
	   * descending if "desc".
	   *
	   * @private
	   * @param {Object} object The object to compare.
	   * @param {Object} other The other object to compare.
	   * @param {boolean[]} orders The order to sort by for each property.
	   * @returns {number} Returns the sort order indicator for `object`.
	   */
	  function compareMultiple(object, other, orders) {
	    var index = -1,
	        objCriteria = object.criteria,
	        othCriteria = other.criteria,
	        length = objCriteria.length,
	        ordersLength = orders.length;

	    while (++index < length) {
	      var result = baseCompareAscending(objCriteria[index], othCriteria[index]);
	      if (result) {
	        if (index >= ordersLength) {
	          return result;
	        }
	        var order = orders[index];
	        return result * ((order === 'asc' || order === true) ? 1 : -1);
	      }
	    }
	    // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
	    // that causes it, under certain circumstances, to provide the same value for
	    // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
	    // for more details.
	    //
	    // This also ensures a stable sort in V8 and other engines.
	    // See https://code.google.com/p/v8/issues/detail?id=90 for more details.
	    return object.index - other.index;
	  }

	  /**
	   * Used by `_.deburr` to convert latin-1 supplementary letters to basic latin letters.
	   *
	   * @private
	   * @param {string} letter The matched letter to deburr.
	   * @returns {string} Returns the deburred letter.
	   */
	  function deburrLetter(letter) {
	    return deburredLetters[letter];
	  }

	  /**
	   * Used by `_.escape` to convert characters to HTML entities.
	   *
	   * @private
	   * @param {string} chr The matched character to escape.
	   * @returns {string} Returns the escaped character.
	   */
	  function escapeHtmlChar(chr) {
	    return htmlEscapes[chr];
	  }

	  /**
	   * Used by `_.escapeRegExp` to escape characters for inclusion in compiled regexes.
	   *
	   * @private
	   * @param {string} chr The matched character to escape.
	   * @param {string} leadingChar The capture group for a leading character.
	   * @param {string} whitespaceChar The capture group for a whitespace character.
	   * @returns {string} Returns the escaped character.
	   */
	  function escapeRegExpChar(chr, leadingChar, whitespaceChar) {
	    if (leadingChar) {
	      chr = regexpEscapes[chr];
	    } else if (whitespaceChar) {
	      chr = stringEscapes[chr];
	    }
	    return '\\' + chr;
	  }

	  /**
	   * Used by `_.template` to escape characters for inclusion in compiled string literals.
	   *
	   * @private
	   * @param {string} chr The matched character to escape.
	   * @returns {string} Returns the escaped character.
	   */
	  function escapeStringChar(chr) {
	    return '\\' + stringEscapes[chr];
	  }

	  /**
	   * Gets the index at which the first occurrence of `NaN` is found in `array`.
	   *
	   * @private
	   * @param {Array} array The array to search.
	   * @param {number} fromIndex The index to search from.
	   * @param {boolean} [fromRight] Specify iterating from right to left.
	   * @returns {number} Returns the index of the matched `NaN`, else `-1`.
	   */
	  function indexOfNaN(array, fromIndex, fromRight) {
	    var length = array.length,
	        index = fromIndex + (fromRight ? 0 : -1);

	    while ((fromRight ? index-- : ++index < length)) {
	      var other = array[index];
	      if (other !== other) {
	        return index;
	      }
	    }
	    return -1;
	  }

	  /**
	   * Checks if `value` is object-like.
	   *
	   * @private
	   * @param {*} value The value to check.
	   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
	   */
	  function isObjectLike(value) {
	    return !!value && typeof value == 'object';
	  }

	  /**
	   * Used by `trimmedLeftIndex` and `trimmedRightIndex` to determine if a
	   * character code is whitespace.
	   *
	   * @private
	   * @param {number} charCode The character code to inspect.
	   * @returns {boolean} Returns `true` if `charCode` is whitespace, else `false`.
	   */
	  function isSpace(charCode) {
	    return ((charCode <= 160 && (charCode >= 9 && charCode <= 13) || charCode == 32 || charCode == 160) || charCode == 5760 || charCode == 6158 ||
	      (charCode >= 8192 && (charCode <= 8202 || charCode == 8232 || charCode == 8233 || charCode == 8239 || charCode == 8287 || charCode == 12288 || charCode == 65279)));
	  }

	  /**
	   * Replaces all `placeholder` elements in `array` with an internal placeholder
	   * and returns an array of their indexes.
	   *
	   * @private
	   * @param {Array} array The array to modify.
	   * @param {*} placeholder The placeholder to replace.
	   * @returns {Array} Returns the new array of placeholder indexes.
	   */
	  function replaceHolders(array, placeholder) {
	    var index = -1,
	        length = array.length,
	        resIndex = -1,
	        result = [];

	    while (++index < length) {
	      if (array[index] === placeholder) {
	        array[index] = PLACEHOLDER;
	        result[++resIndex] = index;
	      }
	    }
	    return result;
	  }

	  /**
	   * An implementation of `_.uniq` optimized for sorted arrays without support
	   * for callback shorthands and `this` binding.
	   *
	   * @private
	   * @param {Array} array The array to inspect.
	   * @param {Function} [iteratee] The function invoked per iteration.
	   * @returns {Array} Returns the new duplicate-value-free array.
	   */
	  function sortedUniq(array, iteratee) {
	    var seen,
	        index = -1,
	        length = array.length,
	        resIndex = -1,
	        result = [];

	    while (++index < length) {
	      var value = array[index],
	          computed = iteratee ? iteratee(value, index, array) : value;

	      if (!index || seen !== computed) {
	        seen = computed;
	        result[++resIndex] = value;
	      }
	    }
	    return result;
	  }

	  /**
	   * Used by `_.trim` and `_.trimLeft` to get the index of the first non-whitespace
	   * character of `string`.
	   *
	   * @private
	   * @param {string} string The string to inspect.
	   * @returns {number} Returns the index of the first non-whitespace character.
	   */
	  function trimmedLeftIndex(string) {
	    var index = -1,
	        length = string.length;

	    while (++index < length && isSpace(string.charCodeAt(index))) {}
	    return index;
	  }

	  /**
	   * Used by `_.trim` and `_.trimRight` to get the index of the last non-whitespace
	   * character of `string`.
	   *
	   * @private
	   * @param {string} string The string to inspect.
	   * @returns {number} Returns the index of the last non-whitespace character.
	   */
	  function trimmedRightIndex(string) {
	    var index = string.length;

	    while (index-- && isSpace(string.charCodeAt(index))) {}
	    return index;
	  }

	  /**
	   * Used by `_.unescape` to convert HTML entities to characters.
	   *
	   * @private
	   * @param {string} chr The matched character to unescape.
	   * @returns {string} Returns the unescaped character.
	   */
	  function unescapeHtmlChar(chr) {
	    return htmlUnescapes[chr];
	  }

	  /*--------------------------------------------------------------------------*/

	  /**
	   * Create a new pristine `lodash` function using the given `context` object.
	   *
	   * @static
	   * @memberOf _
	   * @category Utility
	   * @param {Object} [context=root] The context object.
	   * @returns {Function} Returns a new `lodash` function.
	   * @example
	   *
	   * _.mixin({ 'foo': _.constant('foo') });
	   *
	   * var lodash = _.runInContext();
	   * lodash.mixin({ 'bar': lodash.constant('bar') });
	   *
	   * _.isFunction(_.foo);
	   * // => true
	   * _.isFunction(_.bar);
	   * // => false
	   *
	   * lodash.isFunction(lodash.foo);
	   * // => false
	   * lodash.isFunction(lodash.bar);
	   * // => true
	   *
	   * // using `context` to mock `Date#getTime` use in `_.now`
	   * var mock = _.runInContext({
	   *   'Date': function() {
	   *     return { 'getTime': getTimeMock };
	   *   }
	   * });
	   *
	   * // or creating a suped-up `defer` in Node.js
	   * var defer = _.runInContext({ 'setTimeout': setImmediate }).defer;
	   */
	  function runInContext(context) {
	    // Avoid issues with some ES3 environments that attempt to use values, named
	    // after built-in constructors like `Object`, for the creation of literals.
	    // ES5 clears this up by stating that literals must use built-in constructors.
	    // See https://es5.github.io/#x11.1.5 for more details.
	    context = context ? _.defaults(root.Object(), context, _.pick(root, contextProps)) : root;

	    /** Native constructor references. */
	    var Array = context.Array,
	        Date = context.Date,
	        Error = context.Error,
	        Function = context.Function,
	        Math = context.Math,
	        Number = context.Number,
	        Object = context.Object,
	        RegExp = context.RegExp,
	        String = context.String,
	        TypeError = context.TypeError;

	    /** Used for native method references. */
	    var arrayProto = Array.prototype,
	        objectProto = Object.prototype,
	        stringProto = String.prototype;

	    /** Used to resolve the decompiled source of functions. */
	    var fnToString = Function.prototype.toString;

	    /** Used to check objects for own properties. */
	    var hasOwnProperty = objectProto.hasOwnProperty;

	    /** Used to generate unique IDs. */
	    var idCounter = 0;

	    /**
	     * Used to resolve the [`toStringTag`](http://ecma-international.org/ecma-262/6.0/#sec-object.prototype.tostring)
	     * of values.
	     */
	    var objToString = objectProto.toString;

	    /** Used to restore the original `_` reference in `_.noConflict`. */
	    var oldDash = root._;

	    /** Used to detect if a method is native. */
	    var reIsNative = RegExp('^' +
	      fnToString.call(hasOwnProperty).replace(/[\\^$.*+?()[\]{}|]/g, '\\$&')
	      .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
	    );

	    /** Native method references. */
	    var ArrayBuffer = context.ArrayBuffer,
	        clearTimeout = context.clearTimeout,
	        parseFloat = context.parseFloat,
	        pow = Math.pow,
	        propertyIsEnumerable = objectProto.propertyIsEnumerable,
	        Set = getNative(context, 'Set'),
	        setTimeout = context.setTimeout,
	        splice = arrayProto.splice,
	        Uint8Array = context.Uint8Array,
	        WeakMap = getNative(context, 'WeakMap');

	    /* Native method references for those with the same name as other `lodash` methods. */
	    var nativeCeil = Math.ceil,
	        nativeCreate = getNative(Object, 'create'),
	        nativeFloor = Math.floor,
	        nativeIsArray = getNative(Array, 'isArray'),
	        nativeIsFinite = context.isFinite,
	        nativeKeys = getNative(Object, 'keys'),
	        nativeMax = Math.max,
	        nativeMin = Math.min,
	        nativeNow = getNative(Date, 'now'),
	        nativeParseInt = context.parseInt,
	        nativeRandom = Math.random;

	    /** Used as references for `-Infinity` and `Infinity`. */
	    var NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY,
	        POSITIVE_INFINITY = Number.POSITIVE_INFINITY;

	    /** Used as references for the maximum length and index of an array. */
	    var MAX_ARRAY_LENGTH = 4294967295,
	        MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1,
	        HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;

	    /**
	     * Used as the [maximum length](http://ecma-international.org/ecma-262/6.0/#sec-number.max_safe_integer)
	     * of an array-like value.
	     */
	    var MAX_SAFE_INTEGER = 9007199254740991;

	    /** Used to store function metadata. */
	    var metaMap = WeakMap && new WeakMap;

	    /** Used to lookup unminified function names. */
	    var realNames = {};

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a `lodash` object which wraps `value` to enable implicit chaining.
	     * Methods that operate on and return arrays, collections, and functions can
	     * be chained together. Methods that retrieve a single value or may return a
	     * primitive value will automatically end the chain returning the unwrapped
	     * value. Explicit chaining may be enabled using `_.chain`. The execution of
	     * chained methods is lazy, that is, execution is deferred until `_#value`
	     * is implicitly or explicitly called.
	     *
	     * Lazy evaluation allows several methods to support shortcut fusion. Shortcut
	     * fusion is an optimization strategy which merge iteratee calls; this can help
	     * to avoid the creation of intermediate data structures and greatly reduce the
	     * number of iteratee executions.
	     *
	     * Chaining is supported in custom builds as long as the `_#value` method is
	     * directly or indirectly included in the build.
	     *
	     * In addition to lodash methods, wrappers have `Array` and `String` methods.
	     *
	     * The wrapper `Array` methods are:
	     * `concat`, `join`, `pop`, `push`, `reverse`, `shift`, `slice`, `sort`,
	     * `splice`, and `unshift`
	     *
	     * The wrapper `String` methods are:
	     * `replace` and `split`
	     *
	     * The wrapper methods that support shortcut fusion are:
	     * `compact`, `drop`, `dropRight`, `dropRightWhile`, `dropWhile`, `filter`,
	     * `first`, `initial`, `last`, `map`, `pluck`, `reject`, `rest`, `reverse`,
	     * `slice`, `take`, `takeRight`, `takeRightWhile`, `takeWhile`, `toArray`,
	     * and `where`
	     *
	     * The chainable wrapper methods are:
	     * `after`, `ary`, `assign`, `at`, `before`, `bind`, `bindAll`, `bindKey`,
	     * `callback`, `chain`, `chunk`, `commit`, `compact`, `concat`, `constant`,
	     * `countBy`, `create`, `curry`, `debounce`, `defaults`, `defaultsDeep`,
	     * `defer`, `delay`, `difference`, `drop`, `dropRight`, `dropRightWhile`,
	     * `dropWhile`, `fill`, `filter`, `flatten`, `flattenDeep`, `flow`, `flowRight`,
	     * `forEach`, `forEachRight`, `forIn`, `forInRight`, `forOwn`, `forOwnRight`,
	     * `functions`, `groupBy`, `indexBy`, `initial`, `intersection`, `invert`,
	     * `invoke`, `keys`, `keysIn`, `map`, `mapKeys`, `mapValues`, `matches`,
	     * `matchesProperty`, `memoize`, `merge`, `method`, `methodOf`, `mixin`,
	     * `modArgs`, `negate`, `omit`, `once`, `pairs`, `partial`, `partialRight`,
	     * `partition`, `pick`, `plant`, `pluck`, `property`, `propertyOf`, `pull`,
	     * `pullAt`, `push`, `range`, `rearg`, `reject`, `remove`, `rest`, `restParam`,
	     * `reverse`, `set`, `shuffle`, `slice`, `sort`, `sortBy`, `sortByAll`,
	     * `sortByOrder`, `splice`, `spread`, `take`, `takeRight`, `takeRightWhile`,
	     * `takeWhile`, `tap`, `throttle`, `thru`, `times`, `toArray`, `toPlainObject`,
	     * `transform`, `union`, `uniq`, `unshift`, `unzip`, `unzipWith`, `values`,
	     * `valuesIn`, `where`, `without`, `wrap`, `xor`, `zip`, `zipObject`, `zipWith`
	     *
	     * The wrapper methods that are **not** chainable by default are:
	     * `add`, `attempt`, `camelCase`, `capitalize`, `ceil`, `clone`, `cloneDeep`,
	     * `deburr`, `endsWith`, `escape`, `escapeRegExp`, `every`, `find`, `findIndex`,
	     * `findKey`, `findLast`, `findLastIndex`, `findLastKey`, `findWhere`, `first`,
	     * `floor`, `get`, `gt`, `gte`, `has`, `identity`, `includes`, `indexOf`,
	     * `inRange`, `isArguments`, `isArray`, `isBoolean`, `isDate`, `isElement`,
	     * `isEmpty`, `isEqual`, `isError`, `isFinite` `isFunction`, `isMatch`,
	     * `isNative`, `isNaN`, `isNull`, `isNumber`, `isObject`, `isPlainObject`,
	     * `isRegExp`, `isString`, `isUndefined`, `isTypedArray`, `join`, `kebabCase`,
	     * `last`, `lastIndexOf`, `lt`, `lte`, `max`, `min`, `noConflict`, `noop`,
	     * `now`, `pad`, `padLeft`, `padRight`, `parseInt`, `pop`, `random`, `reduce`,
	     * `reduceRight`, `repeat`, `result`, `round`, `runInContext`, `shift`, `size`,
	     * `snakeCase`, `some`, `sortedIndex`, `sortedLastIndex`, `startCase`,
	     * `startsWith`, `sum`, `template`, `trim`, `trimLeft`, `trimRight`, `trunc`,
	     * `unescape`, `uniqueId`, `value`, and `words`
	     *
	     * The wrapper method `sample` will return a wrapped value when `n` is provided,
	     * otherwise an unwrapped value is returned.
	     *
	     * @name _
	     * @constructor
	     * @category Chain
	     * @param {*} value The value to wrap in a `lodash` instance.
	     * @returns {Object} Returns the new `lodash` wrapper instance.
	     * @example
	     *
	     * var wrapped = _([1, 2, 3]);
	     *
	     * // returns an unwrapped value
	     * wrapped.reduce(function(total, n) {
	     *   return total + n;
	     * });
	     * // => 6
	     *
	     * // returns a wrapped value
	     * var squares = wrapped.map(function(n) {
	     *   return n * n;
	     * });
	     *
	     * _.isArray(squares);
	     * // => false
	     *
	     * _.isArray(squares.value());
	     * // => true
	     */
	    function lodash(value) {
	      if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
	        if (value instanceof LodashWrapper) {
	          return value;
	        }
	        if (hasOwnProperty.call(value, '__chain__') && hasOwnProperty.call(value, '__wrapped__')) {
	          return wrapperClone(value);
	        }
	      }
	      return new LodashWrapper(value);
	    }

	    /**
	     * The function whose prototype all chaining wrappers inherit from.
	     *
	     * @private
	     */
	    function baseLodash() {
	      // No operation performed.
	    }

	    /**
	     * The base constructor for creating `lodash` wrapper objects.
	     *
	     * @private
	     * @param {*} value The value to wrap.
	     * @param {boolean} [chainAll] Enable chaining for all wrapper methods.
	     * @param {Array} [actions=[]] Actions to peform to resolve the unwrapped value.
	     */
	    function LodashWrapper(value, chainAll, actions) {
	      this.__wrapped__ = value;
	      this.__actions__ = actions || [];
	      this.__chain__ = !!chainAll;
	    }

	    /**
	     * An object environment feature flags.
	     *
	     * @static
	     * @memberOf _
	     * @type Object
	     */
	    var support = lodash.support = {};

	    /**
	     * By default, the template delimiters used by lodash are like those in
	     * embedded Ruby (ERB). Change the following template settings to use
	     * alternative delimiters.
	     *
	     * @static
	     * @memberOf _
	     * @type Object
	     */
	    lodash.templateSettings = {

	      /**
	       * Used to detect `data` property values to be HTML-escaped.
	       *
	       * @memberOf _.templateSettings
	       * @type RegExp
	       */
	      'escape': reEscape,

	      /**
	       * Used to detect code to be evaluated.
	       *
	       * @memberOf _.templateSettings
	       * @type RegExp
	       */
	      'evaluate': reEvaluate,

	      /**
	       * Used to detect `data` property values to inject.
	       *
	       * @memberOf _.templateSettings
	       * @type RegExp
	       */
	      'interpolate': reInterpolate,

	      /**
	       * Used to reference the data object in the template text.
	       *
	       * @memberOf _.templateSettings
	       * @type string
	       */
	      'variable': '',

	      /**
	       * Used to import variables into the compiled template.
	       *
	       * @memberOf _.templateSettings
	       * @type Object
	       */
	      'imports': {

	        /**
	         * A reference to the `lodash` function.
	         *
	         * @memberOf _.templateSettings.imports
	         * @type Function
	         */
	        '_': lodash
	      }
	    };

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a lazy wrapper object which wraps `value` to enable lazy evaluation.
	     *
	     * @private
	     * @param {*} value The value to wrap.
	     */
	    function LazyWrapper(value) {
	      this.__wrapped__ = value;
	      this.__actions__ = [];
	      this.__dir__ = 1;
	      this.__filtered__ = false;
	      this.__iteratees__ = [];
	      this.__takeCount__ = POSITIVE_INFINITY;
	      this.__views__ = [];
	    }

	    /**
	     * Creates a clone of the lazy wrapper object.
	     *
	     * @private
	     * @name clone
	     * @memberOf LazyWrapper
	     * @returns {Object} Returns the cloned `LazyWrapper` object.
	     */
	    function lazyClone() {
	      var result = new LazyWrapper(this.__wrapped__);
	      result.__actions__ = arrayCopy(this.__actions__);
	      result.__dir__ = this.__dir__;
	      result.__filtered__ = this.__filtered__;
	      result.__iteratees__ = arrayCopy(this.__iteratees__);
	      result.__takeCount__ = this.__takeCount__;
	      result.__views__ = arrayCopy(this.__views__);
	      return result;
	    }

	    /**
	     * Reverses the direction of lazy iteration.
	     *
	     * @private
	     * @name reverse
	     * @memberOf LazyWrapper
	     * @returns {Object} Returns the new reversed `LazyWrapper` object.
	     */
	    function lazyReverse() {
	      if (this.__filtered__) {
	        var result = new LazyWrapper(this);
	        result.__dir__ = -1;
	        result.__filtered__ = true;
	      } else {
	        result = this.clone();
	        result.__dir__ *= -1;
	      }
	      return result;
	    }

	    /**
	     * Extracts the unwrapped value from its lazy wrapper.
	     *
	     * @private
	     * @name value
	     * @memberOf LazyWrapper
	     * @returns {*} Returns the unwrapped value.
	     */
	    function lazyValue() {
	      var array = this.__wrapped__.value(),
	          dir = this.__dir__,
	          isArr = isArray(array),
	          isRight = dir < 0,
	          arrLength = isArr ? array.length : 0,
	          view = getView(0, arrLength, this.__views__),
	          start = view.start,
	          end = view.end,
	          length = end - start,
	          index = isRight ? end : (start - 1),
	          iteratees = this.__iteratees__,
	          iterLength = iteratees.length,
	          resIndex = 0,
	          takeCount = nativeMin(length, this.__takeCount__);

	      if (!isArr || arrLength < LARGE_ARRAY_SIZE || (arrLength == length && takeCount == length)) {
	        return baseWrapperValue((isRight && isArr) ? array.reverse() : array, this.__actions__);
	      }
	      var result = [];

	      outer:
	      while (length-- && resIndex < takeCount) {
	        index += dir;

	        var iterIndex = -1,
	            value = array[index];

	        while (++iterIndex < iterLength) {
	          var data = iteratees[iterIndex],
	              iteratee = data.iteratee,
	              type = data.type,
	              computed = iteratee(value);

	          if (type == LAZY_MAP_FLAG) {
	            value = computed;
	          } else if (!computed) {
	            if (type == LAZY_FILTER_FLAG) {
	              continue outer;
	            } else {
	              break outer;
	            }
	          }
	        }
	        result[resIndex++] = value;
	      }
	      return result;
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a cache object to store key/value pairs.
	     *
	     * @private
	     * @static
	     * @name Cache
	     * @memberOf _.memoize
	     */
	    function MapCache() {
	      this.__data__ = {};
	    }

	    /**
	     * Removes `key` and its value from the cache.
	     *
	     * @private
	     * @name delete
	     * @memberOf _.memoize.Cache
	     * @param {string} key The key of the value to remove.
	     * @returns {boolean} Returns `true` if the entry was removed successfully, else `false`.
	     */
	    function mapDelete(key) {
	      return this.has(key) && delete this.__data__[key];
	    }

	    /**
	     * Gets the cached value for `key`.
	     *
	     * @private
	     * @name get
	     * @memberOf _.memoize.Cache
	     * @param {string} key The key of the value to get.
	     * @returns {*} Returns the cached value.
	     */
	    function mapGet(key) {
	      return key == '__proto__' ? undefined : this.__data__[key];
	    }

	    /**
	     * Checks if a cached value for `key` exists.
	     *
	     * @private
	     * @name has
	     * @memberOf _.memoize.Cache
	     * @param {string} key The key of the entry to check.
	     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
	     */
	    function mapHas(key) {
	      return key != '__proto__' && hasOwnProperty.call(this.__data__, key);
	    }

	    /**
	     * Sets `value` to `key` of the cache.
	     *
	     * @private
	     * @name set
	     * @memberOf _.memoize.Cache
	     * @param {string} key The key of the value to cache.
	     * @param {*} value The value to cache.
	     * @returns {Object} Returns the cache object.
	     */
	    function mapSet(key, value) {
	      if (key != '__proto__') {
	        this.__data__[key] = value;
	      }
	      return this;
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     *
	     * Creates a cache object to store unique values.
	     *
	     * @private
	     * @param {Array} [values] The values to cache.
	     */
	    function SetCache(values) {
	      var length = values ? values.length : 0;

	      this.data = { 'hash': nativeCreate(null), 'set': new Set };
	      while (length--) {
	        this.push(values[length]);
	      }
	    }

	    /**
	     * Checks if `value` is in `cache` mimicking the return signature of
	     * `_.indexOf` by returning `0` if the value is found, else `-1`.
	     *
	     * @private
	     * @param {Object} cache The cache to search.
	     * @param {*} value The value to search for.
	     * @returns {number} Returns `0` if `value` is found, else `-1`.
	     */
	    function cacheIndexOf(cache, value) {
	      var data = cache.data,
	          result = (typeof value == 'string' || isObject(value)) ? data.set.has(value) : data.hash[value];

	      return result ? 0 : -1;
	    }

	    /**
	     * Adds `value` to the cache.
	     *
	     * @private
	     * @name push
	     * @memberOf SetCache
	     * @param {*} value The value to cache.
	     */
	    function cachePush(value) {
	      var data = this.data;
	      if (typeof value == 'string' || isObject(value)) {
	        data.set.add(value);
	      } else {
	        data.hash[value] = true;
	      }
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a new array joining `array` with `other`.
	     *
	     * @private
	     * @param {Array} array The array to join.
	     * @param {Array} other The other array to join.
	     * @returns {Array} Returns the new concatenated array.
	     */
	    function arrayConcat(array, other) {
	      var index = -1,
	          length = array.length,
	          othIndex = -1,
	          othLength = other.length,
	          result = Array(length + othLength);

	      while (++index < length) {
	        result[index] = array[index];
	      }
	      while (++othIndex < othLength) {
	        result[index++] = other[othIndex];
	      }
	      return result;
	    }

	    /**
	     * Copies the values of `source` to `array`.
	     *
	     * @private
	     * @param {Array} source The array to copy values from.
	     * @param {Array} [array=[]] The array to copy values to.
	     * @returns {Array} Returns `array`.
	     */
	    function arrayCopy(source, array) {
	      var index = -1,
	          length = source.length;

	      array || (array = Array(length));
	      while (++index < length) {
	        array[index] = source[index];
	      }
	      return array;
	    }

	    /**
	     * A specialized version of `_.forEach` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array} Returns `array`.
	     */
	    function arrayEach(array, iteratee) {
	      var index = -1,
	          length = array.length;

	      while (++index < length) {
	        if (iteratee(array[index], index, array) === false) {
	          break;
	        }
	      }
	      return array;
	    }

	    /**
	     * A specialized version of `_.forEachRight` for arrays without support for
	     * callback shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array} Returns `array`.
	     */
	    function arrayEachRight(array, iteratee) {
	      var length = array.length;

	      while (length--) {
	        if (iteratee(array[length], length, array) === false) {
	          break;
	        }
	      }
	      return array;
	    }

	    /**
	     * A specialized version of `_.every` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {boolean} Returns `true` if all elements pass the predicate check,
	     *  else `false`.
	     */
	    function arrayEvery(array, predicate) {
	      var index = -1,
	          length = array.length;

	      while (++index < length) {
	        if (!predicate(array[index], index, array)) {
	          return false;
	        }
	      }
	      return true;
	    }

	    /**
	     * A specialized version of `baseExtremum` for arrays which invokes `iteratee`
	     * with one argument: (value).
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {Function} comparator The function used to compare values.
	     * @param {*} exValue The initial extremum value.
	     * @returns {*} Returns the extremum value.
	     */
	    function arrayExtremum(array, iteratee, comparator, exValue) {
	      var index = -1,
	          length = array.length,
	          computed = exValue,
	          result = computed;

	      while (++index < length) {
	        var value = array[index],
	            current = +iteratee(value);

	        if (comparator(current, computed)) {
	          computed = current;
	          result = value;
	        }
	      }
	      return result;
	    }

	    /**
	     * A specialized version of `_.filter` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {Array} Returns the new filtered array.
	     */
	    function arrayFilter(array, predicate) {
	      var index = -1,
	          length = array.length,
	          resIndex = -1,
	          result = [];

	      while (++index < length) {
	        var value = array[index];
	        if (predicate(value, index, array)) {
	          result[++resIndex] = value;
	        }
	      }
	      return result;
	    }

	    /**
	     * A specialized version of `_.map` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array} Returns the new mapped array.
	     */
	    function arrayMap(array, iteratee) {
	      var index = -1,
	          length = array.length,
	          result = Array(length);

	      while (++index < length) {
	        result[index] = iteratee(array[index], index, array);
	      }
	      return result;
	    }

	    /**
	     * Appends the elements of `values` to `array`.
	     *
	     * @private
	     * @param {Array} array The array to modify.
	     * @param {Array} values The values to append.
	     * @returns {Array} Returns `array`.
	     */
	    function arrayPush(array, values) {
	      var index = -1,
	          length = values.length,
	          offset = array.length;

	      while (++index < length) {
	        array[offset + index] = values[index];
	      }
	      return array;
	    }

	    /**
	     * A specialized version of `_.reduce` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {*} [accumulator] The initial value.
	     * @param {boolean} [initFromArray] Specify using the first element of `array`
	     *  as the initial value.
	     * @returns {*} Returns the accumulated value.
	     */
	    function arrayReduce(array, iteratee, accumulator, initFromArray) {
	      var index = -1,
	          length = array.length;

	      if (initFromArray && length) {
	        accumulator = array[++index];
	      }
	      while (++index < length) {
	        accumulator = iteratee(accumulator, array[index], index, array);
	      }
	      return accumulator;
	    }

	    /**
	     * A specialized version of `_.reduceRight` for arrays without support for
	     * callback shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {*} [accumulator] The initial value.
	     * @param {boolean} [initFromArray] Specify using the last element of `array`
	     *  as the initial value.
	     * @returns {*} Returns the accumulated value.
	     */
	    function arrayReduceRight(array, iteratee, accumulator, initFromArray) {
	      var length = array.length;
	      if (initFromArray && length) {
	        accumulator = array[--length];
	      }
	      while (length--) {
	        accumulator = iteratee(accumulator, array[length], length, array);
	      }
	      return accumulator;
	    }

	    /**
	     * A specialized version of `_.some` for arrays without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {boolean} Returns `true` if any element passes the predicate check,
	     *  else `false`.
	     */
	    function arraySome(array, predicate) {
	      var index = -1,
	          length = array.length;

	      while (++index < length) {
	        if (predicate(array[index], index, array)) {
	          return true;
	        }
	      }
	      return false;
	    }

	    /**
	     * A specialized version of `_.sum` for arrays without support for callback
	     * shorthands and `this` binding..
	     *
	     * @private
	     * @param {Array} array The array to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {number} Returns the sum.
	     */
	    function arraySum(array, iteratee) {
	      var length = array.length,
	          result = 0;

	      while (length--) {
	        result += +iteratee(array[length]) || 0;
	      }
	      return result;
	    }

	    /**
	     * Used by `_.defaults` to customize its `_.assign` use.
	     *
	     * @private
	     * @param {*} objectValue The destination object property value.
	     * @param {*} sourceValue The source object property value.
	     * @returns {*} Returns the value to assign to the destination object.
	     */
	    function assignDefaults(objectValue, sourceValue) {
	      return objectValue === undefined ? sourceValue : objectValue;
	    }

	    /**
	     * Used by `_.template` to customize its `_.assign` use.
	     *
	     * **Note:** This function is like `assignDefaults` except that it ignores
	     * inherited property values when checking if a property is `undefined`.
	     *
	     * @private
	     * @param {*} objectValue The destination object property value.
	     * @param {*} sourceValue The source object property value.
	     * @param {string} key The key associated with the object and source values.
	     * @param {Object} object The destination object.
	     * @returns {*} Returns the value to assign to the destination object.
	     */
	    function assignOwnDefaults(objectValue, sourceValue, key, object) {
	      return (objectValue === undefined || !hasOwnProperty.call(object, key))
	        ? sourceValue
	        : objectValue;
	    }

	    /**
	     * A specialized version of `_.assign` for customizing assigned values without
	     * support for argument juggling, multiple sources, and `this` binding `customizer`
	     * functions.
	     *
	     * @private
	     * @param {Object} object The destination object.
	     * @param {Object} source The source object.
	     * @param {Function} customizer The function to customize assigned values.
	     * @returns {Object} Returns `object`.
	     */
	    function assignWith(object, source, customizer) {
	      var index = -1,
	          props = keys(source),
	          length = props.length;

	      while (++index < length) {
	        var key = props[index],
	            value = object[key],
	            result = customizer(value, source[key], key, object, source);

	        if ((result === result ? (result !== value) : (value === value)) ||
	            (value === undefined && !(key in object))) {
	          object[key] = result;
	        }
	      }
	      return object;
	    }

	    /**
	     * The base implementation of `_.assign` without support for argument juggling,
	     * multiple sources, and `customizer` functions.
	     *
	     * @private
	     * @param {Object} object The destination object.
	     * @param {Object} source The source object.
	     * @returns {Object} Returns `object`.
	     */
	    function baseAssign(object, source) {
	      return source == null
	        ? object
	        : baseCopy(source, keys(source), object);
	    }

	    /**
	     * The base implementation of `_.at` without support for string collections
	     * and individual key arguments.
	     *
	     * @private
	     * @param {Array|Object} collection The collection to iterate over.
	     * @param {number[]|string[]} props The property names or indexes of elements to pick.
	     * @returns {Array} Returns the new array of picked elements.
	     */
	    function baseAt(collection, props) {
	      var index = -1,
	          isNil = collection == null,
	          isArr = !isNil && isArrayLike(collection),
	          length = isArr ? collection.length : 0,
	          propsLength = props.length,
	          result = Array(propsLength);

	      while(++index < propsLength) {
	        var key = props[index];
	        if (isArr) {
	          result[index] = isIndex(key, length) ? collection[key] : undefined;
	        } else {
	          result[index] = isNil ? undefined : collection[key];
	        }
	      }
	      return result;
	    }

	    /**
	     * Copies properties of `source` to `object`.
	     *
	     * @private
	     * @param {Object} source The object to copy properties from.
	     * @param {Array} props The property names to copy.
	     * @param {Object} [object={}] The object to copy properties to.
	     * @returns {Object} Returns `object`.
	     */
	    function baseCopy(source, props, object) {
	      object || (object = {});

	      var index = -1,
	          length = props.length;

	      while (++index < length) {
	        var key = props[index];
	        object[key] = source[key];
	      }
	      return object;
	    }

	    /**
	     * The base implementation of `_.callback` which supports specifying the
	     * number of arguments to provide to `func`.
	     *
	     * @private
	     * @param {*} [func=_.identity] The value to convert to a callback.
	     * @param {*} [thisArg] The `this` binding of `func`.
	     * @param {number} [argCount] The number of arguments to provide to `func`.
	     * @returns {Function} Returns the callback.
	     */
	    function baseCallback(func, thisArg, argCount) {
	      var type = typeof func;
	      if (type == 'function') {
	        return thisArg === undefined
	          ? func
	          : bindCallback(func, thisArg, argCount);
	      }
	      if (func == null) {
	        return identity;
	      }
	      if (type == 'object') {
	        return baseMatches(func);
	      }
	      return thisArg === undefined
	        ? property(func)
	        : baseMatchesProperty(func, thisArg);
	    }

	    /**
	     * The base implementation of `_.clone` without support for argument juggling
	     * and `this` binding `customizer` functions.
	     *
	     * @private
	     * @param {*} value The value to clone.
	     * @param {boolean} [isDeep] Specify a deep clone.
	     * @param {Function} [customizer] The function to customize cloning values.
	     * @param {string} [key] The key of `value`.
	     * @param {Object} [object] The object `value` belongs to.
	     * @param {Array} [stackA=[]] Tracks traversed source objects.
	     * @param {Array} [stackB=[]] Associates clones with source counterparts.
	     * @returns {*} Returns the cloned value.
	     */
	    function baseClone(value, isDeep, customizer, key, object, stackA, stackB) {
	      var result;
	      if (customizer) {
	        result = object ? customizer(value, key, object) : customizer(value);
	      }
	      if (result !== undefined) {
	        return result;
	      }
	      if (!isObject(value)) {
	        return value;
	      }
	      var isArr = isArray(value);
	      if (isArr) {
	        result = initCloneArray(value);
	        if (!isDeep) {
	          return arrayCopy(value, result);
	        }
	      } else {
	        var tag = objToString.call(value),
	            isFunc = tag == funcTag;

	        if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
	          result = initCloneObject(isFunc ? {} : value);
	          if (!isDeep) {
	            return baseAssign(result, value);
	          }
	        } else {
	          return cloneableTags[tag]
	            ? initCloneByTag(value, tag, isDeep)
	            : (object ? value : {});
	        }
	      }
	      // Check for circular references and return its corresponding clone.
	      stackA || (stackA = []);
	      stackB || (stackB = []);

	      var length = stackA.length;
	      while (length--) {
	        if (stackA[length] == value) {
	          return stackB[length];
	        }
	      }
	      // Add the source value to the stack of traversed objects and associate it with its clone.
	      stackA.push(value);
	      stackB.push(result);

	      // Recursively populate clone (susceptible to call stack limits).
	      (isArr ? arrayEach : baseForOwn)(value, function(subValue, key) {
	        result[key] = baseClone(subValue, isDeep, customizer, key, value, stackA, stackB);
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.create` without support for assigning
	     * properties to the created object.
	     *
	     * @private
	     * @param {Object} prototype The object to inherit from.
	     * @returns {Object} Returns the new object.
	     */
	    var baseCreate = (function() {
	      function object() {}
	      return function(prototype) {
	        if (isObject(prototype)) {
	          object.prototype = prototype;
	          var result = new object;
	          object.prototype = undefined;
	        }
	        return result || {};
	      };
	    }());

	    /**
	     * The base implementation of `_.delay` and `_.defer` which accepts an index
	     * of where to slice the arguments to provide to `func`.
	     *
	     * @private
	     * @param {Function} func The function to delay.
	     * @param {number} wait The number of milliseconds to delay invocation.
	     * @param {Object} args The arguments provide to `func`.
	     * @returns {number} Returns the timer id.
	     */
	    function baseDelay(func, wait, args) {
	      if (typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      return setTimeout(function() { func.apply(undefined, args); }, wait);
	    }

	    /**
	     * The base implementation of `_.difference` which accepts a single array
	     * of values to exclude.
	     *
	     * @private
	     * @param {Array} array The array to inspect.
	     * @param {Array} values The values to exclude.
	     * @returns {Array} Returns the new array of filtered values.
	     */
	    function baseDifference(array, values) {
	      var length = array ? array.length : 0,
	          result = [];

	      if (!length) {
	        return result;
	      }
	      var index = -1,
	          indexOf = getIndexOf(),
	          isCommon = indexOf == baseIndexOf,
	          cache = (isCommon && values.length >= LARGE_ARRAY_SIZE) ? createCache(values) : null,
	          valuesLength = values.length;

	      if (cache) {
	        indexOf = cacheIndexOf;
	        isCommon = false;
	        values = cache;
	      }
	      outer:
	      while (++index < length) {
	        var value = array[index];

	        if (isCommon && value === value) {
	          var valuesIndex = valuesLength;
	          while (valuesIndex--) {
	            if (values[valuesIndex] === value) {
	              continue outer;
	            }
	          }
	          result.push(value);
	        }
	        else if (indexOf(values, value, 0) < 0) {
	          result.push(value);
	        }
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `_.forEach` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array|Object|string} Returns `collection`.
	     */
	    var baseEach = createBaseEach(baseForOwn);

	    /**
	     * The base implementation of `_.forEachRight` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array|Object|string} Returns `collection`.
	     */
	    var baseEachRight = createBaseEach(baseForOwnRight, true);

	    /**
	     * The base implementation of `_.every` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {boolean} Returns `true` if all elements pass the predicate check,
	     *  else `false`
	     */
	    function baseEvery(collection, predicate) {
	      var result = true;
	      baseEach(collection, function(value, index, collection) {
	        result = !!predicate(value, index, collection);
	        return result;
	      });
	      return result;
	    }

	    /**
	     * Gets the extremum value of `collection` invoking `iteratee` for each value
	     * in `collection` to generate the criterion by which the value is ranked.
	     * The `iteratee` is invoked with three arguments: (value, index|key, collection).
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {Function} comparator The function used to compare values.
	     * @param {*} exValue The initial extremum value.
	     * @returns {*} Returns the extremum value.
	     */
	    function baseExtremum(collection, iteratee, comparator, exValue) {
	      var computed = exValue,
	          result = computed;

	      baseEach(collection, function(value, index, collection) {
	        var current = +iteratee(value, index, collection);
	        if (comparator(current, computed) || (current === exValue && current === result)) {
	          computed = current;
	          result = value;
	        }
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.fill` without an iteratee call guard.
	     *
	     * @private
	     * @param {Array} array The array to fill.
	     * @param {*} value The value to fill `array` with.
	     * @param {number} [start=0] The start position.
	     * @param {number} [end=array.length] The end position.
	     * @returns {Array} Returns `array`.
	     */
	    function baseFill(array, value, start, end) {
	      var length = array.length;

	      start = start == null ? 0 : (+start || 0);
	      if (start < 0) {
	        start = -start > length ? 0 : (length + start);
	      }
	      end = (end === undefined || end > length) ? length : (+end || 0);
	      if (end < 0) {
	        end += length;
	      }
	      length = start > end ? 0 : (end >>> 0);
	      start >>>= 0;

	      while (start < length) {
	        array[start++] = value;
	      }
	      return array;
	    }

	    /**
	     * The base implementation of `_.filter` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {Array} Returns the new filtered array.
	     */
	    function baseFilter(collection, predicate) {
	      var result = [];
	      baseEach(collection, function(value, index, collection) {
	        if (predicate(value, index, collection)) {
	          result.push(value);
	        }
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.find`, `_.findLast`, `_.findKey`, and `_.findLastKey`,
	     * without support for callback shorthands and `this` binding, which iterates
	     * over `collection` using the provided `eachFunc`.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {Function} predicate The function invoked per iteration.
	     * @param {Function} eachFunc The function to iterate over `collection`.
	     * @param {boolean} [retKey] Specify returning the key of the found element
	     *  instead of the element itself.
	     * @returns {*} Returns the found element or its key, else `undefined`.
	     */
	    function baseFind(collection, predicate, eachFunc, retKey) {
	      var result;
	      eachFunc(collection, function(value, key, collection) {
	        if (predicate(value, key, collection)) {
	          result = retKey ? key : value;
	          return false;
	        }
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.flatten` with added support for restricting
	     * flattening and specifying the start index.
	     *
	     * @private
	     * @param {Array} array The array to flatten.
	     * @param {boolean} [isDeep] Specify a deep flatten.
	     * @param {boolean} [isStrict] Restrict flattening to arrays-like objects.
	     * @param {Array} [result=[]] The initial result value.
	     * @returns {Array} Returns the new flattened array.
	     */
	    function baseFlatten(array, isDeep, isStrict, result) {
	      result || (result = []);

	      var index = -1,
	          length = array.length;

	      while (++index < length) {
	        var value = array[index];
	        if (isObjectLike(value) && isArrayLike(value) &&
	            (isStrict || isArray(value) || isArguments(value))) {
	          if (isDeep) {
	            // Recursively flatten arrays (susceptible to call stack limits).
	            baseFlatten(value, isDeep, isStrict, result);
	          } else {
	            arrayPush(result, value);
	          }
	        } else if (!isStrict) {
	          result[result.length] = value;
	        }
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `baseForIn` and `baseForOwn` which iterates
	     * over `object` properties returned by `keysFunc` invoking `iteratee` for
	     * each property. Iteratee functions may exit iteration early by explicitly
	     * returning `false`.
	     *
	     * @private
	     * @param {Object} object The object to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {Function} keysFunc The function to get the keys of `object`.
	     * @returns {Object} Returns `object`.
	     */
	    var baseFor = createBaseFor();

	    /**
	     * This function is like `baseFor` except that it iterates over properties
	     * in the opposite order.
	     *
	     * @private
	     * @param {Object} object The object to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {Function} keysFunc The function to get the keys of `object`.
	     * @returns {Object} Returns `object`.
	     */
	    var baseForRight = createBaseFor(true);

	    /**
	     * The base implementation of `_.forIn` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Object} object The object to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Object} Returns `object`.
	     */
	    function baseForIn(object, iteratee) {
	      return baseFor(object, iteratee, keysIn);
	    }

	    /**
	     * The base implementation of `_.forOwn` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Object} object The object to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Object} Returns `object`.
	     */
	    function baseForOwn(object, iteratee) {
	      return baseFor(object, iteratee, keys);
	    }

	    /**
	     * The base implementation of `_.forOwnRight` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Object} object The object to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Object} Returns `object`.
	     */
	    function baseForOwnRight(object, iteratee) {
	      return baseForRight(object, iteratee, keys);
	    }

	    /**
	     * The base implementation of `_.functions` which creates an array of
	     * `object` function property names filtered from those provided.
	     *
	     * @private
	     * @param {Object} object The object to inspect.
	     * @param {Array} props The property names to filter.
	     * @returns {Array} Returns the new array of filtered property names.
	     */
	    function baseFunctions(object, props) {
	      var index = -1,
	          length = props.length,
	          resIndex = -1,
	          result = [];

	      while (++index < length) {
	        var key = props[index];
	        if (isFunction(object[key])) {
	          result[++resIndex] = key;
	        }
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `get` without support for string paths
	     * and default values.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @param {Array} path The path of the property to get.
	     * @param {string} [pathKey] The key representation of path.
	     * @returns {*} Returns the resolved value.
	     */
	    function baseGet(object, path, pathKey) {
	      if (object == null) {
	        return;
	      }
	      if (pathKey !== undefined && pathKey in toObject(object)) {
	        path = [pathKey];
	      }
	      var index = 0,
	          length = path.length;

	      while (object != null && index < length) {
	        object = object[path[index++]];
	      }
	      return (index && index == length) ? object : undefined;
	    }

	    /**
	     * The base implementation of `_.isEqual` without support for `this` binding
	     * `customizer` functions.
	     *
	     * @private
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @param {Function} [customizer] The function to customize comparing values.
	     * @param {boolean} [isLoose] Specify performing partial comparisons.
	     * @param {Array} [stackA] Tracks traversed `value` objects.
	     * @param {Array} [stackB] Tracks traversed `other` objects.
	     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
	     */
	    function baseIsEqual(value, other, customizer, isLoose, stackA, stackB) {
	      if (value === other) {
	        return true;
	      }
	      if (value == null || other == null || (!isObject(value) && !isObjectLike(other))) {
	        return value !== value && other !== other;
	      }
	      return baseIsEqualDeep(value, other, baseIsEqual, customizer, isLoose, stackA, stackB);
	    }

	    /**
	     * A specialized version of `baseIsEqual` for arrays and objects which performs
	     * deep comparisons and tracks traversed objects enabling objects with circular
	     * references to be compared.
	     *
	     * @private
	     * @param {Object} object The object to compare.
	     * @param {Object} other The other object to compare.
	     * @param {Function} equalFunc The function to determine equivalents of values.
	     * @param {Function} [customizer] The function to customize comparing objects.
	     * @param {boolean} [isLoose] Specify performing partial comparisons.
	     * @param {Array} [stackA=[]] Tracks traversed `value` objects.
	     * @param {Array} [stackB=[]] Tracks traversed `other` objects.
	     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
	     */
	    function baseIsEqualDeep(object, other, equalFunc, customizer, isLoose, stackA, stackB) {
	      var objIsArr = isArray(object),
	          othIsArr = isArray(other),
	          objTag = arrayTag,
	          othTag = arrayTag;

	      if (!objIsArr) {
	        objTag = objToString.call(object);
	        if (objTag == argsTag) {
	          objTag = objectTag;
	        } else if (objTag != objectTag) {
	          objIsArr = isTypedArray(object);
	        }
	      }
	      if (!othIsArr) {
	        othTag = objToString.call(other);
	        if (othTag == argsTag) {
	          othTag = objectTag;
	        } else if (othTag != objectTag) {
	          othIsArr = isTypedArray(other);
	        }
	      }
	      var objIsObj = objTag == objectTag,
	          othIsObj = othTag == objectTag,
	          isSameTag = objTag == othTag;

	      if (isSameTag && !(objIsArr || objIsObj)) {
	        return equalByTag(object, other, objTag);
	      }
	      if (!isLoose) {
	        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
	            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

	        if (objIsWrapped || othIsWrapped) {
	          return equalFunc(objIsWrapped ? object.value() : object, othIsWrapped ? other.value() : other, customizer, isLoose, stackA, stackB);
	        }
	      }
	      if (!isSameTag) {
	        return false;
	      }
	      // Assume cyclic values are equal.
	      // For more information on detecting circular references see https://es5.github.io/#JO.
	      stackA || (stackA = []);
	      stackB || (stackB = []);

	      var length = stackA.length;
	      while (length--) {
	        if (stackA[length] == object) {
	          return stackB[length] == other;
	        }
	      }
	      // Add `object` and `other` to the stack of traversed objects.
	      stackA.push(object);
	      stackB.push(other);

	      var result = (objIsArr ? equalArrays : equalObjects)(object, other, equalFunc, customizer, isLoose, stackA, stackB);

	      stackA.pop();
	      stackB.pop();

	      return result;
	    }

	    /**
	     * The base implementation of `_.isMatch` without support for callback
	     * shorthands and `this` binding.
	     *
	     * @private
	     * @param {Object} object The object to inspect.
	     * @param {Array} matchData The propery names, values, and compare flags to match.
	     * @param {Function} [customizer] The function to customize comparing objects.
	     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
	     */
	    function baseIsMatch(object, matchData, customizer) {
	      var index = matchData.length,
	          length = index,
	          noCustomizer = !customizer;

	      if (object == null) {
	        return !length;
	      }
	      object = toObject(object);
	      while (index--) {
	        var data = matchData[index];
	        if ((noCustomizer && data[2])
	              ? data[1] !== object[data[0]]
	              : !(data[0] in object)
	            ) {
	          return false;
	        }
	      }
	      while (++index < length) {
	        data = matchData[index];
	        var key = data[0],
	            objValue = object[key],
	            srcValue = data[1];

	        if (noCustomizer && data[2]) {
	          if (objValue === undefined && !(key in object)) {
	            return false;
	          }
	        } else {
	          var result = customizer ? customizer(objValue, srcValue, key) : undefined;
	          if (!(result === undefined ? baseIsEqual(srcValue, objValue, customizer, true) : result)) {
	            return false;
	          }
	        }
	      }
	      return true;
	    }

	    /**
	     * The base implementation of `_.map` without support for callback shorthands
	     * and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {Array} Returns the new mapped array.
	     */
	    function baseMap(collection, iteratee) {
	      var index = -1,
	          result = isArrayLike(collection) ? Array(collection.length) : [];

	      baseEach(collection, function(value, key, collection) {
	        result[++index] = iteratee(value, key, collection);
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.matches` which does not clone `source`.
	     *
	     * @private
	     * @param {Object} source The object of property values to match.
	     * @returns {Function} Returns the new function.
	     */
	    function baseMatches(source) {
	      var matchData = getMatchData(source);
	      if (matchData.length == 1 && matchData[0][2]) {
	        var key = matchData[0][0],
	            value = matchData[0][1];

	        return function(object) {
	          if (object == null) {
	            return false;
	          }
	          return object[key] === value && (value !== undefined || (key in toObject(object)));
	        };
	      }
	      return function(object) {
	        return baseIsMatch(object, matchData);
	      };
	    }

	    /**
	     * The base implementation of `_.matchesProperty` which does not clone `srcValue`.
	     *
	     * @private
	     * @param {string} path The path of the property to get.
	     * @param {*} srcValue The value to compare.
	     * @returns {Function} Returns the new function.
	     */
	    function baseMatchesProperty(path, srcValue) {
	      var isArr = isArray(path),
	          isCommon = isKey(path) && isStrictComparable(srcValue),
	          pathKey = (path + '');

	      path = toPath(path);
	      return function(object) {
	        if (object == null) {
	          return false;
	        }
	        var key = pathKey;
	        object = toObject(object);
	        if ((isArr || !isCommon) && !(key in object)) {
	          object = path.length == 1 ? object : baseGet(object, baseSlice(path, 0, -1));
	          if (object == null) {
	            return false;
	          }
	          key = last(path);
	          object = toObject(object);
	        }
	        return object[key] === srcValue
	          ? (srcValue !== undefined || (key in object))
	          : baseIsEqual(srcValue, object[key], undefined, true);
	      };
	    }

	    /**
	     * The base implementation of `_.merge` without support for argument juggling,
	     * multiple sources, and `this` binding `customizer` functions.
	     *
	     * @private
	     * @param {Object} object The destination object.
	     * @param {Object} source The source object.
	     * @param {Function} [customizer] The function to customize merged values.
	     * @param {Array} [stackA=[]] Tracks traversed source objects.
	     * @param {Array} [stackB=[]] Associates values with source counterparts.
	     * @returns {Object} Returns `object`.
	     */
	    function baseMerge(object, source, customizer, stackA, stackB) {
	      if (!isObject(object)) {
	        return object;
	      }
	      var isSrcArr = isArrayLike(source) && (isArray(source) || isTypedArray(source)),
	          props = isSrcArr ? undefined : keys(source);

	      arrayEach(props || source, function(srcValue, key) {
	        if (props) {
	          key = srcValue;
	          srcValue = source[key];
	        }
	        if (isObjectLike(srcValue)) {
	          stackA || (stackA = []);
	          stackB || (stackB = []);
	          baseMergeDeep(object, source, key, baseMerge, customizer, stackA, stackB);
	        }
	        else {
	          var value = object[key],
	              result = customizer ? customizer(value, srcValue, key, object, source) : undefined,
	              isCommon = result === undefined;

	          if (isCommon) {
	            result = srcValue;
	          }
	          if ((result !== undefined || (isSrcArr && !(key in object))) &&
	              (isCommon || (result === result ? (result !== value) : (value === value)))) {
	            object[key] = result;
	          }
	        }
	      });
	      return object;
	    }

	    /**
	     * A specialized version of `baseMerge` for arrays and objects which performs
	     * deep merges and tracks traversed objects enabling objects with circular
	     * references to be merged.
	     *
	     * @private
	     * @param {Object} object The destination object.
	     * @param {Object} source The source object.
	     * @param {string} key The key of the value to merge.
	     * @param {Function} mergeFunc The function to merge values.
	     * @param {Function} [customizer] The function to customize merged values.
	     * @param {Array} [stackA=[]] Tracks traversed source objects.
	     * @param {Array} [stackB=[]] Associates values with source counterparts.
	     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
	     */
	    function baseMergeDeep(object, source, key, mergeFunc, customizer, stackA, stackB) {
	      var length = stackA.length,
	          srcValue = source[key];

	      while (length--) {
	        if (stackA[length] == srcValue) {
	          object[key] = stackB[length];
	          return;
	        }
	      }
	      var value = object[key],
	          result = customizer ? customizer(value, srcValue, key, object, source) : undefined,
	          isCommon = result === undefined;

	      if (isCommon) {
	        result = srcValue;
	        if (isArrayLike(srcValue) && (isArray(srcValue) || isTypedArray(srcValue))) {
	          result = isArray(value)
	            ? value
	            : (isArrayLike(value) ? arrayCopy(value) : []);
	        }
	        else if (isPlainObject(srcValue) || isArguments(srcValue)) {
	          result = isArguments(value)
	            ? toPlainObject(value)
	            : (isPlainObject(value) ? value : {});
	        }
	        else {
	          isCommon = false;
	        }
	      }
	      // Add the source value to the stack of traversed objects and associate
	      // it with its merged value.
	      stackA.push(srcValue);
	      stackB.push(result);

	      if (isCommon) {
	        // Recursively merge objects and arrays (susceptible to call stack limits).
	        object[key] = mergeFunc(result, srcValue, customizer, stackA, stackB);
	      } else if (result === result ? (result !== value) : (value === value)) {
	        object[key] = result;
	      }
	    }

	    /**
	     * The base implementation of `_.property` without support for deep paths.
	     *
	     * @private
	     * @param {string} key The key of the property to get.
	     * @returns {Function} Returns the new function.
	     */
	    function baseProperty(key) {
	      return function(object) {
	        return object == null ? undefined : object[key];
	      };
	    }

	    /**
	     * A specialized version of `baseProperty` which supports deep paths.
	     *
	     * @private
	     * @param {Array|string} path The path of the property to get.
	     * @returns {Function} Returns the new function.
	     */
	    function basePropertyDeep(path) {
	      var pathKey = (path + '');
	      path = toPath(path);
	      return function(object) {
	        return baseGet(object, path, pathKey);
	      };
	    }

	    /**
	     * The base implementation of `_.pullAt` without support for individual
	     * index arguments and capturing the removed elements.
	     *
	     * @private
	     * @param {Array} array The array to modify.
	     * @param {number[]} indexes The indexes of elements to remove.
	     * @returns {Array} Returns `array`.
	     */
	    function basePullAt(array, indexes) {
	      var length = array ? indexes.length : 0;
	      while (length--) {
	        var index = indexes[length];
	        if (index != previous && isIndex(index)) {
	          var previous = index;
	          splice.call(array, index, 1);
	        }
	      }
	      return array;
	    }

	    /**
	     * The base implementation of `_.random` without support for argument juggling
	     * and returning floating-point numbers.
	     *
	     * @private
	     * @param {number} min The minimum possible value.
	     * @param {number} max The maximum possible value.
	     * @returns {number} Returns the random number.
	     */
	    function baseRandom(min, max) {
	      return min + nativeFloor(nativeRandom() * (max - min + 1));
	    }

	    /**
	     * The base implementation of `_.reduce` and `_.reduceRight` without support
	     * for callback shorthands and `this` binding, which iterates over `collection`
	     * using the provided `eachFunc`.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {*} accumulator The initial value.
	     * @param {boolean} initFromCollection Specify using the first or last element
	     *  of `collection` as the initial value.
	     * @param {Function} eachFunc The function to iterate over `collection`.
	     * @returns {*} Returns the accumulated value.
	     */
	    function baseReduce(collection, iteratee, accumulator, initFromCollection, eachFunc) {
	      eachFunc(collection, function(value, index, collection) {
	        accumulator = initFromCollection
	          ? (initFromCollection = false, value)
	          : iteratee(accumulator, value, index, collection);
	      });
	      return accumulator;
	    }

	    /**
	     * The base implementation of `setData` without support for hot loop detection.
	     *
	     * @private
	     * @param {Function} func The function to associate metadata with.
	     * @param {*} data The metadata.
	     * @returns {Function} Returns `func`.
	     */
	    var baseSetData = !metaMap ? identity : function(func, data) {
	      metaMap.set(func, data);
	      return func;
	    };

	    /**
	     * The base implementation of `_.slice` without an iteratee call guard.
	     *
	     * @private
	     * @param {Array} array The array to slice.
	     * @param {number} [start=0] The start position.
	     * @param {number} [end=array.length] The end position.
	     * @returns {Array} Returns the slice of `array`.
	     */
	    function baseSlice(array, start, end) {
	      var index = -1,
	          length = array.length;

	      start = start == null ? 0 : (+start || 0);
	      if (start < 0) {
	        start = -start > length ? 0 : (length + start);
	      }
	      end = (end === undefined || end > length) ? length : (+end || 0);
	      if (end < 0) {
	        end += length;
	      }
	      length = start > end ? 0 : ((end - start) >>> 0);
	      start >>>= 0;

	      var result = Array(length);
	      while (++index < length) {
	        result[index] = array[index + start];
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `_.some` without support for callback shorthands
	     * and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {boolean} Returns `true` if any element passes the predicate check,
	     *  else `false`.
	     */
	    function baseSome(collection, predicate) {
	      var result;

	      baseEach(collection, function(value, index, collection) {
	        result = predicate(value, index, collection);
	        return !result;
	      });
	      return !!result;
	    }

	    /**
	     * The base implementation of `_.sortBy` which uses `comparer` to define
	     * the sort order of `array` and replaces criteria objects with their
	     * corresponding values.
	     *
	     * @private
	     * @param {Array} array The array to sort.
	     * @param {Function} comparer The function to define sort order.
	     * @returns {Array} Returns `array`.
	     */
	    function baseSortBy(array, comparer) {
	      var length = array.length;

	      array.sort(comparer);
	      while (length--) {
	        array[length] = array[length].value;
	      }
	      return array;
	    }

	    /**
	     * The base implementation of `_.sortByOrder` without param guards.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
	     * @param {boolean[]} orders The sort orders of `iteratees`.
	     * @returns {Array} Returns the new sorted array.
	     */
	    function baseSortByOrder(collection, iteratees, orders) {
	      var callback = getCallback(),
	          index = -1;

	      iteratees = arrayMap(iteratees, function(iteratee) { return callback(iteratee); });

	      var result = baseMap(collection, function(value) {
	        var criteria = arrayMap(iteratees, function(iteratee) { return iteratee(value); });
	        return { 'criteria': criteria, 'index': ++index, 'value': value };
	      });

	      return baseSortBy(result, function(object, other) {
	        return compareMultiple(object, other, orders);
	      });
	    }

	    /**
	     * The base implementation of `_.sum` without support for callback shorthands
	     * and `this` binding.
	     *
	     * @private
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @returns {number} Returns the sum.
	     */
	    function baseSum(collection, iteratee) {
	      var result = 0;
	      baseEach(collection, function(value, index, collection) {
	        result += +iteratee(value, index, collection) || 0;
	      });
	      return result;
	    }

	    /**
	     * The base implementation of `_.uniq` without support for callback shorthands
	     * and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to inspect.
	     * @param {Function} [iteratee] The function invoked per iteration.
	     * @returns {Array} Returns the new duplicate-value-free array.
	     */
	    function baseUniq(array, iteratee) {
	      var index = -1,
	          indexOf = getIndexOf(),
	          length = array.length,
	          isCommon = indexOf == baseIndexOf,
	          isLarge = isCommon && length >= LARGE_ARRAY_SIZE,
	          seen = isLarge ? createCache() : null,
	          result = [];

	      if (seen) {
	        indexOf = cacheIndexOf;
	        isCommon = false;
	      } else {
	        isLarge = false;
	        seen = iteratee ? [] : result;
	      }
	      outer:
	      while (++index < length) {
	        var value = array[index],
	            computed = iteratee ? iteratee(value, index, array) : value;

	        if (isCommon && value === value) {
	          var seenIndex = seen.length;
	          while (seenIndex--) {
	            if (seen[seenIndex] === computed) {
	              continue outer;
	            }
	          }
	          if (iteratee) {
	            seen.push(computed);
	          }
	          result.push(value);
	        }
	        else if (indexOf(seen, computed, 0) < 0) {
	          if (iteratee || isLarge) {
	            seen.push(computed);
	          }
	          result.push(value);
	        }
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `_.values` and `_.valuesIn` which creates an
	     * array of `object` property values corresponding to the property names
	     * of `props`.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @param {Array} props The property names to get values for.
	     * @returns {Object} Returns the array of property values.
	     */
	    function baseValues(object, props) {
	      var index = -1,
	          length = props.length,
	          result = Array(length);

	      while (++index < length) {
	        result[index] = object[props[index]];
	      }
	      return result;
	    }

	    /**
	     * The base implementation of `_.dropRightWhile`, `_.dropWhile`, `_.takeRightWhile`,
	     * and `_.takeWhile` without support for callback shorthands and `this` binding.
	     *
	     * @private
	     * @param {Array} array The array to query.
	     * @param {Function} predicate The function invoked per iteration.
	     * @param {boolean} [isDrop] Specify dropping elements instead of taking them.
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Array} Returns the slice of `array`.
	     */
	    function baseWhile(array, predicate, isDrop, fromRight) {
	      var length = array.length,
	          index = fromRight ? length : -1;

	      while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {}
	      return isDrop
	        ? baseSlice(array, (fromRight ? 0 : index), (fromRight ? index + 1 : length))
	        : baseSlice(array, (fromRight ? index + 1 : 0), (fromRight ? length : index));
	    }

	    /**
	     * The base implementation of `wrapperValue` which returns the result of
	     * performing a sequence of actions on the unwrapped `value`, where each
	     * successive action is supplied the return value of the previous.
	     *
	     * @private
	     * @param {*} value The unwrapped value.
	     * @param {Array} actions Actions to peform to resolve the unwrapped value.
	     * @returns {*} Returns the resolved value.
	     */
	    function baseWrapperValue(value, actions) {
	      var result = value;
	      if (result instanceof LazyWrapper) {
	        result = result.value();
	      }
	      var index = -1,
	          length = actions.length;

	      while (++index < length) {
	        var action = actions[index];
	        result = action.func.apply(action.thisArg, arrayPush([result], action.args));
	      }
	      return result;
	    }

	    /**
	     * Performs a binary search of `array` to determine the index at which `value`
	     * should be inserted into `array` in order to maintain its sort order.
	     *
	     * @private
	     * @param {Array} array The sorted array to inspect.
	     * @param {*} value The value to evaluate.
	     * @param {boolean} [retHighest] Specify returning the highest qualified index.
	     * @returns {number} Returns the index at which `value` should be inserted
	     *  into `array`.
	     */
	    function binaryIndex(array, value, retHighest) {
	      var low = 0,
	          high = array ? array.length : low;

	      if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
	        while (low < high) {
	          var mid = (low + high) >>> 1,
	              computed = array[mid];

	          if ((retHighest ? (computed <= value) : (computed < value)) && computed !== null) {
	            low = mid + 1;
	          } else {
	            high = mid;
	          }
	        }
	        return high;
	      }
	      return binaryIndexBy(array, value, identity, retHighest);
	    }

	    /**
	     * This function is like `binaryIndex` except that it invokes `iteratee` for
	     * `value` and each element of `array` to compute their sort ranking. The
	     * iteratee is invoked with one argument; (value).
	     *
	     * @private
	     * @param {Array} array The sorted array to inspect.
	     * @param {*} value The value to evaluate.
	     * @param {Function} iteratee The function invoked per iteration.
	     * @param {boolean} [retHighest] Specify returning the highest qualified index.
	     * @returns {number} Returns the index at which `value` should be inserted
	     *  into `array`.
	     */
	    function binaryIndexBy(array, value, iteratee, retHighest) {
	      value = iteratee(value);

	      var low = 0,
	          high = array ? array.length : 0,
	          valIsNaN = value !== value,
	          valIsNull = value === null,
	          valIsUndef = value === undefined;

	      while (low < high) {
	        var mid = nativeFloor((low + high) / 2),
	            computed = iteratee(array[mid]),
	            isDef = computed !== undefined,
	            isReflexive = computed === computed;

	        if (valIsNaN) {
	          var setLow = isReflexive || retHighest;
	        } else if (valIsNull) {
	          setLow = isReflexive && isDef && (retHighest || computed != null);
	        } else if (valIsUndef) {
	          setLow = isReflexive && (retHighest || isDef);
	        } else if (computed == null) {
	          setLow = false;
	        } else {
	          setLow = retHighest ? (computed <= value) : (computed < value);
	        }
	        if (setLow) {
	          low = mid + 1;
	        } else {
	          high = mid;
	        }
	      }
	      return nativeMin(high, MAX_ARRAY_INDEX);
	    }

	    /**
	     * A specialized version of `baseCallback` which only supports `this` binding
	     * and specifying the number of arguments to provide to `func`.
	     *
	     * @private
	     * @param {Function} func The function to bind.
	     * @param {*} thisArg The `this` binding of `func`.
	     * @param {number} [argCount] The number of arguments to provide to `func`.
	     * @returns {Function} Returns the callback.
	     */
	    function bindCallback(func, thisArg, argCount) {
	      if (typeof func != 'function') {
	        return identity;
	      }
	      if (thisArg === undefined) {
	        return func;
	      }
	      switch (argCount) {
	        case 1: return function(value) {
	          return func.call(thisArg, value);
	        };
	        case 3: return function(value, index, collection) {
	          return func.call(thisArg, value, index, collection);
	        };
	        case 4: return function(accumulator, value, index, collection) {
	          return func.call(thisArg, accumulator, value, index, collection);
	        };
	        case 5: return function(value, other, key, object, source) {
	          return func.call(thisArg, value, other, key, object, source);
	        };
	      }
	      return function() {
	        return func.apply(thisArg, arguments);
	      };
	    }

	    /**
	     * Creates a clone of the given array buffer.
	     *
	     * @private
	     * @param {ArrayBuffer} buffer The array buffer to clone.
	     * @returns {ArrayBuffer} Returns the cloned array buffer.
	     */
	    function bufferClone(buffer) {
	      var result = new ArrayBuffer(buffer.byteLength),
	          view = new Uint8Array(result);

	      view.set(new Uint8Array(buffer));
	      return result;
	    }

	    /**
	     * Creates an array that is the composition of partially applied arguments,
	     * placeholders, and provided arguments into a single array of arguments.
	     *
	     * @private
	     * @param {Array|Object} args The provided arguments.
	     * @param {Array} partials The arguments to prepend to those provided.
	     * @param {Array} holders The `partials` placeholder indexes.
	     * @returns {Array} Returns the new array of composed arguments.
	     */
	    function composeArgs(args, partials, holders) {
	      var holdersLength = holders.length,
	          argsIndex = -1,
	          argsLength = nativeMax(args.length - holdersLength, 0),
	          leftIndex = -1,
	          leftLength = partials.length,
	          result = Array(leftLength + argsLength);

	      while (++leftIndex < leftLength) {
	        result[leftIndex] = partials[leftIndex];
	      }
	      while (++argsIndex < holdersLength) {
	        result[holders[argsIndex]] = args[argsIndex];
	      }
	      while (argsLength--) {
	        result[leftIndex++] = args[argsIndex++];
	      }
	      return result;
	    }

	    /**
	     * This function is like `composeArgs` except that the arguments composition
	     * is tailored for `_.partialRight`.
	     *
	     * @private
	     * @param {Array|Object} args The provided arguments.
	     * @param {Array} partials The arguments to append to those provided.
	     * @param {Array} holders The `partials` placeholder indexes.
	     * @returns {Array} Returns the new array of composed arguments.
	     */
	    function composeArgsRight(args, partials, holders) {
	      var holdersIndex = -1,
	          holdersLength = holders.length,
	          argsIndex = -1,
	          argsLength = nativeMax(args.length - holdersLength, 0),
	          rightIndex = -1,
	          rightLength = partials.length,
	          result = Array(argsLength + rightLength);

	      while (++argsIndex < argsLength) {
	        result[argsIndex] = args[argsIndex];
	      }
	      var offset = argsIndex;
	      while (++rightIndex < rightLength) {
	        result[offset + rightIndex] = partials[rightIndex];
	      }
	      while (++holdersIndex < holdersLength) {
	        result[offset + holders[holdersIndex]] = args[argsIndex++];
	      }
	      return result;
	    }

	    /**
	     * Creates a `_.countBy`, `_.groupBy`, `_.indexBy`, or `_.partition` function.
	     *
	     * @private
	     * @param {Function} setter The function to set keys and values of the accumulator object.
	     * @param {Function} [initializer] The function to initialize the accumulator object.
	     * @returns {Function} Returns the new aggregator function.
	     */
	    function createAggregator(setter, initializer) {
	      return function(collection, iteratee, thisArg) {
	        var result = initializer ? initializer() : {};
	        iteratee = getCallback(iteratee, thisArg, 3);

	        if (isArray(collection)) {
	          var index = -1,
	              length = collection.length;

	          while (++index < length) {
	            var value = collection[index];
	            setter(result, value, iteratee(value, index, collection), collection);
	          }
	        } else {
	          baseEach(collection, function(value, key, collection) {
	            setter(result, value, iteratee(value, key, collection), collection);
	          });
	        }
	        return result;
	      };
	    }

	    /**
	     * Creates a `_.assign`, `_.defaults`, or `_.merge` function.
	     *
	     * @private
	     * @param {Function} assigner The function to assign values.
	     * @returns {Function} Returns the new assigner function.
	     */
	    function createAssigner(assigner) {
	      return restParam(function(object, sources) {
	        var index = -1,
	            length = object == null ? 0 : sources.length,
	            customizer = length > 2 ? sources[length - 2] : undefined,
	            guard = length > 2 ? sources[2] : undefined,
	            thisArg = length > 1 ? sources[length - 1] : undefined;

	        if (typeof customizer == 'function') {
	          customizer = bindCallback(customizer, thisArg, 5);
	          length -= 2;
	        } else {
	          customizer = typeof thisArg == 'function' ? thisArg : undefined;
	          length -= (customizer ? 1 : 0);
	        }
	        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
	          customizer = length < 3 ? undefined : customizer;
	          length = 1;
	        }
	        while (++index < length) {
	          var source = sources[index];
	          if (source) {
	            assigner(object, source, customizer);
	          }
	        }
	        return object;
	      });
	    }

	    /**
	     * Creates a `baseEach` or `baseEachRight` function.
	     *
	     * @private
	     * @param {Function} eachFunc The function to iterate over a collection.
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Function} Returns the new base function.
	     */
	    function createBaseEach(eachFunc, fromRight) {
	      return function(collection, iteratee) {
	        var length = collection ? getLength(collection) : 0;
	        if (!isLength(length)) {
	          return eachFunc(collection, iteratee);
	        }
	        var index = fromRight ? length : -1,
	            iterable = toObject(collection);

	        while ((fromRight ? index-- : ++index < length)) {
	          if (iteratee(iterable[index], index, iterable) === false) {
	            break;
	          }
	        }
	        return collection;
	      };
	    }

	    /**
	     * Creates a base function for `_.forIn` or `_.forInRight`.
	     *
	     * @private
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Function} Returns the new base function.
	     */
	    function createBaseFor(fromRight) {
	      return function(object, iteratee, keysFunc) {
	        var iterable = toObject(object),
	            props = keysFunc(object),
	            length = props.length,
	            index = fromRight ? length : -1;

	        while ((fromRight ? index-- : ++index < length)) {
	          var key = props[index];
	          if (iteratee(iterable[key], key, iterable) === false) {
	            break;
	          }
	        }
	        return object;
	      };
	    }

	    /**
	     * Creates a function that wraps `func` and invokes it with the `this`
	     * binding of `thisArg`.
	     *
	     * @private
	     * @param {Function} func The function to bind.
	     * @param {*} [thisArg] The `this` binding of `func`.
	     * @returns {Function} Returns the new bound function.
	     */
	    function createBindWrapper(func, thisArg) {
	      var Ctor = createCtorWrapper(func);

	      function wrapper() {
	        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
	        return fn.apply(thisArg, arguments);
	      }
	      return wrapper;
	    }

	    /**
	     * Creates a `Set` cache object to optimize linear searches of large arrays.
	     *
	     * @private
	     * @param {Array} [values] The values to cache.
	     * @returns {null|Object} Returns the new cache object if `Set` is supported, else `null`.
	     */
	    function createCache(values) {
	      return (nativeCreate && Set) ? new SetCache(values) : null;
	    }

	    /**
	     * Creates a function that produces compound words out of the words in a
	     * given string.
	     *
	     * @private
	     * @param {Function} callback The function to combine each word.
	     * @returns {Function} Returns the new compounder function.
	     */
	    function createCompounder(callback) {
	      return function(string) {
	        var index = -1,
	            array = words(deburr(string)),
	            length = array.length,
	            result = '';

	        while (++index < length) {
	          result = callback(result, array[index], index);
	        }
	        return result;
	      };
	    }

	    /**
	     * Creates a function that produces an instance of `Ctor` regardless of
	     * whether it was invoked as part of a `new` expression or by `call` or `apply`.
	     *
	     * @private
	     * @param {Function} Ctor The constructor to wrap.
	     * @returns {Function} Returns the new wrapped function.
	     */
	    function createCtorWrapper(Ctor) {
	      return function() {
	        // Use a `switch` statement to work with class constructors.
	        // See http://ecma-international.org/ecma-262/6.0/#sec-ecmascript-function-objects-call-thisargument-argumentslist
	        // for more details.
	        var args = arguments;
	        switch (args.length) {
	          case 0: return new Ctor;
	          case 1: return new Ctor(args[0]);
	          case 2: return new Ctor(args[0], args[1]);
	          case 3: return new Ctor(args[0], args[1], args[2]);
	          case 4: return new Ctor(args[0], args[1], args[2], args[3]);
	          case 5: return new Ctor(args[0], args[1], args[2], args[3], args[4]);
	          case 6: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
	          case 7: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
	        }
	        var thisBinding = baseCreate(Ctor.prototype),
	            result = Ctor.apply(thisBinding, args);

	        // Mimic the constructor's `return` behavior.
	        // See https://es5.github.io/#x13.2.2 for more details.
	        return isObject(result) ? result : thisBinding;
	      };
	    }

	    /**
	     * Creates a `_.curry` or `_.curryRight` function.
	     *
	     * @private
	     * @param {boolean} flag The curry bit flag.
	     * @returns {Function} Returns the new curry function.
	     */
	    function createCurry(flag) {
	      function curryFunc(func, arity, guard) {
	        if (guard && isIterateeCall(func, arity, guard)) {
	          arity = undefined;
	        }
	        var result = createWrapper(func, flag, undefined, undefined, undefined, undefined, undefined, arity);
	        result.placeholder = curryFunc.placeholder;
	        return result;
	      }
	      return curryFunc;
	    }

	    /**
	     * Creates a `_.defaults` or `_.defaultsDeep` function.
	     *
	     * @private
	     * @param {Function} assigner The function to assign values.
	     * @param {Function} customizer The function to customize assigned values.
	     * @returns {Function} Returns the new defaults function.
	     */
	    function createDefaults(assigner, customizer) {
	      return restParam(function(args) {
	        var object = args[0];
	        if (object == null) {
	          return object;
	        }
	        args.push(customizer);
	        return assigner.apply(undefined, args);
	      });
	    }

	    /**
	     * Creates a `_.max` or `_.min` function.
	     *
	     * @private
	     * @param {Function} comparator The function used to compare values.
	     * @param {*} exValue The initial extremum value.
	     * @returns {Function} Returns the new extremum function.
	     */
	    function createExtremum(comparator, exValue) {
	      return function(collection, iteratee, thisArg) {
	        if (thisArg && isIterateeCall(collection, iteratee, thisArg)) {
	          iteratee = undefined;
	        }
	        iteratee = getCallback(iteratee, thisArg, 3);
	        if (iteratee.length == 1) {
	          collection = isArray(collection) ? collection : toIterable(collection);
	          var result = arrayExtremum(collection, iteratee, comparator, exValue);
	          if (!(collection.length && result === exValue)) {
	            return result;
	          }
	        }
	        return baseExtremum(collection, iteratee, comparator, exValue);
	      };
	    }

	    /**
	     * Creates a `_.find` or `_.findLast` function.
	     *
	     * @private
	     * @param {Function} eachFunc The function to iterate over a collection.
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Function} Returns the new find function.
	     */
	    function createFind(eachFunc, fromRight) {
	      return function(collection, predicate, thisArg) {
	        predicate = getCallback(predicate, thisArg, 3);
	        if (isArray(collection)) {
	          var index = baseFindIndex(collection, predicate, fromRight);
	          return index > -1 ? collection[index] : undefined;
	        }
	        return baseFind(collection, predicate, eachFunc);
	      };
	    }

	    /**
	     * Creates a `_.findIndex` or `_.findLastIndex` function.
	     *
	     * @private
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Function} Returns the new find function.
	     */
	    function createFindIndex(fromRight) {
	      return function(array, predicate, thisArg) {
	        if (!(array && array.length)) {
	          return -1;
	        }
	        predicate = getCallback(predicate, thisArg, 3);
	        return baseFindIndex(array, predicate, fromRight);
	      };
	    }

	    /**
	     * Creates a `_.findKey` or `_.findLastKey` function.
	     *
	     * @private
	     * @param {Function} objectFunc The function to iterate over an object.
	     * @returns {Function} Returns the new find function.
	     */
	    function createFindKey(objectFunc) {
	      return function(object, predicate, thisArg) {
	        predicate = getCallback(predicate, thisArg, 3);
	        return baseFind(object, predicate, objectFunc, true);
	      };
	    }

	    /**
	     * Creates a `_.flow` or `_.flowRight` function.
	     *
	     * @private
	     * @param {boolean} [fromRight] Specify iterating from right to left.
	     * @returns {Function} Returns the new flow function.
	     */
	    function createFlow(fromRight) {
	      return function() {
	        var wrapper,
	            length = arguments.length,
	            index = fromRight ? length : -1,
	            leftIndex = 0,
	            funcs = Array(length);

	        while ((fromRight ? index-- : ++index < length)) {
	          var func = funcs[leftIndex++] = arguments[index];
	          if (typeof func != 'function') {
	            throw new TypeError(FUNC_ERROR_TEXT);
	          }
	          if (!wrapper && LodashWrapper.prototype.thru && getFuncName(func) == 'wrapper') {
	            wrapper = new LodashWrapper([], true);
	          }
	        }
	        index = wrapper ? -1 : length;
	        while (++index < length) {
	          func = funcs[index];

	          var funcName = getFuncName(func),
	              data = funcName == 'wrapper' ? getData(func) : undefined;

	          if (data && isLaziable(data[0]) && data[1] == (ARY_FLAG | CURRY_FLAG | PARTIAL_FLAG | REARG_FLAG) && !data[4].length && data[9] == 1) {
	            wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
	          } else {
	            wrapper = (func.length == 1 && isLaziable(func)) ? wrapper[funcName]() : wrapper.thru(func);
	          }
	        }
	        return function() {
	          var args = arguments,
	              value = args[0];

	          if (wrapper && args.length == 1 && isArray(value) && value.length >= LARGE_ARRAY_SIZE) {
	            return wrapper.plant(value).value();
	          }
	          var index = 0,
	              result = length ? funcs[index].apply(this, args) : value;

	          while (++index < length) {
	            result = funcs[index].call(this, result);
	          }
	          return result;
	        };
	      };
	    }

	    /**
	     * Creates a function for `_.forEach` or `_.forEachRight`.
	     *
	     * @private
	     * @param {Function} arrayFunc The function to iterate over an array.
	     * @param {Function} eachFunc The function to iterate over a collection.
	     * @returns {Function} Returns the new each function.
	     */
	    function createForEach(arrayFunc, eachFunc) {
	      return function(collection, iteratee, thisArg) {
	        return (typeof iteratee == 'function' && thisArg === undefined && isArray(collection))
	          ? arrayFunc(collection, iteratee)
	          : eachFunc(collection, bindCallback(iteratee, thisArg, 3));
	      };
	    }

	    /**
	     * Creates a function for `_.forIn` or `_.forInRight`.
	     *
	     * @private
	     * @param {Function} objectFunc The function to iterate over an object.
	     * @returns {Function} Returns the new each function.
	     */
	    function createForIn(objectFunc) {
	      return function(object, iteratee, thisArg) {
	        if (typeof iteratee != 'function' || thisArg !== undefined) {
	          iteratee = bindCallback(iteratee, thisArg, 3);
	        }
	        return objectFunc(object, iteratee, keysIn);
	      };
	    }

	    /**
	     * Creates a function for `_.forOwn` or `_.forOwnRight`.
	     *
	     * @private
	     * @param {Function} objectFunc The function to iterate over an object.
	     * @returns {Function} Returns the new each function.
	     */
	    function createForOwn(objectFunc) {
	      return function(object, iteratee, thisArg) {
	        if (typeof iteratee != 'function' || thisArg !== undefined) {
	          iteratee = bindCallback(iteratee, thisArg, 3);
	        }
	        return objectFunc(object, iteratee);
	      };
	    }

	    /**
	     * Creates a function for `_.mapKeys` or `_.mapValues`.
	     *
	     * @private
	     * @param {boolean} [isMapKeys] Specify mapping keys instead of values.
	     * @returns {Function} Returns the new map function.
	     */
	    function createObjectMapper(isMapKeys) {
	      return function(object, iteratee, thisArg) {
	        var result = {};
	        iteratee = getCallback(iteratee, thisArg, 3);

	        baseForOwn(object, function(value, key, object) {
	          var mapped = iteratee(value, key, object);
	          key = isMapKeys ? mapped : key;
	          value = isMapKeys ? value : mapped;
	          result[key] = value;
	        });
	        return result;
	      };
	    }

	    /**
	     * Creates a function for `_.padLeft` or `_.padRight`.
	     *
	     * @private
	     * @param {boolean} [fromRight] Specify padding from the right.
	     * @returns {Function} Returns the new pad function.
	     */
	    function createPadDir(fromRight) {
	      return function(string, length, chars) {
	        string = baseToString(string);
	        return (fromRight ? string : '') + createPadding(string, length, chars) + (fromRight ? '' : string);
	      };
	    }

	    /**
	     * Creates a `_.partial` or `_.partialRight` function.
	     *
	     * @private
	     * @param {boolean} flag The partial bit flag.
	     * @returns {Function} Returns the new partial function.
	     */
	    function createPartial(flag) {
	      var partialFunc = restParam(function(func, partials) {
	        var holders = replaceHolders(partials, partialFunc.placeholder);
	        return createWrapper(func, flag, undefined, partials, holders);
	      });
	      return partialFunc;
	    }

	    /**
	     * Creates a function for `_.reduce` or `_.reduceRight`.
	     *
	     * @private
	     * @param {Function} arrayFunc The function to iterate over an array.
	     * @param {Function} eachFunc The function to iterate over a collection.
	     * @returns {Function} Returns the new each function.
	     */
	    function createReduce(arrayFunc, eachFunc) {
	      return function(collection, iteratee, accumulator, thisArg) {
	        var initFromArray = arguments.length < 3;
	        return (typeof iteratee == 'function' && thisArg === undefined && isArray(collection))
	          ? arrayFunc(collection, iteratee, accumulator, initFromArray)
	          : baseReduce(collection, getCallback(iteratee, thisArg, 4), accumulator, initFromArray, eachFunc);
	      };
	    }

	    /**
	     * Creates a function that wraps `func` and invokes it with optional `this`
	     * binding of, partial application, and currying.
	     *
	     * @private
	     * @param {Function|string} func The function or method name to reference.
	     * @param {number} bitmask The bitmask of flags. See `createWrapper` for more details.
	     * @param {*} [thisArg] The `this` binding of `func`.
	     * @param {Array} [partials] The arguments to prepend to those provided to the new function.
	     * @param {Array} [holders] The `partials` placeholder indexes.
	     * @param {Array} [partialsRight] The arguments to append to those provided to the new function.
	     * @param {Array} [holdersRight] The `partialsRight` placeholder indexes.
	     * @param {Array} [argPos] The argument positions of the new function.
	     * @param {number} [ary] The arity cap of `func`.
	     * @param {number} [arity] The arity of `func`.
	     * @returns {Function} Returns the new wrapped function.
	     */
	    function createHybridWrapper(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {
	      var isAry = bitmask & ARY_FLAG,
	          isBind = bitmask & BIND_FLAG,
	          isBindKey = bitmask & BIND_KEY_FLAG,
	          isCurry = bitmask & CURRY_FLAG,
	          isCurryBound = bitmask & CURRY_BOUND_FLAG,
	          isCurryRight = bitmask & CURRY_RIGHT_FLAG,
	          Ctor = isBindKey ? undefined : createCtorWrapper(func);

	      function wrapper() {
	        // Avoid `arguments` object use disqualifying optimizations by
	        // converting it to an array before providing it to other functions.
	        var length = arguments.length,
	            index = length,
	            args = Array(length);

	        while (index--) {
	          args[index] = arguments[index];
	        }
	        if (partials) {
	          args = composeArgs(args, partials, holders);
	        }
	        if (partialsRight) {
	          args = composeArgsRight(args, partialsRight, holdersRight);
	        }
	        if (isCurry || isCurryRight) {
	          var placeholder = wrapper.placeholder,
	              argsHolders = replaceHolders(args, placeholder);

	          length -= argsHolders.length;
	          if (length < arity) {
	            var newArgPos = argPos ? arrayCopy(argPos) : undefined,
	                newArity = nativeMax(arity - length, 0),
	                newsHolders = isCurry ? argsHolders : undefined,
	                newHoldersRight = isCurry ? undefined : argsHolders,
	                newPartials = isCurry ? args : undefined,
	                newPartialsRight = isCurry ? undefined : args;

	            bitmask |= (isCurry ? PARTIAL_FLAG : PARTIAL_RIGHT_FLAG);
	            bitmask &= ~(isCurry ? PARTIAL_RIGHT_FLAG : PARTIAL_FLAG);

	            if (!isCurryBound) {
	              bitmask &= ~(BIND_FLAG | BIND_KEY_FLAG);
	            }
	            var newData = [func, bitmask, thisArg, newPartials, newsHolders, newPartialsRight, newHoldersRight, newArgPos, ary, newArity],
	                result = createHybridWrapper.apply(undefined, newData);

	            if (isLaziable(func)) {
	              setData(result, newData);
	            }
	            result.placeholder = placeholder;
	            return result;
	          }
	        }
	        var thisBinding = isBind ? thisArg : this,
	            fn = isBindKey ? thisBinding[func] : func;

	        if (argPos) {
	          args = reorder(args, argPos);
	        }
	        if (isAry && ary < args.length) {
	          args.length = ary;
	        }
	        if (this && this !== root && this instanceof wrapper) {
	          fn = Ctor || createCtorWrapper(func);
	        }
	        return fn.apply(thisBinding, args);
	      }
	      return wrapper;
	    }

	    /**
	     * Creates the padding required for `string` based on the given `length`.
	     * The `chars` string is truncated if the number of characters exceeds `length`.
	     *
	     * @private
	     * @param {string} string The string to create padding for.
	     * @param {number} [length=0] The padding length.
	     * @param {string} [chars=' '] The string used as padding.
	     * @returns {string} Returns the pad for `string`.
	     */
	    function createPadding(string, length, chars) {
	      var strLength = string.length;
	      length = +length;

	      if (strLength >= length || !nativeIsFinite(length)) {
	        return '';
	      }
	      var padLength = length - strLength;
	      chars = chars == null ? ' ' : (chars + '');
	      return repeat(chars, nativeCeil(padLength / chars.length)).slice(0, padLength);
	    }

	    /**
	     * Creates a function that wraps `func` and invokes it with the optional `this`
	     * binding of `thisArg` and the `partials` prepended to those provided to
	     * the wrapper.
	     *
	     * @private
	     * @param {Function} func The function to partially apply arguments to.
	     * @param {number} bitmask The bitmask of flags. See `createWrapper` for more details.
	     * @param {*} thisArg The `this` binding of `func`.
	     * @param {Array} partials The arguments to prepend to those provided to the new function.
	     * @returns {Function} Returns the new bound function.
	     */
	    function createPartialWrapper(func, bitmask, thisArg, partials) {
	      var isBind = bitmask & BIND_FLAG,
	          Ctor = createCtorWrapper(func);

	      function wrapper() {
	        // Avoid `arguments` object use disqualifying optimizations by
	        // converting it to an array before providing it `func`.
	        var argsIndex = -1,
	            argsLength = arguments.length,
	            leftIndex = -1,
	            leftLength = partials.length,
	            args = Array(leftLength + argsLength);

	        while (++leftIndex < leftLength) {
	          args[leftIndex] = partials[leftIndex];
	        }
	        while (argsLength--) {
	          args[leftIndex++] = arguments[++argsIndex];
	        }
	        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
	        return fn.apply(isBind ? thisArg : this, args);
	      }
	      return wrapper;
	    }

	    /**
	     * Creates a `_.ceil`, `_.floor`, or `_.round` function.
	     *
	     * @private
	     * @param {string} methodName The name of the `Math` method to use when rounding.
	     * @returns {Function} Returns the new round function.
	     */
	    function createRound(methodName) {
	      var func = Math[methodName];
	      return function(number, precision) {
	        precision = precision === undefined ? 0 : (+precision || 0);
	        if (precision) {
	          precision = pow(10, precision);
	          return func(number * precision) / precision;
	        }
	        return func(number);
	      };
	    }

	    /**
	     * Creates a `_.sortedIndex` or `_.sortedLastIndex` function.
	     *
	     * @private
	     * @param {boolean} [retHighest] Specify returning the highest qualified index.
	     * @returns {Function} Returns the new index function.
	     */
	    function createSortedIndex(retHighest) {
	      return function(array, value, iteratee, thisArg) {
	        var callback = getCallback(iteratee);
	        return (iteratee == null && callback === baseCallback)
	          ? binaryIndex(array, value, retHighest)
	          : binaryIndexBy(array, value, callback(iteratee, thisArg, 1), retHighest);
	      };
	    }

	    /**
	     * Creates a function that either curries or invokes `func` with optional
	     * `this` binding and partially applied arguments.
	     *
	     * @private
	     * @param {Function|string} func The function or method name to reference.
	     * @param {number} bitmask The bitmask of flags.
	     *  The bitmask may be composed of the following flags:
	     *     1 - `_.bind`
	     *     2 - `_.bindKey`
	     *     4 - `_.curry` or `_.curryRight` of a bound function
	     *     8 - `_.curry`
	     *    16 - `_.curryRight`
	     *    32 - `_.partial`
	     *    64 - `_.partialRight`
	     *   128 - `_.rearg`
	     *   256 - `_.ary`
	     * @param {*} [thisArg] The `this` binding of `func`.
	     * @param {Array} [partials] The arguments to be partially applied.
	     * @param {Array} [holders] The `partials` placeholder indexes.
	     * @param {Array} [argPos] The argument positions of the new function.
	     * @param {number} [ary] The arity cap of `func`.
	     * @param {number} [arity] The arity of `func`.
	     * @returns {Function} Returns the new wrapped function.
	     */
	    function createWrapper(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {
	      var isBindKey = bitmask & BIND_KEY_FLAG;
	      if (!isBindKey && typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      var length = partials ? partials.length : 0;
	      if (!length) {
	        bitmask &= ~(PARTIAL_FLAG | PARTIAL_RIGHT_FLAG);
	        partials = holders = undefined;
	      }
	      length -= (holders ? holders.length : 0);
	      if (bitmask & PARTIAL_RIGHT_FLAG) {
	        var partialsRight = partials,
	            holdersRight = holders;

	        partials = holders = undefined;
	      }
	      var data = isBindKey ? undefined : getData(func),
	          newData = [func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity];

	      if (data) {
	        mergeData(newData, data);
	        bitmask = newData[1];
	        arity = newData[9];
	      }
	      newData[9] = arity == null
	        ? (isBindKey ? 0 : func.length)
	        : (nativeMax(arity - length, 0) || 0);

	      if (bitmask == BIND_FLAG) {
	        var result = createBindWrapper(newData[0], newData[2]);
	      } else if ((bitmask == PARTIAL_FLAG || bitmask == (BIND_FLAG | PARTIAL_FLAG)) && !newData[4].length) {
	        result = createPartialWrapper.apply(undefined, newData);
	      } else {
	        result = createHybridWrapper.apply(undefined, newData);
	      }
	      var setter = data ? baseSetData : setData;
	      return setter(result, newData);
	    }

	    /**
	     * A specialized version of `baseIsEqualDeep` for arrays with support for
	     * partial deep comparisons.
	     *
	     * @private
	     * @param {Array} array The array to compare.
	     * @param {Array} other The other array to compare.
	     * @param {Function} equalFunc The function to determine equivalents of values.
	     * @param {Function} [customizer] The function to customize comparing arrays.
	     * @param {boolean} [isLoose] Specify performing partial comparisons.
	     * @param {Array} [stackA] Tracks traversed `value` objects.
	     * @param {Array} [stackB] Tracks traversed `other` objects.
	     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
	     */
	    function equalArrays(array, other, equalFunc, customizer, isLoose, stackA, stackB) {
	      var index = -1,
	          arrLength = array.length,
	          othLength = other.length;

	      if (arrLength != othLength && !(isLoose && othLength > arrLength)) {
	        return false;
	      }
	      // Ignore non-index properties.
	      while (++index < arrLength) {
	        var arrValue = array[index],
	            othValue = other[index],
	            result = customizer ? customizer(isLoose ? othValue : arrValue, isLoose ? arrValue : othValue, index) : undefined;

	        if (result !== undefined) {
	          if (result) {
	            continue;
	          }
	          return false;
	        }
	        // Recursively compare arrays (susceptible to call stack limits).
	        if (isLoose) {
	          if (!arraySome(other, function(othValue) {
	                return arrValue === othValue || equalFunc(arrValue, othValue, customizer, isLoose, stackA, stackB);
	              })) {
	            return false;
	          }
	        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, isLoose, stackA, stackB))) {
	          return false;
	        }
	      }
	      return true;
	    }

	    /**
	     * A specialized version of `baseIsEqualDeep` for comparing objects of
	     * the same `toStringTag`.
	     *
	     * **Note:** This function only supports comparing values with tags of
	     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
	     *
	     * @private
	     * @param {Object} object The object to compare.
	     * @param {Object} other The other object to compare.
	     * @param {string} tag The `toStringTag` of the objects to compare.
	     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
	     */
	    function equalByTag(object, other, tag) {
	      switch (tag) {
	        case boolTag:
	        case dateTag:
	          // Coerce dates and booleans to numbers, dates to milliseconds and booleans
	          // to `1` or `0` treating invalid dates coerced to `NaN` as not equal.
	          return +object == +other;

	        case errorTag:
	          return object.name == other.name && object.message == other.message;

	        case numberTag:
	          // Treat `NaN` vs. `NaN` as equal.
	          return (object != +object)
	            ? other != +other
	            : object == +other;

	        case regexpTag:
	        case stringTag:
	          // Coerce regexes to strings and treat strings primitives and string
	          // objects as equal. See https://es5.github.io/#x15.10.6.4 for more details.
	          return object == (other + '');
	      }
	      return false;
	    }

	    /**
	     * A specialized version of `baseIsEqualDeep` for objects with support for
	     * partial deep comparisons.
	     *
	     * @private
	     * @param {Object} object The object to compare.
	     * @param {Object} other The other object to compare.
	     * @param {Function} equalFunc The function to determine equivalents of values.
	     * @param {Function} [customizer] The function to customize comparing values.
	     * @param {boolean} [isLoose] Specify performing partial comparisons.
	     * @param {Array} [stackA] Tracks traversed `value` objects.
	     * @param {Array} [stackB] Tracks traversed `other` objects.
	     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
	     */
	    function equalObjects(object, other, equalFunc, customizer, isLoose, stackA, stackB) {
	      var objProps = keys(object),
	          objLength = objProps.length,
	          othProps = keys(other),
	          othLength = othProps.length;

	      if (objLength != othLength && !isLoose) {
	        return false;
	      }
	      var index = objLength;
	      while (index--) {
	        var key = objProps[index];
	        if (!(isLoose ? key in other : hasOwnProperty.call(other, key))) {
	          return false;
	        }
	      }
	      var skipCtor = isLoose;
	      while (++index < objLength) {
	        key = objProps[index];
	        var objValue = object[key],
	            othValue = other[key],
	            result = customizer ? customizer(isLoose ? othValue : objValue, isLoose? objValue : othValue, key) : undefined;

	        // Recursively compare objects (susceptible to call stack limits).
	        if (!(result === undefined ? equalFunc(objValue, othValue, customizer, isLoose, stackA, stackB) : result)) {
	          return false;
	        }
	        skipCtor || (skipCtor = key == 'constructor');
	      }
	      if (!skipCtor) {
	        var objCtor = object.constructor,
	            othCtor = other.constructor;

	        // Non `Object` object instances with different constructors are not equal.
	        if (objCtor != othCtor &&
	            ('constructor' in object && 'constructor' in other) &&
	            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
	              typeof othCtor == 'function' && othCtor instanceof othCtor)) {
	          return false;
	        }
	      }
	      return true;
	    }

	    /**
	     * Gets the appropriate "callback" function. If the `_.callback` method is
	     * customized this function returns the custom method, otherwise it returns
	     * the `baseCallback` function. If arguments are provided the chosen function
	     * is invoked with them and its result is returned.
	     *
	     * @private
	     * @returns {Function} Returns the chosen function or its result.
	     */
	    function getCallback(func, thisArg, argCount) {
	      var result = lodash.callback || callback;
	      result = result === callback ? baseCallback : result;
	      return argCount ? result(func, thisArg, argCount) : result;
	    }

	    /**
	     * Gets metadata for `func`.
	     *
	     * @private
	     * @param {Function} func The function to query.
	     * @returns {*} Returns the metadata for `func`.
	     */
	    var getData = !metaMap ? noop : function(func) {
	      return metaMap.get(func);
	    };

	    /**
	     * Gets the name of `func`.
	     *
	     * @private
	     * @param {Function} func The function to query.
	     * @returns {string} Returns the function name.
	     */
	    function getFuncName(func) {
	      var result = func.name,
	          array = realNames[result],
	          length = array ? array.length : 0;

	      while (length--) {
	        var data = array[length],
	            otherFunc = data.func;
	        if (otherFunc == null || otherFunc == func) {
	          return data.name;
	        }
	      }
	      return result;
	    }

	    /**
	     * Gets the appropriate "indexOf" function. If the `_.indexOf` method is
	     * customized this function returns the custom method, otherwise it returns
	     * the `baseIndexOf` function. If arguments are provided the chosen function
	     * is invoked with them and its result is returned.
	     *
	     * @private
	     * @returns {Function|number} Returns the chosen function or its result.
	     */
	    function getIndexOf(collection, target, fromIndex) {
	      var result = lodash.indexOf || indexOf;
	      result = result === indexOf ? baseIndexOf : result;
	      return collection ? result(collection, target, fromIndex) : result;
	    }

	    /**
	     * Gets the "length" property value of `object`.
	     *
	     * **Note:** This function is used to avoid a [JIT bug](https://bugs.webkit.org/show_bug.cgi?id=142792)
	     * that affects Safari on at least iOS 8.1-8.3 ARM64.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @returns {*} Returns the "length" value.
	     */
	    var getLength = baseProperty('length');

	    /**
	     * Gets the propery names, values, and compare flags of `object`.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the match data of `object`.
	     */
	    function getMatchData(object) {
	      var result = pairs(object),
	          length = result.length;

	      while (length--) {
	        result[length][2] = isStrictComparable(result[length][1]);
	      }
	      return result;
	    }

	    /**
	     * Gets the native function at `key` of `object`.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @param {string} key The key of the method to get.
	     * @returns {*} Returns the function if it's native, else `undefined`.
	     */
	    function getNative(object, key) {
	      var value = object == null ? undefined : object[key];
	      return isNative(value) ? value : undefined;
	    }

	    /**
	     * Gets the view, applying any `transforms` to the `start` and `end` positions.
	     *
	     * @private
	     * @param {number} start The start of the view.
	     * @param {number} end The end of the view.
	     * @param {Array} transforms The transformations to apply to the view.
	     * @returns {Object} Returns an object containing the `start` and `end`
	     *  positions of the view.
	     */
	    function getView(start, end, transforms) {
	      var index = -1,
	          length = transforms.length;

	      while (++index < length) {
	        var data = transforms[index],
	            size = data.size;

	        switch (data.type) {
	          case 'drop':      start += size; break;
	          case 'dropRight': end -= size; break;
	          case 'take':      end = nativeMin(end, start + size); break;
	          case 'takeRight': start = nativeMax(start, end - size); break;
	        }
	      }
	      return { 'start': start, 'end': end };
	    }

	    /**
	     * Initializes an array clone.
	     *
	     * @private
	     * @param {Array} array The array to clone.
	     * @returns {Array} Returns the initialized clone.
	     */
	    function initCloneArray(array) {
	      var length = array.length,
	          result = new array.constructor(length);

	      // Add array properties assigned by `RegExp#exec`.
	      if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
	        result.index = array.index;
	        result.input = array.input;
	      }
	      return result;
	    }

	    /**
	     * Initializes an object clone.
	     *
	     * @private
	     * @param {Object} object The object to clone.
	     * @returns {Object} Returns the initialized clone.
	     */
	    function initCloneObject(object) {
	      var Ctor = object.constructor;
	      if (!(typeof Ctor == 'function' && Ctor instanceof Ctor)) {
	        Ctor = Object;
	      }
	      return new Ctor;
	    }

	    /**
	     * Initializes an object clone based on its `toStringTag`.
	     *
	     * **Note:** This function only supports cloning values with tags of
	     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
	     *
	     * @private
	     * @param {Object} object The object to clone.
	     * @param {string} tag The `toStringTag` of the object to clone.
	     * @param {boolean} [isDeep] Specify a deep clone.
	     * @returns {Object} Returns the initialized clone.
	     */
	    function initCloneByTag(object, tag, isDeep) {
	      var Ctor = object.constructor;
	      switch (tag) {
	        case arrayBufferTag:
	          return bufferClone(object);

	        case boolTag:
	        case dateTag:
	          return new Ctor(+object);

	        case float32Tag: case float64Tag:
	        case int8Tag: case int16Tag: case int32Tag:
	        case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
	          var buffer = object.buffer;
	          return new Ctor(isDeep ? bufferClone(buffer) : buffer, object.byteOffset, object.length);

	        case numberTag:
	        case stringTag:
	          return new Ctor(object);

	        case regexpTag:
	          var result = new Ctor(object.source, reFlags.exec(object));
	          result.lastIndex = object.lastIndex;
	      }
	      return result;
	    }

	    /**
	     * Invokes the method at `path` on `object`.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @param {Array|string} path The path of the method to invoke.
	     * @param {Array} args The arguments to invoke the method with.
	     * @returns {*} Returns the result of the invoked method.
	     */
	    function invokePath(object, path, args) {
	      if (object != null && !isKey(path, object)) {
	        path = toPath(path);
	        object = path.length == 1 ? object : baseGet(object, baseSlice(path, 0, -1));
	        path = last(path);
	      }
	      var func = object == null ? object : object[path];
	      return func == null ? undefined : func.apply(object, args);
	    }

	    /**
	     * Checks if `value` is array-like.
	     *
	     * @private
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
	     */
	    function isArrayLike(value) {
	      return value != null && isLength(getLength(value));
	    }

	    /**
	     * Checks if `value` is a valid array-like index.
	     *
	     * @private
	     * @param {*} value The value to check.
	     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
	     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
	     */
	    function isIndex(value, length) {
	      value = (typeof value == 'number' || reIsUint.test(value)) ? +value : -1;
	      length = length == null ? MAX_SAFE_INTEGER : length;
	      return value > -1 && value % 1 == 0 && value < length;
	    }

	    /**
	     * Checks if the provided arguments are from an iteratee call.
	     *
	     * @private
	     * @param {*} value The potential iteratee value argument.
	     * @param {*} index The potential iteratee index or key argument.
	     * @param {*} object The potential iteratee object argument.
	     * @returns {boolean} Returns `true` if the arguments are from an iteratee call, else `false`.
	     */
	    function isIterateeCall(value, index, object) {
	      if (!isObject(object)) {
	        return false;
	      }
	      var type = typeof index;
	      if (type == 'number'
	          ? (isArrayLike(object) && isIndex(index, object.length))
	          : (type == 'string' && index in object)) {
	        var other = object[index];
	        return value === value ? (value === other) : (other !== other);
	      }
	      return false;
	    }

	    /**
	     * Checks if `value` is a property name and not a property path.
	     *
	     * @private
	     * @param {*} value The value to check.
	     * @param {Object} [object] The object to query keys on.
	     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
	     */
	    function isKey(value, object) {
	      var type = typeof value;
	      if ((type == 'string' && reIsPlainProp.test(value)) || type == 'number') {
	        return true;
	      }
	      if (isArray(value)) {
	        return false;
	      }
	      var result = !reIsDeepProp.test(value);
	      return result || (object != null && value in toObject(object));
	    }

	    /**
	     * Checks if `func` has a lazy counterpart.
	     *
	     * @private
	     * @param {Function} func The function to check.
	     * @returns {boolean} Returns `true` if `func` has a lazy counterpart, else `false`.
	     */
	    function isLaziable(func) {
	      var funcName = getFuncName(func);
	      if (!(funcName in LazyWrapper.prototype)) {
	        return false;
	      }
	      var other = lodash[funcName];
	      if (func === other) {
	        return true;
	      }
	      var data = getData(other);
	      return !!data && func === data[0];
	    }

	    /**
	     * Checks if `value` is a valid array-like length.
	     *
	     * **Note:** This function is based on [`ToLength`](http://ecma-international.org/ecma-262/6.0/#sec-tolength).
	     *
	     * @private
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
	     */
	    function isLength(value) {
	      return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
	    }

	    /**
	     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
	     *
	     * @private
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` if suitable for strict
	     *  equality comparisons, else `false`.
	     */
	    function isStrictComparable(value) {
	      return value === value && !isObject(value);
	    }

	    /**
	     * Merges the function metadata of `source` into `data`.
	     *
	     * Merging metadata reduces the number of wrappers required to invoke a function.
	     * This is possible because methods like `_.bind`, `_.curry`, and `_.partial`
	     * may be applied regardless of execution order. Methods like `_.ary` and `_.rearg`
	     * augment function arguments, making the order in which they are executed important,
	     * preventing the merging of metadata. However, we make an exception for a safe
	     * common case where curried functions have `_.ary` and or `_.rearg` applied.
	     *
	     * @private
	     * @param {Array} data The destination metadata.
	     * @param {Array} source The source metadata.
	     * @returns {Array} Returns `data`.
	     */
	    function mergeData(data, source) {
	      var bitmask = data[1],
	          srcBitmask = source[1],
	          newBitmask = bitmask | srcBitmask,
	          isCommon = newBitmask < ARY_FLAG;

	      var isCombo =
	        (srcBitmask == ARY_FLAG && bitmask == CURRY_FLAG) ||
	        (srcBitmask == ARY_FLAG && bitmask == REARG_FLAG && data[7].length <= source[8]) ||
	        (srcBitmask == (ARY_FLAG | REARG_FLAG) && bitmask == CURRY_FLAG);

	      // Exit early if metadata can't be merged.
	      if (!(isCommon || isCombo)) {
	        return data;
	      }
	      // Use source `thisArg` if available.
	      if (srcBitmask & BIND_FLAG) {
	        data[2] = source[2];
	        // Set when currying a bound function.
	        newBitmask |= (bitmask & BIND_FLAG) ? 0 : CURRY_BOUND_FLAG;
	      }
	      // Compose partial arguments.
	      var value = source[3];
	      if (value) {
	        var partials = data[3];
	        data[3] = partials ? composeArgs(partials, value, source[4]) : arrayCopy(value);
	        data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : arrayCopy(source[4]);
	      }
	      // Compose partial right arguments.
	      value = source[5];
	      if (value) {
	        partials = data[5];
	        data[5] = partials ? composeArgsRight(partials, value, source[6]) : arrayCopy(value);
	        data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : arrayCopy(source[6]);
	      }
	      // Use source `argPos` if available.
	      value = source[7];
	      if (value) {
	        data[7] = arrayCopy(value);
	      }
	      // Use source `ary` if it's smaller.
	      if (srcBitmask & ARY_FLAG) {
	        data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
	      }
	      // Use source `arity` if one is not provided.
	      if (data[9] == null) {
	        data[9] = source[9];
	      }
	      // Use source `func` and merge bitmasks.
	      data[0] = source[0];
	      data[1] = newBitmask;

	      return data;
	    }

	    /**
	     * Used by `_.defaultsDeep` to customize its `_.merge` use.
	     *
	     * @private
	     * @param {*} objectValue The destination object property value.
	     * @param {*} sourceValue The source object property value.
	     * @returns {*} Returns the value to assign to the destination object.
	     */
	    function mergeDefaults(objectValue, sourceValue) {
	      return objectValue === undefined ? sourceValue : merge(objectValue, sourceValue, mergeDefaults);
	    }

	    /**
	     * A specialized version of `_.pick` which picks `object` properties specified
	     * by `props`.
	     *
	     * @private
	     * @param {Object} object The source object.
	     * @param {string[]} props The property names to pick.
	     * @returns {Object} Returns the new object.
	     */
	    function pickByArray(object, props) {
	      object = toObject(object);

	      var index = -1,
	          length = props.length,
	          result = {};

	      while (++index < length) {
	        var key = props[index];
	        if (key in object) {
	          result[key] = object[key];
	        }
	      }
	      return result;
	    }

	    /**
	     * A specialized version of `_.pick` which picks `object` properties `predicate`
	     * returns truthy for.
	     *
	     * @private
	     * @param {Object} object The source object.
	     * @param {Function} predicate The function invoked per iteration.
	     * @returns {Object} Returns the new object.
	     */
	    function pickByCallback(object, predicate) {
	      var result = {};
	      baseForIn(object, function(value, key, object) {
	        if (predicate(value, key, object)) {
	          result[key] = value;
	        }
	      });
	      return result;
	    }

	    /**
	     * Reorder `array` according to the specified indexes where the element at
	     * the first index is assigned as the first element, the element at
	     * the second index is assigned as the second element, and so on.
	     *
	     * @private
	     * @param {Array} array The array to reorder.
	     * @param {Array} indexes The arranged array indexes.
	     * @returns {Array} Returns `array`.
	     */
	    function reorder(array, indexes) {
	      var arrLength = array.length,
	          length = nativeMin(indexes.length, arrLength),
	          oldArray = arrayCopy(array);

	      while (length--) {
	        var index = indexes[length];
	        array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined;
	      }
	      return array;
	    }

	    /**
	     * Sets metadata for `func`.
	     *
	     * **Note:** If this function becomes hot, i.e. is invoked a lot in a short
	     * period of time, it will trip its breaker and transition to an identity function
	     * to avoid garbage collection pauses in V8. See [V8 issue 2070](https://code.google.com/p/v8/issues/detail?id=2070)
	     * for more details.
	     *
	     * @private
	     * @param {Function} func The function to associate metadata with.
	     * @param {*} data The metadata.
	     * @returns {Function} Returns `func`.
	     */
	    var setData = (function() {
	      var count = 0,
	          lastCalled = 0;

	      return function(key, value) {
	        var stamp = now(),
	            remaining = HOT_SPAN - (stamp - lastCalled);

	        lastCalled = stamp;
	        if (remaining > 0) {
	          if (++count >= HOT_COUNT) {
	            return key;
	          }
	        } else {
	          count = 0;
	        }
	        return baseSetData(key, value);
	      };
	    }());

	    /**
	     * A fallback implementation of `Object.keys` which creates an array of the
	     * own enumerable property names of `object`.
	     *
	     * @private
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the array of property names.
	     */
	    function shimKeys(object) {
	      var props = keysIn(object),
	          propsLength = props.length,
	          length = propsLength && object.length;

	      var allowIndexes = !!length && isLength(length) &&
	        (isArray(object) || isArguments(object));

	      var index = -1,
	          result = [];

	      while (++index < propsLength) {
	        var key = props[index];
	        if ((allowIndexes && isIndex(key, length)) || hasOwnProperty.call(object, key)) {
	          result.push(key);
	        }
	      }
	      return result;
	    }

	    /**
	     * Converts `value` to an array-like object if it's not one.
	     *
	     * @private
	     * @param {*} value The value to process.
	     * @returns {Array|Object} Returns the array-like object.
	     */
	    function toIterable(value) {
	      if (value == null) {
	        return [];
	      }
	      if (!isArrayLike(value)) {
	        return values(value);
	      }
	      return isObject(value) ? value : Object(value);
	    }

	    /**
	     * Converts `value` to an object if it's not one.
	     *
	     * @private
	     * @param {*} value The value to process.
	     * @returns {Object} Returns the object.
	     */
	    function toObject(value) {
	      return isObject(value) ? value : Object(value);
	    }

	    /**
	     * Converts `value` to property path array if it's not one.
	     *
	     * @private
	     * @param {*} value The value to process.
	     * @returns {Array} Returns the property path array.
	     */
	    function toPath(value) {
	      if (isArray(value)) {
	        return value;
	      }
	      var result = [];
	      baseToString(value).replace(rePropName, function(match, number, quote, string) {
	        result.push(quote ? string.replace(reEscapeChar, '$1') : (number || match));
	      });
	      return result;
	    }

	    /**
	     * Creates a clone of `wrapper`.
	     *
	     * @private
	     * @param {Object} wrapper The wrapper to clone.
	     * @returns {Object} Returns the cloned wrapper.
	     */
	    function wrapperClone(wrapper) {
	      return wrapper instanceof LazyWrapper
	        ? wrapper.clone()
	        : new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__, arrayCopy(wrapper.__actions__));
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates an array of elements split into groups the length of `size`.
	     * If `collection` can't be split evenly, the final chunk will be the remaining
	     * elements.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to process.
	     * @param {number} [size=1] The length of each chunk.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the new array containing chunks.
	     * @example
	     *
	     * _.chunk(['a', 'b', 'c', 'd'], 2);
	     * // => [['a', 'b'], ['c', 'd']]
	     *
	     * _.chunk(['a', 'b', 'c', 'd'], 3);
	     * // => [['a', 'b', 'c'], ['d']]
	     */
	    function chunk(array, size, guard) {
	      if (guard ? isIterateeCall(array, size, guard) : size == null) {
	        size = 1;
	      } else {
	        size = nativeMax(nativeFloor(size) || 1, 1);
	      }
	      var index = 0,
	          length = array ? array.length : 0,
	          resIndex = -1,
	          result = Array(nativeCeil(length / size));

	      while (index < length) {
	        result[++resIndex] = baseSlice(array, index, (index += size));
	      }
	      return result;
	    }

	    /**
	     * Creates an array with all falsey values removed. The values `false`, `null`,
	     * `0`, `""`, `undefined`, and `NaN` are falsey.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to compact.
	     * @returns {Array} Returns the new array of filtered values.
	     * @example
	     *
	     * _.compact([0, 1, false, 2, '', 3]);
	     * // => [1, 2, 3]
	     */
	    function compact(array) {
	      var index = -1,
	          length = array ? array.length : 0,
	          resIndex = -1,
	          result = [];

	      while (++index < length) {
	        var value = array[index];
	        if (value) {
	          result[++resIndex] = value;
	        }
	      }
	      return result;
	    }

	    /**
	     * Creates an array of unique `array` values not included in the other
	     * provided arrays using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to inspect.
	     * @param {...Array} [values] The arrays of values to exclude.
	     * @returns {Array} Returns the new array of filtered values.
	     * @example
	     *
	     * _.difference([1, 2, 3], [4, 2]);
	     * // => [1, 3]
	     */
	    var difference = restParam(function(array, values) {
	      return (isObjectLike(array) && isArrayLike(array))
	        ? baseDifference(array, baseFlatten(values, false, true))
	        : [];
	    });

	    /**
	     * Creates a slice of `array` with `n` elements dropped from the beginning.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {number} [n=1] The number of elements to drop.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.drop([1, 2, 3]);
	     * // => [2, 3]
	     *
	     * _.drop([1, 2, 3], 2);
	     * // => [3]
	     *
	     * _.drop([1, 2, 3], 5);
	     * // => []
	     *
	     * _.drop([1, 2, 3], 0);
	     * // => [1, 2, 3]
	     */
	    function drop(array, n, guard) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (guard ? isIterateeCall(array, n, guard) : n == null) {
	        n = 1;
	      }
	      return baseSlice(array, n < 0 ? 0 : n);
	    }

	    /**
	     * Creates a slice of `array` with `n` elements dropped from the end.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {number} [n=1] The number of elements to drop.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.dropRight([1, 2, 3]);
	     * // => [1, 2]
	     *
	     * _.dropRight([1, 2, 3], 2);
	     * // => [1]
	     *
	     * _.dropRight([1, 2, 3], 5);
	     * // => []
	     *
	     * _.dropRight([1, 2, 3], 0);
	     * // => [1, 2, 3]
	     */
	    function dropRight(array, n, guard) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (guard ? isIterateeCall(array, n, guard) : n == null) {
	        n = 1;
	      }
	      n = length - (+n || 0);
	      return baseSlice(array, 0, n < 0 ? 0 : n);
	    }

	    /**
	     * Creates a slice of `array` excluding elements dropped from the end.
	     * Elements are dropped until `predicate` returns falsey. The predicate is
	     * bound to `thisArg` and invoked with three arguments: (value, index, array).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that match the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.dropRightWhile([1, 2, 3], function(n) {
	     *   return n > 1;
	     * });
	     * // => [1]
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': true },
	     *   { 'user': 'fred',    'active': false },
	     *   { 'user': 'pebbles', 'active': false }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.dropRightWhile(users, { 'user': 'pebbles', 'active': false }), 'user');
	     * // => ['barney', 'fred']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.dropRightWhile(users, 'active', false), 'user');
	     * // => ['barney']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.dropRightWhile(users, 'active'), 'user');
	     * // => ['barney', 'fred', 'pebbles']
	     */
	    function dropRightWhile(array, predicate, thisArg) {
	      return (array && array.length)
	        ? baseWhile(array, getCallback(predicate, thisArg, 3), true, true)
	        : [];
	    }

	    /**
	     * Creates a slice of `array` excluding elements dropped from the beginning.
	     * Elements are dropped until `predicate` returns falsey. The predicate is
	     * bound to `thisArg` and invoked with three arguments: (value, index, array).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.dropWhile([1, 2, 3], function(n) {
	     *   return n < 3;
	     * });
	     * // => [3]
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': false },
	     *   { 'user': 'fred',    'active': false },
	     *   { 'user': 'pebbles', 'active': true }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.dropWhile(users, { 'user': 'barney', 'active': false }), 'user');
	     * // => ['fred', 'pebbles']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.dropWhile(users, 'active', false), 'user');
	     * // => ['pebbles']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.dropWhile(users, 'active'), 'user');
	     * // => ['barney', 'fred', 'pebbles']
	     */
	    function dropWhile(array, predicate, thisArg) {
	      return (array && array.length)
	        ? baseWhile(array, getCallback(predicate, thisArg, 3), true)
	        : [];
	    }

	    /**
	     * Fills elements of `array` with `value` from `start` up to, but not
	     * including, `end`.
	     *
	     * **Note:** This method mutates `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to fill.
	     * @param {*} value The value to fill `array` with.
	     * @param {number} [start=0] The start position.
	     * @param {number} [end=array.length] The end position.
	     * @returns {Array} Returns `array`.
	     * @example
	     *
	     * var array = [1, 2, 3];
	     *
	     * _.fill(array, 'a');
	     * console.log(array);
	     * // => ['a', 'a', 'a']
	     *
	     * _.fill(Array(3), 2);
	     * // => [2, 2, 2]
	     *
	     * _.fill([4, 6, 8], '*', 1, 2);
	     * // => [4, '*', 8]
	     */
	    function fill(array, value, start, end) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {
	        start = 0;
	        end = length;
	      }
	      return baseFill(array, value, start, end);
	    }

	    /**
	     * This method is like `_.find` except that it returns the index of the first
	     * element `predicate` returns truthy for instead of the element itself.
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {number} Returns the index of the found element, else `-1`.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': false },
	     *   { 'user': 'fred',    'active': false },
	     *   { 'user': 'pebbles', 'active': true }
	     * ];
	     *
	     * _.findIndex(users, function(chr) {
	     *   return chr.user == 'barney';
	     * });
	     * // => 0
	     *
	     * // using the `_.matches` callback shorthand
	     * _.findIndex(users, { 'user': 'fred', 'active': false });
	     * // => 1
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.findIndex(users, 'active', false);
	     * // => 0
	     *
	     * // using the `_.property` callback shorthand
	     * _.findIndex(users, 'active');
	     * // => 2
	     */
	    var findIndex = createFindIndex();

	    /**
	     * This method is like `_.findIndex` except that it iterates over elements
	     * of `collection` from right to left.
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {number} Returns the index of the found element, else `-1`.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': true },
	     *   { 'user': 'fred',    'active': false },
	     *   { 'user': 'pebbles', 'active': false }
	     * ];
	     *
	     * _.findLastIndex(users, function(chr) {
	     *   return chr.user == 'pebbles';
	     * });
	     * // => 2
	     *
	     * // using the `_.matches` callback shorthand
	     * _.findLastIndex(users, { 'user': 'barney', 'active': true });
	     * // => 0
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.findLastIndex(users, 'active', false);
	     * // => 2
	     *
	     * // using the `_.property` callback shorthand
	     * _.findLastIndex(users, 'active');
	     * // => 0
	     */
	    var findLastIndex = createFindIndex(true);

	    /**
	     * Gets the first element of `array`.
	     *
	     * @static
	     * @memberOf _
	     * @alias head
	     * @category Array
	     * @param {Array} array The array to query.
	     * @returns {*} Returns the first element of `array`.
	     * @example
	     *
	     * _.first([1, 2, 3]);
	     * // => 1
	     *
	     * _.first([]);
	     * // => undefined
	     */
	    function first(array) {
	      return array ? array[0] : undefined;
	    }

	    /**
	     * Flattens a nested array. If `isDeep` is `true` the array is recursively
	     * flattened, otherwise it is only flattened a single level.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to flatten.
	     * @param {boolean} [isDeep] Specify a deep flatten.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the new flattened array.
	     * @example
	     *
	     * _.flatten([1, [2, 3, [4]]]);
	     * // => [1, 2, 3, [4]]
	     *
	     * // using `isDeep`
	     * _.flatten([1, [2, 3, [4]]], true);
	     * // => [1, 2, 3, 4]
	     */
	    function flatten(array, isDeep, guard) {
	      var length = array ? array.length : 0;
	      if (guard && isIterateeCall(array, isDeep, guard)) {
	        isDeep = false;
	      }
	      return length ? baseFlatten(array, isDeep) : [];
	    }

	    /**
	     * Recursively flattens a nested array.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to recursively flatten.
	     * @returns {Array} Returns the new flattened array.
	     * @example
	     *
	     * _.flattenDeep([1, [2, 3, [4]]]);
	     * // => [1, 2, 3, 4]
	     */
	    function flattenDeep(array) {
	      var length = array ? array.length : 0;
	      return length ? baseFlatten(array, true) : [];
	    }

	    /**
	     * Gets the index at which the first occurrence of `value` is found in `array`
	     * using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons. If `fromIndex` is negative, it is used as the offset
	     * from the end of `array`. If `array` is sorted providing `true` for `fromIndex`
	     * performs a faster binary search.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to search.
	     * @param {*} value The value to search for.
	     * @param {boolean|number} [fromIndex=0] The index to search from or `true`
	     *  to perform a binary search on a sorted array.
	     * @returns {number} Returns the index of the matched value, else `-1`.
	     * @example
	     *
	     * _.indexOf([1, 2, 1, 2], 2);
	     * // => 1
	     *
	     * // using `fromIndex`
	     * _.indexOf([1, 2, 1, 2], 2, 2);
	     * // => 3
	     *
	     * // performing a binary search
	     * _.indexOf([1, 1, 2, 2], 2, true);
	     * // => 2
	     */
	    function indexOf(array, value, fromIndex) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return -1;
	      }
	      if (typeof fromIndex == 'number') {
	        fromIndex = fromIndex < 0 ? nativeMax(length + fromIndex, 0) : fromIndex;
	      } else if (fromIndex) {
	        var index = binaryIndex(array, value);
	        if (index < length &&
	            (value === value ? (value === array[index]) : (array[index] !== array[index]))) {
	          return index;
	        }
	        return -1;
	      }
	      return baseIndexOf(array, value, fromIndex || 0);
	    }

	    /**
	     * Gets all but the last element of `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.initial([1, 2, 3]);
	     * // => [1, 2]
	     */
	    function initial(array) {
	      return dropRight(array, 1);
	    }

	    /**
	     * Creates an array of unique values that are included in all of the provided
	     * arrays using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {...Array} [arrays] The arrays to inspect.
	     * @returns {Array} Returns the new array of shared values.
	     * @example
	     * _.intersection([1, 2], [4, 2], [2, 1]);
	     * // => [2]
	     */
	    var intersection = restParam(function(arrays) {
	      var othLength = arrays.length,
	          othIndex = othLength,
	          caches = Array(length),
	          indexOf = getIndexOf(),
	          isCommon = indexOf == baseIndexOf,
	          result = [];

	      while (othIndex--) {
	        var value = arrays[othIndex] = isArrayLike(value = arrays[othIndex]) ? value : [];
	        caches[othIndex] = (isCommon && value.length >= 120) ? createCache(othIndex && value) : null;
	      }
	      var array = arrays[0],
	          index = -1,
	          length = array ? array.length : 0,
	          seen = caches[0];

	      outer:
	      while (++index < length) {
	        value = array[index];
	        if ((seen ? cacheIndexOf(seen, value) : indexOf(result, value, 0)) < 0) {
	          var othIndex = othLength;
	          while (--othIndex) {
	            var cache = caches[othIndex];
	            if ((cache ? cacheIndexOf(cache, value) : indexOf(arrays[othIndex], value, 0)) < 0) {
	              continue outer;
	            }
	          }
	          if (seen) {
	            seen.push(value);
	          }
	          result.push(value);
	        }
	      }
	      return result;
	    });

	    /**
	     * Gets the last element of `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @returns {*} Returns the last element of `array`.
	     * @example
	     *
	     * _.last([1, 2, 3]);
	     * // => 3
	     */
	    function last(array) {
	      var length = array ? array.length : 0;
	      return length ? array[length - 1] : undefined;
	    }

	    /**
	     * This method is like `_.indexOf` except that it iterates over elements of
	     * `array` from right to left.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to search.
	     * @param {*} value The value to search for.
	     * @param {boolean|number} [fromIndex=array.length-1] The index to search from
	     *  or `true` to perform a binary search on a sorted array.
	     * @returns {number} Returns the index of the matched value, else `-1`.
	     * @example
	     *
	     * _.lastIndexOf([1, 2, 1, 2], 2);
	     * // => 3
	     *
	     * // using `fromIndex`
	     * _.lastIndexOf([1, 2, 1, 2], 2, 2);
	     * // => 1
	     *
	     * // performing a binary search
	     * _.lastIndexOf([1, 1, 2, 2], 2, true);
	     * // => 3
	     */
	    function lastIndexOf(array, value, fromIndex) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return -1;
	      }
	      var index = length;
	      if (typeof fromIndex == 'number') {
	        index = (fromIndex < 0 ? nativeMax(length + fromIndex, 0) : nativeMin(fromIndex || 0, length - 1)) + 1;
	      } else if (fromIndex) {
	        index = binaryIndex(array, value, true) - 1;
	        var other = array[index];
	        if (value === value ? (value === other) : (other !== other)) {
	          return index;
	        }
	        return -1;
	      }
	      if (value !== value) {
	        return indexOfNaN(array, index, true);
	      }
	      while (index--) {
	        if (array[index] === value) {
	          return index;
	        }
	      }
	      return -1;
	    }

	    /**
	     * Removes all provided values from `array` using
	     * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons.
	     *
	     * **Note:** Unlike `_.without`, this method mutates `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to modify.
	     * @param {...*} [values] The values to remove.
	     * @returns {Array} Returns `array`.
	     * @example
	     *
	     * var array = [1, 2, 3, 1, 2, 3];
	     *
	     * _.pull(array, 2, 3);
	     * console.log(array);
	     * // => [1, 1]
	     */
	    function pull() {
	      var args = arguments,
	          array = args[0];

	      if (!(array && array.length)) {
	        return array;
	      }
	      var index = 0,
	          indexOf = getIndexOf(),
	          length = args.length;

	      while (++index < length) {
	        var fromIndex = 0,
	            value = args[index];

	        while ((fromIndex = indexOf(array, value, fromIndex)) > -1) {
	          splice.call(array, fromIndex, 1);
	        }
	      }
	      return array;
	    }

	    /**
	     * Removes elements from `array` corresponding to the given indexes and returns
	     * an array of the removed elements. Indexes may be specified as an array of
	     * indexes or as individual arguments.
	     *
	     * **Note:** Unlike `_.at`, this method mutates `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to modify.
	     * @param {...(number|number[])} [indexes] The indexes of elements to remove,
	     *  specified as individual indexes or arrays of indexes.
	     * @returns {Array} Returns the new array of removed elements.
	     * @example
	     *
	     * var array = [5, 10, 15, 20];
	     * var evens = _.pullAt(array, 1, 3);
	     *
	     * console.log(array);
	     * // => [5, 15]
	     *
	     * console.log(evens);
	     * // => [10, 20]
	     */
	    var pullAt = restParam(function(array, indexes) {
	      indexes = baseFlatten(indexes);

	      var result = baseAt(array, indexes);
	      basePullAt(array, indexes.sort(baseCompareAscending));
	      return result;
	    });

	    /**
	     * Removes all elements from `array` that `predicate` returns truthy for
	     * and returns an array of the removed elements. The predicate is bound to
	     * `thisArg` and invoked with three arguments: (value, index, array).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * **Note:** Unlike `_.filter`, this method mutates `array`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to modify.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the new array of removed elements.
	     * @example
	     *
	     * var array = [1, 2, 3, 4];
	     * var evens = _.remove(array, function(n) {
	     *   return n % 2 == 0;
	     * });
	     *
	     * console.log(array);
	     * // => [1, 3]
	     *
	     * console.log(evens);
	     * // => [2, 4]
	     */
	    function remove(array, predicate, thisArg) {
	      var result = [];
	      if (!(array && array.length)) {
	        return result;
	      }
	      var index = -1,
	          indexes = [],
	          length = array.length;

	      predicate = getCallback(predicate, thisArg, 3);
	      while (++index < length) {
	        var value = array[index];
	        if (predicate(value, index, array)) {
	          result.push(value);
	          indexes.push(index);
	        }
	      }
	      basePullAt(array, indexes);
	      return result;
	    }

	    /**
	     * Gets all but the first element of `array`.
	     *
	     * @static
	     * @memberOf _
	     * @alias tail
	     * @category Array
	     * @param {Array} array The array to query.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.rest([1, 2, 3]);
	     * // => [2, 3]
	     */
	    function rest(array) {
	      return drop(array, 1);
	    }

	    /**
	     * Creates a slice of `array` from `start` up to, but not including, `end`.
	     *
	     * **Note:** This method is used instead of `Array#slice` to support node
	     * lists in IE < 9 and to ensure dense arrays are returned.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to slice.
	     * @param {number} [start=0] The start position.
	     * @param {number} [end=array.length] The end position.
	     * @returns {Array} Returns the slice of `array`.
	     */
	    function slice(array, start, end) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {
	        start = 0;
	        end = length;
	      }
	      return baseSlice(array, start, end);
	    }

	    /**
	     * Uses a binary search to determine the lowest index at which `value` should
	     * be inserted into `array` in order to maintain its sort order. If an iteratee
	     * function is provided it is invoked for `value` and each element of `array`
	     * to compute their sort ranking. The iteratee is bound to `thisArg` and
	     * invoked with one argument; (value).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The sorted array to inspect.
	     * @param {*} value The value to evaluate.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {number} Returns the index at which `value` should be inserted
	     *  into `array`.
	     * @example
	     *
	     * _.sortedIndex([30, 50], 40);
	     * // => 1
	     *
	     * _.sortedIndex([4, 4, 5, 5], 5);
	     * // => 2
	     *
	     * var dict = { 'data': { 'thirty': 30, 'forty': 40, 'fifty': 50 } };
	     *
	     * // using an iteratee function
	     * _.sortedIndex(['thirty', 'fifty'], 'forty', function(word) {
	     *   return this.data[word];
	     * }, dict);
	     * // => 1
	     *
	     * // using the `_.property` callback shorthand
	     * _.sortedIndex([{ 'x': 30 }, { 'x': 50 }], { 'x': 40 }, 'x');
	     * // => 1
	     */
	    var sortedIndex = createSortedIndex();

	    /**
	     * This method is like `_.sortedIndex` except that it returns the highest
	     * index at which `value` should be inserted into `array` in order to
	     * maintain its sort order.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The sorted array to inspect.
	     * @param {*} value The value to evaluate.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {number} Returns the index at which `value` should be inserted
	     *  into `array`.
	     * @example
	     *
	     * _.sortedLastIndex([4, 4, 5, 5], 5);
	     * // => 4
	     */
	    var sortedLastIndex = createSortedIndex(true);

	    /**
	     * Creates a slice of `array` with `n` elements taken from the beginning.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {number} [n=1] The number of elements to take.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.take([1, 2, 3]);
	     * // => [1]
	     *
	     * _.take([1, 2, 3], 2);
	     * // => [1, 2]
	     *
	     * _.take([1, 2, 3], 5);
	     * // => [1, 2, 3]
	     *
	     * _.take([1, 2, 3], 0);
	     * // => []
	     */
	    function take(array, n, guard) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (guard ? isIterateeCall(array, n, guard) : n == null) {
	        n = 1;
	      }
	      return baseSlice(array, 0, n < 0 ? 0 : n);
	    }

	    /**
	     * Creates a slice of `array` with `n` elements taken from the end.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {number} [n=1] The number of elements to take.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.takeRight([1, 2, 3]);
	     * // => [3]
	     *
	     * _.takeRight([1, 2, 3], 2);
	     * // => [2, 3]
	     *
	     * _.takeRight([1, 2, 3], 5);
	     * // => [1, 2, 3]
	     *
	     * _.takeRight([1, 2, 3], 0);
	     * // => []
	     */
	    function takeRight(array, n, guard) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (guard ? isIterateeCall(array, n, guard) : n == null) {
	        n = 1;
	      }
	      n = length - (+n || 0);
	      return baseSlice(array, n < 0 ? 0 : n);
	    }

	    /**
	     * Creates a slice of `array` with elements taken from the end. Elements are
	     * taken until `predicate` returns falsey. The predicate is bound to `thisArg`
	     * and invoked with three arguments: (value, index, array).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.takeRightWhile([1, 2, 3], function(n) {
	     *   return n > 1;
	     * });
	     * // => [2, 3]
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': true },
	     *   { 'user': 'fred',    'active': false },
	     *   { 'user': 'pebbles', 'active': false }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.takeRightWhile(users, { 'user': 'pebbles', 'active': false }), 'user');
	     * // => ['pebbles']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.takeRightWhile(users, 'active', false), 'user');
	     * // => ['fred', 'pebbles']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.takeRightWhile(users, 'active'), 'user');
	     * // => []
	     */
	    function takeRightWhile(array, predicate, thisArg) {
	      return (array && array.length)
	        ? baseWhile(array, getCallback(predicate, thisArg, 3), false, true)
	        : [];
	    }

	    /**
	     * Creates a slice of `array` with elements taken from the beginning. Elements
	     * are taken until `predicate` returns falsey. The predicate is bound to
	     * `thisArg` and invoked with three arguments: (value, index, array).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to query.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the slice of `array`.
	     * @example
	     *
	     * _.takeWhile([1, 2, 3], function(n) {
	     *   return n < 3;
	     * });
	     * // => [1, 2]
	     *
	     * var users = [
	     *   { 'user': 'barney',  'active': false },
	     *   { 'user': 'fred',    'active': false},
	     *   { 'user': 'pebbles', 'active': true }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.takeWhile(users, { 'user': 'barney', 'active': false }), 'user');
	     * // => ['barney']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.takeWhile(users, 'active', false), 'user');
	     * // => ['barney', 'fred']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.takeWhile(users, 'active'), 'user');
	     * // => []
	     */
	    function takeWhile(array, predicate, thisArg) {
	      return (array && array.length)
	        ? baseWhile(array, getCallback(predicate, thisArg, 3))
	        : [];
	    }

	    /**
	     * Creates an array of unique values, in order, from all of the provided arrays
	     * using [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {...Array} [arrays] The arrays to inspect.
	     * @returns {Array} Returns the new array of combined values.
	     * @example
	     *
	     * _.union([1, 2], [4, 2], [2, 1]);
	     * // => [1, 2, 4]
	     */
	    var union = restParam(function(arrays) {
	      return baseUniq(baseFlatten(arrays, false, true));
	    });

	    /**
	     * Creates a duplicate-free version of an array, using
	     * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons, in which only the first occurence of each element
	     * is kept. Providing `true` for `isSorted` performs a faster search algorithm
	     * for sorted arrays. If an iteratee function is provided it is invoked for
	     * each element in the array to generate the criterion by which uniqueness
	     * is computed. The `iteratee` is bound to `thisArg` and invoked with three
	     * arguments: (value, index, array).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias unique
	     * @category Array
	     * @param {Array} array The array to inspect.
	     * @param {boolean} [isSorted] Specify the array is sorted.
	     * @param {Function|Object|string} [iteratee] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the new duplicate-value-free array.
	     * @example
	     *
	     * _.uniq([2, 1, 2]);
	     * // => [2, 1]
	     *
	     * // using `isSorted`
	     * _.uniq([1, 1, 2], true);
	     * // => [1, 2]
	     *
	     * // using an iteratee function
	     * _.uniq([1, 2.5, 1.5, 2], function(n) {
	     *   return this.floor(n);
	     * }, Math);
	     * // => [1, 2.5]
	     *
	     * // using the `_.property` callback shorthand
	     * _.uniq([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
	     * // => [{ 'x': 1 }, { 'x': 2 }]
	     */
	    function uniq(array, isSorted, iteratee, thisArg) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      if (isSorted != null && typeof isSorted != 'boolean') {
	        thisArg = iteratee;
	        iteratee = isIterateeCall(array, isSorted, thisArg) ? undefined : isSorted;
	        isSorted = false;
	      }
	      var callback = getCallback();
	      if (!(iteratee == null && callback === baseCallback)) {
	        iteratee = callback(iteratee, thisArg, 3);
	      }
	      return (isSorted && getIndexOf() == baseIndexOf)
	        ? sortedUniq(array, iteratee)
	        : baseUniq(array, iteratee);
	    }

	    /**
	     * This method is like `_.zip` except that it accepts an array of grouped
	     * elements and creates an array regrouping the elements to their pre-zip
	     * configuration.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array of grouped elements to process.
	     * @returns {Array} Returns the new array of regrouped elements.
	     * @example
	     *
	     * var zipped = _.zip(['fred', 'barney'], [30, 40], [true, false]);
	     * // => [['fred', 30, true], ['barney', 40, false]]
	     *
	     * _.unzip(zipped);
	     * // => [['fred', 'barney'], [30, 40], [true, false]]
	     */
	    function unzip(array) {
	      if (!(array && array.length)) {
	        return [];
	      }
	      var index = -1,
	          length = 0;

	      array = arrayFilter(array, function(group) {
	        if (isArrayLike(group)) {
	          length = nativeMax(group.length, length);
	          return true;
	        }
	      });
	      var result = Array(length);
	      while (++index < length) {
	        result[index] = arrayMap(array, baseProperty(index));
	      }
	      return result;
	    }

	    /**
	     * This method is like `_.unzip` except that it accepts an iteratee to specify
	     * how regrouped values should be combined. The `iteratee` is bound to `thisArg`
	     * and invoked with four arguments: (accumulator, value, index, group).
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array of grouped elements to process.
	     * @param {Function} [iteratee] The function to combine regrouped values.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the new array of regrouped elements.
	     * @example
	     *
	     * var zipped = _.zip([1, 2], [10, 20], [100, 200]);
	     * // => [[1, 10, 100], [2, 20, 200]]
	     *
	     * _.unzipWith(zipped, _.add);
	     * // => [3, 30, 300]
	     */
	    function unzipWith(array, iteratee, thisArg) {
	      var length = array ? array.length : 0;
	      if (!length) {
	        return [];
	      }
	      var result = unzip(array);
	      if (iteratee == null) {
	        return result;
	      }
	      iteratee = bindCallback(iteratee, thisArg, 4);
	      return arrayMap(result, function(group) {
	        return arrayReduce(group, iteratee, undefined, true);
	      });
	    }

	    /**
	     * Creates an array excluding all provided values using
	     * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {Array} array The array to filter.
	     * @param {...*} [values] The values to exclude.
	     * @returns {Array} Returns the new array of filtered values.
	     * @example
	     *
	     * _.without([1, 2, 1, 3], 1, 2);
	     * // => [3]
	     */
	    var without = restParam(function(array, values) {
	      return isArrayLike(array)
	        ? baseDifference(array, values)
	        : [];
	    });

	    /**
	     * Creates an array of unique values that is the [symmetric difference](https://en.wikipedia.org/wiki/Symmetric_difference)
	     * of the provided arrays.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {...Array} [arrays] The arrays to inspect.
	     * @returns {Array} Returns the new array of values.
	     * @example
	     *
	     * _.xor([1, 2], [4, 2]);
	     * // => [1, 4]
	     */
	    function xor() {
	      var index = -1,
	          length = arguments.length;

	      while (++index < length) {
	        var array = arguments[index];
	        if (isArrayLike(array)) {
	          var result = result
	            ? arrayPush(baseDifference(result, array), baseDifference(array, result))
	            : array;
	        }
	      }
	      return result ? baseUniq(result) : [];
	    }

	    /**
	     * Creates an array of grouped elements, the first of which contains the first
	     * elements of the given arrays, the second of which contains the second elements
	     * of the given arrays, and so on.
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {...Array} [arrays] The arrays to process.
	     * @returns {Array} Returns the new array of grouped elements.
	     * @example
	     *
	     * _.zip(['fred', 'barney'], [30, 40], [true, false]);
	     * // => [['fred', 30, true], ['barney', 40, false]]
	     */
	    var zip = restParam(unzip);

	    /**
	     * The inverse of `_.pairs`; this method returns an object composed from arrays
	     * of property names and values. Provide either a single two dimensional array,
	     * e.g. `[[key1, value1], [key2, value2]]` or two arrays, one of property names
	     * and one of corresponding values.
	     *
	     * @static
	     * @memberOf _
	     * @alias object
	     * @category Array
	     * @param {Array} props The property names.
	     * @param {Array} [values=[]] The property values.
	     * @returns {Object} Returns the new object.
	     * @example
	     *
	     * _.zipObject([['fred', 30], ['barney', 40]]);
	     * // => { 'fred': 30, 'barney': 40 }
	     *
	     * _.zipObject(['fred', 'barney'], [30, 40]);
	     * // => { 'fred': 30, 'barney': 40 }
	     */
	    function zipObject(props, values) {
	      var index = -1,
	          length = props ? props.length : 0,
	          result = {};

	      if (length && !values && !isArray(props[0])) {
	        values = [];
	      }
	      while (++index < length) {
	        var key = props[index];
	        if (values) {
	          result[key] = values[index];
	        } else if (key) {
	          result[key[0]] = key[1];
	        }
	      }
	      return result;
	    }

	    /**
	     * This method is like `_.zip` except that it accepts an iteratee to specify
	     * how grouped values should be combined. The `iteratee` is bound to `thisArg`
	     * and invoked with four arguments: (accumulator, value, index, group).
	     *
	     * @static
	     * @memberOf _
	     * @category Array
	     * @param {...Array} [arrays] The arrays to process.
	     * @param {Function} [iteratee] The function to combine grouped values.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the new array of grouped elements.
	     * @example
	     *
	     * _.zipWith([1, 2], [10, 20], [100, 200], _.add);
	     * // => [111, 222]
	     */
	    var zipWith = restParam(function(arrays) {
	      var length = arrays.length,
	          iteratee = length > 2 ? arrays[length - 2] : undefined,
	          thisArg = length > 1 ? arrays[length - 1] : undefined;

	      if (length > 2 && typeof iteratee == 'function') {
	        length -= 2;
	      } else {
	        iteratee = (length > 1 && typeof thisArg == 'function') ? (--length, thisArg) : undefined;
	        thisArg = undefined;
	      }
	      arrays.length = length;
	      return unzipWith(arrays, iteratee, thisArg);
	    });

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a `lodash` object that wraps `value` with explicit method
	     * chaining enabled.
	     *
	     * @static
	     * @memberOf _
	     * @category Chain
	     * @param {*} value The value to wrap.
	     * @returns {Object} Returns the new `lodash` wrapper instance.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney',  'age': 36 },
	     *   { 'user': 'fred',    'age': 40 },
	     *   { 'user': 'pebbles', 'age': 1 }
	     * ];
	     *
	     * var youngest = _.chain(users)
	     *   .sortBy('age')
	     *   .map(function(chr) {
	     *     return chr.user + ' is ' + chr.age;
	     *   })
	     *   .first()
	     *   .value();
	     * // => 'pebbles is 1'
	     */
	    function chain(value) {
	      var result = lodash(value);
	      result.__chain__ = true;
	      return result;
	    }

	    /**
	     * This method invokes `interceptor` and returns `value`. The interceptor is
	     * bound to `thisArg` and invoked with one argument; (value). The purpose of
	     * this method is to "tap into" a method chain in order to perform operations
	     * on intermediate results within the chain.
	     *
	     * @static
	     * @memberOf _
	     * @category Chain
	     * @param {*} value The value to provide to `interceptor`.
	     * @param {Function} interceptor The function to invoke.
	     * @param {*} [thisArg] The `this` binding of `interceptor`.
	     * @returns {*} Returns `value`.
	     * @example
	     *
	     * _([1, 2, 3])
	     *  .tap(function(array) {
	     *    array.pop();
	     *  })
	     *  .reverse()
	     *  .value();
	     * // => [2, 1]
	     */
	    function tap(value, interceptor, thisArg) {
	      interceptor.call(thisArg, value);
	      return value;
	    }

	    /**
	     * This method is like `_.tap` except that it returns the result of `interceptor`.
	     *
	     * @static
	     * @memberOf _
	     * @category Chain
	     * @param {*} value The value to provide to `interceptor`.
	     * @param {Function} interceptor The function to invoke.
	     * @param {*} [thisArg] The `this` binding of `interceptor`.
	     * @returns {*} Returns the result of `interceptor`.
	     * @example
	     *
	     * _('  abc  ')
	     *  .chain()
	     *  .trim()
	     *  .thru(function(value) {
	     *    return [value];
	     *  })
	     *  .value();
	     * // => ['abc']
	     */
	    function thru(value, interceptor, thisArg) {
	      return interceptor.call(thisArg, value);
	    }

	    /**
	     * Enables explicit method chaining on the wrapper object.
	     *
	     * @name chain
	     * @memberOf _
	     * @category Chain
	     * @returns {Object} Returns the new `lodash` wrapper instance.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 40 }
	     * ];
	     *
	     * // without explicit chaining
	     * _(users).first();
	     * // => { 'user': 'barney', 'age': 36 }
	     *
	     * // with explicit chaining
	     * _(users).chain()
	     *   .first()
	     *   .pick('user')
	     *   .value();
	     * // => { 'user': 'barney' }
	     */
	    function wrapperChain() {
	      return chain(this);
	    }

	    /**
	     * Executes the chained sequence and returns the wrapped result.
	     *
	     * @name commit
	     * @memberOf _
	     * @category Chain
	     * @returns {Object} Returns the new `lodash` wrapper instance.
	     * @example
	     *
	     * var array = [1, 2];
	     * var wrapped = _(array).push(3);
	     *
	     * console.log(array);
	     * // => [1, 2]
	     *
	     * wrapped = wrapped.commit();
	     * console.log(array);
	     * // => [1, 2, 3]
	     *
	     * wrapped.last();
	     * // => 3
	     *
	     * console.log(array);
	     * // => [1, 2, 3]
	     */
	    function wrapperCommit() {
	      return new LodashWrapper(this.value(), this.__chain__);
	    }

	    /**
	     * Creates a new array joining a wrapped array with any additional arrays
	     * and/or values.
	     *
	     * @name concat
	     * @memberOf _
	     * @category Chain
	     * @param {...*} [values] The values to concatenate.
	     * @returns {Array} Returns the new concatenated array.
	     * @example
	     *
	     * var array = [1];
	     * var wrapped = _(array).concat(2, [3], [[4]]);
	     *
	     * console.log(wrapped.value());
	     * // => [1, 2, 3, [4]]
	     *
	     * console.log(array);
	     * // => [1]
	     */
	    var wrapperConcat = restParam(function(values) {
	      values = baseFlatten(values);
	      return this.thru(function(array) {
	        return arrayConcat(isArray(array) ? array : [toObject(array)], values);
	      });
	    });

	    /**
	     * Creates a clone of the chained sequence planting `value` as the wrapped value.
	     *
	     * @name plant
	     * @memberOf _
	     * @category Chain
	     * @returns {Object} Returns the new `lodash` wrapper instance.
	     * @example
	     *
	     * var array = [1, 2];
	     * var wrapped = _(array).map(function(value) {
	     *   return Math.pow(value, 2);
	     * });
	     *
	     * var other = [3, 4];
	     * var otherWrapped = wrapped.plant(other);
	     *
	     * otherWrapped.value();
	     * // => [9, 16]
	     *
	     * wrapped.value();
	     * // => [1, 4]
	     */
	    function wrapperPlant(value) {
	      var result,
	          parent = this;

	      while (parent instanceof baseLodash) {
	        var clone = wrapperClone(parent);
	        if (result) {
	          previous.__wrapped__ = clone;
	        } else {
	          result = clone;
	        }
	        var previous = clone;
	        parent = parent.__wrapped__;
	      }
	      previous.__wrapped__ = value;
	      return result;
	    }

	    /**
	     * Reverses the wrapped array so the first element becomes the last, the
	     * second element becomes the second to last, and so on.
	     *
	     * **Note:** This method mutates the wrapped array.
	     *
	     * @name reverse
	     * @memberOf _
	     * @category Chain
	     * @returns {Object} Returns the new reversed `lodash` wrapper instance.
	     * @example
	     *
	     * var array = [1, 2, 3];
	     *
	     * _(array).reverse().value()
	     * // => [3, 2, 1]
	     *
	     * console.log(array);
	     * // => [3, 2, 1]
	     */
	    function wrapperReverse() {
	      var value = this.__wrapped__;

	      var interceptor = function(value) {
	        return (wrapped && wrapped.__dir__ < 0) ? value : value.reverse();
	      };
	      if (value instanceof LazyWrapper) {
	        var wrapped = value;
	        if (this.__actions__.length) {
	          wrapped = new LazyWrapper(this);
	        }
	        wrapped = wrapped.reverse();
	        wrapped.__actions__.push({ 'func': thru, 'args': [interceptor], 'thisArg': undefined });
	        return new LodashWrapper(wrapped, this.__chain__);
	      }
	      return this.thru(interceptor);
	    }

	    /**
	     * Produces the result of coercing the unwrapped value to a string.
	     *
	     * @name toString
	     * @memberOf _
	     * @category Chain
	     * @returns {string} Returns the coerced string value.
	     * @example
	     *
	     * _([1, 2, 3]).toString();
	     * // => '1,2,3'
	     */
	    function wrapperToString() {
	      return (this.value() + '');
	    }

	    /**
	     * Executes the chained sequence to extract the unwrapped value.
	     *
	     * @name value
	     * @memberOf _
	     * @alias run, toJSON, valueOf
	     * @category Chain
	     * @returns {*} Returns the resolved unwrapped value.
	     * @example
	     *
	     * _([1, 2, 3]).value();
	     * // => [1, 2, 3]
	     */
	    function wrapperValue() {
	      return baseWrapperValue(this.__wrapped__, this.__actions__);
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates an array of elements corresponding to the given keys, or indexes,
	     * of `collection`. Keys may be specified as individual arguments or as arrays
	     * of keys.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {...(number|number[]|string|string[])} [props] The property names
	     *  or indexes of elements to pick, specified individually or in arrays.
	     * @returns {Array} Returns the new array of picked elements.
	     * @example
	     *
	     * _.at(['a', 'b', 'c'], [0, 2]);
	     * // => ['a', 'c']
	     *
	     * _.at(['barney', 'fred', 'pebbles'], 0, 2);
	     * // => ['barney', 'pebbles']
	     */
	    var at = restParam(function(collection, props) {
	      return baseAt(collection, baseFlatten(props));
	    });

	    /**
	     * Creates an object composed of keys generated from the results of running
	     * each element of `collection` through `iteratee`. The corresponding value
	     * of each key is the number of times the key was returned by `iteratee`.
	     * The `iteratee` is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns the composed aggregate object.
	     * @example
	     *
	     * _.countBy([4.3, 6.1, 6.4], function(n) {
	     *   return Math.floor(n);
	     * });
	     * // => { '4': 1, '6': 2 }
	     *
	     * _.countBy([4.3, 6.1, 6.4], function(n) {
	     *   return this.floor(n);
	     * }, Math);
	     * // => { '4': 1, '6': 2 }
	     *
	     * _.countBy(['one', 'two', 'three'], 'length');
	     * // => { '3': 2, '5': 1 }
	     */
	    var countBy = createAggregator(function(result, value, key) {
	      hasOwnProperty.call(result, key) ? ++result[key] : (result[key] = 1);
	    });

	    /**
	     * Checks if `predicate` returns truthy for **all** elements of `collection`.
	     * The predicate is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias all
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {boolean} Returns `true` if all elements pass the predicate check,
	     *  else `false`.
	     * @example
	     *
	     * _.every([true, 1, null, 'yes'], Boolean);
	     * // => false
	     *
	     * var users = [
	     *   { 'user': 'barney', 'active': false },
	     *   { 'user': 'fred',   'active': false }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.every(users, { 'user': 'barney', 'active': false });
	     * // => false
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.every(users, 'active', false);
	     * // => true
	     *
	     * // using the `_.property` callback shorthand
	     * _.every(users, 'active');
	     * // => false
	     */
	    function every(collection, predicate, thisArg) {
	      var func = isArray(collection) ? arrayEvery : baseEvery;
	      if (thisArg && isIterateeCall(collection, predicate, thisArg)) {
	        predicate = undefined;
	      }
	      if (typeof predicate != 'function' || thisArg !== undefined) {
	        predicate = getCallback(predicate, thisArg, 3);
	      }
	      return func(collection, predicate);
	    }

	    /**
	     * Iterates over elements of `collection`, returning an array of all elements
	     * `predicate` returns truthy for. The predicate is bound to `thisArg` and
	     * invoked with three arguments: (value, index|key, collection).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias select
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the new filtered array.
	     * @example
	     *
	     * _.filter([4, 5, 6], function(n) {
	     *   return n % 2 == 0;
	     * });
	     * // => [4, 6]
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36, 'active': true },
	     *   { 'user': 'fred',   'age': 40, 'active': false }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.filter(users, { 'age': 36, 'active': true }), 'user');
	     * // => ['barney']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.filter(users, 'active', false), 'user');
	     * // => ['fred']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.filter(users, 'active'), 'user');
	     * // => ['barney']
	     */
	    function filter(collection, predicate, thisArg) {
	      var func = isArray(collection) ? arrayFilter : baseFilter;
	      predicate = getCallback(predicate, thisArg, 3);
	      return func(collection, predicate);
	    }

	    /**
	     * Iterates over elements of `collection`, returning the first element
	     * `predicate` returns truthy for. The predicate is bound to `thisArg` and
	     * invoked with three arguments: (value, index|key, collection).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias detect
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {*} Returns the matched element, else `undefined`.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney',  'age': 36, 'active': true },
	     *   { 'user': 'fred',    'age': 40, 'active': false },
	     *   { 'user': 'pebbles', 'age': 1,  'active': true }
	     * ];
	     *
	     * _.result(_.find(users, function(chr) {
	     *   return chr.age < 40;
	     * }), 'user');
	     * // => 'barney'
	     *
	     * // using the `_.matches` callback shorthand
	     * _.result(_.find(users, { 'age': 1, 'active': true }), 'user');
	     * // => 'pebbles'
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.result(_.find(users, 'active', false), 'user');
	     * // => 'fred'
	     *
	     * // using the `_.property` callback shorthand
	     * _.result(_.find(users, 'active'), 'user');
	     * // => 'barney'
	     */
	    var find = createFind(baseEach);

	    /**
	     * This method is like `_.find` except that it iterates over elements of
	     * `collection` from right to left.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {*} Returns the matched element, else `undefined`.
	     * @example
	     *
	     * _.findLast([1, 2, 3, 4], function(n) {
	     *   return n % 2 == 1;
	     * });
	     * // => 3
	     */
	    var findLast = createFind(baseEachRight, true);

	    /**
	     * Performs a deep comparison between each element in `collection` and the
	     * source object, returning the first element that has equivalent property
	     * values.
	     *
	     * **Note:** This method supports comparing arrays, booleans, `Date` objects,
	     * numbers, `Object` objects, regexes, and strings. Objects are compared by
	     * their own, not inherited, enumerable properties. For comparing a single
	     * own or inherited property value see `_.matchesProperty`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {Object} source The object of property values to match.
	     * @returns {*} Returns the matched element, else `undefined`.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36, 'active': true },
	     *   { 'user': 'fred',   'age': 40, 'active': false }
	     * ];
	     *
	     * _.result(_.findWhere(users, { 'age': 36, 'active': true }), 'user');
	     * // => 'barney'
	     *
	     * _.result(_.findWhere(users, { 'age': 40, 'active': false }), 'user');
	     * // => 'fred'
	     */
	    function findWhere(collection, source) {
	      return find(collection, baseMatches(source));
	    }

	    /**
	     * Iterates over elements of `collection` invoking `iteratee` for each element.
	     * The `iteratee` is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection). Iteratee functions may exit iteration early
	     * by explicitly returning `false`.
	     *
	     * **Note:** As with other "Collections" methods, objects with a "length" property
	     * are iterated like arrays. To avoid this behavior `_.forIn` or `_.forOwn`
	     * may be used for object iteration.
	     *
	     * @static
	     * @memberOf _
	     * @alias each
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array|Object|string} Returns `collection`.
	     * @example
	     *
	     * _([1, 2]).forEach(function(n) {
	     *   console.log(n);
	     * }).value();
	     * // => logs each value from left to right and returns the array
	     *
	     * _.forEach({ 'a': 1, 'b': 2 }, function(n, key) {
	     *   console.log(n, key);
	     * });
	     * // => logs each value-key pair and returns the object (iteration order is not guaranteed)
	     */
	    var forEach = createForEach(arrayEach, baseEach);

	    /**
	     * This method is like `_.forEach` except that it iterates over elements of
	     * `collection` from right to left.
	     *
	     * @static
	     * @memberOf _
	     * @alias eachRight
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array|Object|string} Returns `collection`.
	     * @example
	     *
	     * _([1, 2]).forEachRight(function(n) {
	     *   console.log(n);
	     * }).value();
	     * // => logs each value from right to left and returns the array
	     */
	    var forEachRight = createForEach(arrayEachRight, baseEachRight);

	    /**
	     * Creates an object composed of keys generated from the results of running
	     * each element of `collection` through `iteratee`. The corresponding value
	     * of each key is an array of the elements responsible for generating the key.
	     * The `iteratee` is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns the composed aggregate object.
	     * @example
	     *
	     * _.groupBy([4.2, 6.1, 6.4], function(n) {
	     *   return Math.floor(n);
	     * });
	     * // => { '4': [4.2], '6': [6.1, 6.4] }
	     *
	     * _.groupBy([4.2, 6.1, 6.4], function(n) {
	     *   return this.floor(n);
	     * }, Math);
	     * // => { '4': [4.2], '6': [6.1, 6.4] }
	     *
	     * // using the `_.property` callback shorthand
	     * _.groupBy(['one', 'two', 'three'], 'length');
	     * // => { '3': ['one', 'two'], '5': ['three'] }
	     */
	    var groupBy = createAggregator(function(result, value, key) {
	      if (hasOwnProperty.call(result, key)) {
	        result[key].push(value);
	      } else {
	        result[key] = [value];
	      }
	    });

	    /**
	     * Checks if `value` is in `collection` using
	     * [`SameValueZero`](http://ecma-international.org/ecma-262/6.0/#sec-samevaluezero)
	     * for equality comparisons. If `fromIndex` is negative, it is used as the offset
	     * from the end of `collection`.
	     *
	     * @static
	     * @memberOf _
	     * @alias contains, include
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {*} target The value to search for.
	     * @param {number} [fromIndex=0] The index to search from.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.reduce`.
	     * @returns {boolean} Returns `true` if a matching element is found, else `false`.
	     * @example
	     *
	     * _.includes([1, 2, 3], 1);
	     * // => true
	     *
	     * _.includes([1, 2, 3], 1, 2);
	     * // => false
	     *
	     * _.includes({ 'user': 'fred', 'age': 40 }, 'fred');
	     * // => true
	     *
	     * _.includes('pebbles', 'eb');
	     * // => true
	     */
	    function includes(collection, target, fromIndex, guard) {
	      var length = collection ? getLength(collection) : 0;
	      if (!isLength(length)) {
	        collection = values(collection);
	        length = collection.length;
	      }
	      if (typeof fromIndex != 'number' || (guard && isIterateeCall(target, fromIndex, guard))) {
	        fromIndex = 0;
	      } else {
	        fromIndex = fromIndex < 0 ? nativeMax(length + fromIndex, 0) : (fromIndex || 0);
	      }
	      return (typeof collection == 'string' || !isArray(collection) && isString(collection))
	        ? (fromIndex <= length && collection.indexOf(target, fromIndex) > -1)
	        : (!!length && getIndexOf(collection, target, fromIndex) > -1);
	    }

	    /**
	     * Creates an object composed of keys generated from the results of running
	     * each element of `collection` through `iteratee`. The corresponding value
	     * of each key is the last element responsible for generating the key. The
	     * iteratee function is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns the composed aggregate object.
	     * @example
	     *
	     * var keyData = [
	     *   { 'dir': 'left', 'code': 97 },
	     *   { 'dir': 'right', 'code': 100 }
	     * ];
	     *
	     * _.indexBy(keyData, 'dir');
	     * // => { 'left': { 'dir': 'left', 'code': 97 }, 'right': { 'dir': 'right', 'code': 100 } }
	     *
	     * _.indexBy(keyData, function(object) {
	     *   return String.fromCharCode(object.code);
	     * });
	     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }
	     *
	     * _.indexBy(keyData, function(object) {
	     *   return this.fromCharCode(object.code);
	     * }, String);
	     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }
	     */
	    var indexBy = createAggregator(function(result, value, key) {
	      result[key] = value;
	    });

	    /**
	     * Invokes the method at `path` of each element in `collection`, returning
	     * an array of the results of each invoked method. Any additional arguments
	     * are provided to each invoked method. If `methodName` is a function it is
	     * invoked for, and `this` bound to, each element in `collection`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Array|Function|string} path The path of the method to invoke or
	     *  the function invoked per iteration.
	     * @param {...*} [args] The arguments to invoke the method with.
	     * @returns {Array} Returns the array of results.
	     * @example
	     *
	     * _.invoke([[5, 1, 7], [3, 2, 1]], 'sort');
	     * // => [[1, 5, 7], [1, 2, 3]]
	     *
	     * _.invoke([123, 456], String.prototype.split, '');
	     * // => [['1', '2', '3'], ['4', '5', '6']]
	     */
	    var invoke = restParam(function(collection, path, args) {
	      var index = -1,
	          isFunc = typeof path == 'function',
	          isProp = isKey(path),
	          result = isArrayLike(collection) ? Array(collection.length) : [];

	      baseEach(collection, function(value) {
	        var func = isFunc ? path : ((isProp && value != null) ? value[path] : undefined);
	        result[++index] = func ? func.apply(value, args) : invokePath(value, path, args);
	      });
	      return result;
	    });

	    /**
	     * Creates an array of values by running each element in `collection` through
	     * `iteratee`. The `iteratee` is bound to `thisArg` and invoked with three
	     * arguments: (value, index|key, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * Many lodash methods are guarded to work as iteratees for methods like
	     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
	     *
	     * The guarded methods are:
	     * `ary`, `callback`, `chunk`, `clone`, `create`, `curry`, `curryRight`,
	     * `drop`, `dropRight`, `every`, `fill`, `flatten`, `invert`, `max`, `min`,
	     * `parseInt`, `slice`, `sortBy`, `take`, `takeRight`, `template`, `trim`,
	     * `trimLeft`, `trimRight`, `trunc`, `random`, `range`, `sample`, `some`,
	     * `sum`, `uniq`, and `words`
	     *
	     * @static
	     * @memberOf _
	     * @alias collect
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the new mapped array.
	     * @example
	     *
	     * function timesThree(n) {
	     *   return n * 3;
	     * }
	     *
	     * _.map([1, 2], timesThree);
	     * // => [3, 6]
	     *
	     * _.map({ 'a': 1, 'b': 2 }, timesThree);
	     * // => [3, 6] (iteration order is not guaranteed)
	     *
	     * var users = [
	     *   { 'user': 'barney' },
	     *   { 'user': 'fred' }
	     * ];
	     *
	     * // using the `_.property` callback shorthand
	     * _.map(users, 'user');
	     * // => ['barney', 'fred']
	     */
	    function map(collection, iteratee, thisArg) {
	      var func = isArray(collection) ? arrayMap : baseMap;
	      iteratee = getCallback(iteratee, thisArg, 3);
	      return func(collection, iteratee);
	    }

	    /**
	     * Creates an array of elements split into two groups, the first of which
	     * contains elements `predicate` returns truthy for, while the second of which
	     * contains elements `predicate` returns falsey for. The predicate is bound
	     * to `thisArg` and invoked with three arguments: (value, index|key, collection).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the array of grouped elements.
	     * @example
	     *
	     * _.partition([1, 2, 3], function(n) {
	     *   return n % 2;
	     * });
	     * // => [[1, 3], [2]]
	     *
	     * _.partition([1.2, 2.3, 3.4], function(n) {
	     *   return this.floor(n) % 2;
	     * }, Math);
	     * // => [[1.2, 3.4], [2.3]]
	     *
	     * var users = [
	     *   { 'user': 'barney',  'age': 36, 'active': false },
	     *   { 'user': 'fred',    'age': 40, 'active': true },
	     *   { 'user': 'pebbles', 'age': 1,  'active': false }
	     * ];
	     *
	     * var mapper = function(array) {
	     *   return _.pluck(array, 'user');
	     * };
	     *
	     * // using the `_.matches` callback shorthand
	     * _.map(_.partition(users, { 'age': 1, 'active': false }), mapper);
	     * // => [['pebbles'], ['barney', 'fred']]
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.map(_.partition(users, 'active', false), mapper);
	     * // => [['barney', 'pebbles'], ['fred']]
	     *
	     * // using the `_.property` callback shorthand
	     * _.map(_.partition(users, 'active'), mapper);
	     * // => [['fred'], ['barney', 'pebbles']]
	     */
	    var partition = createAggregator(function(result, value, key) {
	      result[key ? 0 : 1].push(value);
	    }, function() { return [[], []]; });

	    /**
	     * Gets the property value of `path` from all elements in `collection`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Array|string} path The path of the property to pluck.
	     * @returns {Array} Returns the property values.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 40 }
	     * ];
	     *
	     * _.pluck(users, 'user');
	     * // => ['barney', 'fred']
	     *
	     * var userIndex = _.indexBy(users, 'user');
	     * _.pluck(userIndex, 'age');
	     * // => [36, 40] (iteration order is not guaranteed)
	     */
	    function pluck(collection, path) {
	      return map(collection, property(path));
	    }

	    /**
	     * Reduces `collection` to a value which is the accumulated result of running
	     * each element in `collection` through `iteratee`, where each successive
	     * invocation is supplied the return value of the previous. If `accumulator`
	     * is not provided the first element of `collection` is used as the initial
	     * value. The `iteratee` is bound to `thisArg` and invoked with four arguments:
	     * (accumulator, value, index|key, collection).
	     *
	     * Many lodash methods are guarded to work as iteratees for methods like
	     * `_.reduce`, `_.reduceRight`, and `_.transform`.
	     *
	     * The guarded methods are:
	     * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `sortByAll`,
	     * and `sortByOrder`
	     *
	     * @static
	     * @memberOf _
	     * @alias foldl, inject
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [accumulator] The initial value.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {*} Returns the accumulated value.
	     * @example
	     *
	     * _.reduce([1, 2], function(total, n) {
	     *   return total + n;
	     * });
	     * // => 3
	     *
	     * _.reduce({ 'a': 1, 'b': 2 }, function(result, n, key) {
	     *   result[key] = n * 3;
	     *   return result;
	     * }, {});
	     * // => { 'a': 3, 'b': 6 } (iteration order is not guaranteed)
	     */
	    var reduce = createReduce(arrayReduce, baseEach);

	    /**
	     * This method is like `_.reduce` except that it iterates over elements of
	     * `collection` from right to left.
	     *
	     * @static
	     * @memberOf _
	     * @alias foldr
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [accumulator] The initial value.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {*} Returns the accumulated value.
	     * @example
	     *
	     * var array = [[0, 1], [2, 3], [4, 5]];
	     *
	     * _.reduceRight(array, function(flattened, other) {
	     *   return flattened.concat(other);
	     * }, []);
	     * // => [4, 5, 2, 3, 0, 1]
	     */
	    var reduceRight = createReduce(arrayReduceRight, baseEachRight);

	    /**
	     * The opposite of `_.filter`; this method returns the elements of `collection`
	     * that `predicate` does **not** return truthy for.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Array} Returns the new filtered array.
	     * @example
	     *
	     * _.reject([1, 2, 3, 4], function(n) {
	     *   return n % 2 == 0;
	     * });
	     * // => [1, 3]
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36, 'active': false },
	     *   { 'user': 'fred',   'age': 40, 'active': true }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.pluck(_.reject(users, { 'age': 40, 'active': true }), 'user');
	     * // => ['barney']
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.pluck(_.reject(users, 'active', false), 'user');
	     * // => ['fred']
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.reject(users, 'active'), 'user');
	     * // => ['barney']
	     */
	    function reject(collection, predicate, thisArg) {
	      var func = isArray(collection) ? arrayFilter : baseFilter;
	      predicate = getCallback(predicate, thisArg, 3);
	      return func(collection, function(value, index, collection) {
	        return !predicate(value, index, collection);
	      });
	    }

	    /**
	     * Gets a random element or `n` random elements from a collection.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to sample.
	     * @param {number} [n] The number of elements to sample.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {*} Returns the random sample(s).
	     * @example
	     *
	     * _.sample([1, 2, 3, 4]);
	     * // => 2
	     *
	     * _.sample([1, 2, 3, 4], 2);
	     * // => [3, 1]
	     */
	    function sample(collection, n, guard) {
	      if (guard ? isIterateeCall(collection, n, guard) : n == null) {
	        collection = toIterable(collection);
	        var length = collection.length;
	        return length > 0 ? collection[baseRandom(0, length - 1)] : undefined;
	      }
	      var index = -1,
	          result = toArray(collection),
	          length = result.length,
	          lastIndex = length - 1;

	      n = nativeMin(n < 0 ? 0 : (+n || 0), length);
	      while (++index < n) {
	        var rand = baseRandom(index, lastIndex),
	            value = result[rand];

	        result[rand] = result[index];
	        result[index] = value;
	      }
	      result.length = n;
	      return result;
	    }

	    /**
	     * Creates an array of shuffled values, using a version of the
	     * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to shuffle.
	     * @returns {Array} Returns the new shuffled array.
	     * @example
	     *
	     * _.shuffle([1, 2, 3, 4]);
	     * // => [4, 1, 3, 2]
	     */
	    function shuffle(collection) {
	      return sample(collection, POSITIVE_INFINITY);
	    }

	    /**
	     * Gets the size of `collection` by returning its length for array-like
	     * values or the number of own enumerable properties for objects.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to inspect.
	     * @returns {number} Returns the size of `collection`.
	     * @example
	     *
	     * _.size([1, 2, 3]);
	     * // => 3
	     *
	     * _.size({ 'a': 1, 'b': 2 });
	     * // => 2
	     *
	     * _.size('pebbles');
	     * // => 7
	     */
	    function size(collection) {
	      var length = collection ? getLength(collection) : 0;
	      return isLength(length) ? length : keys(collection).length;
	    }

	    /**
	     * Checks if `predicate` returns truthy for **any** element of `collection`.
	     * The function returns as soon as it finds a passing value and does not iterate
	     * over the entire collection. The predicate is bound to `thisArg` and invoked
	     * with three arguments: (value, index|key, collection).
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias any
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {boolean} Returns `true` if any element passes the predicate check,
	     *  else `false`.
	     * @example
	     *
	     * _.some([null, 0, 'yes', false], Boolean);
	     * // => true
	     *
	     * var users = [
	     *   { 'user': 'barney', 'active': true },
	     *   { 'user': 'fred',   'active': false }
	     * ];
	     *
	     * // using the `_.matches` callback shorthand
	     * _.some(users, { 'user': 'barney', 'active': false });
	     * // => false
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.some(users, 'active', false);
	     * // => true
	     *
	     * // using the `_.property` callback shorthand
	     * _.some(users, 'active');
	     * // => true
	     */
	    function some(collection, predicate, thisArg) {
	      var func = isArray(collection) ? arraySome : baseSome;
	      if (thisArg && isIterateeCall(collection, predicate, thisArg)) {
	        predicate = undefined;
	      }
	      if (typeof predicate != 'function' || thisArg !== undefined) {
	        predicate = getCallback(predicate, thisArg, 3);
	      }
	      return func(collection, predicate);
	    }

	    /**
	     * Creates an array of elements, sorted in ascending order by the results of
	     * running each element in a collection through `iteratee`. This method performs
	     * a stable sort, that is, it preserves the original sort order of equal elements.
	     * The `iteratee` is bound to `thisArg` and invoked with three arguments:
	     * (value, index|key, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the new sorted array.
	     * @example
	     *
	     * _.sortBy([1, 2, 3], function(n) {
	     *   return Math.sin(n);
	     * });
	     * // => [3, 1, 2]
	     *
	     * _.sortBy([1, 2, 3], function(n) {
	     *   return this.sin(n);
	     * }, Math);
	     * // => [3, 1, 2]
	     *
	     * var users = [
	     *   { 'user': 'fred' },
	     *   { 'user': 'pebbles' },
	     *   { 'user': 'barney' }
	     * ];
	     *
	     * // using the `_.property` callback shorthand
	     * _.pluck(_.sortBy(users, 'user'), 'user');
	     * // => ['barney', 'fred', 'pebbles']
	     */
	    function sortBy(collection, iteratee, thisArg) {
	      if (collection == null) {
	        return [];
	      }
	      if (thisArg && isIterateeCall(collection, iteratee, thisArg)) {
	        iteratee = undefined;
	      }
	      var index = -1;
	      iteratee = getCallback(iteratee, thisArg, 3);

	      var result = baseMap(collection, function(value, key, collection) {
	        return { 'criteria': iteratee(value, key, collection), 'index': ++index, 'value': value };
	      });
	      return baseSortBy(result, compareAscending);
	    }

	    /**
	     * This method is like `_.sortBy` except that it can sort by multiple iteratees
	     * or property names.
	     *
	     * If a property name is provided for an iteratee the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If an object is provided for an iteratee the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {...(Function|Function[]|Object|Object[]|string|string[])} iteratees
	     *  The iteratees to sort by, specified as individual values or arrays of values.
	     * @returns {Array} Returns the new sorted array.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'fred',   'age': 48 },
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 42 },
	     *   { 'user': 'barney', 'age': 34 }
	     * ];
	     *
	     * _.map(_.sortByAll(users, ['user', 'age']), _.values);
	     * // => [['barney', 34], ['barney', 36], ['fred', 42], ['fred', 48]]
	     *
	     * _.map(_.sortByAll(users, 'user', function(chr) {
	     *   return Math.floor(chr.age / 10);
	     * }), _.values);
	     * // => [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 42]]
	     */
	    var sortByAll = restParam(function(collection, iteratees) {
	      if (collection == null) {
	        return [];
	      }
	      var guard = iteratees[2];
	      if (guard && isIterateeCall(iteratees[0], iteratees[1], guard)) {
	        iteratees.length = 1;
	      }
	      return baseSortByOrder(collection, baseFlatten(iteratees), []);
	    });

	    /**
	     * This method is like `_.sortByAll` except that it allows specifying the
	     * sort orders of the iteratees to sort by. If `orders` is unspecified, all
	     * values are sorted in ascending order. Otherwise, a value is sorted in
	     * ascending order if its corresponding order is "asc", and descending if "desc".
	     *
	     * If a property name is provided for an iteratee the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If an object is provided for an iteratee the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
	     * @param {boolean[]} [orders] The sort orders of `iteratees`.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.reduce`.
	     * @returns {Array} Returns the new sorted array.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'fred',   'age': 48 },
	     *   { 'user': 'barney', 'age': 34 },
	     *   { 'user': 'fred',   'age': 42 },
	     *   { 'user': 'barney', 'age': 36 }
	     * ];
	     *
	     * // sort by `user` in ascending order and by `age` in descending order
	     * _.map(_.sortByOrder(users, ['user', 'age'], ['asc', 'desc']), _.values);
	     * // => [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 42]]
	     */
	    function sortByOrder(collection, iteratees, orders, guard) {
	      if (collection == null) {
	        return [];
	      }
	      if (guard && isIterateeCall(iteratees, orders, guard)) {
	        orders = undefined;
	      }
	      if (!isArray(iteratees)) {
	        iteratees = iteratees == null ? [] : [iteratees];
	      }
	      if (!isArray(orders)) {
	        orders = orders == null ? [] : [orders];
	      }
	      return baseSortByOrder(collection, iteratees, orders);
	    }

	    /**
	     * Performs a deep comparison between each element in `collection` and the
	     * source object, returning an array of all elements that have equivalent
	     * property values.
	     *
	     * **Note:** This method supports comparing arrays, booleans, `Date` objects,
	     * numbers, `Object` objects, regexes, and strings. Objects are compared by
	     * their own, not inherited, enumerable properties. For comparing a single
	     * own or inherited property value see `_.matchesProperty`.
	     *
	     * @static
	     * @memberOf _
	     * @category Collection
	     * @param {Array|Object|string} collection The collection to search.
	     * @param {Object} source The object of property values to match.
	     * @returns {Array} Returns the new filtered array.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36, 'active': false, 'pets': ['hoppy'] },
	     *   { 'user': 'fred',   'age': 40, 'active': true, 'pets': ['baby puss', 'dino'] }
	     * ];
	     *
	     * _.pluck(_.where(users, { 'age': 36, 'active': false }), 'user');
	     * // => ['barney']
	     *
	     * _.pluck(_.where(users, { 'pets': ['dino'] }), 'user');
	     * // => ['fred']
	     */
	    function where(collection, source) {
	      return filter(collection, baseMatches(source));
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Gets the number of milliseconds that have elapsed since the Unix epoch
	     * (1 January 1970 00:00:00 UTC).
	     *
	     * @static
	     * @memberOf _
	     * @category Date
	     * @example
	     *
	     * _.defer(function(stamp) {
	     *   console.log(_.now() - stamp);
	     * }, _.now());
	     * // => logs the number of milliseconds it took for the deferred function to be invoked
	     */
	    var now = nativeNow || function() {
	      return new Date().getTime();
	    };

	    /*------------------------------------------------------------------------*/

	    /**
	     * The opposite of `_.before`; this method creates a function that invokes
	     * `func` once it is called `n` or more times.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {number} n The number of calls before `func` is invoked.
	     * @param {Function} func The function to restrict.
	     * @returns {Function} Returns the new restricted function.
	     * @example
	     *
	     * var saves = ['profile', 'settings'];
	     *
	     * var done = _.after(saves.length, function() {
	     *   console.log('done saving!');
	     * });
	     *
	     * _.forEach(saves, function(type) {
	     *   asyncSave({ 'type': type, 'complete': done });
	     * });
	     * // => logs 'done saving!' after the two async saves have completed
	     */
	    function after(n, func) {
	      if (typeof func != 'function') {
	        if (typeof n == 'function') {
	          var temp = n;
	          n = func;
	          func = temp;
	        } else {
	          throw new TypeError(FUNC_ERROR_TEXT);
	        }
	      }
	      n = nativeIsFinite(n = +n) ? n : 0;
	      return function() {
	        if (--n < 1) {
	          return func.apply(this, arguments);
	        }
	      };
	    }

	    /**
	     * Creates a function that accepts up to `n` arguments ignoring any
	     * additional arguments.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to cap arguments for.
	     * @param {number} [n=func.length] The arity cap.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * _.map(['6', '8', '10'], _.ary(parseInt, 1));
	     * // => [6, 8, 10]
	     */
	    function ary(func, n, guard) {
	      if (guard && isIterateeCall(func, n, guard)) {
	        n = undefined;
	      }
	      n = (func && n == null) ? func.length : nativeMax(+n || 0, 0);
	      return createWrapper(func, ARY_FLAG, undefined, undefined, undefined, undefined, n);
	    }

	    /**
	     * Creates a function that invokes `func`, with the `this` binding and arguments
	     * of the created function, while it is called less than `n` times. Subsequent
	     * calls to the created function return the result of the last `func` invocation.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {number} n The number of calls at which `func` is no longer invoked.
	     * @param {Function} func The function to restrict.
	     * @returns {Function} Returns the new restricted function.
	     * @example
	     *
	     * jQuery('#add').on('click', _.before(5, addContactToList));
	     * // => allows adding up to 4 contacts to the list
	     */
	    function before(n, func) {
	      var result;
	      if (typeof func != 'function') {
	        if (typeof n == 'function') {
	          var temp = n;
	          n = func;
	          func = temp;
	        } else {
	          throw new TypeError(FUNC_ERROR_TEXT);
	        }
	      }
	      return function() {
	        if (--n > 0) {
	          result = func.apply(this, arguments);
	        }
	        if (n <= 1) {
	          func = undefined;
	        }
	        return result;
	      };
	    }

	    /**
	     * Creates a function that invokes `func` with the `this` binding of `thisArg`
	     * and prepends any additional `_.bind` arguments to those provided to the
	     * bound function.
	     *
	     * The `_.bind.placeholder` value, which defaults to `_` in monolithic builds,
	     * may be used as a placeholder for partially applied arguments.
	     *
	     * **Note:** Unlike native `Function#bind` this method does not set the "length"
	     * property of bound functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to bind.
	     * @param {*} thisArg The `this` binding of `func`.
	     * @param {...*} [partials] The arguments to be partially applied.
	     * @returns {Function} Returns the new bound function.
	     * @example
	     *
	     * var greet = function(greeting, punctuation) {
	     *   return greeting + ' ' + this.user + punctuation;
	     * };
	     *
	     * var object = { 'user': 'fred' };
	     *
	     * var bound = _.bind(greet, object, 'hi');
	     * bound('!');
	     * // => 'hi fred!'
	     *
	     * // using placeholders
	     * var bound = _.bind(greet, object, _, '!');
	     * bound('hi');
	     * // => 'hi fred!'
	     */
	    var bind = restParam(function(func, thisArg, partials) {
	      var bitmask = BIND_FLAG;
	      if (partials.length) {
	        var holders = replaceHolders(partials, bind.placeholder);
	        bitmask |= PARTIAL_FLAG;
	      }
	      return createWrapper(func, bitmask, thisArg, partials, holders);
	    });

	    /**
	     * Binds methods of an object to the object itself, overwriting the existing
	     * method. Method names may be specified as individual arguments or as arrays
	     * of method names. If no method names are provided all enumerable function
	     * properties, own and inherited, of `object` are bound.
	     *
	     * **Note:** This method does not set the "length" property of bound functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Object} object The object to bind and assign the bound methods to.
	     * @param {...(string|string[])} [methodNames] The object method names to bind,
	     *  specified as individual method names or arrays of method names.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * var view = {
	     *   'label': 'docs',
	     *   'onClick': function() {
	     *     console.log('clicked ' + this.label);
	     *   }
	     * };
	     *
	     * _.bindAll(view);
	     * jQuery('#docs').on('click', view.onClick);
	     * // => logs 'clicked docs' when the element is clicked
	     */
	    var bindAll = restParam(function(object, methodNames) {
	      methodNames = methodNames.length ? baseFlatten(methodNames) : functions(object);

	      var index = -1,
	          length = methodNames.length;

	      while (++index < length) {
	        var key = methodNames[index];
	        object[key] = createWrapper(object[key], BIND_FLAG, object);
	      }
	      return object;
	    });

	    /**
	     * Creates a function that invokes the method at `object[key]` and prepends
	     * any additional `_.bindKey` arguments to those provided to the bound function.
	     *
	     * This method differs from `_.bind` by allowing bound functions to reference
	     * methods that may be redefined or don't yet exist.
	     * See [Peter Michaux's article](http://peter.michaux.ca/articles/lazy-function-definition-pattern)
	     * for more details.
	     *
	     * The `_.bindKey.placeholder` value, which defaults to `_` in monolithic
	     * builds, may be used as a placeholder for partially applied arguments.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Object} object The object the method belongs to.
	     * @param {string} key The key of the method.
	     * @param {...*} [partials] The arguments to be partially applied.
	     * @returns {Function} Returns the new bound function.
	     * @example
	     *
	     * var object = {
	     *   'user': 'fred',
	     *   'greet': function(greeting, punctuation) {
	     *     return greeting + ' ' + this.user + punctuation;
	     *   }
	     * };
	     *
	     * var bound = _.bindKey(object, 'greet', 'hi');
	     * bound('!');
	     * // => 'hi fred!'
	     *
	     * object.greet = function(greeting, punctuation) {
	     *   return greeting + 'ya ' + this.user + punctuation;
	     * };
	     *
	     * bound('!');
	     * // => 'hiya fred!'
	     *
	     * // using placeholders
	     * var bound = _.bindKey(object, 'greet', _, '!');
	     * bound('hi');
	     * // => 'hiya fred!'
	     */
	    var bindKey = restParam(function(object, key, partials) {
	      var bitmask = BIND_FLAG | BIND_KEY_FLAG;
	      if (partials.length) {
	        var holders = replaceHolders(partials, bindKey.placeholder);
	        bitmask |= PARTIAL_FLAG;
	      }
	      return createWrapper(key, bitmask, object, partials, holders);
	    });

	    /**
	     * Creates a function that accepts one or more arguments of `func` that when
	     * called either invokes `func` returning its result, if all `func` arguments
	     * have been provided, or returns a function that accepts one or more of the
	     * remaining `func` arguments, and so on. The arity of `func` may be specified
	     * if `func.length` is not sufficient.
	     *
	     * The `_.curry.placeholder` value, which defaults to `_` in monolithic builds,
	     * may be used as a placeholder for provided arguments.
	     *
	     * **Note:** This method does not set the "length" property of curried functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to curry.
	     * @param {number} [arity=func.length] The arity of `func`.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Function} Returns the new curried function.
	     * @example
	     *
	     * var abc = function(a, b, c) {
	     *   return [a, b, c];
	     * };
	     *
	     * var curried = _.curry(abc);
	     *
	     * curried(1)(2)(3);
	     * // => [1, 2, 3]
	     *
	     * curried(1, 2)(3);
	     * // => [1, 2, 3]
	     *
	     * curried(1, 2, 3);
	     * // => [1, 2, 3]
	     *
	     * // using placeholders
	     * curried(1)(_, 3)(2);
	     * // => [1, 2, 3]
	     */
	    var curry = createCurry(CURRY_FLAG);

	    /**
	     * This method is like `_.curry` except that arguments are applied to `func`
	     * in the manner of `_.partialRight` instead of `_.partial`.
	     *
	     * The `_.curryRight.placeholder` value, which defaults to `_` in monolithic
	     * builds, may be used as a placeholder for provided arguments.
	     *
	     * **Note:** This method does not set the "length" property of curried functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to curry.
	     * @param {number} [arity=func.length] The arity of `func`.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Function} Returns the new curried function.
	     * @example
	     *
	     * var abc = function(a, b, c) {
	     *   return [a, b, c];
	     * };
	     *
	     * var curried = _.curryRight(abc);
	     *
	     * curried(3)(2)(1);
	     * // => [1, 2, 3]
	     *
	     * curried(2, 3)(1);
	     * // => [1, 2, 3]
	     *
	     * curried(1, 2, 3);
	     * // => [1, 2, 3]
	     *
	     * // using placeholders
	     * curried(3)(1, _)(2);
	     * // => [1, 2, 3]
	     */
	    var curryRight = createCurry(CURRY_RIGHT_FLAG);

	    /**
	     * Creates a debounced function that delays invoking `func` until after `wait`
	     * milliseconds have elapsed since the last time the debounced function was
	     * invoked. The debounced function comes with a `cancel` method to cancel
	     * delayed invocations. Provide an options object to indicate that `func`
	     * should be invoked on the leading and/or trailing edge of the `wait` timeout.
	     * Subsequent calls to the debounced function return the result of the last
	     * `func` invocation.
	     *
	     * **Note:** If `leading` and `trailing` options are `true`, `func` is invoked
	     * on the trailing edge of the timeout only if the the debounced function is
	     * invoked more than once during the `wait` timeout.
	     *
	     * See [David Corbacho's article](http://drupalmotion.com/article/debounce-and-throttle-visual-explanation)
	     * for details over the differences between `_.debounce` and `_.throttle`.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to debounce.
	     * @param {number} [wait=0] The number of milliseconds to delay.
	     * @param {Object} [options] The options object.
	     * @param {boolean} [options.leading=false] Specify invoking on the leading
	     *  edge of the timeout.
	     * @param {number} [options.maxWait] The maximum time `func` is allowed to be
	     *  delayed before it is invoked.
	     * @param {boolean} [options.trailing=true] Specify invoking on the trailing
	     *  edge of the timeout.
	     * @returns {Function} Returns the new debounced function.
	     * @example
	     *
	     * // avoid costly calculations while the window size is in flux
	     * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
	     *
	     * // invoke `sendMail` when the click event is fired, debouncing subsequent calls
	     * jQuery('#postbox').on('click', _.debounce(sendMail, 300, {
	     *   'leading': true,
	     *   'trailing': false
	     * }));
	     *
	     * // ensure `batchLog` is invoked once after 1 second of debounced calls
	     * var source = new EventSource('/stream');
	     * jQuery(source).on('message', _.debounce(batchLog, 250, {
	     *   'maxWait': 1000
	     * }));
	     *
	     * // cancel a debounced call
	     * var todoChanges = _.debounce(batchLog, 1000);
	     * Object.observe(models.todo, todoChanges);
	     *
	     * Object.observe(models, function(changes) {
	     *   if (_.find(changes, { 'user': 'todo', 'type': 'delete'})) {
	     *     todoChanges.cancel();
	     *   }
	     * }, ['delete']);
	     *
	     * // ...at some point `models.todo` is changed
	     * models.todo.completed = true;
	     *
	     * // ...before 1 second has passed `models.todo` is deleted
	     * // which cancels the debounced `todoChanges` call
	     * delete models.todo;
	     */
	    function debounce(func, wait, options) {
	      var args,
	          maxTimeoutId,
	          result,
	          stamp,
	          thisArg,
	          timeoutId,
	          trailingCall,
	          lastCalled = 0,
	          maxWait = false,
	          trailing = true;

	      if (typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      wait = wait < 0 ? 0 : (+wait || 0);
	      if (options === true) {
	        var leading = true;
	        trailing = false;
	      } else if (isObject(options)) {
	        leading = !!options.leading;
	        maxWait = 'maxWait' in options && nativeMax(+options.maxWait || 0, wait);
	        trailing = 'trailing' in options ? !!options.trailing : trailing;
	      }

	      function cancel() {
	        if (timeoutId) {
	          clearTimeout(timeoutId);
	        }
	        if (maxTimeoutId) {
	          clearTimeout(maxTimeoutId);
	        }
	        lastCalled = 0;
	        maxTimeoutId = timeoutId = trailingCall = undefined;
	      }

	      function complete(isCalled, id) {
	        if (id) {
	          clearTimeout(id);
	        }
	        maxTimeoutId = timeoutId = trailingCall = undefined;
	        if (isCalled) {
	          lastCalled = now();
	          result = func.apply(thisArg, args);
	          if (!timeoutId && !maxTimeoutId) {
	            args = thisArg = undefined;
	          }
	        }
	      }

	      function delayed() {
	        var remaining = wait - (now() - stamp);
	        if (remaining <= 0 || remaining > wait) {
	          complete(trailingCall, maxTimeoutId);
	        } else {
	          timeoutId = setTimeout(delayed, remaining);
	        }
	      }

	      function maxDelayed() {
	        complete(trailing, timeoutId);
	      }

	      function debounced() {
	        args = arguments;
	        stamp = now();
	        thisArg = this;
	        trailingCall = trailing && (timeoutId || !leading);

	        if (maxWait === false) {
	          var leadingCall = leading && !timeoutId;
	        } else {
	          if (!maxTimeoutId && !leading) {
	            lastCalled = stamp;
	          }
	          var remaining = maxWait - (stamp - lastCalled),
	              isCalled = remaining <= 0 || remaining > maxWait;

	          if (isCalled) {
	            if (maxTimeoutId) {
	              maxTimeoutId = clearTimeout(maxTimeoutId);
	            }
	            lastCalled = stamp;
	            result = func.apply(thisArg, args);
	          }
	          else if (!maxTimeoutId) {
	            maxTimeoutId = setTimeout(maxDelayed, remaining);
	          }
	        }
	        if (isCalled && timeoutId) {
	          timeoutId = clearTimeout(timeoutId);
	        }
	        else if (!timeoutId && wait !== maxWait) {
	          timeoutId = setTimeout(delayed, wait);
	        }
	        if (leadingCall) {
	          isCalled = true;
	          result = func.apply(thisArg, args);
	        }
	        if (isCalled && !timeoutId && !maxTimeoutId) {
	          args = thisArg = undefined;
	        }
	        return result;
	      }
	      debounced.cancel = cancel;
	      return debounced;
	    }

	    /**
	     * Defers invoking the `func` until the current call stack has cleared. Any
	     * additional arguments are provided to `func` when it is invoked.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to defer.
	     * @param {...*} [args] The arguments to invoke the function with.
	     * @returns {number} Returns the timer id.
	     * @example
	     *
	     * _.defer(function(text) {
	     *   console.log(text);
	     * }, 'deferred');
	     * // logs 'deferred' after one or more milliseconds
	     */
	    var defer = restParam(function(func, args) {
	      return baseDelay(func, 1, args);
	    });

	    /**
	     * Invokes `func` after `wait` milliseconds. Any additional arguments are
	     * provided to `func` when it is invoked.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to delay.
	     * @param {number} wait The number of milliseconds to delay invocation.
	     * @param {...*} [args] The arguments to invoke the function with.
	     * @returns {number} Returns the timer id.
	     * @example
	     *
	     * _.delay(function(text) {
	     *   console.log(text);
	     * }, 1000, 'later');
	     * // => logs 'later' after one second
	     */
	    var delay = restParam(function(func, wait, args) {
	      return baseDelay(func, wait, args);
	    });

	    /**
	     * Creates a function that returns the result of invoking the provided
	     * functions with the `this` binding of the created function, where each
	     * successive invocation is supplied the return value of the previous.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {...Function} [funcs] Functions to invoke.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * function square(n) {
	     *   return n * n;
	     * }
	     *
	     * var addSquare = _.flow(_.add, square);
	     * addSquare(1, 2);
	     * // => 9
	     */
	    var flow = createFlow();

	    /**
	     * This method is like `_.flow` except that it creates a function that
	     * invokes the provided functions from right to left.
	     *
	     * @static
	     * @memberOf _
	     * @alias backflow, compose
	     * @category Function
	     * @param {...Function} [funcs] Functions to invoke.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * function square(n) {
	     *   return n * n;
	     * }
	     *
	     * var addSquare = _.flowRight(square, _.add);
	     * addSquare(1, 2);
	     * // => 9
	     */
	    var flowRight = createFlow(true);

	    /**
	     * Creates a function that memoizes the result of `func`. If `resolver` is
	     * provided it determines the cache key for storing the result based on the
	     * arguments provided to the memoized function. By default, the first argument
	     * provided to the memoized function is coerced to a string and used as the
	     * cache key. The `func` is invoked with the `this` binding of the memoized
	     * function.
	     *
	     * **Note:** The cache is exposed as the `cache` property on the memoized
	     * function. Its creation may be customized by replacing the `_.memoize.Cache`
	     * constructor with one whose instances implement the [`Map`](http://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-map-prototype-object)
	     * method interface of `get`, `has`, and `set`.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to have its output memoized.
	     * @param {Function} [resolver] The function to resolve the cache key.
	     * @returns {Function} Returns the new memoizing function.
	     * @example
	     *
	     * var upperCase = _.memoize(function(string) {
	     *   return string.toUpperCase();
	     * });
	     *
	     * upperCase('fred');
	     * // => 'FRED'
	     *
	     * // modifying the result cache
	     * upperCase.cache.set('fred', 'BARNEY');
	     * upperCase('fred');
	     * // => 'BARNEY'
	     *
	     * // replacing `_.memoize.Cache`
	     * var object = { 'user': 'fred' };
	     * var other = { 'user': 'barney' };
	     * var identity = _.memoize(_.identity);
	     *
	     * identity(object);
	     * // => { 'user': 'fred' }
	     * identity(other);
	     * // => { 'user': 'fred' }
	     *
	     * _.memoize.Cache = WeakMap;
	     * var identity = _.memoize(_.identity);
	     *
	     * identity(object);
	     * // => { 'user': 'fred' }
	     * identity(other);
	     * // => { 'user': 'barney' }
	     */
	    function memoize(func, resolver) {
	      if (typeof func != 'function' || (resolver && typeof resolver != 'function')) {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      var memoized = function() {
	        var args = arguments,
	            key = resolver ? resolver.apply(this, args) : args[0],
	            cache = memoized.cache;

	        if (cache.has(key)) {
	          return cache.get(key);
	        }
	        var result = func.apply(this, args);
	        memoized.cache = cache.set(key, result);
	        return result;
	      };
	      memoized.cache = new memoize.Cache;
	      return memoized;
	    }

	    /**
	     * Creates a function that runs each argument through a corresponding
	     * transform function.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to wrap.
	     * @param {...(Function|Function[])} [transforms] The functions to transform
	     * arguments, specified as individual functions or arrays of functions.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * function doubled(n) {
	     *   return n * 2;
	     * }
	     *
	     * function square(n) {
	     *   return n * n;
	     * }
	     *
	     * var modded = _.modArgs(function(x, y) {
	     *   return [x, y];
	     * }, square, doubled);
	     *
	     * modded(1, 2);
	     * // => [1, 4]
	     *
	     * modded(5, 10);
	     * // => [25, 20]
	     */
	    var modArgs = restParam(function(func, transforms) {
	      transforms = baseFlatten(transforms);
	      if (typeof func != 'function' || !arrayEvery(transforms, baseIsFunction)) {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      var length = transforms.length;
	      return restParam(function(args) {
	        var index = nativeMin(args.length, length);
	        while (index--) {
	          args[index] = transforms[index](args[index]);
	        }
	        return func.apply(this, args);
	      });
	    });

	    /**
	     * Creates a function that negates the result of the predicate `func`. The
	     * `func` predicate is invoked with the `this` binding and arguments of the
	     * created function.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} predicate The predicate to negate.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * function isEven(n) {
	     *   return n % 2 == 0;
	     * }
	     *
	     * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));
	     * // => [1, 3, 5]
	     */
	    function negate(predicate) {
	      if (typeof predicate != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      return function() {
	        return !predicate.apply(this, arguments);
	      };
	    }

	    /**
	     * Creates a function that is restricted to invoking `func` once. Repeat calls
	     * to the function return the value of the first call. The `func` is invoked
	     * with the `this` binding and arguments of the created function.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to restrict.
	     * @returns {Function} Returns the new restricted function.
	     * @example
	     *
	     * var initialize = _.once(createApplication);
	     * initialize();
	     * initialize();
	     * // `initialize` invokes `createApplication` once
	     */
	    function once(func) {
	      return before(2, func);
	    }

	    /**
	     * Creates a function that invokes `func` with `partial` arguments prepended
	     * to those provided to the new function. This method is like `_.bind` except
	     * it does **not** alter the `this` binding.
	     *
	     * The `_.partial.placeholder` value, which defaults to `_` in monolithic
	     * builds, may be used as a placeholder for partially applied arguments.
	     *
	     * **Note:** This method does not set the "length" property of partially
	     * applied functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to partially apply arguments to.
	     * @param {...*} [partials] The arguments to be partially applied.
	     * @returns {Function} Returns the new partially applied function.
	     * @example
	     *
	     * var greet = function(greeting, name) {
	     *   return greeting + ' ' + name;
	     * };
	     *
	     * var sayHelloTo = _.partial(greet, 'hello');
	     * sayHelloTo('fred');
	     * // => 'hello fred'
	     *
	     * // using placeholders
	     * var greetFred = _.partial(greet, _, 'fred');
	     * greetFred('hi');
	     * // => 'hi fred'
	     */
	    var partial = createPartial(PARTIAL_FLAG);

	    /**
	     * This method is like `_.partial` except that partially applied arguments
	     * are appended to those provided to the new function.
	     *
	     * The `_.partialRight.placeholder` value, which defaults to `_` in monolithic
	     * builds, may be used as a placeholder for partially applied arguments.
	     *
	     * **Note:** This method does not set the "length" property of partially
	     * applied functions.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to partially apply arguments to.
	     * @param {...*} [partials] The arguments to be partially applied.
	     * @returns {Function} Returns the new partially applied function.
	     * @example
	     *
	     * var greet = function(greeting, name) {
	     *   return greeting + ' ' + name;
	     * };
	     *
	     * var greetFred = _.partialRight(greet, 'fred');
	     * greetFred('hi');
	     * // => 'hi fred'
	     *
	     * // using placeholders
	     * var sayHelloTo = _.partialRight(greet, 'hello', _);
	     * sayHelloTo('fred');
	     * // => 'hello fred'
	     */
	    var partialRight = createPartial(PARTIAL_RIGHT_FLAG);

	    /**
	     * Creates a function that invokes `func` with arguments arranged according
	     * to the specified indexes where the argument value at the first index is
	     * provided as the first argument, the argument value at the second index is
	     * provided as the second argument, and so on.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to rearrange arguments for.
	     * @param {...(number|number[])} indexes The arranged argument indexes,
	     *  specified as individual indexes or arrays of indexes.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var rearged = _.rearg(function(a, b, c) {
	     *   return [a, b, c];
	     * }, 2, 0, 1);
	     *
	     * rearged('b', 'c', 'a')
	     * // => ['a', 'b', 'c']
	     *
	     * var map = _.rearg(_.map, [1, 0]);
	     * map(function(n) {
	     *   return n * 3;
	     * }, [1, 2, 3]);
	     * // => [3, 6, 9]
	     */
	    var rearg = restParam(function(func, indexes) {
	      return createWrapper(func, REARG_FLAG, undefined, undefined, undefined, baseFlatten(indexes));
	    });

	    /**
	     * Creates a function that invokes `func` with the `this` binding of the
	     * created function and arguments from `start` and beyond provided as an array.
	     *
	     * **Note:** This method is based on the [rest parameter](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Functions/rest_parameters).
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to apply a rest parameter to.
	     * @param {number} [start=func.length-1] The start position of the rest parameter.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var say = _.restParam(function(what, names) {
	     *   return what + ' ' + _.initial(names).join(', ') +
	     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
	     * });
	     *
	     * say('hello', 'fred', 'barney', 'pebbles');
	     * // => 'hello fred, barney, & pebbles'
	     */
	    function restParam(func, start) {
	      if (typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      start = nativeMax(start === undefined ? (func.length - 1) : (+start || 0), 0);
	      return function() {
	        var args = arguments,
	            index = -1,
	            length = nativeMax(args.length - start, 0),
	            rest = Array(length);

	        while (++index < length) {
	          rest[index] = args[start + index];
	        }
	        switch (start) {
	          case 0: return func.call(this, rest);
	          case 1: return func.call(this, args[0], rest);
	          case 2: return func.call(this, args[0], args[1], rest);
	        }
	        var otherArgs = Array(start + 1);
	        index = -1;
	        while (++index < start) {
	          otherArgs[index] = args[index];
	        }
	        otherArgs[start] = rest;
	        return func.apply(this, otherArgs);
	      };
	    }

	    /**
	     * Creates a function that invokes `func` with the `this` binding of the created
	     * function and an array of arguments much like [`Function#apply`](https://es5.github.io/#x15.3.4.3).
	     *
	     * **Note:** This method is based on the [spread operator](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Spread_operator).
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to spread arguments over.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var say = _.spread(function(who, what) {
	     *   return who + ' says ' + what;
	     * });
	     *
	     * say(['fred', 'hello']);
	     * // => 'fred says hello'
	     *
	     * // with a Promise
	     * var numbers = Promise.all([
	     *   Promise.resolve(40),
	     *   Promise.resolve(36)
	     * ]);
	     *
	     * numbers.then(_.spread(function(x, y) {
	     *   return x + y;
	     * }));
	     * // => a Promise of 76
	     */
	    function spread(func) {
	      if (typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      return function(array) {
	        return func.apply(this, array);
	      };
	    }

	    /**
	     * Creates a throttled function that only invokes `func` at most once per
	     * every `wait` milliseconds. The throttled function comes with a `cancel`
	     * method to cancel delayed invocations. Provide an options object to indicate
	     * that `func` should be invoked on the leading and/or trailing edge of the
	     * `wait` timeout. Subsequent calls to the throttled function return the
	     * result of the last `func` call.
	     *
	     * **Note:** If `leading` and `trailing` options are `true`, `func` is invoked
	     * on the trailing edge of the timeout only if the the throttled function is
	     * invoked more than once during the `wait` timeout.
	     *
	     * See [David Corbacho's article](http://drupalmotion.com/article/debounce-and-throttle-visual-explanation)
	     * for details over the differences between `_.throttle` and `_.debounce`.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {Function} func The function to throttle.
	     * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
	     * @param {Object} [options] The options object.
	     * @param {boolean} [options.leading=true] Specify invoking on the leading
	     *  edge of the timeout.
	     * @param {boolean} [options.trailing=true] Specify invoking on the trailing
	     *  edge of the timeout.
	     * @returns {Function} Returns the new throttled function.
	     * @example
	     *
	     * // avoid excessively updating the position while scrolling
	     * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
	     *
	     * // invoke `renewToken` when the click event is fired, but not more than once every 5 minutes
	     * jQuery('.interactive').on('click', _.throttle(renewToken, 300000, {
	     *   'trailing': false
	     * }));
	     *
	     * // cancel a trailing throttled call
	     * jQuery(window).on('popstate', throttled.cancel);
	     */
	    function throttle(func, wait, options) {
	      var leading = true,
	          trailing = true;

	      if (typeof func != 'function') {
	        throw new TypeError(FUNC_ERROR_TEXT);
	      }
	      if (options === false) {
	        leading = false;
	      } else if (isObject(options)) {
	        leading = 'leading' in options ? !!options.leading : leading;
	        trailing = 'trailing' in options ? !!options.trailing : trailing;
	      }
	      return debounce(func, wait, { 'leading': leading, 'maxWait': +wait, 'trailing': trailing });
	    }

	    /**
	     * Creates a function that provides `value` to the wrapper function as its
	     * first argument. Any additional arguments provided to the function are
	     * appended to those provided to the wrapper function. The wrapper is invoked
	     * with the `this` binding of the created function.
	     *
	     * @static
	     * @memberOf _
	     * @category Function
	     * @param {*} value The value to wrap.
	     * @param {Function} wrapper The wrapper function.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var p = _.wrap(_.escape, function(func, text) {
	     *   return '<p>' + func(text) + '</p>';
	     * });
	     *
	     * p('fred, barney, & pebbles');
	     * // => '<p>fred, barney, &amp; pebbles</p>'
	     */
	    function wrap(value, wrapper) {
	      wrapper = wrapper == null ? identity : wrapper;
	      return createWrapper(wrapper, PARTIAL_FLAG, undefined, [value], []);
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Creates a clone of `value`. If `isDeep` is `true` nested objects are cloned,
	     * otherwise they are assigned by reference. If `customizer` is provided it is
	     * invoked to produce the cloned values. If `customizer` returns `undefined`
	     * cloning is handled by the method instead. The `customizer` is bound to
	     * `thisArg` and invoked with two argument; (value [, index|key, object]).
	     *
	     * **Note:** This method is loosely based on the
	     * [structured clone algorithm](http://www.w3.org/TR/html5/infrastructure.html#internal-structured-cloning-algorithm).
	     * The enumerable properties of `arguments` objects and objects created by
	     * constructors other than `Object` are cloned to plain `Object` objects. An
	     * empty object is returned for uncloneable values such as functions, DOM nodes,
	     * Maps, Sets, and WeakMaps.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to clone.
	     * @param {boolean} [isDeep] Specify a deep clone.
	     * @param {Function} [customizer] The function to customize cloning values.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {*} Returns the cloned value.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney' },
	     *   { 'user': 'fred' }
	     * ];
	     *
	     * var shallow = _.clone(users);
	     * shallow[0] === users[0];
	     * // => true
	     *
	     * var deep = _.clone(users, true);
	     * deep[0] === users[0];
	     * // => false
	     *
	     * // using a customizer callback
	     * var el = _.clone(document.body, function(value) {
	     *   if (_.isElement(value)) {
	     *     return value.cloneNode(false);
	     *   }
	     * });
	     *
	     * el === document.body
	     * // => false
	     * el.nodeName
	     * // => BODY
	     * el.childNodes.length;
	     * // => 0
	     */
	    function clone(value, isDeep, customizer, thisArg) {
	      if (isDeep && typeof isDeep != 'boolean' && isIterateeCall(value, isDeep, customizer)) {
	        isDeep = false;
	      }
	      else if (typeof isDeep == 'function') {
	        thisArg = customizer;
	        customizer = isDeep;
	        isDeep = false;
	      }
	      return typeof customizer == 'function'
	        ? baseClone(value, isDeep, bindCallback(customizer, thisArg, 1))
	        : baseClone(value, isDeep);
	    }

	    /**
	     * Creates a deep clone of `value`. If `customizer` is provided it is invoked
	     * to produce the cloned values. If `customizer` returns `undefined` cloning
	     * is handled by the method instead. The `customizer` is bound to `thisArg`
	     * and invoked with two argument; (value [, index|key, object]).
	     *
	     * **Note:** This method is loosely based on the
	     * [structured clone algorithm](http://www.w3.org/TR/html5/infrastructure.html#internal-structured-cloning-algorithm).
	     * The enumerable properties of `arguments` objects and objects created by
	     * constructors other than `Object` are cloned to plain `Object` objects. An
	     * empty object is returned for uncloneable values such as functions, DOM nodes,
	     * Maps, Sets, and WeakMaps.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to deep clone.
	     * @param {Function} [customizer] The function to customize cloning values.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {*} Returns the deep cloned value.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney' },
	     *   { 'user': 'fred' }
	     * ];
	     *
	     * var deep = _.cloneDeep(users);
	     * deep[0] === users[0];
	     * // => false
	     *
	     * // using a customizer callback
	     * var el = _.cloneDeep(document.body, function(value) {
	     *   if (_.isElement(value)) {
	     *     return value.cloneNode(true);
	     *   }
	     * });
	     *
	     * el === document.body
	     * // => false
	     * el.nodeName
	     * // => BODY
	     * el.childNodes.length;
	     * // => 20
	     */
	    function cloneDeep(value, customizer, thisArg) {
	      return typeof customizer == 'function'
	        ? baseClone(value, true, bindCallback(customizer, thisArg, 1))
	        : baseClone(value, true);
	    }

	    /**
	     * Checks if `value` is greater than `other`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @returns {boolean} Returns `true` if `value` is greater than `other`, else `false`.
	     * @example
	     *
	     * _.gt(3, 1);
	     * // => true
	     *
	     * _.gt(3, 3);
	     * // => false
	     *
	     * _.gt(1, 3);
	     * // => false
	     */
	    function gt(value, other) {
	      return value > other;
	    }

	    /**
	     * Checks if `value` is greater than or equal to `other`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @returns {boolean} Returns `true` if `value` is greater than or equal to `other`, else `false`.
	     * @example
	     *
	     * _.gte(3, 1);
	     * // => true
	     *
	     * _.gte(3, 3);
	     * // => true
	     *
	     * _.gte(1, 3);
	     * // => false
	     */
	    function gte(value, other) {
	      return value >= other;
	    }

	    /**
	     * Checks if `value` is classified as an `arguments` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isArguments(function() { return arguments; }());
	     * // => true
	     *
	     * _.isArguments([1, 2, 3]);
	     * // => false
	     */
	    function isArguments(value) {
	      return isObjectLike(value) && isArrayLike(value) &&
	        hasOwnProperty.call(value, 'callee') && !propertyIsEnumerable.call(value, 'callee');
	    }

	    /**
	     * Checks if `value` is classified as an `Array` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isArray([1, 2, 3]);
	     * // => true
	     *
	     * _.isArray(function() { return arguments; }());
	     * // => false
	     */
	    var isArray = nativeIsArray || function(value) {
	      return isObjectLike(value) && isLength(value.length) && objToString.call(value) == arrayTag;
	    };

	    /**
	     * Checks if `value` is classified as a boolean primitive or object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isBoolean(false);
	     * // => true
	     *
	     * _.isBoolean(null);
	     * // => false
	     */
	    function isBoolean(value) {
	      return value === true || value === false || (isObjectLike(value) && objToString.call(value) == boolTag);
	    }

	    /**
	     * Checks if `value` is classified as a `Date` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isDate(new Date);
	     * // => true
	     *
	     * _.isDate('Mon April 23 2012');
	     * // => false
	     */
	    function isDate(value) {
	      return isObjectLike(value) && objToString.call(value) == dateTag;
	    }

	    /**
	     * Checks if `value` is a DOM element.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.
	     * @example
	     *
	     * _.isElement(document.body);
	     * // => true
	     *
	     * _.isElement('<body>');
	     * // => false
	     */
	    function isElement(value) {
	      return !!value && value.nodeType === 1 && isObjectLike(value) && !isPlainObject(value);
	    }

	    /**
	     * Checks if `value` is empty. A value is considered empty unless it is an
	     * `arguments` object, array, string, or jQuery-like collection with a length
	     * greater than `0` or an object with own enumerable properties.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {Array|Object|string} value The value to inspect.
	     * @returns {boolean} Returns `true` if `value` is empty, else `false`.
	     * @example
	     *
	     * _.isEmpty(null);
	     * // => true
	     *
	     * _.isEmpty(true);
	     * // => true
	     *
	     * _.isEmpty(1);
	     * // => true
	     *
	     * _.isEmpty([1, 2, 3]);
	     * // => false
	     *
	     * _.isEmpty({ 'a': 1 });
	     * // => false
	     */
	    function isEmpty(value) {
	      if (value == null) {
	        return true;
	      }
	      if (isArrayLike(value) && (isArray(value) || isString(value) || isArguments(value) ||
	          (isObjectLike(value) && isFunction(value.splice)))) {
	        return !value.length;
	      }
	      return !keys(value).length;
	    }

	    /**
	     * Performs a deep comparison between two values to determine if they are
	     * equivalent. If `customizer` is provided it is invoked to compare values.
	     * If `customizer` returns `undefined` comparisons are handled by the method
	     * instead. The `customizer` is bound to `thisArg` and invoked with three
	     * arguments: (value, other [, index|key]).
	     *
	     * **Note:** This method supports comparing arrays, booleans, `Date` objects,
	     * numbers, `Object` objects, regexes, and strings. Objects are compared by
	     * their own, not inherited, enumerable properties. Functions and DOM nodes
	     * are **not** supported. Provide a customizer function to extend support
	     * for comparing other values.
	     *
	     * @static
	     * @memberOf _
	     * @alias eq
	     * @category Lang
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @param {Function} [customizer] The function to customize value comparisons.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
	     * @example
	     *
	     * var object = { 'user': 'fred' };
	     * var other = { 'user': 'fred' };
	     *
	     * object == other;
	     * // => false
	     *
	     * _.isEqual(object, other);
	     * // => true
	     *
	     * // using a customizer callback
	     * var array = ['hello', 'goodbye'];
	     * var other = ['hi', 'goodbye'];
	     *
	     * _.isEqual(array, other, function(value, other) {
	     *   if (_.every([value, other], RegExp.prototype.test, /^h(?:i|ello)$/)) {
	     *     return true;
	     *   }
	     * });
	     * // => true
	     */
	    function isEqual(value, other, customizer, thisArg) {
	      customizer = typeof customizer == 'function' ? bindCallback(customizer, thisArg, 3) : undefined;
	      var result = customizer ? customizer(value, other) : undefined;
	      return  result === undefined ? baseIsEqual(value, other, customizer) : !!result;
	    }

	    /**
	     * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
	     * `SyntaxError`, `TypeError`, or `URIError` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
	     * @example
	     *
	     * _.isError(new Error);
	     * // => true
	     *
	     * _.isError(Error);
	     * // => false
	     */
	    function isError(value) {
	      return isObjectLike(value) && typeof value.message == 'string' && objToString.call(value) == errorTag;
	    }

	    /**
	     * Checks if `value` is a finite primitive number.
	     *
	     * **Note:** This method is based on [`Number.isFinite`](http://ecma-international.org/ecma-262/6.0/#sec-number.isfinite).
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is a finite number, else `false`.
	     * @example
	     *
	     * _.isFinite(10);
	     * // => true
	     *
	     * _.isFinite('10');
	     * // => false
	     *
	     * _.isFinite(true);
	     * // => false
	     *
	     * _.isFinite(Object(10));
	     * // => false
	     *
	     * _.isFinite(Infinity);
	     * // => false
	     */
	    function isFinite(value) {
	      return typeof value == 'number' && nativeIsFinite(value);
	    }

	    /**
	     * Checks if `value` is classified as a `Function` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isFunction(_);
	     * // => true
	     *
	     * _.isFunction(/abc/);
	     * // => false
	     */
	    function isFunction(value) {
	      // The use of `Object#toString` avoids issues with the `typeof` operator
	      // in older versions of Chrome and Safari which return 'function' for regexes
	      // and Safari 8 equivalents which return 'object' for typed array constructors.
	      return isObject(value) && objToString.call(value) == funcTag;
	    }

	    /**
	     * Checks if `value` is the [language type](https://es5.github.io/#x8) of `Object`.
	     * (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is an object, else `false`.
	     * @example
	     *
	     * _.isObject({});
	     * // => true
	     *
	     * _.isObject([1, 2, 3]);
	     * // => true
	     *
	     * _.isObject(1);
	     * // => false
	     */
	    function isObject(value) {
	      // Avoid a V8 JIT bug in Chrome 19-20.
	      // See https://code.google.com/p/v8/issues/detail?id=2291 for more details.
	      var type = typeof value;
	      return !!value && (type == 'object' || type == 'function');
	    }

	    /**
	     * Performs a deep comparison between `object` and `source` to determine if
	     * `object` contains equivalent property values. If `customizer` is provided
	     * it is invoked to compare values. If `customizer` returns `undefined`
	     * comparisons are handled by the method instead. The `customizer` is bound
	     * to `thisArg` and invoked with three arguments: (value, other, index|key).
	     *
	     * **Note:** This method supports comparing properties of arrays, booleans,
	     * `Date` objects, numbers, `Object` objects, regexes, and strings. Functions
	     * and DOM nodes are **not** supported. Provide a customizer function to extend
	     * support for comparing other values.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {Object} object The object to inspect.
	     * @param {Object} source The object of property values to match.
	     * @param {Function} [customizer] The function to customize value comparisons.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
	     * @example
	     *
	     * var object = { 'user': 'fred', 'age': 40 };
	     *
	     * _.isMatch(object, { 'age': 40 });
	     * // => true
	     *
	     * _.isMatch(object, { 'age': 36 });
	     * // => false
	     *
	     * // using a customizer callback
	     * var object = { 'greeting': 'hello' };
	     * var source = { 'greeting': 'hi' };
	     *
	     * _.isMatch(object, source, function(value, other) {
	     *   return _.every([value, other], RegExp.prototype.test, /^h(?:i|ello)$/) || undefined;
	     * });
	     * // => true
	     */
	    function isMatch(object, source, customizer, thisArg) {
	      customizer = typeof customizer == 'function' ? bindCallback(customizer, thisArg, 3) : undefined;
	      return baseIsMatch(object, getMatchData(source), customizer);
	    }

	    /**
	     * Checks if `value` is `NaN`.
	     *
	     * **Note:** This method is not the same as [`isNaN`](https://es5.github.io/#x15.1.2.4)
	     * which returns `true` for `undefined` and other non-numeric values.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
	     * @example
	     *
	     * _.isNaN(NaN);
	     * // => true
	     *
	     * _.isNaN(new Number(NaN));
	     * // => true
	     *
	     * isNaN(undefined);
	     * // => true
	     *
	     * _.isNaN(undefined);
	     * // => false
	     */
	    function isNaN(value) {
	      // An `NaN` primitive is the only value that is not equal to itself.
	      // Perform the `toStringTag` check first to avoid errors with some host objects in IE.
	      return isNumber(value) && value != +value;
	    }

	    /**
	     * Checks if `value` is a native function.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is a native function, else `false`.
	     * @example
	     *
	     * _.isNative(Array.prototype.push);
	     * // => true
	     *
	     * _.isNative(_);
	     * // => false
	     */
	    function isNative(value) {
	      if (value == null) {
	        return false;
	      }
	      if (isFunction(value)) {
	        return reIsNative.test(fnToString.call(value));
	      }
	      return isObjectLike(value) && reIsHostCtor.test(value);
	    }

	    /**
	     * Checks if `value` is `null`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is `null`, else `false`.
	     * @example
	     *
	     * _.isNull(null);
	     * // => true
	     *
	     * _.isNull(void 0);
	     * // => false
	     */
	    function isNull(value) {
	      return value === null;
	    }

	    /**
	     * Checks if `value` is classified as a `Number` primitive or object.
	     *
	     * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are classified
	     * as numbers, use the `_.isFinite` method.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isNumber(8.4);
	     * // => true
	     *
	     * _.isNumber(NaN);
	     * // => true
	     *
	     * _.isNumber('8.4');
	     * // => false
	     */
	    function isNumber(value) {
	      return typeof value == 'number' || (isObjectLike(value) && objToString.call(value) == numberTag);
	    }

	    /**
	     * Checks if `value` is a plain object, that is, an object created by the
	     * `Object` constructor or one with a `[[Prototype]]` of `null`.
	     *
	     * **Note:** This method assumes objects created by the `Object` constructor
	     * have no inherited enumerable properties.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     * }
	     *
	     * _.isPlainObject(new Foo);
	     * // => false
	     *
	     * _.isPlainObject([1, 2, 3]);
	     * // => false
	     *
	     * _.isPlainObject({ 'x': 0, 'y': 0 });
	     * // => true
	     *
	     * _.isPlainObject(Object.create(null));
	     * // => true
	     */
	    function isPlainObject(value) {
	      var Ctor;

	      // Exit early for non `Object` objects.
	      if (!(isObjectLike(value) && objToString.call(value) == objectTag && !isArguments(value)) ||
	          (!hasOwnProperty.call(value, 'constructor') && (Ctor = value.constructor, typeof Ctor == 'function' && !(Ctor instanceof Ctor)))) {
	        return false;
	      }
	      // IE < 9 iterates inherited properties before own properties. If the first
	      // iterated property is an object's own property then there are no inherited
	      // enumerable properties.
	      var result;
	      // In most environments an object's own properties are iterated before
	      // its inherited properties. If the last iterated property is an object's
	      // own property then there are no inherited enumerable properties.
	      baseForIn(value, function(subValue, key) {
	        result = key;
	      });
	      return result === undefined || hasOwnProperty.call(value, result);
	    }

	    /**
	     * Checks if `value` is classified as a `RegExp` object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isRegExp(/abc/);
	     * // => true
	     *
	     * _.isRegExp('/abc/');
	     * // => false
	     */
	    function isRegExp(value) {
	      return isObject(value) && objToString.call(value) == regexpTag;
	    }

	    /**
	     * Checks if `value` is classified as a `String` primitive or object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isString('abc');
	     * // => true
	     *
	     * _.isString(1);
	     * // => false
	     */
	    function isString(value) {
	      return typeof value == 'string' || (isObjectLike(value) && objToString.call(value) == stringTag);
	    }

	    /**
	     * Checks if `value` is classified as a typed array.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is correctly classified, else `false`.
	     * @example
	     *
	     * _.isTypedArray(new Uint8Array);
	     * // => true
	     *
	     * _.isTypedArray([]);
	     * // => false
	     */
	    function isTypedArray(value) {
	      return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[objToString.call(value)];
	    }

	    /**
	     * Checks if `value` is `undefined`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to check.
	     * @returns {boolean} Returns `true` if `value` is `undefined`, else `false`.
	     * @example
	     *
	     * _.isUndefined(void 0);
	     * // => true
	     *
	     * _.isUndefined(null);
	     * // => false
	     */
	    function isUndefined(value) {
	      return value === undefined;
	    }

	    /**
	     * Checks if `value` is less than `other`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @returns {boolean} Returns `true` if `value` is less than `other`, else `false`.
	     * @example
	     *
	     * _.lt(1, 3);
	     * // => true
	     *
	     * _.lt(3, 3);
	     * // => false
	     *
	     * _.lt(3, 1);
	     * // => false
	     */
	    function lt(value, other) {
	      return value < other;
	    }

	    /**
	     * Checks if `value` is less than or equal to `other`.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to compare.
	     * @param {*} other The other value to compare.
	     * @returns {boolean} Returns `true` if `value` is less than or equal to `other`, else `false`.
	     * @example
	     *
	     * _.lte(1, 3);
	     * // => true
	     *
	     * _.lte(3, 3);
	     * // => true
	     *
	     * _.lte(3, 1);
	     * // => false
	     */
	    function lte(value, other) {
	      return value <= other;
	    }

	    /**
	     * Converts `value` to an array.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to convert.
	     * @returns {Array} Returns the converted array.
	     * @example
	     *
	     * (function() {
	     *   return _.toArray(arguments).slice(1);
	     * }(1, 2, 3));
	     * // => [2, 3]
	     */
	    function toArray(value) {
	      var length = value ? getLength(value) : 0;
	      if (!isLength(length)) {
	        return values(value);
	      }
	      if (!length) {
	        return [];
	      }
	      return arrayCopy(value);
	    }

	    /**
	     * Converts `value` to a plain object flattening inherited enumerable
	     * properties of `value` to own properties of the plain object.
	     *
	     * @static
	     * @memberOf _
	     * @category Lang
	     * @param {*} value The value to convert.
	     * @returns {Object} Returns the converted plain object.
	     * @example
	     *
	     * function Foo() {
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.assign({ 'a': 1 }, new Foo);
	     * // => { 'a': 1, 'b': 2 }
	     *
	     * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
	     * // => { 'a': 1, 'b': 2, 'c': 3 }
	     */
	    function toPlainObject(value) {
	      return baseCopy(value, keysIn(value));
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Recursively merges own enumerable properties of the source object(s), that
	     * don't resolve to `undefined` into the destination object. Subsequent sources
	     * overwrite property assignments of previous sources. If `customizer` is
	     * provided it is invoked to produce the merged values of the destination and
	     * source properties. If `customizer` returns `undefined` merging is handled
	     * by the method instead. The `customizer` is bound to `thisArg` and invoked
	     * with five arguments: (objectValue, sourceValue, key, object, source).
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The destination object.
	     * @param {...Object} [sources] The source objects.
	     * @param {Function} [customizer] The function to customize assigned values.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * var users = {
	     *   'data': [{ 'user': 'barney' }, { 'user': 'fred' }]
	     * };
	     *
	     * var ages = {
	     *   'data': [{ 'age': 36 }, { 'age': 40 }]
	     * };
	     *
	     * _.merge(users, ages);
	     * // => { 'data': [{ 'user': 'barney', 'age': 36 }, { 'user': 'fred', 'age': 40 }] }
	     *
	     * // using a customizer callback
	     * var object = {
	     *   'fruits': ['apple'],
	     *   'vegetables': ['beet']
	     * };
	     *
	     * var other = {
	     *   'fruits': ['banana'],
	     *   'vegetables': ['carrot']
	     * };
	     *
	     * _.merge(object, other, function(a, b) {
	     *   if (_.isArray(a)) {
	     *     return a.concat(b);
	     *   }
	     * });
	     * // => { 'fruits': ['apple', 'banana'], 'vegetables': ['beet', 'carrot'] }
	     */
	    var merge = createAssigner(baseMerge);

	    /**
	     * Assigns own enumerable properties of source object(s) to the destination
	     * object. Subsequent sources overwrite property assignments of previous sources.
	     * If `customizer` is provided it is invoked to produce the assigned values.
	     * The `customizer` is bound to `thisArg` and invoked with five arguments:
	     * (objectValue, sourceValue, key, object, source).
	     *
	     * **Note:** This method mutates `object` and is based on
	     * [`Object.assign`](http://ecma-international.org/ecma-262/6.0/#sec-object.assign).
	     *
	     * @static
	     * @memberOf _
	     * @alias extend
	     * @category Object
	     * @param {Object} object The destination object.
	     * @param {...Object} [sources] The source objects.
	     * @param {Function} [customizer] The function to customize assigned values.
	     * @param {*} [thisArg] The `this` binding of `customizer`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * _.assign({ 'user': 'barney' }, { 'age': 40 }, { 'user': 'fred' });
	     * // => { 'user': 'fred', 'age': 40 }
	     *
	     * // using a customizer callback
	     * var defaults = _.partialRight(_.assign, function(value, other) {
	     *   return _.isUndefined(value) ? other : value;
	     * });
	     *
	     * defaults({ 'user': 'barney' }, { 'age': 36 }, { 'user': 'fred' });
	     * // => { 'user': 'barney', 'age': 36 }
	     */
	    var assign = createAssigner(function(object, source, customizer) {
	      return customizer
	        ? assignWith(object, source, customizer)
	        : baseAssign(object, source);
	    });

	    /**
	     * Creates an object that inherits from the given `prototype` object. If a
	     * `properties` object is provided its own enumerable properties are assigned
	     * to the created object.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} prototype The object to inherit from.
	     * @param {Object} [properties] The properties to assign to the object.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Object} Returns the new object.
	     * @example
	     *
	     * function Shape() {
	     *   this.x = 0;
	     *   this.y = 0;
	     * }
	     *
	     * function Circle() {
	     *   Shape.call(this);
	     * }
	     *
	     * Circle.prototype = _.create(Shape.prototype, {
	     *   'constructor': Circle
	     * });
	     *
	     * var circle = new Circle;
	     * circle instanceof Circle;
	     * // => true
	     *
	     * circle instanceof Shape;
	     * // => true
	     */
	    function create(prototype, properties, guard) {
	      var result = baseCreate(prototype);
	      if (guard && isIterateeCall(prototype, properties, guard)) {
	        properties = undefined;
	      }
	      return properties ? baseAssign(result, properties) : result;
	    }

	    /**
	     * Assigns own enumerable properties of source object(s) to the destination
	     * object for all destination properties that resolve to `undefined`. Once a
	     * property is set, additional values of the same property are ignored.
	     *
	     * **Note:** This method mutates `object`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The destination object.
	     * @param {...Object} [sources] The source objects.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * _.defaults({ 'user': 'barney' }, { 'age': 36 }, { 'user': 'fred' });
	     * // => { 'user': 'barney', 'age': 36 }
	     */
	    var defaults = createDefaults(assign, assignDefaults);

	    /**
	     * This method is like `_.defaults` except that it recursively assigns
	     * default properties.
	     *
	     * **Note:** This method mutates `object`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The destination object.
	     * @param {...Object} [sources] The source objects.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * _.defaultsDeep({ 'user': { 'name': 'barney' } }, { 'user': { 'name': 'fred', 'age': 36 } });
	     * // => { 'user': { 'name': 'barney', 'age': 36 } }
	     *
	     */
	    var defaultsDeep = createDefaults(merge, mergeDefaults);

	    /**
	     * This method is like `_.find` except that it returns the key of the first
	     * element `predicate` returns truthy for instead of the element itself.
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {string|undefined} Returns the key of the matched element, else `undefined`.
	     * @example
	     *
	     * var users = {
	     *   'barney':  { 'age': 36, 'active': true },
	     *   'fred':    { 'age': 40, 'active': false },
	     *   'pebbles': { 'age': 1,  'active': true }
	     * };
	     *
	     * _.findKey(users, function(chr) {
	     *   return chr.age < 40;
	     * });
	     * // => 'barney' (iteration order is not guaranteed)
	     *
	     * // using the `_.matches` callback shorthand
	     * _.findKey(users, { 'age': 1, 'active': true });
	     * // => 'pebbles'
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.findKey(users, 'active', false);
	     * // => 'fred'
	     *
	     * // using the `_.property` callback shorthand
	     * _.findKey(users, 'active');
	     * // => 'barney'
	     */
	    var findKey = createFindKey(baseForOwn);

	    /**
	     * This method is like `_.findKey` except that it iterates over elements of
	     * a collection in the opposite order.
	     *
	     * If a property name is provided for `predicate` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `predicate` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to search.
	     * @param {Function|Object|string} [predicate=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {string|undefined} Returns the key of the matched element, else `undefined`.
	     * @example
	     *
	     * var users = {
	     *   'barney':  { 'age': 36, 'active': true },
	     *   'fred':    { 'age': 40, 'active': false },
	     *   'pebbles': { 'age': 1,  'active': true }
	     * };
	     *
	     * _.findLastKey(users, function(chr) {
	     *   return chr.age < 40;
	     * });
	     * // => returns `pebbles` assuming `_.findKey` returns `barney`
	     *
	     * // using the `_.matches` callback shorthand
	     * _.findLastKey(users, { 'age': 36, 'active': true });
	     * // => 'barney'
	     *
	     * // using the `_.matchesProperty` callback shorthand
	     * _.findLastKey(users, 'active', false);
	     * // => 'fred'
	     *
	     * // using the `_.property` callback shorthand
	     * _.findLastKey(users, 'active');
	     * // => 'pebbles'
	     */
	    var findLastKey = createFindKey(baseForOwnRight);

	    /**
	     * Iterates over own and inherited enumerable properties of an object invoking
	     * `iteratee` for each property. The `iteratee` is bound to `thisArg` and invoked
	     * with three arguments: (value, key, object). Iteratee functions may exit
	     * iteration early by explicitly returning `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.forIn(new Foo, function(value, key) {
	     *   console.log(key);
	     * });
	     * // => logs 'a', 'b', and 'c' (iteration order is not guaranteed)
	     */
	    var forIn = createForIn(baseFor);

	    /**
	     * This method is like `_.forIn` except that it iterates over properties of
	     * `object` in the opposite order.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.forInRight(new Foo, function(value, key) {
	     *   console.log(key);
	     * });
	     * // => logs 'c', 'b', and 'a' assuming `_.forIn ` logs 'a', 'b', and 'c'
	     */
	    var forInRight = createForIn(baseForRight);

	    /**
	     * Iterates over own enumerable properties of an object invoking `iteratee`
	     * for each property. The `iteratee` is bound to `thisArg` and invoked with
	     * three arguments: (value, key, object). Iteratee functions may exit iteration
	     * early by explicitly returning `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.forOwn(new Foo, function(value, key) {
	     *   console.log(key);
	     * });
	     * // => logs 'a' and 'b' (iteration order is not guaranteed)
	     */
	    var forOwn = createForOwn(baseForOwn);

	    /**
	     * This method is like `_.forOwn` except that it iterates over properties of
	     * `object` in the opposite order.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.forOwnRight(new Foo, function(value, key) {
	     *   console.log(key);
	     * });
	     * // => logs 'b' and 'a' assuming `_.forOwn` logs 'a' and 'b'
	     */
	    var forOwnRight = createForOwn(baseForOwnRight);

	    /**
	     * Creates an array of function property names from all enumerable properties,
	     * own and inherited, of `object`.
	     *
	     * @static
	     * @memberOf _
	     * @alias methods
	     * @category Object
	     * @param {Object} object The object to inspect.
	     * @returns {Array} Returns the new array of property names.
	     * @example
	     *
	     * _.functions(_);
	     * // => ['after', 'ary', 'assign', ...]
	     */
	    function functions(object) {
	      return baseFunctions(object, keysIn(object));
	    }

	    /**
	     * Gets the property value at `path` of `object`. If the resolved value is
	     * `undefined` the `defaultValue` is used in its place.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @param {Array|string} path The path of the property to get.
	     * @param {*} [defaultValue] The value returned if the resolved value is `undefined`.
	     * @returns {*} Returns the resolved value.
	     * @example
	     *
	     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
	     *
	     * _.get(object, 'a[0].b.c');
	     * // => 3
	     *
	     * _.get(object, ['a', '0', 'b', 'c']);
	     * // => 3
	     *
	     * _.get(object, 'a.b.c', 'default');
	     * // => 'default'
	     */
	    function get(object, path, defaultValue) {
	      var result = object == null ? undefined : baseGet(object, toPath(path), path + '');
	      return result === undefined ? defaultValue : result;
	    }

	    /**
	     * Checks if `path` is a direct property.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @param {Array|string} path The path to check.
	     * @returns {boolean} Returns `true` if `path` is a direct property, else `false`.
	     * @example
	     *
	     * var object = { 'a': { 'b': { 'c': 3 } } };
	     *
	     * _.has(object, 'a');
	     * // => true
	     *
	     * _.has(object, 'a.b.c');
	     * // => true
	     *
	     * _.has(object, ['a', 'b', 'c']);
	     * // => true
	     */
	    function has(object, path) {
	      if (object == null) {
	        return false;
	      }
	      var result = hasOwnProperty.call(object, path);
	      if (!result && !isKey(path)) {
	        path = toPath(path);
	        object = path.length == 1 ? object : baseGet(object, baseSlice(path, 0, -1));
	        if (object == null) {
	          return false;
	        }
	        path = last(path);
	        result = hasOwnProperty.call(object, path);
	      }
	      return result || (isLength(object.length) && isIndex(path, object.length) &&
	        (isArray(object) || isArguments(object)));
	    }

	    /**
	     * Creates an object composed of the inverted keys and values of `object`.
	     * If `object` contains duplicate values, subsequent values overwrite property
	     * assignments of previous values unless `multiValue` is `true`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to invert.
	     * @param {boolean} [multiValue] Allow multiple values per key.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Object} Returns the new inverted object.
	     * @example
	     *
	     * var object = { 'a': 1, 'b': 2, 'c': 1 };
	     *
	     * _.invert(object);
	     * // => { '1': 'c', '2': 'b' }
	     *
	     * // with `multiValue`
	     * _.invert(object, true);
	     * // => { '1': ['a', 'c'], '2': ['b'] }
	     */
	    function invert(object, multiValue, guard) {
	      if (guard && isIterateeCall(object, multiValue, guard)) {
	        multiValue = undefined;
	      }
	      var index = -1,
	          props = keys(object),
	          length = props.length,
	          result = {};

	      while (++index < length) {
	        var key = props[index],
	            value = object[key];

	        if (multiValue) {
	          if (hasOwnProperty.call(result, value)) {
	            result[value].push(key);
	          } else {
	            result[value] = [key];
	          }
	        }
	        else {
	          result[value] = key;
	        }
	      }
	      return result;
	    }

	    /**
	     * Creates an array of the own enumerable property names of `object`.
	     *
	     * **Note:** Non-object values are coerced to objects. See the
	     * [ES spec](http://ecma-international.org/ecma-262/6.0/#sec-object.keys)
	     * for more details.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the array of property names.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.keys(new Foo);
	     * // => ['a', 'b'] (iteration order is not guaranteed)
	     *
	     * _.keys('hi');
	     * // => ['0', '1']
	     */
	    var keys = !nativeKeys ? shimKeys : function(object) {
	      var Ctor = object == null ? undefined : object.constructor;
	      if ((typeof Ctor == 'function' && Ctor.prototype === object) ||
	          (typeof object != 'function' && isArrayLike(object))) {
	        return shimKeys(object);
	      }
	      return isObject(object) ? nativeKeys(object) : [];
	    };

	    /**
	     * Creates an array of the own and inherited enumerable property names of `object`.
	     *
	     * **Note:** Non-object values are coerced to objects.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the array of property names.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.keysIn(new Foo);
	     * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
	     */
	    function keysIn(object) {
	      if (object == null) {
	        return [];
	      }
	      if (!isObject(object)) {
	        object = Object(object);
	      }
	      var length = object.length;
	      length = (length && isLength(length) &&
	        (isArray(object) || isArguments(object)) && length) || 0;

	      var Ctor = object.constructor,
	          index = -1,
	          isProto = typeof Ctor == 'function' && Ctor.prototype === object,
	          result = Array(length),
	          skipIndexes = length > 0;

	      while (++index < length) {
	        result[index] = (index + '');
	      }
	      for (var key in object) {
	        if (!(skipIndexes && isIndex(key, length)) &&
	            !(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
	          result.push(key);
	        }
	      }
	      return result;
	    }

	    /**
	     * The opposite of `_.mapValues`; this method creates an object with the
	     * same values as `object` and keys generated by running each own enumerable
	     * property of `object` through `iteratee`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns the new mapped object.
	     * @example
	     *
	     * _.mapKeys({ 'a': 1, 'b': 2 }, function(value, key) {
	     *   return key + value;
	     * });
	     * // => { 'a1': 1, 'b2': 2 }
	     */
	    var mapKeys = createObjectMapper(true);

	    /**
	     * Creates an object with the same keys as `object` and values generated by
	     * running each own enumerable property of `object` through `iteratee`. The
	     * iteratee function is bound to `thisArg` and invoked with three arguments:
	     * (value, key, object).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to iterate over.
	     * @param {Function|Object|string} [iteratee=_.identity] The function invoked
	     *  per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Object} Returns the new mapped object.
	     * @example
	     *
	     * _.mapValues({ 'a': 1, 'b': 2 }, function(n) {
	     *   return n * 3;
	     * });
	     * // => { 'a': 3, 'b': 6 }
	     *
	     * var users = {
	     *   'fred':    { 'user': 'fred',    'age': 40 },
	     *   'pebbles': { 'user': 'pebbles', 'age': 1 }
	     * };
	     *
	     * // using the `_.property` callback shorthand
	     * _.mapValues(users, 'age');
	     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
	     */
	    var mapValues = createObjectMapper();

	    /**
	     * The opposite of `_.pick`; this method creates an object composed of the
	     * own and inherited enumerable properties of `object` that are not omitted.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The source object.
	     * @param {Function|...(string|string[])} [predicate] The function invoked per
	     *  iteration or property names to omit, specified as individual property
	     *  names or arrays of property names.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Object} Returns the new object.
	     * @example
	     *
	     * var object = { 'user': 'fred', 'age': 40 };
	     *
	     * _.omit(object, 'age');
	     * // => { 'user': 'fred' }
	     *
	     * _.omit(object, _.isNumber);
	     * // => { 'user': 'fred' }
	     */
	    var omit = restParam(function(object, props) {
	      if (object == null) {
	        return {};
	      }
	      if (typeof props[0] != 'function') {
	        var props = arrayMap(baseFlatten(props), String);
	        return pickByArray(object, baseDifference(keysIn(object), props));
	      }
	      var predicate = bindCallback(props[0], props[1], 3);
	      return pickByCallback(object, function(value, key, object) {
	        return !predicate(value, key, object);
	      });
	    });

	    /**
	     * Creates a two dimensional array of the key-value pairs for `object`,
	     * e.g. `[[key1, value1], [key2, value2]]`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the new array of key-value pairs.
	     * @example
	     *
	     * _.pairs({ 'barney': 36, 'fred': 40 });
	     * // => [['barney', 36], ['fred', 40]] (iteration order is not guaranteed)
	     */
	    function pairs(object) {
	      object = toObject(object);

	      var index = -1,
	          props = keys(object),
	          length = props.length,
	          result = Array(length);

	      while (++index < length) {
	        var key = props[index];
	        result[index] = [key, object[key]];
	      }
	      return result;
	    }

	    /**
	     * Creates an object composed of the picked `object` properties. Property
	     * names may be specified as individual arguments or as arrays of property
	     * names. If `predicate` is provided it is invoked for each property of `object`
	     * picking the properties `predicate` returns truthy for. The predicate is
	     * bound to `thisArg` and invoked with three arguments: (value, key, object).
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The source object.
	     * @param {Function|...(string|string[])} [predicate] The function invoked per
	     *  iteration or property names to pick, specified as individual property
	     *  names or arrays of property names.
	     * @param {*} [thisArg] The `this` binding of `predicate`.
	     * @returns {Object} Returns the new object.
	     * @example
	     *
	     * var object = { 'user': 'fred', 'age': 40 };
	     *
	     * _.pick(object, 'user');
	     * // => { 'user': 'fred' }
	     *
	     * _.pick(object, _.isString);
	     * // => { 'user': 'fred' }
	     */
	    var pick = restParam(function(object, props) {
	      if (object == null) {
	        return {};
	      }
	      return typeof props[0] == 'function'
	        ? pickByCallback(object, bindCallback(props[0], props[1], 3))
	        : pickByArray(object, baseFlatten(props));
	    });

	    /**
	     * This method is like `_.get` except that if the resolved value is a function
	     * it is invoked with the `this` binding of its parent object and its result
	     * is returned.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @param {Array|string} path The path of the property to resolve.
	     * @param {*} [defaultValue] The value returned if the resolved value is `undefined`.
	     * @returns {*} Returns the resolved value.
	     * @example
	     *
	     * var object = { 'a': [{ 'b': { 'c1': 3, 'c2': _.constant(4) } }] };
	     *
	     * _.result(object, 'a[0].b.c1');
	     * // => 3
	     *
	     * _.result(object, 'a[0].b.c2');
	     * // => 4
	     *
	     * _.result(object, 'a.b.c', 'default');
	     * // => 'default'
	     *
	     * _.result(object, 'a.b.c', _.constant('default'));
	     * // => 'default'
	     */
	    function result(object, path, defaultValue) {
	      var result = object == null ? undefined : object[path];
	      if (result === undefined) {
	        if (object != null && !isKey(path, object)) {
	          path = toPath(path);
	          object = path.length == 1 ? object : baseGet(object, baseSlice(path, 0, -1));
	          result = object == null ? undefined : object[last(path)];
	        }
	        result = result === undefined ? defaultValue : result;
	      }
	      return isFunction(result) ? result.call(object) : result;
	    }

	    /**
	     * Sets the property value of `path` on `object`. If a portion of `path`
	     * does not exist it is created.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to augment.
	     * @param {Array|string} path The path of the property to set.
	     * @param {*} value The value to set.
	     * @returns {Object} Returns `object`.
	     * @example
	     *
	     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
	     *
	     * _.set(object, 'a[0].b.c', 4);
	     * console.log(object.a[0].b.c);
	     * // => 4
	     *
	     * _.set(object, 'x[0].y.z', 5);
	     * console.log(object.x[0].y.z);
	     * // => 5
	     */
	    function set(object, path, value) {
	      if (object == null) {
	        return object;
	      }
	      var pathKey = (path + '');
	      path = (object[pathKey] != null || isKey(path, object)) ? [pathKey] : toPath(path);

	      var index = -1,
	          length = path.length,
	          lastIndex = length - 1,
	          nested = object;

	      while (nested != null && ++index < length) {
	        var key = path[index];
	        if (isObject(nested)) {
	          if (index == lastIndex) {
	            nested[key] = value;
	          } else if (nested[key] == null) {
	            nested[key] = isIndex(path[index + 1]) ? [] : {};
	          }
	        }
	        nested = nested[key];
	      }
	      return object;
	    }

	    /**
	     * An alternative to `_.reduce`; this method transforms `object` to a new
	     * `accumulator` object which is the result of running each of its own enumerable
	     * properties through `iteratee`, with each invocation potentially mutating
	     * the `accumulator` object. The `iteratee` is bound to `thisArg` and invoked
	     * with four arguments: (accumulator, value, key, object). Iteratee functions
	     * may exit iteration early by explicitly returning `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Array|Object} object The object to iterate over.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [accumulator] The custom accumulator value.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {*} Returns the accumulated value.
	     * @example
	     *
	     * _.transform([2, 3, 4], function(result, n) {
	     *   result.push(n *= n);
	     *   return n % 2 == 0;
	     * });
	     * // => [4, 9]
	     *
	     * _.transform({ 'a': 1, 'b': 2 }, function(result, n, key) {
	     *   result[key] = n * 3;
	     * });
	     * // => { 'a': 3, 'b': 6 }
	     */
	    function transform(object, iteratee, accumulator, thisArg) {
	      var isArr = isArray(object) || isTypedArray(object);
	      iteratee = getCallback(iteratee, thisArg, 4);

	      if (accumulator == null) {
	        if (isArr || isObject(object)) {
	          var Ctor = object.constructor;
	          if (isArr) {
	            accumulator = isArray(object) ? new Ctor : [];
	          } else {
	            accumulator = baseCreate(isFunction(Ctor) ? Ctor.prototype : undefined);
	          }
	        } else {
	          accumulator = {};
	        }
	      }
	      (isArr ? arrayEach : baseForOwn)(object, function(value, index, object) {
	        return iteratee(accumulator, value, index, object);
	      });
	      return accumulator;
	    }

	    /**
	     * Creates an array of the own enumerable property values of `object`.
	     *
	     * **Note:** Non-object values are coerced to objects.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the array of property values.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.values(new Foo);
	     * // => [1, 2] (iteration order is not guaranteed)
	     *
	     * _.values('hi');
	     * // => ['h', 'i']
	     */
	    function values(object) {
	      return baseValues(object, keys(object));
	    }

	    /**
	     * Creates an array of the own and inherited enumerable property values
	     * of `object`.
	     *
	     * **Note:** Non-object values are coerced to objects.
	     *
	     * @static
	     * @memberOf _
	     * @category Object
	     * @param {Object} object The object to query.
	     * @returns {Array} Returns the array of property values.
	     * @example
	     *
	     * function Foo() {
	     *   this.a = 1;
	     *   this.b = 2;
	     * }
	     *
	     * Foo.prototype.c = 3;
	     *
	     * _.valuesIn(new Foo);
	     * // => [1, 2, 3] (iteration order is not guaranteed)
	     */
	    function valuesIn(object) {
	      return baseValues(object, keysIn(object));
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Checks if `n` is between `start` and up to but not including, `end`. If
	     * `end` is not specified it is set to `start` with `start` then set to `0`.
	     *
	     * @static
	     * @memberOf _
	     * @category Number
	     * @param {number} n The number to check.
	     * @param {number} [start=0] The start of the range.
	     * @param {number} end The end of the range.
	     * @returns {boolean} Returns `true` if `n` is in the range, else `false`.
	     * @example
	     *
	     * _.inRange(3, 2, 4);
	     * // => true
	     *
	     * _.inRange(4, 8);
	     * // => true
	     *
	     * _.inRange(4, 2);
	     * // => false
	     *
	     * _.inRange(2, 2);
	     * // => false
	     *
	     * _.inRange(1.2, 2);
	     * // => true
	     *
	     * _.inRange(5.2, 4);
	     * // => false
	     */
	    function inRange(value, start, end) {
	      start = +start || 0;
	      if (end === undefined) {
	        end = start;
	        start = 0;
	      } else {
	        end = +end || 0;
	      }
	      return value >= nativeMin(start, end) && value < nativeMax(start, end);
	    }

	    /**
	     * Produces a random number between `min` and `max` (inclusive). If only one
	     * argument is provided a number between `0` and the given number is returned.
	     * If `floating` is `true`, or either `min` or `max` are floats, a floating-point
	     * number is returned instead of an integer.
	     *
	     * @static
	     * @memberOf _
	     * @category Number
	     * @param {number} [min=0] The minimum possible value.
	     * @param {number} [max=1] The maximum possible value.
	     * @param {boolean} [floating] Specify returning a floating-point number.
	     * @returns {number} Returns the random number.
	     * @example
	     *
	     * _.random(0, 5);
	     * // => an integer between 0 and 5
	     *
	     * _.random(5);
	     * // => also an integer between 0 and 5
	     *
	     * _.random(5, true);
	     * // => a floating-point number between 0 and 5
	     *
	     * _.random(1.2, 5.2);
	     * // => a floating-point number between 1.2 and 5.2
	     */
	    function random(min, max, floating) {
	      if (floating && isIterateeCall(min, max, floating)) {
	        max = floating = undefined;
	      }
	      var noMin = min == null,
	          noMax = max == null;

	      if (floating == null) {
	        if (noMax && typeof min == 'boolean') {
	          floating = min;
	          min = 1;
	        }
	        else if (typeof max == 'boolean') {
	          floating = max;
	          noMax = true;
	        }
	      }
	      if (noMin && noMax) {
	        max = 1;
	        noMax = false;
	      }
	      min = +min || 0;
	      if (noMax) {
	        max = min;
	        min = 0;
	      } else {
	        max = +max || 0;
	      }
	      if (floating || min % 1 || max % 1) {
	        var rand = nativeRandom();
	        return nativeMin(min + (rand * (max - min + parseFloat('1e-' + ((rand + '').length - 1)))), max);
	      }
	      return baseRandom(min, max);
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to convert.
	     * @returns {string} Returns the camel cased string.
	     * @example
	     *
	     * _.camelCase('Foo Bar');
	     * // => 'fooBar'
	     *
	     * _.camelCase('--foo-bar');
	     * // => 'fooBar'
	     *
	     * _.camelCase('__foo_bar__');
	     * // => 'fooBar'
	     */
	    var camelCase = createCompounder(function(result, word, index) {
	      word = word.toLowerCase();
	      return result + (index ? (word.charAt(0).toUpperCase() + word.slice(1)) : word);
	    });

	    /**
	     * Capitalizes the first character of `string`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to capitalize.
	     * @returns {string} Returns the capitalized string.
	     * @example
	     *
	     * _.capitalize('fred');
	     * // => 'Fred'
	     */
	    function capitalize(string) {
	      string = baseToString(string);
	      return string && (string.charAt(0).toUpperCase() + string.slice(1));
	    }

	    /**
	     * Deburrs `string` by converting [latin-1 supplementary letters](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
	     * to basic latin letters and removing [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to deburr.
	     * @returns {string} Returns the deburred string.
	     * @example
	     *
	     * _.deburr('déjà vu');
	     * // => 'deja vu'
	     */
	    function deburr(string) {
	      string = baseToString(string);
	      return string && string.replace(reLatin1, deburrLetter).replace(reComboMark, '');
	    }

	    /**
	     * Checks if `string` ends with the given target string.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to search.
	     * @param {string} [target] The string to search for.
	     * @param {number} [position=string.length] The position to search from.
	     * @returns {boolean} Returns `true` if `string` ends with `target`, else `false`.
	     * @example
	     *
	     * _.endsWith('abc', 'c');
	     * // => true
	     *
	     * _.endsWith('abc', 'b');
	     * // => false
	     *
	     * _.endsWith('abc', 'b', 2);
	     * // => true
	     */
	    function endsWith(string, target, position) {
	      string = baseToString(string);
	      target = (target + '');

	      var length = string.length;
	      position = position === undefined
	        ? length
	        : nativeMin(position < 0 ? 0 : (+position || 0), length);

	      position -= target.length;
	      return position >= 0 && string.indexOf(target, position) == position;
	    }

	    /**
	     * Converts the characters "&", "<", ">", '"', "'", and "\`", in `string` to
	     * their corresponding HTML entities.
	     *
	     * **Note:** No other characters are escaped. To escape additional characters
	     * use a third-party library like [_he_](https://mths.be/he).
	     *
	     * Though the ">" character is escaped for symmetry, characters like
	     * ">" and "/" don't need escaping in HTML and have no special meaning
	     * unless they're part of a tag or unquoted attribute value.
	     * See [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
	     * (under "semi-related fun fact") for more details.
	     *
	     * Backticks are escaped because in Internet Explorer < 9, they can break out
	     * of attribute values or HTML comments. See [#59](https://html5sec.org/#59),
	     * [#102](https://html5sec.org/#102), [#108](https://html5sec.org/#108), and
	     * [#133](https://html5sec.org/#133) of the [HTML5 Security Cheatsheet](https://html5sec.org/)
	     * for more details.
	     *
	     * When working with HTML you should always [quote attribute values](http://wonko.com/post/html-escaping)
	     * to reduce XSS vectors.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to escape.
	     * @returns {string} Returns the escaped string.
	     * @example
	     *
	     * _.escape('fred, barney, & pebbles');
	     * // => 'fred, barney, &amp; pebbles'
	     */
	    function escape(string) {
	      // Reset `lastIndex` because in IE < 9 `String#replace` does not.
	      string = baseToString(string);
	      return (string && reHasUnescapedHtml.test(string))
	        ? string.replace(reUnescapedHtml, escapeHtmlChar)
	        : string;
	    }

	    /**
	     * Escapes the `RegExp` special characters "\", "/", "^", "$", ".", "|", "?",
	     * "*", "+", "(", ")", "[", "]", "{" and "}" in `string`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to escape.
	     * @returns {string} Returns the escaped string.
	     * @example
	     *
	     * _.escapeRegExp('[lodash](https://lodash.com/)');
	     * // => '\[lodash\]\(https:\/\/lodash\.com\/\)'
	     */
	    function escapeRegExp(string) {
	      string = baseToString(string);
	      return (string && reHasRegExpChars.test(string))
	        ? string.replace(reRegExpChars, escapeRegExpChar)
	        : (string || '(?:)');
	    }

	    /**
	     * Converts `string` to [kebab case](https://en.wikipedia.org/wiki/Letter_case#Special_case_styles).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to convert.
	     * @returns {string} Returns the kebab cased string.
	     * @example
	     *
	     * _.kebabCase('Foo Bar');
	     * // => 'foo-bar'
	     *
	     * _.kebabCase('fooBar');
	     * // => 'foo-bar'
	     *
	     * _.kebabCase('__foo_bar__');
	     * // => 'foo-bar'
	     */
	    var kebabCase = createCompounder(function(result, word, index) {
	      return result + (index ? '-' : '') + word.toLowerCase();
	    });

	    /**
	     * Pads `string` on the left and right sides if it's shorter than `length`.
	     * Padding characters are truncated if they can't be evenly divided by `length`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to pad.
	     * @param {number} [length=0] The padding length.
	     * @param {string} [chars=' '] The string used as padding.
	     * @returns {string} Returns the padded string.
	     * @example
	     *
	     * _.pad('abc', 8);
	     * // => '  abc   '
	     *
	     * _.pad('abc', 8, '_-');
	     * // => '_-abc_-_'
	     *
	     * _.pad('abc', 3);
	     * // => 'abc'
	     */
	    function pad(string, length, chars) {
	      string = baseToString(string);
	      length = +length;

	      var strLength = string.length;
	      if (strLength >= length || !nativeIsFinite(length)) {
	        return string;
	      }
	      var mid = (length - strLength) / 2,
	          leftLength = nativeFloor(mid),
	          rightLength = nativeCeil(mid);

	      chars = createPadding('', rightLength, chars);
	      return chars.slice(0, leftLength) + string + chars;
	    }

	    /**
	     * Pads `string` on the left side if it's shorter than `length`. Padding
	     * characters are truncated if they exceed `length`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to pad.
	     * @param {number} [length=0] The padding length.
	     * @param {string} [chars=' '] The string used as padding.
	     * @returns {string} Returns the padded string.
	     * @example
	     *
	     * _.padLeft('abc', 6);
	     * // => '   abc'
	     *
	     * _.padLeft('abc', 6, '_-');
	     * // => '_-_abc'
	     *
	     * _.padLeft('abc', 3);
	     * // => 'abc'
	     */
	    var padLeft = createPadDir();

	    /**
	     * Pads `string` on the right side if it's shorter than `length`. Padding
	     * characters are truncated if they exceed `length`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to pad.
	     * @param {number} [length=0] The padding length.
	     * @param {string} [chars=' '] The string used as padding.
	     * @returns {string} Returns the padded string.
	     * @example
	     *
	     * _.padRight('abc', 6);
	     * // => 'abc   '
	     *
	     * _.padRight('abc', 6, '_-');
	     * // => 'abc_-_'
	     *
	     * _.padRight('abc', 3);
	     * // => 'abc'
	     */
	    var padRight = createPadDir(true);

	    /**
	     * Converts `string` to an integer of the specified radix. If `radix` is
	     * `undefined` or `0`, a `radix` of `10` is used unless `value` is a hexadecimal,
	     * in which case a `radix` of `16` is used.
	     *
	     * **Note:** This method aligns with the [ES5 implementation](https://es5.github.io/#E)
	     * of `parseInt`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} string The string to convert.
	     * @param {number} [radix] The radix to interpret `value` by.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {number} Returns the converted integer.
	     * @example
	     *
	     * _.parseInt('08');
	     * // => 8
	     *
	     * _.map(['6', '08', '10'], _.parseInt);
	     * // => [6, 8, 10]
	     */
	    function parseInt(string, radix, guard) {
	      // Firefox < 21 and Opera < 15 follow ES3 for `parseInt`.
	      // Chrome fails to trim leading <BOM> whitespace characters.
	      // See https://code.google.com/p/v8/issues/detail?id=3109 for more details.
	      if (guard ? isIterateeCall(string, radix, guard) : radix == null) {
	        radix = 0;
	      } else if (radix) {
	        radix = +radix;
	      }
	      string = trim(string);
	      return nativeParseInt(string, radix || (reHasHexPrefix.test(string) ? 16 : 10));
	    }

	    /**
	     * Repeats the given string `n` times.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to repeat.
	     * @param {number} [n=0] The number of times to repeat the string.
	     * @returns {string} Returns the repeated string.
	     * @example
	     *
	     * _.repeat('*', 3);
	     * // => '***'
	     *
	     * _.repeat('abc', 2);
	     * // => 'abcabc'
	     *
	     * _.repeat('abc', 0);
	     * // => ''
	     */
	    function repeat(string, n) {
	      var result = '';
	      string = baseToString(string);
	      n = +n;
	      if (n < 1 || !string || !nativeIsFinite(n)) {
	        return result;
	      }
	      // Leverage the exponentiation by squaring algorithm for a faster repeat.
	      // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
	      do {
	        if (n % 2) {
	          result += string;
	        }
	        n = nativeFloor(n / 2);
	        string += string;
	      } while (n);

	      return result;
	    }

	    /**
	     * Converts `string` to [snake case](https://en.wikipedia.org/wiki/Snake_case).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to convert.
	     * @returns {string} Returns the snake cased string.
	     * @example
	     *
	     * _.snakeCase('Foo Bar');
	     * // => 'foo_bar'
	     *
	     * _.snakeCase('fooBar');
	     * // => 'foo_bar'
	     *
	     * _.snakeCase('--foo-bar');
	     * // => 'foo_bar'
	     */
	    var snakeCase = createCompounder(function(result, word, index) {
	      return result + (index ? '_' : '') + word.toLowerCase();
	    });

	    /**
	     * Converts `string` to [start case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to convert.
	     * @returns {string} Returns the start cased string.
	     * @example
	     *
	     * _.startCase('--foo-bar');
	     * // => 'Foo Bar'
	     *
	     * _.startCase('fooBar');
	     * // => 'Foo Bar'
	     *
	     * _.startCase('__foo_bar__');
	     * // => 'Foo Bar'
	     */
	    var startCase = createCompounder(function(result, word, index) {
	      return result + (index ? ' ' : '') + (word.charAt(0).toUpperCase() + word.slice(1));
	    });

	    /**
	     * Checks if `string` starts with the given target string.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to search.
	     * @param {string} [target] The string to search for.
	     * @param {number} [position=0] The position to search from.
	     * @returns {boolean} Returns `true` if `string` starts with `target`, else `false`.
	     * @example
	     *
	     * _.startsWith('abc', 'a');
	     * // => true
	     *
	     * _.startsWith('abc', 'b');
	     * // => false
	     *
	     * _.startsWith('abc', 'b', 1);
	     * // => true
	     */
	    function startsWith(string, target, position) {
	      string = baseToString(string);
	      position = position == null
	        ? 0
	        : nativeMin(position < 0 ? 0 : (+position || 0), string.length);

	      return string.lastIndexOf(target, position) == position;
	    }

	    /**
	     * Creates a compiled template function that can interpolate data properties
	     * in "interpolate" delimiters, HTML-escape interpolated data properties in
	     * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
	     * properties may be accessed as free variables in the template. If a setting
	     * object is provided it takes precedence over `_.templateSettings` values.
	     *
	     * **Note:** In the development build `_.template` utilizes
	     * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
	     * for easier debugging.
	     *
	     * For more information on precompiling templates see
	     * [lodash's custom builds documentation](https://lodash.com/custom-builds).
	     *
	     * For more information on Chrome extension sandboxes see
	     * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The template string.
	     * @param {Object} [options] The options object.
	     * @param {RegExp} [options.escape] The HTML "escape" delimiter.
	     * @param {RegExp} [options.evaluate] The "evaluate" delimiter.
	     * @param {Object} [options.imports] An object to import into the template as free variables.
	     * @param {RegExp} [options.interpolate] The "interpolate" delimiter.
	     * @param {string} [options.sourceURL] The sourceURL of the template's compiled source.
	     * @param {string} [options.variable] The data object variable name.
	     * @param- {Object} [otherOptions] Enables the legacy `options` param signature.
	     * @returns {Function} Returns the compiled template function.
	     * @example
	     *
	     * // using the "interpolate" delimiter to create a compiled template
	     * var compiled = _.template('hello <%= user %>!');
	     * compiled({ 'user': 'fred' });
	     * // => 'hello fred!'
	     *
	     * // using the HTML "escape" delimiter to escape data property values
	     * var compiled = _.template('<b><%- value %></b>');
	     * compiled({ 'value': '<script>' });
	     * // => '<b>&lt;script&gt;</b>'
	     *
	     * // using the "evaluate" delimiter to execute JavaScript and generate HTML
	     * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
	     * compiled({ 'users': ['fred', 'barney'] });
	     * // => '<li>fred</li><li>barney</li>'
	     *
	     * // using the internal `print` function in "evaluate" delimiters
	     * var compiled = _.template('<% print("hello " + user); %>!');
	     * compiled({ 'user': 'barney' });
	     * // => 'hello barney!'
	     *
	     * // using the ES delimiter as an alternative to the default "interpolate" delimiter
	     * var compiled = _.template('hello ${ user }!');
	     * compiled({ 'user': 'pebbles' });
	     * // => 'hello pebbles!'
	     *
	     * // using custom template delimiters
	     * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
	     * var compiled = _.template('hello {{ user }}!');
	     * compiled({ 'user': 'mustache' });
	     * // => 'hello mustache!'
	     *
	     * // using backslashes to treat delimiters as plain text
	     * var compiled = _.template('<%= "\\<%- value %\\>" %>');
	     * compiled({ 'value': 'ignored' });
	     * // => '<%- value %>'
	     *
	     * // using the `imports` option to import `jQuery` as `jq`
	     * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
	     * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
	     * compiled({ 'users': ['fred', 'barney'] });
	     * // => '<li>fred</li><li>barney</li>'
	     *
	     * // using the `sourceURL` option to specify a custom sourceURL for the template
	     * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
	     * compiled(data);
	     * // => find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector
	     *
	     * // using the `variable` option to ensure a with-statement isn't used in the compiled template
	     * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
	     * compiled.source;
	     * // => function(data) {
	     * //   var __t, __p = '';
	     * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
	     * //   return __p;
	     * // }
	     *
	     * // using the `source` property to inline compiled templates for meaningful
	     * // line numbers in error messages and a stack trace
	     * fs.writeFileSync(path.join(cwd, 'jst.js'), '\
	     *   var JST = {\
	     *     "main": ' + _.template(mainText).source + '\
	     *   };\
	     * ');
	     */
	    function template(string, options, otherOptions) {
	      // Based on John Resig's `tmpl` implementation (http://ejohn.org/blog/javascript-micro-templating/)
	      // and Laura Doktorova's doT.js (https://github.com/olado/doT).
	      var settings = lodash.templateSettings;

	      if (otherOptions && isIterateeCall(string, options, otherOptions)) {
	        options = otherOptions = undefined;
	      }
	      string = baseToString(string);
	      options = assignWith(baseAssign({}, otherOptions || options), settings, assignOwnDefaults);

	      var imports = assignWith(baseAssign({}, options.imports), settings.imports, assignOwnDefaults),
	          importsKeys = keys(imports),
	          importsValues = baseValues(imports, importsKeys);

	      var isEscaping,
	          isEvaluating,
	          index = 0,
	          interpolate = options.interpolate || reNoMatch,
	          source = "__p += '";

	      // Compile the regexp to match each delimiter.
	      var reDelimiters = RegExp(
	        (options.escape || reNoMatch).source + '|' +
	        interpolate.source + '|' +
	        (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
	        (options.evaluate || reNoMatch).source + '|$'
	      , 'g');

	      // Use a sourceURL for easier debugging.
	      var sourceURL = '//# sourceURL=' +
	        ('sourceURL' in options
	          ? options.sourceURL
	          : ('lodash.templateSources[' + (++templateCounter) + ']')
	        ) + '\n';

	      string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
	        interpolateValue || (interpolateValue = esTemplateValue);

	        // Escape characters that can't be included in string literals.
	        source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);

	        // Replace delimiters with snippets.
	        if (escapeValue) {
	          isEscaping = true;
	          source += "' +\n__e(" + escapeValue + ") +\n'";
	        }
	        if (evaluateValue) {
	          isEvaluating = true;
	          source += "';\n" + evaluateValue + ";\n__p += '";
	        }
	        if (interpolateValue) {
	          source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
	        }
	        index = offset + match.length;

	        // The JS engine embedded in Adobe products requires returning the `match`
	        // string in order to produce the correct `offset` value.
	        return match;
	      });

	      source += "';\n";

	      // If `variable` is not specified wrap a with-statement around the generated
	      // code to add the data object to the top of the scope chain.
	      var variable = options.variable;
	      if (!variable) {
	        source = 'with (obj) {\n' + source + '\n}\n';
	      }
	      // Cleanup code by stripping empty strings.
	      source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
	        .replace(reEmptyStringMiddle, '$1')
	        .replace(reEmptyStringTrailing, '$1;');

	      // Frame code as the function body.
	      source = 'function(' + (variable || 'obj') + ') {\n' +
	        (variable
	          ? ''
	          : 'obj || (obj = {});\n'
	        ) +
	        "var __t, __p = ''" +
	        (isEscaping
	           ? ', __e = _.escape'
	           : ''
	        ) +
	        (isEvaluating
	          ? ', __j = Array.prototype.join;\n' +
	            "function print() { __p += __j.call(arguments, '') }\n"
	          : ';\n'
	        ) +
	        source +
	        'return __p\n}';

	      var result = attempt(function() {
	        return Function(importsKeys, sourceURL + 'return ' + source).apply(undefined, importsValues);
	      });

	      // Provide the compiled function's source by its `toString` method or
	      // the `source` property as a convenience for inlining compiled templates.
	      result.source = source;
	      if (isError(result)) {
	        throw result;
	      }
	      return result;
	    }

	    /**
	     * Removes leading and trailing whitespace or specified characters from `string`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to trim.
	     * @param {string} [chars=whitespace] The characters to trim.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {string} Returns the trimmed string.
	     * @example
	     *
	     * _.trim('  abc  ');
	     * // => 'abc'
	     *
	     * _.trim('-_-abc-_-', '_-');
	     * // => 'abc'
	     *
	     * _.map(['  foo  ', '  bar  '], _.trim);
	     * // => ['foo', 'bar']
	     */
	    function trim(string, chars, guard) {
	      var value = string;
	      string = baseToString(string);
	      if (!string) {
	        return string;
	      }
	      if (guard ? isIterateeCall(value, chars, guard) : chars == null) {
	        return string.slice(trimmedLeftIndex(string), trimmedRightIndex(string) + 1);
	      }
	      chars = (chars + '');
	      return string.slice(charsLeftIndex(string, chars), charsRightIndex(string, chars) + 1);
	    }

	    /**
	     * Removes leading whitespace or specified characters from `string`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to trim.
	     * @param {string} [chars=whitespace] The characters to trim.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {string} Returns the trimmed string.
	     * @example
	     *
	     * _.trimLeft('  abc  ');
	     * // => 'abc  '
	     *
	     * _.trimLeft('-_-abc-_-', '_-');
	     * // => 'abc-_-'
	     */
	    function trimLeft(string, chars, guard) {
	      var value = string;
	      string = baseToString(string);
	      if (!string) {
	        return string;
	      }
	      if (guard ? isIterateeCall(value, chars, guard) : chars == null) {
	        return string.slice(trimmedLeftIndex(string));
	      }
	      return string.slice(charsLeftIndex(string, (chars + '')));
	    }

	    /**
	     * Removes trailing whitespace or specified characters from `string`.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to trim.
	     * @param {string} [chars=whitespace] The characters to trim.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {string} Returns the trimmed string.
	     * @example
	     *
	     * _.trimRight('  abc  ');
	     * // => '  abc'
	     *
	     * _.trimRight('-_-abc-_-', '_-');
	     * // => '-_-abc'
	     */
	    function trimRight(string, chars, guard) {
	      var value = string;
	      string = baseToString(string);
	      if (!string) {
	        return string;
	      }
	      if (guard ? isIterateeCall(value, chars, guard) : chars == null) {
	        return string.slice(0, trimmedRightIndex(string) + 1);
	      }
	      return string.slice(0, charsRightIndex(string, (chars + '')) + 1);
	    }

	    /**
	     * Truncates `string` if it's longer than the given maximum string length.
	     * The last characters of the truncated string are replaced with the omission
	     * string which defaults to "...".
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to truncate.
	     * @param {Object|number} [options] The options object or maximum string length.
	     * @param {number} [options.length=30] The maximum string length.
	     * @param {string} [options.omission='...'] The string to indicate text is omitted.
	     * @param {RegExp|string} [options.separator] The separator pattern to truncate to.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {string} Returns the truncated string.
	     * @example
	     *
	     * _.trunc('hi-diddly-ho there, neighborino');
	     * // => 'hi-diddly-ho there, neighbo...'
	     *
	     * _.trunc('hi-diddly-ho there, neighborino', 24);
	     * // => 'hi-diddly-ho there, n...'
	     *
	     * _.trunc('hi-diddly-ho there, neighborino', {
	     *   'length': 24,
	     *   'separator': ' '
	     * });
	     * // => 'hi-diddly-ho there,...'
	     *
	     * _.trunc('hi-diddly-ho there, neighborino', {
	     *   'length': 24,
	     *   'separator': /,? +/
	     * });
	     * // => 'hi-diddly-ho there...'
	     *
	     * _.trunc('hi-diddly-ho there, neighborino', {
	     *   'omission': ' [...]'
	     * });
	     * // => 'hi-diddly-ho there, neig [...]'
	     */
	    function trunc(string, options, guard) {
	      if (guard && isIterateeCall(string, options, guard)) {
	        options = undefined;
	      }
	      var length = DEFAULT_TRUNC_LENGTH,
	          omission = DEFAULT_TRUNC_OMISSION;

	      if (options != null) {
	        if (isObject(options)) {
	          var separator = 'separator' in options ? options.separator : separator;
	          length = 'length' in options ? (+options.length || 0) : length;
	          omission = 'omission' in options ? baseToString(options.omission) : omission;
	        } else {
	          length = +options || 0;
	        }
	      }
	      string = baseToString(string);
	      if (length >= string.length) {
	        return string;
	      }
	      var end = length - omission.length;
	      if (end < 1) {
	        return omission;
	      }
	      var result = string.slice(0, end);
	      if (separator == null) {
	        return result + omission;
	      }
	      if (isRegExp(separator)) {
	        if (string.slice(end).search(separator)) {
	          var match,
	              newEnd,
	              substring = string.slice(0, end);

	          if (!separator.global) {
	            separator = RegExp(separator.source, (reFlags.exec(separator) || '') + 'g');
	          }
	          separator.lastIndex = 0;
	          while ((match = separator.exec(substring))) {
	            newEnd = match.index;
	          }
	          result = result.slice(0, newEnd == null ? end : newEnd);
	        }
	      } else if (string.indexOf(separator, end) != end) {
	        var index = result.lastIndexOf(separator);
	        if (index > -1) {
	          result = result.slice(0, index);
	        }
	      }
	      return result + omission;
	    }

	    /**
	     * The inverse of `_.escape`; this method converts the HTML entities
	     * `&amp;`, `&lt;`, `&gt;`, `&quot;`, `&#39;`, and `&#96;` in `string` to their
	     * corresponding characters.
	     *
	     * **Note:** No other HTML entities are unescaped. To unescape additional HTML
	     * entities use a third-party library like [_he_](https://mths.be/he).
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to unescape.
	     * @returns {string} Returns the unescaped string.
	     * @example
	     *
	     * _.unescape('fred, barney, &amp; pebbles');
	     * // => 'fred, barney, & pebbles'
	     */
	    function unescape(string) {
	      string = baseToString(string);
	      return (string && reHasEscapedHtml.test(string))
	        ? string.replace(reEscapedHtml, unescapeHtmlChar)
	        : string;
	    }

	    /**
	     * Splits `string` into an array of its words.
	     *
	     * @static
	     * @memberOf _
	     * @category String
	     * @param {string} [string=''] The string to inspect.
	     * @param {RegExp|string} [pattern] The pattern to match words.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Array} Returns the words of `string`.
	     * @example
	     *
	     * _.words('fred, barney, & pebbles');
	     * // => ['fred', 'barney', 'pebbles']
	     *
	     * _.words('fred, barney, & pebbles', /[^, ]+/g);
	     * // => ['fred', 'barney', '&', 'pebbles']
	     */
	    function words(string, pattern, guard) {
	      if (guard && isIterateeCall(string, pattern, guard)) {
	        pattern = undefined;
	      }
	      string = baseToString(string);
	      return string.match(pattern || reWords) || [];
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Attempts to invoke `func`, returning either the result or the caught error
	     * object. Any additional arguments are provided to `func` when it is invoked.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Function} func The function to attempt.
	     * @returns {*} Returns the `func` result or error object.
	     * @example
	     *
	     * // avoid throwing errors for invalid selectors
	     * var elements = _.attempt(function(selector) {
	     *   return document.querySelectorAll(selector);
	     * }, '>_>');
	     *
	     * if (_.isError(elements)) {
	     *   elements = [];
	     * }
	     */
	    var attempt = restParam(function(func, args) {
	      try {
	        return func.apply(undefined, args);
	      } catch(e) {
	        return isError(e) ? e : new Error(e);
	      }
	    });

	    /**
	     * Creates a function that invokes `func` with the `this` binding of `thisArg`
	     * and arguments of the created function. If `func` is a property name the
	     * created callback returns the property value for a given element. If `func`
	     * is an object the created callback returns `true` for elements that contain
	     * the equivalent object properties, otherwise it returns `false`.
	     *
	     * @static
	     * @memberOf _
	     * @alias iteratee
	     * @category Utility
	     * @param {*} [func=_.identity] The value to convert to a callback.
	     * @param {*} [thisArg] The `this` binding of `func`.
	     * @param- {Object} [guard] Enables use as a callback for functions like `_.map`.
	     * @returns {Function} Returns the callback.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 40 }
	     * ];
	     *
	     * // wrap to create custom callback shorthands
	     * _.callback = _.wrap(_.callback, function(callback, func, thisArg) {
	     *   var match = /^(.+?)__([gl]t)(.+)$/.exec(func);
	     *   if (!match) {
	     *     return callback(func, thisArg);
	     *   }
	     *   return function(object) {
	     *     return match[2] == 'gt'
	     *       ? object[match[1]] > match[3]
	     *       : object[match[1]] < match[3];
	     *   };
	     * });
	     *
	     * _.filter(users, 'age__gt36');
	     * // => [{ 'user': 'fred', 'age': 40 }]
	     */
	    function callback(func, thisArg, guard) {
	      if (guard && isIterateeCall(func, thisArg, guard)) {
	        thisArg = undefined;
	      }
	      return isObjectLike(func)
	        ? matches(func)
	        : baseCallback(func, thisArg);
	    }

	    /**
	     * Creates a function that returns `value`.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {*} value The value to return from the new function.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var object = { 'user': 'fred' };
	     * var getter = _.constant(object);
	     *
	     * getter() === object;
	     * // => true
	     */
	    function constant(value) {
	      return function() {
	        return value;
	      };
	    }

	    /**
	     * This method returns the first argument provided to it.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {*} value Any value.
	     * @returns {*} Returns `value`.
	     * @example
	     *
	     * var object = { 'user': 'fred' };
	     *
	     * _.identity(object) === object;
	     * // => true
	     */
	    function identity(value) {
	      return value;
	    }

	    /**
	     * Creates a function that performs a deep comparison between a given object
	     * and `source`, returning `true` if the given object has equivalent property
	     * values, else `false`.
	     *
	     * **Note:** This method supports comparing arrays, booleans, `Date` objects,
	     * numbers, `Object` objects, regexes, and strings. Objects are compared by
	     * their own, not inherited, enumerable properties. For comparing a single
	     * own or inherited property value see `_.matchesProperty`.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Object} source The object of property values to match.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36, 'active': true },
	     *   { 'user': 'fred',   'age': 40, 'active': false }
	     * ];
	     *
	     * _.filter(users, _.matches({ 'age': 40, 'active': false }));
	     * // => [{ 'user': 'fred', 'age': 40, 'active': false }]
	     */
	    function matches(source) {
	      return baseMatches(baseClone(source, true));
	    }

	    /**
	     * Creates a function that compares the property value of `path` on a given
	     * object to `value`.
	     *
	     * **Note:** This method supports comparing arrays, booleans, `Date` objects,
	     * numbers, `Object` objects, regexes, and strings. Objects are compared by
	     * their own, not inherited, enumerable properties.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Array|string} path The path of the property to get.
	     * @param {*} srcValue The value to match.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var users = [
	     *   { 'user': 'barney' },
	     *   { 'user': 'fred' }
	     * ];
	     *
	     * _.find(users, _.matchesProperty('user', 'fred'));
	     * // => { 'user': 'fred' }
	     */
	    function matchesProperty(path, srcValue) {
	      return baseMatchesProperty(path, baseClone(srcValue, true));
	    }

	    /**
	     * Creates a function that invokes the method at `path` on a given object.
	     * Any additional arguments are provided to the invoked method.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Array|string} path The path of the method to invoke.
	     * @param {...*} [args] The arguments to invoke the method with.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var objects = [
	     *   { 'a': { 'b': { 'c': _.constant(2) } } },
	     *   { 'a': { 'b': { 'c': _.constant(1) } } }
	     * ];
	     *
	     * _.map(objects, _.method('a.b.c'));
	     * // => [2, 1]
	     *
	     * _.invoke(_.sortBy(objects, _.method(['a', 'b', 'c'])), 'a.b.c');
	     * // => [1, 2]
	     */
	    var method = restParam(function(path, args) {
	      return function(object) {
	        return invokePath(object, path, args);
	      };
	    });

	    /**
	     * The opposite of `_.method`; this method creates a function that invokes
	     * the method at a given path on `object`. Any additional arguments are
	     * provided to the invoked method.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Object} object The object to query.
	     * @param {...*} [args] The arguments to invoke the method with.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var array = _.times(3, _.constant),
	     *     object = { 'a': array, 'b': array, 'c': array };
	     *
	     * _.map(['a[2]', 'c[0]'], _.methodOf(object));
	     * // => [2, 0]
	     *
	     * _.map([['a', '2'], ['c', '0']], _.methodOf(object));
	     * // => [2, 0]
	     */
	    var methodOf = restParam(function(object, args) {
	      return function(path) {
	        return invokePath(object, path, args);
	      };
	    });

	    /**
	     * Adds all own enumerable function properties of a source object to the
	     * destination object. If `object` is a function then methods are added to
	     * its prototype as well.
	     *
	     * **Note:** Use `_.runInContext` to create a pristine `lodash` function to
	     * avoid conflicts caused by modifying the original.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Function|Object} [object=lodash] The destination object.
	     * @param {Object} source The object of functions to add.
	     * @param {Object} [options] The options object.
	     * @param {boolean} [options.chain=true] Specify whether the functions added
	     *  are chainable.
	     * @returns {Function|Object} Returns `object`.
	     * @example
	     *
	     * function vowels(string) {
	     *   return _.filter(string, function(v) {
	     *     return /[aeiou]/i.test(v);
	     *   });
	     * }
	     *
	     * _.mixin({ 'vowels': vowels });
	     * _.vowels('fred');
	     * // => ['e']
	     *
	     * _('fred').vowels().value();
	     * // => ['e']
	     *
	     * _.mixin({ 'vowels': vowels }, { 'chain': false });
	     * _('fred').vowels();
	     * // => ['e']
	     */
	    function mixin(object, source, options) {
	      if (options == null) {
	        var isObj = isObject(source),
	            props = isObj ? keys(source) : undefined,
	            methodNames = (props && props.length) ? baseFunctions(source, props) : undefined;

	        if (!(methodNames ? methodNames.length : isObj)) {
	          methodNames = false;
	          options = source;
	          source = object;
	          object = this;
	        }
	      }
	      if (!methodNames) {
	        methodNames = baseFunctions(source, keys(source));
	      }
	      var chain = true,
	          index = -1,
	          isFunc = isFunction(object),
	          length = methodNames.length;

	      if (options === false) {
	        chain = false;
	      } else if (isObject(options) && 'chain' in options) {
	        chain = options.chain;
	      }
	      while (++index < length) {
	        var methodName = methodNames[index],
	            func = source[methodName];

	        object[methodName] = func;
	        if (isFunc) {
	          object.prototype[methodName] = (function(func) {
	            return function() {
	              var chainAll = this.__chain__;
	              if (chain || chainAll) {
	                var result = object(this.__wrapped__),
	                    actions = result.__actions__ = arrayCopy(this.__actions__);

	                actions.push({ 'func': func, 'args': arguments, 'thisArg': object });
	                result.__chain__ = chainAll;
	                return result;
	              }
	              return func.apply(object, arrayPush([this.value()], arguments));
	            };
	          }(func));
	        }
	      }
	      return object;
	    }

	    /**
	     * Reverts the `_` variable to its previous value and returns a reference to
	     * the `lodash` function.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @returns {Function} Returns the `lodash` function.
	     * @example
	     *
	     * var lodash = _.noConflict();
	     */
	    function noConflict() {
	      root._ = oldDash;
	      return this;
	    }

	    /**
	     * A no-operation function that returns `undefined` regardless of the
	     * arguments it receives.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @example
	     *
	     * var object = { 'user': 'fred' };
	     *
	     * _.noop(object) === undefined;
	     * // => true
	     */
	    function noop() {
	      // No operation performed.
	    }

	    /**
	     * Creates a function that returns the property value at `path` on a
	     * given object.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Array|string} path The path of the property to get.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var objects = [
	     *   { 'a': { 'b': { 'c': 2 } } },
	     *   { 'a': { 'b': { 'c': 1 } } }
	     * ];
	     *
	     * _.map(objects, _.property('a.b.c'));
	     * // => [2, 1]
	     *
	     * _.pluck(_.sortBy(objects, _.property(['a', 'b', 'c'])), 'a.b.c');
	     * // => [1, 2]
	     */
	    function property(path) {
	      return isKey(path) ? baseProperty(path) : basePropertyDeep(path);
	    }

	    /**
	     * The opposite of `_.property`; this method creates a function that returns
	     * the property value at a given path on `object`.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {Object} object The object to query.
	     * @returns {Function} Returns the new function.
	     * @example
	     *
	     * var array = [0, 1, 2],
	     *     object = { 'a': array, 'b': array, 'c': array };
	     *
	     * _.map(['a[2]', 'c[0]'], _.propertyOf(object));
	     * // => [2, 0]
	     *
	     * _.map([['a', '2'], ['c', '0']], _.propertyOf(object));
	     * // => [2, 0]
	     */
	    function propertyOf(object) {
	      return function(path) {
	        return baseGet(object, toPath(path), path + '');
	      };
	    }

	    /**
	     * Creates an array of numbers (positive and/or negative) progressing from
	     * `start` up to, but not including, `end`. If `end` is not specified it is
	     * set to `start` with `start` then set to `0`. If `end` is less than `start`
	     * a zero-length range is created unless a negative `step` is specified.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {number} [start=0] The start of the range.
	     * @param {number} end The end of the range.
	     * @param {number} [step=1] The value to increment or decrement by.
	     * @returns {Array} Returns the new array of numbers.
	     * @example
	     *
	     * _.range(4);
	     * // => [0, 1, 2, 3]
	     *
	     * _.range(1, 5);
	     * // => [1, 2, 3, 4]
	     *
	     * _.range(0, 20, 5);
	     * // => [0, 5, 10, 15]
	     *
	     * _.range(0, -4, -1);
	     * // => [0, -1, -2, -3]
	     *
	     * _.range(1, 4, 0);
	     * // => [1, 1, 1]
	     *
	     * _.range(0);
	     * // => []
	     */
	    function range(start, end, step) {
	      if (step && isIterateeCall(start, end, step)) {
	        end = step = undefined;
	      }
	      start = +start || 0;
	      step = step == null ? 1 : (+step || 0);

	      if (end == null) {
	        end = start;
	        start = 0;
	      } else {
	        end = +end || 0;
	      }
	      // Use `Array(length)` so engines like Chakra and V8 avoid slower modes.
	      // See https://youtu.be/XAqIpGU8ZZk#t=17m25s for more details.
	      var index = -1,
	          length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
	          result = Array(length);

	      while (++index < length) {
	        result[index] = start;
	        start += step;
	      }
	      return result;
	    }

	    /**
	     * Invokes the iteratee function `n` times, returning an array of the results
	     * of each invocation. The `iteratee` is bound to `thisArg` and invoked with
	     * one argument; (index).
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {number} n The number of times to invoke `iteratee`.
	     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {Array} Returns the array of results.
	     * @example
	     *
	     * var diceRolls = _.times(3, _.partial(_.random, 1, 6, false));
	     * // => [3, 6, 4]
	     *
	     * _.times(3, function(n) {
	     *   mage.castSpell(n);
	     * });
	     * // => invokes `mage.castSpell(n)` three times with `n` of `0`, `1`, and `2`
	     *
	     * _.times(3, function(n) {
	     *   this.cast(n);
	     * }, mage);
	     * // => also invokes `mage.castSpell(n)` three times
	     */
	    function times(n, iteratee, thisArg) {
	      n = nativeFloor(n);

	      // Exit early to avoid a JSC JIT bug in Safari 8
	      // where `Array(0)` is treated as `Array(1)`.
	      if (n < 1 || !nativeIsFinite(n)) {
	        return [];
	      }
	      var index = -1,
	          result = Array(nativeMin(n, MAX_ARRAY_LENGTH));

	      iteratee = bindCallback(iteratee, thisArg, 1);
	      while (++index < n) {
	        if (index < MAX_ARRAY_LENGTH) {
	          result[index] = iteratee(index);
	        } else {
	          iteratee(index);
	        }
	      }
	      return result;
	    }

	    /**
	     * Generates a unique ID. If `prefix` is provided the ID is appended to it.
	     *
	     * @static
	     * @memberOf _
	     * @category Utility
	     * @param {string} [prefix] The value to prefix the ID with.
	     * @returns {string} Returns the unique ID.
	     * @example
	     *
	     * _.uniqueId('contact_');
	     * // => 'contact_104'
	     *
	     * _.uniqueId();
	     * // => '105'
	     */
	    function uniqueId(prefix) {
	      var id = ++idCounter;
	      return baseToString(prefix) + id;
	    }

	    /*------------------------------------------------------------------------*/

	    /**
	     * Adds two numbers.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {number} augend The first number to add.
	     * @param {number} addend The second number to add.
	     * @returns {number} Returns the sum.
	     * @example
	     *
	     * _.add(6, 4);
	     * // => 10
	     */
	    function add(augend, addend) {
	      return (+augend || 0) + (+addend || 0);
	    }

	    /**
	     * Calculates `n` rounded up to `precision`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {number} n The number to round up.
	     * @param {number} [precision=0] The precision to round up to.
	     * @returns {number} Returns the rounded up number.
	     * @example
	     *
	     * _.ceil(4.006);
	     * // => 5
	     *
	     * _.ceil(6.004, 2);
	     * // => 6.01
	     *
	     * _.ceil(6040, -2);
	     * // => 6100
	     */
	    var ceil = createRound('ceil');

	    /**
	     * Calculates `n` rounded down to `precision`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {number} n The number to round down.
	     * @param {number} [precision=0] The precision to round down to.
	     * @returns {number} Returns the rounded down number.
	     * @example
	     *
	     * _.floor(4.006);
	     * // => 4
	     *
	     * _.floor(0.046, 2);
	     * // => 0.04
	     *
	     * _.floor(4060, -2);
	     * // => 4000
	     */
	    var floor = createRound('floor');

	    /**
	     * Gets the maximum value of `collection`. If `collection` is empty or falsey
	     * `-Infinity` is returned. If an iteratee function is provided it is invoked
	     * for each value in `collection` to generate the criterion by which the value
	     * is ranked. The `iteratee` is bound to `thisArg` and invoked with three
	     * arguments: (value, index, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {*} Returns the maximum value.
	     * @example
	     *
	     * _.max([4, 2, 8, 6]);
	     * // => 8
	     *
	     * _.max([]);
	     * // => -Infinity
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 40 }
	     * ];
	     *
	     * _.max(users, function(chr) {
	     *   return chr.age;
	     * });
	     * // => { 'user': 'fred', 'age': 40 }
	     *
	     * // using the `_.property` callback shorthand
	     * _.max(users, 'age');
	     * // => { 'user': 'fred', 'age': 40 }
	     */
	    var max = createExtremum(gt, NEGATIVE_INFINITY);

	    /**
	     * Gets the minimum value of `collection`. If `collection` is empty or falsey
	     * `Infinity` is returned. If an iteratee function is provided it is invoked
	     * for each value in `collection` to generate the criterion by which the value
	     * is ranked. The `iteratee` is bound to `thisArg` and invoked with three
	     * arguments: (value, index, collection).
	     *
	     * If a property name is provided for `iteratee` the created `_.property`
	     * style callback returns the property value of the given element.
	     *
	     * If a value is also provided for `thisArg` the created `_.matchesProperty`
	     * style callback returns `true` for elements that have a matching property
	     * value, else `false`.
	     *
	     * If an object is provided for `iteratee` the created `_.matches` style
	     * callback returns `true` for elements that have the properties of the given
	     * object, else `false`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {*} Returns the minimum value.
	     * @example
	     *
	     * _.min([4, 2, 8, 6]);
	     * // => 2
	     *
	     * _.min([]);
	     * // => Infinity
	     *
	     * var users = [
	     *   { 'user': 'barney', 'age': 36 },
	     *   { 'user': 'fred',   'age': 40 }
	     * ];
	     *
	     * _.min(users, function(chr) {
	     *   return chr.age;
	     * });
	     * // => { 'user': 'barney', 'age': 36 }
	     *
	     * // using the `_.property` callback shorthand
	     * _.min(users, 'age');
	     * // => { 'user': 'barney', 'age': 36 }
	     */
	    var min = createExtremum(lt, POSITIVE_INFINITY);

	    /**
	     * Calculates `n` rounded to `precision`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {number} n The number to round.
	     * @param {number} [precision=0] The precision to round to.
	     * @returns {number} Returns the rounded number.
	     * @example
	     *
	     * _.round(4.006);
	     * // => 4
	     *
	     * _.round(4.006, 2);
	     * // => 4.01
	     *
	     * _.round(4060, -2);
	     * // => 4100
	     */
	    var round = createRound('round');

	    /**
	     * Gets the sum of the values in `collection`.
	     *
	     * @static
	     * @memberOf _
	     * @category Math
	     * @param {Array|Object|string} collection The collection to iterate over.
	     * @param {Function|Object|string} [iteratee] The function invoked per iteration.
	     * @param {*} [thisArg] The `this` binding of `iteratee`.
	     * @returns {number} Returns the sum.
	     * @example
	     *
	     * _.sum([4, 6]);
	     * // => 10
	     *
	     * _.sum({ 'a': 4, 'b': 6 });
	     * // => 10
	     *
	     * var objects = [
	     *   { 'n': 4 },
	     *   { 'n': 6 }
	     * ];
	     *
	     * _.sum(objects, function(object) {
	     *   return object.n;
	     * });
	     * // => 10
	     *
	     * // using the `_.property` callback shorthand
	     * _.sum(objects, 'n');
	     * // => 10
	     */
	    function sum(collection, iteratee, thisArg) {
	      if (thisArg && isIterateeCall(collection, iteratee, thisArg)) {
	        iteratee = undefined;
	      }
	      iteratee = getCallback(iteratee, thisArg, 3);
	      return iteratee.length == 1
	        ? arraySum(isArray(collection) ? collection : toIterable(collection), iteratee)
	        : baseSum(collection, iteratee);
	    }

	    /*------------------------------------------------------------------------*/

	    // Ensure wrappers are instances of `baseLodash`.
	    lodash.prototype = baseLodash.prototype;

	    LodashWrapper.prototype = baseCreate(baseLodash.prototype);
	    LodashWrapper.prototype.constructor = LodashWrapper;

	    LazyWrapper.prototype = baseCreate(baseLodash.prototype);
	    LazyWrapper.prototype.constructor = LazyWrapper;

	    // Add functions to the `Map` cache.
	    MapCache.prototype['delete'] = mapDelete;
	    MapCache.prototype.get = mapGet;
	    MapCache.prototype.has = mapHas;
	    MapCache.prototype.set = mapSet;

	    // Add functions to the `Set` cache.
	    SetCache.prototype.push = cachePush;

	    // Assign cache to `_.memoize`.
	    memoize.Cache = MapCache;

	    // Add functions that return wrapped values when chaining.
	    lodash.after = after;
	    lodash.ary = ary;
	    lodash.assign = assign;
	    lodash.at = at;
	    lodash.before = before;
	    lodash.bind = bind;
	    lodash.bindAll = bindAll;
	    lodash.bindKey = bindKey;
	    lodash.callback = callback;
	    lodash.chain = chain;
	    lodash.chunk = chunk;
	    lodash.compact = compact;
	    lodash.constant = constant;
	    lodash.countBy = countBy;
	    lodash.create = create;
	    lodash.curry = curry;
	    lodash.curryRight = curryRight;
	    lodash.debounce = debounce;
	    lodash.defaults = defaults;
	    lodash.defaultsDeep = defaultsDeep;
	    lodash.defer = defer;
	    lodash.delay = delay;
	    lodash.difference = difference;
	    lodash.drop = drop;
	    lodash.dropRight = dropRight;
	    lodash.dropRightWhile = dropRightWhile;
	    lodash.dropWhile = dropWhile;
	    lodash.fill = fill;
	    lodash.filter = filter;
	    lodash.flatten = flatten;
	    lodash.flattenDeep = flattenDeep;
	    lodash.flow = flow;
	    lodash.flowRight = flowRight;
	    lodash.forEach = forEach;
	    lodash.forEachRight = forEachRight;
	    lodash.forIn = forIn;
	    lodash.forInRight = forInRight;
	    lodash.forOwn = forOwn;
	    lodash.forOwnRight = forOwnRight;
	    lodash.functions = functions;
	    lodash.groupBy = groupBy;
	    lodash.indexBy = indexBy;
	    lodash.initial = initial;
	    lodash.intersection = intersection;
	    lodash.invert = invert;
	    lodash.invoke = invoke;
	    lodash.keys = keys;
	    lodash.keysIn = keysIn;
	    lodash.map = map;
	    lodash.mapKeys = mapKeys;
	    lodash.mapValues = mapValues;
	    lodash.matches = matches;
	    lodash.matchesProperty = matchesProperty;
	    lodash.memoize = memoize;
	    lodash.merge = merge;
	    lodash.method = method;
	    lodash.methodOf = methodOf;
	    lodash.mixin = mixin;
	    lodash.modArgs = modArgs;
	    lodash.negate = negate;
	    lodash.omit = omit;
	    lodash.once = once;
	    lodash.pairs = pairs;
	    lodash.partial = partial;
	    lodash.partialRight = partialRight;
	    lodash.partition = partition;
	    lodash.pick = pick;
	    lodash.pluck = pluck;
	    lodash.property = property;
	    lodash.propertyOf = propertyOf;
	    lodash.pull = pull;
	    lodash.pullAt = pullAt;
	    lodash.range = range;
	    lodash.rearg = rearg;
	    lodash.reject = reject;
	    lodash.remove = remove;
	    lodash.rest = rest;
	    lodash.restParam = restParam;
	    lodash.set = set;
	    lodash.shuffle = shuffle;
	    lodash.slice = slice;
	    lodash.sortBy = sortBy;
	    lodash.sortByAll = sortByAll;
	    lodash.sortByOrder = sortByOrder;
	    lodash.spread = spread;
	    lodash.take = take;
	    lodash.takeRight = takeRight;
	    lodash.takeRightWhile = takeRightWhile;
	    lodash.takeWhile = takeWhile;
	    lodash.tap = tap;
	    lodash.throttle = throttle;
	    lodash.thru = thru;
	    lodash.times = times;
	    lodash.toArray = toArray;
	    lodash.toPlainObject = toPlainObject;
	    lodash.transform = transform;
	    lodash.union = union;
	    lodash.uniq = uniq;
	    lodash.unzip = unzip;
	    lodash.unzipWith = unzipWith;
	    lodash.values = values;
	    lodash.valuesIn = valuesIn;
	    lodash.where = where;
	    lodash.without = without;
	    lodash.wrap = wrap;
	    lodash.xor = xor;
	    lodash.zip = zip;
	    lodash.zipObject = zipObject;
	    lodash.zipWith = zipWith;

	    // Add aliases.
	    lodash.backflow = flowRight;
	    lodash.collect = map;
	    lodash.compose = flowRight;
	    lodash.each = forEach;
	    lodash.eachRight = forEachRight;
	    lodash.extend = assign;
	    lodash.iteratee = callback;
	    lodash.methods = functions;
	    lodash.object = zipObject;
	    lodash.select = filter;
	    lodash.tail = rest;
	    lodash.unique = uniq;

	    // Add functions to `lodash.prototype`.
	    mixin(lodash, lodash);

	    /*------------------------------------------------------------------------*/

	    // Add functions that return unwrapped values when chaining.
	    lodash.add = add;
	    lodash.attempt = attempt;
	    lodash.camelCase = camelCase;
	    lodash.capitalize = capitalize;
	    lodash.ceil = ceil;
	    lodash.clone = clone;
	    lodash.cloneDeep = cloneDeep;
	    lodash.deburr = deburr;
	    lodash.endsWith = endsWith;
	    lodash.escape = escape;
	    lodash.escapeRegExp = escapeRegExp;
	    lodash.every = every;
	    lodash.find = find;
	    lodash.findIndex = findIndex;
	    lodash.findKey = findKey;
	    lodash.findLast = findLast;
	    lodash.findLastIndex = findLastIndex;
	    lodash.findLastKey = findLastKey;
	    lodash.findWhere = findWhere;
	    lodash.first = first;
	    lodash.floor = floor;
	    lodash.get = get;
	    lodash.gt = gt;
	    lodash.gte = gte;
	    lodash.has = has;
	    lodash.identity = identity;
	    lodash.includes = includes;
	    lodash.indexOf = indexOf;
	    lodash.inRange = inRange;
	    lodash.isArguments = isArguments;
	    lodash.isArray = isArray;
	    lodash.isBoolean = isBoolean;
	    lodash.isDate = isDate;
	    lodash.isElement = isElement;
	    lodash.isEmpty = isEmpty;
	    lodash.isEqual = isEqual;
	    lodash.isError = isError;
	    lodash.isFinite = isFinite;
	    lodash.isFunction = isFunction;
	    lodash.isMatch = isMatch;
	    lodash.isNaN = isNaN;
	    lodash.isNative = isNative;
	    lodash.isNull = isNull;
	    lodash.isNumber = isNumber;
	    lodash.isObject = isObject;
	    lodash.isPlainObject = isPlainObject;
	    lodash.isRegExp = isRegExp;
	    lodash.isString = isString;
	    lodash.isTypedArray = isTypedArray;
	    lodash.isUndefined = isUndefined;
	    lodash.kebabCase = kebabCase;
	    lodash.last = last;
	    lodash.lastIndexOf = lastIndexOf;
	    lodash.lt = lt;
	    lodash.lte = lte;
	    lodash.max = max;
	    lodash.min = min;
	    lodash.noConflict = noConflict;
	    lodash.noop = noop;
	    lodash.now = now;
	    lodash.pad = pad;
	    lodash.padLeft = padLeft;
	    lodash.padRight = padRight;
	    lodash.parseInt = parseInt;
	    lodash.random = random;
	    lodash.reduce = reduce;
	    lodash.reduceRight = reduceRight;
	    lodash.repeat = repeat;
	    lodash.result = result;
	    lodash.round = round;
	    lodash.runInContext = runInContext;
	    lodash.size = size;
	    lodash.snakeCase = snakeCase;
	    lodash.some = some;
	    lodash.sortedIndex = sortedIndex;
	    lodash.sortedLastIndex = sortedLastIndex;
	    lodash.startCase = startCase;
	    lodash.startsWith = startsWith;
	    lodash.sum = sum;
	    lodash.template = template;
	    lodash.trim = trim;
	    lodash.trimLeft = trimLeft;
	    lodash.trimRight = trimRight;
	    lodash.trunc = trunc;
	    lodash.unescape = unescape;
	    lodash.uniqueId = uniqueId;
	    lodash.words = words;

	    // Add aliases.
	    lodash.all = every;
	    lodash.any = some;
	    lodash.contains = includes;
	    lodash.eq = isEqual;
	    lodash.detect = find;
	    lodash.foldl = reduce;
	    lodash.foldr = reduceRight;
	    lodash.head = first;
	    lodash.include = includes;
	    lodash.inject = reduce;

	    mixin(lodash, (function() {
	      var source = {};
	      baseForOwn(lodash, function(func, methodName) {
	        if (!lodash.prototype[methodName]) {
	          source[methodName] = func;
	        }
	      });
	      return source;
	    }()), false);

	    /*------------------------------------------------------------------------*/

	    // Add functions capable of returning wrapped and unwrapped values when chaining.
	    lodash.sample = sample;

	    lodash.prototype.sample = function(n) {
	      if (!this.__chain__ && n == null) {
	        return sample(this.value());
	      }
	      return this.thru(function(value) {
	        return sample(value, n);
	      });
	    };

	    /*------------------------------------------------------------------------*/

	    /**
	     * The semantic version number.
	     *
	     * @static
	     * @memberOf _
	     * @type string
	     */
	    lodash.VERSION = VERSION;

	    // Assign default placeholders.
	    arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function(methodName) {
	      lodash[methodName].placeholder = lodash;
	    });

	    // Add `LazyWrapper` methods for `_.drop` and `_.take` variants.
	    arrayEach(['drop', 'take'], function(methodName, index) {
	      LazyWrapper.prototype[methodName] = function(n) {
	        var filtered = this.__filtered__;
	        if (filtered && !index) {
	          return new LazyWrapper(this);
	        }
	        n = n == null ? 1 : nativeMax(nativeFloor(n) || 0, 0);

	        var result = this.clone();
	        if (filtered) {
	          result.__takeCount__ = nativeMin(result.__takeCount__, n);
	        } else {
	          result.__views__.push({ 'size': n, 'type': methodName + (result.__dir__ < 0 ? 'Right' : '') });
	        }
	        return result;
	      };

	      LazyWrapper.prototype[methodName + 'Right'] = function(n) {
	        return this.reverse()[methodName](n).reverse();
	      };
	    });

	    // Add `LazyWrapper` methods that accept an `iteratee` value.
	    arrayEach(['filter', 'map', 'takeWhile'], function(methodName, index) {
	      var type = index + 1,
	          isFilter = type != LAZY_MAP_FLAG;

	      LazyWrapper.prototype[methodName] = function(iteratee, thisArg) {
	        var result = this.clone();
	        result.__iteratees__.push({ 'iteratee': getCallback(iteratee, thisArg, 1), 'type': type });
	        result.__filtered__ = result.__filtered__ || isFilter;
	        return result;
	      };
	    });

	    // Add `LazyWrapper` methods for `_.first` and `_.last`.
	    arrayEach(['first', 'last'], function(methodName, index) {
	      var takeName = 'take' + (index ? 'Right' : '');

	      LazyWrapper.prototype[methodName] = function() {
	        return this[takeName](1).value()[0];
	      };
	    });

	    // Add `LazyWrapper` methods for `_.initial` and `_.rest`.
	    arrayEach(['initial', 'rest'], function(methodName, index) {
	      var dropName = 'drop' + (index ? '' : 'Right');

	      LazyWrapper.prototype[methodName] = function() {
	        return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
	      };
	    });

	    // Add `LazyWrapper` methods for `_.pluck` and `_.where`.
	    arrayEach(['pluck', 'where'], function(methodName, index) {
	      var operationName = index ? 'filter' : 'map',
	          createCallback = index ? baseMatches : property;

	      LazyWrapper.prototype[methodName] = function(value) {
	        return this[operationName](createCallback(value));
	      };
	    });

	    LazyWrapper.prototype.compact = function() {
	      return this.filter(identity);
	    };

	    LazyWrapper.prototype.reject = function(predicate, thisArg) {
	      predicate = getCallback(predicate, thisArg, 1);
	      return this.filter(function(value) {
	        return !predicate(value);
	      });
	    };

	    LazyWrapper.prototype.slice = function(start, end) {
	      start = start == null ? 0 : (+start || 0);

	      var result = this;
	      if (result.__filtered__ && (start > 0 || end < 0)) {
	        return new LazyWrapper(result);
	      }
	      if (start < 0) {
	        result = result.takeRight(-start);
	      } else if (start) {
	        result = result.drop(start);
	      }
	      if (end !== undefined) {
	        end = (+end || 0);
	        result = end < 0 ? result.dropRight(-end) : result.take(end - start);
	      }
	      return result;
	    };

	    LazyWrapper.prototype.takeRightWhile = function(predicate, thisArg) {
	      return this.reverse().takeWhile(predicate, thisArg).reverse();
	    };

	    LazyWrapper.prototype.toArray = function() {
	      return this.take(POSITIVE_INFINITY);
	    };

	    // Add `LazyWrapper` methods to `lodash.prototype`.
	    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
	      var checkIteratee = /^(?:filter|map|reject)|While$/.test(methodName),
	          retUnwrapped = /^(?:first|last)$/.test(methodName),
	          lodashFunc = lodash[retUnwrapped ? ('take' + (methodName == 'last' ? 'Right' : '')) : methodName];

	      if (!lodashFunc) {
	        return;
	      }
	      lodash.prototype[methodName] = function() {
	        var args = retUnwrapped ? [1] : arguments,
	            chainAll = this.__chain__,
	            value = this.__wrapped__,
	            isHybrid = !!this.__actions__.length,
	            isLazy = value instanceof LazyWrapper,
	            iteratee = args[0],
	            useLazy = isLazy || isArray(value);

	        if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {
	          // Avoid lazy use if the iteratee has a "length" value other than `1`.
	          isLazy = useLazy = false;
	        }
	        var interceptor = function(value) {
	          return (retUnwrapped && chainAll)
	            ? lodashFunc(value, 1)[0]
	            : lodashFunc.apply(undefined, arrayPush([value], args));
	        };

	        var action = { 'func': thru, 'args': [interceptor], 'thisArg': undefined },
	            onlyLazy = isLazy && !isHybrid;

	        if (retUnwrapped && !chainAll) {
	          if (onlyLazy) {
	            value = value.clone();
	            value.__actions__.push(action);
	            return func.call(value);
	          }
	          return lodashFunc.call(undefined, this.value())[0];
	        }
	        if (!retUnwrapped && useLazy) {
	          value = onlyLazy ? value : new LazyWrapper(this);
	          var result = func.apply(value, args);
	          result.__actions__.push(action);
	          return new LodashWrapper(result, chainAll);
	        }
	        return this.thru(interceptor);
	      };
	    });

	    // Add `Array` and `String` methods to `lodash.prototype`.
	    arrayEach(['join', 'pop', 'push', 'replace', 'shift', 'sort', 'splice', 'split', 'unshift'], function(methodName) {
	      var func = (/^(?:replace|split)$/.test(methodName) ? stringProto : arrayProto)[methodName],
	          chainName = /^(?:push|sort|unshift)$/.test(methodName) ? 'tap' : 'thru',
	          retUnwrapped = /^(?:join|pop|replace|shift)$/.test(methodName);

	      lodash.prototype[methodName] = function() {
	        var args = arguments;
	        if (retUnwrapped && !this.__chain__) {
	          return func.apply(this.value(), args);
	        }
	        return this[chainName](function(value) {
	          return func.apply(value, args);
	        });
	      };
	    });

	    // Map minified function names to their real names.
	    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
	      var lodashFunc = lodash[methodName];
	      if (lodashFunc) {
	        var key = lodashFunc.name,
	            names = realNames[key] || (realNames[key] = []);

	        names.push({ 'name': methodName, 'func': lodashFunc });
	      }
	    });

	    realNames[createHybridWrapper(undefined, BIND_KEY_FLAG).name] = [{ 'name': 'wrapper', 'func': undefined }];

	    // Add functions to the lazy wrapper.
	    LazyWrapper.prototype.clone = lazyClone;
	    LazyWrapper.prototype.reverse = lazyReverse;
	    LazyWrapper.prototype.value = lazyValue;

	    // Add chaining functions to the `lodash` wrapper.
	    lodash.prototype.chain = wrapperChain;
	    lodash.prototype.commit = wrapperCommit;
	    lodash.prototype.concat = wrapperConcat;
	    lodash.prototype.plant = wrapperPlant;
	    lodash.prototype.reverse = wrapperReverse;
	    lodash.prototype.toString = wrapperToString;
	    lodash.prototype.run = lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;

	    // Add function aliases to the `lodash` wrapper.
	    lodash.prototype.collect = lodash.prototype.map;
	    lodash.prototype.head = lodash.prototype.first;
	    lodash.prototype.select = lodash.prototype.filter;
	    lodash.prototype.tail = lodash.prototype.rest;

	    return lodash;
	  }

	  /*--------------------------------------------------------------------------*/

	  // Export lodash.
	  var _ = runInContext();

	  // Some AMD build optimizers like r.js check for condition patterns like the following:
	  if (true) {
	    // Expose lodash to the global object when an AMD loader is present to avoid
	    // errors in cases where lodash is loaded by a script tag and not intended
	    // as an AMD module. See http://requirejs.org/docs/errors.html#mismatch for
	    // more details.
	    root._ = _;

	    // Define as an anonymous module so, through path mapping, it can be
	    // referenced as the "underscore" module.
	    !(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
	      return _;
	    }.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	  }
	  // Check for `exports` after `define` in case a build optimizer adds an `exports` object.
	  else if (freeExports && freeModule) {
	    // Export for Node.js or RingoJS.
	    if (moduleExports) {
	      (freeModule.exports = _)._ = _;
	    }
	    // Export for Rhino with CommonJS support.
	    else {
	      freeExports._ = _;
	    }
	  }
	  else {
	    // Export for a browser or Rhino.
	    root._ = _;
	  }
	}.call(this));
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(65)(module), (function() { return this; }())))

/***/ },
/* 43 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {/*!
	 * The buffer module from node.js, for the browser.
	 *
	 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
	 * @license  MIT
	 */

	var base64 = __webpack_require__(73)
	var ieee754 = __webpack_require__(66)
	var isArray = __webpack_require__(67)

	exports.Buffer = Buffer
	exports.SlowBuffer = SlowBuffer
	exports.INSPECT_MAX_BYTES = 50
	Buffer.poolSize = 8192 // not used by this implementation

	var rootParent = {}

	/**
	 * If `Buffer.TYPED_ARRAY_SUPPORT`:
	 *   === true    Use Uint8Array implementation (fastest)
	 *   === false   Use Object implementation (most compatible, even IE6)
	 *
	 * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
	 * Opera 11.6+, iOS 4.2+.
	 *
	 * Note:
	 *
	 * - Implementation must support adding new properties to `Uint8Array` instances.
	 *   Firefox 4-29 lacked support, fixed in Firefox 30+.
	 *   See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
	 *
	 *  - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
	 *
	 *  - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
	 *    incorrect length in some situations.
	 *
	 * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they will
	 * get the Object implementation, which is slower but will work correctly.
	 */
	Buffer.TYPED_ARRAY_SUPPORT = (function () {
	  function Foo () {}
	  try {
	    var buf = new ArrayBuffer(0)
	    var arr = new Uint8Array(buf)
	    arr.foo = function () { return 42 }
	    arr.constructor = Foo
	    return arr.foo() === 42 && // typed array instances can be augmented
	        arr.constructor === Foo && // constructor can be set
	        typeof arr.subarray === 'function' && // chrome 9-10 lack `subarray`
	        new Uint8Array(1).subarray(1, 1).byteLength === 0 // ie10 has broken `subarray`
	  } catch (e) {
	    return false
	  }
	})()

	function kMaxLength () {
	  return Buffer.TYPED_ARRAY_SUPPORT
	    ? 0x7fffffff
	    : 0x3fffffff
	}

	/**
	 * Class: Buffer
	 * =============
	 *
	 * The Buffer constructor returns instances of `Uint8Array` that are augmented
	 * with function properties for all the node `Buffer` API functions. We use
	 * `Uint8Array` so that square bracket notation works as expected -- it returns
	 * a single octet.
	 *
	 * By augmenting the instances, we can avoid modifying the `Uint8Array`
	 * prototype.
	 */
	function Buffer (arg) {
	  if (!(this instanceof Buffer)) {
	    // Avoid going through an ArgumentsAdaptorTrampoline in the common case.
	    if (arguments.length > 1) return new Buffer(arg, arguments[1])
	    return new Buffer(arg)
	  }

	  this.length = 0
	  this.parent = undefined

	  // Common case.
	  if (typeof arg === 'number') {
	    return fromNumber(this, arg)
	  }

	  // Slightly less common case.
	  if (typeof arg === 'string') {
	    return fromString(this, arg, arguments.length > 1 ? arguments[1] : 'utf8')
	  }

	  // Unusual.
	  return fromObject(this, arg)
	}

	function fromNumber (that, length) {
	  that = allocate(that, length < 0 ? 0 : checked(length) | 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < length; i++) {
	      that[i] = 0
	    }
	  }
	  return that
	}

	function fromString (that, string, encoding) {
	  if (typeof encoding !== 'string' || encoding === '') encoding = 'utf8'

	  // Assumption: byteLength() return value is always < kMaxLength.
	  var length = byteLength(string, encoding) | 0
	  that = allocate(that, length)

	  that.write(string, encoding)
	  return that
	}

	function fromObject (that, object) {
	  if (Buffer.isBuffer(object)) return fromBuffer(that, object)

	  if (isArray(object)) return fromArray(that, object)

	  if (object == null) {
	    throw new TypeError('must start with number, buffer, array or string')
	  }

	  if (typeof ArrayBuffer !== 'undefined' && object.buffer instanceof ArrayBuffer) {
	    return fromTypedArray(that, object)
	  }

	  if (object.length) return fromArrayLike(that, object)

	  return fromJsonObject(that, object)
	}

	function fromBuffer (that, buffer) {
	  var length = checked(buffer.length) | 0
	  that = allocate(that, length)
	  buffer.copy(that, 0, 0, length)
	  return that
	}

	function fromArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	// Duplicate of fromArray() to keep fromArray() monomorphic.
	function fromTypedArray (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  // Truncating the elements is probably not what people expect from typed
	  // arrays with BYTES_PER_ELEMENT > 1 but it's compatible with the behavior
	  // of the old Buffer constructor.
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	function fromArrayLike (that, array) {
	  var length = checked(array.length) | 0
	  that = allocate(that, length)
	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	// Deserialize { type: 'Buffer', data: [1,2,3,...] } into a Buffer object.
	// Returns a zero-length buffer for inputs that don't conform to the spec.
	function fromJsonObject (that, object) {
	  var array
	  var length = 0

	  if (object.type === 'Buffer' && isArray(object.data)) {
	    array = object.data
	    length = checked(array.length) | 0
	  }
	  that = allocate(that, length)

	  for (var i = 0; i < length; i += 1) {
	    that[i] = array[i] & 255
	  }
	  return that
	}

	function allocate (that, length) {
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    // Return an augmented `Uint8Array` instance, for best performance
	    that = Buffer._augment(new Uint8Array(length))
	  } else {
	    // Fallback: Return an object instance of the Buffer class
	    that.length = length
	    that._isBuffer = true
	  }

	  var fromPool = length !== 0 && length <= Buffer.poolSize >>> 1
	  if (fromPool) that.parent = rootParent

	  return that
	}

	function checked (length) {
	  // Note: cannot use `length < kMaxLength` here because that fails when
	  // length is NaN (which is otherwise coerced to zero.)
	  if (length >= kMaxLength()) {
	    throw new RangeError('Attempt to allocate Buffer larger than maximum ' +
	                         'size: 0x' + kMaxLength().toString(16) + ' bytes')
	  }
	  return length | 0
	}

	function SlowBuffer (subject, encoding) {
	  if (!(this instanceof SlowBuffer)) return new SlowBuffer(subject, encoding)

	  var buf = new Buffer(subject, encoding)
	  delete buf.parent
	  return buf
	}

	Buffer.isBuffer = function isBuffer (b) {
	  return !!(b != null && b._isBuffer)
	}

	Buffer.compare = function compare (a, b) {
	  if (!Buffer.isBuffer(a) || !Buffer.isBuffer(b)) {
	    throw new TypeError('Arguments must be Buffers')
	  }

	  if (a === b) return 0

	  var x = a.length
	  var y = b.length

	  var i = 0
	  var len = Math.min(x, y)
	  while (i < len) {
	    if (a[i] !== b[i]) break

	    ++i
	  }

	  if (i !== len) {
	    x = a[i]
	    y = b[i]
	  }

	  if (x < y) return -1
	  if (y < x) return 1
	  return 0
	}

	Buffer.isEncoding = function isEncoding (encoding) {
	  switch (String(encoding).toLowerCase()) {
	    case 'hex':
	    case 'utf8':
	    case 'utf-8':
	    case 'ascii':
	    case 'binary':
	    case 'base64':
	    case 'raw':
	    case 'ucs2':
	    case 'ucs-2':
	    case 'utf16le':
	    case 'utf-16le':
	      return true
	    default:
	      return false
	  }
	}

	Buffer.concat = function concat (list, length) {
	  if (!isArray(list)) throw new TypeError('list argument must be an Array of Buffers.')

	  if (list.length === 0) {
	    return new Buffer(0)
	  } else if (list.length === 1) {
	    return list[0]
	  }

	  var i
	  if (length === undefined) {
	    length = 0
	    for (i = 0; i < list.length; i++) {
	      length += list[i].length
	    }
	  }

	  var buf = new Buffer(length)
	  var pos = 0
	  for (i = 0; i < list.length; i++) {
	    var item = list[i]
	    item.copy(buf, pos)
	    pos += item.length
	  }
	  return buf
	}

	function byteLength (string, encoding) {
	  if (typeof string !== 'string') string = '' + string

	  var len = string.length
	  if (len === 0) return 0

	  // Use a for loop to avoid recursion
	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'ascii':
	      case 'binary':
	      // Deprecated
	      case 'raw':
	      case 'raws':
	        return len
	      case 'utf8':
	      case 'utf-8':
	        return utf8ToBytes(string).length
	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return len * 2
	      case 'hex':
	        return len >>> 1
	      case 'base64':
	        return base64ToBytes(string).length
	      default:
	        if (loweredCase) return utf8ToBytes(string).length // assume utf8
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}
	Buffer.byteLength = byteLength

	// pre-set for values that may exist in the future
	Buffer.prototype.length = undefined
	Buffer.prototype.parent = undefined

	function slowToString (encoding, start, end) {
	  var loweredCase = false

	  start = start | 0
	  end = end === undefined || end === Infinity ? this.length : end | 0

	  if (!encoding) encoding = 'utf8'
	  if (start < 0) start = 0
	  if (end > this.length) end = this.length
	  if (end <= start) return ''

	  while (true) {
	    switch (encoding) {
	      case 'hex':
	        return hexSlice(this, start, end)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Slice(this, start, end)

	      case 'ascii':
	        return asciiSlice(this, start, end)

	      case 'binary':
	        return binarySlice(this, start, end)

	      case 'base64':
	        return base64Slice(this, start, end)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return utf16leSlice(this, start, end)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = (encoding + '').toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toString = function toString () {
	  var length = this.length | 0
	  if (length === 0) return ''
	  if (arguments.length === 0) return utf8Slice(this, 0, length)
	  return slowToString.apply(this, arguments)
	}

	Buffer.prototype.equals = function equals (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return true
	  return Buffer.compare(this, b) === 0
	}

	Buffer.prototype.inspect = function inspect () {
	  var str = ''
	  var max = exports.INSPECT_MAX_BYTES
	  if (this.length > 0) {
	    str = this.toString('hex', 0, max).match(/.{2}/g).join(' ')
	    if (this.length > max) str += ' ... '
	  }
	  return '<Buffer ' + str + '>'
	}

	Buffer.prototype.compare = function compare (b) {
	  if (!Buffer.isBuffer(b)) throw new TypeError('Argument must be a Buffer')
	  if (this === b) return 0
	  return Buffer.compare(this, b)
	}

	Buffer.prototype.indexOf = function indexOf (val, byteOffset) {
	  if (byteOffset > 0x7fffffff) byteOffset = 0x7fffffff
	  else if (byteOffset < -0x80000000) byteOffset = -0x80000000
	  byteOffset >>= 0

	  if (this.length === 0) return -1
	  if (byteOffset >= this.length) return -1

	  // Negative offsets start from the end of the buffer
	  if (byteOffset < 0) byteOffset = Math.max(this.length + byteOffset, 0)

	  if (typeof val === 'string') {
	    if (val.length === 0) return -1 // special case: looking for empty string always fails
	    return String.prototype.indexOf.call(this, val, byteOffset)
	  }
	  if (Buffer.isBuffer(val)) {
	    return arrayIndexOf(this, val, byteOffset)
	  }
	  if (typeof val === 'number') {
	    if (Buffer.TYPED_ARRAY_SUPPORT && Uint8Array.prototype.indexOf === 'function') {
	      return Uint8Array.prototype.indexOf.call(this, val, byteOffset)
	    }
	    return arrayIndexOf(this, [ val ], byteOffset)
	  }

	  function arrayIndexOf (arr, val, byteOffset) {
	    var foundIndex = -1
	    for (var i = 0; byteOffset + i < arr.length; i++) {
	      if (arr[byteOffset + i] === val[foundIndex === -1 ? 0 : i - foundIndex]) {
	        if (foundIndex === -1) foundIndex = i
	        if (i - foundIndex + 1 === val.length) return byteOffset + foundIndex
	      } else {
	        foundIndex = -1
	      }
	    }
	    return -1
	  }

	  throw new TypeError('val must be string, number or Buffer')
	}

	// `get` will be removed in Node 0.13+
	Buffer.prototype.get = function get (offset) {
	  console.log('.get() is deprecated. Access using array indexes instead.')
	  return this.readUInt8(offset)
	}

	// `set` will be removed in Node 0.13+
	Buffer.prototype.set = function set (v, offset) {
	  console.log('.set() is deprecated. Access using array indexes instead.')
	  return this.writeUInt8(v, offset)
	}

	function hexWrite (buf, string, offset, length) {
	  offset = Number(offset) || 0
	  var remaining = buf.length - offset
	  if (!length) {
	    length = remaining
	  } else {
	    length = Number(length)
	    if (length > remaining) {
	      length = remaining
	    }
	  }

	  // must be an even number of digits
	  var strLen = string.length
	  if (strLen % 2 !== 0) throw new Error('Invalid hex string')

	  if (length > strLen / 2) {
	    length = strLen / 2
	  }
	  for (var i = 0; i < length; i++) {
	    var parsed = parseInt(string.substr(i * 2, 2), 16)
	    if (isNaN(parsed)) throw new Error('Invalid hex string')
	    buf[offset + i] = parsed
	  }
	  return i
	}

	function utf8Write (buf, string, offset, length) {
	  return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length)
	}

	function asciiWrite (buf, string, offset, length) {
	  return blitBuffer(asciiToBytes(string), buf, offset, length)
	}

	function binaryWrite (buf, string, offset, length) {
	  return asciiWrite(buf, string, offset, length)
	}

	function base64Write (buf, string, offset, length) {
	  return blitBuffer(base64ToBytes(string), buf, offset, length)
	}

	function ucs2Write (buf, string, offset, length) {
	  return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length)
	}

	Buffer.prototype.write = function write (string, offset, length, encoding) {
	  // Buffer#write(string)
	  if (offset === undefined) {
	    encoding = 'utf8'
	    length = this.length
	    offset = 0
	  // Buffer#write(string, encoding)
	  } else if (length === undefined && typeof offset === 'string') {
	    encoding = offset
	    length = this.length
	    offset = 0
	  // Buffer#write(string, offset[, length][, encoding])
	  } else if (isFinite(offset)) {
	    offset = offset | 0
	    if (isFinite(length)) {
	      length = length | 0
	      if (encoding === undefined) encoding = 'utf8'
	    } else {
	      encoding = length
	      length = undefined
	    }
	  // legacy write(string, encoding, offset, length) - remove in v0.13
	  } else {
	    var swap = encoding
	    encoding = offset
	    offset = length | 0
	    length = swap
	  }

	  var remaining = this.length - offset
	  if (length === undefined || length > remaining) length = remaining

	  if ((string.length > 0 && (length < 0 || offset < 0)) || offset > this.length) {
	    throw new RangeError('attempt to write outside buffer bounds')
	  }

	  if (!encoding) encoding = 'utf8'

	  var loweredCase = false
	  for (;;) {
	    switch (encoding) {
	      case 'hex':
	        return hexWrite(this, string, offset, length)

	      case 'utf8':
	      case 'utf-8':
	        return utf8Write(this, string, offset, length)

	      case 'ascii':
	        return asciiWrite(this, string, offset, length)

	      case 'binary':
	        return binaryWrite(this, string, offset, length)

	      case 'base64':
	        // Warning: maxLength not taken into account in base64Write
	        return base64Write(this, string, offset, length)

	      case 'ucs2':
	      case 'ucs-2':
	      case 'utf16le':
	      case 'utf-16le':
	        return ucs2Write(this, string, offset, length)

	      default:
	        if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding)
	        encoding = ('' + encoding).toLowerCase()
	        loweredCase = true
	    }
	  }
	}

	Buffer.prototype.toJSON = function toJSON () {
	  return {
	    type: 'Buffer',
	    data: Array.prototype.slice.call(this._arr || this, 0)
	  }
	}

	function base64Slice (buf, start, end) {
	  if (start === 0 && end === buf.length) {
	    return base64.fromByteArray(buf)
	  } else {
	    return base64.fromByteArray(buf.slice(start, end))
	  }
	}

	function utf8Slice (buf, start, end) {
	  var res = ''
	  var tmp = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; i++) {
	    if (buf[i] <= 0x7F) {
	      res += decodeUtf8Char(tmp) + String.fromCharCode(buf[i])
	      tmp = ''
	    } else {
	      tmp += '%' + buf[i].toString(16)
	    }
	  }

	  return res + decodeUtf8Char(tmp)
	}

	function asciiSlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i] & 0x7F)
	  }
	  return ret
	}

	function binarySlice (buf, start, end) {
	  var ret = ''
	  end = Math.min(buf.length, end)

	  for (var i = start; i < end; i++) {
	    ret += String.fromCharCode(buf[i])
	  }
	  return ret
	}

	function hexSlice (buf, start, end) {
	  var len = buf.length

	  if (!start || start < 0) start = 0
	  if (!end || end < 0 || end > len) end = len

	  var out = ''
	  for (var i = start; i < end; i++) {
	    out += toHex(buf[i])
	  }
	  return out
	}

	function utf16leSlice (buf, start, end) {
	  var bytes = buf.slice(start, end)
	  var res = ''
	  for (var i = 0; i < bytes.length; i += 2) {
	    res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256)
	  }
	  return res
	}

	Buffer.prototype.slice = function slice (start, end) {
	  var len = this.length
	  start = ~~start
	  end = end === undefined ? len : ~~end

	  if (start < 0) {
	    start += len
	    if (start < 0) start = 0
	  } else if (start > len) {
	    start = len
	  }

	  if (end < 0) {
	    end += len
	    if (end < 0) end = 0
	  } else if (end > len) {
	    end = len
	  }

	  if (end < start) end = start

	  var newBuf
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    newBuf = Buffer._augment(this.subarray(start, end))
	  } else {
	    var sliceLen = end - start
	    newBuf = new Buffer(sliceLen, undefined)
	    for (var i = 0; i < sliceLen; i++) {
	      newBuf[i] = this[i + start]
	    }
	  }

	  if (newBuf.length) newBuf.parent = this.parent || this

	  return newBuf
	}

	/*
	 * Need to make sure that buffer isn't trying to write out of bounds.
	 */
	function checkOffset (offset, ext, length) {
	  if ((offset % 1) !== 0 || offset < 0) throw new RangeError('offset is not uint')
	  if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length')
	}

	Buffer.prototype.readUIntLE = function readUIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }

	  return val
	}

	Buffer.prototype.readUIntBE = function readUIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) {
	    checkOffset(offset, byteLength, this.length)
	  }

	  var val = this[offset + --byteLength]
	  var mul = 1
	  while (byteLength > 0 && (mul *= 0x100)) {
	    val += this[offset + --byteLength] * mul
	  }

	  return val
	}

	Buffer.prototype.readUInt8 = function readUInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  return this[offset]
	}

	Buffer.prototype.readUInt16LE = function readUInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return this[offset] | (this[offset + 1] << 8)
	}

	Buffer.prototype.readUInt16BE = function readUInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  return (this[offset] << 8) | this[offset + 1]
	}

	Buffer.prototype.readUInt32LE = function readUInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return ((this[offset]) |
	      (this[offset + 1] << 8) |
	      (this[offset + 2] << 16)) +
	      (this[offset + 3] * 0x1000000)
	}

	Buffer.prototype.readUInt32BE = function readUInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] * 0x1000000) +
	    ((this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    this[offset + 3])
	}

	Buffer.prototype.readIntLE = function readIntLE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var val = this[offset]
	  var mul = 1
	  var i = 0
	  while (++i < byteLength && (mul *= 0x100)) {
	    val += this[offset + i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readIntBE = function readIntBE (offset, byteLength, noAssert) {
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkOffset(offset, byteLength, this.length)

	  var i = byteLength
	  var mul = 1
	  var val = this[offset + --i]
	  while (i > 0 && (mul *= 0x100)) {
	    val += this[offset + --i] * mul
	  }
	  mul *= 0x80

	  if (val >= mul) val -= Math.pow(2, 8 * byteLength)

	  return val
	}

	Buffer.prototype.readInt8 = function readInt8 (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 1, this.length)
	  if (!(this[offset] & 0x80)) return (this[offset])
	  return ((0xff - this[offset] + 1) * -1)
	}

	Buffer.prototype.readInt16LE = function readInt16LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset] | (this[offset + 1] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt16BE = function readInt16BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 2, this.length)
	  var val = this[offset + 1] | (this[offset] << 8)
	  return (val & 0x8000) ? val | 0xFFFF0000 : val
	}

	Buffer.prototype.readInt32LE = function readInt32LE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset]) |
	    (this[offset + 1] << 8) |
	    (this[offset + 2] << 16) |
	    (this[offset + 3] << 24)
	}

	Buffer.prototype.readInt32BE = function readInt32BE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)

	  return (this[offset] << 24) |
	    (this[offset + 1] << 16) |
	    (this[offset + 2] << 8) |
	    (this[offset + 3])
	}

	Buffer.prototype.readFloatLE = function readFloatLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, true, 23, 4)
	}

	Buffer.prototype.readFloatBE = function readFloatBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 4, this.length)
	  return ieee754.read(this, offset, false, 23, 4)
	}

	Buffer.prototype.readDoubleLE = function readDoubleLE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, true, 52, 8)
	}

	Buffer.prototype.readDoubleBE = function readDoubleBE (offset, noAssert) {
	  if (!noAssert) checkOffset(offset, 8, this.length)
	  return ieee754.read(this, offset, false, 52, 8)
	}

	function checkInt (buf, value, offset, ext, max, min) {
	  if (!Buffer.isBuffer(buf)) throw new TypeError('buffer must be a Buffer instance')
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	}

	Buffer.prototype.writeUIntLE = function writeUIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

	  var mul = 1
	  var i = 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUIntBE = function writeUIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  byteLength = byteLength | 0
	  if (!noAssert) checkInt(this, value, offset, byteLength, Math.pow(2, 8 * byteLength), 0)

	  var i = byteLength - 1
	  var mul = 1
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = (value / mul) & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeUInt8 = function writeUInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  this[offset] = value
	  return offset + 1
	}

	function objectWriteUInt16 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; i++) {
	    buf[offset + i] = (value & (0xff << (8 * (littleEndian ? i : 1 - i)))) >>>
	      (littleEndian ? i : 1 - i) * 8
	  }
	}

	Buffer.prototype.writeUInt16LE = function writeUInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeUInt16BE = function writeUInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = value
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	function objectWriteUInt32 (buf, value, offset, littleEndian) {
	  if (value < 0) value = 0xffffffff + value + 1
	  for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; i++) {
	    buf[offset + i] = (value >>> (littleEndian ? i : 3 - i) * 8) & 0xff
	  }
	}

	Buffer.prototype.writeUInt32LE = function writeUInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset + 3] = (value >>> 24)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 1] = (value >>> 8)
	    this[offset] = value
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeUInt32BE = function writeUInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = value
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeIntLE = function writeIntLE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = 0
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset] = value & 0xFF
	  while (++i < byteLength && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeIntBE = function writeIntBE (value, offset, byteLength, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) {
	    var limit = Math.pow(2, 8 * byteLength - 1)

	    checkInt(this, value, offset, byteLength, limit - 1, -limit)
	  }

	  var i = byteLength - 1
	  var mul = 1
	  var sub = value < 0 ? 1 : 0
	  this[offset + i] = value & 0xFF
	  while (--i >= 0 && (mul *= 0x100)) {
	    this[offset + i] = ((value / mul) >> 0) - sub & 0xFF
	  }

	  return offset + byteLength
	}

	Buffer.prototype.writeInt8 = function writeInt8 (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80)
	  if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value)
	  if (value < 0) value = 0xff + value + 1
	  this[offset] = value
	  return offset + 1
	}

	Buffer.prototype.writeInt16LE = function writeInt16LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	  } else {
	    objectWriteUInt16(this, value, offset, true)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt16BE = function writeInt16BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 8)
	    this[offset + 1] = value
	  } else {
	    objectWriteUInt16(this, value, offset, false)
	  }
	  return offset + 2
	}

	Buffer.prototype.writeInt32LE = function writeInt32LE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = value
	    this[offset + 1] = (value >>> 8)
	    this[offset + 2] = (value >>> 16)
	    this[offset + 3] = (value >>> 24)
	  } else {
	    objectWriteUInt32(this, value, offset, true)
	  }
	  return offset + 4
	}

	Buffer.prototype.writeInt32BE = function writeInt32BE (value, offset, noAssert) {
	  value = +value
	  offset = offset | 0
	  if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000)
	  if (value < 0) value = 0xffffffff + value + 1
	  if (Buffer.TYPED_ARRAY_SUPPORT) {
	    this[offset] = (value >>> 24)
	    this[offset + 1] = (value >>> 16)
	    this[offset + 2] = (value >>> 8)
	    this[offset + 3] = value
	  } else {
	    objectWriteUInt32(this, value, offset, false)
	  }
	  return offset + 4
	}

	function checkIEEE754 (buf, value, offset, ext, max, min) {
	  if (value > max || value < min) throw new RangeError('value is out of bounds')
	  if (offset + ext > buf.length) throw new RangeError('index out of range')
	  if (offset < 0) throw new RangeError('index out of range')
	}

	function writeFloat (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 4, 3.4028234663852886e+38, -3.4028234663852886e+38)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 23, 4)
	  return offset + 4
	}

	Buffer.prototype.writeFloatLE = function writeFloatLE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeFloatBE = function writeFloatBE (value, offset, noAssert) {
	  return writeFloat(this, value, offset, false, noAssert)
	}

	function writeDouble (buf, value, offset, littleEndian, noAssert) {
	  if (!noAssert) {
	    checkIEEE754(buf, value, offset, 8, 1.7976931348623157E+308, -1.7976931348623157E+308)
	  }
	  ieee754.write(buf, value, offset, littleEndian, 52, 8)
	  return offset + 8
	}

	Buffer.prototype.writeDoubleLE = function writeDoubleLE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, true, noAssert)
	}

	Buffer.prototype.writeDoubleBE = function writeDoubleBE (value, offset, noAssert) {
	  return writeDouble(this, value, offset, false, noAssert)
	}

	// copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)
	Buffer.prototype.copy = function copy (target, targetStart, start, end) {
	  if (!start) start = 0
	  if (!end && end !== 0) end = this.length
	  if (targetStart >= target.length) targetStart = target.length
	  if (!targetStart) targetStart = 0
	  if (end > 0 && end < start) end = start

	  // Copy 0 bytes; we're done
	  if (end === start) return 0
	  if (target.length === 0 || this.length === 0) return 0

	  // Fatal error conditions
	  if (targetStart < 0) {
	    throw new RangeError('targetStart out of bounds')
	  }
	  if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds')
	  if (end < 0) throw new RangeError('sourceEnd out of bounds')

	  // Are we oob?
	  if (end > this.length) end = this.length
	  if (target.length - targetStart < end - start) {
	    end = target.length - targetStart + start
	  }

	  var len = end - start

	  if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
	    for (var i = 0; i < len; i++) {
	      target[i + targetStart] = this[i + start]
	    }
	  } else {
	    target._set(this.subarray(start, start + len), targetStart)
	  }

	  return len
	}

	// fill(value, start=0, end=buffer.length)
	Buffer.prototype.fill = function fill (value, start, end) {
	  if (!value) value = 0
	  if (!start) start = 0
	  if (!end) end = this.length

	  if (end < start) throw new RangeError('end < start')

	  // Fill 0 bytes; we're done
	  if (end === start) return
	  if (this.length === 0) return

	  if (start < 0 || start >= this.length) throw new RangeError('start out of bounds')
	  if (end < 0 || end > this.length) throw new RangeError('end out of bounds')

	  var i
	  if (typeof value === 'number') {
	    for (i = start; i < end; i++) {
	      this[i] = value
	    }
	  } else {
	    var bytes = utf8ToBytes(value.toString())
	    var len = bytes.length
	    for (i = start; i < end; i++) {
	      this[i] = bytes[i % len]
	    }
	  }

	  return this
	}

	/**
	 * Creates a new `ArrayBuffer` with the *copied* memory of the buffer instance.
	 * Added in Node 0.12. Only available in browsers that support ArrayBuffer.
	 */
	Buffer.prototype.toArrayBuffer = function toArrayBuffer () {
	  if (typeof Uint8Array !== 'undefined') {
	    if (Buffer.TYPED_ARRAY_SUPPORT) {
	      return (new Buffer(this)).buffer
	    } else {
	      var buf = new Uint8Array(this.length)
	      for (var i = 0, len = buf.length; i < len; i += 1) {
	        buf[i] = this[i]
	      }
	      return buf.buffer
	    }
	  } else {
	    throw new TypeError('Buffer.toArrayBuffer not supported in this browser')
	  }
	}

	// HELPER FUNCTIONS
	// ================

	var BP = Buffer.prototype

	/**
	 * Augment a Uint8Array *instance* (not the Uint8Array class!) with Buffer methods
	 */
	Buffer._augment = function _augment (arr) {
	  arr.constructor = Buffer
	  arr._isBuffer = true

	  // save reference to original Uint8Array set method before overwriting
	  arr._set = arr.set

	  // deprecated, will be removed in node 0.13+
	  arr.get = BP.get
	  arr.set = BP.set

	  arr.write = BP.write
	  arr.toString = BP.toString
	  arr.toLocaleString = BP.toString
	  arr.toJSON = BP.toJSON
	  arr.equals = BP.equals
	  arr.compare = BP.compare
	  arr.indexOf = BP.indexOf
	  arr.copy = BP.copy
	  arr.slice = BP.slice
	  arr.readUIntLE = BP.readUIntLE
	  arr.readUIntBE = BP.readUIntBE
	  arr.readUInt8 = BP.readUInt8
	  arr.readUInt16LE = BP.readUInt16LE
	  arr.readUInt16BE = BP.readUInt16BE
	  arr.readUInt32LE = BP.readUInt32LE
	  arr.readUInt32BE = BP.readUInt32BE
	  arr.readIntLE = BP.readIntLE
	  arr.readIntBE = BP.readIntBE
	  arr.readInt8 = BP.readInt8
	  arr.readInt16LE = BP.readInt16LE
	  arr.readInt16BE = BP.readInt16BE
	  arr.readInt32LE = BP.readInt32LE
	  arr.readInt32BE = BP.readInt32BE
	  arr.readFloatLE = BP.readFloatLE
	  arr.readFloatBE = BP.readFloatBE
	  arr.readDoubleLE = BP.readDoubleLE
	  arr.readDoubleBE = BP.readDoubleBE
	  arr.writeUInt8 = BP.writeUInt8
	  arr.writeUIntLE = BP.writeUIntLE
	  arr.writeUIntBE = BP.writeUIntBE
	  arr.writeUInt16LE = BP.writeUInt16LE
	  arr.writeUInt16BE = BP.writeUInt16BE
	  arr.writeUInt32LE = BP.writeUInt32LE
	  arr.writeUInt32BE = BP.writeUInt32BE
	  arr.writeIntLE = BP.writeIntLE
	  arr.writeIntBE = BP.writeIntBE
	  arr.writeInt8 = BP.writeInt8
	  arr.writeInt16LE = BP.writeInt16LE
	  arr.writeInt16BE = BP.writeInt16BE
	  arr.writeInt32LE = BP.writeInt32LE
	  arr.writeInt32BE = BP.writeInt32BE
	  arr.writeFloatLE = BP.writeFloatLE
	  arr.writeFloatBE = BP.writeFloatBE
	  arr.writeDoubleLE = BP.writeDoubleLE
	  arr.writeDoubleBE = BP.writeDoubleBE
	  arr.fill = BP.fill
	  arr.inspect = BP.inspect
	  arr.toArrayBuffer = BP.toArrayBuffer

	  return arr
	}

	var INVALID_BASE64_RE = /[^+\/0-9A-z\-]/g

	function base64clean (str) {
	  // Node strips out invalid characters like \n and \t from the string, base64-js does not
	  str = stringtrim(str).replace(INVALID_BASE64_RE, '')
	  // Node converts strings with length < 2 to ''
	  if (str.length < 2) return ''
	  // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not
	  while (str.length % 4 !== 0) {
	    str = str + '='
	  }
	  return str
	}

	function stringtrim (str) {
	  if (str.trim) return str.trim()
	  return str.replace(/^\s+|\s+$/g, '')
	}

	function toHex (n) {
	  if (n < 16) return '0' + n.toString(16)
	  return n.toString(16)
	}

	function utf8ToBytes (string, units) {
	  units = units || Infinity
	  var codePoint
	  var length = string.length
	  var leadSurrogate = null
	  var bytes = []
	  var i = 0

	  for (; i < length; i++) {
	    codePoint = string.charCodeAt(i)

	    // is surrogate component
	    if (codePoint > 0xD7FF && codePoint < 0xE000) {
	      // last char was a lead
	      if (leadSurrogate) {
	        // 2 leads in a row
	        if (codePoint < 0xDC00) {
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          leadSurrogate = codePoint
	          continue
	        } else {
	          // valid surrogate pair
	          codePoint = leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00 | 0x10000
	          leadSurrogate = null
	        }
	      } else {
	        // no lead yet

	        if (codePoint > 0xDBFF) {
	          // unexpected trail
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else if (i + 1 === length) {
	          // unpaired lead
	          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	          continue
	        } else {
	          // valid lead
	          leadSurrogate = codePoint
	          continue
	        }
	      }
	    } else if (leadSurrogate) {
	      // valid bmp char, but last char was a lead
	      if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD)
	      leadSurrogate = null
	    }

	    // encode utf8
	    if (codePoint < 0x80) {
	      if ((units -= 1) < 0) break
	      bytes.push(codePoint)
	    } else if (codePoint < 0x800) {
	      if ((units -= 2) < 0) break
	      bytes.push(
	        codePoint >> 0x6 | 0xC0,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x10000) {
	      if ((units -= 3) < 0) break
	      bytes.push(
	        codePoint >> 0xC | 0xE0,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else if (codePoint < 0x200000) {
	      if ((units -= 4) < 0) break
	      bytes.push(
	        codePoint >> 0x12 | 0xF0,
	        codePoint >> 0xC & 0x3F | 0x80,
	        codePoint >> 0x6 & 0x3F | 0x80,
	        codePoint & 0x3F | 0x80
	      )
	    } else {
	      throw new Error('Invalid code point')
	    }
	  }

	  return bytes
	}

	function asciiToBytes (str) {
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    // Node's code seems to be doing this and not & 0x7F..
	    byteArray.push(str.charCodeAt(i) & 0xFF)
	  }
	  return byteArray
	}

	function utf16leToBytes (str, units) {
	  var c, hi, lo
	  var byteArray = []
	  for (var i = 0; i < str.length; i++) {
	    if ((units -= 2) < 0) break

	    c = str.charCodeAt(i)
	    hi = c >> 8
	    lo = c % 256
	    byteArray.push(lo)
	    byteArray.push(hi)
	  }

	  return byteArray
	}

	function base64ToBytes (str) {
	  return base64.toByteArray(base64clean(str))
	}

	function blitBuffer (src, dst, offset, length) {
	  for (var i = 0; i < length; i++) {
	    if ((i + offset >= dst.length) || (i >= src.length)) break
	    dst[i + offset] = src[i]
	  }
	  return i
	}

	function decodeUtf8Char (str) {
	  try {
	    return decodeURIComponent(str)
	  } catch (err) {
	    return String.fromCharCode(0xFFFD) // UTF 8 invalid char
	  }
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 44 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	var punycode = __webpack_require__(64);

	exports.parse = urlParse;
	exports.resolve = urlResolve;
	exports.resolveObject = urlResolveObject;
	exports.format = urlFormat;

	exports.Url = Url;

	function Url() {
	  this.protocol = null;
	  this.slashes = null;
	  this.auth = null;
	  this.host = null;
	  this.port = null;
	  this.hostname = null;
	  this.hash = null;
	  this.search = null;
	  this.query = null;
	  this.pathname = null;
	  this.path = null;
	  this.href = null;
	}

	// Reference: RFC 3986, RFC 1808, RFC 2396

	// define these here so at least they only have to be
	// compiled once on the first module load.
	var protocolPattern = /^([a-z0-9.+-]+:)/i,
	    portPattern = /:[0-9]*$/,

	    // RFC 2396: characters reserved for delimiting URLs.
	    // We actually just auto-escape these.
	    delims = ['<', '>', '"', '`', ' ', '\r', '\n', '\t'],

	    // RFC 2396: characters not allowed for various reasons.
	    unwise = ['{', '}', '|', '\\', '^', '`'].concat(delims),

	    // Allowed by RFCs, but cause of XSS attacks.  Always escape these.
	    autoEscape = ['\''].concat(unwise),
	    // Characters that are never ever allowed in a hostname.
	    // Note that any invalid chars are also handled, but these
	    // are the ones that are *expected* to be seen, so we fast-path
	    // them.
	    nonHostChars = ['%', '/', '?', ';', '#'].concat(autoEscape),
	    hostEndingChars = ['/', '?', '#'],
	    hostnameMaxLen = 255,
	    hostnamePartPattern = /^[a-z0-9A-Z_-]{0,63}$/,
	    hostnamePartStart = /^([a-z0-9A-Z_-]{0,63})(.*)$/,
	    // protocols that can allow "unsafe" and "unwise" chars.
	    unsafeProtocol = {
	      'javascript': true,
	      'javascript:': true
	    },
	    // protocols that never have a hostname.
	    hostlessProtocol = {
	      'javascript': true,
	      'javascript:': true
	    },
	    // protocols that always contain a // bit.
	    slashedProtocol = {
	      'http': true,
	      'https': true,
	      'ftp': true,
	      'gopher': true,
	      'file': true,
	      'http:': true,
	      'https:': true,
	      'ftp:': true,
	      'gopher:': true,
	      'file:': true
	    },
	    querystring = __webpack_require__(68);

	function urlParse(url, parseQueryString, slashesDenoteHost) {
	  if (url && isObject(url) && url instanceof Url) return url;

	  var u = new Url;
	  u.parse(url, parseQueryString, slashesDenoteHost);
	  return u;
	}

	Url.prototype.parse = function(url, parseQueryString, slashesDenoteHost) {
	  if (!isString(url)) {
	    throw new TypeError("Parameter 'url' must be a string, not " + typeof url);
	  }

	  var rest = url;

	  // trim before proceeding.
	  // This is to support parse stuff like "  http://foo.com  \n"
	  rest = rest.trim();

	  var proto = protocolPattern.exec(rest);
	  if (proto) {
	    proto = proto[0];
	    var lowerProto = proto.toLowerCase();
	    this.protocol = lowerProto;
	    rest = rest.substr(proto.length);
	  }

	  // figure out if it's got a host
	  // user@server is *always* interpreted as a hostname, and url
	  // resolution will treat //foo/bar as host=foo,path=bar because that's
	  // how the browser resolves relative URLs.
	  if (slashesDenoteHost || proto || rest.match(/^\/\/[^@\/]+@[^@\/]+/)) {
	    var slashes = rest.substr(0, 2) === '//';
	    if (slashes && !(proto && hostlessProtocol[proto])) {
	      rest = rest.substr(2);
	      this.slashes = true;
	    }
	  }

	  if (!hostlessProtocol[proto] &&
	      (slashes || (proto && !slashedProtocol[proto]))) {

	    // there's a hostname.
	    // the first instance of /, ?, ;, or # ends the host.
	    //
	    // If there is an @ in the hostname, then non-host chars *are* allowed
	    // to the left of the last @ sign, unless some host-ending character
	    // comes *before* the @-sign.
	    // URLs are obnoxious.
	    //
	    // ex:
	    // http://a@b@c/ => user:a@b host:c
	    // http://a@b?@c => user:a host:c path:/?@c

	    // v0.12 TODO(isaacs): This is not quite how Chrome does things.
	    // Review our test case against browsers more comprehensively.

	    // find the first instance of any hostEndingChars
	    var hostEnd = -1;
	    for (var i = 0; i < hostEndingChars.length; i++) {
	      var hec = rest.indexOf(hostEndingChars[i]);
	      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
	        hostEnd = hec;
	    }

	    // at this point, either we have an explicit point where the
	    // auth portion cannot go past, or the last @ char is the decider.
	    var auth, atSign;
	    if (hostEnd === -1) {
	      // atSign can be anywhere.
	      atSign = rest.lastIndexOf('@');
	    } else {
	      // atSign must be in auth portion.
	      // http://a@b/c@d => host:b auth:a path:/c@d
	      atSign = rest.lastIndexOf('@', hostEnd);
	    }

	    // Now we have a portion which is definitely the auth.
	    // Pull that off.
	    if (atSign !== -1) {
	      auth = rest.slice(0, atSign);
	      rest = rest.slice(atSign + 1);
	      this.auth = decodeURIComponent(auth);
	    }

	    // the host is the remaining to the left of the first non-host char
	    hostEnd = -1;
	    for (var i = 0; i < nonHostChars.length; i++) {
	      var hec = rest.indexOf(nonHostChars[i]);
	      if (hec !== -1 && (hostEnd === -1 || hec < hostEnd))
	        hostEnd = hec;
	    }
	    // if we still have not hit it, then the entire thing is a host.
	    if (hostEnd === -1)
	      hostEnd = rest.length;

	    this.host = rest.slice(0, hostEnd);
	    rest = rest.slice(hostEnd);

	    // pull out port.
	    this.parseHost();

	    // we've indicated that there is a hostname,
	    // so even if it's empty, it has to be present.
	    this.hostname = this.hostname || '';

	    // if hostname begins with [ and ends with ]
	    // assume that it's an IPv6 address.
	    var ipv6Hostname = this.hostname[0] === '[' &&
	        this.hostname[this.hostname.length - 1] === ']';

	    // validate a little.
	    if (!ipv6Hostname) {
	      var hostparts = this.hostname.split(/\./);
	      for (var i = 0, l = hostparts.length; i < l; i++) {
	        var part = hostparts[i];
	        if (!part) continue;
	        if (!part.match(hostnamePartPattern)) {
	          var newpart = '';
	          for (var j = 0, k = part.length; j < k; j++) {
	            if (part.charCodeAt(j) > 127) {
	              // we replace non-ASCII char with a temporary placeholder
	              // we need this to make sure size of hostname is not
	              // broken by replacing non-ASCII by nothing
	              newpart += 'x';
	            } else {
	              newpart += part[j];
	            }
	          }
	          // we test again with ASCII char only
	          if (!newpart.match(hostnamePartPattern)) {
	            var validParts = hostparts.slice(0, i);
	            var notHost = hostparts.slice(i + 1);
	            var bit = part.match(hostnamePartStart);
	            if (bit) {
	              validParts.push(bit[1]);
	              notHost.unshift(bit[2]);
	            }
	            if (notHost.length) {
	              rest = '/' + notHost.join('.') + rest;
	            }
	            this.hostname = validParts.join('.');
	            break;
	          }
	        }
	      }
	    }

	    if (this.hostname.length > hostnameMaxLen) {
	      this.hostname = '';
	    } else {
	      // hostnames are always lower case.
	      this.hostname = this.hostname.toLowerCase();
	    }

	    if (!ipv6Hostname) {
	      // IDNA Support: Returns a puny coded representation of "domain".
	      // It only converts the part of the domain name that
	      // has non ASCII characters. I.e. it dosent matter if
	      // you call it with a domain that already is in ASCII.
	      var domainArray = this.hostname.split('.');
	      var newOut = [];
	      for (var i = 0; i < domainArray.length; ++i) {
	        var s = domainArray[i];
	        newOut.push(s.match(/[^A-Za-z0-9_-]/) ?
	            'xn--' + punycode.encode(s) : s);
	      }
	      this.hostname = newOut.join('.');
	    }

	    var p = this.port ? ':' + this.port : '';
	    var h = this.hostname || '';
	    this.host = h + p;
	    this.href += this.host;

	    // strip [ and ] from the hostname
	    // the host field still retains them, though
	    if (ipv6Hostname) {
	      this.hostname = this.hostname.substr(1, this.hostname.length - 2);
	      if (rest[0] !== '/') {
	        rest = '/' + rest;
	      }
	    }
	  }

	  // now rest is set to the post-host stuff.
	  // chop off any delim chars.
	  if (!unsafeProtocol[lowerProto]) {

	    // First, make 100% sure that any "autoEscape" chars get
	    // escaped, even if encodeURIComponent doesn't think they
	    // need to be.
	    for (var i = 0, l = autoEscape.length; i < l; i++) {
	      var ae = autoEscape[i];
	      var esc = encodeURIComponent(ae);
	      if (esc === ae) {
	        esc = escape(ae);
	      }
	      rest = rest.split(ae).join(esc);
	    }
	  }


	  // chop off from the tail first.
	  var hash = rest.indexOf('#');
	  if (hash !== -1) {
	    // got a fragment string.
	    this.hash = rest.substr(hash);
	    rest = rest.slice(0, hash);
	  }
	  var qm = rest.indexOf('?');
	  if (qm !== -1) {
	    this.search = rest.substr(qm);
	    this.query = rest.substr(qm + 1);
	    if (parseQueryString) {
	      this.query = querystring.parse(this.query);
	    }
	    rest = rest.slice(0, qm);
	  } else if (parseQueryString) {
	    // no query string, but parseQueryString still requested
	    this.search = '';
	    this.query = {};
	  }
	  if (rest) this.pathname = rest;
	  if (slashedProtocol[lowerProto] &&
	      this.hostname && !this.pathname) {
	    this.pathname = '/';
	  }

	  //to support http.request
	  if (this.pathname || this.search) {
	    var p = this.pathname || '';
	    var s = this.search || '';
	    this.path = p + s;
	  }

	  // finally, reconstruct the href based on what has been validated.
	  this.href = this.format();
	  return this;
	};

	// format a parsed object into a url string
	function urlFormat(obj) {
	  // ensure it's an object, and not a string url.
	  // If it's an obj, this is a no-op.
	  // this way, you can call url_format() on strings
	  // to clean up potentially wonky urls.
	  if (isString(obj)) obj = urlParse(obj);
	  if (!(obj instanceof Url)) return Url.prototype.format.call(obj);
	  return obj.format();
	}

	Url.prototype.format = function() {
	  var auth = this.auth || '';
	  if (auth) {
	    auth = encodeURIComponent(auth);
	    auth = auth.replace(/%3A/i, ':');
	    auth += '@';
	  }

	  var protocol = this.protocol || '',
	      pathname = this.pathname || '',
	      hash = this.hash || '',
	      host = false,
	      query = '';

	  if (this.host) {
	    host = auth + this.host;
	  } else if (this.hostname) {
	    host = auth + (this.hostname.indexOf(':') === -1 ?
	        this.hostname :
	        '[' + this.hostname + ']');
	    if (this.port) {
	      host += ':' + this.port;
	    }
	  }

	  if (this.query &&
	      isObject(this.query) &&
	      Object.keys(this.query).length) {
	    query = querystring.stringify(this.query);
	  }

	  var search = this.search || (query && ('?' + query)) || '';

	  if (protocol && protocol.substr(-1) !== ':') protocol += ':';

	  // only the slashedProtocols get the //.  Not mailto:, xmpp:, etc.
	  // unless they had them to begin with.
	  if (this.slashes ||
	      (!protocol || slashedProtocol[protocol]) && host !== false) {
	    host = '//' + (host || '');
	    if (pathname && pathname.charAt(0) !== '/') pathname = '/' + pathname;
	  } else if (!host) {
	    host = '';
	  }

	  if (hash && hash.charAt(0) !== '#') hash = '#' + hash;
	  if (search && search.charAt(0) !== '?') search = '?' + search;

	  pathname = pathname.replace(/[?#]/g, function(match) {
	    return encodeURIComponent(match);
	  });
	  search = search.replace('#', '%23');

	  return protocol + host + pathname + search + hash;
	};

	function urlResolve(source, relative) {
	  return urlParse(source, false, true).resolve(relative);
	}

	Url.prototype.resolve = function(relative) {
	  return this.resolveObject(urlParse(relative, false, true)).format();
	};

	function urlResolveObject(source, relative) {
	  if (!source) return relative;
	  return urlParse(source, false, true).resolveObject(relative);
	}

	Url.prototype.resolveObject = function(relative) {
	  if (isString(relative)) {
	    var rel = new Url();
	    rel.parse(relative, false, true);
	    relative = rel;
	  }

	  var result = new Url();
	  Object.keys(this).forEach(function(k) {
	    result[k] = this[k];
	  }, this);

	  // hash is always overridden, no matter what.
	  // even href="" will remove it.
	  result.hash = relative.hash;

	  // if the relative url is empty, then there's nothing left to do here.
	  if (relative.href === '') {
	    result.href = result.format();
	    return result;
	  }

	  // hrefs like //foo/bar always cut to the protocol.
	  if (relative.slashes && !relative.protocol) {
	    // take everything except the protocol from relative
	    Object.keys(relative).forEach(function(k) {
	      if (k !== 'protocol')
	        result[k] = relative[k];
	    });

	    //urlParse appends trailing / to urls like http://www.example.com
	    if (slashedProtocol[result.protocol] &&
	        result.hostname && !result.pathname) {
	      result.path = result.pathname = '/';
	    }

	    result.href = result.format();
	    return result;
	  }

	  if (relative.protocol && relative.protocol !== result.protocol) {
	    // if it's a known url protocol, then changing
	    // the protocol does weird things
	    // first, if it's not file:, then we MUST have a host,
	    // and if there was a path
	    // to begin with, then we MUST have a path.
	    // if it is file:, then the host is dropped,
	    // because that's known to be hostless.
	    // anything else is assumed to be absolute.
	    if (!slashedProtocol[relative.protocol]) {
	      Object.keys(relative).forEach(function(k) {
	        result[k] = relative[k];
	      });
	      result.href = result.format();
	      return result;
	    }

	    result.protocol = relative.protocol;
	    if (!relative.host && !hostlessProtocol[relative.protocol]) {
	      var relPath = (relative.pathname || '').split('/');
	      while (relPath.length && !(relative.host = relPath.shift()));
	      if (!relative.host) relative.host = '';
	      if (!relative.hostname) relative.hostname = '';
	      if (relPath[0] !== '') relPath.unshift('');
	      if (relPath.length < 2) relPath.unshift('');
	      result.pathname = relPath.join('/');
	    } else {
	      result.pathname = relative.pathname;
	    }
	    result.search = relative.search;
	    result.query = relative.query;
	    result.host = relative.host || '';
	    result.auth = relative.auth;
	    result.hostname = relative.hostname || relative.host;
	    result.port = relative.port;
	    // to support http.request
	    if (result.pathname || result.search) {
	      var p = result.pathname || '';
	      var s = result.search || '';
	      result.path = p + s;
	    }
	    result.slashes = result.slashes || relative.slashes;
	    result.href = result.format();
	    return result;
	  }

	  var isSourceAbs = (result.pathname && result.pathname.charAt(0) === '/'),
	      isRelAbs = (
	          relative.host ||
	          relative.pathname && relative.pathname.charAt(0) === '/'
	      ),
	      mustEndAbs = (isRelAbs || isSourceAbs ||
	                    (result.host && relative.pathname)),
	      removeAllDots = mustEndAbs,
	      srcPath = result.pathname && result.pathname.split('/') || [],
	      relPath = relative.pathname && relative.pathname.split('/') || [],
	      psychotic = result.protocol && !slashedProtocol[result.protocol];

	  // if the url is a non-slashed url, then relative
	  // links like ../.. should be able
	  // to crawl up to the hostname, as well.  This is strange.
	  // result.protocol has already been set by now.
	  // Later on, put the first path part into the host field.
	  if (psychotic) {
	    result.hostname = '';
	    result.port = null;
	    if (result.host) {
	      if (srcPath[0] === '') srcPath[0] = result.host;
	      else srcPath.unshift(result.host);
	    }
	    result.host = '';
	    if (relative.protocol) {
	      relative.hostname = null;
	      relative.port = null;
	      if (relative.host) {
	        if (relPath[0] === '') relPath[0] = relative.host;
	        else relPath.unshift(relative.host);
	      }
	      relative.host = null;
	    }
	    mustEndAbs = mustEndAbs && (relPath[0] === '' || srcPath[0] === '');
	  }

	  if (isRelAbs) {
	    // it's absolute.
	    result.host = (relative.host || relative.host === '') ?
	                  relative.host : result.host;
	    result.hostname = (relative.hostname || relative.hostname === '') ?
	                      relative.hostname : result.hostname;
	    result.search = relative.search;
	    result.query = relative.query;
	    srcPath = relPath;
	    // fall through to the dot-handling below.
	  } else if (relPath.length) {
	    // it's relative
	    // throw away the existing file, and take the new path instead.
	    if (!srcPath) srcPath = [];
	    srcPath.pop();
	    srcPath = srcPath.concat(relPath);
	    result.search = relative.search;
	    result.query = relative.query;
	  } else if (!isNullOrUndefined(relative.search)) {
	    // just pull out the search.
	    // like href='?foo'.
	    // Put this after the other two cases because it simplifies the booleans
	    if (psychotic) {
	      result.hostname = result.host = srcPath.shift();
	      //occationaly the auth can get stuck only in host
	      //this especialy happens in cases like
	      //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
	      var authInHost = result.host && result.host.indexOf('@') > 0 ?
	                       result.host.split('@') : false;
	      if (authInHost) {
	        result.auth = authInHost.shift();
	        result.host = result.hostname = authInHost.shift();
	      }
	    }
	    result.search = relative.search;
	    result.query = relative.query;
	    //to support http.request
	    if (!isNull(result.pathname) || !isNull(result.search)) {
	      result.path = (result.pathname ? result.pathname : '') +
	                    (result.search ? result.search : '');
	    }
	    result.href = result.format();
	    return result;
	  }

	  if (!srcPath.length) {
	    // no path at all.  easy.
	    // we've already handled the other stuff above.
	    result.pathname = null;
	    //to support http.request
	    if (result.search) {
	      result.path = '/' + result.search;
	    } else {
	      result.path = null;
	    }
	    result.href = result.format();
	    return result;
	  }

	  // if a url ENDs in . or .., then it must get a trailing slash.
	  // however, if it ends in anything else non-slashy,
	  // then it must NOT get a trailing slash.
	  var last = srcPath.slice(-1)[0];
	  var hasTrailingSlash = (
	      (result.host || relative.host) && (last === '.' || last === '..') ||
	      last === '');

	  // strip single dots, resolve double dots to parent dir
	  // if the path tries to go above the root, `up` ends up > 0
	  var up = 0;
	  for (var i = srcPath.length; i >= 0; i--) {
	    last = srcPath[i];
	    if (last == '.') {
	      srcPath.splice(i, 1);
	    } else if (last === '..') {
	      srcPath.splice(i, 1);
	      up++;
	    } else if (up) {
	      srcPath.splice(i, 1);
	      up--;
	    }
	  }

	  // if the path is allowed to go above the root, restore leading ..s
	  if (!mustEndAbs && !removeAllDots) {
	    for (; up--; up) {
	      srcPath.unshift('..');
	    }
	  }

	  if (mustEndAbs && srcPath[0] !== '' &&
	      (!srcPath[0] || srcPath[0].charAt(0) !== '/')) {
	    srcPath.unshift('');
	  }

	  if (hasTrailingSlash && (srcPath.join('/').substr(-1) !== '/')) {
	    srcPath.push('');
	  }

	  var isAbsolute = srcPath[0] === '' ||
	      (srcPath[0] && srcPath[0].charAt(0) === '/');

	  // put the host back
	  if (psychotic) {
	    result.hostname = result.host = isAbsolute ? '' :
	                                    srcPath.length ? srcPath.shift() : '';
	    //occationaly the auth can get stuck only in host
	    //this especialy happens in cases like
	    //url.resolveObject('mailto:local1@domain1', 'local2@domain2')
	    var authInHost = result.host && result.host.indexOf('@') > 0 ?
	                     result.host.split('@') : false;
	    if (authInHost) {
	      result.auth = authInHost.shift();
	      result.host = result.hostname = authInHost.shift();
	    }
	  }

	  mustEndAbs = mustEndAbs || (result.host && srcPath.length);

	  if (mustEndAbs && !isAbsolute) {
	    srcPath.unshift('');
	  }

	  if (!srcPath.length) {
	    result.pathname = null;
	    result.path = null;
	  } else {
	    result.pathname = srcPath.join('/');
	  }

	  //to support request.http
	  if (!isNull(result.pathname) || !isNull(result.search)) {
	    result.path = (result.pathname ? result.pathname : '') +
	                  (result.search ? result.search : '');
	  }
	  result.auth = relative.auth || result.auth;
	  result.slashes = result.slashes || relative.slashes;
	  result.href = result.format();
	  return result;
	};

	Url.prototype.parseHost = function() {
	  var host = this.host;
	  var port = portPattern.exec(host);
	  if (port) {
	    port = port[0];
	    if (port !== ':') {
	      this.port = port.substr(1);
	    }
	    host = host.substr(0, host.length - port.length);
	  }
	  if (host) this.hostname = host;
	};

	function isString(arg) {
	  return typeof arg === "string";
	}

	function isObject(arg) {
	  return typeof arg === 'object' && arg !== null;
	}

	function isNull(arg) {
	  return arg === null;
	}
	function isNullOrUndefined(arg) {
	  return  arg == null;
	}


/***/ },
/* 45 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function(options) { // inject sjcl dependency
	  var sjcl = options.sjcl;

	  var Base58Utils = (function () {
	    var alphabets = {
	      'ripple':  "rpshnaf39wBUDNEGHJKLM4PQRST7VWXYZ2bcdeCg65jkm8oFqi1tuvAxyz",
	      'bitcoin': "123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz"
	    };

	    var SHA256  = function (bytes) {
	      return sjcl.codec.bytes.fromBits(sjcl.hash.sha256.hash(sjcl.codec.bytes.toBits(bytes)));
	    };

	    return {
	      // --> input: big-endian array of bytes.
	      // <-- string at least as long as input.
	      encode_base: function (input, alphabetName) {
	        var alphabet = alphabets[alphabetName || 'ripple'],
	            base     = new sjcl.bn(alphabet.length),
	            bi       = sjcl.bn.fromBits(sjcl.codec.bytes.toBits(input)),
	            buffer   = [];

	        while (bi.greaterEquals(base)) {
	          var mod = bi.mod(base);
	          buffer.push(alphabet[mod.limbs[0]]);
	          bi = bi.div(base);
	        }
	        buffer.push(alphabet[bi.limbs[0]]);

	        // Convert leading zeros too.
	        for (var i = 0; i != input.length && !input[i]; i += 1) {
	          buffer.push(alphabet[0]);
	        }

	        return buffer.reverse().join("");
	      },

	      // --> input: String
	      // <-- array of bytes or undefined.
	      decode_base: function (input, alphabetName) {
	        var alphabet = alphabets[alphabetName || 'ripple'],
	            base     = new sjcl.bn(alphabet.length),
	            bi       = new sjcl.bn(0);

	        var i;
	        while (i != input.length && input[i] === alphabet[0]) {
	          i += 1;
	        }

	        for (i = 0; i != input.length; i += 1) {
	          var v = alphabet.indexOf(input[i]);

	          if (v < 0) {
	            return null;
	          }

	          bi = bi.mul(base).addM(v);
	        }

	        var bytes = sjcl.codec.bytes.fromBits(bi.toBits()).reverse();

	        // Remove leading zeros
	        while(bytes[bytes.length-1] === 0) {
	          bytes.pop();
	        }

	        // Add the right number of leading zeros
	        for (i = 0; input[i] === alphabet[0]; i++) {
	          bytes.push(0);
	        }

	        bytes.reverse();

	        return bytes;
	      },

	      // --> input: Array
	      // <-- String
	      encode_base_check: function (version, input, alphabet) {
	        var buffer  = [].concat(version, input);
	        var check   = SHA256(SHA256(buffer)).slice(0, 4);
	        return Base58Utils.encode_base([].concat(buffer, check), alphabet);
	      },

	      // --> input : String
	      // <-- NaN || BigInteger
	      decode_base_check: function (version, input, alphabet) {
	        var buffer = Base58Utils.decode_base(input, alphabet);

	        if (!buffer || buffer[0] !== version || buffer.length < 5) {
	          return NaN;
	        }

	        var computed = SHA256(SHA256(buffer.slice(0, -4))).slice(0, 4),
	            checksum = buffer.slice(-4);

	        var i;
	        for (i = 0; i != 4; i += 1)
	          if (computed[i] !== checksum[i])
	            return NaN;

	        return buffer.slice(1, -4);
	      }
	    };
	  })();
	  return Base58Utils;
	};


/***/ },
/* 46 */
/***/ function(module, exports, __webpack_require__) {

	
	module.exports = function(options) {
	  var sjcl = options.sjcl;
	  var base58 = __webpack_require__(45)({ sjcl: sjcl });

	  function MasterKey(key) {
	    this.value = key;
	  }

	  MasterKey.fromBytes = function(bytes) {
	    return new MasterKey(base58.encode_base_check(33, bytes));
	  };

	  MasterKey.getRandom = function() {
	    if (typeof window === 'object' && window.crypto) {
	      // Browser with crypto
	      var entropy = new Uint32Array(32);
	      window.crypto.getRandomValues(entropy);
	      sjcl.random.addEntropy(entropy, 1024, 'crypto.getRandomValues');
	    } else if (typeof module === 'object' && module.exports) {
	      // Node
	      var entropy = __webpack_require__(70).randomBytes(128);
	      entropy = new Uint32Array(new Uint8Array(entropy).buffer);
	      sjcl.random.addEntropy(entropy, 1024, 'crypto.randomBytes');
	    } else {
	      throw new Error('No secure source of entropy available');
	    }

	    var SJCL_PARANOIA_256_BITS = 6;
	    var words = sjcl.random.randomWords(4, SJCL_PARANOIA_256_BITS);
	    var randomBytes = sjcl.codec.bytes.fromBits(words);

	    return MasterKey.fromBytes(randomBytes);
	  };

	  return MasterKey;
	}


/***/ },
/* 47 */
/***/ function(module, exports, __webpack_require__) {

	
	module.exports = function(options) { // inject sjcl dependency
	  var sjcl = options.sjcl
	  var base58 = __webpack_require__(45)({ sjcl: sjcl });


	  function SHA256_RIPEMD160(bits) {
	    return sjcl.hash.ripemd160.hash(sjcl.hash.sha256.hash(bits));
	  }

	  function RippleAddress(address){
	    this.value = address;
	  }

	  RippleAddress.fromPublicKey = function(publicKey){
	    /* Encode the EC public key as a ripple address 
	       using SHA256 and then RIPEMD160
	    */
	    var publicKeyBytes = sjcl.codec.bytes.fromBits(SHA256_RIPEMD160(sjcl.codec.bytes.toBits(publicKey.toBytesCompressed())));
	    return new this(base58.encode_base_check(0, publicKeyBytes));
	  }

	  return RippleAddress;
	}


/***/ },
/* 48 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function(options) { // inject sjcl dependency
	  var sjcl = options.sjcl; 

	  function PublicGenerator(eccPoint) {
	    if (eccPoint instanceof sjcl.ecc.point) {
	      this.value = eccPoint;
	    } else {
	      throw new Error('eccPoint must be a sjcl.ecc.point'); 
	    }
	  }

	  PublicGenerator.fromPrivateGenerator = function(privateGenerator) {
	    /* Compute the public generator using from the 
	       private generator on the elliptic curve
	    */
	    return new this(sjcl.ecc.curves.c256.G.mult(privateGenerator));
	  };

	  PublicGenerator.prototype = {
	    toString: function() {
	      return this.value.toString();
	    }
	  }

	  return PublicGenerator;
	}



/***/ },
/* 49 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/*! bignumber.js v2.0.7 https://github.com/MikeMcl/bignumber.js/LICENCE */

	;(function (global) {
	    'use strict';

	    /*
	      bignumber.js v2.0.7
	      A JavaScript library for arbitrary-precision arithmetic.
	      https://github.com/MikeMcl/bignumber.js
	      Copyright (c) 2015 Michael Mclaughlin <M8ch88l@gmail.com>
	      MIT Expat Licence
	    */


	    var BigNumber, crypto, parseNumeric,
	        isNumeric = /^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i,
	        mathceil = Math.ceil,
	        mathfloor = Math.floor,
	        notBool = ' not a boolean or binary digit',
	        roundingMode = 'rounding mode',
	        tooManyDigits = 'number type has more than 15 significant digits',
	        ALPHABET = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_',
	        BASE = 1e14,
	        LOG_BASE = 14,
	        MAX_SAFE_INTEGER = 0x1fffffffffffff,         // 2^53 - 1
	        // MAX_INT32 = 0x7fffffff,                   // 2^31 - 1
	        POWS_TEN = [1, 10, 100, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9, 1e10, 1e11, 1e12, 1e13],
	        SQRT_BASE = 1e7,

	        /*
	         * The limit on the value of DECIMAL_PLACES, TO_EXP_NEG, TO_EXP_POS, MIN_EXP, MAX_EXP, and
	         * the arguments to toExponential, toFixed, toFormat, and toPrecision, beyond which an
	         * exception is thrown (if ERRORS is true).
	         */
	        MAX = 1E9;                                   // 0 to MAX_INT32


	    /*
	     * Create and return a BigNumber constructor.
	     */
	    function another(configObj) {
	        var div,

	            // id tracks the caller function, so its name can be included in error messages.
	            id = 0,
	            P = BigNumber.prototype,
	            ONE = new BigNumber(1),


	            /********************************* EDITABLE DEFAULTS **********************************/


	            /*
	             * The default values below must be integers within the inclusive ranges stated.
	             * The values can also be changed at run-time using BigNumber.config.
	             */

	            // The maximum number of decimal places for operations involving division.
	            DECIMAL_PLACES = 20,                     // 0 to MAX

	            /*
	             * The rounding mode used when rounding to the above decimal places, and when using
	             * toExponential, toFixed, toFormat and toPrecision, and round (default value).
	             * UP         0 Away from zero.
	             * DOWN       1 Towards zero.
	             * CEIL       2 Towards +Infinity.
	             * FLOOR      3 Towards -Infinity.
	             * HALF_UP    4 Towards nearest neighbour. If equidistant, up.
	             * HALF_DOWN  5 Towards nearest neighbour. If equidistant, down.
	             * HALF_EVEN  6 Towards nearest neighbour. If equidistant, towards even neighbour.
	             * HALF_CEIL  7 Towards nearest neighbour. If equidistant, towards +Infinity.
	             * HALF_FLOOR 8 Towards nearest neighbour. If equidistant, towards -Infinity.
	             */
	            ROUNDING_MODE = 4,                       // 0 to 8

	            // EXPONENTIAL_AT : [TO_EXP_NEG , TO_EXP_POS]

	            // The exponent value at and beneath which toString returns exponential notation.
	            // Number type: -7
	            TO_EXP_NEG = -7,                         // 0 to -MAX

	            // The exponent value at and above which toString returns exponential notation.
	            // Number type: 21
	            TO_EXP_POS = 21,                         // 0 to MAX

	            // RANGE : [MIN_EXP, MAX_EXP]

	            // The minimum exponent value, beneath which underflow to zero occurs.
	            // Number type: -324  (5e-324)
	            MIN_EXP = -1e7,                          // -1 to -MAX

	            // The maximum exponent value, above which overflow to Infinity occurs.
	            // Number type:  308  (1.7976931348623157e+308)
	            // For MAX_EXP > 1e7, e.g. new BigNumber('1e100000000').plus(1) may be slow.
	            MAX_EXP = 1e7,                           // 1 to MAX

	            // Whether BigNumber Errors are ever thrown.
	            ERRORS = true,                           // true or false

	            // Change to intValidatorNoErrors if ERRORS is false.
	            isValidInt = intValidatorWithErrors,     // intValidatorWithErrors/intValidatorNoErrors

	            // Whether to use cryptographically-secure random number generation, if available.
	            CRYPTO = false,                          // true or false

	            /*
	             * The modulo mode used when calculating the modulus: a mod n.
	             * The quotient (q = a / n) is calculated according to the corresponding rounding mode.
	             * The remainder (r) is calculated as: r = a - n * q.
	             *
	             * UP        0 The remainder is positive if the dividend is negative, else is negative.
	             * DOWN      1 The remainder has the same sign as the dividend.
	             *             This modulo mode is commonly known as 'truncated division' and is
	             *             equivalent to (a % n) in JavaScript.
	             * FLOOR     3 The remainder has the same sign as the divisor (Python %).
	             * HALF_EVEN 6 This modulo mode implements the IEEE 754 remainder function.
	             * EUCLID    9 Euclidian division. q = sign(n) * floor(a / abs(n)).
	             *             The remainder is always positive.
	             *
	             * The truncated division, floored division, Euclidian division and IEEE 754 remainder
	             * modes are commonly used for the modulus operation.
	             * Although the other rounding modes can also be used, they may not give useful results.
	             */
	            MODULO_MODE = 1,                         // 0 to 9

	            // The maximum number of significant digits of the result of the toPower operation.
	            // If POW_PRECISION is 0, there will be unlimited significant digits.
	            POW_PRECISION = 100,                     // 0 to MAX

	            // The format specification used by the BigNumber.prototype.toFormat method.
	            FORMAT = {
	                decimalSeparator: '.',
	                groupSeparator: ',',
	                groupSize: 3,
	                secondaryGroupSize: 0,
	                fractionGroupSeparator: '\xA0',      // non-breaking space
	                fractionGroupSize: 0
	            };


	        /******************************************************************************************/


	        // CONSTRUCTOR


	        /*
	         * The BigNumber constructor and exported function.
	         * Create and return a new instance of a BigNumber object.
	         *
	         * n {number|string|BigNumber} A numeric value.
	         * [b] {number} The base of n. Integer, 2 to 64 inclusive.
	         */
	        function BigNumber( n, b ) {
	            var c, e, i, num, len, str,
	                x = this;

	            // Enable constructor usage without new.
	            if ( !( x instanceof BigNumber ) ) {

	                // 'BigNumber() constructor call without new: {n}'
	                if (ERRORS) raise( 26, 'constructor call without new', n );
	                return new BigNumber( n, b );
	            }

	            // 'new BigNumber() base not an integer: {b}'
	            // 'new BigNumber() base out of range: {b}'
	            if ( b == null || !isValidInt( b, 2, 64, id, 'base' ) ) {

	                // Duplicate.
	                if ( n instanceof BigNumber ) {
	                    x.s = n.s;
	                    x.e = n.e;
	                    x.c = ( n = n.c ) ? n.slice() : n;
	                    id = 0;
	                    return;
	                }

	                if ( ( num = typeof n == 'number' ) && n * 0 == 0 ) {
	                    x.s = 1 / n < 0 ? ( n = -n, -1 ) : 1;

	                    // Fast path for integers.
	                    if ( n === ~~n ) {
	                        for ( e = 0, i = n; i >= 10; i /= 10, e++ );
	                        x.e = e;
	                        x.c = [n];
	                        id = 0;
	                        return;
	                    }

	                    str = n + '';
	                } else {
	                    if ( !isNumeric.test( str = n + '' ) ) return parseNumeric( x, str, num );
	                    x.s = str.charCodeAt(0) === 45 ? ( str = str.slice(1), -1 ) : 1;
	                }
	            } else {
	                b = b | 0;
	                str = n + '';

	                // Ensure return value is rounded to DECIMAL_PLACES as with other bases.
	                // Allow exponential notation to be used with base 10 argument.
	                if ( b == 10 ) {
	                    x = new BigNumber( n instanceof BigNumber ? n : str );
	                    return round( x, DECIMAL_PLACES + x.e + 1, ROUNDING_MODE );
	                }

	                // Avoid potential interpretation of Infinity and NaN as base 44+ values.
	                // Any number in exponential form will fail due to the [Ee][+-].
	                if ( ( num = typeof n == 'number' ) && n * 0 != 0 ||
	                  !( new RegExp( '^-?' + ( c = '[' + ALPHABET.slice( 0, b ) + ']+' ) +
	                    '(?:\\.' + c + ')?$',b < 37 ? 'i' : '' ) ).test(str) ) {
	                    return parseNumeric( x, str, num, b );
	                }

	                if (num) {
	                    x.s = 1 / n < 0 ? ( str = str.slice(1), -1 ) : 1;

	                    if ( ERRORS && str.replace( /^0\.0*|\./, '' ).length > 15 ) {

	                        // 'new BigNumber() number type has more than 15 significant digits: {n}'
	                        raise( id, tooManyDigits, n );
	                    }

	                    // Prevent later check for length on converted number.
	                    num = false;
	                } else {
	                    x.s = str.charCodeAt(0) === 45 ? ( str = str.slice(1), -1 ) : 1;
	                }

	                str = convertBase( str, 10, b, x.s );
	            }

	            // Decimal point?
	            if ( ( e = str.indexOf('.') ) > -1 ) str = str.replace( '.', '' );

	            // Exponential form?
	            if ( ( i = str.search( /e/i ) ) > 0 ) {

	                // Determine exponent.
	                if ( e < 0 ) e = i;
	                e += +str.slice( i + 1 );
	                str = str.substring( 0, i );
	            } else if ( e < 0 ) {

	                // Integer.
	                e = str.length;
	            }

	            // Determine leading zeros.
	            for ( i = 0; str.charCodeAt(i) === 48; i++ );

	            // Determine trailing zeros.
	            for ( len = str.length; str.charCodeAt(--len) === 48; );
	            str = str.slice( i, len + 1 );

	            if (str) {
	                len = str.length;

	                // Disallow numbers with over 15 significant digits if number type.
	                // 'new BigNumber() number type has more than 15 significant digits: {n}'
	                if ( num && ERRORS && len > 15 ) raise( id, tooManyDigits, x.s * n );

	                e = e - i - 1;

	                 // Overflow?
	                if ( e > MAX_EXP ) {

	                    // Infinity.
	                    x.c = x.e = null;

	                // Underflow?
	                } else if ( e < MIN_EXP ) {

	                    // Zero.
	                    x.c = [ x.e = 0 ];
	                } else {
	                    x.e = e;
	                    x.c = [];

	                    // Transform base

	                    // e is the base 10 exponent.
	                    // i is where to slice str to get the first element of the coefficient array.
	                    i = ( e + 1 ) % LOG_BASE;
	                    if ( e < 0 ) i += LOG_BASE;

	                    if ( i < len ) {
	                        if (i) x.c.push( +str.slice( 0, i ) );

	                        for ( len -= LOG_BASE; i < len; ) {
	                            x.c.push( +str.slice( i, i += LOG_BASE ) );
	                        }

	                        str = str.slice(i);
	                        i = LOG_BASE - str.length;
	                    } else {
	                        i -= len;
	                    }

	                    for ( ; i--; str += '0' );
	                    x.c.push( +str );
	                }
	            } else {

	                // Zero.
	                x.c = [ x.e = 0 ];
	            }

	            id = 0;
	        }


	        // CONSTRUCTOR PROPERTIES


	        BigNumber.another = another;

	        BigNumber.ROUND_UP = 0;
	        BigNumber.ROUND_DOWN = 1;
	        BigNumber.ROUND_CEIL = 2;
	        BigNumber.ROUND_FLOOR = 3;
	        BigNumber.ROUND_HALF_UP = 4;
	        BigNumber.ROUND_HALF_DOWN = 5;
	        BigNumber.ROUND_HALF_EVEN = 6;
	        BigNumber.ROUND_HALF_CEIL = 7;
	        BigNumber.ROUND_HALF_FLOOR = 8;
	        BigNumber.EUCLID = 9;


	        /*
	         * Configure infrequently-changing library-wide settings.
	         *
	         * Accept an object or an argument list, with one or many of the following properties or
	         * parameters respectively:
	         *
	         *   DECIMAL_PLACES  {number}  Integer, 0 to MAX inclusive
	         *   ROUNDING_MODE   {number}  Integer, 0 to 8 inclusive
	         *   EXPONENTIAL_AT  {number|number[]}  Integer, -MAX to MAX inclusive or
	         *                                      [integer -MAX to 0 incl., 0 to MAX incl.]
	         *   RANGE           {number|number[]}  Non-zero integer, -MAX to MAX inclusive or
	         *                                      [integer -MAX to -1 incl., integer 1 to MAX incl.]
	         *   ERRORS          {boolean|number}   true, false, 1 or 0
	         *   CRYPTO          {boolean|number}   true, false, 1 or 0
	         *   MODULO_MODE     {number}           0 to 9 inclusive
	         *   POW_PRECISION   {number}           0 to MAX inclusive
	         *   FORMAT          {object}           See BigNumber.prototype.toFormat
	         *      decimalSeparator       {string}
	         *      groupSeparator         {string}
	         *      groupSize              {number}
	         *      secondaryGroupSize     {number}
	         *      fractionGroupSeparator {string}
	         *      fractionGroupSize      {number}
	         *
	         * (The values assigned to the above FORMAT object properties are not checked for validity.)
	         *
	         * E.g.
	         * BigNumber.config(20, 4) is equivalent to
	         * BigNumber.config({ DECIMAL_PLACES : 20, ROUNDING_MODE : 4 })
	         *
	         * Ignore properties/parameters set to null or undefined.
	         * Return an object with the properties current values.
	         */
	        BigNumber.config = function () {
	            var v, p,
	                i = 0,
	                r = {},
	                a = arguments,
	                o = a[0],
	                has = o && typeof o == 'object'
	                  ? function () { if ( o.hasOwnProperty(p) ) return ( v = o[p] ) != null; }
	                  : function () { if ( a.length > i ) return ( v = a[i++] ) != null; };

	            // DECIMAL_PLACES {number} Integer, 0 to MAX inclusive.
	            // 'config() DECIMAL_PLACES not an integer: {v}'
	            // 'config() DECIMAL_PLACES out of range: {v}'
	            if ( has( p = 'DECIMAL_PLACES' ) && isValidInt( v, 0, MAX, 2, p ) ) {
	                DECIMAL_PLACES = v | 0;
	            }
	            r[p] = DECIMAL_PLACES;

	            // ROUNDING_MODE {number} Integer, 0 to 8 inclusive.
	            // 'config() ROUNDING_MODE not an integer: {v}'
	            // 'config() ROUNDING_MODE out of range: {v}'
	            if ( has( p = 'ROUNDING_MODE' ) && isValidInt( v, 0, 8, 2, p ) ) {
	                ROUNDING_MODE = v | 0;
	            }
	            r[p] = ROUNDING_MODE;

	            // EXPONENTIAL_AT {number|number[]}
	            // Integer, -MAX to MAX inclusive or [integer -MAX to 0 inclusive, 0 to MAX inclusive].
	            // 'config() EXPONENTIAL_AT not an integer: {v}'
	            // 'config() EXPONENTIAL_AT out of range: {v}'
	            if ( has( p = 'EXPONENTIAL_AT' ) ) {

	                if ( isArray(v) ) {
	                    if ( isValidInt( v[0], -MAX, 0, 2, p ) && isValidInt( v[1], 0, MAX, 2, p ) ) {
	                        TO_EXP_NEG = v[0] | 0;
	                        TO_EXP_POS = v[1] | 0;
	                    }
	                } else if ( isValidInt( v, -MAX, MAX, 2, p ) ) {
	                    TO_EXP_NEG = -( TO_EXP_POS = ( v < 0 ? -v : v ) | 0 );
	                }
	            }
	            r[p] = [ TO_EXP_NEG, TO_EXP_POS ];

	            // RANGE {number|number[]} Non-zero integer, -MAX to MAX inclusive or
	            // [integer -MAX to -1 inclusive, integer 1 to MAX inclusive].
	            // 'config() RANGE not an integer: {v}'
	            // 'config() RANGE cannot be zero: {v}'
	            // 'config() RANGE out of range: {v}'
	            if ( has( p = 'RANGE' ) ) {

	                if ( isArray(v) ) {
	                    if ( isValidInt( v[0], -MAX, -1, 2, p ) && isValidInt( v[1], 1, MAX, 2, p ) ) {
	                        MIN_EXP = v[0] | 0;
	                        MAX_EXP = v[1] | 0;
	                    }
	                } else if ( isValidInt( v, -MAX, MAX, 2, p ) ) {
	                    if ( v | 0 ) MIN_EXP = -( MAX_EXP = ( v < 0 ? -v : v ) | 0 );
	                    else if (ERRORS) raise( 2, p + ' cannot be zero', v );
	                }
	            }
	            r[p] = [ MIN_EXP, MAX_EXP ];

	            // ERRORS {boolean|number} true, false, 1 or 0.
	            // 'config() ERRORS not a boolean or binary digit: {v}'
	            if ( has( p = 'ERRORS' ) ) {

	                if ( v === !!v || v === 1 || v === 0 ) {
	                    id = 0;
	                    isValidInt = ( ERRORS = !!v ) ? intValidatorWithErrors : intValidatorNoErrors;
	                } else if (ERRORS) {
	                    raise( 2, p + notBool, v );
	                }
	            }
	            r[p] = ERRORS;

	            // CRYPTO {boolean|number} true, false, 1 or 0.
	            // 'config() CRYPTO not a boolean or binary digit: {v}'
	            // 'config() crypto unavailable: {crypto}'
	            if ( has( p = 'CRYPTO' ) ) {

	                if ( v === !!v || v === 1 || v === 0 ) {
	                    CRYPTO = !!( v && crypto && typeof crypto == 'object' );
	                    if ( v && !CRYPTO && ERRORS ) raise( 2, 'crypto unavailable', crypto );
	                } else if (ERRORS) {
	                    raise( 2, p + notBool, v );
	                }
	            }
	            r[p] = CRYPTO;

	            // MODULO_MODE {number} Integer, 0 to 9 inclusive.
	            // 'config() MODULO_MODE not an integer: {v}'
	            // 'config() MODULO_MODE out of range: {v}'
	            if ( has( p = 'MODULO_MODE' ) && isValidInt( v, 0, 9, 2, p ) ) {
	                MODULO_MODE = v | 0;
	            }
	            r[p] = MODULO_MODE;

	            // POW_PRECISION {number} Integer, 0 to MAX inclusive.
	            // 'config() POW_PRECISION not an integer: {v}'
	            // 'config() POW_PRECISION out of range: {v}'
	            if ( has( p = 'POW_PRECISION' ) && isValidInt( v, 0, MAX, 2, p ) ) {
	                POW_PRECISION = v | 0;
	            }
	            r[p] = POW_PRECISION;

	            // FORMAT {object}
	            // 'config() FORMAT not an object: {v}'
	            if ( has( p = 'FORMAT' ) ) {

	                if ( typeof v == 'object' ) {
	                    FORMAT = v;
	                } else if (ERRORS) {
	                    raise( 2, p + ' not an object', v );
	                }
	            }
	            r[p] = FORMAT;

	            return r;
	        };


	        /*
	         * Return a new BigNumber whose value is the maximum of the arguments.
	         *
	         * arguments {number|string|BigNumber}
	         */
	        BigNumber.max = function () { return maxOrMin( arguments, P.lt ); };


	        /*
	         * Return a new BigNumber whose value is the minimum of the arguments.
	         *
	         * arguments {number|string|BigNumber}
	         */
	        BigNumber.min = function () { return maxOrMin( arguments, P.gt ); };


	        /*
	         * Return a new BigNumber with a random value equal to or greater than 0 and less than 1,
	         * and with dp, or DECIMAL_PLACES if dp is omitted, decimal places (or less if trailing
	         * zeros are produced).
	         *
	         * [dp] {number} Decimal places. Integer, 0 to MAX inclusive.
	         *
	         * 'random() decimal places not an integer: {dp}'
	         * 'random() decimal places out of range: {dp}'
	         * 'random() crypto unavailable: {crypto}'
	         */
	        BigNumber.random = (function () {
	            var pow2_53 = 0x20000000000000;

	            // Return a 53 bit integer n, where 0 <= n < 9007199254740992.
	            // Check if Math.random() produces more than 32 bits of randomness.
	            // If it does, assume at least 53 bits are produced, otherwise assume at least 30 bits.
	            // 0x40000000 is 2^30, 0x800000 is 2^23, 0x1fffff is 2^21 - 1.
	            var random53bitInt = (Math.random() * pow2_53) & 0x1fffff
	              ? function () { return mathfloor( Math.random() * pow2_53 ); }
	              : function () { return ((Math.random() * 0x40000000 | 0) * 0x800000) +
	                  (Math.random() * 0x800000 | 0); };

	            return function (dp) {
	                var a, b, e, k, v,
	                    i = 0,
	                    c = [],
	                    rand = new BigNumber(ONE);

	                dp = dp == null || !isValidInt( dp, 0, MAX, 14 ) ? DECIMAL_PLACES : dp | 0;
	                k = mathceil( dp / LOG_BASE );

	                if (CRYPTO) {

	                    // Browsers supporting crypto.getRandomValues.
	                    if ( crypto && crypto.getRandomValues ) {

	                        a = crypto.getRandomValues( new Uint32Array( k *= 2 ) );

	                        for ( ; i < k; ) {

	                            // 53 bits:
	                            // ((Math.pow(2, 32) - 1) * Math.pow(2, 21)).toString(2)
	                            // 11111 11111111 11111111 11111111 11100000 00000000 00000000
	                            // ((Math.pow(2, 32) - 1) >>> 11).toString(2)
	                            //                                     11111 11111111 11111111
	                            // 0x20000 is 2^21.
	                            v = a[i] * 0x20000 + (a[i + 1] >>> 11);

	                            // Rejection sampling:
	                            // 0 <= v < 9007199254740992
	                            // Probability that v >= 9e15, is
	                            // 7199254740992 / 9007199254740992 ~= 0.0008, i.e. 1 in 1251
	                            if ( v >= 9e15 ) {
	                                b = crypto.getRandomValues( new Uint32Array(2) );
	                                a[i] = b[0];
	                                a[i + 1] = b[1];
	                            } else {

	                                // 0 <= v <= 8999999999999999
	                                // 0 <= (v % 1e14) <= 99999999999999
	                                c.push( v % 1e14 );
	                                i += 2;
	                            }
	                        }
	                        i = k / 2;

	                    // Node.js supporting crypto.randomBytes.
	                    } else if ( crypto && crypto.randomBytes ) {

	                        // buffer
	                        a = crypto.randomBytes( k *= 7 );

	                        for ( ; i < k; ) {

	                            // 0x1000000000000 is 2^48, 0x10000000000 is 2^40
	                            // 0x100000000 is 2^32, 0x1000000 is 2^24
	                            // 11111 11111111 11111111 11111111 11111111 11111111 11111111
	                            // 0 <= v < 9007199254740992
	                            v = ( ( a[i] & 31 ) * 0x1000000000000 ) + ( a[i + 1] * 0x10000000000 ) +
	                                  ( a[i + 2] * 0x100000000 ) + ( a[i + 3] * 0x1000000 ) +
	                                  ( a[i + 4] << 16 ) + ( a[i + 5] << 8 ) + a[i + 6];

	                            if ( v >= 9e15 ) {
	                                crypto.randomBytes(7).copy( a, i );
	                            } else {

	                                // 0 <= (v % 1e14) <= 99999999999999
	                                c.push( v % 1e14 );
	                                i += 7;
	                            }
	                        }
	                        i = k / 7;
	                    } else if (ERRORS) {
	                        raise( 14, 'crypto unavailable', crypto );
	                    }
	                }

	                // Use Math.random: CRYPTO is false or crypto is unavailable and ERRORS is false.
	                if (!i) {

	                    for ( ; i < k; ) {
	                        v = random53bitInt();
	                        if ( v < 9e15 ) c[i++] = v % 1e14;
	                    }
	                }

	                k = c[--i];
	                dp %= LOG_BASE;

	                // Convert trailing digits to zeros according to dp.
	                if ( k && dp ) {
	                    v = POWS_TEN[LOG_BASE - dp];
	                    c[i] = mathfloor( k / v ) * v;
	                }

	                // Remove trailing elements which are zero.
	                for ( ; c[i] === 0; c.pop(), i-- );

	                // Zero?
	                if ( i < 0 ) {
	                    c = [ e = 0 ];
	                } else {

	                    // Remove leading elements which are zero and adjust exponent accordingly.
	                    for ( e = -1 ; c[0] === 0; c.shift(), e -= LOG_BASE);

	                    // Count the digits of the first element of c to determine leading zeros, and...
	                    for ( i = 1, v = c[0]; v >= 10; v /= 10, i++);

	                    // adjust the exponent accordingly.
	                    if ( i < LOG_BASE ) e -= LOG_BASE - i;
	                }

	                rand.e = e;
	                rand.c = c;
	                return rand;
	            };
	        })();


	        // PRIVATE FUNCTIONS


	        // Convert a numeric string of baseIn to a numeric string of baseOut.
	        function convertBase( str, baseOut, baseIn, sign ) {
	            var d, e, k, r, x, xc, y,
	                i = str.indexOf( '.' ),
	                dp = DECIMAL_PLACES,
	                rm = ROUNDING_MODE;

	            if ( baseIn < 37 ) str = str.toLowerCase();

	            // Non-integer.
	            if ( i >= 0 ) {
	                k = POW_PRECISION;

	                // Unlimited precision.
	                POW_PRECISION = 0;
	                str = str.replace( '.', '' );
	                y = new BigNumber(baseIn);
	                x = y.pow( str.length - i );
	                POW_PRECISION = k;

	                // Convert str as if an integer, then restore the fraction part by dividing the
	                // result by its base raised to a power.
	                y.c = toBaseOut( toFixedPoint( coeffToString( x.c ), x.e ), 10, baseOut );
	                y.e = y.c.length;
	            }

	            // Convert the number as integer.
	            xc = toBaseOut( str, baseIn, baseOut );
	            e = k = xc.length;

	            // Remove trailing zeros.
	            for ( ; xc[--k] == 0; xc.pop() );
	            if ( !xc[0] ) return '0';

	            if ( i < 0 ) {
	                --e;
	            } else {
	                x.c = xc;
	                x.e = e;

	                // sign is needed for correct rounding.
	                x.s = sign;
	                x = div( x, y, dp, rm, baseOut );
	                xc = x.c;
	                r = x.r;
	                e = x.e;
	            }

	            d = e + dp + 1;

	            // The rounding digit, i.e. the digit to the right of the digit that may be rounded up.
	            i = xc[d];
	            k = baseOut / 2;
	            r = r || d < 0 || xc[d + 1] != null;

	            r = rm < 4 ? ( i != null || r ) && ( rm == 0 || rm == ( x.s < 0 ? 3 : 2 ) )
	                       : i > k || i == k &&( rm == 4 || r || rm == 6 && xc[d - 1] & 1 ||
	                         rm == ( x.s < 0 ? 8 : 7 ) );

	            if ( d < 1 || !xc[0] ) {

	                // 1^-dp or 0.
	                str = r ? toFixedPoint( '1', -dp ) : '0';
	            } else {
	                xc.length = d;

	                if (r) {

	                    // Rounding up may mean the previous digit has to be rounded up and so on.
	                    for ( --baseOut; ++xc[--d] > baseOut; ) {
	                        xc[d] = 0;

	                        if ( !d ) {
	                            ++e;
	                            xc.unshift(1);
	                        }
	                    }
	                }

	                // Determine trailing zeros.
	                for ( k = xc.length; !xc[--k]; );

	                // E.g. [4, 11, 15] becomes 4bf.
	                for ( i = 0, str = ''; i <= k; str += ALPHABET.charAt( xc[i++] ) );
	                str = toFixedPoint( str, e );
	            }

	            // The caller will add the sign.
	            return str;
	        }


	        // Perform division in the specified base. Called by div and convertBase.
	        div = (function () {

	            // Assume non-zero x and k.
	            function multiply( x, k, base ) {
	                var m, temp, xlo, xhi,
	                    carry = 0,
	                    i = x.length,
	                    klo = k % SQRT_BASE,
	                    khi = k / SQRT_BASE | 0;

	                for ( x = x.slice(); i--; ) {
	                    xlo = x[i] % SQRT_BASE;
	                    xhi = x[i] / SQRT_BASE | 0;
	                    m = khi * xlo + xhi * klo;
	                    temp = klo * xlo + ( ( m % SQRT_BASE ) * SQRT_BASE ) + carry;
	                    carry = ( temp / base | 0 ) + ( m / SQRT_BASE | 0 ) + khi * xhi;
	                    x[i] = temp % base;
	                }

	                if (carry) x.unshift(carry);

	                return x;
	            }

	            function compare( a, b, aL, bL ) {
	                var i, cmp;

	                if ( aL != bL ) {
	                    cmp = aL > bL ? 1 : -1;
	                } else {

	                    for ( i = cmp = 0; i < aL; i++ ) {

	                        if ( a[i] != b[i] ) {
	                            cmp = a[i] > b[i] ? 1 : -1;
	                            break;
	                        }
	                    }
	                }
	                return cmp;
	            }

	            function subtract( a, b, aL, base ) {
	                var i = 0;

	                // Subtract b from a.
	                for ( ; aL--; ) {
	                    a[aL] -= i;
	                    i = a[aL] < b[aL] ? 1 : 0;
	                    a[aL] = i * base + a[aL] - b[aL];
	                }

	                // Remove leading zeros.
	                for ( ; !a[0] && a.length > 1; a.shift() );
	            }

	            // x: dividend, y: divisor.
	            return function ( x, y, dp, rm, base ) {
	                var cmp, e, i, more, n, prod, prodL, q, qc, rem, remL, rem0, xi, xL, yc0,
	                    yL, yz,
	                    s = x.s == y.s ? 1 : -1,
	                    xc = x.c,
	                    yc = y.c;

	                // Either NaN, Infinity or 0?
	                if ( !xc || !xc[0] || !yc || !yc[0] ) {

	                    return new BigNumber(

	                      // Return NaN if either NaN, or both Infinity or 0.
	                      !x.s || !y.s || ( xc ? yc && xc[0] == yc[0] : !yc ) ? NaN :

	                        // Return ±0 if x is ±0 or y is ±Infinity, or return ±Infinity as y is ±0.
	                        xc && xc[0] == 0 || !yc ? s * 0 : s / 0
	                    );
	                }

	                q = new BigNumber(s);
	                qc = q.c = [];
	                e = x.e - y.e;
	                s = dp + e + 1;

	                if ( !base ) {
	                    base = BASE;
	                    e = bitFloor( x.e / LOG_BASE ) - bitFloor( y.e / LOG_BASE );
	                    s = s / LOG_BASE | 0;
	                }

	                // Result exponent may be one less then the current value of e.
	                // The coefficients of the BigNumbers from convertBase may have trailing zeros.
	                for ( i = 0; yc[i] == ( xc[i] || 0 ); i++ );
	                if ( yc[i] > ( xc[i] || 0 ) ) e--;

	                if ( s < 0 ) {
	                    qc.push(1);
	                    more = true;
	                } else {
	                    xL = xc.length;
	                    yL = yc.length;
	                    i = 0;
	                    s += 2;

	                    // Normalise xc and yc so highest order digit of yc is >= base / 2.

	                    n = mathfloor( base / ( yc[0] + 1 ) );

	                    // Not necessary, but to handle odd bases where yc[0] == ( base / 2 ) - 1.
	                    // if ( n > 1 || n++ == 1 && yc[0] < base / 2 ) {
	                    if ( n > 1 ) {
	                        yc = multiply( yc, n, base );
	                        xc = multiply( xc, n, base );
	                        yL = yc.length;
	                        xL = xc.length;
	                    }

	                    xi = yL;
	                    rem = xc.slice( 0, yL );
	                    remL = rem.length;

	                    // Add zeros to make remainder as long as divisor.
	                    for ( ; remL < yL; rem[remL++] = 0 );
	                    yz = yc.slice();
	                    yz.unshift(0);
	                    yc0 = yc[0];
	                    if ( yc[1] >= base / 2 ) yc0++;
	                    // Not necessary, but to prevent trial digit n > base, when using base 3.
	                    // else if ( base == 3 && yc0 == 1 ) yc0 = 1 + 1e-15;

	                    do {
	                        n = 0;

	                        // Compare divisor and remainder.
	                        cmp = compare( yc, rem, yL, remL );

	                        // If divisor < remainder.
	                        if ( cmp < 0 ) {

	                            // Calculate trial digit, n.

	                            rem0 = rem[0];
	                            if ( yL != remL ) rem0 = rem0 * base + ( rem[1] || 0 );

	                            // n is how many times the divisor goes into the current remainder.
	                            n = mathfloor( rem0 / yc0 );

	                            //  Algorithm:
	                            //  1. product = divisor * trial digit (n)
	                            //  2. if product > remainder: product -= divisor, n--
	                            //  3. remainder -= product
	                            //  4. if product was < remainder at 2:
	                            //    5. compare new remainder and divisor
	                            //    6. If remainder > divisor: remainder -= divisor, n++

	                            if ( n > 1 ) {

	                                // n may be > base only when base is 3.
	                                if (n >= base) n = base - 1;

	                                // product = divisor * trial digit.
	                                prod = multiply( yc, n, base );
	                                prodL = prod.length;
	                                remL = rem.length;

	                                // Compare product and remainder.
	                                // If product > remainder.
	                                // Trial digit n too high.
	                                // n is 1 too high about 5% of the time, and is not known to have
	                                // ever been more than 1 too high.
	                                while ( compare( prod, rem, prodL, remL ) == 1 ) {
	                                    n--;

	                                    // Subtract divisor from product.
	                                    subtract( prod, yL < prodL ? yz : yc, prodL, base );
	                                    prodL = prod.length;
	                                    cmp = 1;
	                                }
	                            } else {

	                                // n is 0 or 1, cmp is -1.
	                                // If n is 0, there is no need to compare yc and rem again below,
	                                // so change cmp to 1 to avoid it.
	                                // If n is 1, leave cmp as -1, so yc and rem are compared again.
	                                if ( n == 0 ) {

	                                    // divisor < remainder, so n must be at least 1.
	                                    cmp = n = 1;
	                                }

	                                // product = divisor
	                                prod = yc.slice();
	                                prodL = prod.length;
	                            }

	                            if ( prodL < remL ) prod.unshift(0);

	                            // Subtract product from remainder.
	                            subtract( rem, prod, remL, base );
	                            remL = rem.length;

	                             // If product was < remainder.
	                            if ( cmp == -1 ) {

	                                // Compare divisor and new remainder.
	                                // If divisor < new remainder, subtract divisor from remainder.
	                                // Trial digit n too low.
	                                // n is 1 too low about 5% of the time, and very rarely 2 too low.
	                                while ( compare( yc, rem, yL, remL ) < 1 ) {
	                                    n++;

	                                    // Subtract divisor from remainder.
	                                    subtract( rem, yL < remL ? yz : yc, remL, base );
	                                    remL = rem.length;
	                                }
	                            }
	                        } else if ( cmp === 0 ) {
	                            n++;
	                            rem = [0];
	                        } // else cmp === 1 and n will be 0

	                        // Add the next digit, n, to the result array.
	                        qc[i++] = n;

	                        // Update the remainder.
	                        if ( rem[0] ) {
	                            rem[remL++] = xc[xi] || 0;
	                        } else {
	                            rem = [ xc[xi] ];
	                            remL = 1;
	                        }
	                    } while ( ( xi++ < xL || rem[0] != null ) && s-- );

	                    more = rem[0] != null;

	                    // Leading zero?
	                    if ( !qc[0] ) qc.shift();
	                }

	                if ( base == BASE ) {

	                    // To calculate q.e, first get the number of digits of qc[0].
	                    for ( i = 1, s = qc[0]; s >= 10; s /= 10, i++ );
	                    round( q, dp + ( q.e = i + e * LOG_BASE - 1 ) + 1, rm, more );

	                // Caller is convertBase.
	                } else {
	                    q.e = e;
	                    q.r = +more;
	                }

	                return q;
	            };
	        })();


	        /*
	         * Return a string representing the value of BigNumber n in fixed-point or exponential
	         * notation rounded to the specified decimal places or significant digits.
	         *
	         * n is a BigNumber.
	         * i is the index of the last digit required (i.e. the digit that may be rounded up).
	         * rm is the rounding mode.
	         * caller is caller id: toExponential 19, toFixed 20, toFormat 21, toPrecision 24.
	         */
	        function format( n, i, rm, caller ) {
	            var c0, e, ne, len, str;

	            rm = rm != null && isValidInt( rm, 0, 8, caller, roundingMode )
	              ? rm | 0 : ROUNDING_MODE;

	            if ( !n.c ) return n.toString();
	            c0 = n.c[0];
	            ne = n.e;

	            if ( i == null ) {
	                str = coeffToString( n.c );
	                str = caller == 19 || caller == 24 && ne <= TO_EXP_NEG
	                  ? toExponential( str, ne )
	                  : toFixedPoint( str, ne );
	            } else {
	                n = round( new BigNumber(n), i, rm );

	                // n.e may have changed if the value was rounded up.
	                e = n.e;

	                str = coeffToString( n.c );
	                len = str.length;

	                // toPrecision returns exponential notation if the number of significant digits
	                // specified is less than the number of digits necessary to represent the integer
	                // part of the value in fixed-point notation.

	                // Exponential notation.
	                if ( caller == 19 || caller == 24 && ( i <= e || e <= TO_EXP_NEG ) ) {

	                    // Append zeros?
	                    for ( ; len < i; str += '0', len++ );
	                    str = toExponential( str, e );

	                // Fixed-point notation.
	                } else {
	                    i -= ne;
	                    str = toFixedPoint( str, e );

	                    // Append zeros?
	                    if ( e + 1 > len ) {
	                        if ( --i > 0 ) for ( str += '.'; i--; str += '0' );
	                    } else {
	                        i += e - len;
	                        if ( i > 0 ) {
	                            if ( e + 1 == len ) str += '.';
	                            for ( ; i--; str += '0' );
	                        }
	                    }
	                }
	            }

	            return n.s < 0 && c0 ? '-' + str : str;
	        }


	        // Handle BigNumber.max and BigNumber.min.
	        function maxOrMin( args, method ) {
	            var m, n,
	                i = 0;

	            if ( isArray( args[0] ) ) args = args[0];
	            m = new BigNumber( args[0] );

	            for ( ; ++i < args.length; ) {
	                n = new BigNumber( args[i] );

	                // If any number is NaN, return NaN.
	                if ( !n.s ) {
	                    m = n;
	                    break;
	                } else if ( method.call( m, n ) ) {
	                    m = n;
	                }
	            }

	            return m;
	        }


	        /*
	         * Return true if n is an integer in range, otherwise throw.
	         * Use for argument validation when ERRORS is true.
	         */
	        function intValidatorWithErrors( n, min, max, caller, name ) {
	            if ( n < min || n > max || n != truncate(n) ) {
	                raise( caller, ( name || 'decimal places' ) +
	                  ( n < min || n > max ? ' out of range' : ' not an integer' ), n );
	            }

	            return true;
	        }


	        /*
	         * Strip trailing zeros, calculate base 10 exponent and check against MIN_EXP and MAX_EXP.
	         * Called by minus, plus and times.
	         */
	        function normalise( n, c, e ) {
	            var i = 1,
	                j = c.length;

	             // Remove trailing zeros.
	            for ( ; !c[--j]; c.pop() );

	            // Calculate the base 10 exponent. First get the number of digits of c[0].
	            for ( j = c[0]; j >= 10; j /= 10, i++ );

	            // Overflow?
	            if ( ( e = i + e * LOG_BASE - 1 ) > MAX_EXP ) {

	                // Infinity.
	                n.c = n.e = null;

	            // Underflow?
	            } else if ( e < MIN_EXP ) {

	                // Zero.
	                n.c = [ n.e = 0 ];
	            } else {
	                n.e = e;
	                n.c = c;
	            }

	            return n;
	        }


	        // Handle values that fail the validity test in BigNumber.
	        parseNumeric = (function () {
	            var basePrefix = /^(-?)0([xbo])(?=\w[\w.]*$)/i,
	                dotAfter = /^([^.]+)\.$/,
	                dotBefore = /^\.([^.]+)$/,
	                isInfinityOrNaN = /^-?(Infinity|NaN)$/,
	                whitespaceOrPlus = /^\s*\+(?=[\w.])|^\s+|\s+$/g;

	            return function ( x, str, num, b ) {
	                var base,
	                    s = num ? str : str.replace( whitespaceOrPlus, '' );

	                // No exception on ±Infinity or NaN.
	                if ( isInfinityOrNaN.test(s) ) {
	                    x.s = isNaN(s) ? null : s < 0 ? -1 : 1;
	                } else {
	                    if ( !num ) {

	                        // basePrefix = /^(-?)0([xbo])(?=\w[\w.]*$)/i
	                        s = s.replace( basePrefix, function ( m, p1, p2 ) {
	                            base = ( p2 = p2.toLowerCase() ) == 'x' ? 16 : p2 == 'b' ? 2 : 8;
	                            return !b || b == base ? p1 : m;
	                        });

	                        if (b) {
	                            base = b;

	                            // E.g. '1.' to '1', '.1' to '0.1'
	                            s = s.replace( dotAfter, '$1' ).replace( dotBefore, '0.$1' );
	                        }

	                        if ( str != s ) return new BigNumber( s, base );
	                    }

	                    // 'new BigNumber() not a number: {n}'
	                    // 'new BigNumber() not a base {b} number: {n}'
	                    if (ERRORS) raise( id, 'not a' + ( b ? ' base ' + b : '' ) + ' number', str );
	                    x.s = null;
	                }

	                x.c = x.e = null;
	                id = 0;
	            }
	        })();


	        // Throw a BigNumber Error.
	        function raise( caller, msg, val ) {
	            var error = new Error( [
	                'new BigNumber',     // 0
	                'cmp',               // 1
	                'config',            // 2
	                'div',               // 3
	                'divToInt',          // 4
	                'eq',                // 5
	                'gt',                // 6
	                'gte',               // 7
	                'lt',                // 8
	                'lte',               // 9
	                'minus',             // 10
	                'mod',               // 11
	                'plus',              // 12
	                'precision',         // 13
	                'random',            // 14
	                'round',             // 15
	                'shift',             // 16
	                'times',             // 17
	                'toDigits',          // 18
	                'toExponential',     // 19
	                'toFixed',           // 20
	                'toFormat',          // 21
	                'toFraction',        // 22
	                'pow',               // 23
	                'toPrecision',       // 24
	                'toString',          // 25
	                'BigNumber'          // 26
	            ][caller] + '() ' + msg + ': ' + val );

	            error.name = 'BigNumber Error';
	            id = 0;
	            throw error;
	        }


	        /*
	         * Round x to sd significant digits using rounding mode rm. Check for over/under-flow.
	         * If r is truthy, it is known that there are more digits after the rounding digit.
	         */
	        function round( x, sd, rm, r ) {
	            var d, i, j, k, n, ni, rd,
	                xc = x.c,
	                pows10 = POWS_TEN;

	            // if x is not Infinity or NaN...
	            if (xc) {

	                // rd is the rounding digit, i.e. the digit after the digit that may be rounded up.
	                // n is a base 1e14 number, the value of the element of array x.c containing rd.
	                // ni is the index of n within x.c.
	                // d is the number of digits of n.
	                // i is the index of rd within n including leading zeros.
	                // j is the actual index of rd within n (if < 0, rd is a leading zero).
	                out: {

	                    // Get the number of digits of the first element of xc.
	                    for ( d = 1, k = xc[0]; k >= 10; k /= 10, d++ );
	                    i = sd - d;

	                    // If the rounding digit is in the first element of xc...
	                    if ( i < 0 ) {
	                        i += LOG_BASE;
	                        j = sd;
	                        n = xc[ ni = 0 ];

	                        // Get the rounding digit at index j of n.
	                        rd = n / pows10[ d - j - 1 ] % 10 | 0;
	                    } else {
	                        ni = mathceil( ( i + 1 ) / LOG_BASE );

	                        if ( ni >= xc.length ) {

	                            if (r) {

	                                // Needed by sqrt.
	                                for ( ; xc.length <= ni; xc.push(0) );
	                                n = rd = 0;
	                                d = 1;
	                                i %= LOG_BASE;
	                                j = i - LOG_BASE + 1;
	                            } else {
	                                break out;
	                            }
	                        } else {
	                            n = k = xc[ni];

	                            // Get the number of digits of n.
	                            for ( d = 1; k >= 10; k /= 10, d++ );

	                            // Get the index of rd within n.
	                            i %= LOG_BASE;

	                            // Get the index of rd within n, adjusted for leading zeros.
	                            // The number of leading zeros of n is given by LOG_BASE - d.
	                            j = i - LOG_BASE + d;

	                            // Get the rounding digit at index j of n.
	                            rd = j < 0 ? 0 : n / pows10[ d - j - 1 ] % 10 | 0;
	                        }
	                    }

	                    r = r || sd < 0 ||

	                    // Are there any non-zero digits after the rounding digit?
	                    // The expression  n % pows10[ d - j - 1 ]  returns all digits of n to the right
	                    // of the digit at j, e.g. if n is 908714 and j is 2, the expression gives 714.
	                      xc[ni + 1] != null || ( j < 0 ? n : n % pows10[ d - j - 1 ] );

	                    r = rm < 4
	                      ? ( rd || r ) && ( rm == 0 || rm == ( x.s < 0 ? 3 : 2 ) )
	                      : rd > 5 || rd == 5 && ( rm == 4 || r || rm == 6 &&

	                        // Check whether the digit to the left of the rounding digit is odd.
	                        ( ( i > 0 ? j > 0 ? n / pows10[ d - j ] : 0 : xc[ni - 1] ) % 10 ) & 1 ||
	                          rm == ( x.s < 0 ? 8 : 7 ) );

	                    if ( sd < 1 || !xc[0] ) {
	                        xc.length = 0;

	                        if (r) {

	                            // Convert sd to decimal places.
	                            sd -= x.e + 1;

	                            // 1, 0.1, 0.01, 0.001, 0.0001 etc.
	                            xc[0] = pows10[ sd % LOG_BASE ];
	                            x.e = -sd || 0;
	                        } else {

	                            // Zero.
	                            xc[0] = x.e = 0;
	                        }

	                        return x;
	                    }

	                    // Remove excess digits.
	                    if ( i == 0 ) {
	                        xc.length = ni;
	                        k = 1;
	                        ni--;
	                    } else {
	                        xc.length = ni + 1;
	                        k = pows10[ LOG_BASE - i ];

	                        // E.g. 56700 becomes 56000 if 7 is the rounding digit.
	                        // j > 0 means i > number of leading zeros of n.
	                        xc[ni] = j > 0 ? mathfloor( n / pows10[ d - j ] % pows10[j] ) * k : 0;
	                    }

	                    // Round up?
	                    if (r) {

	                        for ( ; ; ) {

	                            // If the digit to be rounded up is in the first element of xc...
	                            if ( ni == 0 ) {

	                                // i will be the length of xc[0] before k is added.
	                                for ( i = 1, j = xc[0]; j >= 10; j /= 10, i++ );
	                                j = xc[0] += k;
	                                for ( k = 1; j >= 10; j /= 10, k++ );

	                                // if i != k the length has increased.
	                                if ( i != k ) {
	                                    x.e++;
	                                    if ( xc[0] == BASE ) xc[0] = 1;
	                                }

	                                break;
	                            } else {
	                                xc[ni] += k;
	                                if ( xc[ni] != BASE ) break;
	                                xc[ni--] = 0;
	                                k = 1;
	                            }
	                        }
	                    }

	                    // Remove trailing zeros.
	                    for ( i = xc.length; xc[--i] === 0; xc.pop() );
	                }

	                // Overflow? Infinity.
	                if ( x.e > MAX_EXP ) {
	                    x.c = x.e = null;

	                // Underflow? Zero.
	                } else if ( x.e < MIN_EXP ) {
	                    x.c = [ x.e = 0 ];
	                }
	            }

	            return x;
	        }


	        // PROTOTYPE/INSTANCE METHODS


	        /*
	         * Return a new BigNumber whose value is the absolute value of this BigNumber.
	         */
	        P.absoluteValue = P.abs = function () {
	            var x = new BigNumber(this);
	            if ( x.s < 0 ) x.s = 1;
	            return x;
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber rounded to a whole
	         * number in the direction of Infinity.
	         */
	        P.ceil = function () {
	            return round( new BigNumber(this), this.e + 1, 2 );
	        };


	        /*
	         * Return
	         * 1 if the value of this BigNumber is greater than the value of BigNumber(y, b),
	         * -1 if the value of this BigNumber is less than the value of BigNumber(y, b),
	         * 0 if they have the same value,
	         * or null if the value of either is NaN.
	         */
	        P.comparedTo = P.cmp = function ( y, b ) {
	            id = 1;
	            return compare( this, new BigNumber( y, b ) );
	        };


	        /*
	         * Return the number of decimal places of the value of this BigNumber, or null if the value
	         * of this BigNumber is ±Infinity or NaN.
	         */
	        P.decimalPlaces = P.dp = function () {
	            var n, v,
	                c = this.c;

	            if ( !c ) return null;
	            n = ( ( v = c.length - 1 ) - bitFloor( this.e / LOG_BASE ) ) * LOG_BASE;

	            // Subtract the number of trailing zeros of the last number.
	            if ( v = c[v] ) for ( ; v % 10 == 0; v /= 10, n-- );
	            if ( n < 0 ) n = 0;

	            return n;
	        };


	        /*
	         *  n / 0 = I
	         *  n / N = N
	         *  n / I = 0
	         *  0 / n = 0
	         *  0 / 0 = N
	         *  0 / N = N
	         *  0 / I = 0
	         *  N / n = N
	         *  N / 0 = N
	         *  N / N = N
	         *  N / I = N
	         *  I / n = I
	         *  I / 0 = I
	         *  I / N = N
	         *  I / I = N
	         *
	         * Return a new BigNumber whose value is the value of this BigNumber divided by the value of
	         * BigNumber(y, b), rounded according to DECIMAL_PLACES and ROUNDING_MODE.
	         */
	        P.dividedBy = P.div = function ( y, b ) {
	            id = 3;
	            return div( this, new BigNumber( y, b ), DECIMAL_PLACES, ROUNDING_MODE );
	        };


	        /*
	         * Return a new BigNumber whose value is the integer part of dividing the value of this
	         * BigNumber by the value of BigNumber(y, b).
	         */
	        P.dividedToIntegerBy = P.divToInt = function ( y, b ) {
	            id = 4;
	            return div( this, new BigNumber( y, b ), 0, 1 );
	        };


	        /*
	         * Return true if the value of this BigNumber is equal to the value of BigNumber(y, b),
	         * otherwise returns false.
	         */
	        P.equals = P.eq = function ( y, b ) {
	            id = 5;
	            return compare( this, new BigNumber( y, b ) ) === 0;
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber rounded to a whole
	         * number in the direction of -Infinity.
	         */
	        P.floor = function () {
	            return round( new BigNumber(this), this.e + 1, 3 );
	        };


	        /*
	         * Return true if the value of this BigNumber is greater than the value of BigNumber(y, b),
	         * otherwise returns false.
	         */
	        P.greaterThan = P.gt = function ( y, b ) {
	            id = 6;
	            return compare( this, new BigNumber( y, b ) ) > 0;
	        };


	        /*
	         * Return true if the value of this BigNumber is greater than or equal to the value of
	         * BigNumber(y, b), otherwise returns false.
	         */
	        P.greaterThanOrEqualTo = P.gte = function ( y, b ) {
	            id = 7;
	            return ( b = compare( this, new BigNumber( y, b ) ) ) === 1 || b === 0;

	        };


	        /*
	         * Return true if the value of this BigNumber is a finite number, otherwise returns false.
	         */
	        P.isFinite = function () {
	            return !!this.c;
	        };


	        /*
	         * Return true if the value of this BigNumber is an integer, otherwise return false.
	         */
	        P.isInteger = P.isInt = function () {
	            return !!this.c && bitFloor( this.e / LOG_BASE ) > this.c.length - 2;
	        };


	        /*
	         * Return true if the value of this BigNumber is NaN, otherwise returns false.
	         */
	        P.isNaN = function () {
	            return !this.s;
	        };


	        /*
	         * Return true if the value of this BigNumber is negative, otherwise returns false.
	         */
	        P.isNegative = P.isNeg = function () {
	            return this.s < 0;
	        };


	        /*
	         * Return true if the value of this BigNumber is 0 or -0, otherwise returns false.
	         */
	        P.isZero = function () {
	            return !!this.c && this.c[0] == 0;
	        };


	        /*
	         * Return true if the value of this BigNumber is less than the value of BigNumber(y, b),
	         * otherwise returns false.
	         */
	        P.lessThan = P.lt = function ( y, b ) {
	            id = 8;
	            return compare( this, new BigNumber( y, b ) ) < 0;
	        };


	        /*
	         * Return true if the value of this BigNumber is less than or equal to the value of
	         * BigNumber(y, b), otherwise returns false.
	         */
	        P.lessThanOrEqualTo = P.lte = function ( y, b ) {
	            id = 9;
	            return ( b = compare( this, new BigNumber( y, b ) ) ) === -1 || b === 0;
	        };


	        /*
	         *  n - 0 = n
	         *  n - N = N
	         *  n - I = -I
	         *  0 - n = -n
	         *  0 - 0 = 0
	         *  0 - N = N
	         *  0 - I = -I
	         *  N - n = N
	         *  N - 0 = N
	         *  N - N = N
	         *  N - I = N
	         *  I - n = I
	         *  I - 0 = I
	         *  I - N = N
	         *  I - I = N
	         *
	         * Return a new BigNumber whose value is the value of this BigNumber minus the value of
	         * BigNumber(y, b).
	         */
	        P.minus = P.sub = function ( y, b ) {
	            var i, j, t, xLTy,
	                x = this,
	                a = x.s;

	            id = 10;
	            y = new BigNumber( y, b );
	            b = y.s;

	            // Either NaN?
	            if ( !a || !b ) return new BigNumber(NaN);

	            // Signs differ?
	            if ( a != b ) {
	                y.s = -b;
	                return x.plus(y);
	            }

	            var xe = x.e / LOG_BASE,
	                ye = y.e / LOG_BASE,
	                xc = x.c,
	                yc = y.c;

	            if ( !xe || !ye ) {

	                // Either Infinity?
	                if ( !xc || !yc ) return xc ? ( y.s = -b, y ) : new BigNumber( yc ? x : NaN );

	                // Either zero?
	                if ( !xc[0] || !yc[0] ) {

	                    // Return y if y is non-zero, x if x is non-zero, or zero if both are zero.
	                    return yc[0] ? ( y.s = -b, y ) : new BigNumber( xc[0] ? x :

	                      // IEEE 754 (2008) 6.3: n - n = -0 when rounding to -Infinity
	                      ROUNDING_MODE == 3 ? -0 : 0 );
	                }
	            }

	            xe = bitFloor(xe);
	            ye = bitFloor(ye);
	            xc = xc.slice();

	            // Determine which is the bigger number.
	            if ( a = xe - ye ) {

	                if ( xLTy = a < 0 ) {
	                    a = -a;
	                    t = xc;
	                } else {
	                    ye = xe;
	                    t = yc;
	                }

	                t.reverse();

	                // Prepend zeros to equalise exponents.
	                for ( b = a; b--; t.push(0) );
	                t.reverse();
	            } else {

	                // Exponents equal. Check digit by digit.
	                j = ( xLTy = ( a = xc.length ) < ( b = yc.length ) ) ? a : b;

	                for ( a = b = 0; b < j; b++ ) {

	                    if ( xc[b] != yc[b] ) {
	                        xLTy = xc[b] < yc[b];
	                        break;
	                    }
	                }
	            }

	            // x < y? Point xc to the array of the bigger number.
	            if (xLTy) t = xc, xc = yc, yc = t, y.s = -y.s;

	            b = ( j = yc.length ) - ( i = xc.length );

	            // Append zeros to xc if shorter.
	            // No need to add zeros to yc if shorter as subtract only needs to start at yc.length.
	            if ( b > 0 ) for ( ; b--; xc[i++] = 0 );
	            b = BASE - 1;

	            // Subtract yc from xc.
	            for ( ; j > a; ) {

	                if ( xc[--j] < yc[j] ) {
	                    for ( i = j; i && !xc[--i]; xc[i] = b );
	                    --xc[i];
	                    xc[j] += BASE;
	                }

	                xc[j] -= yc[j];
	            }

	            // Remove leading zeros and adjust exponent accordingly.
	            for ( ; xc[0] == 0; xc.shift(), --ye );

	            // Zero?
	            if ( !xc[0] ) {

	                // Following IEEE 754 (2008) 6.3,
	                // n - n = +0  but  n - n = -0  when rounding towards -Infinity.
	                y.s = ROUNDING_MODE == 3 ? -1 : 1;
	                y.c = [ y.e = 0 ];
	                return y;
	            }

	            // No need to check for Infinity as +x - +y != Infinity && -x - -y != Infinity
	            // for finite x and y.
	            return normalise( y, xc, ye );
	        };


	        /*
	         *   n % 0 =  N
	         *   n % N =  N
	         *   n % I =  n
	         *   0 % n =  0
	         *  -0 % n = -0
	         *   0 % 0 =  N
	         *   0 % N =  N
	         *   0 % I =  0
	         *   N % n =  N
	         *   N % 0 =  N
	         *   N % N =  N
	         *   N % I =  N
	         *   I % n =  N
	         *   I % 0 =  N
	         *   I % N =  N
	         *   I % I =  N
	         *
	         * Return a new BigNumber whose value is the value of this BigNumber modulo the value of
	         * BigNumber(y, b). The result depends on the value of MODULO_MODE.
	         */
	        P.modulo = P.mod = function ( y, b ) {
	            var q, s,
	                x = this;

	            id = 11;
	            y = new BigNumber( y, b );

	            // Return NaN if x is Infinity or NaN, or y is NaN or zero.
	            if ( !x.c || !y.s || y.c && !y.c[0] ) {
	                return new BigNumber(NaN);

	            // Return x if y is Infinity or x is zero.
	            } else if ( !y.c || x.c && !x.c[0] ) {
	                return new BigNumber(x);
	            }

	            if ( MODULO_MODE == 9 ) {

	                // Euclidian division: q = sign(y) * floor(x / abs(y))
	                // r = x - qy    where  0 <= r < abs(y)
	                s = y.s;
	                y.s = 1;
	                q = div( x, y, 0, 3 );
	                y.s = s;
	                q.s *= s;
	            } else {
	                q = div( x, y, 0, MODULO_MODE );
	            }

	            return x.minus( q.times(y) );
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber negated,
	         * i.e. multiplied by -1.
	         */
	        P.negated = P.neg = function () {
	            var x = new BigNumber(this);
	            x.s = -x.s || null;
	            return x;
	        };


	        /*
	         *  n + 0 = n
	         *  n + N = N
	         *  n + I = I
	         *  0 + n = n
	         *  0 + 0 = 0
	         *  0 + N = N
	         *  0 + I = I
	         *  N + n = N
	         *  N + 0 = N
	         *  N + N = N
	         *  N + I = N
	         *  I + n = I
	         *  I + 0 = I
	         *  I + N = N
	         *  I + I = I
	         *
	         * Return a new BigNumber whose value is the value of this BigNumber plus the value of
	         * BigNumber(y, b).
	         */
	        P.plus = P.add = function ( y, b ) {
	            var t,
	                x = this,
	                a = x.s;

	            id = 12;
	            y = new BigNumber( y, b );
	            b = y.s;

	            // Either NaN?
	            if ( !a || !b ) return new BigNumber(NaN);

	            // Signs differ?
	             if ( a != b ) {
	                y.s = -b;
	                return x.minus(y);
	            }

	            var xe = x.e / LOG_BASE,
	                ye = y.e / LOG_BASE,
	                xc = x.c,
	                yc = y.c;

	            if ( !xe || !ye ) {

	                // Return ±Infinity if either ±Infinity.
	                if ( !xc || !yc ) return new BigNumber( a / 0 );

	                // Either zero?
	                // Return y if y is non-zero, x if x is non-zero, or zero if both are zero.
	                if ( !xc[0] || !yc[0] ) return yc[0] ? y : new BigNumber( xc[0] ? x : a * 0 );
	            }

	            xe = bitFloor(xe);
	            ye = bitFloor(ye);
	            xc = xc.slice();

	            // Prepend zeros to equalise exponents. Faster to use reverse then do unshifts.
	            if ( a = xe - ye ) {
	                if ( a > 0 ) {
	                    ye = xe;
	                    t = yc;
	                } else {
	                    a = -a;
	                    t = xc;
	                }

	                t.reverse();
	                for ( ; a--; t.push(0) );
	                t.reverse();
	            }

	            a = xc.length;
	            b = yc.length;

	            // Point xc to the longer array, and b to the shorter length.
	            if ( a - b < 0 ) t = yc, yc = xc, xc = t, b = a;

	            // Only start adding at yc.length - 1 as the further digits of xc can be ignored.
	            for ( a = 0; b; ) {
	                a = ( xc[--b] = xc[b] + yc[b] + a ) / BASE | 0;
	                xc[b] %= BASE;
	            }

	            if (a) {
	                xc.unshift(a);
	                ++ye;
	            }

	            // No need to check for zero, as +x + +y != 0 && -x + -y != 0
	            // ye = MAX_EXP + 1 possible
	            return normalise( y, xc, ye );
	        };


	        /*
	         * Return the number of significant digits of the value of this BigNumber.
	         *
	         * [z] {boolean|number} Whether to count integer-part trailing zeros: true, false, 1 or 0.
	         */
	        P.precision = P.sd = function (z) {
	            var n, v,
	                x = this,
	                c = x.c;

	            // 'precision() argument not a boolean or binary digit: {z}'
	            if ( z != null && z !== !!z && z !== 1 && z !== 0 ) {
	                if (ERRORS) raise( 13, 'argument' + notBool, z );
	                if ( z != !!z ) z = null;
	            }

	            if ( !c ) return null;
	            v = c.length - 1;
	            n = v * LOG_BASE + 1;

	            if ( v = c[v] ) {

	                // Subtract the number of trailing zeros of the last element.
	                for ( ; v % 10 == 0; v /= 10, n-- );

	                // Add the number of digits of the first element.
	                for ( v = c[0]; v >= 10; v /= 10, n++ );
	            }

	            if ( z && x.e + 1 > n ) n = x.e + 1;

	            return n;
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber rounded to a maximum of
	         * dp decimal places using rounding mode rm, or to 0 and ROUNDING_MODE respectively if
	         * omitted.
	         *
	         * [dp] {number} Decimal places. Integer, 0 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'round() decimal places out of range: {dp}'
	         * 'round() decimal places not an integer: {dp}'
	         * 'round() rounding mode not an integer: {rm}'
	         * 'round() rounding mode out of range: {rm}'
	         */
	        P.round = function ( dp, rm ) {
	            var n = new BigNumber(this);

	            if ( dp == null || isValidInt( dp, 0, MAX, 15 ) ) {
	                round( n, ~~dp + this.e + 1, rm == null ||
	                  !isValidInt( rm, 0, 8, 15, roundingMode ) ? ROUNDING_MODE : rm | 0 );
	            }

	            return n;
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber shifted by k places
	         * (powers of 10). Shift to the right if n > 0, and to the left if n < 0.
	         *
	         * k {number} Integer, -MAX_SAFE_INTEGER to MAX_SAFE_INTEGER inclusive.
	         *
	         * If k is out of range and ERRORS is false, the result will be ±0 if k < 0, or ±Infinity
	         * otherwise.
	         *
	         * 'shift() argument not an integer: {k}'
	         * 'shift() argument out of range: {k}'
	         */
	        P.shift = function (k) {
	            var n = this;
	            return isValidInt( k, -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER, 16, 'argument' )

	              // k < 1e+21, or truncate(k) will produce exponential notation.
	              ? n.times( '1e' + truncate(k) )
	              : new BigNumber( n.c && n.c[0] && ( k < -MAX_SAFE_INTEGER || k > MAX_SAFE_INTEGER )
	                ? n.s * ( k < 0 ? 0 : 1 / 0 )
	                : n );
	        };


	        /*
	         *  sqrt(-n) =  N
	         *  sqrt( N) =  N
	         *  sqrt(-I) =  N
	         *  sqrt( I) =  I
	         *  sqrt( 0) =  0
	         *  sqrt(-0) = -0
	         *
	         * Return a new BigNumber whose value is the square root of the value of this BigNumber,
	         * rounded according to DECIMAL_PLACES and ROUNDING_MODE.
	         */
	        P.squareRoot = P.sqrt = function () {
	            var m, n, r, rep, t,
	                x = this,
	                c = x.c,
	                s = x.s,
	                e = x.e,
	                dp = DECIMAL_PLACES + 4,
	                half = new BigNumber('0.5');

	            // Negative/NaN/Infinity/zero?
	            if ( s !== 1 || !c || !c[0] ) {
	                return new BigNumber( !s || s < 0 && ( !c || c[0] ) ? NaN : c ? x : 1 / 0 );
	            }

	            // Initial estimate.
	            s = Math.sqrt( +x );

	            // Math.sqrt underflow/overflow?
	            // Pass x to Math.sqrt as integer, then adjust the exponent of the result.
	            if ( s == 0 || s == 1 / 0 ) {
	                n = coeffToString(c);
	                if ( ( n.length + e ) % 2 == 0 ) n += '0';
	                s = Math.sqrt(n);
	                e = bitFloor( ( e + 1 ) / 2 ) - ( e < 0 || e % 2 );

	                if ( s == 1 / 0 ) {
	                    n = '1e' + e;
	                } else {
	                    n = s.toExponential();
	                    n = n.slice( 0, n.indexOf('e') + 1 ) + e;
	                }

	                r = new BigNumber(n);
	            } else {
	                r = new BigNumber( s + '' );
	            }

	            // Check for zero.
	            // r could be zero if MIN_EXP is changed after the this value was created.
	            // This would cause a division by zero (x/t) and hence Infinity below, which would cause
	            // coeffToString to throw.
	            if ( r.c[0] ) {
	                e = r.e;
	                s = e + dp;
	                if ( s < 3 ) s = 0;

	                // Newton-Raphson iteration.
	                for ( ; ; ) {
	                    t = r;
	                    r = half.times( t.plus( div( x, t, dp, 1 ) ) );

	                    if ( coeffToString( t.c   ).slice( 0, s ) === ( n =
	                         coeffToString( r.c ) ).slice( 0, s ) ) {

	                        // The exponent of r may here be one less than the final result exponent,
	                        // e.g 0.0009999 (e-4) --> 0.001 (e-3), so adjust s so the rounding digits
	                        // are indexed correctly.
	                        if ( r.e < e ) --s;
	                        n = n.slice( s - 3, s + 1 );

	                        // The 4th rounding digit may be in error by -1 so if the 4 rounding digits
	                        // are 9999 or 4999 (i.e. approaching a rounding boundary) continue the
	                        // iteration.
	                        if ( n == '9999' || !rep && n == '4999' ) {

	                            // On the first iteration only, check to see if rounding up gives the
	                            // exact result as the nines may infinitely repeat.
	                            if ( !rep ) {
	                                round( t, t.e + DECIMAL_PLACES + 2, 0 );

	                                if ( t.times(t).eq(x) ) {
	                                    r = t;
	                                    break;
	                                }
	                            }

	                            dp += 4;
	                            s += 4;
	                            rep = 1;
	                        } else {

	                            // If rounding digits are null, 0{0,4} or 50{0,3}, check for exact
	                            // result. If not, then there are further digits and m will be truthy.
	                            if ( !+n || !+n.slice(1) && n.charAt(0) == '5' ) {

	                                // Truncate to the first rounding digit.
	                                round( r, r.e + DECIMAL_PLACES + 2, 1 );
	                                m = !r.times(r).eq(x);
	                            }

	                            break;
	                        }
	                    }
	                }
	            }

	            return round( r, r.e + DECIMAL_PLACES + 1, ROUNDING_MODE, m );
	        };


	        /*
	         *  n * 0 = 0
	         *  n * N = N
	         *  n * I = I
	         *  0 * n = 0
	         *  0 * 0 = 0
	         *  0 * N = N
	         *  0 * I = N
	         *  N * n = N
	         *  N * 0 = N
	         *  N * N = N
	         *  N * I = N
	         *  I * n = I
	         *  I * 0 = N
	         *  I * N = N
	         *  I * I = I
	         *
	         * Return a new BigNumber whose value is the value of this BigNumber times the value of
	         * BigNumber(y, b).
	         */
	        P.times = P.mul = function ( y, b ) {
	            var c, e, i, j, k, m, xcL, xlo, xhi, ycL, ylo, yhi, zc,
	                base, sqrtBase,
	                x = this,
	                xc = x.c,
	                yc = ( id = 17, y = new BigNumber( y, b ) ).c;

	            // Either NaN, ±Infinity or ±0?
	            if ( !xc || !yc || !xc[0] || !yc[0] ) {

	                // Return NaN if either is NaN, or one is 0 and the other is Infinity.
	                if ( !x.s || !y.s || xc && !xc[0] && !yc || yc && !yc[0] && !xc ) {
	                    y.c = y.e = y.s = null;
	                } else {
	                    y.s *= x.s;

	                    // Return ±Infinity if either is ±Infinity.
	                    if ( !xc || !yc ) {
	                        y.c = y.e = null;

	                    // Return ±0 if either is ±0.
	                    } else {
	                        y.c = [0];
	                        y.e = 0;
	                    }
	                }

	                return y;
	            }

	            e = bitFloor( x.e / LOG_BASE ) + bitFloor( y.e / LOG_BASE );
	            y.s *= x.s;
	            xcL = xc.length;
	            ycL = yc.length;

	            // Ensure xc points to longer array and xcL to its length.
	            if ( xcL < ycL ) zc = xc, xc = yc, yc = zc, i = xcL, xcL = ycL, ycL = i;

	            // Initialise the result array with zeros.
	            for ( i = xcL + ycL, zc = []; i--; zc.push(0) );

	            base = BASE;
	            sqrtBase = SQRT_BASE;

	            for ( i = ycL; --i >= 0; ) {
	                c = 0;
	                ylo = yc[i] % sqrtBase;
	                yhi = yc[i] / sqrtBase | 0;

	                for ( k = xcL, j = i + k; j > i; ) {
	                    xlo = xc[--k] % sqrtBase;
	                    xhi = xc[k] / sqrtBase | 0;
	                    m = yhi * xlo + xhi * ylo;
	                    xlo = ylo * xlo + ( ( m % sqrtBase ) * sqrtBase ) + zc[j] + c;
	                    c = ( xlo / base | 0 ) + ( m / sqrtBase | 0 ) + yhi * xhi;
	                    zc[j--] = xlo % base;
	                }

	                zc[j] = c;
	            }

	            if (c) {
	                ++e;
	            } else {
	                zc.shift();
	            }

	            return normalise( y, zc, e );
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber rounded to a maximum of
	         * sd significant digits using rounding mode rm, or ROUNDING_MODE if rm is omitted.
	         *
	         * [sd] {number} Significant digits. Integer, 1 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'toDigits() precision out of range: {sd}'
	         * 'toDigits() precision not an integer: {sd}'
	         * 'toDigits() rounding mode not an integer: {rm}'
	         * 'toDigits() rounding mode out of range: {rm}'
	         */
	        P.toDigits = function ( sd, rm ) {
	            var n = new BigNumber(this);
	            sd = sd == null || !isValidInt( sd, 1, MAX, 18, 'precision' ) ? null : sd | 0;
	            rm = rm == null || !isValidInt( rm, 0, 8, 18, roundingMode ) ? ROUNDING_MODE : rm | 0;
	            return sd ? round( n, sd, rm ) : n;
	        };


	        /*
	         * Return a string representing the value of this BigNumber in exponential notation and
	         * rounded using ROUNDING_MODE to dp fixed decimal places.
	         *
	         * [dp] {number} Decimal places. Integer, 0 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'toExponential() decimal places not an integer: {dp}'
	         * 'toExponential() decimal places out of range: {dp}'
	         * 'toExponential() rounding mode not an integer: {rm}'
	         * 'toExponential() rounding mode out of range: {rm}'
	         */
	        P.toExponential = function ( dp, rm ) {
	            return format( this,
	              dp != null && isValidInt( dp, 0, MAX, 19 ) ? ~~dp + 1 : null, rm, 19 );
	        };


	        /*
	         * Return a string representing the value of this BigNumber in fixed-point notation rounding
	         * to dp fixed decimal places using rounding mode rm, or ROUNDING_MODE if rm is omitted.
	         *
	         * Note: as with JavaScript's number type, (-0).toFixed(0) is '0',
	         * but e.g. (-0.00001).toFixed(0) is '-0'.
	         *
	         * [dp] {number} Decimal places. Integer, 0 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'toFixed() decimal places not an integer: {dp}'
	         * 'toFixed() decimal places out of range: {dp}'
	         * 'toFixed() rounding mode not an integer: {rm}'
	         * 'toFixed() rounding mode out of range: {rm}'
	         */
	        P.toFixed = function ( dp, rm ) {
	            return format( this, dp != null && isValidInt( dp, 0, MAX, 20 )
	              ? ~~dp + this.e + 1 : null, rm, 20 );
	        };


	        /*
	         * Return a string representing the value of this BigNumber in fixed-point notation rounded
	         * using rm or ROUNDING_MODE to dp decimal places, and formatted according to the properties
	         * of the FORMAT object (see BigNumber.config).
	         *
	         * FORMAT = {
	         *      decimalSeparator : '.',
	         *      groupSeparator : ',',
	         *      groupSize : 3,
	         *      secondaryGroupSize : 0,
	         *      fractionGroupSeparator : '\xA0',    // non-breaking space
	         *      fractionGroupSize : 0
	         * };
	         *
	         * [dp] {number} Decimal places. Integer, 0 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'toFormat() decimal places not an integer: {dp}'
	         * 'toFormat() decimal places out of range: {dp}'
	         * 'toFormat() rounding mode not an integer: {rm}'
	         * 'toFormat() rounding mode out of range: {rm}'
	         */
	        P.toFormat = function ( dp, rm ) {
	            var str = format( this, dp != null && isValidInt( dp, 0, MAX, 21 )
	              ? ~~dp + this.e + 1 : null, rm, 21 );

	            if ( this.c ) {
	                var i,
	                    arr = str.split('.'),
	                    g1 = +FORMAT.groupSize,
	                    g2 = +FORMAT.secondaryGroupSize,
	                    groupSeparator = FORMAT.groupSeparator,
	                    intPart = arr[0],
	                    fractionPart = arr[1],
	                    isNeg = this.s < 0,
	                    intDigits = isNeg ? intPart.slice(1) : intPart,
	                    len = intDigits.length;

	                if (g2) i = g1, g1 = g2, g2 = i, len -= i;

	                if ( g1 > 0 && len > 0 ) {
	                    i = len % g1 || g1;
	                    intPart = intDigits.substr( 0, i );

	                    for ( ; i < len; i += g1 ) {
	                        intPart += groupSeparator + intDigits.substr( i, g1 );
	                    }

	                    if ( g2 > 0 ) intPart += groupSeparator + intDigits.slice(i);
	                    if (isNeg) intPart = '-' + intPart;
	                }

	                str = fractionPart
	                  ? intPart + FORMAT.decimalSeparator + ( ( g2 = +FORMAT.fractionGroupSize )
	                    ? fractionPart.replace( new RegExp( '\\d{' + g2 + '}\\B', 'g' ),
	                      '$&' + FORMAT.fractionGroupSeparator )
	                    : fractionPart )
	                  : intPart;
	            }

	            return str;
	        };


	        /*
	         * Return a string array representing the value of this BigNumber as a simple fraction with
	         * an integer numerator and an integer denominator. The denominator will be a positive
	         * non-zero value less than or equal to the specified maximum denominator. If a maximum
	         * denominator is not specified, the denominator will be the lowest value necessary to
	         * represent the number exactly.
	         *
	         * [md] {number|string|BigNumber} Integer >= 1 and < Infinity. The maximum denominator.
	         *
	         * 'toFraction() max denominator not an integer: {md}'
	         * 'toFraction() max denominator out of range: {md}'
	         */
	        P.toFraction = function (md) {
	            var arr, d0, d2, e, exp, n, n0, q, s,
	                k = ERRORS,
	                x = this,
	                xc = x.c,
	                d = new BigNumber(ONE),
	                n1 = d0 = new BigNumber(ONE),
	                d1 = n0 = new BigNumber(ONE);

	            if ( md != null ) {
	                ERRORS = false;
	                n = new BigNumber(md);
	                ERRORS = k;

	                if ( !( k = n.isInt() ) || n.lt(ONE) ) {

	                    if (ERRORS) {
	                        raise( 22,
	                          'max denominator ' + ( k ? 'out of range' : 'not an integer' ), md );
	                    }

	                    // ERRORS is false:
	                    // If md is a finite non-integer >= 1, round it to an integer and use it.
	                    md = !k && n.c && round( n, n.e + 1, 1 ).gte(ONE) ? n : null;
	                }
	            }

	            if ( !xc ) return x.toString();
	            s = coeffToString(xc);

	            // Determine initial denominator.
	            // d is a power of 10 and the minimum max denominator that specifies the value exactly.
	            e = d.e = s.length - x.e - 1;
	            d.c[0] = POWS_TEN[ ( exp = e % LOG_BASE ) < 0 ? LOG_BASE + exp : exp ];
	            md = !md || n.cmp(d) > 0 ? ( e > 0 ? d : n1 ) : n;

	            exp = MAX_EXP;
	            MAX_EXP = 1 / 0;
	            n = new BigNumber(s);

	            // n0 = d1 = 0
	            n0.c[0] = 0;

	            for ( ; ; )  {
	                q = div( n, d, 0, 1 );
	                d2 = d0.plus( q.times(d1) );
	                if ( d2.cmp(md) == 1 ) break;
	                d0 = d1;
	                d1 = d2;
	                n1 = n0.plus( q.times( d2 = n1 ) );
	                n0 = d2;
	                d = n.minus( q.times( d2 = d ) );
	                n = d2;
	            }

	            d2 = div( md.minus(d0), d1, 0, 1 );
	            n0 = n0.plus( d2.times(n1) );
	            d0 = d0.plus( d2.times(d1) );
	            n0.s = n1.s = x.s;
	            e *= 2;

	            // Determine which fraction is closer to x, n0/d0 or n1/d1
	            arr = div( n1, d1, e, ROUNDING_MODE ).minus(x).abs().cmp(
	                  div( n0, d0, e, ROUNDING_MODE ).minus(x).abs() ) < 1
	                    ? [ n1.toString(), d1.toString() ]
	                    : [ n0.toString(), d0.toString() ];

	            MAX_EXP = exp;
	            return arr;
	        };


	        /*
	         * Return the value of this BigNumber converted to a number primitive.
	         */
	        P.toNumber = function () {
	            var x = this;

	            // Ensure zero has correct sign.
	            return +x || ( x.s ? x.s * 0 : NaN );
	        };


	        /*
	         * Return a BigNumber whose value is the value of this BigNumber raised to the power n.
	         * If n is negative round according to DECIMAL_PLACES and ROUNDING_MODE.
	         * If POW_PRECISION is not 0, round to POW_PRECISION using ROUNDING_MODE.
	         *
	         * n {number} Integer, -9007199254740992 to 9007199254740992 inclusive.
	         * (Performs 54 loop iterations for n of 9007199254740992.)
	         *
	         * 'pow() exponent not an integer: {n}'
	         * 'pow() exponent out of range: {n}'
	         */
	        P.toPower = P.pow = function (n) {
	            var k, y,
	                i = mathfloor( n < 0 ? -n : +n ),
	                x = this;

	            // Pass ±Infinity to Math.pow if exponent is out of range.
	            if ( !isValidInt( n, -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER, 23, 'exponent' ) &&
	              ( !isFinite(n) || i > MAX_SAFE_INTEGER && ( n /= 0 ) ||
	                parseFloat(n) != n && !( n = NaN ) ) ) {
	                return new BigNumber( Math.pow( +x, n ) );
	            }

	            // Truncating each coefficient array to a length of k after each multiplication equates
	            // to truncating significant digits to POW_PRECISION + [28, 41], i.e. there will be a
	            // minimum of 28 guard digits retained. (Using + 1.5 would give [9, 21] guard digits.)
	            k = POW_PRECISION ? mathceil( POW_PRECISION / LOG_BASE + 2 ) : 0;
	            y = new BigNumber(ONE);

	            for ( ; ; ) {

	                if ( i % 2 ) {
	                    y = y.times(x);
	                    if ( !y.c ) break;
	                    if ( k && y.c.length > k ) y.c.length = k;
	                }

	                i = mathfloor( i / 2 );
	                if ( !i ) break;

	                x = x.times(x);
	                if ( k && x.c && x.c.length > k ) x.c.length = k;
	            }

	            if ( n < 0 ) y = ONE.div(y);
	            return k ? round( y, POW_PRECISION, ROUNDING_MODE ) : y;
	        };


	        /*
	         * Return a string representing the value of this BigNumber rounded to sd significant digits
	         * using rounding mode rm or ROUNDING_MODE. If sd is less than the number of digits
	         * necessary to represent the integer part of the value in fixed-point notation, then use
	         * exponential notation.
	         *
	         * [sd] {number} Significant digits. Integer, 1 to MAX inclusive.
	         * [rm] {number} Rounding mode. Integer, 0 to 8 inclusive.
	         *
	         * 'toPrecision() precision not an integer: {sd}'
	         * 'toPrecision() precision out of range: {sd}'
	         * 'toPrecision() rounding mode not an integer: {rm}'
	         * 'toPrecision() rounding mode out of range: {rm}'
	         */
	        P.toPrecision = function ( sd, rm ) {
	            return format( this, sd != null && isValidInt( sd, 1, MAX, 24, 'precision' )
	              ? sd | 0 : null, rm, 24 );
	        };


	        /*
	         * Return a string representing the value of this BigNumber in base b, or base 10 if b is
	         * omitted. If a base is specified, including base 10, round according to DECIMAL_PLACES and
	         * ROUNDING_MODE. If a base is not specified, and this BigNumber has a positive exponent
	         * that is equal to or greater than TO_EXP_POS, or a negative exponent equal to or less than
	         * TO_EXP_NEG, return exponential notation.
	         *
	         * [b] {number} Integer, 2 to 64 inclusive.
	         *
	         * 'toString() base not an integer: {b}'
	         * 'toString() base out of range: {b}'
	         */
	        P.toString = function (b) {
	            var str,
	                n = this,
	                s = n.s,
	                e = n.e;

	            // Infinity or NaN?
	            if ( e === null ) {

	                if (s) {
	                    str = 'Infinity';
	                    if ( s < 0 ) str = '-' + str;
	                } else {
	                    str = 'NaN';
	                }
	            } else {
	                str = coeffToString( n.c );

	                if ( b == null || !isValidInt( b, 2, 64, 25, 'base' ) ) {
	                    str = e <= TO_EXP_NEG || e >= TO_EXP_POS
	                      ? toExponential( str, e )
	                      : toFixedPoint( str, e );
	                } else {
	                    str = convertBase( toFixedPoint( str, e ), b | 0, 10, s );
	                }

	                if ( s < 0 && n.c[0] ) str = '-' + str;
	            }

	            return str;
	        };


	        /*
	         * Return a new BigNumber whose value is the value of this BigNumber truncated to a whole
	         * number.
	         */
	        P.truncated = P.trunc = function () {
	            return round( new BigNumber(this), this.e + 1, 1 );
	        };



	        /*
	         * Return as toString, but do not accept a base argument.
	         */
	        P.valueOf = P.toJSON = function () {
	            return this.toString();
	        };


	        // Aliases for BigDecimal methods.
	        //P.add = P.plus;         // P.add included above
	        //P.subtract = P.minus;   // P.sub included above
	        //P.multiply = P.times;   // P.mul included above
	        //P.divide = P.div;
	        //P.remainder = P.mod;
	        //P.compareTo = P.cmp;
	        //P.negate = P.neg;


	        if ( configObj != null ) BigNumber.config(configObj);

	        return BigNumber;
	    }


	    // PRIVATE HELPER FUNCTIONS


	    function bitFloor(n) {
	        var i = n | 0;
	        return n > 0 || n === i ? i : i - 1;
	    }


	    // Return a coefficient array as a string of base 10 digits.
	    function coeffToString(a) {
	        var s, z,
	            i = 1,
	            j = a.length,
	            r = a[0] + '';

	        for ( ; i < j; ) {
	            s = a[i++] + '';
	            z = LOG_BASE - s.length;
	            for ( ; z--; s = '0' + s );
	            r += s;
	        }

	        // Determine trailing zeros.
	        for ( j = r.length; r.charCodeAt(--j) === 48; );
	        return r.slice( 0, j + 1 || 1 );
	    }


	    // Compare the value of BigNumbers x and y.
	    function compare( x, y ) {
	        var a, b,
	            xc = x.c,
	            yc = y.c,
	            i = x.s,
	            j = y.s,
	            k = x.e,
	            l = y.e;

	        // Either NaN?
	        if ( !i || !j ) return null;

	        a = xc && !xc[0];
	        b = yc && !yc[0];

	        // Either zero?
	        if ( a || b ) return a ? b ? 0 : -j : i;

	        // Signs differ?
	        if ( i != j ) return i;

	        a = i < 0;
	        b = k == l;

	        // Either Infinity?
	        if ( !xc || !yc ) return b ? 0 : !xc ^ a ? 1 : -1;

	        // Compare exponents.
	        if ( !b ) return k > l ^ a ? 1 : -1;

	        j = ( k = xc.length ) < ( l = yc.length ) ? k : l;

	        // Compare digit by digit.
	        for ( i = 0; i < j; i++ ) if ( xc[i] != yc[i] ) return xc[i] > yc[i] ^ a ? 1 : -1;

	        // Compare lengths.
	        return k == l ? 0 : k > l ^ a ? 1 : -1;
	    }


	    /*
	     * Return true if n is a valid number in range, otherwise false.
	     * Use for argument validation when ERRORS is false.
	     * Note: parseInt('1e+1') == 1 but parseFloat('1e+1') == 10.
	     */
	    function intValidatorNoErrors( n, min, max ) {
	        return ( n = truncate(n) ) >= min && n <= max;
	    }


	    function isArray(obj) {
	        return Object.prototype.toString.call(obj) == '[object Array]';
	    }


	    /*
	     * Convert string of baseIn to an array of numbers of baseOut.
	     * Eg. convertBase('255', 10, 16) returns [15, 15].
	     * Eg. convertBase('ff', 16, 10) returns [2, 5, 5].
	     */
	    function toBaseOut( str, baseIn, baseOut ) {
	        var j,
	            arr = [0],
	            arrL,
	            i = 0,
	            len = str.length;

	        for ( ; i < len; ) {
	            for ( arrL = arr.length; arrL--; arr[arrL] *= baseIn );
	            arr[ j = 0 ] += ALPHABET.indexOf( str.charAt( i++ ) );

	            for ( ; j < arr.length; j++ ) {

	                if ( arr[j] > baseOut - 1 ) {
	                    if ( arr[j + 1] == null ) arr[j + 1] = 0;
	                    arr[j + 1] += arr[j] / baseOut | 0;
	                    arr[j] %= baseOut;
	                }
	            }
	        }

	        return arr.reverse();
	    }


	    function toExponential( str, e ) {
	        return ( str.length > 1 ? str.charAt(0) + '.' + str.slice(1) : str ) +
	          ( e < 0 ? 'e' : 'e+' ) + e;
	    }


	    function toFixedPoint( str, e ) {
	        var len, z;

	        // Negative exponent?
	        if ( e < 0 ) {

	            // Prepend zeros.
	            for ( z = '0.'; ++e; z += '0' );
	            str = z + str;

	        // Positive exponent
	        } else {
	            len = str.length;

	            // Append zeros.
	            if ( ++e > len ) {
	                for ( z = '0', e -= len; --e; z += '0' );
	                str += z;
	            } else if ( e < len ) {
	                str = str.slice( 0, e ) + '.' + str.slice(e);
	            }
	        }

	        return str;
	    }


	    function truncate(n) {
	        n = parseFloat(n);
	        return n < 0 ? mathceil(n) : mathfloor(n);
	    }


	    // EXPORT


	    BigNumber = another();

	    // AMD.
	    if ( true ) {
	        !(__WEBPACK_AMD_DEFINE_RESULT__ = function () { return BigNumber; }.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

	    // Node and other environments that support module.exports.
	    } else if ( typeof module != 'undefined' && module.exports ) {
	        module.exports = BigNumber;
	        if ( !crypto ) try { crypto = require('crypto'); } catch (e) {}

	    // Browser.
	    } else {
	        global.BigNumber = BigNumber;
	    }
	})(this);


/***/ },
/* 50 */
/***/ function(module, exports, __webpack_require__) {

	;(function () { // closure for web browsers

	if (typeof module === 'object' && module.exports) {
	  module.exports = LRUCache
	} else {
	  // just set the global for non-node platforms.
	  this.LRUCache = LRUCache
	}

	function hOP (obj, key) {
	  return Object.prototype.hasOwnProperty.call(obj, key)
	}

	function naiveLength () { return 1 }

	function LRUCache (options) {
	  if (!(this instanceof LRUCache))
	    return new LRUCache(options)

	  if (typeof options === 'number')
	    options = { max: options }

	  if (!options)
	    options = {}

	  this._max = options.max
	  // Kind of weird to have a default max of Infinity, but oh well.
	  if (!this._max || !(typeof this._max === "number") || this._max <= 0 )
	    this._max = Infinity

	  this._lengthCalculator = options.length || naiveLength
	  if (typeof this._lengthCalculator !== "function")
	    this._lengthCalculator = naiveLength

	  this._allowStale = options.stale || false
	  this._maxAge = options.maxAge || null
	  this._dispose = options.dispose
	  this.reset()
	}

	// resize the cache when the max changes.
	Object.defineProperty(LRUCache.prototype, "max",
	  { set : function (mL) {
	      if (!mL || !(typeof mL === "number") || mL <= 0 ) mL = Infinity
	      this._max = mL
	      if (this._length > this._max) trim(this)
	    }
	  , get : function () { return this._max }
	  , enumerable : true
	  })

	// resize the cache when the lengthCalculator changes.
	Object.defineProperty(LRUCache.prototype, "lengthCalculator",
	  { set : function (lC) {
	      if (typeof lC !== "function") {
	        this._lengthCalculator = naiveLength
	        this._length = this._itemCount
	        for (var key in this._cache) {
	          this._cache[key].length = 1
	        }
	      } else {
	        this._lengthCalculator = lC
	        this._length = 0
	        for (var key in this._cache) {
	          this._cache[key].length = this._lengthCalculator(this._cache[key].value)
	          this._length += this._cache[key].length
	        }
	      }

	      if (this._length > this._max) trim(this)
	    }
	  , get : function () { return this._lengthCalculator }
	  , enumerable : true
	  })

	Object.defineProperty(LRUCache.prototype, "length",
	  { get : function () { return this._length }
	  , enumerable : true
	  })


	Object.defineProperty(LRUCache.prototype, "itemCount",
	  { get : function () { return this._itemCount }
	  , enumerable : true
	  })

	LRUCache.prototype.forEach = function (fn, thisp) {
	  thisp = thisp || this
	  var i = 0;
	  for (var k = this._mru - 1; k >= 0 && i < this._itemCount; k--) if (this._lruList[k]) {
	    i++
	    var hit = this._lruList[k]
	    if (this._maxAge && (Date.now() - hit.now > this._maxAge)) {
	      del(this, hit)
	      if (!this._allowStale) hit = undefined
	    }
	    if (hit) {
	      fn.call(thisp, hit.value, hit.key, this)
	    }
	  }
	}

	LRUCache.prototype.keys = function () {
	  var keys = new Array(this._itemCount)
	  var i = 0
	  for (var k = this._mru - 1; k >= 0 && i < this._itemCount; k--) if (this._lruList[k]) {
	    var hit = this._lruList[k]
	    keys[i++] = hit.key
	  }
	  return keys
	}

	LRUCache.prototype.values = function () {
	  var values = new Array(this._itemCount)
	  var i = 0
	  for (var k = this._mru - 1; k >= 0 && i < this._itemCount; k--) if (this._lruList[k]) {
	    var hit = this._lruList[k]
	    values[i++] = hit.value
	  }
	  return values
	}

	LRUCache.prototype.reset = function () {
	  if (this._dispose && this._cache) {
	    for (var k in this._cache) {
	      this._dispose(k, this._cache[k].value)
	    }
	  }

	  this._cache = Object.create(null) // hash of items by key
	  this._lruList = Object.create(null) // list of items in order of use recency
	  this._mru = 0 // most recently used
	  this._lru = 0 // least recently used
	  this._length = 0 // number of items in the list
	  this._itemCount = 0
	}

	// Provided for debugging/dev purposes only. No promises whatsoever that
	// this API stays stable.
	LRUCache.prototype.dump = function () {
	  return this._cache
	}

	LRUCache.prototype.dumpLru = function () {
	  return this._lruList
	}

	LRUCache.prototype.set = function (key, value) {
	  if (hOP(this._cache, key)) {
	    // dispose of the old one before overwriting
	    if (this._dispose) this._dispose(key, this._cache[key].value)
	    if (this._maxAge) this._cache[key].now = Date.now()
	    this._cache[key].value = value
	    this.get(key)
	    return true
	  }

	  var len = this._lengthCalculator(value)
	  var age = this._maxAge ? Date.now() : 0
	  var hit = new Entry(key, value, this._mru++, len, age)

	  // oversized objects fall out of cache automatically.
	  if (hit.length > this._max) {
	    if (this._dispose) this._dispose(key, value)
	    return false
	  }

	  this._length += hit.length
	  this._lruList[hit.lu] = this._cache[key] = hit
	  this._itemCount ++

	  if (this._length > this._max) trim(this)
	  return true
	}

	LRUCache.prototype.has = function (key) {
	  if (!hOP(this._cache, key)) return false
	  var hit = this._cache[key]
	  if (this._maxAge && (Date.now() - hit.now > this._maxAge)) {
	    return false
	  }
	  return true
	}

	LRUCache.prototype.get = function (key) {
	  return get(this, key, true)
	}

	LRUCache.prototype.peek = function (key) {
	  return get(this, key, false)
	}

	LRUCache.prototype.pop = function () {
	  var hit = this._lruList[this._lru]
	  del(this, hit)
	  return hit || null
	}

	LRUCache.prototype.del = function (key) {
	  del(this, this._cache[key])
	}

	function get (self, key, doUse) {
	  var hit = self._cache[key]
	  if (hit) {
	    if (self._maxAge && (Date.now() - hit.now > self._maxAge)) {
	      del(self, hit)
	      if (!self._allowStale) hit = undefined
	    } else {
	      if (doUse) use(self, hit)
	    }
	    if (hit) hit = hit.value
	  }
	  return hit
	}

	function use (self, hit) {
	  shiftLU(self, hit)
	  hit.lu = self._mru ++
	  if (self._maxAge) hit.now = Date.now()
	  self._lruList[hit.lu] = hit
	}

	function trim (self) {
	  while (self._lru < self._mru && self._length > self._max)
	    del(self, self._lruList[self._lru])
	}

	function shiftLU (self, hit) {
	  delete self._lruList[ hit.lu ]
	  while (self._lru < self._mru && !self._lruList[self._lru]) self._lru ++
	}

	function del (self, hit) {
	  if (hit) {
	    if (self._dispose) self._dispose(hit.key, hit.value)
	    self._length -= hit.length
	    self._itemCount --
	    delete self._cache[ hit.key ]
	    shiftLU(self, hit)
	  }
	}

	// classy, since V8 prefers predictable objects.
	function Entry (key, value, lu, length, now) {
	  this.key = key
	  this.value = value
	  this.lu = lu
	  this.length = length
	  this.now = now
	}

	})()


/***/ },
/* 51 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/* WEBPACK VAR INJECTION */(function(process, setImmediate) {/*!
	 * async
	 * https://github.com/caolan/async
	 *
	 * Copyright 2010-2014 Caolan McMahon
	 * Released under the MIT license
	 */
	/*jshint onevar: false, indent:4 */
	/*global setImmediate: false, setTimeout: false, console: false */
	(function () {

	    var async = {};

	    // global on the server, window in the browser
	    var root, previous_async;

	    root = this;
	    if (root != null) {
	      previous_async = root.async;
	    }

	    async.noConflict = function () {
	        root.async = previous_async;
	        return async;
	    };

	    function only_once(fn) {
	        var called = false;
	        return function() {
	            if (called) throw new Error("Callback was already called.");
	            called = true;
	            fn.apply(root, arguments);
	        }
	    }

	    //// cross-browser compatiblity functions ////

	    var _toString = Object.prototype.toString;

	    var _isArray = Array.isArray || function (obj) {
	        return _toString.call(obj) === '[object Array]';
	    };

	    var _each = function (arr, iterator) {
	        for (var i = 0; i < arr.length; i += 1) {
	            iterator(arr[i], i, arr);
	        }
	    };

	    var _map = function (arr, iterator) {
	        if (arr.map) {
	            return arr.map(iterator);
	        }
	        var results = [];
	        _each(arr, function (x, i, a) {
	            results.push(iterator(x, i, a));
	        });
	        return results;
	    };

	    var _reduce = function (arr, iterator, memo) {
	        if (arr.reduce) {
	            return arr.reduce(iterator, memo);
	        }
	        _each(arr, function (x, i, a) {
	            memo = iterator(memo, x, i, a);
	        });
	        return memo;
	    };

	    var _keys = function (obj) {
	        if (Object.keys) {
	            return Object.keys(obj);
	        }
	        var keys = [];
	        for (var k in obj) {
	            if (obj.hasOwnProperty(k)) {
	                keys.push(k);
	            }
	        }
	        return keys;
	    };

	    //// exported async module functions ////

	    //// nextTick implementation with browser-compatible fallback ////
	    if (typeof process === 'undefined' || !(process.nextTick)) {
	        if (typeof setImmediate === 'function') {
	            async.nextTick = function (fn) {
	                // not a direct alias for IE10 compatibility
	                setImmediate(fn);
	            };
	            async.setImmediate = async.nextTick;
	        }
	        else {
	            async.nextTick = function (fn) {
	                setTimeout(fn, 0);
	            };
	            async.setImmediate = async.nextTick;
	        }
	    }
	    else {
	        async.nextTick = process.nextTick;
	        if (typeof setImmediate !== 'undefined') {
	            async.setImmediate = function (fn) {
	              // not a direct alias for IE10 compatibility
	              setImmediate(fn);
	            };
	        }
	        else {
	            async.setImmediate = async.nextTick;
	        }
	    }

	    async.each = function (arr, iterator, callback) {
	        callback = callback || function () {};
	        if (!arr.length) {
	            return callback();
	        }
	        var completed = 0;
	        _each(arr, function (x) {
	            iterator(x, only_once(done) );
	        });
	        function done(err) {
	          if (err) {
	              callback(err);
	              callback = function () {};
	          }
	          else {
	              completed += 1;
	              if (completed >= arr.length) {
	                  callback();
	              }
	          }
	        }
	    };
	    async.forEach = async.each;

	    async.eachSeries = function (arr, iterator, callback) {
	        callback = callback || function () {};
	        if (!arr.length) {
	            return callback();
	        }
	        var completed = 0;
	        var iterate = function () {
	            iterator(arr[completed], function (err) {
	                if (err) {
	                    callback(err);
	                    callback = function () {};
	                }
	                else {
	                    completed += 1;
	                    if (completed >= arr.length) {
	                        callback();
	                    }
	                    else {
	                        iterate();
	                    }
	                }
	            });
	        };
	        iterate();
	    };
	    async.forEachSeries = async.eachSeries;

	    async.eachLimit = function (arr, limit, iterator, callback) {
	        var fn = _eachLimit(limit);
	        fn.apply(null, [arr, iterator, callback]);
	    };
	    async.forEachLimit = async.eachLimit;

	    var _eachLimit = function (limit) {

	        return function (arr, iterator, callback) {
	            callback = callback || function () {};
	            if (!arr.length || limit <= 0) {
	                return callback();
	            }
	            var completed = 0;
	            var started = 0;
	            var running = 0;

	            (function replenish () {
	                if (completed >= arr.length) {
	                    return callback();
	                }

	                while (running < limit && started < arr.length) {
	                    started += 1;
	                    running += 1;
	                    iterator(arr[started - 1], function (err) {
	                        if (err) {
	                            callback(err);
	                            callback = function () {};
	                        }
	                        else {
	                            completed += 1;
	                            running -= 1;
	                            if (completed >= arr.length) {
	                                callback();
	                            }
	                            else {
	                                replenish();
	                            }
	                        }
	                    });
	                }
	            })();
	        };
	    };


	    var doParallel = function (fn) {
	        return function () {
	            var args = Array.prototype.slice.call(arguments);
	            return fn.apply(null, [async.each].concat(args));
	        };
	    };
	    var doParallelLimit = function(limit, fn) {
	        return function () {
	            var args = Array.prototype.slice.call(arguments);
	            return fn.apply(null, [_eachLimit(limit)].concat(args));
	        };
	    };
	    var doSeries = function (fn) {
	        return function () {
	            var args = Array.prototype.slice.call(arguments);
	            return fn.apply(null, [async.eachSeries].concat(args));
	        };
	    };


	    var _asyncMap = function (eachfn, arr, iterator, callback) {
	        arr = _map(arr, function (x, i) {
	            return {index: i, value: x};
	        });
	        if (!callback) {
	            eachfn(arr, function (x, callback) {
	                iterator(x.value, function (err) {
	                    callback(err);
	                });
	            });
	        } else {
	            var results = [];
	            eachfn(arr, function (x, callback) {
	                iterator(x.value, function (err, v) {
	                    results[x.index] = v;
	                    callback(err);
	                });
	            }, function (err) {
	                callback(err, results);
	            });
	        }
	    };
	    async.map = doParallel(_asyncMap);
	    async.mapSeries = doSeries(_asyncMap);
	    async.mapLimit = function (arr, limit, iterator, callback) {
	        return _mapLimit(limit)(arr, iterator, callback);
	    };

	    var _mapLimit = function(limit) {
	        return doParallelLimit(limit, _asyncMap);
	    };

	    // reduce only has a series version, as doing reduce in parallel won't
	    // work in many situations.
	    async.reduce = function (arr, memo, iterator, callback) {
	        async.eachSeries(arr, function (x, callback) {
	            iterator(memo, x, function (err, v) {
	                memo = v;
	                callback(err);
	            });
	        }, function (err) {
	            callback(err, memo);
	        });
	    };
	    // inject alias
	    async.inject = async.reduce;
	    // foldl alias
	    async.foldl = async.reduce;

	    async.reduceRight = function (arr, memo, iterator, callback) {
	        var reversed = _map(arr, function (x) {
	            return x;
	        }).reverse();
	        async.reduce(reversed, memo, iterator, callback);
	    };
	    // foldr alias
	    async.foldr = async.reduceRight;

	    var _filter = function (eachfn, arr, iterator, callback) {
	        var results = [];
	        arr = _map(arr, function (x, i) {
	            return {index: i, value: x};
	        });
	        eachfn(arr, function (x, callback) {
	            iterator(x.value, function (v) {
	                if (v) {
	                    results.push(x);
	                }
	                callback();
	            });
	        }, function (err) {
	            callback(_map(results.sort(function (a, b) {
	                return a.index - b.index;
	            }), function (x) {
	                return x.value;
	            }));
	        });
	    };
	    async.filter = doParallel(_filter);
	    async.filterSeries = doSeries(_filter);
	    // select alias
	    async.select = async.filter;
	    async.selectSeries = async.filterSeries;

	    var _reject = function (eachfn, arr, iterator, callback) {
	        var results = [];
	        arr = _map(arr, function (x, i) {
	            return {index: i, value: x};
	        });
	        eachfn(arr, function (x, callback) {
	            iterator(x.value, function (v) {
	                if (!v) {
	                    results.push(x);
	                }
	                callback();
	            });
	        }, function (err) {
	            callback(_map(results.sort(function (a, b) {
	                return a.index - b.index;
	            }), function (x) {
	                return x.value;
	            }));
	        });
	    };
	    async.reject = doParallel(_reject);
	    async.rejectSeries = doSeries(_reject);

	    var _detect = function (eachfn, arr, iterator, main_callback) {
	        eachfn(arr, function (x, callback) {
	            iterator(x, function (result) {
	                if (result) {
	                    main_callback(x);
	                    main_callback = function () {};
	                }
	                else {
	                    callback();
	                }
	            });
	        }, function (err) {
	            main_callback();
	        });
	    };
	    async.detect = doParallel(_detect);
	    async.detectSeries = doSeries(_detect);

	    async.some = function (arr, iterator, main_callback) {
	        async.each(arr, function (x, callback) {
	            iterator(x, function (v) {
	                if (v) {
	                    main_callback(true);
	                    main_callback = function () {};
	                }
	                callback();
	            });
	        }, function (err) {
	            main_callback(false);
	        });
	    };
	    // any alias
	    async.any = async.some;

	    async.every = function (arr, iterator, main_callback) {
	        async.each(arr, function (x, callback) {
	            iterator(x, function (v) {
	                if (!v) {
	                    main_callback(false);
	                    main_callback = function () {};
	                }
	                callback();
	            });
	        }, function (err) {
	            main_callback(true);
	        });
	    };
	    // all alias
	    async.all = async.every;

	    async.sortBy = function (arr, iterator, callback) {
	        async.map(arr, function (x, callback) {
	            iterator(x, function (err, criteria) {
	                if (err) {
	                    callback(err);
	                }
	                else {
	                    callback(null, {value: x, criteria: criteria});
	                }
	            });
	        }, function (err, results) {
	            if (err) {
	                return callback(err);
	            }
	            else {
	                var fn = function (left, right) {
	                    var a = left.criteria, b = right.criteria;
	                    return a < b ? -1 : a > b ? 1 : 0;
	                };
	                callback(null, _map(results.sort(fn), function (x) {
	                    return x.value;
	                }));
	            }
	        });
	    };

	    async.auto = function (tasks, callback) {
	        callback = callback || function () {};
	        var keys = _keys(tasks);
	        var remainingTasks = keys.length
	        if (!remainingTasks) {
	            return callback();
	        }

	        var results = {};

	        var listeners = [];
	        var addListener = function (fn) {
	            listeners.unshift(fn);
	        };
	        var removeListener = function (fn) {
	            for (var i = 0; i < listeners.length; i += 1) {
	                if (listeners[i] === fn) {
	                    listeners.splice(i, 1);
	                    return;
	                }
	            }
	        };
	        var taskComplete = function () {
	            remainingTasks--
	            _each(listeners.slice(0), function (fn) {
	                fn();
	            });
	        };

	        addListener(function () {
	            if (!remainingTasks) {
	                var theCallback = callback;
	                // prevent final callback from calling itself if it errors
	                callback = function () {};

	                theCallback(null, results);
	            }
	        });

	        _each(keys, function (k) {
	            var task = _isArray(tasks[k]) ? tasks[k]: [tasks[k]];
	            var taskCallback = function (err) {
	                var args = Array.prototype.slice.call(arguments, 1);
	                if (args.length <= 1) {
	                    args = args[0];
	                }
	                if (err) {
	                    var safeResults = {};
	                    _each(_keys(results), function(rkey) {
	                        safeResults[rkey] = results[rkey];
	                    });
	                    safeResults[k] = args;
	                    callback(err, safeResults);
	                    // stop subsequent errors hitting callback multiple times
	                    callback = function () {};
	                }
	                else {
	                    results[k] = args;
	                    async.setImmediate(taskComplete);
	                }
	            };
	            var requires = task.slice(0, Math.abs(task.length - 1)) || [];
	            var ready = function () {
	                return _reduce(requires, function (a, x) {
	                    return (a && results.hasOwnProperty(x));
	                }, true) && !results.hasOwnProperty(k);
	            };
	            if (ready()) {
	                task[task.length - 1](taskCallback, results);
	            }
	            else {
	                var listener = function () {
	                    if (ready()) {
	                        removeListener(listener);
	                        task[task.length - 1](taskCallback, results);
	                    }
	                };
	                addListener(listener);
	            }
	        });
	    };

	    async.retry = function(times, task, callback) {
	        var DEFAULT_TIMES = 5;
	        var attempts = [];
	        // Use defaults if times not passed
	        if (typeof times === 'function') {
	            callback = task;
	            task = times;
	            times = DEFAULT_TIMES;
	        }
	        // Make sure times is a number
	        times = parseInt(times, 10) || DEFAULT_TIMES;
	        var wrappedTask = function(wrappedCallback, wrappedResults) {
	            var retryAttempt = function(task, finalAttempt) {
	                return function(seriesCallback) {
	                    task(function(err, result){
	                        seriesCallback(!err || finalAttempt, {err: err, result: result});
	                    }, wrappedResults);
	                };
	            };
	            while (times) {
	                attempts.push(retryAttempt(task, !(times-=1)));
	            }
	            async.series(attempts, function(done, data){
	                data = data[data.length - 1];
	                (wrappedCallback || callback)(data.err, data.result);
	            });
	        }
	        // If a callback is passed, run this as a controll flow
	        return callback ? wrappedTask() : wrappedTask
	    };

	    async.waterfall = function (tasks, callback) {
	        callback = callback || function () {};
	        if (!_isArray(tasks)) {
	          var err = new Error('First argument to waterfall must be an array of functions');
	          return callback(err);
	        }
	        if (!tasks.length) {
	            return callback();
	        }
	        var wrapIterator = function (iterator) {
	            return function (err) {
	                if (err) {
	                    callback.apply(null, arguments);
	                    callback = function () {};
	                }
	                else {
	                    var args = Array.prototype.slice.call(arguments, 1);
	                    var next = iterator.next();
	                    if (next) {
	                        args.push(wrapIterator(next));
	                    }
	                    else {
	                        args.push(callback);
	                    }
	                    async.setImmediate(function () {
	                        iterator.apply(null, args);
	                    });
	                }
	            };
	        };
	        wrapIterator(async.iterator(tasks))();
	    };

	    var _parallel = function(eachfn, tasks, callback) {
	        callback = callback || function () {};
	        if (_isArray(tasks)) {
	            eachfn.map(tasks, function (fn, callback) {
	                if (fn) {
	                    fn(function (err) {
	                        var args = Array.prototype.slice.call(arguments, 1);
	                        if (args.length <= 1) {
	                            args = args[0];
	                        }
	                        callback.call(null, err, args);
	                    });
	                }
	            }, callback);
	        }
	        else {
	            var results = {};
	            eachfn.each(_keys(tasks), function (k, callback) {
	                tasks[k](function (err) {
	                    var args = Array.prototype.slice.call(arguments, 1);
	                    if (args.length <= 1) {
	                        args = args[0];
	                    }
	                    results[k] = args;
	                    callback(err);
	                });
	            }, function (err) {
	                callback(err, results);
	            });
	        }
	    };

	    async.parallel = function (tasks, callback) {
	        _parallel({ map: async.map, each: async.each }, tasks, callback);
	    };

	    async.parallelLimit = function(tasks, limit, callback) {
	        _parallel({ map: _mapLimit(limit), each: _eachLimit(limit) }, tasks, callback);
	    };

	    async.series = function (tasks, callback) {
	        callback = callback || function () {};
	        if (_isArray(tasks)) {
	            async.mapSeries(tasks, function (fn, callback) {
	                if (fn) {
	                    fn(function (err) {
	                        var args = Array.prototype.slice.call(arguments, 1);
	                        if (args.length <= 1) {
	                            args = args[0];
	                        }
	                        callback.call(null, err, args);
	                    });
	                }
	            }, callback);
	        }
	        else {
	            var results = {};
	            async.eachSeries(_keys(tasks), function (k, callback) {
	                tasks[k](function (err) {
	                    var args = Array.prototype.slice.call(arguments, 1);
	                    if (args.length <= 1) {
	                        args = args[0];
	                    }
	                    results[k] = args;
	                    callback(err);
	                });
	            }, function (err) {
	                callback(err, results);
	            });
	        }
	    };

	    async.iterator = function (tasks) {
	        var makeCallback = function (index) {
	            var fn = function () {
	                if (tasks.length) {
	                    tasks[index].apply(null, arguments);
	                }
	                return fn.next();
	            };
	            fn.next = function () {
	                return (index < tasks.length - 1) ? makeCallback(index + 1): null;
	            };
	            return fn;
	        };
	        return makeCallback(0);
	    };

	    async.apply = function (fn) {
	        var args = Array.prototype.slice.call(arguments, 1);
	        return function () {
	            return fn.apply(
	                null, args.concat(Array.prototype.slice.call(arguments))
	            );
	        };
	    };

	    var _concat = function (eachfn, arr, fn, callback) {
	        var r = [];
	        eachfn(arr, function (x, cb) {
	            fn(x, function (err, y) {
	                r = r.concat(y || []);
	                cb(err);
	            });
	        }, function (err) {
	            callback(err, r);
	        });
	    };
	    async.concat = doParallel(_concat);
	    async.concatSeries = doSeries(_concat);

	    async.whilst = function (test, iterator, callback) {
	        if (test()) {
	            iterator(function (err) {
	                if (err) {
	                    return callback(err);
	                }
	                async.whilst(test, iterator, callback);
	            });
	        }
	        else {
	            callback();
	        }
	    };

	    async.doWhilst = function (iterator, test, callback) {
	        iterator(function (err) {
	            if (err) {
	                return callback(err);
	            }
	            var args = Array.prototype.slice.call(arguments, 1);
	            if (test.apply(null, args)) {
	                async.doWhilst(iterator, test, callback);
	            }
	            else {
	                callback();
	            }
	        });
	    };

	    async.until = function (test, iterator, callback) {
	        if (!test()) {
	            iterator(function (err) {
	                if (err) {
	                    return callback(err);
	                }
	                async.until(test, iterator, callback);
	            });
	        }
	        else {
	            callback();
	        }
	    };

	    async.doUntil = function (iterator, test, callback) {
	        iterator(function (err) {
	            if (err) {
	                return callback(err);
	            }
	            var args = Array.prototype.slice.call(arguments, 1);
	            if (!test.apply(null, args)) {
	                async.doUntil(iterator, test, callback);
	            }
	            else {
	                callback();
	            }
	        });
	    };

	    async.queue = function (worker, concurrency) {
	        if (concurrency === undefined) {
	            concurrency = 1;
	        }
	        function _insert(q, data, pos, callback) {
	          if (!q.started){
	            q.started = true;
	          }
	          if (!_isArray(data)) {
	              data = [data];
	          }
	          if(data.length == 0) {
	             // call drain immediately if there are no tasks
	             return async.setImmediate(function() {
	                 if (q.drain) {
	                     q.drain();
	                 }
	             });
	          }
	          _each(data, function(task) {
	              var item = {
	                  data: task,
	                  callback: typeof callback === 'function' ? callback : null
	              };

	              if (pos) {
	                q.tasks.unshift(item);
	              } else {
	                q.tasks.push(item);
	              }

	              if (q.saturated && q.tasks.length === q.concurrency) {
	                  q.saturated();
	              }
	              async.setImmediate(q.process);
	          });
	        }

	        var workers = 0;
	        var q = {
	            tasks: [],
	            concurrency: concurrency,
	            saturated: null,
	            empty: null,
	            drain: null,
	            started: false,
	            paused: false,
	            push: function (data, callback) {
	              _insert(q, data, false, callback);
	            },
	            kill: function () {
	              q.drain = null;
	              q.tasks = [];
	            },
	            unshift: function (data, callback) {
	              _insert(q, data, true, callback);
	            },
	            process: function () {
	                if (!q.paused && workers < q.concurrency && q.tasks.length) {
	                    var task = q.tasks.shift();
	                    if (q.empty && q.tasks.length === 0) {
	                        q.empty();
	                    }
	                    workers += 1;
	                    var next = function () {
	                        workers -= 1;
	                        if (task.callback) {
	                            task.callback.apply(task, arguments);
	                        }
	                        if (q.drain && q.tasks.length + workers === 0) {
	                            q.drain();
	                        }
	                        q.process();
	                    };
	                    var cb = only_once(next);
	                    worker(task.data, cb);
	                }
	            },
	            length: function () {
	                return q.tasks.length;
	            },
	            running: function () {
	                return workers;
	            },
	            idle: function() {
	                return q.tasks.length + workers === 0;
	            },
	            pause: function () {
	                if (q.paused === true) { return; }
	                q.paused = true;
	            },
	            resume: function () {
	                if (q.paused === false) { return; }
	                q.paused = false;
	                // Need to call q.process once per concurrent
	                // worker to preserve full concurrency after pause
	                for (var w = 1; w <= q.concurrency; w++) {
	                    async.setImmediate(q.process);
	                }
	            }
	        };
	        return q;
	    };

	    async.priorityQueue = function (worker, concurrency) {

	        function _compareTasks(a, b){
	          return a.priority - b.priority;
	        };

	        function _binarySearch(sequence, item, compare) {
	          var beg = -1,
	              end = sequence.length - 1;
	          while (beg < end) {
	            var mid = beg + ((end - beg + 1) >>> 1);
	            if (compare(item, sequence[mid]) >= 0) {
	              beg = mid;
	            } else {
	              end = mid - 1;
	            }
	          }
	          return beg;
	        }

	        function _insert(q, data, priority, callback) {
	          if (!q.started){
	            q.started = true;
	          }
	          if (!_isArray(data)) {
	              data = [data];
	          }
	          if(data.length == 0) {
	             // call drain immediately if there are no tasks
	             return async.setImmediate(function() {
	                 if (q.drain) {
	                     q.drain();
	                 }
	             });
	          }
	          _each(data, function(task) {
	              var item = {
	                  data: task,
	                  priority: priority,
	                  callback: typeof callback === 'function' ? callback : null
	              };

	              q.tasks.splice(_binarySearch(q.tasks, item, _compareTasks) + 1, 0, item);

	              if (q.saturated && q.tasks.length === q.concurrency) {
	                  q.saturated();
	              }
	              async.setImmediate(q.process);
	          });
	        }

	        // Start with a normal queue
	        var q = async.queue(worker, concurrency);

	        // Override push to accept second parameter representing priority
	        q.push = function (data, priority, callback) {
	          _insert(q, data, priority, callback);
	        };

	        // Remove unshift function
	        delete q.unshift;

	        return q;
	    };

	    async.cargo = function (worker, payload) {
	        var working     = false,
	            tasks       = [];

	        var cargo = {
	            tasks: tasks,
	            payload: payload,
	            saturated: null,
	            empty: null,
	            drain: null,
	            drained: true,
	            push: function (data, callback) {
	                if (!_isArray(data)) {
	                    data = [data];
	                }
	                _each(data, function(task) {
	                    tasks.push({
	                        data: task,
	                        callback: typeof callback === 'function' ? callback : null
	                    });
	                    cargo.drained = false;
	                    if (cargo.saturated && tasks.length === payload) {
	                        cargo.saturated();
	                    }
	                });
	                async.setImmediate(cargo.process);
	            },
	            process: function process() {
	                if (working) return;
	                if (tasks.length === 0) {
	                    if(cargo.drain && !cargo.drained) cargo.drain();
	                    cargo.drained = true;
	                    return;
	                }

	                var ts = typeof payload === 'number'
	                            ? tasks.splice(0, payload)
	                            : tasks.splice(0, tasks.length);

	                var ds = _map(ts, function (task) {
	                    return task.data;
	                });

	                if(cargo.empty) cargo.empty();
	                working = true;
	                worker(ds, function () {
	                    working = false;

	                    var args = arguments;
	                    _each(ts, function (data) {
	                        if (data.callback) {
	                            data.callback.apply(null, args);
	                        }
	                    });

	                    process();
	                });
	            },
	            length: function () {
	                return tasks.length;
	            },
	            running: function () {
	                return working;
	            }
	        };
	        return cargo;
	    };

	    var _console_fn = function (name) {
	        return function (fn) {
	            var args = Array.prototype.slice.call(arguments, 1);
	            fn.apply(null, args.concat([function (err) {
	                var args = Array.prototype.slice.call(arguments, 1);
	                if (typeof console !== 'undefined') {
	                    if (err) {
	                        if (console.error) {
	                            console.error(err);
	                        }
	                    }
	                    else if (console[name]) {
	                        _each(args, function (x) {
	                            console[name](x);
	                        });
	                    }
	                }
	            }]));
	        };
	    };
	    async.log = _console_fn('log');
	    async.dir = _console_fn('dir');
	    /*async.info = _console_fn('info');
	    async.warn = _console_fn('warn');
	    async.error = _console_fn('error');*/

	    async.memoize = function (fn, hasher) {
	        var memo = {};
	        var queues = {};
	        hasher = hasher || function (x) {
	            return x;
	        };
	        var memoized = function () {
	            var args = Array.prototype.slice.call(arguments);
	            var callback = args.pop();
	            var key = hasher.apply(null, args);
	            if (key in memo) {
	                async.nextTick(function () {
	                    callback.apply(null, memo[key]);
	                });
	            }
	            else if (key in queues) {
	                queues[key].push(callback);
	            }
	            else {
	                queues[key] = [callback];
	                fn.apply(null, args.concat([function () {
	                    memo[key] = arguments;
	                    var q = queues[key];
	                    delete queues[key];
	                    for (var i = 0, l = q.length; i < l; i++) {
	                      q[i].apply(null, arguments);
	                    }
	                }]));
	            }
	        };
	        memoized.memo = memo;
	        memoized.unmemoized = fn;
	        return memoized;
	    };

	    async.unmemoize = function (fn) {
	      return function () {
	        return (fn.unmemoized || fn).apply(null, arguments);
	      };
	    };

	    async.times = function (count, iterator, callback) {
	        var counter = [];
	        for (var i = 0; i < count; i++) {
	            counter.push(i);
	        }
	        return async.map(counter, iterator, callback);
	    };

	    async.timesSeries = function (count, iterator, callback) {
	        var counter = [];
	        for (var i = 0; i < count; i++) {
	            counter.push(i);
	        }
	        return async.mapSeries(counter, iterator, callback);
	    };

	    async.seq = function (/* functions... */) {
	        var fns = arguments;
	        return function () {
	            var that = this;
	            var args = Array.prototype.slice.call(arguments);
	            var callback = args.pop();
	            async.reduce(fns, args, function (newargs, fn, cb) {
	                fn.apply(that, newargs.concat([function () {
	                    var err = arguments[0];
	                    var nextargs = Array.prototype.slice.call(arguments, 1);
	                    cb(err, nextargs);
	                }]))
	            },
	            function (err, results) {
	                callback.apply(that, [err].concat(results));
	            });
	        };
	    };

	    async.compose = function (/* functions... */) {
	      return async.seq.apply(null, Array.prototype.reverse.call(arguments));
	    };

	    var _applyEach = function (eachfn, fns /*args...*/) {
	        var go = function () {
	            var that = this;
	            var args = Array.prototype.slice.call(arguments);
	            var callback = args.pop();
	            return eachfn(fns, function (fn, cb) {
	                fn.apply(that, args.concat([cb]));
	            },
	            callback);
	        };
	        if (arguments.length > 2) {
	            var args = Array.prototype.slice.call(arguments, 2);
	            return go.apply(this, args);
	        }
	        else {
	            return go;
	        }
	    };
	    async.applyEach = doParallel(_applyEach);
	    async.applyEachSeries = doSeries(_applyEach);

	    async.forever = function (fn, callback) {
	        function next(err) {
	            if (err) {
	                if (callback) {
	                    return callback(err);
	                }
	                throw err;
	            }
	            fn(next);
	        }
	        next();
	    };

	    // Node.js
	    if (typeof module !== 'undefined' && module.exports) {
	        module.exports = async;
	    }
	    // AMD / RequireJS
	    else if (true) {
	        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = function () {
	            return async;
	        }.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    }
	    // included directly via <script> tag
	    else {
	        root.async = async;
	    }

	}());
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(63), __webpack_require__(71).setImmediate))

/***/ },
/* 52 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/** @fileOverview Javascript cryptography implementation.
	 *
	 * Crush to remove comments, shorten variable names and
	 * generally reduce transmission size.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	"use strict";
	/*jslint indent: 2, bitwise: false, nomen: false, plusplus: false, white: false, regexp: false */
	/*global document, window, escape, unescape, module, require, Uint32Array */

	/** @namespace The Stanford Javascript Crypto Library, top-level namespace. */
	var sjcl = {
	  /** @namespace Symmetric ciphers. */
	  cipher: {},

	  /** @namespace Hash functions.  Right now only SHA256 is implemented. */
	  hash: {},

	  /** @namespace Key exchange functions.  Right now only SRP is implemented. */
	  keyexchange: {},
	  
	  /** @namespace Block cipher modes of operation. */
	  mode: {},

	  /** @namespace Miscellaneous.  HMAC and PBKDF2. */
	  misc: {},
	  
	  /**
	   * @namespace Bit array encoders and decoders.
	   *
	   * @description
	   * The members of this namespace are functions which translate between
	   * SJCL's bitArrays and other objects (usually strings).  Because it
	   * isn't always clear which direction is encoding and which is decoding,
	   * the method names are "fromBits" and "toBits".
	   */
	  codec: {},
	  
	  /** @namespace Exceptions. */
	  exception: {
	    /** @constructor Ciphertext is corrupt. */
	    corrupt: function(message) {
	      this.toString = function() { return "CORRUPT: "+this.message; };
	      this.message = message;
	    },
	    
	    /** @constructor Invalid parameter. */
	    invalid: function(message) {
	      this.toString = function() { return "INVALID: "+this.message; };
	      this.message = message;
	    },
	    
	    /** @constructor Bug or missing feature in SJCL. @constructor */
	    bug: function(message) {
	      this.toString = function() { return "BUG: "+this.message; };
	      this.message = message;
	    },

	    /** @constructor Something isn't ready. */
	    notReady: function(message) {
	      this.toString = function() { return "NOT READY: "+this.message; };
	      this.message = message;
	    }
	  }
	};

	if(typeof module !== 'undefined' && module.exports){
	  module.exports = sjcl;
	}
	if (true) {
	    !(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = function () {
	        return sjcl;
	    }.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	}
	/** @fileOverview Low-level AES implementation.
	 *
	 * This file contains a low-level implementation of AES, optimized for
	 * size and for efficiency on several browsers.  It is based on
	 * OpenSSL's aes_core.c, a public-domain implementation by Vincent
	 * Rijmen, Antoon Bosselaers and Paulo Barreto.
	 *
	 * An older version of this implementation is available in the public
	 * domain, but this one is (c) Emily Stark, Mike Hamburg, Dan Boneh,
	 * Stanford University 2008-2010 and BSD-licensed for liability
	 * reasons.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/**
	 * Schedule out an AES key for both encryption and decryption.  This
	 * is a low-level class.  Use a cipher mode to do bulk encryption.
	 *
	 * @constructor
	 * @param {Array} key The key as an array of 4, 6 or 8 words.
	 *
	 * @class Advanced Encryption Standard (low-level interface)
	 */
	sjcl.cipher.aes = function (key) {
	  if (!this._tables[0][0][0]) {
	    this._precompute();
	  }
	  
	  var i, j, tmp,
	    encKey, decKey,
	    sbox = this._tables[0][4], decTable = this._tables[1],
	    keyLen = key.length, rcon = 1;
	  
	  if (keyLen !== 4 && keyLen !== 6 && keyLen !== 8) {
	    throw new sjcl.exception.invalid("invalid aes key size");
	  }
	  
	  this._key = [encKey = key.slice(0), decKey = []];
	  
	  // schedule encryption keys
	  for (i = keyLen; i < 4 * keyLen + 28; i++) {
	    tmp = encKey[i-1];
	    
	    // apply sbox
	    if (i%keyLen === 0 || (keyLen === 8 && i%keyLen === 4)) {
	      tmp = sbox[tmp>>>24]<<24 ^ sbox[tmp>>16&255]<<16 ^ sbox[tmp>>8&255]<<8 ^ sbox[tmp&255];
	      
	      // shift rows and add rcon
	      if (i%keyLen === 0) {
	        tmp = tmp<<8 ^ tmp>>>24 ^ rcon<<24;
	        rcon = rcon<<1 ^ (rcon>>7)*283;
	      }
	    }
	    
	    encKey[i] = encKey[i-keyLen] ^ tmp;
	  }
	  
	  // schedule decryption keys
	  for (j = 0; i; j++, i--) {
	    tmp = encKey[j&3 ? i : i - 4];
	    if (i<=4 || j<4) {
	      decKey[j] = tmp;
	    } else {
	      decKey[j] = decTable[0][sbox[tmp>>>24      ]] ^
	                  decTable[1][sbox[tmp>>16  & 255]] ^
	                  decTable[2][sbox[tmp>>8   & 255]] ^
	                  decTable[3][sbox[tmp      & 255]];
	    }
	  }
	};

	sjcl.cipher.aes.prototype = {
	  // public
	  /* Something like this might appear here eventually
	  name: "AES",
	  blockSize: 4,
	  keySizes: [4,6,8],
	  */
	  
	  /**
	   * Encrypt an array of 4 big-endian words.
	   * @param {Array} data The plaintext.
	   * @return {Array} The ciphertext.
	   */
	  encrypt:function (data) { return this._crypt(data,0); },
	  
	  /**
	   * Decrypt an array of 4 big-endian words.
	   * @param {Array} data The ciphertext.
	   * @return {Array} The plaintext.
	   */
	  decrypt:function (data) { return this._crypt(data,1); },
	  
	  /**
	   * The expanded S-box and inverse S-box tables.  These will be computed
	   * on the client so that we don't have to send them down the wire.
	   *
	   * There are two tables, _tables[0] is for encryption and
	   * _tables[1] is for decryption.
	   *
	   * The first 4 sub-tables are the expanded S-box with MixColumns.  The
	   * last (_tables[01][4]) is the S-box itself.
	   *
	   * @private
	   */
	  _tables: [[[],[],[],[],[]],[[],[],[],[],[]]],

	  /**
	   * Expand the S-box tables.
	   *
	   * @private
	   */
	  _precompute: function () {
	   var encTable = this._tables[0], decTable = this._tables[1],
	       sbox = encTable[4], sboxInv = decTable[4],
	       i, x, xInv, d=[], th=[], x2, x4, x8, s, tEnc, tDec;

	    // Compute double and third tables
	   for (i = 0; i < 256; i++) {
	     th[( d[i] = i<<1 ^ (i>>7)*283 )^i]=i;
	   }
	   
	   for (x = xInv = 0; !sbox[x]; x ^= x2 || 1, xInv = th[xInv] || 1) {
	     // Compute sbox
	     s = xInv ^ xInv<<1 ^ xInv<<2 ^ xInv<<3 ^ xInv<<4;
	     s = s>>8 ^ s&255 ^ 99;
	     sbox[x] = s;
	     sboxInv[s] = x;
	     
	     // Compute MixColumns
	     x8 = d[x4 = d[x2 = d[x]]];
	     tDec = x8*0x1010101 ^ x4*0x10001 ^ x2*0x101 ^ x*0x1010100;
	     tEnc = d[s]*0x101 ^ s*0x1010100;
	     
	     for (i = 0; i < 4; i++) {
	       encTable[i][x] = tEnc = tEnc<<24 ^ tEnc>>>8;
	       decTable[i][s] = tDec = tDec<<24 ^ tDec>>>8;
	     }
	   }
	   
	   // Compactify.  Considerable speedup on Firefox.
	   for (i = 0; i < 5; i++) {
	     encTable[i] = encTable[i].slice(0);
	     decTable[i] = decTable[i].slice(0);
	   }
	  },
	  
	  /**
	   * Encryption and decryption core.
	   * @param {Array} input Four words to be encrypted or decrypted.
	   * @param dir The direction, 0 for encrypt and 1 for decrypt.
	   * @return {Array} The four encrypted or decrypted words.
	   * @private
	   */
	  _crypt:function (input, dir) {
	    if (input.length !== 4) {
	      throw new sjcl.exception.invalid("invalid aes block size");
	    }
	    
	    var key = this._key[dir],
	        // state variables a,b,c,d are loaded with pre-whitened data
	        a = input[0]           ^ key[0],
	        b = input[dir ? 3 : 1] ^ key[1],
	        c = input[2]           ^ key[2],
	        d = input[dir ? 1 : 3] ^ key[3],
	        a2, b2, c2,
	        
	        nInnerRounds = key.length/4 - 2,
	        i,
	        kIndex = 4,
	        out = [0,0,0,0],
	        table = this._tables[dir],
	        
	        // load up the tables
	        t0    = table[0],
	        t1    = table[1],
	        t2    = table[2],
	        t3    = table[3],
	        sbox  = table[4];
	 
	    // Inner rounds.  Cribbed from OpenSSL.
	    for (i = 0; i < nInnerRounds; i++) {
	      a2 = t0[a>>>24] ^ t1[b>>16 & 255] ^ t2[c>>8 & 255] ^ t3[d & 255] ^ key[kIndex];
	      b2 = t0[b>>>24] ^ t1[c>>16 & 255] ^ t2[d>>8 & 255] ^ t3[a & 255] ^ key[kIndex + 1];
	      c2 = t0[c>>>24] ^ t1[d>>16 & 255] ^ t2[a>>8 & 255] ^ t3[b & 255] ^ key[kIndex + 2];
	      d  = t0[d>>>24] ^ t1[a>>16 & 255] ^ t2[b>>8 & 255] ^ t3[c & 255] ^ key[kIndex + 3];
	      kIndex += 4;
	      a=a2; b=b2; c=c2;
	    }
	        
	    // Last round.
	    for (i = 0; i < 4; i++) {
	      out[dir ? 3&-i : i] =
	        sbox[a>>>24      ]<<24 ^ 
	        sbox[b>>16  & 255]<<16 ^
	        sbox[c>>8   & 255]<<8  ^
	        sbox[d      & 255]     ^
	        key[kIndex++];
	      a2=a; a=b; b=c; c=d; d=a2;
	    }
	    
	    return out;
	  }
	};

	/** @fileOverview Arrays of bits, encoded as arrays of Numbers.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace Arrays of bits, encoded as arrays of Numbers.
	 *
	 * @description
	 * <p>
	 * These objects are the currency accepted by SJCL's crypto functions.
	 * </p>
	 *
	 * <p>
	 * Most of our crypto primitives operate on arrays of 4-byte words internally,
	 * but many of them can take arguments that are not a multiple of 4 bytes.
	 * This library encodes arrays of bits (whose size need not be a multiple of 8
	 * bits) as arrays of 32-bit words.  The bits are packed, big-endian, into an
	 * array of words, 32 bits at a time.  Since the words are double-precision
	 * floating point numbers, they fit some extra data.  We use this (in a private,
	 * possibly-changing manner) to encode the number of bits actually  present
	 * in the last word of the array.
	 * </p>
	 *
	 * <p>
	 * Because bitwise ops clear this out-of-band data, these arrays can be passed
	 * to ciphers like AES which want arrays of words.
	 * </p>
	 */
	sjcl.bitArray = {
	  /**
	   * Array slices in units of bits.
	   * @param {bitArray} a The array to slice.
	   * @param {Number} bstart The offset to the start of the slice, in bits.
	   * @param {Number} bend The offset to the end of the slice, in bits.  If this is undefined,
	   * slice until the end of the array.
	   * @return {bitArray} The requested slice.
	   */
	  bitSlice: function (a, bstart, bend) {
	    a = sjcl.bitArray._shiftRight(a.slice(bstart/32), 32 - (bstart & 31)).slice(1);
	    return (bend === undefined) ? a : sjcl.bitArray.clamp(a, bend-bstart);
	  },

	  /**
	   * Extract a number packed into a bit array.
	   * @param {bitArray} a The array to slice.
	   * @param {Number} bstart The offset to the start of the slice, in bits.
	   * @param {Number} length The length of the number to extract.
	   * @return {Number} The requested slice.
	   */
	  extract: function(a, bstart, blength) {
	    // FIXME: this Math.floor is not necessary at all, but for some reason
	    // seems to suppress a bug in the Chromium JIT.
	    var x, sh = Math.floor((-bstart-blength) & 31);
	    if ((bstart + blength - 1 ^ bstart) & -32) {
	      // it crosses a boundary
	      x = (a[bstart/32|0] << (32 - sh)) ^ (a[bstart/32+1|0] >>> sh);
	    } else {
	      // within a single word
	      x = a[bstart/32|0] >>> sh;
	    }
	    return x & ((1<<blength) - 1);
	  },

	  /**
	   * Concatenate two bit arrays.
	   * @param {bitArray} a1 The first array.
	   * @param {bitArray} a2 The second array.
	   * @return {bitArray} The concatenation of a1 and a2.
	   */
	  concat: function (a1, a2) {
	    if (a1.length === 0 || a2.length === 0) {
	      return a1.concat(a2);
	    }
	    
	    var last = a1[a1.length-1], shift = sjcl.bitArray.getPartial(last);
	    if (shift === 32) {
	      return a1.concat(a2);
	    } else {
	      return sjcl.bitArray._shiftRight(a2, shift, last|0, a1.slice(0,a1.length-1));
	    }
	  },

	  /**
	   * Find the length of an array of bits.
	   * @param {bitArray} a The array.
	   * @return {Number} The length of a, in bits.
	   */
	  bitLength: function (a) {
	    var l = a.length, x;
	    if (l === 0) { return 0; }
	    x = a[l - 1];
	    return (l-1) * 32 + sjcl.bitArray.getPartial(x);
	  },

	  /**
	   * Truncate an array.
	   * @param {bitArray} a The array.
	   * @param {Number} len The length to truncate to, in bits.
	   * @return {bitArray} A new array, truncated to len bits.
	   */
	  clamp: function (a, len) {
	    if (a.length * 32 < len) { return a; }
	    a = a.slice(0, Math.ceil(len / 32));
	    var l = a.length;
	    len = len & 31;
	    if (l > 0 && len) {
	      a[l-1] = sjcl.bitArray.partial(len, a[l-1] & 0x80000000 >> (len-1), 1);
	    }
	    return a;
	  },

	  /**
	   * Make a partial word for a bit array.
	   * @param {Number} len The number of bits in the word.
	   * @param {Number} x The bits.
	   * @param {Number} [0] _end Pass 1 if x has already been shifted to the high side.
	   * @return {Number} The partial word.
	   */
	  partial: function (len, x, _end) {
	    if (len === 32) { return x; }
	    return (_end ? x|0 : x << (32-len)) + len * 0x10000000000;
	  },

	  /**
	   * Get the number of bits used by a partial word.
	   * @param {Number} x The partial word.
	   * @return {Number} The number of bits used by the partial word.
	   */
	  getPartial: function (x) {
	    return Math.round(x/0x10000000000) || 32;
	  },

	  /**
	   * Compare two arrays for equality in a predictable amount of time.
	   * @param {bitArray} a The first array.
	   * @param {bitArray} b The second array.
	   * @return {boolean} true if a == b; false otherwise.
	   */
	  equal: function (a, b) {
	    if (sjcl.bitArray.bitLength(a) !== sjcl.bitArray.bitLength(b)) {
	      return false;
	    }
	    var x = 0, i;
	    for (i=0; i<a.length; i++) {
	      x |= a[i]^b[i];
	    }
	    return (x === 0);
	  },

	  /** Shift an array right.
	   * @param {bitArray} a The array to shift.
	   * @param {Number} shift The number of bits to shift.
	   * @param {Number} [carry=0] A byte to carry in
	   * @param {bitArray} [out=[]] An array to prepend to the output.
	   * @private
	   */
	  _shiftRight: function (a, shift, carry, out) {
	    var i, last2=0, shift2;
	    if (out === undefined) { out = []; }
	    
	    for (; shift >= 32; shift -= 32) {
	      out.push(carry);
	      carry = 0;
	    }
	    if (shift === 0) {
	      return out.concat(a);
	    }
	    
	    for (i=0; i<a.length; i++) {
	      out.push(carry | a[i]>>>shift);
	      carry = a[i] << (32-shift);
	    }
	    last2 = a.length ? a[a.length-1] : 0;
	    shift2 = sjcl.bitArray.getPartial(last2);
	    out.push(sjcl.bitArray.partial(shift+shift2 & 31, (shift + shift2 > 32) ? carry : out.pop(),1));
	    return out;
	  },
	  
	  /** xor a block of 4 words together.
	   * @private
	   */
	  _xor4: function(x,y) {
	    return [x[0]^y[0],x[1]^y[1],x[2]^y[2],x[3]^y[3]];
	  },

	  /** byteswap a word array inplace.
	   * (does not handle partial words)
	   * @param {sjcl.bitArray} a word array
	   * @return {sjcl.bitArray} byteswapped array
	   */
	  byteswapM: function(a) {
	    var i, v, m = 0xff00;
	    for (i = 0; i < a.length; ++i) {
	      v = a[i];
	      a[i] = (v >>> 24) | ((v >>> 8) & m) | ((v & m) << 8) | (v << 24);
	    }
	    return a;
	  }
	};
	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */
	 
	/** @namespace UTF-8 strings */
	sjcl.codec.utf8String = {
	  /** Convert from a bitArray to a UTF-8 string. */
	  fromBits: function (arr) {
	    var out = "", bl = sjcl.bitArray.bitLength(arr), i, tmp;
	    for (i=0; i<bl/8; i++) {
	      if ((i&3) === 0) {
	        tmp = arr[i/4];
	      }
	      out += String.fromCharCode(tmp >>> 24);
	      tmp <<= 8;
	    }
	    return decodeURIComponent(escape(out));
	  },
	  
	  /** Convert from a UTF-8 string to a bitArray. */
	  toBits: function (str) {
	    str = unescape(encodeURIComponent(str));
	    var out = [], i, tmp=0;
	    for (i=0; i<str.length; i++) {
	      tmp = tmp << 8 | str.charCodeAt(i);
	      if ((i&3) === 3) {
	        out.push(tmp);
	        tmp = 0;
	      }
	    }
	    if (i&3) {
	      out.push(sjcl.bitArray.partial(8*(i&3), tmp));
	    }
	    return out;
	  }
	};
	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace Hexadecimal */
	sjcl.codec.hex = {
	  /** Convert from a bitArray to a hex string. */
	  fromBits: function (arr) {
	    var out = "", i;
	    for (i=0; i<arr.length; i++) {
	      out += ((arr[i]|0)+0xF00000000000).toString(16).substr(4);
	    }
	    return out.substr(0, sjcl.bitArray.bitLength(arr)/4);//.replace(/(.{8})/g, "$1 ");
	  },
	  /** Convert from a hex string to a bitArray. */
	  toBits: function (str) {
	    var i, out=[], len;
	    str = str.replace(/\s|0x/g, "");
	    len = str.length;
	    str = str + "00000000";
	    for (i=0; i<str.length; i+=8) {
	      out.push(parseInt(str.substr(i,8),16)^0);
	    }
	    return sjcl.bitArray.clamp(out, len*4);
	  }
	};

	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Nils Kenneweg
	 */

	/** @namespace Base32 encoding/decoding */
	sjcl.codec.base32 = {
	  /** The base32 alphabet.
	   * @private
	   */
	  _chars: "0123456789abcdefghjkmnpqrstvwxyz",

	  /* bits in an array */
	  BITS: 32,
	  /* base to encode at (2^x) */
	  BASE: 5,
	  /* bits - base */
	  REMAINING: 27,
	  
	  /** Convert from a bitArray to a base32 string. */
	  fromBits: function (arr, _noEquals) {
	    var BITS = sjcl.codec.base32.BITS, BASE = sjcl.codec.base32.BASE, REMAINING = sjcl.codec.base32.REMAINING;
	    var out = "", i, bits=0, c = sjcl.codec.base32._chars, ta=0, bl = sjcl.bitArray.bitLength(arr);

	    for (i=0; out.length * BASE <= bl; ) {
	      out += c.charAt((ta ^ arr[i]>>>bits) >>> REMAINING);
	      if (bits < BASE) {
	        ta = arr[i] << (BASE-bits);
	        bits += REMAINING;
	        i++;
	      } else {
	        ta <<= BASE;
	        bits -= BASE;
	      }
	    }

	    return out;
	  },
	  
	  /** Convert from a base32 string to a bitArray */
	  toBits: function(str) {
	    var BITS = sjcl.codec.base32.BITS, BASE = sjcl.codec.base32.BASE, REMAINING = sjcl.codec.base32.REMAINING;
	    var out = [], i, bits=0, c = sjcl.codec.base32._chars, ta=0, x;

	    for (i=0; i<str.length; i++) {
	      x = c.indexOf(str.charAt(i));
	      if (x < 0) {
	        throw new sjcl.exception.invalid("this isn't base32!");
	      }
	      if (bits > REMAINING) {
	        bits -= REMAINING;
	        out.push(ta ^ x>>>bits);
	        ta  = x << (BITS-bits);
	      } else {
	        bits += BASE;
	        ta ^= x << (BITS-bits);
	      }
	    }
	    if (bits&56) {
	      out.push(sjcl.bitArray.partial(bits&56, ta, 1));
	    }
	    return out;
	  }
	};
	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace Base64 encoding/decoding */
	sjcl.codec.base64 = {
	  /** The base64 alphabet.
	   * @private
	   */
	  _chars: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
	  
	  /** Convert from a bitArray to a base64 string. */
	  fromBits: function (arr, _noEquals, _url) {
	    var out = "", i, bits=0, c = sjcl.codec.base64._chars, ta=0, bl = sjcl.bitArray.bitLength(arr);
	    if (_url) {
	      c = c.substr(0,62) + '-_';
	    }
	    for (i=0; out.length * 6 < bl; ) {
	      out += c.charAt((ta ^ arr[i]>>>bits) >>> 26);
	      if (bits < 6) {
	        ta = arr[i] << (6-bits);
	        bits += 26;
	        i++;
	      } else {
	        ta <<= 6;
	        bits -= 6;
	      }
	    }
	    while ((out.length & 3) && !_noEquals) { out += "="; }
	    return out;
	  },
	  
	  /** Convert from a base64 string to a bitArray */
	  toBits: function(str, _url) {
	    str = str.replace(/\s|=/g,'');
	    var out = [], i, bits=0, c = sjcl.codec.base64._chars, ta=0, x;
	    if (_url) {
	      c = c.substr(0,62) + '-_';
	    }
	    for (i=0; i<str.length; i++) {
	      x = c.indexOf(str.charAt(i));
	      if (x < 0) {
	        throw new sjcl.exception.invalid("this isn't base64!");
	      }
	      if (bits > 26) {
	        bits -= 26;
	        out.push(ta ^ x>>>bits);
	        ta  = x << (32-bits);
	      } else {
	        bits += 6;
	        ta ^= x << (32-bits);
	      }
	    }
	    if (bits&56) {
	      out.push(sjcl.bitArray.partial(bits&56, ta, 1));
	    }
	    return out;
	  }
	};

	sjcl.codec.base64url = {
	  fromBits: function (arr) { return sjcl.codec.base64.fromBits(arr,1,1); },
	  toBits: function (str) { return sjcl.codec.base64.toBits(str,1); }
	};
	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace Arrays of bytes */
	sjcl.codec.bytes = {
	  /** Convert from a bitArray to an array of bytes. */
	  fromBits: function (arr) {
	    var out = [], bl = sjcl.bitArray.bitLength(arr), i, tmp;
	    for (i=0; i<bl/8; i++) {
	      if ((i&3) === 0) {
	        tmp = arr[i/4];
	      }
	      out.push(tmp >>> 24);
	      tmp <<= 8;
	    }
	    return out;
	  },
	  /** Convert from an array of bytes to a bitArray. */
	  toBits: function (bytes) {
	    var out = [], i, tmp=0;
	    for (i=0; i<bytes.length; i++) {
	      tmp = tmp << 8 | bytes[i];
	      if ((i&3) === 3) {
	        out.push(tmp);
	        tmp = 0;
	      }
	    }
	    if (i&3) {
	      out.push(sjcl.bitArray.partial(8*(i&3), tmp));
	    }
	    return out;
	  }
	};
	/** @fileOverview Javascript SHA-256 implementation.
	 *
	 * An older version of this implementation is available in the public
	 * domain, but this one is (c) Emily Stark, Mike Hamburg, Dan Boneh,
	 * Stanford University 2008-2010 and BSD-licensed for liability
	 * reasons.
	 *
	 * Special thanks to Aldo Cortesi for pointing out several bugs in
	 * this code.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/**
	 * Context for a SHA-256 operation in progress.
	 * @constructor
	 * @class Secure Hash Algorithm, 256 bits.
	 */
	sjcl.hash.sha256 = function (hash) {
	  if (!this._key[0]) { this._precompute(); }
	  if (hash) {
	    this._h = hash._h.slice(0);
	    this._buffer = hash._buffer.slice(0);
	    this._length = hash._length;
	  } else {
	    this.reset();
	  }
	};

	/**
	 * Hash a string or an array of words.
	 * @static
	 * @param {bitArray|String} data the data to hash.
	 * @return {bitArray} The hash value, an array of 16 big-endian words.
	 */
	sjcl.hash.sha256.hash = function (data) {
	  return (new sjcl.hash.sha256()).update(data).finalize();
	};

	sjcl.hash.sha256.prototype = {
	  /**
	   * The hash's block size, in bits.
	   * @constant
	   */
	  blockSize: 512,
	   
	  /**
	   * Reset the hash state.
	   * @return this
	   */
	  reset:function () {
	    this._h = this._init.slice(0);
	    this._buffer = [];
	    this._length = 0;
	    return this;
	  },
	  
	  /**
	   * Input several words to the hash.
	   * @param {bitArray|String} data the data to hash.
	   * @return this
	   */
	  update: function (data) {
	    if (typeof data === "string") {
	      data = sjcl.codec.utf8String.toBits(data);
	    }
	    var i, b = this._buffer = sjcl.bitArray.concat(this._buffer, data),
	        ol = this._length,
	        nl = this._length = ol + sjcl.bitArray.bitLength(data);
	    for (i = 512+ol & -512; i <= nl; i+= 512) {
	      this._block(b.splice(0,16));
	    }
	    return this;
	  },
	  
	  /**
	   * Complete hashing and output the hash value.
	   * @return {bitArray} The hash value, an array of 8 big-endian words.
	   */
	  finalize:function () {
	    var i, b = this._buffer, h = this._h;

	    // Round out and push the buffer
	    b = sjcl.bitArray.concat(b, [sjcl.bitArray.partial(1,1)]);
	    
	    // Round out the buffer to a multiple of 16 words, less the 2 length words.
	    for (i = b.length + 2; i & 15; i++) {
	      b.push(0);
	    }
	    
	    // append the length
	    b.push(Math.floor(this._length / 0x100000000));
	    b.push(this._length | 0);

	    while (b.length) {
	      this._block(b.splice(0,16));
	    }

	    this.reset();
	    return h;
	  },

	  /**
	   * The SHA-256 initialization vector, to be precomputed.
	   * @private
	   */
	  _init:[],
	  /*
	  _init:[0x6a09e667,0xbb67ae85,0x3c6ef372,0xa54ff53a,0x510e527f,0x9b05688c,0x1f83d9ab,0x5be0cd19],
	  */
	  
	  /**
	   * The SHA-256 hash key, to be precomputed.
	   * @private
	   */
	  _key:[],
	  /*
	  _key:
	    [0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
	     0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
	     0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
	     0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
	     0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
	     0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
	     0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
	     0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2],
	  */


	  /**
	   * Function to precompute _init and _key.
	   * @private
	   */
	  _precompute: function () {
	    var i = 0, prime = 2, factor;

	    function frac(x) { return (x-Math.floor(x)) * 0x100000000 | 0; }

	    outer: for (; i<64; prime++) {
	      for (factor=2; factor*factor <= prime; factor++) {
	        if (prime % factor === 0) {
	          // not a prime
	          continue outer;
	        }
	      }
	      
	      if (i<8) {
	        this._init[i] = frac(Math.pow(prime, 1/2));
	      }
	      this._key[i] = frac(Math.pow(prime, 1/3));
	      i++;
	    }
	  },
	  
	  /**
	   * Perform one cycle of SHA-256.
	   * @param {bitArray} words one block of words.
	   * @private
	   */
	  _block:function (words) {  
	    var i, tmp, a, b,
	      w = words.slice(0),
	      h = this._h,
	      k = this._key,
	      h0 = h[0], h1 = h[1], h2 = h[2], h3 = h[3],
	      h4 = h[4], h5 = h[5], h6 = h[6], h7 = h[7];

	    /* Rationale for placement of |0 :
	     * If a value can overflow is original 32 bits by a factor of more than a few
	     * million (2^23 ish), there is a possibility that it might overflow the
	     * 53-bit mantissa and lose precision.
	     *
	     * To avoid this, we clamp back to 32 bits by |'ing with 0 on any value that
	     * propagates around the loop, and on the hash state h[].  I don't believe
	     * that the clamps on h4 and on h0 are strictly necessary, but it's close
	     * (for h4 anyway), and better safe than sorry.
	     *
	     * The clamps on h[] are necessary for the output to be correct even in the
	     * common case and for short inputs.
	     */
	    for (i=0; i<64; i++) {
	      // load up the input word for this round
	      if (i<16) {
	        tmp = w[i];
	      } else {
	        a   = w[(i+1 ) & 15];
	        b   = w[(i+14) & 15];
	        tmp = w[i&15] = ((a>>>7  ^ a>>>18 ^ a>>>3  ^ a<<25 ^ a<<14) + 
	                         (b>>>17 ^ b>>>19 ^ b>>>10 ^ b<<15 ^ b<<13) +
	                         w[i&15] + w[(i+9) & 15]) | 0;
	      }
	      
	      tmp = (tmp + h7 + (h4>>>6 ^ h4>>>11 ^ h4>>>25 ^ h4<<26 ^ h4<<21 ^ h4<<7) +  (h6 ^ h4&(h5^h6)) + k[i]); // | 0;
	      
	      // shift register
	      h7 = h6; h6 = h5; h5 = h4;
	      h4 = h3 + tmp | 0;
	      h3 = h2; h2 = h1; h1 = h0;

	      h0 = (tmp +  ((h1&h2) ^ (h3&(h1^h2))) + (h1>>>2 ^ h1>>>13 ^ h1>>>22 ^ h1<<30 ^ h1<<19 ^ h1<<10)) | 0;
	    }

	    h[0] = h[0]+h0 | 0;
	    h[1] = h[1]+h1 | 0;
	    h[2] = h[2]+h2 | 0;
	    h[3] = h[3]+h3 | 0;
	    h[4] = h[4]+h4 | 0;
	    h[5] = h[5]+h5 | 0;
	    h[6] = h[6]+h6 | 0;
	    h[7] = h[7]+h7 | 0;
	  }
	};


	/** @fileOverview Javascript SHA-512 implementation.
	 *
	 * This implementation was written for CryptoJS by Jeff Mott and adapted for
	 * SJCL by Stefan Thomas.
	 *
	 * CryptoJS (c) 2009–2012 by Jeff Mott. All rights reserved.
	 * Released with New BSD License
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 * @author Jeff Mott
	 * @author Stefan Thomas
	 */

	/**
	 * Context for a SHA-512 operation in progress.
	 * @constructor
	 * @class Secure Hash Algorithm, 512 bits.
	 */
	sjcl.hash.sha512 = function (hash) {
	  if (!this._key[0]) { this._precompute(); }
	  if (hash) {
	    this._h = hash._h.slice(0);
	    this._buffer = hash._buffer.slice(0);
	    this._length = hash._length;
	  } else {
	    this.reset();
	  }
	};

	/**
	 * Hash a string or an array of words.
	 * @static
	 * @param {bitArray|String} data the data to hash.
	 * @return {bitArray} The hash value, an array of 16 big-endian words.
	 */
	sjcl.hash.sha512.hash = function (data) {
	  return (new sjcl.hash.sha512()).update(data).finalize();
	};

	sjcl.hash.sha512.prototype = {
	  /**
	   * The hash's block size, in bits.
	   * @constant
	   */
	  blockSize: 1024,
	   
	  /**
	   * Reset the hash state.
	   * @return this
	   */
	  reset:function () {
	    this._h = this._init.slice(0);
	    this._buffer = [];
	    this._length = 0;
	    return this;
	  },
	  
	  /**
	   * Input several words to the hash.
	   * @param {bitArray|String} data the data to hash.
	   * @return this
	   */
	  update: function (data) {
	    if (typeof data === "string") {
	      data = sjcl.codec.utf8String.toBits(data);
	    }
	    var i, b = this._buffer = sjcl.bitArray.concat(this._buffer, data),
	        ol = this._length,
	        nl = this._length = ol + sjcl.bitArray.bitLength(data);
	    for (i = 1024+ol & -1024; i <= nl; i+= 1024) {
	      this._block(b.splice(0,32));
	    }
	    return this;
	  },
	  
	  /**
	   * Complete hashing and output the hash value.
	   * @return {bitArray} The hash value, an array of 16 big-endian words.
	   */
	  finalize:function () {
	    var i, b = this._buffer, h = this._h;

	    // Round out and push the buffer
	    b = sjcl.bitArray.concat(b, [sjcl.bitArray.partial(1,1)]);

	    // Round out the buffer to a multiple of 32 words, less the 4 length words.
	    for (i = b.length + 4; i & 31; i++) {
	      b.push(0);
	    }

	    // append the length
	    b.push(0);
	    b.push(0);
	    b.push(Math.floor(this._length / 0x100000000));
	    b.push(this._length | 0);

	    while (b.length) {
	      this._block(b.splice(0,32));
	    }

	    this.reset();
	    return h;
	  },

	  /**
	   * The SHA-512 initialization vector, to be precomputed.
	   * @private
	   */
	  _init:[],

	  /**
	   * Least significant 24 bits of SHA512 initialization values.
	   *
	   * Javascript only has 53 bits of precision, so we compute the 40 most
	   * significant bits and add the remaining 24 bits as constants.
	   *
	   * @private
	   */
	  _initr: [ 0xbcc908, 0xcaa73b, 0x94f82b, 0x1d36f1, 0xe682d1, 0x3e6c1f, 0x41bd6b, 0x7e2179 ],

	  /*
	  _init:
	  [0x6a09e667, 0xf3bcc908, 0xbb67ae85, 0x84caa73b, 0x3c6ef372, 0xfe94f82b, 0xa54ff53a, 0x5f1d36f1,
	   0x510e527f, 0xade682d1, 0x9b05688c, 0x2b3e6c1f, 0x1f83d9ab, 0xfb41bd6b, 0x5be0cd19, 0x137e2179],
	  */

	  /**
	   * The SHA-512 hash key, to be precomputed.
	   * @private
	   */
	  _key:[],

	  /**
	   * Least significant 24 bits of SHA512 key values.
	   * @private
	   */
	  _keyr:
	  [0x28ae22, 0xef65cd, 0x4d3b2f, 0x89dbbc, 0x48b538, 0x05d019, 0x194f9b, 0x6d8118,
	   0x030242, 0x706fbe, 0xe4b28c, 0xffb4e2, 0x7b896f, 0x1696b1, 0xc71235, 0x692694,
	   0xf14ad2, 0x4f25e3, 0x8cd5b5, 0xac9c65, 0x2b0275, 0xa6e483, 0x41fbd4, 0x1153b5,
	   0x66dfab, 0xb43210, 0xfb213f, 0xef0ee4, 0xa88fc2, 0x0aa725, 0x03826f, 0x0e6e70,
	   0xd22ffc, 0x26c926, 0xc42aed, 0x95b3df, 0xaf63de, 0x77b2a8, 0xedaee6, 0x82353b,
	   0xf10364, 0x423001, 0xf89791, 0x54be30, 0xef5218, 0x65a910, 0x71202a, 0xbbd1b8,
	   0xd2d0c8, 0x41ab53, 0x8eeb99, 0x9b48a8, 0xc95a63, 0x418acb, 0x63e373, 0xb2b8a3,
	   0xefb2fc, 0x172f60, 0xf0ab72, 0x6439ec, 0x631e28, 0x82bde9, 0xc67915, 0x72532b,
	   0x26619c, 0xc0c207, 0xe0eb1e, 0x6ed178, 0x176fba, 0xc898a6, 0xf90dae, 0x1c471b,
	   0x047d84, 0xc72493, 0xc9bebc, 0x100d4c, 0x3e42b6, 0x657e2a, 0xd6faec, 0x475817],

	  /*
	  _key:
	  [0x428a2f98, 0xd728ae22, 0x71374491, 0x23ef65cd, 0xb5c0fbcf, 0xec4d3b2f, 0xe9b5dba5, 0x8189dbbc,
	   0x3956c25b, 0xf348b538, 0x59f111f1, 0xb605d019, 0x923f82a4, 0xaf194f9b, 0xab1c5ed5, 0xda6d8118,
	   0xd807aa98, 0xa3030242, 0x12835b01, 0x45706fbe, 0x243185be, 0x4ee4b28c, 0x550c7dc3, 0xd5ffb4e2,
	   0x72be5d74, 0xf27b896f, 0x80deb1fe, 0x3b1696b1, 0x9bdc06a7, 0x25c71235, 0xc19bf174, 0xcf692694,
	   0xe49b69c1, 0x9ef14ad2, 0xefbe4786, 0x384f25e3, 0x0fc19dc6, 0x8b8cd5b5, 0x240ca1cc, 0x77ac9c65,
	   0x2de92c6f, 0x592b0275, 0x4a7484aa, 0x6ea6e483, 0x5cb0a9dc, 0xbd41fbd4, 0x76f988da, 0x831153b5,
	   0x983e5152, 0xee66dfab, 0xa831c66d, 0x2db43210, 0xb00327c8, 0x98fb213f, 0xbf597fc7, 0xbeef0ee4,
	   0xc6e00bf3, 0x3da88fc2, 0xd5a79147, 0x930aa725, 0x06ca6351, 0xe003826f, 0x14292967, 0x0a0e6e70,
	   0x27b70a85, 0x46d22ffc, 0x2e1b2138, 0x5c26c926, 0x4d2c6dfc, 0x5ac42aed, 0x53380d13, 0x9d95b3df,
	   0x650a7354, 0x8baf63de, 0x766a0abb, 0x3c77b2a8, 0x81c2c92e, 0x47edaee6, 0x92722c85, 0x1482353b,
	   0xa2bfe8a1, 0x4cf10364, 0xa81a664b, 0xbc423001, 0xc24b8b70, 0xd0f89791, 0xc76c51a3, 0x0654be30,
	   0xd192e819, 0xd6ef5218, 0xd6990624, 0x5565a910, 0xf40e3585, 0x5771202a, 0x106aa070, 0x32bbd1b8,
	   0x19a4c116, 0xb8d2d0c8, 0x1e376c08, 0x5141ab53, 0x2748774c, 0xdf8eeb99, 0x34b0bcb5, 0xe19b48a8,
	   0x391c0cb3, 0xc5c95a63, 0x4ed8aa4a, 0xe3418acb, 0x5b9cca4f, 0x7763e373, 0x682e6ff3, 0xd6b2b8a3,
	   0x748f82ee, 0x5defb2fc, 0x78a5636f, 0x43172f60, 0x84c87814, 0xa1f0ab72, 0x8cc70208, 0x1a6439ec,
	   0x90befffa, 0x23631e28, 0xa4506ceb, 0xde82bde9, 0xbef9a3f7, 0xb2c67915, 0xc67178f2, 0xe372532b,
	   0xca273ece, 0xea26619c, 0xd186b8c7, 0x21c0c207, 0xeada7dd6, 0xcde0eb1e, 0xf57d4f7f, 0xee6ed178,
	   0x06f067aa, 0x72176fba, 0x0a637dc5, 0xa2c898a6, 0x113f9804, 0xbef90dae, 0x1b710b35, 0x131c471b,
	   0x28db77f5, 0x23047d84, 0x32caab7b, 0x40c72493, 0x3c9ebe0a, 0x15c9bebc, 0x431d67c4, 0x9c100d4c,
	   0x4cc5d4be, 0xcb3e42b6, 0x597f299c, 0xfc657e2a, 0x5fcb6fab, 0x3ad6faec, 0x6c44198c, 0x4a475817],
	  */

	  /**
	   * Function to precompute _init and _key.
	   * @private
	   */
	  _precompute: function () {
	    // XXX: This code is for precomputing the SHA256 constants, change for
	    //      SHA512 and re-enable.
	    var i = 0, prime = 2, factor;

	    function frac(x)  { return (x-Math.floor(x)) * 0x100000000 | 0; }
	    function frac2(x) { return (x-Math.floor(x)) * 0x10000000000 & 0xff; }

	    outer: for (; i<80; prime++) {
	      for (factor=2; factor*factor <= prime; factor++) {
	        if (prime % factor === 0) {
	          // not a prime
	          continue outer;
	        }
	      }

	      if (i<8) {
	        this._init[i*2] = frac(Math.pow(prime, 1/2));
	        this._init[i*2+1] = (frac2(Math.pow(prime, 1/2)) << 24) | this._initr[i];
	      }
	      this._key[i*2] = frac(Math.pow(prime, 1/3));
	      this._key[i*2+1] = (frac2(Math.pow(prime, 1/3)) << 24) | this._keyr[i];
	      i++;
	    }
	  },

	  /**
	   * Perform one cycle of SHA-512.
	   * @param {bitArray} words one block of words.
	   * @private
	   */
	  _block:function (words) {
	    var i, wrh, wrl,
	        w = words.slice(0),
	        h = this._h,
	        k = this._key,
	        h0h = h[ 0], h0l = h[ 1], h1h = h[ 2], h1l = h[ 3],
	        h2h = h[ 4], h2l = h[ 5], h3h = h[ 6], h3l = h[ 7],
	        h4h = h[ 8], h4l = h[ 9], h5h = h[10], h5l = h[11],
	        h6h = h[12], h6l = h[13], h7h = h[14], h7l = h[15];

	    // Working variables
	    var ah = h0h, al = h0l, bh = h1h, bl = h1l,
	        ch = h2h, cl = h2l, dh = h3h, dl = h3l,
	        eh = h4h, el = h4l, fh = h5h, fl = h5l,
	        gh = h6h, gl = h6l, hh = h7h, hl = h7l;

	    for (i=0; i<80; i++) {
	      // load up the input word for this round
	      if (i<16) {
	        wrh = w[i * 2];
	        wrl = w[i * 2 + 1];
	      } else {
	        // Gamma0
	        var gamma0xh = w[(i-15) * 2];
	        var gamma0xl = w[(i-15) * 2 + 1];
	        var gamma0h =
	          ((gamma0xl << 31) | (gamma0xh >>> 1)) ^
	          ((gamma0xl << 24) | (gamma0xh >>> 8)) ^
	           (gamma0xh >>> 7);
	        var gamma0l =
	          ((gamma0xh << 31) | (gamma0xl >>> 1)) ^
	          ((gamma0xh << 24) | (gamma0xl >>> 8)) ^
	          ((gamma0xh << 25) | (gamma0xl >>> 7));

	        // Gamma1
	        var gamma1xh = w[(i-2) * 2];
	        var gamma1xl = w[(i-2) * 2 + 1];
	        var gamma1h =
	          ((gamma1xl << 13) | (gamma1xh >>> 19)) ^
	          ((gamma1xh << 3)  | (gamma1xl >>> 29)) ^
	           (gamma1xh >>> 6);
	        var gamma1l =
	          ((gamma1xh << 13) | (gamma1xl >>> 19)) ^
	          ((gamma1xl << 3)  | (gamma1xh >>> 29)) ^
	          ((gamma1xh << 26) | (gamma1xl >>> 6));

	        // Shortcuts
	        var wr7h = w[(i-7) * 2];
	        var wr7l = w[(i-7) * 2 + 1];

	        var wr16h = w[(i-16) * 2];
	        var wr16l = w[(i-16) * 2 + 1];

	        // W(round) = gamma0 + W(round - 7) + gamma1 + W(round - 16)
	        wrl = gamma0l + wr7l;
	        wrh = gamma0h + wr7h + ((wrl >>> 0) < (gamma0l >>> 0) ? 1 : 0);
	        wrl += gamma1l;
	        wrh += gamma1h + ((wrl >>> 0) < (gamma1l >>> 0) ? 1 : 0);
	        wrl += wr16l;
	        wrh += wr16h + ((wrl >>> 0) < (wr16l >>> 0) ? 1 : 0);
	      }

	      w[i*2]     = wrh |= 0;
	      w[i*2 + 1] = wrl |= 0;

	      // Ch
	      var chh = (eh & fh) ^ (~eh & gh);
	      var chl = (el & fl) ^ (~el & gl);

	      // Maj
	      var majh = (ah & bh) ^ (ah & ch) ^ (bh & ch);
	      var majl = (al & bl) ^ (al & cl) ^ (bl & cl);

	      // Sigma0
	      var sigma0h = ((al << 4) | (ah >>> 28)) ^ ((ah << 30) | (al >>> 2)) ^ ((ah << 25) | (al >>> 7));
	      var sigma0l = ((ah << 4) | (al >>> 28)) ^ ((al << 30) | (ah >>> 2)) ^ ((al << 25) | (ah >>> 7));

	      // Sigma1
	      var sigma1h = ((el << 18) | (eh >>> 14)) ^ ((el << 14) | (eh >>> 18)) ^ ((eh << 23) | (el >>> 9));
	      var sigma1l = ((eh << 18) | (el >>> 14)) ^ ((eh << 14) | (el >>> 18)) ^ ((el << 23) | (eh >>> 9));

	      // K(round)
	      var krh = k[i*2];
	      var krl = k[i*2+1];

	      // t1 = h + sigma1 + ch + K(round) + W(round)
	      var t1l = hl + sigma1l;
	      var t1h = hh + sigma1h + ((t1l >>> 0) < (hl >>> 0) ? 1 : 0);
	      t1l += chl;
	      t1h += chh + ((t1l >>> 0) < (chl >>> 0) ? 1 : 0);
	      t1l += krl;
	      t1h += krh + ((t1l >>> 0) < (krl >>> 0) ? 1 : 0);
	      t1l = t1l + wrl|0;   // FF32..FF34 perf issue https://bugzilla.mozilla.org/show_bug.cgi?id=1054972
	      t1h += wrh + ((t1l >>> 0) < (wrl >>> 0) ? 1 : 0);

	      // t2 = sigma0 + maj
	      var t2l = sigma0l + majl;
	      var t2h = sigma0h + majh + ((t2l >>> 0) < (sigma0l >>> 0) ? 1 : 0);

	      // Update working variables
	      hh = gh;
	      hl = gl;
	      gh = fh;
	      gl = fl;
	      fh = eh;
	      fl = el;
	      el = (dl + t1l) | 0;
	      eh = (dh + t1h + ((el >>> 0) < (dl >>> 0) ? 1 : 0)) | 0;
	      dh = ch;
	      dl = cl;
	      ch = bh;
	      cl = bl;
	      bh = ah;
	      bl = al;
	      al = (t1l + t2l) | 0;
	      ah = (t1h + t2h + ((al >>> 0) < (t1l >>> 0) ? 1 : 0)) | 0;
	    }

	    // Intermediate hash
	    h0l = h[1] = (h0l + al) | 0;
	    h[0] = (h0h + ah + ((h0l >>> 0) < (al >>> 0) ? 1 : 0)) | 0;
	    h1l = h[3] = (h1l + bl) | 0;
	    h[2] = (h1h + bh + ((h1l >>> 0) < (bl >>> 0) ? 1 : 0)) | 0;
	    h2l = h[5] = (h2l + cl) | 0;
	    h[4] = (h2h + ch + ((h2l >>> 0) < (cl >>> 0) ? 1 : 0)) | 0;
	    h3l = h[7] = (h3l + dl) | 0;
	    h[6] = (h3h + dh + ((h3l >>> 0) < (dl >>> 0) ? 1 : 0)) | 0;
	    h4l = h[9] = (h4l + el) | 0;
	    h[8] = (h4h + eh + ((h4l >>> 0) < (el >>> 0) ? 1 : 0)) | 0;
	    h5l = h[11] = (h5l + fl) | 0;
	    h[10] = (h5h + fh + ((h5l >>> 0) < (fl >>> 0) ? 1 : 0)) | 0;
	    h6l = h[13] = (h6l + gl) | 0;
	    h[12] = (h6h + gh + ((h6l >>> 0) < (gl >>> 0) ? 1 : 0)) | 0;
	    h7l = h[15] = (h7l + hl) | 0;
	    h[14] = (h7h + hh + ((h7l >>> 0) < (hl >>> 0) ? 1 : 0)) | 0;
	  }
	};


	/** @fileOverview Javascript SHA-1 implementation.
	 *
	 * Based on the implementation in RFC 3174, method 1, and on the SJCL
	 * SHA-256 implementation.
	 *
	 * @author Quinn Slack
	 */

	/**
	 * Context for a SHA-1 operation in progress.
	 * @constructor
	 * @class Secure Hash Algorithm, 160 bits.
	 */
	sjcl.hash.sha1 = function (hash) {
	  if (hash) {
	    this._h = hash._h.slice(0);
	    this._buffer = hash._buffer.slice(0);
	    this._length = hash._length;
	  } else {
	    this.reset();
	  }
	};

	/**
	 * Hash a string or an array of words.
	 * @static
	 * @param {bitArray|String} data the data to hash.
	 * @return {bitArray} The hash value, an array of 5 big-endian words.
	 */
	sjcl.hash.sha1.hash = function (data) {
	  return (new sjcl.hash.sha1()).update(data).finalize();
	};

	sjcl.hash.sha1.prototype = {
	  /**
	   * The hash's block size, in bits.
	   * @constant
	   */
	  blockSize: 512,
	   
	  /**
	   * Reset the hash state.
	   * @return this
	   */
	  reset:function () {
	    this._h = this._init.slice(0);
	    this._buffer = [];
	    this._length = 0;
	    return this;
	  },
	  
	  /**
	   * Input several words to the hash.
	   * @param {bitArray|String} data the data to hash.
	   * @return this
	   */
	  update: function (data) {
	    if (typeof data === "string") {
	      data = sjcl.codec.utf8String.toBits(data);
	    }
	    var i, b = this._buffer = sjcl.bitArray.concat(this._buffer, data),
	        ol = this._length,
	        nl = this._length = ol + sjcl.bitArray.bitLength(data);
	    for (i = this.blockSize+ol & -this.blockSize; i <= nl;
	         i+= this.blockSize) {
	      this._block(b.splice(0,16));
	    }
	    return this;
	  },
	  
	  /**
	   * Complete hashing and output the hash value.
	   * @return {bitArray} The hash value, an array of 5 big-endian words. TODO
	   */
	  finalize:function () {
	    var i, b = this._buffer, h = this._h;

	    // Round out and push the buffer
	    b = sjcl.bitArray.concat(b, [sjcl.bitArray.partial(1,1)]);
	    // Round out the buffer to a multiple of 16 words, less the 2 length words.
	    for (i = b.length + 2; i & 15; i++) {
	      b.push(0);
	    }

	    // append the length
	    b.push(Math.floor(this._length / 0x100000000));
	    b.push(this._length | 0);

	    while (b.length) {
	      this._block(b.splice(0,16));
	    }

	    this.reset();
	    return h;
	  },

	  /**
	   * The SHA-1 initialization vector.
	   * @private
	   */
	  _init:[0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476, 0xC3D2E1F0],

	  /**
	   * The SHA-1 hash key.
	   * @private
	   */
	  _key:[0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xCA62C1D6],

	  /**
	   * The SHA-1 logical functions f(0), f(1), ..., f(79).
	   * @private
	   */
	  _f:function(t, b, c, d) {
	    if (t <= 19) {
	      return (b & c) | (~b & d);
	    } else if (t <= 39) {
	      return b ^ c ^ d;
	    } else if (t <= 59) {
	      return (b & c) | (b & d) | (c & d);
	    } else if (t <= 79) {
	      return b ^ c ^ d;
	    }
	  },

	  /**
	   * Circular left-shift operator.
	   * @private
	   */
	  _S:function(n, x) {
	    return (x << n) | (x >>> 32-n);
	  },
	  
	  /**
	   * Perform one cycle of SHA-1.
	   * @param {bitArray} words one block of words.
	   * @private
	   */
	  _block:function (words) {  
	    var t, tmp, a, b, c, d, e,
	    w = words.slice(0),
	    h = this._h;
	   
	    a = h[0]; b = h[1]; c = h[2]; d = h[3]; e = h[4]; 

	    for (t=0; t<=79; t++) {
	      if (t >= 16) {
	        w[t] = this._S(1, w[t-3] ^ w[t-8] ^ w[t-14] ^ w[t-16]);
	      }
	      tmp = (this._S(5, a) + this._f(t, b, c, d) + e + w[t] +
	             this._key[Math.floor(t/20)]) | 0;
	      e = d;
	      d = c;
	      c = this._S(30, b);
	      b = a;
	      a = tmp;
	   }

	   h[0] = (h[0]+a) |0;
	   h[1] = (h[1]+b) |0;
	   h[2] = (h[2]+c) |0;
	   h[3] = (h[3]+d) |0;
	   h[4] = (h[4]+e) |0;
	  }
	};
	/** @fileOverview CCM mode implementation.
	 *
	 * Special thanks to Roy Nicholson for pointing out a bug in our
	 * implementation.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace CTR mode with CBC MAC. */
	sjcl.mode.ccm = {
	  /** The name of the mode.
	   * @constant
	   */
	  name: "ccm",
	  
	  _progressListeners: [],

	  listenProgress: function (cb) {
	    sjcl.mode.ccm._progressListeners.push(cb);
	  },

	  unListenProgress: function (cb) {
	    var index = sjcl.mode.ccm._progressListeners.indexOf(cb);
	    if (index > -1) {
	      sjcl.mode.ccm._progressListeners.splice(index, 1);
	    }
	  },

	  _callProgressListener: function (val) {
	    var p = sjcl.mode.ccm._progressListeners.slice(), i;

	    for (i = 0; i < p.length; i += 1) {
	      p[i](val);
	    }
	  },

	  /** Encrypt in CCM mode.
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} plaintext The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=64] the desired tag length, in bits.
	   * @return {bitArray} The encrypted data, an array of bytes.
	   */
	  encrypt: function(prf, plaintext, iv, adata, tlen) {
	    var L, out = plaintext.slice(0), tag, w=sjcl.bitArray, ivl = w.bitLength(iv) / 8, ol = w.bitLength(out) / 8;
	    tlen = tlen || 64;
	    adata = adata || [];
	    
	    if (ivl < 7) {
	      throw new sjcl.exception.invalid("ccm: iv must be at least 7 bytes");
	    }
	    
	    // compute the length of the length
	    for (L=2; L<4 && ol >>> 8*L; L++) {}
	    if (L < 15 - ivl) { L = 15-ivl; }
	    iv = w.clamp(iv,8*(15-L));
	    
	    // compute the tag
	    tag = sjcl.mode.ccm._computeTag(prf, plaintext, iv, adata, tlen, L);
	    
	    // encrypt
	    out = sjcl.mode.ccm._ctrMode(prf, out, iv, tag, tlen, L);
	    
	    return w.concat(out.data, out.tag);
	  },
	  
	  /** Decrypt in CCM mode.
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} ciphertext The ciphertext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [[]] adata The authenticated data.
	   * @param {Number} [64] tlen the desired tag length, in bits.
	   * @return {bitArray} The decrypted data.
	   */
	  decrypt: function(prf, ciphertext, iv, adata, tlen) {
	    tlen = tlen || 64;
	    adata = adata || [];
	    var L,
	        w=sjcl.bitArray,
	        ivl = w.bitLength(iv) / 8,
	        ol = w.bitLength(ciphertext), 
	        out = w.clamp(ciphertext, ol - tlen),
	        tag = w.bitSlice(ciphertext, ol - tlen), tag2;
	    

	    ol = (ol - tlen) / 8;
	        
	    if (ivl < 7) {
	      throw new sjcl.exception.invalid("ccm: iv must be at least 7 bytes");
	    }
	    
	    // compute the length of the length
	    for (L=2; L<4 && ol >>> 8*L; L++) {}
	    if (L < 15 - ivl) { L = 15-ivl; }
	    iv = w.clamp(iv,8*(15-L));
	    
	    // decrypt
	    out = sjcl.mode.ccm._ctrMode(prf, out, iv, tag, tlen, L);
	    
	    // check the tag
	    tag2 = sjcl.mode.ccm._computeTag(prf, out.data, iv, adata, tlen, L);
	    if (!w.equal(out.tag, tag2)) {
	      throw new sjcl.exception.corrupt("ccm: tag doesn't match");
	    }
	    
	    return out.data;
	  },

	  _macAdditionalData: function (prf, adata, iv, tlen, ol, L) {
	    var mac, tmp, i, macData = [], w=sjcl.bitArray, xor = w._xor4;

	    // mac the flags
	    mac = [w.partial(8, (adata.length ? 1<<6 : 0) | (tlen-2) << 2 | L-1)];

	    // mac the iv and length
	    mac = w.concat(mac, iv);
	    mac[3] |= ol;
	    mac = prf.encrypt(mac);
	  
	    if (adata.length) {
	      // mac the associated data.  start with its length...
	      tmp = w.bitLength(adata)/8;
	      if (tmp <= 0xFEFF) {
	        macData = [w.partial(16, tmp)];
	      } else if (tmp <= 0xFFFFFFFF) {
	        macData = w.concat([w.partial(16,0xFFFE)], [tmp]);
	      } // else ...
	    
	      // mac the data itself
	      macData = w.concat(macData, adata);
	      for (i=0; i<macData.length; i += 4) {
	        mac = prf.encrypt(xor(mac, macData.slice(i,i+4).concat([0,0,0])));
	      }
	    }

	    return mac;
	  },

	  /* Compute the (unencrypted) authentication tag, according to the CCM specification
	   * @param {Object} prf The pseudorandom function.
	   * @param {bitArray} plaintext The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} adata The authenticated data.
	   * @param {Number} tlen the desired tag length, in bits.
	   * @return {bitArray} The tag, but not yet encrypted.
	   * @private
	   */
	  _computeTag: function(prf, plaintext, iv, adata, tlen, L) {
	    // compute B[0]
	    var mac, i, w=sjcl.bitArray, xor = w._xor4;

	    tlen /= 8;
	  
	    // check tag length and message length
	    if (tlen % 2 || tlen < 4 || tlen > 16) {
	      throw new sjcl.exception.invalid("ccm: invalid tag length");
	    }
	  
	    if (adata.length > 0xFFFFFFFF || plaintext.length > 0xFFFFFFFF) {
	      // I don't want to deal with extracting high words from doubles.
	      throw new sjcl.exception.bug("ccm: can't deal with 4GiB or more data");
	    }

	    mac = sjcl.mode.ccm._macAdditionalData(prf, adata, iv, tlen, w.bitLength(plaintext)/8, L);

	    // mac the plaintext
	    for (i=0; i<plaintext.length; i+=4) {
	      mac = prf.encrypt(xor(mac, plaintext.slice(i,i+4).concat([0,0,0])));
	    }

	    return w.clamp(mac, tlen * 8);
	  },

	  /** CCM CTR mode.
	   * Encrypt or decrypt data and tag with the prf in CCM-style CTR mode.
	   * May mutate its arguments.
	   * @param {Object} prf The PRF.
	   * @param {bitArray} data The data to be encrypted or decrypted.
	   * @param {bitArray} iv The initialization vector.
	   * @param {bitArray} tag The authentication tag.
	   * @param {Number} tlen The length of th etag, in bits.
	   * @param {Number} L The CCM L value.
	   * @return {Object} An object with data and tag, the en/decryption of data and tag values.
	   * @private
	   */
	  _ctrMode: function(prf, data, iv, tag, tlen, L) {
	    var enc, i, w=sjcl.bitArray, xor = w._xor4, ctr, l = data.length, bl=w.bitLength(data), n = l/50, p = n;

	    // start the ctr
	    ctr = w.concat([w.partial(8,L-1)],iv).concat([0,0,0]).slice(0,4);
	    
	    // en/decrypt the tag
	    tag = w.bitSlice(xor(tag,prf.encrypt(ctr)), 0, tlen);
	  
	    // en/decrypt the data
	    if (!l) { return {tag:tag, data:[]}; }
	    
	    for (i=0; i<l; i+=4) {
	      if (i > n) {
	        sjcl.mode.ccm._callProgressListener(i/l);
	        n += p;
	      }
	      ctr[3]++;
	      enc = prf.encrypt(ctr);
	      data[i]   ^= enc[0];
	      data[i+1] ^= enc[1];
	      data[i+2] ^= enc[2];
	      data[i+3] ^= enc[3];
	    }
	    return { tag:tag, data:w.clamp(data,bl) };
	  }
	};
	/** @fileOverview CBC mode implementation
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	if (sjcl.beware === undefined) {
	  sjcl.beware = {};
	}
	sjcl.beware["CBC mode is dangerous because it doesn't protect message integrity."
	] = function() {
	  /** @namespace
	   * Dangerous: CBC mode with PKCS#5 padding.
	   *
	   * @author Emily Stark
	   * @author Mike Hamburg
	   * @author Dan Boneh
	   */
	  sjcl.mode.cbc = {
	    /** The name of the mode.
	     * @constant
	     */
	    name: "cbc",
	    
	    /** Encrypt in CBC mode with PKCS#5 padding.
	     * @param {Object} prp The block cipher.  It must have a block size of 16 bytes.
	     * @param {bitArray} plaintext The plaintext data.
	     * @param {bitArray} iv The initialization value.
	     * @param {bitArray} [adata=[]] The authenticated data.  Must be empty.
	     * @return The encrypted data, an array of bytes.
	     * @throws {sjcl.exception.invalid} if the IV isn't exactly 128 bits, or if any adata is specified.
	     */
	    encrypt: function(prp, plaintext, iv, adata) {
	      if (adata && adata.length) {
	        throw new sjcl.exception.invalid("cbc can't authenticate data");
	      }
	      if (sjcl.bitArray.bitLength(iv) !== 128) {
	        throw new sjcl.exception.invalid("cbc iv must be 128 bits");
	      }
	      var i,
	          w = sjcl.bitArray,
	          xor = w._xor4,
	          bl = w.bitLength(plaintext),
	          bp = 0,
	          output = [];

	      if (bl&7) {
	        throw new sjcl.exception.invalid("pkcs#5 padding only works for multiples of a byte");
	      }
	    
	      for (i=0; bp+128 <= bl; i+=4, bp+=128) {
	        /* Encrypt a non-final block */
	        iv = prp.encrypt(xor(iv, plaintext.slice(i,i+4)));
	        output.splice(i,0,iv[0],iv[1],iv[2],iv[3]);
	      }
	      
	      /* Construct the pad. */
	      bl = (16 - ((bl >> 3) & 15)) * 0x1010101;

	      /* Pad and encrypt. */
	      iv = prp.encrypt(xor(iv,w.concat(plaintext,[bl,bl,bl,bl]).slice(i,i+4)));
	      output.splice(i,0,iv[0],iv[1],iv[2],iv[3]);
	      return output;
	    },
	    
	    /** Decrypt in CBC mode.
	     * @param {Object} prp The block cipher.  It must have a block size of 16 bytes.
	     * @param {bitArray} ciphertext The ciphertext data.
	     * @param {bitArray} iv The initialization value.
	     * @param {bitArray} [adata=[]] The authenticated data.  It must be empty.
	     * @return The decrypted data, an array of bytes.
	     * @throws {sjcl.exception.invalid} if the IV isn't exactly 128 bits, or if any adata is specified.
	     * @throws {sjcl.exception.corrupt} if if the message is corrupt.
	     */
	    decrypt: function(prp, ciphertext, iv, adata) {
	      if (adata && adata.length) {
	        throw new sjcl.exception.invalid("cbc can't authenticate data");
	      }
	      if (sjcl.bitArray.bitLength(iv) !== 128) {
	        throw new sjcl.exception.invalid("cbc iv must be 128 bits");
	      }
	      if ((sjcl.bitArray.bitLength(ciphertext) & 127) || !ciphertext.length) {
	        throw new sjcl.exception.corrupt("cbc ciphertext must be a positive multiple of the block size");
	      }
	      var i,
	          w = sjcl.bitArray,
	          xor = w._xor4,
	          bi, bo,
	          output = [];
	          
	      adata = adata || [];
	    
	      for (i=0; i<ciphertext.length; i+=4) {
	        bi = ciphertext.slice(i,i+4);
	        bo = xor(iv,prp.decrypt(bi));
	        output.splice(i,0,bo[0],bo[1],bo[2],bo[3]);
	        iv = bi;
	      }

	      /* check and remove the pad */
	      bi = output[i-1] & 255;
	      if (bi === 0 || bi > 16) {
	        throw new sjcl.exception.corrupt("pkcs#5 padding corrupt");
	      }
	      bo = bi * 0x1010101;
	      if (!w.equal(w.bitSlice([bo,bo,bo,bo], 0, bi*8),
	                   w.bitSlice(output, output.length*32 - bi*8, output.length*32))) {
	        throw new sjcl.exception.corrupt("pkcs#5 padding corrupt");
	      }

	      return w.bitSlice(output, 0, output.length*32 - bi*8);
	    }
	  };
	};
	/** @fileOverview OCB 2.0 implementation
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** @namespace
	 * Phil Rogaway's Offset CodeBook mode, version 2.0.
	 * May be covered by US and international patents.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */
	sjcl.mode.ocb2 = {
	  /** The name of the mode.
	   * @constant
	   */
	  name: "ocb2",
	  
	  /** Encrypt in OCB mode, version 2.0.
	   * @param {Object} prp The block cipher.  It must have a block size of 16 bytes.
	   * @param {bitArray} plaintext The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=64] the desired tag length, in bits.
	   * @param [false] premac 1 if the authentication data is pre-macced with PMAC.
	   * @return The encrypted data, an array of bytes.
	   * @throws {sjcl.exception.invalid} if the IV isn't exactly 128 bits.
	   */
	  encrypt: function(prp, plaintext, iv, adata, tlen, premac) {
	    if (sjcl.bitArray.bitLength(iv) !== 128) {
	      throw new sjcl.exception.invalid("ocb iv must be 128 bits");
	    }
	    var i,
	        times2 = sjcl.mode.ocb2._times2,
	        w = sjcl.bitArray,
	        xor = w._xor4,
	        checksum = [0,0,0,0],
	        delta = times2(prp.encrypt(iv)),
	        bi, bl,
	        output = [],
	        pad;
	        
	    adata = adata || [];
	    tlen  = tlen || 64;
	  
	    for (i=0; i+4 < plaintext.length; i+=4) {
	      /* Encrypt a non-final block */
	      bi = plaintext.slice(i,i+4);
	      checksum = xor(checksum, bi);
	      output = output.concat(xor(delta,prp.encrypt(xor(delta, bi))));
	      delta = times2(delta);
	    }
	    
	    /* Chop out the final block */
	    bi = plaintext.slice(i);
	    bl = w.bitLength(bi);
	    pad = prp.encrypt(xor(delta,[0,0,0,bl]));
	    bi = w.clamp(xor(bi.concat([0,0,0]),pad), bl);
	    
	    /* Checksum the final block, and finalize the checksum */
	    checksum = xor(checksum,xor(bi.concat([0,0,0]),pad));
	    checksum = prp.encrypt(xor(checksum,xor(delta,times2(delta))));
	    
	    /* MAC the header */
	    if (adata.length) {
	      checksum = xor(checksum, premac ? adata : sjcl.mode.ocb2.pmac(prp, adata));
	    }
	    
	    return output.concat(w.concat(bi, w.clamp(checksum, tlen)));
	  },
	  
	  /** Decrypt in OCB mode.
	   * @param {Object} prp The block cipher.  It must have a block size of 16 bytes.
	   * @param {bitArray} ciphertext The ciphertext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=64] the desired tag length, in bits.
	   * @param {boolean} [premac=false] true if the authentication data is pre-macced with PMAC.
	   * @return The decrypted data, an array of bytes.
	   * @throws {sjcl.exception.invalid} if the IV isn't exactly 128 bits.
	   * @throws {sjcl.exception.corrupt} if if the message is corrupt.
	   */
	  decrypt: function(prp, ciphertext, iv, adata, tlen, premac) {
	    if (sjcl.bitArray.bitLength(iv) !== 128) {
	      throw new sjcl.exception.invalid("ocb iv must be 128 bits");
	    }
	    tlen  = tlen || 64;
	    var i,
	        times2 = sjcl.mode.ocb2._times2,
	        w = sjcl.bitArray,
	        xor = w._xor4,
	        checksum = [0,0,0,0],
	        delta = times2(prp.encrypt(iv)),
	        bi, bl,
	        len = sjcl.bitArray.bitLength(ciphertext) - tlen,
	        output = [],
	        pad;
	        
	    adata = adata || [];
	  
	    for (i=0; i+4 < len/32; i+=4) {
	      /* Decrypt a non-final block */
	      bi = xor(delta, prp.decrypt(xor(delta, ciphertext.slice(i,i+4))));
	      checksum = xor(checksum, bi);
	      output = output.concat(bi);
	      delta = times2(delta);
	    }
	    
	    /* Chop out and decrypt the final block */
	    bl = len-i*32;
	    pad = prp.encrypt(xor(delta,[0,0,0,bl]));
	    bi = xor(pad, w.clamp(ciphertext.slice(i),bl).concat([0,0,0]));
	    
	    /* Checksum the final block, and finalize the checksum */
	    checksum = xor(checksum, bi);
	    checksum = prp.encrypt(xor(checksum, xor(delta, times2(delta))));
	    
	    /* MAC the header */
	    if (adata.length) {
	      checksum = xor(checksum, premac ? adata : sjcl.mode.ocb2.pmac(prp, adata));
	    }
	    
	    if (!w.equal(w.clamp(checksum, tlen), w.bitSlice(ciphertext, len))) {
	      throw new sjcl.exception.corrupt("ocb: tag doesn't match");
	    }
	    
	    return output.concat(w.clamp(bi,bl));
	  },
	  
	  /** PMAC authentication for OCB associated data.
	   * @param {Object} prp The block cipher.  It must have a block size of 16 bytes.
	   * @param {bitArray} adata The authenticated data.
	   */
	  pmac: function(prp, adata) {
	    var i,
	        times2 = sjcl.mode.ocb2._times2,
	        w = sjcl.bitArray,
	        xor = w._xor4,
	        checksum = [0,0,0,0],
	        delta = prp.encrypt([0,0,0,0]),
	        bi;
	        
	    delta = xor(delta,times2(times2(delta)));
	 
	    for (i=0; i+4<adata.length; i+=4) {
	      delta = times2(delta);
	      checksum = xor(checksum, prp.encrypt(xor(delta, adata.slice(i,i+4))));
	    }
	    
	    bi = adata.slice(i);
	    if (w.bitLength(bi) < 128) {
	      delta = xor(delta,times2(delta));
	      bi = w.concat(bi,[0x80000000|0,0,0,0]);
	    }
	    checksum = xor(checksum, bi);
	    return prp.encrypt(xor(times2(xor(delta,times2(delta))), checksum));
	  },
	  
	  /** Double a block of words, OCB style.
	   * @private
	   */
	  _times2: function(x) {
	    return [x[0]<<1 ^ x[1]>>>31,
	            x[1]<<1 ^ x[2]>>>31,
	            x[2]<<1 ^ x[3]>>>31,
	            x[3]<<1 ^ (x[0]>>>31)*0x87];
	  }
	};
	/** @fileOverview GCM mode implementation.
	 *
	 * @author Juho Vähä-Herttua
	 */

	/** @namespace Galois/Counter mode. */
	sjcl.mode.gcm = {
	  /** The name of the mode.
	   * @constant
	   */
	  name: "gcm",
	  
	  /** Encrypt in GCM mode.
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} plaintext The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=128] The desired tag length, in bits.
	   * @return {bitArray} The encrypted data, an array of bytes.
	   */
	  encrypt: function (prf, plaintext, iv, adata, tlen) {
	    var out, data = plaintext.slice(0), w=sjcl.bitArray;
	    tlen = tlen || 128;
	    adata = adata || [];

	    // encrypt and tag
	    out = sjcl.mode.gcm._ctrMode(true, prf, data, adata, iv, tlen);

	    return w.concat(out.data, out.tag);
	  },
	  
	  /** Decrypt in GCM mode.
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} ciphertext The ciphertext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=128] The desired tag length, in bits.
	   * @return {bitArray} The decrypted data.
	   */
	  decrypt: function (prf, ciphertext, iv, adata, tlen) {
	    var out, data = ciphertext.slice(0), tag, w=sjcl.bitArray, l=w.bitLength(data);
	    tlen = tlen || 128;
	    adata = adata || [];

	    // Slice tag out of data
	    if (tlen <= l) {
	      tag = w.bitSlice(data, l-tlen);
	      data = w.bitSlice(data, 0, l-tlen);
	    } else {
	      tag = data;
	      data = [];
	    }

	    // decrypt and tag
	    out = sjcl.mode.gcm._ctrMode(false, prf, data, adata, iv, tlen);

	    if (!w.equal(out.tag, tag)) {
	      throw new sjcl.exception.corrupt("gcm: tag doesn't match");
	    }
	    return out.data;
	  },

	  /* Compute the galois multiplication of X and Y
	   * @private
	   */
	  _galoisMultiply: function (x, y) {
	    var i, j, xi, Zi, Vi, lsb_Vi, w=sjcl.bitArray, xor=w._xor4;

	    Zi = [0,0,0,0];
	    Vi = y.slice(0);

	    // Block size is 128 bits, run 128 times to get Z_128
	    for (i=0; i<128; i++) {
	      xi = (x[Math.floor(i/32)] & (1 << (31-i%32))) !== 0;
	      if (xi) {
	        // Z_i+1 = Z_i ^ V_i
	        Zi = xor(Zi, Vi);
	      }

	      // Store the value of LSB(V_i)
	      lsb_Vi = (Vi[3] & 1) !== 0;

	      // V_i+1 = V_i >> 1
	      for (j=3; j>0; j--) {
	        Vi[j] = (Vi[j] >>> 1) | ((Vi[j-1]&1) << 31);
	      }
	      Vi[0] = Vi[0] >>> 1;

	      // If LSB(V_i) is 1, V_i+1 = (V_i >> 1) ^ R
	      if (lsb_Vi) {
	        Vi[0] = Vi[0] ^ (0xe1 << 24);
	      }
	    }
	    return Zi;
	  },

	  _ghash: function(H, Y0, data) {
	    var Yi, i, l = data.length;

	    Yi = Y0.slice(0);
	    for (i=0; i<l; i+=4) {
	      Yi[0] ^= 0xffffffff&data[i];
	      Yi[1] ^= 0xffffffff&data[i+1];
	      Yi[2] ^= 0xffffffff&data[i+2];
	      Yi[3] ^= 0xffffffff&data[i+3];
	      Yi = sjcl.mode.gcm._galoisMultiply(Yi, H);
	    }
	    return Yi;
	  },

	  /** GCM CTR mode.
	   * Encrypt or decrypt data and tag with the prf in GCM-style CTR mode.
	   * @param {Boolean} encrypt True if encrypt, false if decrypt.
	   * @param {Object} prf The PRF.
	   * @param {bitArray} data The data to be encrypted or decrypted.
	   * @param {bitArray} iv The initialization vector.
	   * @param {bitArray} adata The associated data to be tagged.
	   * @param {Number} tlen The length of the tag, in bits.
	   */
	  _ctrMode: function(encrypt, prf, data, adata, iv, tlen) {
	    var H, J0, S0, enc, i, ctr, tag, last, l, bl, abl, ivbl, w=sjcl.bitArray;

	    // Calculate data lengths
	    l = data.length;
	    bl = w.bitLength(data);
	    abl = w.bitLength(adata);
	    ivbl = w.bitLength(iv);

	    // Calculate the parameters
	    H = prf.encrypt([0,0,0,0]);
	    if (ivbl === 96) {
	      J0 = iv.slice(0);
	      J0 = w.concat(J0, [1]);
	    } else {
	      J0 = sjcl.mode.gcm._ghash(H, [0,0,0,0], iv);
	      J0 = sjcl.mode.gcm._ghash(H, J0, [0,0,Math.floor(ivbl/0x100000000),ivbl&0xffffffff]);
	    }
	    S0 = sjcl.mode.gcm._ghash(H, [0,0,0,0], adata);

	    // Initialize ctr and tag
	    ctr = J0.slice(0);
	    tag = S0.slice(0);

	    // If decrypting, calculate hash
	    if (!encrypt) {
	      tag = sjcl.mode.gcm._ghash(H, S0, data);
	    }

	    // Encrypt all the data
	    for (i=0; i<l; i+=4) {
	       ctr[3]++;
	       enc = prf.encrypt(ctr);
	       data[i]   ^= enc[0];
	       data[i+1] ^= enc[1];
	       data[i+2] ^= enc[2];
	       data[i+3] ^= enc[3];
	    }
	    data = w.clamp(data, bl);

	    // If encrypting, calculate hash
	    if (encrypt) {
	      tag = sjcl.mode.gcm._ghash(H, S0, data);
	    }

	    // Calculate last block from bit lengths, ugly because bitwise operations are 32-bit
	    last = [
	      Math.floor(abl/0x100000000), abl&0xffffffff,
	      Math.floor(bl/0x100000000), bl&0xffffffff
	    ];

	    // Calculate the final tag block
	    tag = sjcl.mode.gcm._ghash(H, tag, last);
	    enc = prf.encrypt(J0);
	    tag[0] ^= enc[0];
	    tag[1] ^= enc[1];
	    tag[2] ^= enc[2];
	    tag[3] ^= enc[3];

	    return { tag:w.bitSlice(tag, 0, tlen), data:data };
	  }
	};
	/** @fileOverview HMAC implementation.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** HMAC with the specified hash function.
	 * @constructor
	 * @param {bitArray} key the key for HMAC.
	 * @param {Object} [hash=sjcl.hash.sha256] The hash function to use.
	 */
	sjcl.misc.hmac = function (key, Hash) {
	  this._hash = Hash = Hash || sjcl.hash.sha256;
	  var exKey = [[],[]], i,
	      bs = Hash.prototype.blockSize / 32;
	  this._baseHash = [new Hash(), new Hash()];

	  if (key.length > bs) {
	    key = Hash.hash(key);
	  }
	  
	  for (i=0; i<bs; i++) {
	    exKey[0][i] = key[i]^0x36363636;
	    exKey[1][i] = key[i]^0x5C5C5C5C;
	  }
	  
	  this._baseHash[0].update(exKey[0]);
	  this._baseHash[1].update(exKey[1]);
	  this._resultHash = new Hash(this._baseHash[0]);
	};

	/** HMAC with the specified hash function.  Also called encrypt since it's a prf.
	 * @param {bitArray|String} data The data to mac.
	 */
	sjcl.misc.hmac.prototype.encrypt = sjcl.misc.hmac.prototype.mac = function (data) {
	  if (!this._updated) {
	    this.update(data);
	    return this.digest(data);
	  } else {
	    throw new sjcl.exception.invalid("encrypt on already updated hmac called!");
	  }
	};

	sjcl.misc.hmac.prototype.reset = function () {
	  this._resultHash = new this._hash(this._baseHash[0]);
	  this._updated = false;
	};

	sjcl.misc.hmac.prototype.update = function (data) {
	  this._updated = true;
	  this._resultHash.update(data);
	};

	sjcl.misc.hmac.prototype.digest = function () {
	  var w = this._resultHash.finalize(), result = new (this._hash)(this._baseHash[1]).update(w).finalize();

	  this.reset();

	  return result;
	};/** @fileOverview Password-based key-derivation function, version 2.0.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	/** Password-Based Key-Derivation Function, version 2.0.
	 *
	 * Generate keys from passwords using PBKDF2-HMAC-SHA256.
	 *
	 * This is the method specified by RSA's PKCS #5 standard.
	 *
	 * @param {bitArray|String} password  The password.
	 * @param {bitArray|String} salt The salt.  Should have lots of entropy.
	 * @param {Number} [count=1000] The number of iterations.  Higher numbers make the function slower but more secure.
	 * @param {Number} [length] The length of the derived key.  Defaults to the
	                            output size of the hash function.
	 * @param {Object} [Prff=sjcl.misc.hmac] The pseudorandom function family.
	 * @return {bitArray} the derived key.
	 */
	sjcl.misc.pbkdf2 = function (password, salt, count, length, Prff) {
	  count = count || 1000;
	  
	  if (length < 0 || count < 0) {
	    throw sjcl.exception.invalid("invalid params to pbkdf2");
	  }
	  
	  if (typeof password === "string") {
	    password = sjcl.codec.utf8String.toBits(password);
	  }
	  
	  if (typeof salt === "string") {
	    salt = sjcl.codec.utf8String.toBits(salt);
	  }
	  
	  Prff = Prff || sjcl.misc.hmac;
	  
	  var prf = new Prff(password),
	      u, ui, i, j, k, out = [], b = sjcl.bitArray;

	  for (k = 1; 32 * out.length < (length || 1); k++) {
	    u = ui = prf.encrypt(b.concat(salt,[k]));
	    
	    for (i=1; i<count; i++) {
	      ui = prf.encrypt(ui);
	      for (j=0; j<ui.length; j++) {
	        u[j] ^= ui[j];
	      }
	    }
	    
	    out = out.concat(u);
	  }

	  if (length) { out = b.clamp(out, length); }

	  return out;
	};
	/** @fileOverview Random number generator.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 * @author Michael Brooks
	 */

	/** @constructor
	 * @class Random number generator
	 * @description
	 * <b>Use sjcl.random as a singleton for this class!</b>
	 * <p>
	 * This random number generator is a derivative of Ferguson and Schneier's
	 * generator Fortuna.  It collects entropy from various events into several
	 * pools, implemented by streaming SHA-256 instances.  It differs from
	 * ordinary Fortuna in a few ways, though.
	 * </p>
	 *
	 * <p>
	 * Most importantly, it has an entropy estimator.  This is present because
	 * there is a strong conflict here between making the generator available
	 * as soon as possible, and making sure that it doesn't "run on empty".
	 * In Fortuna, there is a saved state file, and the system is likely to have
	 * time to warm up.
	 * </p>
	 *
	 * <p>
	 * Second, because users are unlikely to stay on the page for very long,
	 * and to speed startup time, the number of pools increases logarithmically:
	 * a new pool is created when the previous one is actually used for a reseed.
	 * This gives the same asymptotic guarantees as Fortuna, but gives more
	 * entropy to early reseeds.
	 * </p>
	 *
	 * <p>
	 * The entire mechanism here feels pretty klunky.  Furthermore, there are
	 * several improvements that should be made, including support for
	 * dedicated cryptographic functions that may be present in some browsers;
	 * state files in local storage; cookies containing randomness; etc.  So
	 * look for improvements in future versions.
	 * </p>
	 */
	sjcl.prng = function(defaultParanoia) {
	  
	  /* private */
	  this._pools                   = [new sjcl.hash.sha256()];
	  this._poolEntropy             = [0];
	  this._reseedCount             = 0;
	  this._robins                  = {};
	  this._eventId                 = 0;
	  
	  this._collectorIds            = {};
	  this._collectorIdNext         = 0;
	  
	  this._strength                = 0;
	  this._poolStrength            = 0;
	  this._nextReseed              = 0;
	  this._key                     = [0,0,0,0,0,0,0,0];
	  this._counter                 = [0,0,0,0];
	  this._cipher                  = undefined;
	  this._defaultParanoia         = defaultParanoia;
	  
	  /* event listener stuff */
	  this._collectorsStarted       = false;
	  this._callbacks               = {progress: {}, seeded: {}};
	  this._callbackI               = 0;
	  
	  /* constants */
	  this._NOT_READY               = 0;
	  this._READY                   = 1;
	  this._REQUIRES_RESEED         = 2;

	  this._MAX_WORDS_PER_BURST     = 65536;
	  this._PARANOIA_LEVELS         = [0,48,64,96,128,192,256,384,512,768,1024];
	  this._MILLISECONDS_PER_RESEED = 30000;
	  this._BITS_PER_RESEED         = 80;
	};
	 
	sjcl.prng.prototype = {
	  /** Generate several random words, and return them in an array.
	   * A word consists of 32 bits (4 bytes)
	   * @param {Number} nwords The number of words to generate.
	   */
	  randomWords: function (nwords, paranoia) {
	    var out = [], i, readiness = this.isReady(paranoia), g;
	  
	    if (readiness === this._NOT_READY) {
	      throw new sjcl.exception.notReady("generator isn't seeded");
	    } else if (readiness & this._REQUIRES_RESEED) {
	      this._reseedFromPools(!(readiness & this._READY));
	    }
	  
	    for (i=0; i<nwords; i+= 4) {
	      if ((i+1) % this._MAX_WORDS_PER_BURST === 0) {
	        this._gate();
	      }
	   
	      g = this._gen4words();
	      out.push(g[0],g[1],g[2],g[3]);
	    }
	    this._gate();
	  
	    return out.slice(0,nwords);
	  },
	  
	  setDefaultParanoia: function (paranoia, allowZeroParanoia) {
	    if (paranoia === 0 && allowZeroParanoia !== "Setting paranoia=0 will ruin your security; use it only for testing") {
	      throw "Setting paranoia=0 will ruin your security; use it only for testing";
	    }

	    this._defaultParanoia = paranoia;
	  },
	  
	  /**
	   * Add entropy to the pools.
	   * @param data The entropic value.  Should be a 32-bit integer, array of 32-bit integers, or string
	   * @param {Number} estimatedEntropy The estimated entropy of data, in bits
	   * @param {String} source The source of the entropy, eg "mouse"
	   */
	  addEntropy: function (data, estimatedEntropy, source) {
	    source = source || "user";
	  
	    var id,
	      i, tmp,
	      t = (new Date()).valueOf(),
	      robin = this._robins[source],
	      oldReady = this.isReady(), err = 0, objName;
	      
	    id = this._collectorIds[source];
	    if (id === undefined) { id = this._collectorIds[source] = this._collectorIdNext ++; }
	      
	    if (robin === undefined) { robin = this._robins[source] = 0; }
	    this._robins[source] = ( this._robins[source] + 1 ) % this._pools.length;
	  
	    switch(typeof(data)) {
	      
	    case "number":
	      if (estimatedEntropy === undefined) {
	        estimatedEntropy = 1;
	      }
	      this._pools[robin].update([id,this._eventId++,1,estimatedEntropy,t,1,data|0]);
	      break;
	      
	    case "object":
	      objName = Object.prototype.toString.call(data);
	      if (objName === "[object Uint32Array]") {
	        tmp = [];
	        for (i = 0; i < data.length; i++) {
	          tmp.push(data[i]);
	        }
	        data = tmp;
	      } else {
	        if (objName !== "[object Array]") {
	          err = 1;
	        }
	        for (i=0; i<data.length && !err; i++) {
	          if (typeof(data[i]) !== "number") {
	            err = 1;
	          }
	        }
	      }
	      if (!err) {
	        if (estimatedEntropy === undefined) {
	          /* horrible entropy estimator */
	          estimatedEntropy = 0;
	          for (i=0; i<data.length; i++) {
	            tmp= data[i];
	            while (tmp>0) {
	              estimatedEntropy++;
	              tmp = tmp >>> 1;
	            }
	          }
	        }
	        this._pools[robin].update([id,this._eventId++,2,estimatedEntropy,t,data.length].concat(data));
	      }
	      break;
	      
	    case "string":
	      if (estimatedEntropy === undefined) {
	       /* English text has just over 1 bit per character of entropy.
	        * But this might be HTML or something, and have far less
	        * entropy than English...  Oh well, let's just say one bit.
	        */
	       estimatedEntropy = data.length;
	      }
	      this._pools[robin].update([id,this._eventId++,3,estimatedEntropy,t,data.length]);
	      this._pools[robin].update(data);
	      break;
	      
	    default:
	      err=1;
	    }
	    if (err) {
	      throw new sjcl.exception.bug("random: addEntropy only supports number, array of numbers or string");
	    }
	  
	    /* record the new strength */
	    this._poolEntropy[robin] += estimatedEntropy;
	    this._poolStrength += estimatedEntropy;
	  
	    /* fire off events */
	    if (oldReady === this._NOT_READY) {
	      if (this.isReady() !== this._NOT_READY) {
	        this._fireEvent("seeded", Math.max(this._strength, this._poolStrength));
	      }
	      this._fireEvent("progress", this.getProgress());
	    }
	  },
	  
	  /** Is the generator ready? */
	  isReady: function (paranoia) {
	    var entropyRequired = this._PARANOIA_LEVELS[ (paranoia !== undefined) ? paranoia : this._defaultParanoia ];
	  
	    if (this._strength && this._strength >= entropyRequired) {
	      return (this._poolEntropy[0] > this._BITS_PER_RESEED && (new Date()).valueOf() > this._nextReseed) ?
	        this._REQUIRES_RESEED | this._READY :
	        this._READY;
	    } else {
	      return (this._poolStrength >= entropyRequired) ?
	        this._REQUIRES_RESEED | this._NOT_READY :
	        this._NOT_READY;
	    }
	  },
	  
	  /** Get the generator's progress toward readiness, as a fraction */
	  getProgress: function (paranoia) {
	    var entropyRequired = this._PARANOIA_LEVELS[ paranoia ? paranoia : this._defaultParanoia ];
	  
	    if (this._strength >= entropyRequired) {
	      return 1.0;
	    } else {
	      return (this._poolStrength > entropyRequired) ?
	        1.0 :
	        this._poolStrength / entropyRequired;
	    }
	  },
	  
	  /** start the built-in entropy collectors */
	  startCollectors: function () {
	    if (this._collectorsStarted) { return; }
	  
	    this._eventListener = {
	      loadTimeCollector: this._bind(this._loadTimeCollector),
	      mouseCollector: this._bind(this._mouseCollector),
	      keyboardCollector: this._bind(this._keyboardCollector),
	      accelerometerCollector: this._bind(this._accelerometerCollector),
	      touchCollector: this._bind(this._touchCollector)
	    };

	    if (window.addEventListener) {
	      window.addEventListener("load", this._eventListener.loadTimeCollector, false);
	      window.addEventListener("mousemove", this._eventListener.mouseCollector, false);
	      window.addEventListener("keypress", this._eventListener.keyboardCollector, false);
	      window.addEventListener("devicemotion", this._eventListener.accelerometerCollector, false);
	      window.addEventListener("touchmove", this._eventListener.touchCollector, false);
	    } else if (document.attachEvent) {
	      document.attachEvent("onload", this._eventListener.loadTimeCollector);
	      document.attachEvent("onmousemove", this._eventListener.mouseCollector);
	      document.attachEvent("keypress", this._eventListener.keyboardCollector);
	    } else {
	      throw new sjcl.exception.bug("can't attach event");
	    }
	  
	    this._collectorsStarted = true;
	  },
	  
	  /** stop the built-in entropy collectors */
	  stopCollectors: function () {
	    if (!this._collectorsStarted) { return; }
	  
	    if (window.removeEventListener) {
	      window.removeEventListener("load", this._eventListener.loadTimeCollector, false);
	      window.removeEventListener("mousemove", this._eventListener.mouseCollector, false);
	      window.removeEventListener("keypress", this._eventListener.keyboardCollector, false);
	      window.removeEventListener("devicemotion", this._eventListener.accelerometerCollector, false);
	      window.removeEventListener("touchmove", this._eventListener.touchCollector, false);
	    } else if (document.detachEvent) {
	      document.detachEvent("onload", this._eventListener.loadTimeCollector);
	      document.detachEvent("onmousemove", this._eventListener.mouseCollector);
	      document.detachEvent("keypress", this._eventListener.keyboardCollector);
	    }

	    this._collectorsStarted = false;
	  },
	  
	  /* use a cookie to store entropy.
	  useCookie: function (all_cookies) {
	      throw new sjcl.exception.bug("random: useCookie is unimplemented");
	  },*/
	  
	  /** add an event listener for progress or seeded-ness. */
	  addEventListener: function (name, callback) {
	    this._callbacks[name][this._callbackI++] = callback;
	  },
	  
	  /** remove an event listener for progress or seeded-ness */
	  removeEventListener: function (name, cb) {
	    var i, j, cbs=this._callbacks[name], jsTemp=[];

	    /* I'm not sure if this is necessary; in C++, iterating over a
	     * collection and modifying it at the same time is a no-no.
	     */

	    for (j in cbs) {
	      if (cbs.hasOwnProperty(j) && cbs[j] === cb) {
	        jsTemp.push(j);
	      }
	    }

	    for (i=0; i<jsTemp.length; i++) {
	      j = jsTemp[i];
	      delete cbs[j];
	    }
	  },
	  
	  _bind: function (func) {
	    var that = this;
	    return function () {
	      func.apply(that, arguments);
	    };
	  },

	  /** Generate 4 random words, no reseed, no gate.
	   * @private
	   */
	  _gen4words: function () {
	    for (var i=0; i<4; i++) {
	      this._counter[i] = this._counter[i]+1 | 0;
	      if (this._counter[i]) { break; }
	    }
	    return this._cipher.encrypt(this._counter);
	  },
	  
	  /* Rekey the AES instance with itself after a request, or every _MAX_WORDS_PER_BURST words.
	   * @private
	   */
	  _gate: function () {
	    this._key = this._gen4words().concat(this._gen4words());
	    this._cipher = new sjcl.cipher.aes(this._key);
	  },
	  
	  /** Reseed the generator with the given words
	   * @private
	   */
	  _reseed: function (seedWords) {
	    this._key = sjcl.hash.sha256.hash(this._key.concat(seedWords));
	    this._cipher = new sjcl.cipher.aes(this._key);
	    for (var i=0; i<4; i++) {
	      this._counter[i] = this._counter[i]+1 | 0;
	      if (this._counter[i]) { break; }
	    }
	  },
	  
	  /** reseed the data from the entropy pools
	   * @param full If set, use all the entropy pools in the reseed.
	   */
	  _reseedFromPools: function (full) {
	    var reseedData = [], strength = 0, i;
	  
	    this._nextReseed = reseedData[0] =
	      (new Date()).valueOf() + this._MILLISECONDS_PER_RESEED;
	    
	    for (i=0; i<16; i++) {
	      /* On some browsers, this is cryptographically random.  So we might
	       * as well toss it in the pot and stir...
	       */
	      reseedData.push(Math.random()*0x100000000|0);
	    }
	    
	    for (i=0; i<this._pools.length; i++) {
	     reseedData = reseedData.concat(this._pools[i].finalize());
	     strength += this._poolEntropy[i];
	     this._poolEntropy[i] = 0;
	   
	     if (!full && (this._reseedCount & (1<<i))) { break; }
	    }
	  
	    /* if we used the last pool, push a new one onto the stack */
	    if (this._reseedCount >= 1 << this._pools.length) {
	     this._pools.push(new sjcl.hash.sha256());
	     this._poolEntropy.push(0);
	    }
	  
	    /* how strong was this reseed? */
	    this._poolStrength -= strength;
	    if (strength > this._strength) {
	      this._strength = strength;
	    }
	  
	    this._reseedCount ++;
	    this._reseed(reseedData);
	  },
	  
	  _keyboardCollector: function () {
	    this._addCurrentTimeToEntropy(1);
	  },
	  
	  _mouseCollector: function (ev) {
	    var x, y;

	    try {
	      x = ev.x || ev.clientX || ev.offsetX || 0;
	      y = ev.y || ev.clientY || ev.offsetY || 0;
	    } catch (err) {
	      // Event originated from a secure element. No mouse position available.
	      x = 0;
	      y = 0;
	    }

	    if (x != 0 && y!= 0) {
	      sjcl.random.addEntropy([x,y], 2, "mouse");
	    }

	    this._addCurrentTimeToEntropy(0);
	  },

	  _touchCollector: function(ev) {
	    var touch = ev.touches[0] || ev.changedTouches[0];
	    var x = touch.pageX || touch.clientX,
	        y = touch.pageY || touch.clientY;

	    sjcl.random.addEntropy([x,y],1,"touch");

	    this._addCurrentTimeToEntropy(0);
	  },
	  
	  _loadTimeCollector: function () {
	    this._addCurrentTimeToEntropy(2);
	  },

	  _addCurrentTimeToEntropy: function (estimatedEntropy) {
	    if (typeof window !== 'undefined' && window.performance && typeof window.performance.now === "function") {
	      //how much entropy do we want to add here?
	      sjcl.random.addEntropy(window.performance.now(), estimatedEntropy, "loadtime");
	    } else {
	      sjcl.random.addEntropy((new Date()).valueOf(), estimatedEntropy, "loadtime");
	    }
	  },
	  _accelerometerCollector: function (ev) {
	    var ac = ev.accelerationIncludingGravity.x||ev.accelerationIncludingGravity.y||ev.accelerationIncludingGravity.z;
	    if(window.orientation){
	      var or = window.orientation;
	      if (typeof or === "number") {
	        sjcl.random.addEntropy(or, 1, "accelerometer");
	      }
	    }
	    if (ac) {
	      sjcl.random.addEntropy(ac, 2, "accelerometer");
	    }
	    this._addCurrentTimeToEntropy(0);
	  },

	  _fireEvent: function (name, arg) {
	    var j, cbs=sjcl.random._callbacks[name], cbsTemp=[];
	    /* TODO: there is a race condition between removing collectors and firing them */

	    /* I'm not sure if this is necessary; in C++, iterating over a
	     * collection and modifying it at the same time is a no-no.
	     */

	    for (j in cbs) {
	      if (cbs.hasOwnProperty(j)) {
	        cbsTemp.push(cbs[j]);
	      }
	    }

	    for (j=0; j<cbsTemp.length; j++) {
	      cbsTemp[j](arg);
	    }
	  }
	};

	/** an instance for the prng.
	* @see sjcl.prng
	*/
	sjcl.random = new sjcl.prng(6);

	(function(){
	  // function for getting nodejs crypto module. catches and ignores errors.
	  function getCryptoModule() {
	    try {
	      return __webpack_require__(70);
	    }
	    catch (e) {
	      return null;
	    }
	  }

	  try {
	    var buf, crypt, ab;

	    // get cryptographically strong entropy depending on runtime environment
	    if (typeof module !== 'undefined' && module.exports && (crypt = getCryptoModule()) && crypt.randomBytes) {
	      buf = crypt.randomBytes(1024/8);
	      buf = new Uint32Array(new Uint8Array(buf).buffer);
	      sjcl.random.addEntropy(buf, 1024, "crypto.randomBytes");

	    } else if (typeof window !== 'undefined' && typeof Uint32Array !== 'undefined') {
	      ab = new Uint32Array(32);
	      if (window.crypto && window.crypto.getRandomValues) {
	        window.crypto.getRandomValues(ab);
	      } else if (window.msCrypto && window.msCrypto.getRandomValues) {
	        window.msCrypto.getRandomValues(ab);
	      } else {
	        return;
	      }

	      // get cryptographically strong entropy in Webkit
	      sjcl.random.addEntropy(ab, 1024, "crypto.getRandomValues");

	    } else {
	      // no getRandomValues :-(
	    }
	  } catch (e) {
	    if (typeof window !== 'undefined' && window.console) {
	      console.log("There was an error collecting entropy from the browser:");
	      console.log(e);
	      //we do not want the library to fail due to randomness not being maintained.
	    }
	  }
	}());
	/** @fileOverview Convenince functions centered around JSON encapsulation.
	 *
	 * @author Emily Stark
	 * @author Mike Hamburg
	 * @author Dan Boneh
	 */

	 /** @namespace JSON encapsulation */
	 sjcl.json = {
	  /** Default values for encryption */
	  defaults: { v:1, iter:1000, ks:128, ts:64, mode:"ccm", adata:"", cipher:"aes" },

	  /** Simple encryption function.
	   * @param {String|bitArray} password The password or key.
	   * @param {String} plaintext The data to encrypt.
	   * @param {Object} [params] The parameters including tag, iv and salt.
	   * @param {Object} [rp] A returned version with filled-in parameters.
	   * @return {Object} The cipher raw data.
	   * @throws {sjcl.exception.invalid} if a parameter is invalid.
	   */
	  _encrypt: function (password, plaintext, params, rp) {
	    params = params || {};
	    rp = rp || {};

	    var j = sjcl.json, p = j._add({ iv: sjcl.random.randomWords(4,0) },
	                                  j.defaults), tmp, prp, adata;
	    j._add(p, params);
	    adata = p.adata;
	    if (typeof p.salt === "string") {
	      p.salt = sjcl.codec.base64.toBits(p.salt);
	    }
	    if (typeof p.iv === "string") {
	      p.iv = sjcl.codec.base64.toBits(p.iv);
	    }

	    if (!sjcl.mode[p.mode] ||
	        !sjcl.cipher[p.cipher] ||
	        (typeof password === "string" && p.iter <= 100) ||
	        (p.ts !== 64 && p.ts !== 96 && p.ts !== 128) ||
	        (p.ks !== 128 && p.ks !== 192 && p.ks !== 256) ||
	        (p.iv.length < 2 || p.iv.length > 4)) {
	      throw new sjcl.exception.invalid("json encrypt: invalid parameters");
	    }

	    if (typeof password === "string") {
	      tmp = sjcl.misc.cachedPbkdf2(password, p);
	      password = tmp.key.slice(0,p.ks/32);
	      p.salt = tmp.salt;
	    } else if (sjcl.ecc && password instanceof sjcl.ecc.elGamal.publicKey) {
	      tmp = password.kem();
	      p.kemtag = tmp.tag;
	      password = tmp.key.slice(0,p.ks/32);
	    }
	    if (typeof plaintext === "string") {
	      plaintext = sjcl.codec.utf8String.toBits(plaintext);
	    }
	    if (typeof adata === "string") {
	      p.adata = adata = sjcl.codec.utf8String.toBits(adata);
	    }
	    prp = new sjcl.cipher[p.cipher](password);

	    /* return the json data */
	    j._add(rp, p);
	    rp.key = password;

	    /* do the encryption */
	    if (p.mode === "ccm" && sjcl.arrayBuffer && sjcl.arrayBuffer.ccm && plaintext instanceof ArrayBuffer) {
	      p.ct = sjcl.arrayBuffer.ccm.encrypt(prp, plaintext, p.iv, adata, p.ts);
	    } else {
	      p.ct = sjcl.mode[p.mode].encrypt(prp, plaintext, p.iv, adata, p.ts);
	    }

	    //return j.encode(j._subtract(p, j.defaults));
	    return p;
	  },

	  /** Simple encryption function.
	   * @param {String|bitArray} password The password or key.
	   * @param {String} plaintext The data to encrypt.
	   * @param {Object} [params] The parameters including tag, iv and salt.
	   * @param {Object} [rp] A returned version with filled-in parameters.
	   * @return {String} The ciphertext serialized data.
	   * @throws {sjcl.exception.invalid} if a parameter is invalid.
	   */
	  encrypt: function (password, plaintext, params, rp) {
	    var j = sjcl.json, p = j._encrypt.apply(j, arguments);
	    return j.encode(p);
	  },

	  /** Simple decryption function.
	   * @param {String|bitArray} password The password or key.
	   * @param {Object} ciphertext The cipher raw data to decrypt.
	   * @param {Object} [params] Additional non-default parameters.
	   * @param {Object} [rp] A returned object with filled parameters.
	   * @return {String} The plaintext.
	   * @throws {sjcl.exception.invalid} if a parameter is invalid.
	   * @throws {sjcl.exception.corrupt} if the ciphertext is corrupt.
	   */
	  _decrypt: function (password, ciphertext, params, rp) {
	    params = params || {};
	    rp = rp || {};

	    var j = sjcl.json, p = j._add(j._add(j._add({},j.defaults),ciphertext), params, true), ct, tmp, prp, adata=p.adata;
	    if (typeof p.salt === "string") {
	      p.salt = sjcl.codec.base64.toBits(p.salt);
	    }
	    if (typeof p.iv === "string") {
	      p.iv = sjcl.codec.base64.toBits(p.iv);
	    }

	    if (!sjcl.mode[p.mode] ||
	        !sjcl.cipher[p.cipher] ||
	        (typeof password === "string" && p.iter <= 100) ||
	        (p.ts !== 64 && p.ts !== 96 && p.ts !== 128) ||
	        (p.ks !== 128 && p.ks !== 192 && p.ks !== 256) ||
	        (!p.iv) ||
	        (p.iv.length < 2 || p.iv.length > 4)) {
	      throw new sjcl.exception.invalid("json decrypt: invalid parameters");
	    }

	    if (typeof password === "string") {
	      tmp = sjcl.misc.cachedPbkdf2(password, p);
	      password = tmp.key.slice(0,p.ks/32);
	      p.salt  = tmp.salt;
	    } else if (sjcl.ecc && password instanceof sjcl.ecc.elGamal.secretKey) {
	      password = password.unkem(sjcl.codec.base64.toBits(p.kemtag)).slice(0,p.ks/32);
	    }
	    if (typeof adata === "string") {
	      adata = sjcl.codec.utf8String.toBits(adata);
	    }
	    prp = new sjcl.cipher[p.cipher](password);

	    /* do the decryption */
	    if (p.mode === "ccm" && sjcl.arrayBuffer && sjcl.arrayBuffer.ccm && p.ct instanceof ArrayBuffer) {
	      ct = sjcl.arrayBuffer.ccm.decrypt(prp, p.ct, p.iv, p.tag, adata, p.ts);
	    } else {
	      ct = sjcl.mode[p.mode].decrypt(prp, p.ct, p.iv, adata, p.ts);
	    }

	    /* return the json data */
	    j._add(rp, p);
	    rp.key = password;

	    if (params.raw === 1) {
	      return ct;
	    } else {
	      return sjcl.codec.utf8String.fromBits(ct);
	    }
	  },

	  /** Simple decryption function.
	   * @param {String|bitArray} password The password or key.
	   * @param {String} ciphertext The ciphertext to decrypt.
	   * @param {Object} [params] Additional non-default parameters.
	   * @param {Object} [rp] A returned object with filled parameters.
	   * @return {String} The plaintext.
	   * @throws {sjcl.exception.invalid} if a parameter is invalid.
	   * @throws {sjcl.exception.corrupt} if the ciphertext is corrupt.
	   */
	  decrypt: function (password, ciphertext, params, rp) {
	    var j = sjcl.json;
	    return j._decrypt(password, j.decode(ciphertext), params, rp);
	  },

	  /** Encode a flat structure into a JSON string.
	   * @param {Object} obj The structure to encode.
	   * @return {String} A JSON string.
	   * @throws {sjcl.exception.invalid} if obj has a non-alphanumeric property.
	   * @throws {sjcl.exception.bug} if a parameter has an unsupported type.
	   */
	  encode: function (obj) {
	    var i, out='{', comma='';
	    for (i in obj) {
	      if (obj.hasOwnProperty(i)) {
	        if (!i.match(/^[a-z0-9]+$/i)) {
	          throw new sjcl.exception.invalid("json encode: invalid property name");
	        }
	        out += comma + '"' + i + '":';
	        comma = ',';

	        switch (typeof obj[i]) {
	          case 'number':
	          case 'boolean':
	            out += obj[i];
	            break;

	          case 'string':
	            out += '"' + escape(obj[i]) + '"';
	            break;

	          case 'object':
	            out += '"' + sjcl.codec.base64.fromBits(obj[i],0) + '"';
	            break;

	          default:
	            throw new sjcl.exception.bug("json encode: unsupported type");
	        }
	      }
	    }
	    return out+'}';
	  },

	  /** Decode a simple (flat) JSON string into a structure.  The ciphertext,
	   * adata, salt and iv will be base64-decoded.
	   * @param {String} str The string.
	   * @return {Object} The decoded structure.
	   * @throws {sjcl.exception.invalid} if str isn't (simple) JSON.
	   */
	  decode: function (str) {
	    str = str.replace(/\s/g,'');
	    if (!str.match(/^\{.*\}$/)) {
	      throw new sjcl.exception.invalid("json decode: this isn't json!");
	    }
	    var a = str.replace(/^\{|\}$/g, '').split(/,/), out={}, i, m;
	    for (i=0; i<a.length; i++) {
	      if (!(m=a[i].match(/^\s*(?:(["']?)([a-z][a-z0-9]*)\1)\s*:\s*(?:(-?\d+)|"([a-z0-9+\/%*_.@=\-]*)"|(true|false))$/i))) {
	        throw new sjcl.exception.invalid("json decode: this isn't json!");
	      }
	      if (m[3] != null) {
	        out[m[2]] = parseInt(m[3],10);
	      } else if (m[4] != null) {
	        out[m[2]] = m[2].match(/^(ct|adata|salt|iv)$/) ? sjcl.codec.base64.toBits(m[4]) : unescape(m[4]);
	      } else if (m[5] != null) {
	        out[m[2]] = m[5] === 'true';
	      }
	    }
	    return out;
	  },

	  /** Insert all elements of src into target, modifying and returning target.
	   * @param {Object} target The object to be modified.
	   * @param {Object} src The object to pull data from.
	   * @param {boolean} [requireSame=false] If true, throw an exception if any field of target differs from corresponding field of src.
	   * @return {Object} target.
	   * @private
	   */
	  _add: function (target, src, requireSame) {
	    if (target === undefined) { target = {}; }
	    if (src === undefined) { return target; }
	    var i;
	    for (i in src) {
	      if (src.hasOwnProperty(i)) {
	        if (requireSame && target[i] !== undefined && target[i] !== src[i]) {
	          throw new sjcl.exception.invalid("required parameter overridden");
	        }
	        target[i] = src[i];
	      }
	    }
	    return target;
	  },

	  /** Remove all elements of minus from plus.  Does not modify plus.
	   * @private
	   */
	  _subtract: function (plus, minus) {
	    var out = {}, i;

	    for (i in plus) {
	      if (plus.hasOwnProperty(i) && plus[i] !== minus[i]) {
	        out[i] = plus[i];
	      }
	    }

	    return out;
	  },

	  /** Return only the specified elements of src.
	   * @private
	   */
	  _filter: function (src, filter) {
	    var out = {}, i;
	    for (i=0; i<filter.length; i++) {
	      if (src[filter[i]] !== undefined) {
	        out[filter[i]] = src[filter[i]];
	      }
	    }
	    return out;
	  }
	};

	/** Simple encryption function; convenient shorthand for sjcl.json.encrypt.
	 * @param {String|bitArray} password The password or key.
	 * @param {String} plaintext The data to encrypt.
	 * @param {Object} [params] The parameters including tag, iv and salt.
	 * @param {Object} [rp] A returned version with filled-in parameters.
	 * @return {String} The ciphertext.
	 */
	sjcl.encrypt = sjcl.json.encrypt;

	/** Simple decryption function; convenient shorthand for sjcl.json.decrypt.
	 * @param {String|bitArray} password The password or key.
	 * @param {String} ciphertext The ciphertext to decrypt.
	 * @param {Object} [params] Additional non-default parameters.
	 * @param {Object} [rp] A returned object with filled parameters.
	 * @return {String} The plaintext.
	 */
	sjcl.decrypt = sjcl.json.decrypt;

	/** The cache for cachedPbkdf2.
	 * @private
	 */
	sjcl.misc._pbkdf2Cache = {};

	/** Cached PBKDF2 key derivation.
	 * @param {String} password The password.
	 * @param {Object} [obj] The derivation params (iteration count and optional salt).
	 * @return {Object} The derived data in key, the salt in salt.
	 */
	sjcl.misc.cachedPbkdf2 = function (password, obj) {
	  var cache = sjcl.misc._pbkdf2Cache, c, cp, str, salt, iter;

	  obj = obj || {};
	  iter = obj.iter || 1000;

	  /* open the cache for this password and iteration count */
	  cp = cache[password] = cache[password] || {};
	  c = cp[iter] = cp[iter] || { firstSalt: (obj.salt && obj.salt.length) ?
	                     obj.salt.slice(0) : sjcl.random.randomWords(2,0) };

	  salt = (obj.salt === undefined) ? c.firstSalt : obj.salt;

	  c[salt] = c[salt] || sjcl.misc.pbkdf2(password, salt, obj.iter);
	  return { key: c[salt].slice(0), salt:salt.slice(0) };
	};
	/**
	 * @constructor
	 * Constructs a new bignum from another bignum, a number or a hex string.
	 */
	sjcl.bn = function(it) {
	  this.initWith(it);
	};

	sjcl.bn.prototype = {
	  radix: 24,
	  maxMul: 8,
	  _class: sjcl.bn,

	  copy: function() {
	    return new this._class(this);
	  },

	  /**
	   * Initializes this with it, either as a bn, a number, or a hex string.
	   */
	  initWith: function(it) {
	    var i=0, k;
	    switch(typeof it) {
	    case "object":
	      this.limbs = it.limbs.slice(0);
	      break;

	    case "number":
	      this.limbs = [it];
	      this.normalize();
	      break;

	    case "string":
	      it = it.replace(/^0x/, '');
	      this.limbs = [];
	      // hack
	      k = this.radix / 4;
	      for (i=0; i < it.length; i+=k) {
	        this.limbs.push(parseInt(it.substring(Math.max(it.length - i - k, 0), it.length - i),16));
	      }
	      break;

	    default:
	      this.limbs = [0];
	    }
	    return this;
	  },

	  /**
	   * Returns true if "this" and "that" are equal.  Calls fullReduce().
	   * Equality test is in constant time.
	   */
	  equals: function(that) {
	    if (typeof that === "number") { that = new this._class(that); }
	    var difference = 0, i;
	    this.fullReduce();
	    that.fullReduce();
	    for (i = 0; i < this.limbs.length || i < that.limbs.length; i++) {
	      difference |= this.getLimb(i) ^ that.getLimb(i);
	    }
	    return (difference === 0);
	  },

	  /**
	   * Get the i'th limb of this, zero if i is too large.
	   */
	  getLimb: function(i) {
	    return (i >= this.limbs.length) ? 0 : this.limbs[i];
	  },

	  /**
	   * Constant time comparison function.
	   * Returns 1 if this >= that, or zero otherwise.
	   */
	  greaterEquals: function(that) {
	    if (typeof that === "number") { that = new this._class(that); }
	    var less = 0, greater = 0, i, a, b;
	    i = Math.max(this.limbs.length, that.limbs.length) - 1;
	    for (; i>= 0; i--) {
	      a = this.getLimb(i);
	      b = that.getLimb(i);
	      greater |= (b - a) & ~less;
	      less |= (a - b) & ~greater;
	    }
	    return (greater | ~less) >>> 31;
	  },

	  /**
	   * Convert to a hex string.
	   */
	  toString: function() {
	    this.fullReduce();
	    var out="", i, s, l = this.limbs;
	    for (i=0; i < this.limbs.length; i++) {
	      s = l[i].toString(16);
	      while (i < this.limbs.length - 1 && s.length < 6) {
	        s = "0" + s;
	      }
	      out = s + out;
	    }
	    return "0x"+out;
	  },

	  /** this += that.  Does not normalize. */
	  addM: function(that) {
	    if (typeof(that) !== "object") { that = new this._class(that); }
	    var i, l=this.limbs, ll=that.limbs;
	    for (i=l.length; i<ll.length; i++) {
	      l[i] = 0;
	    }
	    for (i=0; i<ll.length; i++) {
	      l[i] += ll[i];
	    }
	    return this;
	  },

	  /** this *= 2.  Requires normalized; ends up normalized. */
	  doubleM: function() {
	    var i, carry=0, tmp, r=this.radix, m=this.radixMask, l=this.limbs;
	    for (i=0; i<l.length; i++) {
	      tmp = l[i];
	      tmp = tmp+tmp+carry;
	      l[i] = tmp & m;
	      carry = tmp >> r;
	    }
	    if (carry) {
	      l.push(carry);
	    }
	    return this;
	  },

	  /** this /= 2, rounded down.  Requires normalized; ends up normalized. */
	  halveM: function() {
	    var i, carry=0, tmp, r=this.radix, l=this.limbs;
	    for (i=l.length-1; i>=0; i--) {
	      tmp = l[i];
	      l[i] = (tmp+carry)>>1;
	      carry = (tmp&1) << r;
	    }
	    if (!l[l.length-1]) {
	      l.pop();
	    }
	    return this;
	  },

	  /** this -= that.  Does not normalize. */
	  subM: function(that) {
	    if (typeof(that) !== "object") { that = new this._class(that); }
	    var i, l=this.limbs, ll=that.limbs;
	    for (i=l.length; i<ll.length; i++) {
	      l[i] = 0;
	    }
	    for (i=0; i<ll.length; i++) {
	      l[i] -= ll[i];
	    }
	    return this;
	  },

	  mod: function(that) {
	    var neg = !this.greaterEquals(new sjcl.bn(0));

	    that = new sjcl.bn(that).normalize(); // copy before we begin
	    var out = new sjcl.bn(this).normalize(), ci=0;

	    if (neg) out = (new sjcl.bn(0)).subM(out).normalize();

	    for (; out.greaterEquals(that); ci++) {
	      that.doubleM();
	    }

	    if (neg) out = that.sub(out).normalize();

	    for (; ci > 0; ci--) {
	      that.halveM();
	      if (out.greaterEquals(that)) {
	        out.subM(that).normalize();
	      }
	    }
	    return out.trim();
	  },

	  /** return inverse mod prime p.  p must be odd. Binary extended Euclidean algorithm mod p. */
	  inverseMod: function(p) {
	    var a = new sjcl.bn(1), b = new sjcl.bn(0), x = new sjcl.bn(this), y = new sjcl.bn(p), tmp, i, nz=1;

	    if (!(p.limbs[0] & 1)) {
	      throw (new sjcl.exception.invalid("inverseMod: p must be odd"));
	    }

	    // invariant: y is odd
	    do {
	      if (x.limbs[0] & 1) {
	        if (!x.greaterEquals(y)) {
	          // x < y; swap everything
	          tmp = x; x = y; y = tmp;
	          tmp = a; a = b; b = tmp;
	        }
	        x.subM(y);
	        x.normalize();

	        if (!a.greaterEquals(b)) {
	          a.addM(p);
	        }
	        a.subM(b);
	      }

	      // cut everything in half
	      x.halveM();
	      if (a.limbs[0] & 1) {
	        a.addM(p);
	      }
	      a.normalize();
	      a.halveM();

	      // check for termination: x ?= 0
	      for (i=nz=0; i<x.limbs.length; i++) {
	        nz |= x.limbs[i];
	      }
	    } while(nz);

	    if (!y.equals(1)) {
	      throw (new sjcl.exception.invalid("inverseMod: p and x must be relatively prime"));
	    }

	    return b;
	  },

	  /** this + that.  Does not normalize. */
	  add: function(that) {
	    return this.copy().addM(that);
	  },

	  /** this - that.  Does not normalize. */
	  sub: function(that) {
	    return this.copy().subM(that);
	  },

	  /** this * that.  Normalizes and reduces. */
	  mul: function(that) {
	    if (typeof(that) === "number") { that = new this._class(that); }
	    var i, j, a = this.limbs, b = that.limbs, al = a.length, bl = b.length, out = new this._class(), c = out.limbs, ai, ii=this.maxMul;

	    for (i=0; i < this.limbs.length + that.limbs.length + 1; i++) {
	      c[i] = 0;
	    }
	    for (i=0; i<al; i++) {
	      ai = a[i];
	      for (j=0; j<bl; j++) {
	        c[i+j] += ai * b[j];
	      }

	      if (!--ii) {
	        ii = this.maxMul;
	        out.cnormalize();
	      }
	    }
	    return out.cnormalize().reduce();
	  },

	  /** this ^ 2.  Normalizes and reduces. */
	  square: function() {
	    return this.mul(this);
	  },

	  /** this ^ n.  Uses square-and-multiply.  Normalizes and reduces. */
	  power: function(l) {
	    l = new sjcl.bn(l).normalize().trim().limbs;
	    var i, j, out = new this._class(1), pow = this;

	    for (i=0; i<l.length; i++) {
	      for (j=0; j<this.radix; j++) {
	        if (l[i] & (1<<j)) { out = out.mul(pow); }
	        if (i == (l.length - 1) && l[i]>>(j + 1) == 0) { break; }

	        pow = pow.square();
	      }
	    }

	    return out;
	  },

	  /** this * that mod N */
	  mulmod: function(that, N) {
	    return this.mod(N).mul(that.mod(N)).mod(N);
	  },

	  /** this ^ x mod N */
	  powermod: function(x, N) {
	    x = new sjcl.bn(x);
	    N = new sjcl.bn(N);

	    // Jump to montpowermod if possible.
	    if ((N.limbs[0] & 1) == 1) {
	      var montOut = this.montpowermod(x, N);

	      if (montOut != false) { return montOut; } // else go to slow powermod
	    }

	    var i, j, l = x.normalize().trim().limbs, out = new this._class(1), pow = this;

	    for (i=0; i<l.length; i++) {
	      for (j=0; j<this.radix; j++) {
	        if (l[i] & (1<<j)) { out = out.mulmod(pow, N); }
	        if (i == (l.length - 1) && l[i]>>(j + 1) == 0) { break; }

	        pow = pow.mulmod(pow, N);
	      }
	    }

	    return out;
	  },

	  /** this ^ x mod N with Montomery reduction */
	  montpowermod: function(x, N) {
	    x = new sjcl.bn(x).normalize().trim();
	    N = new sjcl.bn(N);

	    var i, j,
	      radix = this.radix,
	      out = new this._class(1),
	      pow = this.copy();

	    // Generate R as a cap of N.
	    var R, s, wind, bitsize = x.bitLength();

	    R = new sjcl.bn({
	      limbs: N.copy().normalize().trim().limbs.map(function() { return 0; })
	    });

	    for (s = this.radix; s > 0; s--) {
	      if (((N.limbs[N.limbs.length - 1] >> s) & 1) == 1) {
	        R.limbs[R.limbs.length - 1] = 1 << s;
	        break;
	      }
	    }

	    // Calculate window size as a function of the exponent's size.
	    if (bitsize == 0) {
	      return this;
	    } else if (bitsize < 18)  {
	      wind = 1;
	    } else if (bitsize < 48)  {
	      wind = 3;
	    } else if (bitsize < 144) {
	      wind = 4;
	    } else if (bitsize < 768) {
	      wind = 5;
	    } else {
	      wind = 6;
	    }

	    // Find R' and N' such that R * R' - N * N' = 1.
	    var RR = R.copy(), NN = N.copy(), RP = new sjcl.bn(1), NP = new sjcl.bn(0), RT = R.copy();

	    while (RT.greaterEquals(1)) {
	      RT.halveM();

	      if ((RP.limbs[0] & 1) == 0) {
	        RP.halveM();
	        NP.halveM();
	      } else {
	        RP.addM(NN);
	        RP.halveM();

	        NP.halveM();
	        NP.addM(RR);
	      }
	    }

	    RP = RP.normalize();
	    NP = NP.normalize();

	    RR.doubleM()
	    var R2 = RR.mulmod(RR, N);

	    // Check whether the invariant holds.
	    // If it doesn't, we can't use Montgomery reduction on this modulus.
	    if (!RR.mul(RP).sub(N.mul(NP)).equals(1)) {
	      return false;
	    }

	    var montIn = function(c) { return montMul(c, R2) },
	    montMul = function(a, b) {
	      // Standard Montgomery reduction
	      var k, carry, ab, right, abBar, mask = (1 << (s + 1)) - 1;

	      ab = a.mul(b);

	      right = ab.mul(NP);
	      right.limbs = right.limbs.slice(0, R.limbs.length);

	      if (right.limbs.length == R.limbs.length) {
	        right.limbs[R.limbs.length - 1] &= mask;
	      }

	      right = right.mul(N);

	      abBar = ab.add(right).normalize().trim();
	      abBar.limbs = abBar.limbs.slice(R.limbs.length - 1);

	      // Division.  Equivelent to calling *.halveM() s times.
	      for (k=0; k < abBar.limbs.length; k++) {
	        if (k > 0) {
	          abBar.limbs[k - 1] |= (abBar.limbs[k] & mask) << (radix - s - 1)
	        }

	        abBar.limbs[k] = abBar.limbs[k] >> (s + 1)
	      }

	      if (abBar.greaterEquals(N)) {
	        abBar.subM(N)
	      }

	      return abBar;
	    },
	    montOut = function(c) { return montMul(c, 1); };

	    pow = montIn(pow);
	    out = montIn(out);

	    // Sliding-Window Exponentiation (HAC 14.85)
	    var h, precomp = {}, cap = (1 << (wind - 1)) - 1;

	    precomp[1] = pow.copy();
	    precomp[2] = montMul(pow, pow);

	    for (h=1; h<=cap; h++) {
	      precomp[(2 * h) + 1] = montMul(precomp[(2 * h) - 1], precomp[2]);
	    }

	    var getBit = function(exp, i) { // Gets ith bit of exp.
	      var off = i % exp.radix;

	      return (exp.limbs[Math.floor(i / exp.radix)] & (1 << off)) >> off;
	    }

	    for (i = x.bitLength() - 1; i >= 0; ) {
	      if (getBit(x, i) == 0) {
	        // If the next bit is zero:
	        //   Square, move forward one bit.
	        out = montMul(out, out)
	        i = i - 1;
	      } else {
	        // If the next bit is one:
	        //   Find the longest sequence of bits after this one, less than `wind`
	        //   bits long, that ends with a 1.  Convert the sequence into an
	        //   integer and look up the pre-computed value to add.
	        var l = i - wind + 1;

	        while (getBit(x, l) == 0) {
	          l++;
	        }

	        var indx = 0;
	        for (j = l; j <= i; j++) {
	          indx += getBit(x, j) << (j - l)
	          out = montMul(out, out);
	        }

	        out = montMul(out, precomp[indx])

	        i = l - 1;
	      }
	    }

	    return montOut(out);
	  },

	  trim: function() {
	    var l = this.limbs, p;
	    do {
	      p = l.pop();
	    } while (l.length && p === 0);
	    l.push(p);
	    return this;
	  },

	  /** Reduce mod a modulus.  Stubbed for subclassing. */
	  reduce: function() {
	    return this;
	  },

	  /** Reduce and normalize. */
	  fullReduce: function() {
	    return this.normalize();
	  },

	  /** Propagate carries. */
	  normalize: function() {
	    var carry=0, i, pv = this.placeVal, ipv = this.ipv, l, m, limbs = this.limbs, ll = limbs.length, mask = this.radixMask;
	    for (i=0; i < ll || (carry !== 0 && carry !== -1); i++) {
	      l = (limbs[i]||0) + carry;
	      m = limbs[i] = l & mask;
	      carry = (l-m)*ipv;
	    }
	    if (carry === -1) {
	      limbs[i-1] -= pv;
	    }
	    return this;
	  },

	  /** Constant-time normalize. Does not allocate additional space. */
	  cnormalize: function() {
	    var carry=0, i, ipv = this.ipv, l, m, limbs = this.limbs, ll = limbs.length, mask = this.radixMask;
	    for (i=0; i < ll-1; i++) {
	      l = limbs[i] + carry;
	      m = limbs[i] = l & mask;
	      carry = (l-m)*ipv;
	    }
	    limbs[i] += carry;
	    return this;
	  },

	  /** Serialize to a bit array */
	  toBits: function(len) {
	    this.fullReduce();
	    len = len || this.exponent || this.bitLength();
	    var i = Math.floor((len-1)/24), w=sjcl.bitArray, e = (len + 7 & -8) % this.radix || this.radix,
	        out = [w.partial(e, this.getLimb(i))];
	    for (i--; i >= 0; i--) {
	      out = w.concat(out, [w.partial(Math.min(this.radix,len), this.getLimb(i))]);
	      len -= this.radix;
	    }
	    return out;
	  },

	  /** Return the length in bits, rounded up to the nearest byte. */
	  bitLength: function() {
	    this.fullReduce();
	    var out = this.radix * (this.limbs.length - 1),
	        b = this.limbs[this.limbs.length - 1];
	    for (; b; b >>>= 1) {
	      out ++;
	    }
	    return out+7 & -8;
	  }
	};

	/** @memberOf sjcl.bn
	* @this { sjcl.bn }
	*/
	sjcl.bn.fromBits = function(bits) {
	  var Class = this, out = new Class(), words=[], w=sjcl.bitArray, t = this.prototype,
	      l = Math.min(this.bitLength || 0x100000000, w.bitLength(bits)), e = l % t.radix || t.radix;

	  words[0] = w.extract(bits, 0, e);
	  for (; e < l; e += t.radix) {
	    words.unshift(w.extract(bits, e, t.radix));
	  }

	  out.limbs = words;
	  return out;
	};



	sjcl.bn.prototype.ipv = 1 / (sjcl.bn.prototype.placeVal = Math.pow(2,sjcl.bn.prototype.radix));
	sjcl.bn.prototype.radixMask = (1 << sjcl.bn.prototype.radix) - 1;

	/**
	 * Creates a new subclass of bn, based on reduction modulo a pseudo-Mersenne prime,
	 * i.e. a prime of the form 2^e + sum(a * 2^b),where the sum is negative and sparse.
	 */
	sjcl.bn.pseudoMersennePrime = function(exponent, coeff) {
	  /** @constructor
	  * @private
	  */
	  function p(it) {
	    this.initWith(it);
	    /*if (this.limbs[this.modOffset]) {
	      this.reduce();
	    }*/
	  }

	  var ppr = p.prototype = new sjcl.bn(), i, tmp, mo;
	  mo = ppr.modOffset = Math.ceil(tmp = exponent / ppr.radix);
	  ppr.exponent = exponent;
	  ppr.offset = [];
	  ppr.factor = [];
	  ppr.minOffset = mo;
	  ppr.fullMask = 0;
	  ppr.fullOffset = [];
	  ppr.fullFactor = [];
	  ppr.modulus = p.modulus = new sjcl.bn(Math.pow(2,exponent));

	  ppr.fullMask = 0|-Math.pow(2, exponent % ppr.radix);

	  for (i=0; i<coeff.length; i++) {
	    ppr.offset[i] = Math.floor(coeff[i][0] / ppr.radix - tmp);
	    ppr.fullOffset[i] = Math.ceil(coeff[i][0] / ppr.radix - tmp);
	    ppr.factor[i] = coeff[i][1] * Math.pow(1/2, exponent - coeff[i][0] + ppr.offset[i] * ppr.radix);
	    ppr.fullFactor[i] = coeff[i][1] * Math.pow(1/2, exponent - coeff[i][0] + ppr.fullOffset[i] * ppr.radix);
	    ppr.modulus.addM(new sjcl.bn(Math.pow(2,coeff[i][0])*coeff[i][1]));
	    ppr.minOffset = Math.min(ppr.minOffset, -ppr.offset[i]); // conservative
	  }
	  ppr._class = p;
	  ppr.modulus.cnormalize();

	  /** Approximate reduction mod p.  May leave a number which is negative or slightly larger than p.
	   * @memberof sjcl.bn
	   * @this { sjcl.bn }
	   */
	  ppr.reduce = function() {
	    var i, k, l, mo = this.modOffset, limbs = this.limbs, off = this.offset, ol = this.offset.length, fac = this.factor, ll;

	    i = this.minOffset;
	    while (limbs.length > mo) {
	      l = limbs.pop();
	      ll = limbs.length;
	      for (k=0; k<ol; k++) {
	        limbs[ll+off[k]] -= fac[k] * l;
	      }

	      i--;
	      if (!i) {
	        limbs.push(0);
	        this.cnormalize();
	        i = this.minOffset;
	      }
	    }
	    this.cnormalize();

	    return this;
	  };

	  /** @memberof sjcl.bn
	  * @this { sjcl.bn }
	  */
	  ppr._strongReduce = (ppr.fullMask === -1) ? ppr.reduce : function() {
	    var limbs = this.limbs, i = limbs.length - 1, k, l;
	    this.reduce();
	    if (i === this.modOffset - 1) {
	      l = limbs[i] & this.fullMask;
	      limbs[i] -= l;
	      for (k=0; k<this.fullOffset.length; k++) {
	        limbs[i+this.fullOffset[k]] -= this.fullFactor[k] * l;
	      }
	      this.normalize();
	    }
	  };

	  /** mostly constant-time, very expensive full reduction.
	   * @memberof sjcl.bn
	   * @this { sjcl.bn }
	   */
	  ppr.fullReduce = function() {
	    var greater, i;
	    // massively above the modulus, may be negative

	    this._strongReduce();
	    // less than twice the modulus, may be negative

	    this.addM(this.modulus);
	    this.addM(this.modulus);
	    this.normalize();
	    // probably 2-3x the modulus

	    this._strongReduce();
	    // less than the power of 2.  still may be more than
	    // the modulus

	    // HACK: pad out to this length
	    for (i=this.limbs.length; i<this.modOffset; i++) {
	      this.limbs[i] = 0;
	    }

	    // constant-time subtract modulus
	    greater = this.greaterEquals(this.modulus);
	    for (i=0; i<this.limbs.length; i++) {
	      this.limbs[i] -= this.modulus.limbs[i] * greater;
	    }
	    this.cnormalize();

	    return this;
	  };


	  /** @memberof sjcl.bn
	  * @this { sjcl.bn }
	  */
	  ppr.inverse = function() {
	    return (this.power(this.modulus.sub(2)));
	  };

	  p.fromBits = sjcl.bn.fromBits;

	  return p;
	};

	// a small Mersenne prime
	var sbp = sjcl.bn.pseudoMersennePrime;
	sjcl.bn.prime = {
	  p127: sbp(127, [[0,-1]]),

	  // Bernstein's prime for Curve25519
	  p25519: sbp(255, [[0,-19]]),

	  // Koblitz primes
	  p192k: sbp(192, [[32,-1],[12,-1],[8,-1],[7,-1],[6,-1],[3,-1],[0,-1]]),
	  p224k: sbp(224, [[32,-1],[12,-1],[11,-1],[9,-1],[7,-1],[4,-1],[1,-1],[0,-1]]),
	  p256k: sbp(256, [[32,-1],[9,-1],[8,-1],[7,-1],[6,-1],[4,-1],[0,-1]]),

	  // NIST primes
	  p192: sbp(192, [[0,-1],[64,-1]]),
	  p224: sbp(224, [[0,1],[96,-1]]),
	  p256: sbp(256, [[0,-1],[96,1],[192,1],[224,-1]]),
	  p384: sbp(384, [[0,-1],[32,1],[96,-1],[128,-1]]),
	  p521: sbp(521, [[0,-1]])
	};

	sjcl.bn.random = function(modulus, paranoia) {
	  if (typeof modulus !== "object") { modulus = new sjcl.bn(modulus); }
	  var words, i, l = modulus.limbs.length, m = modulus.limbs[l-1]+1, out = new sjcl.bn();
	  while (true) {
	    // get a sequence whose first digits make sense
	    do {
	      words = sjcl.random.randomWords(l, paranoia);
	      if (words[l-1] < 0) { words[l-1] += 0x100000000; }
	    } while (Math.floor(words[l-1] / m) === Math.floor(0x100000000 / m));
	    words[l-1] %= m;

	    // mask off all the limbs
	    for (i=0; i<l-1; i++) {
	      words[i] &= modulus.radixMask;
	    }

	    // check the rest of the digitssj
	    out.limbs = words;
	    if (!out.greaterEquals(modulus)) {
	      return out;
	    }
	  }
	};
	/**
	 * base class for all ecc operations.
	 */
	sjcl.ecc = {};

	/**
	 * Represents a point on a curve in affine coordinates.
	 * @constructor
	 * @param {sjcl.ecc.curve} curve The curve that this point lies on.
	 * @param {bigInt} x The x coordinate.
	 * @param {bigInt} y The y coordinate.
	 */
	sjcl.ecc.point = function(curve,x,y) {
	  if (x === undefined) {
	    this.isIdentity = true;
	  } else {
	    if (x instanceof sjcl.bn) {
	      x = new curve.field(x);
	    }
	    if (y instanceof sjcl.bn) {
	      y = new curve.field(y);
	    }

	    this.x = x;
	    this.y = y;

	    this.isIdentity = false;
	  }
	  this.curve = curve;
	};



	sjcl.ecc.point.prototype = {
	  toJac: function() {
	    return new sjcl.ecc.pointJac(this.curve, this.x, this.y, new this.curve.field(1));
	  },

	  mult: function(k) {
	    return this.toJac().mult(k, this).toAffine();
	  },

	  /**
	   * Multiply this point by k, added to affine2*k2, and return the answer in Jacobian coordinates.
	   * @param {bigInt} k The coefficient to multiply this by.
	   * @param {bigInt} k2 The coefficient to multiply affine2 this by.
	   * @param {sjcl.ecc.point} affine The other point in affine coordinates.
	   * @return {sjcl.ecc.pointJac} The result of the multiplication and addition, in Jacobian coordinates.
	   */
	  mult2: function(k, k2, affine2) {
	    return this.toJac().mult2(k, this, k2, affine2).toAffine();
	  },

	  multiples: function() {
	    var m, i, j;
	    if (this._multiples === undefined) {
	      j = this.toJac().doubl();
	      m = this._multiples = [new sjcl.ecc.point(this.curve), this, j.toAffine()];
	      for (i=3; i<16; i++) {
	        j = j.add(this);
	        m.push(j.toAffine());
	      }
	    }
	    return this._multiples;
	  },

	  negate: function() {
	    var newY = new this.curve.field(0).sub(this.y).normalize().reduce();
	    return new sjcl.ecc.point(this.curve, this.x, newY);
	  },

	  isValid: function() {
	    return this.y.square().equals(this.curve.b.add(this.x.mul(this.curve.a.add(this.x.square()))));
	  },

	  toBits: function() {
	    return sjcl.bitArray.concat(this.x.toBits(), this.y.toBits());
	  }
	};

	/**
	 * Represents a point on a curve in Jacobian coordinates. Coordinates can be specified as bigInts or strings (which
	 * will be converted to bigInts).
	 *
	 * @constructor
	 * @param {bigInt/string} x The x coordinate.
	 * @param {bigInt/string} y The y coordinate.
	 * @param {bigInt/string} z The z coordinate.
	 * @param {sjcl.ecc.curve} curve The curve that this point lies on.
	 */
	sjcl.ecc.pointJac = function(curve, x, y, z) {
	  if (x === undefined) {
	    this.isIdentity = true;
	  } else {
	    this.x = x;
	    this.y = y;
	    this.z = z;
	    this.isIdentity = false;
	  }
	  this.curve = curve;
	};

	sjcl.ecc.pointJac.prototype = {
	  /**
	   * Adds S and T and returns the result in Jacobian coordinates. Note that S must be in Jacobian coordinates and T must be in affine coordinates.
	   * @param {sjcl.ecc.pointJac} S One of the points to add, in Jacobian coordinates.
	   * @param {sjcl.ecc.point} T The other point to add, in affine coordinates.
	   * @return {sjcl.ecc.pointJac} The sum of the two points, in Jacobian coordinates.
	   */
	  add: function(T) {
	    var S = this, sz2, c, d, c2, x1, x2, x, y1, y2, y, z;
	    if (S.curve !== T.curve) {
	      throw("sjcl.ecc.add(): Points must be on the same curve to add them!");
	    }

	    if (S.isIdentity) {
	      return T.toJac();
	    } else if (T.isIdentity) {
	      return S;
	    }

	    sz2 = S.z.square();
	    c = T.x.mul(sz2).subM(S.x);

	    if (c.equals(0)) {
	      if (S.y.equals(T.y.mul(sz2.mul(S.z)))) {
	        // same point
	        return S.doubl();
	      } else {
	        // inverses
	        return new sjcl.ecc.pointJac(S.curve);
	      }
	    }

	    d = T.y.mul(sz2.mul(S.z)).subM(S.y);
	    c2 = c.square();

	    x1 = d.square();
	    x2 = c.square().mul(c).addM( S.x.add(S.x).mul(c2) );
	    x  = x1.subM(x2);

	    y1 = S.x.mul(c2).subM(x).mul(d);
	    y2 = S.y.mul(c.square().mul(c));
	    y  = y1.subM(y2);

	    z  = S.z.mul(c);

	    return new sjcl.ecc.pointJac(this.curve,x,y,z);
	  },

	  /**
	   * doubles this point.
	   * @return {sjcl.ecc.pointJac} The doubled point.
	   */
	  doubl: function() {
	    if (this.isIdentity) { return this; }

	    var
	      y2 = this.y.square(),
	      a  = y2.mul(this.x.mul(4)),
	      b  = y2.square().mul(8),
	      z2 = this.z.square(),
	      c  = this.curve.a.toString() == (new sjcl.bn(-3)).toString() ?
	                this.x.sub(z2).mul(3).mul(this.x.add(z2)) :
	                this.x.square().mul(3).add(z2.square().mul(this.curve.a)),
	      x  = c.square().subM(a).subM(a),
	      y  = a.sub(x).mul(c).subM(b),
	      z  = this.y.add(this.y).mul(this.z);
	    return new sjcl.ecc.pointJac(this.curve, x, y, z);
	  },

	  /**
	   * Returns a copy of this point converted to affine coordinates.
	   * @return {sjcl.ecc.point} The converted point.
	   */
	  toAffine: function() {
	    if (this.isIdentity || this.z.equals(0)) {
	      return new sjcl.ecc.point(this.curve);
	    }
	    var zi = this.z.inverse(), zi2 = zi.square();
	    return new sjcl.ecc.point(this.curve, this.x.mul(zi2).fullReduce(), this.y.mul(zi2.mul(zi)).fullReduce());
	  },

	  /**
	   * Multiply this point by k and return the answer in Jacobian coordinates.
	   * @param {bigInt} k The coefficient to multiply by.
	   * @param {sjcl.ecc.point} affine This point in affine coordinates.
	   * @return {sjcl.ecc.pointJac} The result of the multiplication, in Jacobian coordinates.
	   */
	  mult: function(k, affine) {
	    if (typeof(k) === "number") {
	      k = [k];
	    } else if (k.limbs !== undefined) {
	      k = k.normalize().limbs;
	    }

	    var i, j, out = new sjcl.ecc.point(this.curve).toJac(), multiples = affine.multiples();

	    for (i=k.length-1; i>=0; i--) {
	      for (j=sjcl.bn.prototype.radix-4; j>=0; j-=4) {
	        out = out.doubl().doubl().doubl().doubl().add(multiples[k[i]>>j & 0xF]);
	      }
	    }

	    return out;
	  },

	  /**
	   * Multiply this point by k, added to affine2*k2, and return the answer in Jacobian coordinates.
	   * @param {bigInt} k The coefficient to multiply this by.
	   * @param {sjcl.ecc.point} affine This point in affine coordinates.
	   * @param {bigInt} k2 The coefficient to multiply affine2 this by.
	   * @param {sjcl.ecc.point} affine The other point in affine coordinates.
	   * @return {sjcl.ecc.pointJac} The result of the multiplication and addition, in Jacobian coordinates.
	   */
	  mult2: function(k1, affine, k2, affine2) {
	    if (typeof(k1) === "number") {
	      k1 = [k1];
	    } else if (k1.limbs !== undefined) {
	      k1 = k1.normalize().limbs;
	    }

	    if (typeof(k2) === "number") {
	      k2 = [k2];
	    } else if (k2.limbs !== undefined) {
	      k2 = k2.normalize().limbs;
	    }

	    var i, j, out = new sjcl.ecc.point(this.curve).toJac(), m1 = affine.multiples(),
	        m2 = affine2.multiples(), l1, l2;

	    for (i=Math.max(k1.length,k2.length)-1; i>=0; i--) {
	      l1 = k1[i] | 0;
	      l2 = k2[i] | 0;
	      for (j=sjcl.bn.prototype.radix-4; j>=0; j-=4) {
	        out = out.doubl().doubl().doubl().doubl().add(m1[l1>>j & 0xF]).add(m2[l2>>j & 0xF]);
	      }
	    }

	    return out;
	  },

	  negate: function() {
	    return this.toAffine().negate().toJac();
	  },

	  isValid: function() {
	    var z2 = this.z.square(), z4 = z2.square(), z6 = z4.mul(z2);
	    return this.y.square().equals(
	             this.curve.b.mul(z6).add(this.x.mul(
	               this.curve.a.mul(z4).add(this.x.square()))));
	  }
	};

	/**
	 * Construct an elliptic curve. Most users will not use this and instead start with one of the NIST curves defined below.
	 *
	 * @constructor
	 * @param {bigInt} p The prime modulus.
	 * @param {bigInt} r The prime order of the curve.
	 * @param {bigInt} a The constant a in the equation of the curve y^2 = x^3 + ax + b (for NIST curves, a is always -3).
	 * @param {bigInt} x The x coordinate of a base point of the curve.
	 * @param {bigInt} y The y coordinate of a base point of the curve.
	 */
	sjcl.ecc.curve = function(Field, r, a, b, x, y) {
	  this.field = Field;
	  this.r = new sjcl.bn(r);
	  this.a = new Field(a);
	  this.b = new Field(b);
	  this.G = new sjcl.ecc.point(this, new Field(x), new Field(y));
	};

	sjcl.ecc.curve.prototype.fromBits = function (bits) {
	  var w = sjcl.bitArray, l = this.field.prototype.exponent + 7 & -8,
	      p = new sjcl.ecc.point(this, this.field.fromBits(w.bitSlice(bits, 0, l)),
	                             this.field.fromBits(w.bitSlice(bits, l, 2*l)));
	  if (!p.isValid()) {
	    throw new sjcl.exception.corrupt("not on the curve!");
	  }
	  return p;
	};

	sjcl.ecc.curves = {
	  c192: new sjcl.ecc.curve(
	    sjcl.bn.prime.p192,
	    "0xffffffffffffffffffffffff99def836146bc9b1b4d22831",
	    -3,
	    "0x64210519e59c80e70fa7e9ab72243049feb8deecc146b9b1",
	    "0x188da80eb03090f67cbf20eb43a18800f4ff0afd82ff1012",
	    "0x07192b95ffc8da78631011ed6b24cdd573f977a11e794811"),

	  c224: new sjcl.ecc.curve(
	    sjcl.bn.prime.p224,
	    "0xffffffffffffffffffffffffffff16a2e0b8f03e13dd29455c5c2a3d",
	    -3,
	    "0xb4050a850c04b3abf54132565044b0b7d7bfd8ba270b39432355ffb4",
	    "0xb70e0cbd6bb4bf7f321390b94a03c1d356c21122343280d6115c1d21",
	    "0xbd376388b5f723fb4c22dfe6cd4375a05a07476444d5819985007e34"),

	  c256: new sjcl.ecc.curve(
	    sjcl.bn.prime.p256,
	    "0xffffffff00000000ffffffffffffffffbce6faada7179e84f3b9cac2fc632551",
	    -3,
	    "0x5ac635d8aa3a93e7b3ebbd55769886bc651d06b0cc53b0f63bce3c3e27d2604b",
	    "0x6b17d1f2e12c4247f8bce6e563a440f277037d812deb33a0f4a13945d898c296",
	    "0x4fe342e2fe1a7f9b8ee7eb4a7c0f9e162bce33576b315ececbb6406837bf51f5"),

	  c384: new sjcl.ecc.curve(
	    sjcl.bn.prime.p384,
	    "0xffffffffffffffffffffffffffffffffffffffffffffffffc7634d81f4372ddf581a0db248b0a77aecec196accc52973",
	    -3,
	    "0xb3312fa7e23ee7e4988e056be3f82d19181d9c6efe8141120314088f5013875ac656398d8a2ed19d2a85c8edd3ec2aef",
	    "0xaa87ca22be8b05378eb1c71ef320ad746e1d3b628ba79b9859f741e082542a385502f25dbf55296c3a545e3872760ab7",
	    "0x3617de4a96262c6f5d9e98bf9292dc29f8f41dbd289a147ce9da3113b5f0b8c00a60b1ce1d7e819d7a431d7c90ea0e5f"),
	    
	  c521: new sjcl.ecc.curve(
	    sjcl.bn.prime.p521,
	    "0x1FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA51868783BF2F966B7FCC0148F709A5D03BB5C9B8899C47AEBB6FB71E91386409",
	    -3,
	    "0x051953EB9618E1C9A1F929A21A0B68540EEA2DA725B99B315F3B8B489918EF109E156193951EC7E937B1652C0BD3BB1BF073573DF883D2C34F1EF451FD46B503F00",
	    "0xC6858E06B70404E9CD9E3ECB662395B4429C648139053FB521F828AF606B4D3DBAA14B5E77EFE75928FE1DC127A2FFA8DE3348B3C1856A429BF97E7E31C2E5BD66",
	    "0x11839296A789A3BC0045C8A5FB42C7D1BD998F54449579B446817AFBD17273E662C97EE72995EF42640C550B9013FAD0761353C7086A272C24088BE94769FD16650"),

	  k192: new sjcl.ecc.curve(
	    sjcl.bn.prime.p192k,
	    "0xfffffffffffffffffffffffe26f2fc170f69466a74defd8d",
	    0,
	    3,
	    "0xdb4ff10ec057e9ae26b07d0280b7f4341da5d1b1eae06c7d",
	    "0x9b2f2f6d9c5628a7844163d015be86344082aa88d95e2f9d"),

	  k224: new sjcl.ecc.curve(
	    sjcl.bn.prime.p224k,
	    "0x010000000000000000000000000001dce8d2ec6184caf0a971769fb1f7",
	    0,
	    5,
	    "0xa1455b334df099df30fc28a169a467e9e47075a90f7e650eb6b7a45c",
	    "0x7e089fed7fba344282cafbd6f7e319f7c0b0bd59e2ca4bdb556d61a5"),

	  k256: new sjcl.ecc.curve(
	    sjcl.bn.prime.p256k,
	    "0xfffffffffffffffffffffffffffffffebaaedce6af48a03bbfd25e8cd0364141",
	    0,
	    7,
	    "0x79be667ef9dcbbac55a06295ce870b07029bfcdb2dce28d959f2815b16f81798",
	    "0x483ada7726a3c4655da4fbfc0e1108a8fd17b448a68554199c47d08ffb10d4b8")

	};

	/** our basicKey classes
	*/
	sjcl.ecc.basicKey = {
	  /** ecc publicKey.
	  * @constructor
	  * @param {curve} curve the elliptic curve
	  * @param {point} point the point on the curve
	  */
	  publicKey: function(curve, point) {
	    this._curve = curve;
	    this._curveBitLength = curve.r.bitLength();
	    if (point instanceof Array) {
	      this._point = curve.fromBits(point);
	    } else {
	      this._point = point;
	    }

	    /** get this keys point data
	    * @return x and y as bitArrays
	    */
	    this.get = function() {
	      var pointbits = this._point.toBits();
	      var len = sjcl.bitArray.bitLength(pointbits);
	      var x = sjcl.bitArray.bitSlice(pointbits, 0, len/2);
	      var y = sjcl.bitArray.bitSlice(pointbits, len/2);
	      return { x: x, y: y };
	    };
	  },

	  /** ecc secretKey
	  * @constructor
	  * @param {curve} curve the elliptic curve
	  * @param exponent
	  */
	  secretKey: function(curve, exponent) {
	    this._curve = curve;
	    this._curveBitLength = curve.r.bitLength();
	    this._exponent = exponent;

	    /** get this keys exponent data
	    * @return {bitArray} exponent
	    */
	    this.get = function () {
	      return this._exponent.toBits();
	    };
	  }
	};

	/** @private */
	sjcl.ecc.basicKey.generateKeys = function(cn) {
	  return function generateKeys(curve, paranoia, sec) {
	    curve = curve || 256;

	    if (typeof curve === "number") {
	      curve = sjcl.ecc.curves['c'+curve];
	      if (curve === undefined) {
	        throw new sjcl.exception.invalid("no such curve");
	      }
	    }
	    sec = sec || sjcl.bn.random(curve.r, paranoia);

	    var pub = curve.G.mult(sec);
	    return { pub: new sjcl.ecc[cn].publicKey(curve, pub),
	             sec: new sjcl.ecc[cn].secretKey(curve, sec) };
	  };
	};

	/** elGamal keys */
	sjcl.ecc.elGamal = {
	  /** generate keys
	  * @function
	  * @param curve
	  * @param {int} paranoia Paranoia for generation (default 6)
	  * @param {secretKey} sec secret Key to use. used to get the publicKey for ones secretKey
	  */
	  generateKeys: sjcl.ecc.basicKey.generateKeys("elGamal"),
	  /** elGamal publicKey.
	  * @constructor
	  * @augments sjcl.ecc.basicKey.publicKey
	  */
	  publicKey: function (curve, point) {
	    sjcl.ecc.basicKey.publicKey.apply(this, arguments);
	  },
	  /** elGamal secretKey
	  * @constructor
	  * @augments sjcl.ecc.basicKey.secretKey
	  */
	  secretKey: function (curve, exponent) {
	    sjcl.ecc.basicKey.secretKey.apply(this, arguments);
	  }
	};

	sjcl.ecc.elGamal.publicKey.prototype = {
	  /** Kem function of elGamal Public Key
	  * @param paranoia paranoia to use for randomization.
	  * @return {object} key and tag. unkem(tag) with the corresponding secret key results in the key returned.
	  */
	  kem: function(paranoia) {
	    var sec = sjcl.bn.random(this._curve.r, paranoia),
	        tag = this._curve.G.mult(sec).toBits(),
	        key = sjcl.hash.sha256.hash(this._point.mult(sec).toBits());
	    return { key: key, tag: tag };
	  }
	};

	sjcl.ecc.elGamal.secretKey.prototype = {
	  /** UnKem function of elGamal Secret Key
	  * @param {bitArray} tag The Tag to decrypt.
	  * @return {bitArray} decrypted key.
	  */
	  unkem: function(tag) {
	    return sjcl.hash.sha256.hash(this._curve.fromBits(tag).mult(this._exponent).toBits());
	  },

	  /** Diffie-Hellmann function
	  * @param {elGamal.publicKey} pk The Public Key to do Diffie-Hellmann with
	  * @return {bitArray} diffie-hellmann result for this key combination.
	  */
	  dh: function(pk) {
	    return sjcl.hash.sha256.hash(pk._point.mult(this._exponent).toBits());
	  },

	  /** Diffie-Hellmann function, compatible with Java generateSecret
	   * @param {elGamal.publicKey} pk The Public Key to do Diffie-Hellmann with
	   * @return {bitArray} undigested X value, diffie-hellmann result for this key combination,
	   * compatible with Java generateSecret().
	   */
	   dhJavaEc: function(pk) {
	     return pk._point.mult(this._exponent).x.toBits();
	   }
	};

	/** ecdsa keys */
	sjcl.ecc.ecdsa = {
	  /** generate keys
	  * @function
	  * @param curve
	  * @param {int} paranoia Paranoia for generation (default 6)
	  * @param {secretKey} sec secret Key to use. used to get the publicKey for ones secretKey
	  */
	  generateKeys: sjcl.ecc.basicKey.generateKeys("ecdsa")
	};

	/** ecdsa publicKey.
	* @constructor
	* @augments sjcl.ecc.basicKey.publicKey
	*/
	sjcl.ecc.ecdsa.publicKey = function (curve, point) {
	  sjcl.ecc.basicKey.publicKey.apply(this, arguments);
	};

	/** specific functions for ecdsa publicKey. */
	sjcl.ecc.ecdsa.publicKey.prototype = {
	  /** Diffie-Hellmann function
	  * @param {bitArray} hash hash to verify.
	  * @param {bitArray} rs signature bitArray.
	  * @param {boolean}  fakeLegacyVersion use old legacy version
	  */
	  verify: function(hash, rs, fakeLegacyVersion) {
	    if (sjcl.bitArray.bitLength(hash) > this._curveBitLength) {
	      hash = sjcl.bitArray.clamp(hash, this._curveBitLength);
	    }
	    var w = sjcl.bitArray,
	        R = this._curve.r,
	        l = this._curveBitLength,
	        r = sjcl.bn.fromBits(w.bitSlice(rs,0,l)),
	        ss = sjcl.bn.fromBits(w.bitSlice(rs,l,2*l)),
	        s = fakeLegacyVersion ? ss : ss.inverseMod(R),
	        hG = sjcl.bn.fromBits(hash).mul(s).mod(R),
	        hA = r.mul(s).mod(R),
	        r2 = this._curve.G.mult2(hG, hA, this._point).x;
	    if (r.equals(0) || ss.equals(0) || r.greaterEquals(R) || ss.greaterEquals(R) || !r2.equals(r)) {
	      if (fakeLegacyVersion === undefined) {
	        return this.verify(hash, rs, true);
	      } else {
	        throw (new sjcl.exception.corrupt("signature didn't check out"));
	      }
	    }
	    return true;
	  }
	};

	/** ecdsa secretKey
	* @constructor
	* @augments sjcl.ecc.basicKey.publicKey
	*/
	sjcl.ecc.ecdsa.secretKey = function (curve, exponent) {
	  sjcl.ecc.basicKey.secretKey.apply(this, arguments);
	};

	/** specific functions for ecdsa secretKey. */
	sjcl.ecc.ecdsa.secretKey.prototype = {
	  /** Diffie-Hellmann function
	  * @param {bitArray} hash hash to sign.
	  * @param {int} paranoia paranoia for random number generation
	  * @param {boolean} fakeLegacyVersion use old legacy version
	  */
	  sign: function(hash, paranoia, fakeLegacyVersion, fixedKForTesting) {
	    if (sjcl.bitArray.bitLength(hash) > this._curveBitLength) {
	      hash = sjcl.bitArray.clamp(hash, this._curveBitLength);
	    }
	    var R  = this._curve.r,
	        l  = R.bitLength(),
	        k  = fixedKForTesting || sjcl.bn.random(R.sub(1), paranoia).add(1),
	        r  = this._curve.G.mult(k).x.mod(R),
	        ss = sjcl.bn.fromBits(hash).add(r.mul(this._exponent)),
	        s  = fakeLegacyVersion ? ss.inverseMod(R).mul(k).mod(R)
	             : ss.mul(k.inverseMod(R)).mod(R);
	    return sjcl.bitArray.concat(r.toBits(l), s.toBits(l));
	  }
	};
	/** @fileOverview Javascript SRP implementation.
	 *
	 * This file contains a partial implementation of the SRP (Secure Remote
	 * Password) password-authenticated key exchange protocol. Given a user
	 * identity, salt, and SRP group, it generates the SRP verifier that may
	 * be sent to a remote server to establish and SRP account.
	 *
	 * For more information, see http://srp.stanford.edu/.
	 *
	 * @author Quinn Slack
	 */

	/**
	 * Compute the SRP verifier from the username, password, salt, and group.
	 * @class SRP
	 */
	sjcl.keyexchange.srp = {
	  /**
	   * Calculates SRP v, the verifier.
	   *   v = g^x mod N [RFC 5054]
	   * @param {String} I The username.
	   * @param {String} P The password.
	   * @param {Object} s A bitArray of the salt.
	   * @param {Object} group The SRP group. Use sjcl.keyexchange.srp.knownGroup
	                           to obtain this object.
	   * @return {Object} A bitArray of SRP v.
	   */
	  makeVerifier: function(I, P, s, group) {
	    var x;
	    x = sjcl.keyexchange.srp.makeX(I, P, s);
	    x = sjcl.bn.fromBits(x);
	    return group.g.powermod(x, group.N);
	  },

	  /**
	   * Calculates SRP x.
	   *   x = SHA1(<salt> | SHA(<username> | ":" | <raw password>)) [RFC 2945]
	   * @param {String} I The username.
	   * @param {String} P The password.
	   * @param {Object} s A bitArray of the salt.
	   * @return {Object} A bitArray of SRP x.
	   */
	  makeX: function(I, P, s) {
	    var inner = sjcl.hash.sha1.hash(I + ':' + P);
	    return sjcl.hash.sha1.hash(sjcl.bitArray.concat(s, inner));
	  },

	  /**
	   * Returns the known SRP group with the given size (in bits).
	   * @param {String} i The size of the known SRP group.
	   * @return {Object} An object with "N" and "g" properties.
	   */
	  knownGroup:function(i) {
	    if (typeof i !== "string") { i = i.toString(); }
	    if (!sjcl.keyexchange.srp._didInitKnownGroups) { sjcl.keyexchange.srp._initKnownGroups(); }
	    return sjcl.keyexchange.srp._knownGroups[i];
	  },

	  /**
	   * Initializes bignum objects for known group parameters.
	   * @private
	   */
	  _didInitKnownGroups: false,
	  _initKnownGroups:function() {
	    var i, size, group;
	    for (i=0; i < sjcl.keyexchange.srp._knownGroupSizes.length; i++) {
	      size = sjcl.keyexchange.srp._knownGroupSizes[i].toString();
	      group = sjcl.keyexchange.srp._knownGroups[size];
	      group.N = new sjcl.bn(group.N);
	      group.g = new sjcl.bn(group.g);
	    }
	    sjcl.keyexchange.srp._didInitKnownGroups = true;
	  },

	  _knownGroupSizes: [1024, 1536, 2048, 3072, 4096, 6144, 8192],
	  _knownGroups: {
	    1024: {
	      N: "EEAF0AB9ADB38DD69C33F80AFA8FC5E86072618775FF3C0B9EA2314C" +
	         "9C256576D674DF7496EA81D3383B4813D692C6E0E0D5D8E250B98BE4" +
	         "8E495C1D6089DAD15DC7D7B46154D6B6CE8EF4AD69B15D4982559B29" +
	         "7BCF1885C529F566660E57EC68EDBC3C05726CC02FD4CBF4976EAA9A" +
	         "FD5138FE8376435B9FC61D2FC0EB06E3",
	      g:2
	    },

	    1536: {
	      N: "9DEF3CAFB939277AB1F12A8617A47BBBDBA51DF499AC4C80BEEEA961" +
	         "4B19CC4D5F4F5F556E27CBDE51C6A94BE4607A291558903BA0D0F843" +
	         "80B655BB9A22E8DCDF028A7CEC67F0D08134B1C8B97989149B609E0B" +
	         "E3BAB63D47548381DBC5B1FC764E3F4B53DD9DA1158BFD3E2B9C8CF5" +
	         "6EDF019539349627DB2FD53D24B7C48665772E437D6C7F8CE442734A" +
	         "F7CCB7AE837C264AE3A9BEB87F8A2FE9B8B5292E5A021FFF5E91479E" +
	         "8CE7A28C2442C6F315180F93499A234DCF76E3FED135F9BB",
	      g: 2
	    },

	    2048: {
	      N: "AC6BDB41324A9A9BF166DE5E1389582FAF72B6651987EE07FC319294" +
	         "3DB56050A37329CBB4A099ED8193E0757767A13DD52312AB4B03310D" +
	         "CD7F48A9DA04FD50E8083969EDB767B0CF6095179A163AB3661A05FB" +
	         "D5FAAAE82918A9962F0B93B855F97993EC975EEAA80D740ADBF4FF74" +
	         "7359D041D5C33EA71D281E446B14773BCA97B43A23FB801676BD207A" +
	         "436C6481F1D2B9078717461A5B9D32E688F87748544523B524B0D57D" +
	         "5EA77A2775D2ECFA032CFBDBF52FB3786160279004E57AE6AF874E73" +
	         "03CE53299CCC041C7BC308D82A5698F3A8D0C38271AE35F8E9DBFBB6" +
	         "94B5C803D89F7AE435DE236D525F54759B65E372FCD68EF20FA7111F" +
	         "9E4AFF73",
	      g: 2
	    },

	    3072: {
	      N: "FFFFFFFFFFFFFFFFC90FDAA22168C234C4C6628B80DC1CD129024E08" +
	         "8A67CC74020BBEA63B139B22514A08798E3404DDEF9519B3CD3A431B" +
	         "302B0A6DF25F14374FE1356D6D51C245E485B576625E7EC6F44C42E9" +
	         "A637ED6B0BFF5CB6F406B7EDEE386BFB5A899FA5AE9F24117C4B1FE6" +
	         "49286651ECE45B3DC2007CB8A163BF0598DA48361C55D39A69163FA8" +
	         "FD24CF5F83655D23DCA3AD961C62F356208552BB9ED529077096966D" +
	         "670C354E4ABC9804F1746C08CA18217C32905E462E36CE3BE39E772C" +
	         "180E86039B2783A2EC07A28FB5C55DF06F4C52C9DE2BCBF695581718" +
	         "3995497CEA956AE515D2261898FA051015728E5A8AAAC42DAD33170D" +
	         "04507A33A85521ABDF1CBA64ECFB850458DBEF0A8AEA71575D060C7D" +
	         "B3970F85A6E1E4C7ABF5AE8CDB0933D71E8C94E04A25619DCEE3D226" +
	         "1AD2EE6BF12FFA06D98A0864D87602733EC86A64521F2B18177B200C" +
	         "BBE117577A615D6C770988C0BAD946E208E24FA074E5AB3143DB5BFC" +
	         "E0FD108E4B82D120A93AD2CAFFFFFFFFFFFFFFFF",
	       g: 5
	    },

	    4096: {
	      N: "FFFFFFFFFFFFFFFFC90FDAA22168C234C4C6628B80DC1CD129024E08" +
	        "8A67CC74020BBEA63B139B22514A08798E3404DDEF9519B3CD3A431B" +
	        "302B0A6DF25F14374FE1356D6D51C245E485B576625E7EC6F44C42E9" +
	        "A637ED6B0BFF5CB6F406B7EDEE386BFB5A899FA5AE9F24117C4B1FE6" +
	        "49286651ECE45B3DC2007CB8A163BF0598DA48361C55D39A69163FA8" +
	        "FD24CF5F83655D23DCA3AD961C62F356208552BB9ED529077096966D" +
	        "670C354E4ABC9804F1746C08CA18217C32905E462E36CE3BE39E772C" +
	        "180E86039B2783A2EC07A28FB5C55DF06F4C52C9DE2BCBF695581718" +
	        "3995497CEA956AE515D2261898FA051015728E5A8AAAC42DAD33170D" +
	        "04507A33A85521ABDF1CBA64ECFB850458DBEF0A8AEA71575D060C7D" +
	        "B3970F85A6E1E4C7ABF5AE8CDB0933D71E8C94E04A25619DCEE3D226" +
	        "1AD2EE6BF12FFA06D98A0864D87602733EC86A64521F2B18177B200C" +
	        "BBE117577A615D6C770988C0BAD946E208E24FA074E5AB3143DB5BFC" +
	        "E0FD108E4B82D120A92108011A723C12A787E6D788719A10BDBA5B26" +
	        "99C327186AF4E23C1A946834B6150BDA2583E9CA2AD44CE8DBBBC2DB" +
	        "04DE8EF92E8EFC141FBECAA6287C59474E6BC05D99B2964FA090C3A2" +
	        "233BA186515BE7ED1F612970CEE2D7AFB81BDD762170481CD0069127" +
	        "D5B05AA993B4EA988D8FDDC186FFB7DC90A6C08F4DF435C934063199" +
	        "FFFFFFFFFFFFFFFF",
	      g: 5
	    },

	    6144: {
	      N: "FFFFFFFFFFFFFFFFC90FDAA22168C234C4C6628B80DC1CD129024E08" +
	        "8A67CC74020BBEA63B139B22514A08798E3404DDEF9519B3CD3A431B" +
	        "302B0A6DF25F14374FE1356D6D51C245E485B576625E7EC6F44C42E9" +
	        "A637ED6B0BFF5CB6F406B7EDEE386BFB5A899FA5AE9F24117C4B1FE6" +
	        "49286651ECE45B3DC2007CB8A163BF0598DA48361C55D39A69163FA8" +
	        "FD24CF5F83655D23DCA3AD961C62F356208552BB9ED529077096966D" +
	        "670C354E4ABC9804F1746C08CA18217C32905E462E36CE3BE39E772C" +
	        "180E86039B2783A2EC07A28FB5C55DF06F4C52C9DE2BCBF695581718" +
	        "3995497CEA956AE515D2261898FA051015728E5A8AAAC42DAD33170D" +
	        "04507A33A85521ABDF1CBA64ECFB850458DBEF0A8AEA71575D060C7D" +
	        "B3970F85A6E1E4C7ABF5AE8CDB0933D71E8C94E04A25619DCEE3D226" +
	        "1AD2EE6BF12FFA06D98A0864D87602733EC86A64521F2B18177B200C" +
	        "BBE117577A615D6C770988C0BAD946E208E24FA074E5AB3143DB5BFC" +
	        "E0FD108E4B82D120A92108011A723C12A787E6D788719A10BDBA5B26" +
	        "99C327186AF4E23C1A946834B6150BDA2583E9CA2AD44CE8DBBBC2DB" +
	        "04DE8EF92E8EFC141FBECAA6287C59474E6BC05D99B2964FA090C3A2" +
	        "233BA186515BE7ED1F612970CEE2D7AFB81BDD762170481CD0069127" +
	        "D5B05AA993B4EA988D8FDDC186FFB7DC90A6C08F4DF435C934028492" +
	        "36C3FAB4D27C7026C1D4DCB2602646DEC9751E763DBA37BDF8FF9406" +
	        "AD9E530EE5DB382F413001AEB06A53ED9027D831179727B0865A8918" +
	        "DA3EDBEBCF9B14ED44CE6CBACED4BB1BDB7F1447E6CC254B33205151" +
	        "2BD7AF426FB8F401378CD2BF5983CA01C64B92ECF032EA15D1721D03" +
	        "F482D7CE6E74FEF6D55E702F46980C82B5A84031900B1C9E59E7C97F" +
	        "BEC7E8F323A97A7E36CC88BE0F1D45B7FF585AC54BD407B22B4154AA" +
	        "CC8F6D7EBF48E1D814CC5ED20F8037E0A79715EEF29BE32806A1D58B" +
	        "B7C5DA76F550AA3D8A1FBFF0EB19CCB1A313D55CDA56C9EC2EF29632" +
	        "387FE8D76E3C0468043E8F663F4860EE12BF2D5B0B7474D6E694F91E" +
	        "6DCC4024FFFFFFFFFFFFFFFF",
	      g: 5
	    },

	    8192: {
	      N:"FFFFFFFFFFFFFFFFC90FDAA22168C234C4C6628B80DC1CD129024E08" +
	        "8A67CC74020BBEA63B139B22514A08798E3404DDEF9519B3CD3A431B" +
	        "302B0A6DF25F14374FE1356D6D51C245E485B576625E7EC6F44C42E9" +
	        "A637ED6B0BFF5CB6F406B7EDEE386BFB5A899FA5AE9F24117C4B1FE6" +
	        "49286651ECE45B3DC2007CB8A163BF0598DA48361C55D39A69163FA8" +
	        "FD24CF5F83655D23DCA3AD961C62F356208552BB9ED529077096966D" +
	        "670C354E4ABC9804F1746C08CA18217C32905E462E36CE3BE39E772C" +
	        "180E86039B2783A2EC07A28FB5C55DF06F4C52C9DE2BCBF695581718" +
	        "3995497CEA956AE515D2261898FA051015728E5A8AAAC42DAD33170D" +
	        "04507A33A85521ABDF1CBA64ECFB850458DBEF0A8AEA71575D060C7D" +
	        "B3970F85A6E1E4C7ABF5AE8CDB0933D71E8C94E04A25619DCEE3D226" +
	        "1AD2EE6BF12FFA06D98A0864D87602733EC86A64521F2B18177B200C" +
	        "BBE117577A615D6C770988C0BAD946E208E24FA074E5AB3143DB5BFC" +
	        "E0FD108E4B82D120A92108011A723C12A787E6D788719A10BDBA5B26" +
	        "99C327186AF4E23C1A946834B6150BDA2583E9CA2AD44CE8DBBBC2DB" +
	        "04DE8EF92E8EFC141FBECAA6287C59474E6BC05D99B2964FA090C3A2" +
	        "233BA186515BE7ED1F612970CEE2D7AFB81BDD762170481CD0069127" +
	        "D5B05AA993B4EA988D8FDDC186FFB7DC90A6C08F4DF435C934028492" +
	        "36C3FAB4D27C7026C1D4DCB2602646DEC9751E763DBA37BDF8FF9406" +
	        "AD9E530EE5DB382F413001AEB06A53ED9027D831179727B0865A8918" +
	        "DA3EDBEBCF9B14ED44CE6CBACED4BB1BDB7F1447E6CC254B33205151" +
	        "2BD7AF426FB8F401378CD2BF5983CA01C64B92ECF032EA15D1721D03" +
	        "F482D7CE6E74FEF6D55E702F46980C82B5A84031900B1C9E59E7C97F" +
	        "BEC7E8F323A97A7E36CC88BE0F1D45B7FF585AC54BD407B22B4154AA" +
	        "CC8F6D7EBF48E1D814CC5ED20F8037E0A79715EEF29BE32806A1D58B" +
	        "B7C5DA76F550AA3D8A1FBFF0EB19CCB1A313D55CDA56C9EC2EF29632" +
	        "387FE8D76E3C0468043E8F663F4860EE12BF2D5B0B7474D6E694F91E" +
	        "6DBE115974A3926F12FEE5E438777CB6A932DF8CD8BEC4D073B931BA" +
	        "3BC832B68D9DD300741FA7BF8AFC47ED2576F6936BA424663AAB639C" +
	        "5AE4F5683423B4742BF1C978238F16CBE39D652DE3FDB8BEFC848AD9" +
	        "22222E04A4037C0713EB57A81A23F0C73473FC646CEA306B4BCBC886" +
	        "2F8385DDFA9D4B7FA2C087E879683303ED5BDD3A062B3CF5B3A278A6" +
	        "6D2A13F83F44F82DDF310EE074AB6A364597E899A0255DC164F31CC5" +
	        "0846851DF9AB48195DED7EA1B1D510BD7EE74D73FAF36BC31ECFA268" +
	        "359046F4EB879F924009438B481C6CD7889A002ED5EE382BC9190DA6" +
	        "FC026E479558E4475677E9AA9E3050E2765694DFC81F56E880B96E71" +
	        "60C980DD98EDD3DFFFFFFFFFFFFFFFFF",
	      g: 19
	    }
	  }

	};
	/** @fileOverview Really fast & small implementation of CCM using JS' array buffers
	 *
	 * @author Marco Munizaga
	 */

	/** @namespace CTR mode with CBC MAC. */

	sjcl.arrayBuffer = sjcl.arrayBuffer || {};

	//patch arraybuffers if they don't exist
	if (typeof(ArrayBuffer) === 'undefined') {
	  (function(globals){
	      "use strict";
	      globals.ArrayBuffer = function(){};
	      globals.DataView = function(){};
	  }(this));
	}


	sjcl.arrayBuffer.ccm = {
	  mode: "ccm",

	  defaults: {
	    tlen:128 //this is M in the NIST paper
	  },

	  /** Encrypt in CCM mode. Meant to return the same exact thing as the bitArray ccm to work as a drop in replacement
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} plaintext The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=64] the desired tag length, in bits.
	   * @return {bitArray} The encrypted data, an array of bytes.
	   */
	  compat_encrypt: function(prf, plaintext, iv, adata, tlen){
	    var plaintext_buffer = sjcl.codec.arrayBuffer.fromBits(plaintext, true, 16),
	        ol = sjcl.bitArray.bitLength(plaintext)/8,
	        encrypted_obj,
	        ct,
	        tag;

	    tlen = tlen || 64;
	    adata = adata || [];

	    encrypted_obj = sjcl.arrayBuffer.ccm.encrypt(prf, plaintext_buffer, iv, adata, tlen, ol);
	    ct = sjcl.codec.arrayBuffer.toBits(encrypted_obj.ciphertext_buffer);

	    ct = sjcl.bitArray.clamp(ct, ol*8);


	    return sjcl.bitArray.concat(ct, encrypted_obj.tag);
	  },

	  /** Decrypt in CCM mode. Meant to imitate the bitArray ccm 
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes.
	   * @param {bitArray} ciphertext The ciphertext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} [[]] adata The authenticated data.
	   * @param {Number} [64] tlen the desired tag length, in bits.
	   * @return {bitArray} The decrypted data.
	   */
	  compat_decrypt: function(prf, ciphertext, iv, adata, tlen){
	    tlen = tlen || 64;
	    adata = adata || [];
	    var L, i, 
	        w=sjcl.bitArray,
	        ol = w.bitLength(ciphertext), 
	        out = w.clamp(ciphertext, ol - tlen),
	        tag = w.bitSlice(ciphertext, ol - tlen), tag2,
	        ciphertext_buffer = sjcl.codec.arrayBuffer.fromBits(out, true, 16);

	    var plaintext_buffer = sjcl.arrayBuffer.ccm.decrypt(prf, ciphertext_buffer, iv, tag, adata, tlen, (ol-tlen)/8);
	    return sjcl.bitArray.clamp(sjcl.codec.arrayBuffer.toBits(plaintext_buffer), ol-tlen);

	  },

	  /** Really fast ccm encryption, uses arraybufer and mutates the plaintext buffer
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes. 
	   * @param {ArrayBuffer} plaintext_buffer The plaintext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {ArrayBuffer} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=128] the desired tag length, in bits.
	   * @return {ArrayBuffer} The encrypted data, in the same array buffer as the given plaintext, but given back anyways
	   */
	  encrypt: function(prf, plaintext_buffer, iv, adata, tlen, ol){
	    var auth_blocks, mac, L, w = sjcl.bitArray,
	      ivl = w.bitLength(iv) / 8;

	    //set up defaults
	    adata = adata || [];
	    tlen = tlen || sjcl.arrayBuffer.ccm.defaults.tlen;
	    ol = ol || plaintext_buffer.byteLength;
	    tlen = Math.ceil(tlen/8);
	    
	    for (L=2; L<4 && ol >>> 8*L; L++) {}
	    if (L < 15 - ivl) { L = 15-ivl; }
	    iv = w.clamp(iv,8*(15-L));

	    //prf should use a 256 bit key to make precomputation attacks infeasible

	    mac = sjcl.arrayBuffer.ccm._computeTag(prf, plaintext_buffer, iv, adata, tlen, ol, L);

	    //encrypt the plaintext and the mac 
	    //returns the mac since the plaintext will be left encrypted inside the buffer
	    mac = sjcl.arrayBuffer.ccm._ctrMode(prf, plaintext_buffer, iv, mac, tlen, L);


	    //the plaintext_buffer has been modified so it is now the ciphertext_buffer
	    return {'ciphertext_buffer':plaintext_buffer, 'tag':mac};
	  },

	  /** Really fast ccm decryption, uses arraybufer and mutates the given buffer
	   * @static
	   * @param {Object} prf The pseudorandom function.  It must have a block size of 16 bytes. 
	   * @param {ArrayBuffer} ciphertext_buffer The Ciphertext data.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} The authentication tag for the ciphertext
	   * @param {ArrayBuffer} [adata=[]] The authenticated data.
	   * @param {Number} [tlen=128] the desired tag length, in bits.
	   * @return {ArrayBuffer} The decrypted data, in the same array buffer as the given buffer, but given back anyways
	   */
	  decrypt: function(prf, ciphertext_buffer, iv, tag, adata, tlen, ol){
	    var mac, mac2, i, L, w = sjcl.bitArray, 
	      ivl = w.bitLength(iv) / 8;

	    //set up defaults
	    adata = adata || [];
	    tlen = tlen || sjcl.arrayBuffer.ccm.defaults.tlen;
	    ol = ol || ciphertext_buffer.byteLength;
	    tlen = Math.ceil(tlen/8) ;

	    for (L=2; L<4 && ol >>> 8*L; L++) {}
	    if (L < 15 - ivl) { L = 15-ivl; }
	    iv = w.clamp(iv,8*(15-L));
	    
	    //prf should use a 256 bit key to make precomputation attacks infeasible

	    //decrypt the buffer
	    mac = sjcl.arrayBuffer.ccm._ctrMode(prf, ciphertext_buffer, iv, tag, tlen, L);

	    mac2 = sjcl.arrayBuffer.ccm._computeTag(prf, ciphertext_buffer, iv, adata, tlen, ol, L);

	    //check the tag
	    if (!sjcl.bitArray.equal(mac, mac2)){
	      throw new sjcl.exception.corrupt("ccm: tag doesn't match");
	    }

	    return ciphertext_buffer;

	  },

	  /* Compute the (unencrypted) authentication tag, according to the CCM specification
	   * @param {Object} prf The pseudorandom function.
	   * @param {ArrayBuffer} data_buffer The plaintext data in an arraybuffer.
	   * @param {bitArray} iv The initialization value.
	   * @param {bitArray} adata The authenticated data.
	   * @param {Number} tlen the desired tag length, in bits.
	   * @return {bitArray} The tag, but not yet encrypted.
	   * @private
	   */
	  _computeTag: function(prf, data_buffer, iv, adata, tlen, ol, L){
	    var i, plaintext, mac, data, data_blocks_size, data_blocks,
	      w = sjcl.bitArray, tmp, macData;

	    mac = sjcl.mode.ccm._macAdditionalData(prf, adata, iv, tlen, ol, L);

	    if (data_buffer.byteLength !== 0) {
	      data = new DataView(data_buffer);
	      //set padding bytes to 0
	      for (i=ol; i< data_buffer.byteLength; i++){
	        data.setUint8(i,0);
	      }

	      //now to mac the plaintext blocks
	      for (i=0; i < data.byteLength; i+=16){
	        mac[0] ^= data.getUint32(i);
	        mac[1] ^= data.getUint32(i+4);
	        mac[2] ^= data.getUint32(i+8);
	        mac[3] ^= data.getUint32(i+12);

	        mac = prf.encrypt(mac);
	      }
	    }

	    return sjcl.bitArray.clamp(mac,tlen*8);
	  },

	  /** CCM CTR mode.
	   * Encrypt or decrypt data and tag with the prf in CCM-style CTR mode.
	   * Mutates given array buffer
	   * @param {Object} prf The PRF.
	   * @param {ArrayBuffer} data_buffer The data to be encrypted or decrypted.
	   * @param {bitArray} iv The initialization vector.
	   * @param {bitArray} tag The authentication tag.
	   * @param {Number} tlen The length of th etag, in bits.
	   * @return {Object} An object with data and tag, the en/decryption of data and tag values.
	   * @private
	   */
	  _ctrMode: function(prf, data_buffer, iv, mac, tlen, L){
	    var data, ctr, word0, word1, word2, word3, keyblock, i, w = sjcl.bitArray, xor = w._xor4, n = data_buffer.byteLength/50, p = n;

	    ctr = new DataView(new ArrayBuffer(16)); //create the first block for the counter

	    //prf should use a 256 bit key to make precomputation attacks infeasible

	    // start the ctr
	    ctr = w.concat([w.partial(8,L-1)],iv).concat([0,0,0]).slice(0,4);

	    // en/decrypt the tag
	    mac = w.bitSlice(xor(mac,prf.encrypt(ctr)), 0, tlen*8);

	    ctr[3]++;
	    if (ctr[3]===0) ctr[2]++; //increment higher bytes if the lowest 4 bytes are 0

	    if (data_buffer.byteLength !== 0) {
	      data = new DataView(data_buffer);
	      //now lets encrypt the message
	      for (i=0; i<data.byteLength;i+=16){
	        if (i > n) {
	          sjcl.mode.ccm._callProgressListener(i/data_buffer.byteLength);
	          n += p;
	        }
	        keyblock = prf.encrypt(ctr);

	        word0 = data.getUint32(i);
	        word1 = data.getUint32(i+4);
	        word2 = data.getUint32(i+8);
	        word3 = data.getUint32(i+12);

	        data.setUint32(i,word0 ^ keyblock[0]);
	        data.setUint32(i+4, word1 ^ keyblock[1]);
	        data.setUint32(i+8, word2 ^ keyblock[2]);
	        data.setUint32(i+12, word3 ^ keyblock[3]);

	        ctr[3]++;
	        if (ctr[3]===0) ctr[2]++; //increment higher bytes if the lowest 4 bytes are 0
	      }
	    }

	    //return the mac, the ciphered data is available through the same data_buffer that was given
	    return mac;
	  }

	};
	/** @fileOverview Bit array codec implementations.
	 *
	 * @author Marco Munizaga
	 */

	//patch arraybuffers if they don't exist
	if (typeof(ArrayBuffer) === 'undefined') {
	  (function(globals){
	      "use strict";
	      globals.ArrayBuffer = function(){};
	      globals.DataView = function(){};
	  }(this));
	}

	/** @namespace ArrayBuffer */
	sjcl.codec.arrayBuffer = {
	  /** Convert from a bitArray to an ArrayBuffer. 
	   * Will default to 8byte padding if padding is undefined*/
	  fromBits: function (arr, padding, padding_count) {
	    var out, i, ol, tmp, smallest;
	    padding = padding==undefined  ? true : padding
	    padding_count = padding_count || 8

	    if (arr.length === 0) {
	      return new ArrayBuffer(0);
	    }

	    ol = sjcl.bitArray.bitLength(arr)/8;

	    //check to make sure the bitLength is divisible by 8, if it isn't 
	    //we can't do anything since arraybuffers work with bytes, not bits
	    if ( sjcl.bitArray.bitLength(arr)%8 !== 0 ) {
	      throw new sjcl.exception.invalid("Invalid bit size, must be divisble by 8 to fit in an arraybuffer correctly")
	    }

	    if (padding && ol%padding_count !== 0){
	      ol += padding_count - (ol%padding_count);
	    }


	    //padded temp for easy copying
	    tmp = new DataView(new ArrayBuffer(arr.length*4));
	    for (i=0; i<arr.length; i++) {
	      tmp.setUint32(i*4, (arr[i]<<32)); //get rid of the higher bits
	    }

	    //now copy the final message if we are not going to 0 pad
	    out = new DataView(new ArrayBuffer(ol));

	    //save a step when the tmp and out bytelength are ===
	    if (out.byteLength === tmp.byteLength){
	      return tmp.buffer;
	    }

	    smallest = tmp.byteLength < out.byteLength ? tmp.byteLength : out.byteLength;
	    for(i=0; i<smallest; i++){
	      out.setUint8(i,tmp.getUint8(i));
	    }


	    return out.buffer
	  },

	  toBits: function (buffer) {
	    var i, out=[], len, inView, tmp;

	    if (buffer.byteLength === 0) {
	      return [];
	    }

	    inView = new DataView(buffer);
	    len = inView.byteLength - inView.byteLength%4;

	    for (var i = 0; i < len; i+=4) {
	      out.push(inView.getUint32(i));
	    }

	    if (inView.byteLength%4 != 0) {
	      tmp = new DataView(new ArrayBuffer(4));
	      for (var i = 0, l = inView.byteLength%4; i < l; i++) {
	        //we want the data to the right, because partial slices off the starting bits
	        tmp.setUint8(i+4-l, inView.getUint8(len+i)); // big-endian, 
	      }
	      out.push(
	        sjcl.bitArray.partial( (inView.byteLength%4)*8, tmp.getUint32(0) )
	      ); 
	    }
	    return out;
	  },



	  /** Prints a hex output of the buffer contents, akin to hexdump **/
	  hexDumpBuffer: function(buffer){
	      var stringBufferView = new DataView(buffer)
	      var string = ''
	      var pad = function (n, width) {
	          n = n + '';
	          return n.length >= width ? n : new Array(width - n.length + 1).join('0') + n;
	      }

	      for (var i = 0; i < stringBufferView.byteLength; i+=2) {
	          if (i%16 == 0) string += ('\n'+(i).toString(16)+'\t')
	          string += ( pad(stringBufferView.getUint16(i).toString(16),4) + ' ')
	      }

	      if ( typeof console === undefined ){
	        console = console || {log:function(){}} //fix for IE
	      }
	      console.log(string.toUpperCase())
	  }
	};

	/** @fileOverview Javascript RIPEMD-160 implementation.
	 *
	 * @author Artem S Vybornov <vybornov@gmail.com>
	 */
	(function() {

	/**
	 * Context for a RIPEMD-160 operation in progress.
	 * @constructor
	 * @class RIPEMD, 160 bits.
	 */
	sjcl.hash.ripemd160 = function (hash) {
	    if (hash) {
	        this._h = hash._h.slice(0);
	        this._buffer = hash._buffer.slice(0);
	        this._length = hash._length;
	    } else {
	        this.reset();
	    }
	};

	/**
	 * Hash a string or an array of words.
	 * @static
	 * @param {bitArray|String} data the data to hash.
	 * @return {bitArray} The hash value, an array of 5 big-endian words.
	 */
	sjcl.hash.ripemd160.hash = function (data) {
	  return (new sjcl.hash.ripemd160()).update(data).finalize();
	};

	sjcl.hash.ripemd160.prototype = {
	    /**
	     * Reset the hash state.
	     * @return this
	     */
	    reset: function () {
	        this._h = _h0.slice(0);
	        this._buffer = [];
	        this._length = 0;
	        return this;
	    },

	    /**
	     * Reset the hash state.
	     * @param {bitArray|String} data the data to hash.
	     * @return this
	     */
	    update: function (data) {
	        if ( typeof data === "string" )
	            data = sjcl.codec.utf8String.toBits(data);

	        var i, b = this._buffer = sjcl.bitArray.concat(this._buffer, data),
	            ol = this._length,
	            nl = this._length = ol + sjcl.bitArray.bitLength(data);
	        for (i = 512+ol & -512; i <= nl; i+= 512) {
	            var words = b.splice(0,16);
	            for ( var w = 0; w < 16; ++w )
	                words[w] = _cvt(words[w]);

	            _block.call( this, words );
	        }

	        return this;
	    },

	    /**
	     * Complete hashing and output the hash value.
	     * @return {bitArray} The hash value, an array of 5 big-endian words.
	     */
	    finalize: function () {
	        var b = sjcl.bitArray.concat( this._buffer, [ sjcl.bitArray.partial(1,1) ] ),
	            l = ( this._length + 1 ) % 512,
	            z = ( l > 448 ? 512 : 448 ) - l % 448,
	            zp = z % 32;

	        if ( zp > 0 )
	            b = sjcl.bitArray.concat( b, [ sjcl.bitArray.partial(zp,0) ] )
	        for ( ; z >= 32; z -= 32 )
	            b.push(0);

	        b.push( _cvt( this._length | 0 ) );
	        b.push( _cvt( Math.floor(this._length / 0x100000000) ) );

	        while ( b.length ) {
	            var words = b.splice(0,16);
	            for ( var w = 0; w < 16; ++w )
	                words[w] = _cvt(words[w]);

	            _block.call( this, words );
	        }

	        var h = this._h;
	        this.reset();

	        for ( var w = 0; w < 5; ++w )
	            h[w] = _cvt(h[w]);

	        return h;
	    }
	};

	var _h0 = [ 0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0 ];

	var _k1 = [ 0x00000000, 0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xa953fd4e ];
	var _k2 = [ 0x50a28be6, 0x5c4dd124, 0x6d703ef3, 0x7a6d76e9, 0x00000000 ];
	for ( var i = 4; i >= 0; --i ) {
	    for ( var j = 1; j < 16; ++j ) {
	        _k1.splice(i,0,_k1[i]);
	        _k2.splice(i,0,_k2[i]);
	    }
	}

	var _r1 = [  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	             7,  4, 13,  1, 10,  6, 15,  3, 12,  0,  9,  5,  2, 14, 11,  8,
	             3, 10, 14,  4,  9, 15,  8,  1,  2,  7,  0,  6, 13, 11,  5, 12,
	             1,  9, 11, 10,  0,  8, 12,  4, 13,  3,  7, 15, 14,  5,  6,  2,
	             4,  0,  5,  9,  7, 12,  2, 10, 14,  1,  3,  8, 11,  6, 15, 13 ];
	var _r2 = [  5, 14,  7,  0,  9,  2, 11,  4, 13,  6, 15,  8,  1, 10,  3, 12,
	             6, 11,  3,  7,  0, 13,  5, 10, 14, 15,  8, 12,  4,  9,  1,  2,
	            15,  5,  1,  3,  7, 14,  6,  9, 11,  8, 12,  2, 10,  0,  4, 13,
	             8,  6,  4,  1,  3, 11, 15,  0,  5, 12,  2, 13,  9,  7, 10, 14,
	            12, 15, 10,  4,  1,  5,  8,  7,  6,  2, 13, 14,  0,  3,  9, 11 ];

	var _s1 = [ 11, 14, 15, 12,  5,  8,  7,  9, 11, 13, 14, 15,  6,  7,  9,  8,
	             7,  6,  8, 13, 11,  9,  7, 15,  7, 12, 15,  9, 11,  7, 13, 12,
	            11, 13,  6,  7, 14,  9, 13, 15, 14,  8, 13,  6,  5, 12,  7,  5,
	            11, 12, 14, 15, 14, 15,  9,  8,  9, 14,  5,  6,  8,  6,  5, 12,
	             9, 15,  5, 11,  6,  8, 13, 12,  5, 12, 13, 14, 11,  8,  5,  6 ];
	var _s2 = [  8,  9,  9, 11, 13, 15, 15,  5,  7,  7,  8, 11, 14, 14, 12,  6,
	             9, 13, 15,  7, 12,  8,  9, 11,  7,  7, 12,  7,  6, 15, 13, 11,
	             9,  7, 15, 11,  8,  6,  6, 14, 12, 13,  5, 14, 13, 13,  7,  5,
	            15,  5,  8, 11, 14, 14,  6, 14,  6,  9, 12,  9, 12,  5, 15,  8,
	             8,  5, 12,  9, 12,  5, 14,  6,  8, 13,  6,  5, 15, 13, 11, 11 ];

	function _f0(x,y,z) {
	    return x ^ y ^ z;
	};

	function _f1(x,y,z) {
	    return (x & y) | (~x & z);
	};

	function _f2(x,y,z) {
	    return (x | ~y) ^ z;
	};

	function _f3(x,y,z) {
	    return (x & z) | (y & ~z);
	};

	function _f4(x,y,z) {
	    return x ^ (y | ~z);
	};

	function _rol(n,l) {
	    return (n << l) | (n >>> (32-l));
	}

	function _cvt(n) {
	    return ( (n & 0xff <<  0) <<  24 )
	         | ( (n & 0xff <<  8) <<   8 )
	         | ( (n & 0xff << 16) >>>  8 )
	         | ( (n & 0xff << 24) >>> 24 );
	}

	function _block(X) {
	    var A1 = this._h[0], B1 = this._h[1], C1 = this._h[2], D1 = this._h[3], E1 = this._h[4],
	        A2 = this._h[0], B2 = this._h[1], C2 = this._h[2], D2 = this._h[3], E2 = this._h[4];

	    var j = 0, T;

	    for ( ; j < 16; ++j ) {
	        T = _rol( A1 + _f0(B1,C1,D1) + X[_r1[j]] + _k1[j], _s1[j] ) + E1;
	        A1 = E1; E1 = D1; D1 = _rol(C1,10); C1 = B1; B1 = T;
	        T = _rol( A2 + _f4(B2,C2,D2) + X[_r2[j]] + _k2[j], _s2[j] ) + E2;
	        A2 = E2; E2 = D2; D2 = _rol(C2,10); C2 = B2; B2 = T; }
	    for ( ; j < 32; ++j ) {
	        T = _rol( A1 + _f1(B1,C1,D1) + X[_r1[j]] + _k1[j], _s1[j] ) + E1;
	        A1 = E1; E1 = D1; D1 = _rol(C1,10); C1 = B1; B1 = T;
	        T = _rol( A2 + _f3(B2,C2,D2) + X[_r2[j]] + _k2[j], _s2[j] ) + E2;
	        A2 = E2; E2 = D2; D2 = _rol(C2,10); C2 = B2; B2 = T; }
	    for ( ; j < 48; ++j ) {
	        T = _rol( A1 + _f2(B1,C1,D1) + X[_r1[j]] + _k1[j], _s1[j] ) + E1;
	        A1 = E1; E1 = D1; D1 = _rol(C1,10); C1 = B1; B1 = T;
	        T = _rol( A2 + _f2(B2,C2,D2) + X[_r2[j]] + _k2[j], _s2[j] ) + E2;
	        A2 = E2; E2 = D2; D2 = _rol(C2,10); C2 = B2; B2 = T; }
	    for ( ; j < 64; ++j ) {
	        T = _rol( A1 + _f3(B1,C1,D1) + X[_r1[j]] + _k1[j], _s1[j] ) + E1;
	        A1 = E1; E1 = D1; D1 = _rol(C1,10); C1 = B1; B1 = T;
	        T = _rol( A2 + _f1(B2,C2,D2) + X[_r2[j]] + _k2[j], _s2[j] ) + E2;
	        A2 = E2; E2 = D2; D2 = _rol(C2,10); C2 = B2; B2 = T; }
	    for ( ; j < 80; ++j ) {
	        T = _rol( A1 + _f4(B1,C1,D1) + X[_r1[j]] + _k1[j], _s1[j] ) + E1;
	        A1 = E1; E1 = D1; D1 = _rol(C1,10); C1 = B1; B1 = T;
	        T = _rol( A2 + _f0(B2,C2,D2) + X[_r2[j]] + _k2[j], _s2[j] ) + E2;
	        A2 = E2; E2 = D2; D2 = _rol(C2,10); C2 = B2; B2 = T; }

	    T = this._h[1] + C1 + D2;
	    this._h[1] = this._h[2] + D1 + E2;
	    this._h[2] = this._h[3] + E1 + A2;
	    this._h[3] = this._h[4] + A1 + B2;
	    this._h[4] = this._h[0] + B1 + C2;
	    this._h[0] = T;
	}

	})();


/***/ },
/* 53 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _ = __webpack_require__(42);
	var assert = __webpack_require__(38);
	var UInt160 = __webpack_require__(9).UInt160;
	var Amount = __webpack_require__(3).Amount;
	var Utils = __webpack_require__(54);

	function assertValidNumber(number, message) {
	  assert(!_.isNull(number) && !isNaN(number), message);
	}

	function assertValidLegOneOffer(legOneOffer, message) {
	  assert(legOneOffer);
	  assert.strictEqual(typeof legOneOffer, 'object', message);
	  assert.strictEqual(typeof legOneOffer.TakerPays, 'object', message);
	  assertValidNumber(legOneOffer.TakerGets, message);
	}

	function AutobridgeCalculator(currencyGets, currencyPays, legOneOffers, legTwoOffers, issuerGets, issuerPays) {
	  this._currencyGets = currencyGets;
	  this._currencyPays = currencyPays;
	  this._issuerGets = issuerGets;
	  this._issuerPays = issuerPays;
	  this.legOneOffers = _.cloneDeep(legOneOffers);
	  this.legTwoOffers = _.cloneDeep(legTwoOffers);

	  this._ownerFundsLeftover = {};
	}

	/**
	 * Calculates an ordered array of autobridged offers by quality
	 *
	 * @return {Array}
	 */

	AutobridgeCalculator.prototype.calculate = function () {
	  var legOnePointer = 0;
	  var legTwoPointer = 0;

	  var offersAutobridged = [];

	  this.clearOwnerFundsLeftover();

	  while (this.legOneOffers[legOnePointer] && this.legTwoOffers[legTwoPointer]) {
	    var legOneOffer = this.legOneOffers[legOnePointer];
	    var legTwoOffer = this.legTwoOffers[legTwoPointer];
	    var leftoverFunds = this.getLeftoverOwnerFunds(legOneOffer.Account);
	    var autobridgedOffer = undefined;

	    if (legOneOffer.Account === legTwoOffer.Account) {
	      this.unclampLegOneOwnerFunds(legOneOffer);
	    } else if (!legOneOffer.is_fully_funded && !leftoverFunds.is_zero()) {
	      this.adjustLegOneFundedAmount(legOneOffer);
	    }

	    var legOneTakerGetsFunded = Utils.getOfferTakerGetsFunded(legOneOffer);
	    var legTwoTakerPaysFunded = Utils.getOfferTakerPaysFunded(legTwoOffer);

	    if (legOneTakerGetsFunded.is_zero()) {
	      legOnePointer++;

	      continue;
	    }

	    if (legTwoTakerPaysFunded.is_zero()) {
	      legTwoPointer++;

	      continue;
	    }

	    if (legOneTakerGetsFunded.compareTo(legTwoTakerPaysFunded) > 0) {
	      autobridgedOffer = this.getAutobridgedOfferWithClampedLegOne(legOneOffer, legTwoOffer);

	      legTwoPointer++;
	    } else if (legTwoTakerPaysFunded.compareTo(legOneTakerGetsFunded) > 0) {
	      autobridgedOffer = this.getAutobridgedOfferWithClampedLegTwo(legOneOffer, legTwoOffer);

	      legOnePointer++;
	    } else {
	      autobridgedOffer = this.getAutobridgedOfferWithoutClamps(legOneOffer, legTwoOffer);

	      legOnePointer++;
	      legTwoPointer++;
	    }

	    offersAutobridged.push(autobridgedOffer);
	  }

	  return offersAutobridged;
	};

	/**
	 * In this case, the output from leg one is greater than the input to leg two.
	 * Therefore, we must effectively clamp leg one output to leg two input.
	 *
	 * @param {Object} legOneOffer
	 * @param {Object} legTwoOffer
	 *
	 * @return {Object}
	 */

	AutobridgeCalculator.prototype.getAutobridgedOfferWithClampedLegOne = function (legOneOffer, legTwoOffer) {
	  var legOneTakerGetsFunded = Utils.getOfferTakerGetsFunded(legOneOffer);
	  var legTwoTakerPaysFunded = Utils.getOfferTakerPaysFunded(legTwoOffer);
	  var legOneQuality = Utils.getOfferQuality(legOneOffer, this._currencyGets);

	  var autobridgedTakerGets = Utils.getOfferTakerGetsFunded(legTwoOffer);
	  var autobridgedTakerPays = legTwoTakerPaysFunded.multiply(legOneQuality);

	  if (legOneOffer.Account === legTwoOffer.Account) {
	    var legOneTakerGets = Utils.getOfferTakerGets(legOneOffer);
	    var updatedTakerGets = legOneTakerGets.subtract(legTwoTakerPaysFunded);

	    this.setLegOneTakerGets(legOneOffer, updatedTakerGets);

	    this.clampLegOneOwnerFunds(legOneOffer);
	  } else {
	    // Update funded amount since leg one offer was not completely consumed
	    var updatedTakerGetsFunded = legOneTakerGetsFunded.subtract(legTwoTakerPaysFunded);

	    this.setLegOneTakerGetsFunded(legOneOffer, updatedTakerGetsFunded);
	  }

	  return this.formatAutobridgedOffer(autobridgedTakerGets, autobridgedTakerPays);
	};

	/**
	 * In this case, the input from leg two is greater than the output to leg one.
	 * Therefore, we must effectively clamp leg two input to leg one output.
	 *
	 * @param {Object} legOneOffer
	 * @param {Object} legTwoOffer
	 *
	 * @return {Object}
	 */

	AutobridgeCalculator.prototype.getAutobridgedOfferWithClampedLegTwo = function (legOneOffer, legTwoOffer) {
	  var legOneTakerGetsFunded = Utils.getOfferTakerGetsFunded(legOneOffer);
	  var legTwoTakerPaysFunded = Utils.getOfferTakerPaysFunded(legTwoOffer);
	  var legTwoQuality = Utils.getOfferQuality(legTwoOffer, this._currencyGets);

	  var autobridgedTakerGets = legOneTakerGetsFunded.divide(legTwoQuality);
	  var autobridgedTakerPays = Utils.getOfferTakerPaysFunded(legOneOffer);

	  // Update funded amount since leg two offer was not completely consumed
	  legTwoOffer.taker_gets_funded = Utils.getOfferTakerGetsFunded(legTwoOffer).subtract(autobridgedTakerGets).to_text();
	  legTwoOffer.taker_pays_funded = legTwoTakerPaysFunded.subtract(legOneTakerGetsFunded).to_text();

	  return this.formatAutobridgedOffer(autobridgedTakerGets, autobridgedTakerPays);
	};

	/**
	 * In this case, the output from leg one and the input to leg two are the same.
	 * We do not need to clamp either.
	 * @param {Object} legOneOffer
	 * @param {Object} legTwoOffer
	 *
	 * @return {Object}
	 */

	AutobridgeCalculator.prototype.getAutobridgedOfferWithoutClamps = function (legOneOffer, legTwoOffer) {
	  var autobridgedTakerGets = Utils.getOfferTakerGetsFunded(legTwoOffer);
	  var autobridgedTakerPays = Utils.getOfferTakerPaysFunded(legOneOffer);

	  return this.formatAutobridgedOffer(autobridgedTakerGets, autobridgedTakerPays);
	};

	/**
	 * Clear owner funds leftovers
	 */

	AutobridgeCalculator.prototype.clearOwnerFundsLeftover = function () {
	  this._ownerFundsLeftover = {};
	};

	/**
	 * Reset owner funds leftovers for an account to 0
	 *
	 * @param {String} account
	 *
	 * @return {Amount}
	 */

	AutobridgeCalculator.prototype.resetOwnerFundsLeftover = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');

	  this._ownerFundsLeftover[account] = Utils.normalizeAmount('0');

	  return this._ownerFundsLeftover[account];
	};

	/**
	 * Retrieve leftover funds found after clamping leg one by account
	 *
	 * @param {String} account
	 *
	 * @return {Amount}
	 */

	AutobridgeCalculator.prototype.getLeftoverOwnerFunds = function (account) {
	  assert(UInt160.is_valid(account), 'Account is invalid');

	  var amount = this._ownerFundsLeftover[account];

	  if (!amount) {
	    amount = Utils.normalizeAmount('0');
	  }

	  return amount;
	};

	/**
	 * Add funds to account's leftover funds
	 *
	 * @param {String} account
	 * @param {Amount} amount
	 *
	 * @return {Amount}
	 */

	AutobridgeCalculator.prototype.addLeftoverOwnerFunds = function (account, amount) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  assert(amount instanceof Amount, 'Amount is invalid');

	  this._ownerFundsLeftover[account] = this.getLeftoverOwnerFunds(account).add(amount);

	  return this._ownerFundsLeftover[account];
	};

	/**
	 * Set account's leftover funds
	 *
	 * @param {String} account
	 * @param {Amount} amount
	 */

	AutobridgeCalculator.prototype.setLeftoverOwnerFunds = function (account, amount) {
	  assert(UInt160.is_valid(account), 'Account is invalid');
	  assert(amount instanceof Amount, 'Amount is invalid');

	  this._ownerFundsLeftover[account] = amount;
	};

	/**
	 * Format an autobridged offer and compute synthetic values (e.g. quality)
	 *
	 * @param {Amount} takerGets
	 * @param {Amount} takerPays
	 *
	 * @return {Object}
	 */

	AutobridgeCalculator.prototype.formatAutobridgedOffer = function (takerGets, takerPays) {
	  assert(takerGets instanceof Amount, 'Autobridged taker gets is invalid');
	  assert(takerPays instanceof Amount, 'Autobridged taker pays is invalid');

	  var autobridgedOffer = {};
	  var quality = takerPays.divide(takerGets);

	  autobridgedOffer.TakerGets = {
	    value: takerGets.to_text(),
	    currency: this._currencyGets.to_hex(),
	    issuer: this._issuerGets
	  };

	  autobridgedOffer.TakerPays = {
	    value: takerPays.to_text(),
	    currency: this._currencyPays.to_hex(),
	    issuer: this._issuerPays
	  };

	  autobridgedOffer.quality = quality.to_text();

	  autobridgedOffer.taker_gets_funded = autobridgedOffer.TakerGets.value;
	  autobridgedOffer.taker_pays_funded = autobridgedOffer.TakerPays.value;

	  autobridgedOffer.autobridged = true;

	  autobridgedOffer.BookDirectory = Utils.convertOfferQualityToHex(quality);

	  return autobridgedOffer;
	};

	/**
	 * Remove funds clamp on leg one offer. This is necessary when the two offers
	 * are owned by the same account. In this case, it doesn't matter if offer one
	 * is not fully funded. Leg one out goes to leg two in and since its the same
	 * account, an infinite amount can flow.
	 *
	 * @param {Object} legOneOffer - IOU:XRP offer
	 */

	AutobridgeCalculator.prototype.unclampLegOneOwnerFunds = function (legOneOffer) {
	  assertValidLegOneOffer(legOneOffer, 'Leg one offer is invalid');

	  legOneOffer.initTakerGetsFunded = Utils.getOfferTakerGetsFunded(legOneOffer);

	  this.setLegOneTakerGetsFunded(legOneOffer, Utils.getOfferTakerGets(legOneOffer));
	};

	/**
	 * Apply clamp back on leg one offer after a round of autobridge calculation
	 * completes. We must reapply clamps that have been removed because we cannot
	 * guarantee that the next offer from leg two will also be from the same
	 * account.
	 *
	 * When we reapply, it could happen that the amount of TakerGets left after
	 * the autobridge calculation is less than the original funded amount. In this
	 * case, we have extra funds we can use towards unfunded offers with worse
	 * quality by the same owner.
	 *
	 * @param {Object} legOneOffer - IOU:XRP offer
	 */

	AutobridgeCalculator.prototype.clampLegOneOwnerFunds = function (legOneOffer) {
	  assertValidLegOneOffer(legOneOffer, 'Leg one offer is invalid');

	  var takerGets = Utils.getOfferTakerGets(legOneOffer);

	  if (takerGets.compareTo(legOneOffer.initTakerGetsFunded) > 0) {
	    // After clamping, TakerGets is still greater than initial funded amount
	    this.setLegOneTakerGetsFunded(legOneOffer, legOneOffer.initTakerGetsFunded);
	  } else {
	    var updatedLeftover = legOneOffer.initTakerGetsFunded.subtract(takerGets);

	    this.setLegOneTakerGetsFunded(legOneOffer, takerGets);
	    this.addLeftoverOwnerFunds(legOneOffer.Account, updatedLeftover);
	  }
	};

	/**
	 * Increase leg one offer funded amount with extra funds found after applying
	 * clamp.
	 *
	 * @param {Object} legOneOffer - IOU:XRP offer
	 */

	AutobridgeCalculator.prototype.adjustLegOneFundedAmount = function (legOneOffer) {
	  assertValidLegOneOffer(legOneOffer, 'Leg one offer is invalid');
	  assert(!legOneOffer.is_fully_funded, 'Leg one offer cannot be fully funded');

	  var fundedSum = Utils.getOfferTakerGetsFunded(legOneOffer).add(this.getLeftoverOwnerFunds(legOneOffer.Account));

	  if (fundedSum.compareTo(Utils.getOfferTakerGets(legOneOffer)) >= 0) {
	    // There are enough extra funds to fully fund the offer
	    var legOneTakerGets = Utils.getOfferTakerGets(legOneOffer);
	    var updatedLeftover = fundedSum.subtract(legOneTakerGets);

	    this.setLegOneTakerGetsFunded(legOneOffer, legOneTakerGets);
	    this.setLeftoverOwnerFunds(legOneOffer.Account, updatedLeftover);
	  } else {
	    // There are not enough extra funds to fully fund the offer
	    this.setLegOneTakerGetsFunded(legOneOffer, fundedSum);
	    this.resetOwnerFundsLeftover(legOneOffer.Account);
	  }
	};

	/**
	 * Set taker gets funded amount for a IOU:XRP offer. Also calculates taker
	 * pays funded using offer quality and updates is_fully_funded flag
	 *
	 * @param {Object} legOneOffer - IOU:XRP offer
	 * @param {Amount} takerGetsFunded
	 */

	AutobridgeCalculator.prototype.setLegOneTakerGetsFunded = function setLegOneTakerGetsFunded(legOneOffer, takerGetsFunded) {
	  assertValidLegOneOffer(legOneOffer, 'Leg one offer is invalid');
	  assert(takerGetsFunded instanceof Amount, 'Taker gets funded is invalid');

	  legOneOffer.taker_gets_funded = takerGetsFunded.to_text();
	  legOneOffer.taker_pays_funded = takerGetsFunded.multiply(Utils.getOfferQuality(legOneOffer, this._currencyGets)).to_text();

	  if (legOneOffer.taker_gets_funded === legOneOffer.TakerGets.value) {
	    legOneOffer.is_fully_funded = true;
	  }
	};

	/**
	 * Set taker gets amount for a IOU:XRP offer. Also calculates taker pays
	 * using offer quality
	 *
	 * @param {Object} legOneOffer - IOU:XRP offer
	 * @param {Amount} takerGets
	 */

	AutobridgeCalculator.prototype.setLegOneTakerGets = function (legOneOffer, takerGets) {
	  assertValidLegOneOffer(legOneOffer, 'Leg one offer is invalid');
	  assert(takerGets instanceof Amount, 'Taker gets funded is invalid');

	  var legOneQuality = Utils.getOfferQuality(legOneOffer, this._currencyGets);

	  legOneOffer.TakerGets = takerGets.to_text();
	  legOneOffer.TakerPays = takerGets.multiply(legOneQuality);
	};

	module.exports = AutobridgeCalculator;

/***/ },
/* 54 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _ = __webpack_require__(42);
	var assert = __webpack_require__(38);
	var SerializedObject = __webpack_require__(13).SerializedObject;
	var Types = __webpack_require__(26);
	var Amount = __webpack_require__(3).Amount;

	var IOU_SUFFIX = '/000/rrrrrrrrrrrrrrrrrrrrrhoLvTp';
	var OrderBookUtils = {};

	function assertValidNumber(number, message) {
	  assert(!_.isNull(number) && !isNaN(number), message);
	}

	/**
	 * Casts and returns offer's taker gets funded amount as a default IOU amount
	 *
	 * @param {Object} offer
	 * @return {Amount}
	 */

	OrderBookUtils.getOfferTakerGetsFunded = function (offer) {
	  assertValidNumber(offer.taker_gets_funded, 'Taker gets funded is invalid');

	  return Amount.from_json(offer.taker_gets_funded + IOU_SUFFIX);
	};

	/**
	 * Casts and returns offer's taker pays funded amount as a default IOU amount
	 *
	 * @param {Object} offer
	 * @return {Amount}
	 */

	OrderBookUtils.getOfferTakerPaysFunded = function (offer) {
	  assertValidNumber(offer.taker_pays_funded, 'Taker gets funded is invalid');

	  return Amount.from_json(offer.taker_pays_funded + IOU_SUFFIX);
	};

	/**
	 * Get offer taker gets amount
	 *
	 * @param {Object} offer
	 *
	 * @return {Amount}
	 */

	OrderBookUtils.getOfferTakerGets = function (offer) {
	  assert(typeof offer, 'object', 'Offer is invalid');

	  return Amount.from_json(offer.TakerGets + IOU_SUFFIX);
	};

	/**
	 * Retrieve offer quality
	 *
	 * @param {Object} offer
	 * @param {Currency} currencyGets
	 */

	OrderBookUtils.getOfferQuality = function (offer, currencyGets) {
	  var amount;

	  if (currencyGets.has_interest()) {
	    // XXX Should use Amount#from_quality
	    amount = Amount.from_json(offer.TakerPays).ratio_human(offer.TakerGets, {
	      reference_date: new Date()
	    });
	  } else {
	    amount = Amount.from_json(offer.quality + IOU_SUFFIX);
	  }

	  return amount;
	};

	/**
	 * Formats an offer quality amount to a hex that can be parsed by
	 * Amount.parse_quality
	 *
	 * @param {Amount} quality
	 *
	 * @return {String}
	 */

	OrderBookUtils.convertOfferQualityToHex = function (quality) {
	  assert(quality instanceof Amount, 'Quality is not an amount');

	  var so = new SerializedObject();
	  Types.Quality.serialize(so, quality.to_text() + IOU_SUFFIX);

	  return so.to_hex();
	};

	/**
	 *
	 */

	OrderBookUtils.normalizeAmount = function (value) {
	  return Amount.from_json(value + IOU_SUFFIX);
	};

	module.exports = OrderBookUtils;

/***/ },
/* 55 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint new-cap: [2, {newIsCapExceptions: ["bn"]}] */
	'use strict';
	var sjcl = __webpack_require__(52);
	/**
	 *  Check that the point is valid based on the method described in
	 *  SEC 1: Elliptic Curve Cryptography, section 3.2.2.1:
	 *  Elliptic Curve Public Key Validation Primitive
	 *  http://www.secg.org/download/aid-780/sec1-v2.pdf
	 *
	 *  @returns {Boolean} true if point is valid
	 */
	sjcl.ecc.point.prototype.isValidPoint = function () {

	  var self = this;

	  var field_modulus = self.curve.field.modulus;

	  if (self.isIdentity) {
	    return false;
	  }

	  // Check that coordinatres are in bounds
	  // Return false if x < 1 or x > (field_modulus - 1)
	  if (new sjcl.bn(1).greaterEquals(self.x) && !self.x.equals(1) || self.x.greaterEquals(field_modulus.sub(1)) && !self.x.equals(1)) {

	    return false;
	  }

	  // Return false if y < 1 or y > (field_modulus - 1)
	  if (new sjcl.bn(1).greaterEquals(self.y) && !self.y.equals(1) || self.y.greaterEquals(field_modulus.sub(1)) && !self.y.equals(1)) {

	    return false;
	  }

	  if (!self.isOnCurve()) {
	    return false;
	  }

	  // TODO check to make sure point is a scalar multiple of base_point

	  return true;
	};

	/**
	 *  Check that the point is on the curve
	 *
	 *  @returns {Boolean} true if point is on the curve
	 */
	sjcl.ecc.point.prototype.isOnCurve = function () {

	  var self = this;

	  var component_a = self.curve.a;
	  var component_b = self.curve.b;
	  var field_modulus = self.curve.field.modulus;

	  var left_hand_side = self.y.mul(self.y).mod(field_modulus);
	  var right_hand_side = self.x.mul(self.x).mul(self.x).add(component_a.mul(self.x)).add(component_b).mod(field_modulus);

	  return left_hand_side.equals(right_hand_side);
	};

	sjcl.ecc.point.prototype.toString = function () {
	  return '(' + this.x.toString() + ', ' + this.y.toString() + ')';
	};

	sjcl.ecc.pointJac.prototype.toString = function () {
	  return '(' + this.x.toString() + ', ' + this.y.toString() + ', ' + this.z.toString() + ')';
	};

/***/ },
/* 56 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint new-cap: [2, {newIsCapExceptions: ["pointJac"]}] */
	'use strict';
	var sjcl = __webpack_require__(52);

	// ----- for secp256k1 ------

	sjcl.ecc.point.prototype.toBytesCompressed = function () {
	  var header = this.y.mod(2).toString() === '0x0' ? 0x02 : 0x03;
	  return [header].concat(sjcl.codec.bytes.fromBits(this.x.toBits()));
	};

	// Replace point addition and doubling algorithms
	// NIST-P256 is a=-3, we need algorithms for a=0
	//
	// This is a custom point addition formula that
	// only works for a=-3 Jacobian curve. It's much
	// faster than the generic implementation
	sjcl.ecc.pointJac.prototype.add = function (T) {
	  var self = this;
	  if (self.curve !== T.curve) {
	    throw 'sjcl.ecc.add(): Points must be on the same curve to add them!';
	  }

	  if (self.isIdentity) {
	    return T.toJac();
	  } else if (T.isIdentity) {
	    return self;
	  }

	  var z1z1 = self.z.square();
	  var h = T.x.mul(z1z1).subM(self.x);
	  var s2 = T.y.mul(self.z).mul(z1z1);

	  if (h.equals(0)) {
	    if (self.y.equals(T.y.mul(z1z1.mul(self.z)))) {
	      // same point
	      return self.doubl();
	    }
	    // inverses
	    return new sjcl.ecc.pointJac(self.curve);
	  }

	  var hh = h.square();
	  var i = hh.copy().doubleM().doubleM();
	  var j = h.mul(i);
	  var r = s2.sub(self.y).doubleM();
	  var v = self.x.mul(i);

	  var x = r.square().subM(j).subM(v.copy().doubleM());
	  var y = r.mul(v.sub(x)).subM(self.y.mul(j).doubleM());
	  var z = self.z.add(h).square().subM(z1z1).subM(hh);

	  return new sjcl.ecc.pointJac(this.curve, x, y, z);
	};

	// This is a custom doubling algorithm that
	// only works for a=-3 Jacobian curve. It's much
	// faster than the generic implementation
	sjcl.ecc.pointJac.prototype.doubl = function () {
	  if (this.isIdentity) {
	    return this;
	  }

	  var a = this.x.square();
	  var b = this.y.square();
	  var c = b.square();
	  var d = this.x.add(b).square().subM(a).subM(c).doubleM();
	  var e = a.mul(3);
	  var f = e.square();
	  var x = f.sub(d.copy().doubleM());
	  var y = e.mul(d.sub(x)).subM(c.doubleM().doubleM().doubleM());
	  var z = this.z.mul(this.y).doubleM();
	  return new sjcl.ecc.pointJac(this.curve, x, y, z);
	};

	// DEPRECATED:
	// previously the c256 curve was overridden with the secp256k1 curve
	// since then, sjcl has been updated to support k256
	// this override exist to keep supporting the old c256 with k256 behavior
	// this will be removed in future release
	sjcl.ecc.curves.c256 = sjcl.ecc.curves.k256;

/***/ },
/* 57 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint new-cap: [2, {newIsCapExceptions: ["bn"]}] */
	'use strict';
	var sjcl = __webpack_require__(52);

	sjcl.bn.ZERO = new sjcl.bn(0);

	/* [ this / that , this % that ] */
	sjcl.bn.prototype.divRem = function (that) {
	  if (typeof that !== 'object') {
	    that = new this._class(that);
	  }
	  var thisa = this.abs(),
	      thata = that.abs(),
	      quot = new this._class(0),
	      ci = 0;
	  if (!thisa.greaterEquals(thata)) {
	    return [new sjcl.bn(0), this.copy()];
	  } else if (thisa.equals(thata)) {
	    return [new sjcl.bn(1), new sjcl.bn(0)];
	  }

	  for (; thisa.greaterEquals(thata); ci++) {
	    thata.doubleM();
	  }
	  for (; ci > 0; ci--) {
	    quot.doubleM();
	    thata.halveM();
	    if (thisa.greaterEquals(thata)) {
	      quot.addM(1);
	      thisa.subM(that).normalize();
	    }
	  }
	  return [quot, thisa];
	};

	/* this /= that (rounded to nearest int) */
	sjcl.bn.prototype.divRound = function (that) {
	  var dr = this.divRem(that),
	      quot = dr[0],
	      rem = dr[1];

	  if (rem.doubleM().greaterEquals(that)) {
	    quot.addM(1);
	  }

	  return quot;
	};

	/* this /= that (rounded down) */
	sjcl.bn.prototype.div = function (that) {
	  var dr = this.divRem(that);
	  return dr[0];
	};

	sjcl.bn.prototype.sign = function () {
	  return this.greaterEquals(sjcl.bn.ZERO) ? 1 : -1;
	};

	/* -this */
	sjcl.bn.prototype.neg = function () {
	  return sjcl.bn.ZERO.sub(this);
	};

	/* |this| */
	sjcl.bn.prototype.abs = function () {
	  if (this.sign() === -1) {
	    return this.neg();
	  }
	  return this;
	};

	/* this >> that */
	sjcl.bn.prototype.shiftRight = function (that) {
	  if (typeof that !== 'number') {
	    throw new Error('shiftRight expects a number');
	  }

	  that = +that;

	  if (that < 0) {
	    return this.shiftLeft(that);
	  }

	  var a = new sjcl.bn(this);

	  while (that >= this.radix) {
	    a.limbs.shift();
	    that -= this.radix;
	  }

	  while (that--) {
	    a.halveM();
	  }

	  return a;
	};

	/* this >> that */
	sjcl.bn.prototype.shiftLeft = function (that) {
	  if (typeof that !== 'number') {
	    throw new Error('shiftLeft expects a number');
	  }

	  that = +that;

	  if (that < 0) {
	    return this.shiftRight(that);
	  }

	  var a = new sjcl.bn(this);

	  while (that >= this.radix) {
	    a.limbs.unshift(0);
	    that -= this.radix;
	  }

	  while (that--) {
	    a.doubleM();
	  }

	  return a;
	};

	/* (int)this */
	// NOTE Truncates to 32-bit integer
	sjcl.bn.prototype.toNumber = function () {
	  return this.limbs[0] | 0;
	};

	/* find n-th bit, 0 = LSB */
	sjcl.bn.prototype.testBit = function (bitIndex) {
	  var limbIndex = Math.floor(bitIndex / this.radix);
	  var bitIndexInLimb = bitIndex % this.radix;

	  if (limbIndex >= this.limbs.length) {
	    return 0;
	  }

	  return this.limbs[limbIndex] >>> bitIndexInLimb & 1;
	};

	/* set n-th bit, 0 = LSB */
	sjcl.bn.prototype.setBitM = function (bitIndex) {
	  var limbIndex = Math.floor(bitIndex / this.radix);
	  var bitIndexInLimb = bitIndex % this.radix;

	  while (limbIndex >= this.limbs.length) {
	    this.limbs.push(0);
	  }

	  this.limbs[limbIndex] |= 1 << bitIndexInLimb;

	  this.cnormalize();

	  return this;
	};

	sjcl.bn.prototype.modInt = function (n) {
	  return this.toNumber() % n;
	};

/***/ },
/* 58 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint new-cap: [2, {newIsCapExceptions: ["corrupt"]}] */
	'use strict';
	var sjcl = __webpack_require__(52);

	sjcl.ecc.ecdsa.secretKey.prototype.sign = function (hash, paranoia, k_for_testing) {
	  var R = this._curve.r,
	      l = R.bitLength();

	  // k_for_testing should ONLY BE SPECIFIED FOR TESTING
	  // specifying it will make the signature INSECURE
	  var k;
	  if (typeof k_for_testing === 'object' && k_for_testing.length > 0 && typeof k_for_testing[0] === 'number') {
	    k = k_for_testing;
	  } else if (typeof k_for_testing === 'string' && /^[0-9a-fA-F]+$/.test(k_for_testing)) {
	    k = sjcl.bn.fromBits(sjcl.codec.hex.toBits(k_for_testing));
	  } else {
	    // This is the only option that should be used in production
	    k = sjcl.bn.random(R.sub(1), paranoia).add(1);
	  }

	  var r = this._curve.G.mult(k).x.mod(R);
	  var s = sjcl.bn.fromBits(hash).add(r.mul(this._exponent)).mul(k.inverseMod(R)).mod(R);

	  return sjcl.bitArray.concat(r.toBits(l), s.toBits(l));
	};

	sjcl.ecc.ecdsa.publicKey.prototype.verify = function (hash, rs) {
	  var w = sjcl.bitArray;
	  var R = this._curve.r;
	  var l = R.bitLength();
	  var r = sjcl.bn.fromBits(w.bitSlice(rs, 0, l));
	  var s = sjcl.bn.fromBits(w.bitSlice(rs, l, 2 * l));
	  var sInv = s.inverseMod(R);
	  var hG = sjcl.bn.fromBits(hash).mul(sInv).mod(R);
	  var hA = r.mul(sInv).mod(R);
	  var r2 = this._curve.G.mult2(hG, hA, this._point).x;

	  if (r.equals(0) || s.equals(0) || r.greaterEquals(R) || s.greaterEquals(R) || !r2.equals(r)) {
	    throw new sjcl.exception.corrupt('signature didn\'t check out');
	  }
	  return true;
	};

/***/ },
/* 59 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var sjcl = __webpack_require__(52);

	sjcl.ecc.ecdsa.secretKey.prototype.canonicalizeSignature = function (rs) {
	    var w = sjcl.bitArray,
	        R = this._curve.r,
	        l = R.bitLength();

	    var r = sjcl.bn.fromBits(w.bitSlice(rs, 0, l)),
	        s = sjcl.bn.fromBits(w.bitSlice(rs, l, 2 * l));

	    // For a canonical signature we want the lower of two possible values for s
	    // 0 < s <= n/2
	    if (!R.copy().halveM().greaterEquals(s)) {
	        s = R.sub(s);
	    }

	    return w.concat(r.toBits(l), s.toBits(l));
	};

/***/ },
/* 60 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var sjcl = __webpack_require__(52);

	sjcl.ecc.ecdsa.secretKey.prototype.signDER = function (hash, paranoia) {
	  return this.encodeDER(this.sign(hash, paranoia));
	};

	sjcl.ecc.ecdsa.secretKey.prototype.encodeDER = function (rs) {
	  var w = sjcl.bitArray,
	      R = this._curve.r,
	      l = R.bitLength();

	  var rb = sjcl.codec.bytes.fromBits(w.bitSlice(rs, 0, l)),
	      sb = sjcl.codec.bytes.fromBits(w.bitSlice(rs, l, 2 * l));

	  // Drop empty leading bytes
	  while (!rb[0] && rb.length) {
	    rb.shift();
	  }
	  while (!sb[0] && sb.length) {
	    sb.shift();
	  }

	  // If high bit is set, prepend an extra zero byte (DER signed integer)
	  if (rb[0] & 0x80) {
	    rb.unshift(0);
	  }
	  if (sb[0] & 0x80) {
	    sb.unshift(0);
	  }

	  var buffer = [].concat(0x30, 4 + rb.length + sb.length, 0x02, rb.length, rb, 0x02, sb.length, sb);

	  return sjcl.codec.bytes.toBits(buffer);
	};

/***/ },
/* 61 */
/***/ function(module, exports, __webpack_require__) {

	/* eslint-disable valid-jsdoc */
	/* eslint new-cap: [2, {newIsCapExceptions: [
	    "bn", "invalid", "point", "corrupt", "bug", "publicKey"]}] */
	'use strict';
	var sjcl = __webpack_require__(52);

	/**
	 *  This module uses the public key recovery method
	 *  described in SEC 1: Elliptic Curve Cryptography,
	 *  section 4.1.6, "Public Key Recovery Operation".
	 *  http://www.secg.org/download/aid-780/sec1-v2.pdf
	 *
	 *  Implementation based on:
	 *  https://github.com/bitcoinjs/bitcoinjs-lib/blob/
	 *    89cf731ac7309b4f98994e3b4b67b7226020181f/src/ecdsa.js
	 */

	// Defined here so that this value only needs to be calculated once
	var FIELD_MODULUS_PLUS_ONE_DIVIDED_BY_FOUR = undefined;

	/**
	 *  Retrieve the r and s components of a signature
	 *
	 *  @param {sjcl.ecc.curve} curve - curve
	 *  @param {bitArray} signature - signature
	 *  @returns {Object} Object with 'r' and 's' fields each as an sjcl.bn
	 */
	function getRandSFromSignature(curve, signature) {

	  var r_length = curve.r.bitLength();

	  return {
	    r: sjcl.bn.fromBits(sjcl.bitArray.bitSlice(signature, 0, r_length)),
	    s: sjcl.bn.fromBits(sjcl.bitArray.bitSlice(signature, r_length, sjcl.bitArray.bitLength(signature)))
	  };
	}

	/**
	 *  Verify a signature given the raw components
	 *  using method defined in section 4.1.5:
	 *  "Alternative Verifying Operation"
	 *
	 *  @param {sjcl.ecc.curve} curve
	 *  @param {sjcl.bn} e
	 *  @param {sjcl.bn} r
	 *  @param {sjcl.bn} s
	 *  @param {sjcl.ecc.point} public_key_point
	 *  @returns {Boolean}
	 */
	function verify_raw(curve, e, r, s, public_key_point) {

	  var field_order = curve.r;

	  // Return false if r is out of bounds
	  if (new sjcl.bn(1).greaterEquals(r) || r.greaterEquals(new sjcl.bn(field_order))) {
	    return false;
	  }

	  // Return false if s is out of bounds
	  if (new sjcl.bn(1).greaterEquals(s) || s.greaterEquals(new sjcl.bn(field_order))) {
	    return false;
	  }

	  // Check that r = (u1 + u2)G
	  // u1 = e x s^-1 (mod field_order)
	  // u2 = r x s^-1 (mod field_order)
	  var s_mod_inverse_field_order = s.inverseMod(field_order);
	  var u1 = e.mul(s_mod_inverse_field_order).mod(field_order);
	  var u2 = r.mul(s_mod_inverse_field_order).mod(field_order);

	  var point_computed = curve.G.mult2(u1, u2, public_key_point);

	  return r.equals(point_computed.x.mod(field_order));
	}

	/**
	 *  Recover the public key from the signature.
	 *
	 *  @param {sjcl.ecc.curve} curve
	 *  @param {sjcl.bn} r
	 *  @param {sjcl.bn} s
	 *  @param {bitArray} hash_bits
	 *  @param {Number, 0-3} recovery_factor
	 *  @returns {sjcl.point} Public key corresponding to signature
	 */
	function recoverPublicKeyPointFromSignature(curve, signature_r, signature_s, hash_bits, recovery_factor) {

	  var field_order = curve.r;
	  var field_modulus = curve.field.modulus;

	  // The less significant bit specifies whether the y coordinate
	  // of the compressed point is even or not.
	  var compressed_point_y_coord_is_even = recovery_factor & 1;

	  // The more significant bit specifies whether we should use the
	  // first or second candidate key.
	  var use_second_candidate_key = (recovery_factor & 2) >> 1;

	  // Calculate (field_order + 1) / 4
	  if (!FIELD_MODULUS_PLUS_ONE_DIVIDED_BY_FOUR) {
	    FIELD_MODULUS_PLUS_ONE_DIVIDED_BY_FOUR = field_modulus.add(1).div(4);
	  }

	  // In the paper they write "1. For j from 0 to h do the following..."
	  // That is not necessary here because we are given the recovery_factor
	  // step 1.1 Let x = r + jn
	  // Here "j" is either 0 or 1
	  var x = undefined;
	  if (use_second_candidate_key) {
	    x = signature_r.add(field_order);
	  } else {
	    x = signature_r;
	  }

	  // step 1.2 and 1.3  convert x to an elliptic curve point
	  // Following formula in section 2.3.4 Octet-String-to-Elliptic-Curve-Point
	  // Conversion
	  var alpha = x.mul(x).mul(x).add(curve.a.mul(x)).add(curve.b).mod(field_modulus);
	  var beta = alpha.powermod(FIELD_MODULUS_PLUS_ONE_DIVIDED_BY_FOUR, field_modulus);

	  // If beta is even but y isn't or
	  // if beta is odd and y is even
	  // then subtract beta from the field_modulus
	  var y = undefined;
	  var beta_is_even = beta.mod(2).equals(0);
	  if (beta_is_even && !compressed_point_y_coord_is_even || !beta_is_even && compressed_point_y_coord_is_even) {
	    y = beta;
	  } else {
	    y = field_modulus.sub(beta);
	  }

	  // generated_point_R is the point generated from x and y
	  var generated_point_R = new sjcl.ecc.point(curve, x, y);

	  // step 1.4  check that R is valid and R x field_order !== infinity
	  // TODO: add check for R x field_order === infinity
	  if (!generated_point_R.isValidPoint()) {
	    throw new sjcl.exception.corrupt('point R. Not a valid point on the curve. Cannot recover public key');
	  }

	  // step 1.5  Compute e from M
	  var message_e = sjcl.bn.fromBits(hash_bits);
	  var message_e_neg = new sjcl.bn(0).sub(message_e).mod(field_order);

	  // step 1.6  Compute Q = r^-1 (sR - eG)
	  // console.log('r: ', signature_r);
	  var signature_r_inv = signature_r.inverseMod(field_order);
	  var public_key_point = generated_point_R.mult2(signature_s, message_e_neg, curve.G).mult(signature_r_inv);

	  // Validate public key point
	  if (!public_key_point.isValidPoint()) {
	    throw new sjcl.exception.corrupt('public_key_point. Not a valid point' + ' on the curve. Cannot recover public key');
	  }

	  // Verify that this public key matches the signature
	  if (!verify_raw(curve, message_e, signature_r, signature_s, public_key_point)) {
	    throw new sjcl.exception.corrupt('cannot recover public key');
	  }

	  return public_key_point;
	}

	/**
	 *  Determine the recovery factor by trying all four
	 *  possibilities and figuring out which results in the
	 *  correct public key
	 *
	 *  @param {sjcl.ecc.curve} curve
	 *  @param {sjcl.bn} r
	 *  @param {sjcl.bn} s
	 *  @param {bitArray} hash_bits
	 *  @param {sjcl.ecc.point} original_public_key_point
	 *  @returns {Number, 0-3} Recovery factor
	 */
	function calculateRecoveryFactor(curve, r, s, hash_bits, original_public_key_point) {

	  var original_public_key_point_bits = original_public_key_point.toBits();

	  // TODO: verify that it is possible for the recovery_factor to be 2 or 3,
	  // we may only need 1 bit because the canonical signature might remove the
	  // possibility of us needing to "use the second candidate key"
	  for (var possible_factor = 0; possible_factor < 4; possible_factor++) {

	    var resulting_public_key_point = undefined;
	    try {
	      resulting_public_key_point = recoverPublicKeyPointFromSignature(curve, r, s, hash_bits, possible_factor);
	    } catch (err) {
	      // console.log(err, err.stack);
	      continue;
	    }

	    if (sjcl.bitArray.equal(resulting_public_key_point.toBits(), original_public_key_point_bits)) {
	      return possible_factor;
	    }
	  }

	  throw new sjcl.exception.bug('unable to calculate recovery factor from signature');
	}

	/**
	 *  Sign the given hash such that the public key, prepending an extra byte
	 *  so that the public key will be recoverable from the signature
	 *
	 *  @param {bitArray} hash - hash to sign
	 *  @param {Number} paranoia - minimum entropy required
	 *  @param {Number} k_for_testing - fixed k value to bypass PRNG
	 *  @returns {bitArray} Signature formatted as bitArray
	 */
	sjcl.ecc.ecdsa.secretKey.prototype.signWithRecoverablePublicKey = function (hash, paranoia, k_for_testing) {

	  var self = this;

	  // Convert hash to bits and determine encoding for output
	  var hash_bits = undefined;
	  if (typeof hash === 'object' && hash.length > 0 && typeof hash[0] === 'number') {
	    hash_bits = hash;
	  } else {
	    throw new sjcl.exception.invalid('hash. Must be a bitArray');
	  }

	  // Sign hash with standard, canonicalized method
	  var standard_signature = self.sign(hash_bits, paranoia, k_for_testing);
	  var canonical_signature = self.canonicalizeSignature(standard_signature);

	  // Extract r and s signature components from canonical signature
	  var r_and_s = getRandSFromSignature(self._curve, canonical_signature);

	  // Rederive public key
	  var public_key = self._curve.G.mult(sjcl.bn.fromBits(self.get()));

	  // Determine recovery factor based on which possible value
	  // returns the correct public key
	  var recovery_factor = calculateRecoveryFactor(self._curve, r_and_s.r, r_and_s.s, hash_bits, public_key);

	  // Prepend recovery_factor to signature and encode in DER
	  // The value_to_prepend should be 4 bytes total
	  var value_to_prepend = recovery_factor + 27;

	  var final_signature_bits = sjcl.bitArray.concat([value_to_prepend], canonical_signature);

	  // Return value in bits
	  return final_signature_bits;
	};

	/**
	 *  Recover the public key from a signature created with the
	 *  signWithRecoverablePublicKey method in this module
	 *
	 *  @static
	 *
	 *  @param {bitArray} hash
	 *  @param {bitArray} signature
	 *  @param {sjcl.ecc.curve} [curve=sjcl.ecc.curves['k256']]
	 *  @returns {sjcl.ecc.ecdsa.publicKey} Public key
	 */
	sjcl.ecc.ecdsa.publicKey.recoverFromSignature = function (hash, signature) {
	  var curve = arguments.length <= 2 || arguments[2] === undefined ? sjcl.ecc.curves.k256 : arguments[2];

	  if (!signature || signature instanceof sjcl.ecc.curve) {
	    throw new sjcl.exception.invalid('must supply hash and signature to recover public key');
	  }

	  // Convert hash to bits and determine encoding for output
	  var hash_bits = undefined;
	  if (typeof hash === 'object' && hash.length > 0 && typeof hash[0] === 'number') {
	    hash_bits = hash;
	  } else {
	    throw new sjcl.exception.invalid('hash. Must be a bitArray');
	  }

	  var signature_bits = undefined;
	  if (typeof signature === 'object' && signature.length > 0 && typeof signature[0] === 'number') {
	    signature_bits = signature;
	  } else {
	    throw new sjcl.exception.invalid('signature. Must be a bitArray');
	  }

	  // Extract recovery_factor from first 4 bytes
	  var recovery_factor = signature_bits[0] - 27;

	  if (recovery_factor < 0 || recovery_factor > 3) {
	    throw new sjcl.exception.invalid('signature. Signature must be generated with algorithm ' + 'that prepends the recovery factor in order to recover the public key');
	  }

	  // Separate r and s values
	  var r_and_s = getRandSFromSignature(curve, signature_bits.slice(1));
	  var signature_r = r_and_s.r;
	  var signature_s = r_and_s.s;

	  // Recover public key using recovery_factor
	  var recovered_public_key_point = recoverPublicKeyPointFromSignature(curve, signature_r, signature_s, hash_bits, recovery_factor);
	  var recovered_public_key = new sjcl.ecc.ecdsa.publicKey(curve, recovered_public_key_point);

	  return recovered_public_key;
	};

/***/ },
/* 62 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function isBuffer(arg) {
	  return arg && typeof arg === 'object'
	    && typeof arg.copy === 'function'
	    && typeof arg.fill === 'function'
	    && typeof arg.readUInt8 === 'function';
	}

/***/ },
/* 63 */
/***/ function(module, exports, __webpack_require__) {

	// shim for using process in browser

	var process = module.exports = {};
	var queue = [];
	var draining = false;

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    draining = true;
	    var currentQueue;
	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        var i = -1;
	        while (++i < len) {
	            currentQueue[i]();
	        }
	        len = queue.length;
	    }
	    draining = false;
	}
	process.nextTick = function (fun) {
	    queue.push(fun);
	    if (!draining) {
	        setTimeout(drainQueue, 0);
	    }
	};

	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	// TODO(shtylman)
	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 64 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/* WEBPACK VAR INJECTION */(function(module, global) {/*! https://mths.be/punycode v1.3.2 by @mathias */
	;(function(root) {

		/** Detect free variables */
		var freeExports = typeof exports == 'object' && exports &&
			!exports.nodeType && exports;
		var freeModule = typeof module == 'object' && module &&
			!module.nodeType && module;
		var freeGlobal = typeof global == 'object' && global;
		if (
			freeGlobal.global === freeGlobal ||
			freeGlobal.window === freeGlobal ||
			freeGlobal.self === freeGlobal
		) {
			root = freeGlobal;
		}

		/**
		 * The `punycode` object.
		 * @name punycode
		 * @type Object
		 */
		var punycode,

		/** Highest positive signed 32-bit float value */
		maxInt = 2147483647, // aka. 0x7FFFFFFF or 2^31-1

		/** Bootstring parameters */
		base = 36,
		tMin = 1,
		tMax = 26,
		skew = 38,
		damp = 700,
		initialBias = 72,
		initialN = 128, // 0x80
		delimiter = '-', // '\x2D'

		/** Regular expressions */
		regexPunycode = /^xn--/,
		regexNonASCII = /[^\x20-\x7E]/, // unprintable ASCII chars + non-ASCII chars
		regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g, // RFC 3490 separators

		/** Error messages */
		errors = {
			'overflow': 'Overflow: input needs wider integers to process',
			'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
			'invalid-input': 'Invalid input'
		},

		/** Convenience shortcuts */
		baseMinusTMin = base - tMin,
		floor = Math.floor,
		stringFromCharCode = String.fromCharCode,

		/** Temporary variable */
		key;

		/*--------------------------------------------------------------------------*/

		/**
		 * A generic error utility function.
		 * @private
		 * @param {String} type The error type.
		 * @returns {Error} Throws a `RangeError` with the applicable error message.
		 */
		function error(type) {
			throw RangeError(errors[type]);
		}

		/**
		 * A generic `Array#map` utility function.
		 * @private
		 * @param {Array} array The array to iterate over.
		 * @param {Function} callback The function that gets called for every array
		 * item.
		 * @returns {Array} A new array of values returned by the callback function.
		 */
		function map(array, fn) {
			var length = array.length;
			var result = [];
			while (length--) {
				result[length] = fn(array[length]);
			}
			return result;
		}

		/**
		 * A simple `Array#map`-like wrapper to work with domain name strings or email
		 * addresses.
		 * @private
		 * @param {String} domain The domain name or email address.
		 * @param {Function} callback The function that gets called for every
		 * character.
		 * @returns {Array} A new string of characters returned by the callback
		 * function.
		 */
		function mapDomain(string, fn) {
			var parts = string.split('@');
			var result = '';
			if (parts.length > 1) {
				// In email addresses, only the domain name should be punycoded. Leave
				// the local part (i.e. everything up to `@`) intact.
				result = parts[0] + '@';
				string = parts[1];
			}
			// Avoid `split(regex)` for IE8 compatibility. See #17.
			string = string.replace(regexSeparators, '\x2E');
			var labels = string.split('.');
			var encoded = map(labels, fn).join('.');
			return result + encoded;
		}

		/**
		 * Creates an array containing the numeric code points of each Unicode
		 * character in the string. While JavaScript uses UCS-2 internally,
		 * this function will convert a pair of surrogate halves (each of which
		 * UCS-2 exposes as separate characters) into a single code point,
		 * matching UTF-16.
		 * @see `punycode.ucs2.encode`
		 * @see <https://mathiasbynens.be/notes/javascript-encoding>
		 * @memberOf punycode.ucs2
		 * @name decode
		 * @param {String} string The Unicode input string (UCS-2).
		 * @returns {Array} The new array of code points.
		 */
		function ucs2decode(string) {
			var output = [],
			    counter = 0,
			    length = string.length,
			    value,
			    extra;
			while (counter < length) {
				value = string.charCodeAt(counter++);
				if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
					// high surrogate, and there is a next character
					extra = string.charCodeAt(counter++);
					if ((extra & 0xFC00) == 0xDC00) { // low surrogate
						output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
					} else {
						// unmatched surrogate; only append this code unit, in case the next
						// code unit is the high surrogate of a surrogate pair
						output.push(value);
						counter--;
					}
				} else {
					output.push(value);
				}
			}
			return output;
		}

		/**
		 * Creates a string based on an array of numeric code points.
		 * @see `punycode.ucs2.decode`
		 * @memberOf punycode.ucs2
		 * @name encode
		 * @param {Array} codePoints The array of numeric code points.
		 * @returns {String} The new Unicode string (UCS-2).
		 */
		function ucs2encode(array) {
			return map(array, function(value) {
				var output = '';
				if (value > 0xFFFF) {
					value -= 0x10000;
					output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
					value = 0xDC00 | value & 0x3FF;
				}
				output += stringFromCharCode(value);
				return output;
			}).join('');
		}

		/**
		 * Converts a basic code point into a digit/integer.
		 * @see `digitToBasic()`
		 * @private
		 * @param {Number} codePoint The basic numeric code point value.
		 * @returns {Number} The numeric value of a basic code point (for use in
		 * representing integers) in the range `0` to `base - 1`, or `base` if
		 * the code point does not represent a value.
		 */
		function basicToDigit(codePoint) {
			if (codePoint - 48 < 10) {
				return codePoint - 22;
			}
			if (codePoint - 65 < 26) {
				return codePoint - 65;
			}
			if (codePoint - 97 < 26) {
				return codePoint - 97;
			}
			return base;
		}

		/**
		 * Converts a digit/integer into a basic code point.
		 * @see `basicToDigit()`
		 * @private
		 * @param {Number} digit The numeric value of a basic code point.
		 * @returns {Number} The basic code point whose value (when used for
		 * representing integers) is `digit`, which needs to be in the range
		 * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
		 * used; else, the lowercase form is used. The behavior is undefined
		 * if `flag` is non-zero and `digit` has no uppercase form.
		 */
		function digitToBasic(digit, flag) {
			//  0..25 map to ASCII a..z or A..Z
			// 26..35 map to ASCII 0..9
			return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
		}

		/**
		 * Bias adaptation function as per section 3.4 of RFC 3492.
		 * http://tools.ietf.org/html/rfc3492#section-3.4
		 * @private
		 */
		function adapt(delta, numPoints, firstTime) {
			var k = 0;
			delta = firstTime ? floor(delta / damp) : delta >> 1;
			delta += floor(delta / numPoints);
			for (/* no initialization */; delta > baseMinusTMin * tMax >> 1; k += base) {
				delta = floor(delta / baseMinusTMin);
			}
			return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
		}

		/**
		 * Converts a Punycode string of ASCII-only symbols to a string of Unicode
		 * symbols.
		 * @memberOf punycode
		 * @param {String} input The Punycode string of ASCII-only symbols.
		 * @returns {String} The resulting string of Unicode symbols.
		 */
		function decode(input) {
			// Don't use UCS-2
			var output = [],
			    inputLength = input.length,
			    out,
			    i = 0,
			    n = initialN,
			    bias = initialBias,
			    basic,
			    j,
			    index,
			    oldi,
			    w,
			    k,
			    digit,
			    t,
			    /** Cached calculation results */
			    baseMinusT;

			// Handle the basic code points: let `basic` be the number of input code
			// points before the last delimiter, or `0` if there is none, then copy
			// the first basic code points to the output.

			basic = input.lastIndexOf(delimiter);
			if (basic < 0) {
				basic = 0;
			}

			for (j = 0; j < basic; ++j) {
				// if it's not a basic code point
				if (input.charCodeAt(j) >= 0x80) {
					error('not-basic');
				}
				output.push(input.charCodeAt(j));
			}

			// Main decoding loop: start just after the last delimiter if any basic code
			// points were copied; start at the beginning otherwise.

			for (index = basic > 0 ? basic + 1 : 0; index < inputLength; /* no final expression */) {

				// `index` is the index of the next character to be consumed.
				// Decode a generalized variable-length integer into `delta`,
				// which gets added to `i`. The overflow checking is easier
				// if we increase `i` as we go, then subtract off its starting
				// value at the end to obtain `delta`.
				for (oldi = i, w = 1, k = base; /* no condition */; k += base) {

					if (index >= inputLength) {
						error('invalid-input');
					}

					digit = basicToDigit(input.charCodeAt(index++));

					if (digit >= base || digit > floor((maxInt - i) / w)) {
						error('overflow');
					}

					i += digit * w;
					t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);

					if (digit < t) {
						break;
					}

					baseMinusT = base - t;
					if (w > floor(maxInt / baseMinusT)) {
						error('overflow');
					}

					w *= baseMinusT;

				}

				out = output.length + 1;
				bias = adapt(i - oldi, out, oldi == 0);

				// `i` was supposed to wrap around from `out` to `0`,
				// incrementing `n` each time, so we'll fix that now:
				if (floor(i / out) > maxInt - n) {
					error('overflow');
				}

				n += floor(i / out);
				i %= out;

				// Insert `n` at position `i` of the output
				output.splice(i++, 0, n);

			}

			return ucs2encode(output);
		}

		/**
		 * Converts a string of Unicode symbols (e.g. a domain name label) to a
		 * Punycode string of ASCII-only symbols.
		 * @memberOf punycode
		 * @param {String} input The string of Unicode symbols.
		 * @returns {String} The resulting Punycode string of ASCII-only symbols.
		 */
		function encode(input) {
			var n,
			    delta,
			    handledCPCount,
			    basicLength,
			    bias,
			    j,
			    m,
			    q,
			    k,
			    t,
			    currentValue,
			    output = [],
			    /** `inputLength` will hold the number of code points in `input`. */
			    inputLength,
			    /** Cached calculation results */
			    handledCPCountPlusOne,
			    baseMinusT,
			    qMinusT;

			// Convert the input in UCS-2 to Unicode
			input = ucs2decode(input);

			// Cache the length
			inputLength = input.length;

			// Initialize the state
			n = initialN;
			delta = 0;
			bias = initialBias;

			// Handle the basic code points
			for (j = 0; j < inputLength; ++j) {
				currentValue = input[j];
				if (currentValue < 0x80) {
					output.push(stringFromCharCode(currentValue));
				}
			}

			handledCPCount = basicLength = output.length;

			// `handledCPCount` is the number of code points that have been handled;
			// `basicLength` is the number of basic code points.

			// Finish the basic string - if it is not empty - with a delimiter
			if (basicLength) {
				output.push(delimiter);
			}

			// Main encoding loop:
			while (handledCPCount < inputLength) {

				// All non-basic code points < n have been handled already. Find the next
				// larger one:
				for (m = maxInt, j = 0; j < inputLength; ++j) {
					currentValue = input[j];
					if (currentValue >= n && currentValue < m) {
						m = currentValue;
					}
				}

				// Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
				// but guard against overflow
				handledCPCountPlusOne = handledCPCount + 1;
				if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
					error('overflow');
				}

				delta += (m - n) * handledCPCountPlusOne;
				n = m;

				for (j = 0; j < inputLength; ++j) {
					currentValue = input[j];

					if (currentValue < n && ++delta > maxInt) {
						error('overflow');
					}

					if (currentValue == n) {
						// Represent delta as a generalized variable-length integer
						for (q = delta, k = base; /* no condition */; k += base) {
							t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
							if (q < t) {
								break;
							}
							qMinusT = q - t;
							baseMinusT = base - t;
							output.push(
								stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
							);
							q = floor(qMinusT / baseMinusT);
						}

						output.push(stringFromCharCode(digitToBasic(q, 0)));
						bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
						delta = 0;
						++handledCPCount;
					}
				}

				++delta;
				++n;

			}
			return output.join('');
		}

		/**
		 * Converts a Punycode string representing a domain name or an email address
		 * to Unicode. Only the Punycoded parts of the input will be converted, i.e.
		 * it doesn't matter if you call it on a string that has already been
		 * converted to Unicode.
		 * @memberOf punycode
		 * @param {String} input The Punycoded domain name or email address to
		 * convert to Unicode.
		 * @returns {String} The Unicode representation of the given Punycode
		 * string.
		 */
		function toUnicode(input) {
			return mapDomain(input, function(string) {
				return regexPunycode.test(string)
					? decode(string.slice(4).toLowerCase())
					: string;
			});
		}

		/**
		 * Converts a Unicode string representing a domain name or an email address to
		 * Punycode. Only the non-ASCII parts of the domain name will be converted,
		 * i.e. it doesn't matter if you call it with a domain that's already in
		 * ASCII.
		 * @memberOf punycode
		 * @param {String} input The domain name or email address to convert, as a
		 * Unicode string.
		 * @returns {String} The Punycode representation of the given domain name or
		 * email address.
		 */
		function toASCII(input) {
			return mapDomain(input, function(string) {
				return regexNonASCII.test(string)
					? 'xn--' + encode(string)
					: string;
			});
		}

		/*--------------------------------------------------------------------------*/

		/** Define the public API */
		punycode = {
			/**
			 * A string representing the current Punycode.js version number.
			 * @memberOf punycode
			 * @type String
			 */
			'version': '1.3.2',
			/**
			 * An object of methods to convert from JavaScript's internal character
			 * representation (UCS-2) to Unicode code points, and back.
			 * @see <https://mathiasbynens.be/notes/javascript-encoding>
			 * @memberOf punycode
			 * @type Object
			 */
			'ucs2': {
				'decode': ucs2decode,
				'encode': ucs2encode
			},
			'decode': decode,
			'encode': encode,
			'toASCII': toASCII,
			'toUnicode': toUnicode
		};

		/** Expose `punycode` */
		// Some AMD build optimizers, like r.js, check for specific condition patterns
		// like the following:
		if (
			true
		) {
			!(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
				return punycode;
			}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else if (freeExports && freeModule) {
			if (module.exports == freeExports) { // in Node.js or RingoJS v0.8.0+
				freeModule.exports = punycode;
			} else { // in Narwhal or RingoJS v0.7.0-
				for (key in punycode) {
					punycode.hasOwnProperty(key) && (freeExports[key] = punycode[key]);
				}
			}
		} else { // in Rhino or a web browser
			root.punycode = punycode;
		}

	}(this));
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(65)(module), (function() { return this; }())))

/***/ },
/* 65 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function(module) {
		if(!module.webpackPolyfill) {
			module.deprecate = function() {};
			module.paths = [];
			// module.parent = undefined by default
			module.children = [];
			module.webpackPolyfill = 1;
		}
		return module;
	}


/***/ },
/* 66 */
/***/ function(module, exports, __webpack_require__) {

	exports.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var nBits = -7
	  var i = isLE ? (nBytes - 1) : 0
	  var d = isLE ? -1 : 1
	  var s = buffer[offset + i]

	  i += d

	  e = s & ((1 << (-nBits)) - 1)
	  s >>= (-nBits)
	  nBits += eLen
	  for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1)
	  e >>= (-nBits)
	  nBits += mLen
	  for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen)
	    e = e - eBias
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	}

	exports.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c
	  var eLen = nBytes * 8 - mLen - 1
	  var eMax = (1 << eLen) - 1
	  var eBias = eMax >> 1
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0)
	  var i = isLE ? 0 : (nBytes - 1)
	  var d = isLE ? 1 : -1
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0

	  value = Math.abs(value)

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0
	    e = eMax
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2)
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--
	      c *= 2
	    }
	    if (e + eBias >= 1) {
	      value += rt / c
	    } else {
	      value += rt * Math.pow(2, 1 - eBias)
	    }
	    if (value * c >= 2) {
	      e++
	      c /= 2
	    }

	    if (e + eBias >= eMax) {
	      m = 0
	      e = eMax
	    } else if (e + eBias >= 1) {
	      m = (value * c - 1) * Math.pow(2, mLen)
	      e = e + eBias
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen)
	      e = 0
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m
	  eLen += mLen
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128
	}


/***/ },
/* 67 */
/***/ function(module, exports, __webpack_require__) {

	
	/**
	 * isArray
	 */

	var isArray = Array.isArray;

	/**
	 * toString
	 */

	var str = Object.prototype.toString;

	/**
	 * Whether or not the given `val`
	 * is an array.
	 *
	 * example:
	 *
	 *        isArray([]);
	 *        // > true
	 *        isArray(arguments);
	 *        // > false
	 *        isArray('');
	 *        // > false
	 *
	 * @param {mixed} val
	 * @return {bool}
	 */

	module.exports = isArray || function (val) {
	  return !! val && '[object Array]' == str.call(val);
	};


/***/ },
/* 68 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.decode = exports.parse = __webpack_require__(74);
	exports.encode = exports.stringify = __webpack_require__(75);


/***/ },
/* 69 */
/***/ function(module, exports, __webpack_require__) {

	__webpack_require__(76);
	module.exports = __webpack_require__(77).core.Object.keys;

/***/ },
/* 70 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var rng = __webpack_require__(78)

	function error () {
	  var m = [].slice.call(arguments).join(' ')
	  throw new Error([
	    m,
	    'we accept pull requests',
	    'http://github.com/dominictarr/crypto-browserify'
	    ].join('\n'))
	}

	exports.createHash = __webpack_require__(79)

	exports.createHmac = __webpack_require__(80)

	exports.randomBytes = function(size, callback) {
	  if (callback && callback.call) {
	    try {
	      callback.call(this, undefined, new Buffer(rng(size)))
	    } catch (err) { callback(err) }
	  } else {
	    return new Buffer(rng(size))
	  }
	}

	function each(a, f) {
	  for(var i in a)
	    f(a[i], i)
	}

	exports.getHashes = function () {
	  return ['sha1', 'sha256', 'sha512', 'md5', 'rmd160']
	}

	var p = __webpack_require__(81)(exports)
	exports.pbkdf2 = p.pbkdf2
	exports.pbkdf2Sync = p.pbkdf2Sync


	// the least I can do is make error messages for the rest of the node.js/crypto api.
	each(['createCredentials'
	, 'createCipher'
	, 'createCipheriv'
	, 'createDecipher'
	, 'createDecipheriv'
	, 'createSign'
	, 'createVerify'
	, 'createDiffieHellman'
	], function (name) {
	  exports[name] = function () {
	    error('sorry,', name, 'is not implemented yet')
	  }
	})
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 71 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(setImmediate, clearImmediate) {var nextTick = __webpack_require__(83).nextTick;
	var apply = Function.prototype.apply;
	var slice = Array.prototype.slice;
	var immediateIds = {};
	var nextImmediateId = 0;

	// DOM APIs, for completeness

	exports.setTimeout = function() {
	  return new Timeout(apply.call(setTimeout, window, arguments), clearTimeout);
	};
	exports.setInterval = function() {
	  return new Timeout(apply.call(setInterval, window, arguments), clearInterval);
	};
	exports.clearTimeout =
	exports.clearInterval = function(timeout) { timeout.close(); };

	function Timeout(id, clearFn) {
	  this._id = id;
	  this._clearFn = clearFn;
	}
	Timeout.prototype.unref = Timeout.prototype.ref = function() {};
	Timeout.prototype.close = function() {
	  this._clearFn.call(window, this._id);
	};

	// Does not start the time, just sets up the members needed.
	exports.enroll = function(item, msecs) {
	  clearTimeout(item._idleTimeoutId);
	  item._idleTimeout = msecs;
	};

	exports.unenroll = function(item) {
	  clearTimeout(item._idleTimeoutId);
	  item._idleTimeout = -1;
	};

	exports._unrefActive = exports.active = function(item) {
	  clearTimeout(item._idleTimeoutId);

	  var msecs = item._idleTimeout;
	  if (msecs >= 0) {
	    item._idleTimeoutId = setTimeout(function onTimeout() {
	      if (item._onTimeout)
	        item._onTimeout();
	    }, msecs);
	  }
	};

	// That's not how node.js implements it but the exposed api is the same.
	exports.setImmediate = typeof setImmediate === "function" ? setImmediate : function(fn) {
	  var id = nextImmediateId++;
	  var args = arguments.length < 2 ? false : slice.call(arguments, 1);

	  immediateIds[id] = true;

	  nextTick(function onNextTick() {
	    if (immediateIds[id]) {
	      // fn.call() is faster so we optimize for the common use-case
	      // @see http://jsperf.com/call-apply-segu
	      if (args) {
	        fn.apply(null, args);
	      } else {
	        fn.call(null);
	      }
	      // Prevent ids from leaking
	      exports.clearImmediate(id);
	    }
	  });

	  return id;
	};

	exports.clearImmediate = typeof clearImmediate === "function" ? clearImmediate : function(id) {
	  delete immediateIds[id];
	};
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(71).setImmediate, __webpack_require__(71).clearImmediate))

/***/ },
/* 72 */
/***/ function(module, exports, __webpack_require__) {

	if (typeof Object.create === 'function') {
	  // implementation from standard node.js 'util' module
	  module.exports = function inherits(ctor, superCtor) {
	    ctor.super_ = superCtor
	    ctor.prototype = Object.create(superCtor.prototype, {
	      constructor: {
	        value: ctor,
	        enumerable: false,
	        writable: true,
	        configurable: true
	      }
	    });
	  };
	} else {
	  // old school shim for old browsers
	  module.exports = function inherits(ctor, superCtor) {
	    ctor.super_ = superCtor
	    var TempCtor = function () {}
	    TempCtor.prototype = superCtor.prototype
	    ctor.prototype = new TempCtor()
	    ctor.prototype.constructor = ctor
	  }
	}


/***/ },
/* 73 */
/***/ function(module, exports, __webpack_require__) {

	var lookup = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

	;(function (exports) {
		'use strict';

	  var Arr = (typeof Uint8Array !== 'undefined')
	    ? Uint8Array
	    : Array

		var PLUS   = '+'.charCodeAt(0)
		var SLASH  = '/'.charCodeAt(0)
		var NUMBER = '0'.charCodeAt(0)
		var LOWER  = 'a'.charCodeAt(0)
		var UPPER  = 'A'.charCodeAt(0)
		var PLUS_URL_SAFE = '-'.charCodeAt(0)
		var SLASH_URL_SAFE = '_'.charCodeAt(0)

		function decode (elt) {
			var code = elt.charCodeAt(0)
			if (code === PLUS ||
			    code === PLUS_URL_SAFE)
				return 62 // '+'
			if (code === SLASH ||
			    code === SLASH_URL_SAFE)
				return 63 // '/'
			if (code < NUMBER)
				return -1 //no match
			if (code < NUMBER + 10)
				return code - NUMBER + 26 + 26
			if (code < UPPER + 26)
				return code - UPPER
			if (code < LOWER + 26)
				return code - LOWER + 26
		}

		function b64ToByteArray (b64) {
			var i, j, l, tmp, placeHolders, arr

			if (b64.length % 4 > 0) {
				throw new Error('Invalid string. Length must be a multiple of 4')
			}

			// the number of equal signs (place holders)
			// if there are two placeholders, than the two characters before it
			// represent one byte
			// if there is only one, then the three characters before it represent 2 bytes
			// this is just a cheap hack to not do indexOf twice
			var len = b64.length
			placeHolders = '=' === b64.charAt(len - 2) ? 2 : '=' === b64.charAt(len - 1) ? 1 : 0

			// base64 is 4/3 + up to two characters of the original data
			arr = new Arr(b64.length * 3 / 4 - placeHolders)

			// if there are placeholders, only get up to the last complete 4 chars
			l = placeHolders > 0 ? b64.length - 4 : b64.length

			var L = 0

			function push (v) {
				arr[L++] = v
			}

			for (i = 0, j = 0; i < l; i += 4, j += 3) {
				tmp = (decode(b64.charAt(i)) << 18) | (decode(b64.charAt(i + 1)) << 12) | (decode(b64.charAt(i + 2)) << 6) | decode(b64.charAt(i + 3))
				push((tmp & 0xFF0000) >> 16)
				push((tmp & 0xFF00) >> 8)
				push(tmp & 0xFF)
			}

			if (placeHolders === 2) {
				tmp = (decode(b64.charAt(i)) << 2) | (decode(b64.charAt(i + 1)) >> 4)
				push(tmp & 0xFF)
			} else if (placeHolders === 1) {
				tmp = (decode(b64.charAt(i)) << 10) | (decode(b64.charAt(i + 1)) << 4) | (decode(b64.charAt(i + 2)) >> 2)
				push((tmp >> 8) & 0xFF)
				push(tmp & 0xFF)
			}

			return arr
		}

		function uint8ToBase64 (uint8) {
			var i,
				extraBytes = uint8.length % 3, // if we have 1 byte left, pad 2 bytes
				output = "",
				temp, length

			function encode (num) {
				return lookup.charAt(num)
			}

			function tripletToBase64 (num) {
				return encode(num >> 18 & 0x3F) + encode(num >> 12 & 0x3F) + encode(num >> 6 & 0x3F) + encode(num & 0x3F)
			}

			// go through the array every three bytes, we'll deal with trailing stuff later
			for (i = 0, length = uint8.length - extraBytes; i < length; i += 3) {
				temp = (uint8[i] << 16) + (uint8[i + 1] << 8) + (uint8[i + 2])
				output += tripletToBase64(temp)
			}

			// pad the end with zeros, but make sure to not forget the extra bytes
			switch (extraBytes) {
				case 1:
					temp = uint8[uint8.length - 1]
					output += encode(temp >> 2)
					output += encode((temp << 4) & 0x3F)
					output += '=='
					break
				case 2:
					temp = (uint8[uint8.length - 2] << 8) + (uint8[uint8.length - 1])
					output += encode(temp >> 10)
					output += encode((temp >> 4) & 0x3F)
					output += encode((temp << 2) & 0x3F)
					output += '='
					break
			}

			return output
		}

		exports.toByteArray = b64ToByteArray
		exports.fromByteArray = uint8ToBase64
	}(false ? (this.base64js = {}) : exports))


/***/ },
/* 74 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	'use strict';

	// If obj.hasOwnProperty has been overridden, then calling
	// obj.hasOwnProperty(prop) will break.
	// See: https://github.com/joyent/node/issues/1707
	function hasOwnProperty(obj, prop) {
	  return Object.prototype.hasOwnProperty.call(obj, prop);
	}

	module.exports = function(qs, sep, eq, options) {
	  sep = sep || '&';
	  eq = eq || '=';
	  var obj = {};

	  if (typeof qs !== 'string' || qs.length === 0) {
	    return obj;
	  }

	  var regexp = /\+/g;
	  qs = qs.split(sep);

	  var maxKeys = 1000;
	  if (options && typeof options.maxKeys === 'number') {
	    maxKeys = options.maxKeys;
	  }

	  var len = qs.length;
	  // maxKeys <= 0 means that we should not limit keys count
	  if (maxKeys > 0 && len > maxKeys) {
	    len = maxKeys;
	  }

	  for (var i = 0; i < len; ++i) {
	    var x = qs[i].replace(regexp, '%20'),
	        idx = x.indexOf(eq),
	        kstr, vstr, k, v;

	    if (idx >= 0) {
	      kstr = x.substr(0, idx);
	      vstr = x.substr(idx + 1);
	    } else {
	      kstr = x;
	      vstr = '';
	    }

	    k = decodeURIComponent(kstr);
	    v = decodeURIComponent(vstr);

	    if (!hasOwnProperty(obj, k)) {
	      obj[k] = v;
	    } else if (Array.isArray(obj[k])) {
	      obj[k].push(v);
	    } else {
	      obj[k] = [obj[k], v];
	    }
	  }

	  return obj;
	};


/***/ },
/* 75 */
/***/ function(module, exports, __webpack_require__) {

	// Copyright Joyent, Inc. and other Node contributors.
	//
	// Permission is hereby granted, free of charge, to any person obtaining a
	// copy of this software and associated documentation files (the
	// "Software"), to deal in the Software without restriction, including
	// without limitation the rights to use, copy, modify, merge, publish,
	// distribute, sublicense, and/or sell copies of the Software, and to permit
	// persons to whom the Software is furnished to do so, subject to the
	// following conditions:
	//
	// The above copyright notice and this permission notice shall be included
	// in all copies or substantial portions of the Software.
	//
	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
	// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
	// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
	// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
	// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
	// USE OR OTHER DEALINGS IN THE SOFTWARE.

	'use strict';

	var stringifyPrimitive = function(v) {
	  switch (typeof v) {
	    case 'string':
	      return v;

	    case 'boolean':
	      return v ? 'true' : 'false';

	    case 'number':
	      return isFinite(v) ? v : '';

	    default:
	      return '';
	  }
	};

	module.exports = function(obj, sep, eq, name) {
	  sep = sep || '&';
	  eq = eq || '=';
	  if (obj === null) {
	    obj = undefined;
	  }

	  if (typeof obj === 'object') {
	    return Object.keys(obj).map(function(k) {
	      var ks = encodeURIComponent(stringifyPrimitive(k)) + eq;
	      if (Array.isArray(obj[k])) {
	        return obj[k].map(function(v) {
	          return ks + encodeURIComponent(stringifyPrimitive(v));
	        }).join(sep);
	      } else {
	        return ks + encodeURIComponent(stringifyPrimitive(obj[k]));
	      }
	    }).join(sep);

	  }

	  if (!name) return '';
	  return encodeURIComponent(stringifyPrimitive(name)) + eq +
	         encodeURIComponent(stringifyPrimitive(obj));
	};


/***/ },
/* 76 */
/***/ function(module, exports, __webpack_require__) {

	var $        = __webpack_require__(77)
	  , $def     = __webpack_require__(86)
	  , isObject = $.isObject
	  , toObject = $.toObject;
	$.each.call(('freeze,seal,preventExtensions,isFrozen,isSealed,isExtensible,' +
	  'getOwnPropertyDescriptor,getPrototypeOf,keys,getOwnPropertyNames').split(',')
	, function(KEY, ID){
	  var fn     = ($.core.Object || {})[KEY] || Object[KEY]
	    , forced = 0
	    , method = {};
	  method[KEY] = ID == 0 ? function freeze(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 1 ? function seal(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 2 ? function preventExtensions(it){
	    return isObject(it) ? fn(it) : it;
	  } : ID == 3 ? function isFrozen(it){
	    return isObject(it) ? fn(it) : true;
	  } : ID == 4 ? function isSealed(it){
	    return isObject(it) ? fn(it) : true;
	  } : ID == 5 ? function isExtensible(it){
	    return isObject(it) ? fn(it) : false;
	  } : ID == 6 ? function getOwnPropertyDescriptor(it, key){
	    return fn(toObject(it), key);
	  } : ID == 7 ? function getPrototypeOf(it){
	    return fn(Object($.assertDefined(it)));
	  } : ID == 8 ? function keys(it){
	    return fn(toObject(it));
	  } : __webpack_require__(87).get;
	  try {
	    fn('z');
	  } catch(e){
	    forced = 1;
	  }
	  $def($def.S + $def.F * forced, 'Object', method);
	});

/***/ },
/* 77 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	var global = typeof self != 'undefined' ? self : Function('return this')()
	  , core   = {}
	  , defineProperty = Object.defineProperty
	  , hasOwnProperty = {}.hasOwnProperty
	  , ceil  = Math.ceil
	  , floor = Math.floor
	  , max   = Math.max
	  , min   = Math.min;
	// The engine works fine with descriptors? Thank's IE8 for his funny defineProperty.
	var DESC = !!function(){
	  try {
	    return defineProperty({}, 'a', {get: function(){ return 2; }}).a == 2;
	  } catch(e){ /* empty */ }
	}();
	var hide = createDefiner(1);
	// 7.1.4 ToInteger
	function toInteger(it){
	  return isNaN(it = +it) ? 0 : (it > 0 ? floor : ceil)(it);
	}
	function desc(bitmap, value){
	  return {
	    enumerable  : !(bitmap & 1),
	    configurable: !(bitmap & 2),
	    writable    : !(bitmap & 4),
	    value       : value
	  };
	}
	function simpleSet(object, key, value){
	  object[key] = value;
	  return object;
	}
	function createDefiner(bitmap){
	  return DESC ? function(object, key, value){
	    return $.setDesc(object, key, desc(bitmap, value));
	  } : simpleSet;
	}

	function isObject(it){
	  return it !== null && (typeof it == 'object' || typeof it == 'function');
	}
	function isFunction(it){
	  return typeof it == 'function';
	}
	function assertDefined(it){
	  if(it == undefined)throw TypeError("Can't call method on  " + it);
	  return it;
	}

	var $ = module.exports = __webpack_require__(84)({
	  g: global,
	  core: core,
	  html: global.document && document.documentElement,
	  // http://jsperf.com/core-js-isobject
	  isObject:   isObject,
	  isFunction: isFunction,
	  that: function(){
	    return this;
	  },
	  // 7.1.4 ToInteger
	  toInteger: toInteger,
	  // 7.1.15 ToLength
	  toLength: function(it){
	    return it > 0 ? min(toInteger(it), 0x1fffffffffffff) : 0; // pow(2, 53) - 1 == 9007199254740991
	  },
	  toIndex: function(index, length){
	    index = toInteger(index);
	    return index < 0 ? max(index + length, 0) : min(index, length);
	  },
	  has: function(it, key){
	    return hasOwnProperty.call(it, key);
	  },
	  create:     Object.create,
	  getProto:   Object.getPrototypeOf,
	  DESC:       DESC,
	  desc:       desc,
	  getDesc:    Object.getOwnPropertyDescriptor,
	  setDesc:    defineProperty,
	  setDescs:   Object.defineProperties,
	  getKeys:    Object.keys,
	  getNames:   Object.getOwnPropertyNames,
	  getSymbols: Object.getOwnPropertySymbols,
	  assertDefined: assertDefined,
	  // Dummy, fix for not array-like ES3 string in es5 module
	  ES5Object: Object,
	  toObject: function(it){
	    return $.ES5Object(assertDefined(it));
	  },
	  hide: hide,
	  def: createDefiner(0),
	  set: global.Symbol ? simpleSet : hide,
	  each: [].forEach
	});
	/* eslint-disable no-undef */
	if(typeof __e != 'undefined')__e = core;
	if(typeof __g != 'undefined')__g = global;

/***/ },
/* 78 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global, Buffer) {(function() {
	  var g = ('undefined' === typeof window ? global : window) || {}
	  _crypto = (
	    g.crypto || g.msCrypto || __webpack_require__(82)
	  )
	  module.exports = function(size) {
	    // Modern Browsers
	    if(_crypto.getRandomValues) {
	      var bytes = new Buffer(size); //in browserify, this is an extended Uint8Array
	      /* This will not work in older browsers.
	       * See https://developer.mozilla.org/en-US/docs/Web/API/window.crypto.getRandomValues
	       */
	    
	      _crypto.getRandomValues(bytes);
	      return bytes;
	    }
	    else if (_crypto.randomBytes) {
	      return _crypto.randomBytes(size)
	    }
	    else
	      throw new Error(
	        'secure random number generation not supported by this browser\n'+
	        'use chrome, FireFox or Internet Explorer 11'
	      )
	  }
	}())
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }()), __webpack_require__(43).Buffer))

/***/ },
/* 79 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var createHash = __webpack_require__(88)

	var md5 = toConstructor(__webpack_require__(85))
	var rmd160 = toConstructor(__webpack_require__(91))

	function toConstructor (fn) {
	  return function () {
	    var buffers = []
	    var m= {
	      update: function (data, enc) {
	        if(!Buffer.isBuffer(data)) data = new Buffer(data, enc)
	        buffers.push(data)
	        return this
	      },
	      digest: function (enc) {
	        var buf = Buffer.concat(buffers)
	        var r = fn(buf)
	        buffers = null
	        return enc ? r.toString(enc) : r
	      }
	    }
	    return m
	  }
	}

	module.exports = function (alg) {
	  if('md5' === alg) return new md5()
	  if('rmd160' === alg) return new rmd160()
	  return createHash(alg)
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 80 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var createHash = __webpack_require__(79)

	var zeroBuffer = new Buffer(128)
	zeroBuffer.fill(0)

	module.exports = Hmac

	function Hmac (alg, key) {
	  if(!(this instanceof Hmac)) return new Hmac(alg, key)
	  this._opad = opad
	  this._alg = alg

	  var blocksize = (alg === 'sha512') ? 128 : 64

	  key = this._key = !Buffer.isBuffer(key) ? new Buffer(key) : key

	  if(key.length > blocksize) {
	    key = createHash(alg).update(key).digest()
	  } else if(key.length < blocksize) {
	    key = Buffer.concat([key, zeroBuffer], blocksize)
	  }

	  var ipad = this._ipad = new Buffer(blocksize)
	  var opad = this._opad = new Buffer(blocksize)

	  for(var i = 0; i < blocksize; i++) {
	    ipad[i] = key[i] ^ 0x36
	    opad[i] = key[i] ^ 0x5C
	  }

	  this._hash = createHash(alg).update(ipad)
	}

	Hmac.prototype.update = function (data, enc) {
	  this._hash.update(data, enc)
	  return this
	}

	Hmac.prototype.digest = function (enc) {
	  var h = this._hash.digest()
	  return createHash(this._alg).update(this._opad).update(h).digest(enc)
	}

	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 81 */
/***/ function(module, exports, __webpack_require__) {

	var pbkdf2Export = __webpack_require__(89)

	module.exports = function (crypto, exports) {
	  exports = exports || {}

	  var exported = pbkdf2Export(crypto)

	  exports.pbkdf2 = exported.pbkdf2
	  exports.pbkdf2Sync = exported.pbkdf2Sync

	  return exports
	}


/***/ },
/* 82 */
/***/ function(module, exports, __webpack_require__) {

	/* (ignored) */

/***/ },
/* 83 */
/***/ function(module, exports, __webpack_require__) {

	// shim for using process in browser

	var process = module.exports = {};
	var queue = [];
	var draining = false;
	var currentQueue;
	var queueIndex = -1;

	function cleanUpNextTick() {
	    draining = false;
	    if (currentQueue.length) {
	        queue = currentQueue.concat(queue);
	    } else {
	        queueIndex = -1;
	    }
	    if (queue.length) {
	        drainQueue();
	    }
	}

	function drainQueue() {
	    if (draining) {
	        return;
	    }
	    var timeout = setTimeout(cleanUpNextTick);
	    draining = true;

	    var len = queue.length;
	    while(len) {
	        currentQueue = queue;
	        queue = [];
	        while (++queueIndex < len) {
	            currentQueue[queueIndex].run();
	        }
	        queueIndex = -1;
	        len = queue.length;
	    }
	    currentQueue = null;
	    draining = false;
	    clearTimeout(timeout);
	}

	process.nextTick = function (fun) {
	    var args = new Array(arguments.length - 1);
	    if (arguments.length > 1) {
	        for (var i = 1; i < arguments.length; i++) {
	            args[i - 1] = arguments[i];
	        }
	    }
	    queue.push(new Item(fun, args));
	    if (queue.length === 1 && !draining) {
	        setTimeout(drainQueue, 0);
	    }
	};

	// v8 likes predictible objects
	function Item(fun, array) {
	    this.fun = fun;
	    this.array = array;
	}
	Item.prototype.run = function () {
	    this.fun.apply(null, this.array);
	};
	process.title = 'browser';
	process.browser = true;
	process.env = {};
	process.argv = [];
	process.version = ''; // empty string to avoid regexp issues
	process.versions = {};

	function noop() {}

	process.on = noop;
	process.addListener = noop;
	process.once = noop;
	process.off = noop;
	process.removeListener = noop;
	process.removeAllListeners = noop;
	process.emit = noop;

	process.binding = function (name) {
	    throw new Error('process.binding is not supported');
	};

	// TODO(shtylman)
	process.cwd = function () { return '/' };
	process.chdir = function (dir) {
	    throw new Error('process.chdir is not supported');
	};
	process.umask = function() { return 0; };


/***/ },
/* 84 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function($){
	  $.FW   = false;
	  $.path = $.core;
	  return $;
	};

/***/ },
/* 85 */
/***/ function(module, exports, __webpack_require__) {

	/*
	 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
	 * Digest Algorithm, as defined in RFC 1321.
	 * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
	 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
	 * Distributed under the BSD License
	 * See http://pajhome.org.uk/crypt/md5 for more info.
	 */

	var helpers = __webpack_require__(90);

	/*
	 * Calculate the MD5 of an array of little-endian words, and a bit length
	 */
	function core_md5(x, len)
	{
	  /* append padding */
	  x[len >> 5] |= 0x80 << ((len) % 32);
	  x[(((len + 64) >>> 9) << 4) + 14] = len;

	  var a =  1732584193;
	  var b = -271733879;
	  var c = -1732584194;
	  var d =  271733878;

	  for(var i = 0; i < x.length; i += 16)
	  {
	    var olda = a;
	    var oldb = b;
	    var oldc = c;
	    var oldd = d;

	    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
	    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
	    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
	    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
	    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
	    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
	    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
	    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
	    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
	    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
	    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
	    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
	    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
	    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
	    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
	    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

	    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
	    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
	    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
	    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
	    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
	    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
	    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
	    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
	    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
	    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
	    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
	    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
	    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
	    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
	    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
	    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

	    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
	    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
	    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
	    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
	    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
	    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
	    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
	    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
	    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
	    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
	    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
	    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
	    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
	    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
	    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
	    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

	    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
	    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
	    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
	    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
	    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
	    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
	    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
	    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
	    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
	    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
	    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
	    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
	    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
	    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
	    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
	    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

	    a = safe_add(a, olda);
	    b = safe_add(b, oldb);
	    c = safe_add(c, oldc);
	    d = safe_add(d, oldd);
	  }
	  return Array(a, b, c, d);

	}

	/*
	 * These functions implement the four basic operations the algorithm uses.
	 */
	function md5_cmn(q, a, b, x, s, t)
	{
	  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
	}
	function md5_ff(a, b, c, d, x, s, t)
	{
	  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
	}
	function md5_gg(a, b, c, d, x, s, t)
	{
	  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
	}
	function md5_hh(a, b, c, d, x, s, t)
	{
	  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
	}
	function md5_ii(a, b, c, d, x, s, t)
	{
	  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
	}

	/*
	 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
	 * to work around bugs in some JS interpreters.
	 */
	function safe_add(x, y)
	{
	  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	  return (msw << 16) | (lsw & 0xFFFF);
	}

	/*
	 * Bitwise rotate a 32-bit number to the left.
	 */
	function bit_rol(num, cnt)
	{
	  return (num << cnt) | (num >>> (32 - cnt));
	}

	module.exports = function md5(buf) {
	  return helpers.hash(buf, core_md5, 16);
	};


/***/ },
/* 86 */
/***/ function(module, exports, __webpack_require__) {

	var $          = __webpack_require__(77)
	  , global     = $.g
	  , core       = $.core
	  , isFunction = $.isFunction;
	function ctx(fn, that){
	  return function(){
	    return fn.apply(that, arguments);
	  };
	}
	// type bitmap
	$def.F = 1;  // forced
	$def.G = 2;  // global
	$def.S = 4;  // static
	$def.P = 8;  // proto
	$def.B = 16; // bind
	$def.W = 32; // wrap
	function $def(type, name, source){
	  var key, own, out, exp
	    , isGlobal = type & $def.G
	    , isProto  = type & $def.P
	    , target   = isGlobal ? global : type & $def.S
	        ? global[name] : (global[name] || {}).prototype
	    , exports  = isGlobal ? core : core[name] || (core[name] = {});
	  if(isGlobal)source = name;
	  for(key in source){
	    // contains in native
	    own = !(type & $def.F) && target && key in target;
	    if(own && key in exports)continue;
	    // export native or passed
	    out = own ? target[key] : source[key];
	    // prevent global pollution for namespaces
	    if(isGlobal && !isFunction(target[key]))exp = source[key];
	    // bind timers to global for call from export context
	    else if(type & $def.B && own)exp = ctx(out, global);
	    // wrap global constructors for prevent change them in library
	    else if(type & $def.W && target[key] == out)!function(C){
	      exp = function(param){
	        return this instanceof C ? new C(param) : C(param);
	      };
	      exp.prototype = C.prototype;
	    }(out);
	    else exp = isProto && isFunction(out) ? ctx(Function.call, out) : out;
	    // export
	    exports[key] = exp;
	    if(isProto)(exports.prototype || (exports.prototype = {}))[key] = out;
	  }
	}
	module.exports = $def;

/***/ },
/* 87 */
/***/ function(module, exports, __webpack_require__) {

	// fallback for IE11 buggy Object.getOwnPropertyNames with iframe and window
	var $ = __webpack_require__(77)
	  , toString = {}.toString
	  , getNames = $.getNames;

	var windowNames = typeof window == 'object' && Object.getOwnPropertyNames
	  ? Object.getOwnPropertyNames(window) : [];

	function getWindowNames(it){
	  try {
	    return getNames(it);
	  } catch(e){
	    return windowNames.slice();
	  }
	}

	module.exports.get = function getOwnPropertyNames(it){
	  if(windowNames && toString.call(it) == '[object Window]')return getWindowNames(it);
	  return getNames($.toObject(it));
	};

/***/ },
/* 88 */
/***/ function(module, exports, __webpack_require__) {

	var exports = module.exports = function (alg) {
	  var Alg = exports[alg]
	  if(!Alg) throw new Error(alg + ' is not supported (we accept pull requests)')
	  return new Alg()
	}

	var Buffer = __webpack_require__(43).Buffer
	var Hash   = __webpack_require__(92)(Buffer)

	exports.sha1 = __webpack_require__(93)(Buffer, Hash)
	exports.sha256 = __webpack_require__(94)(Buffer, Hash)
	exports.sha512 = __webpack_require__(95)(Buffer, Hash)


/***/ },
/* 89 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {module.exports = function(crypto) {
	  function pbkdf2(password, salt, iterations, keylen, digest, callback) {
	    if ('function' === typeof digest) {
	      callback = digest
	      digest = undefined
	    }

	    if ('function' !== typeof callback)
	      throw new Error('No callback provided to pbkdf2')

	    setTimeout(function() {
	      var result

	      try {
	        result = pbkdf2Sync(password, salt, iterations, keylen, digest)
	      } catch (e) {
	        return callback(e)
	      }

	      callback(undefined, result)
	    })
	  }

	  function pbkdf2Sync(password, salt, iterations, keylen, digest) {
	    if ('number' !== typeof iterations)
	      throw new TypeError('Iterations not a number')

	    if (iterations < 0)
	      throw new TypeError('Bad iterations')

	    if ('number' !== typeof keylen)
	      throw new TypeError('Key length not a number')

	    if (keylen < 0)
	      throw new TypeError('Bad key length')

	    digest = digest || 'sha1'

	    if (!Buffer.isBuffer(password)) password = new Buffer(password)
	    if (!Buffer.isBuffer(salt)) salt = new Buffer(salt)

	    var hLen, l = 1, r, T
	    var DK = new Buffer(keylen)
	    var block1 = new Buffer(salt.length + 4)
	    salt.copy(block1, 0, 0, salt.length)

	    for (var i = 1; i <= l; i++) {
	      block1.writeUInt32BE(i, salt.length)

	      var U = crypto.createHmac(digest, password).update(block1).digest()

	      if (!hLen) {
	        hLen = U.length
	        T = new Buffer(hLen)
	        l = Math.ceil(keylen / hLen)
	        r = keylen - (l - 1) * hLen

	        if (keylen > (Math.pow(2, 32) - 1) * hLen)
	          throw new TypeError('keylen exceeds maximum length')
	      }

	      U.copy(T, 0, 0, hLen)

	      for (var j = 1; j < iterations; j++) {
	        U = crypto.createHmac(digest, password).update(U).digest()

	        for (var k = 0; k < hLen; k++) {
	          T[k] ^= U[k]
	        }
	      }

	      var destPos = (i - 1) * hLen
	      var len = (i == l ? r : hLen)
	      T.copy(DK, destPos, 0, len)
	    }

	    return DK
	  }

	  return {
	    pbkdf2: pbkdf2,
	    pbkdf2Sync: pbkdf2Sync
	  }
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 90 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {var intSize = 4;
	var zeroBuffer = new Buffer(intSize); zeroBuffer.fill(0);
	var chrsz = 8;

	function toArray(buf, bigEndian) {
	  if ((buf.length % intSize) !== 0) {
	    var len = buf.length + (intSize - (buf.length % intSize));
	    buf = Buffer.concat([buf, zeroBuffer], len);
	  }

	  var arr = [];
	  var fn = bigEndian ? buf.readInt32BE : buf.readInt32LE;
	  for (var i = 0; i < buf.length; i += intSize) {
	    arr.push(fn.call(buf, i));
	  }
	  return arr;
	}

	function toBuffer(arr, size, bigEndian) {
	  var buf = new Buffer(size);
	  var fn = bigEndian ? buf.writeInt32BE : buf.writeInt32LE;
	  for (var i = 0; i < arr.length; i++) {
	    fn.call(buf, arr[i], i * 4, true);
	  }
	  return buf;
	}

	function hash(buf, fn, hashSize, bigEndian) {
	  if (!Buffer.isBuffer(buf)) buf = new Buffer(buf);
	  var arr = fn(toArray(buf, bigEndian), buf.length * chrsz);
	  return toBuffer(arr, hashSize, bigEndian);
	}

	module.exports = { hash: hash };
	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 91 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(Buffer) {
	module.exports = ripemd160



	/*
	CryptoJS v3.1.2
	code.google.com/p/crypto-js
	(c) 2009-2013 by Jeff Mott. All rights reserved.
	code.google.com/p/crypto-js/wiki/License
	*/
	/** @preserve
	(c) 2012 by Cédric Mesnil. All rights reserved.

	Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

	    - Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	    - Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	*/

	// Constants table
	var zl = [
	    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	    7,  4, 13,  1, 10,  6, 15,  3, 12,  0,  9,  5,  2, 14, 11,  8,
	    3, 10, 14,  4,  9, 15,  8,  1,  2,  7,  0,  6, 13, 11,  5, 12,
	    1,  9, 11, 10,  0,  8, 12,  4, 13,  3,  7, 15, 14,  5,  6,  2,
	    4,  0,  5,  9,  7, 12,  2, 10, 14,  1,  3,  8, 11,  6, 15, 13];
	var zr = [
	    5, 14,  7,  0,  9,  2, 11,  4, 13,  6, 15,  8,  1, 10,  3, 12,
	    6, 11,  3,  7,  0, 13,  5, 10, 14, 15,  8, 12,  4,  9,  1,  2,
	    15,  5,  1,  3,  7, 14,  6,  9, 11,  8, 12,  2, 10,  0,  4, 13,
	    8,  6,  4,  1,  3, 11, 15,  0,  5, 12,  2, 13,  9,  7, 10, 14,
	    12, 15, 10,  4,  1,  5,  8,  7,  6,  2, 13, 14,  0,  3,  9, 11];
	var sl = [
	     11, 14, 15, 12,  5,  8,  7,  9, 11, 13, 14, 15,  6,  7,  9,  8,
	    7, 6,   8, 13, 11,  9,  7, 15,  7, 12, 15,  9, 11,  7, 13, 12,
	    11, 13,  6,  7, 14,  9, 13, 15, 14,  8, 13,  6,  5, 12,  7,  5,
	      11, 12, 14, 15, 14, 15,  9,  8,  9, 14,  5,  6,  8,  6,  5, 12,
	    9, 15,  5, 11,  6,  8, 13, 12,  5, 12, 13, 14, 11,  8,  5,  6 ];
	var sr = [
	    8,  9,  9, 11, 13, 15, 15,  5,  7,  7,  8, 11, 14, 14, 12,  6,
	    9, 13, 15,  7, 12,  8,  9, 11,  7,  7, 12,  7,  6, 15, 13, 11,
	    9,  7, 15, 11,  8,  6,  6, 14, 12, 13,  5, 14, 13, 13,  7,  5,
	    15,  5,  8, 11, 14, 14,  6, 14,  6,  9, 12,  9, 12,  5, 15,  8,
	    8,  5, 12,  9, 12,  5, 14,  6,  8, 13,  6,  5, 15, 13, 11, 11 ];

	var hl =  [ 0x00000000, 0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xA953FD4E];
	var hr =  [ 0x50A28BE6, 0x5C4DD124, 0x6D703EF3, 0x7A6D76E9, 0x00000000];

	var bytesToWords = function (bytes) {
	  var words = [];
	  for (var i = 0, b = 0; i < bytes.length; i++, b += 8) {
	    words[b >>> 5] |= bytes[i] << (24 - b % 32);
	  }
	  return words;
	};

	var wordsToBytes = function (words) {
	  var bytes = [];
	  for (var b = 0; b < words.length * 32; b += 8) {
	    bytes.push((words[b >>> 5] >>> (24 - b % 32)) & 0xFF);
	  }
	  return bytes;
	};

	var processBlock = function (H, M, offset) {

	  // Swap endian
	  for (var i = 0; i < 16; i++) {
	    var offset_i = offset + i;
	    var M_offset_i = M[offset_i];

	    // Swap
	    M[offset_i] = (
	        (((M_offset_i << 8)  | (M_offset_i >>> 24)) & 0x00ff00ff) |
	        (((M_offset_i << 24) | (M_offset_i >>> 8))  & 0xff00ff00)
	    );
	  }

	  // Working variables
	  var al, bl, cl, dl, el;
	  var ar, br, cr, dr, er;

	  ar = al = H[0];
	  br = bl = H[1];
	  cr = cl = H[2];
	  dr = dl = H[3];
	  er = el = H[4];
	  // Computation
	  var t;
	  for (var i = 0; i < 80; i += 1) {
	    t = (al +  M[offset+zl[i]])|0;
	    if (i<16){
	        t +=  f1(bl,cl,dl) + hl[0];
	    } else if (i<32) {
	        t +=  f2(bl,cl,dl) + hl[1];
	    } else if (i<48) {
	        t +=  f3(bl,cl,dl) + hl[2];
	    } else if (i<64) {
	        t +=  f4(bl,cl,dl) + hl[3];
	    } else {// if (i<80) {
	        t +=  f5(bl,cl,dl) + hl[4];
	    }
	    t = t|0;
	    t =  rotl(t,sl[i]);
	    t = (t+el)|0;
	    al = el;
	    el = dl;
	    dl = rotl(cl, 10);
	    cl = bl;
	    bl = t;

	    t = (ar + M[offset+zr[i]])|0;
	    if (i<16){
	        t +=  f5(br,cr,dr) + hr[0];
	    } else if (i<32) {
	        t +=  f4(br,cr,dr) + hr[1];
	    } else if (i<48) {
	        t +=  f3(br,cr,dr) + hr[2];
	    } else if (i<64) {
	        t +=  f2(br,cr,dr) + hr[3];
	    } else {// if (i<80) {
	        t +=  f1(br,cr,dr) + hr[4];
	    }
	    t = t|0;
	    t =  rotl(t,sr[i]) ;
	    t = (t+er)|0;
	    ar = er;
	    er = dr;
	    dr = rotl(cr, 10);
	    cr = br;
	    br = t;
	  }
	  // Intermediate hash value
	  t    = (H[1] + cl + dr)|0;
	  H[1] = (H[2] + dl + er)|0;
	  H[2] = (H[3] + el + ar)|0;
	  H[3] = (H[4] + al + br)|0;
	  H[4] = (H[0] + bl + cr)|0;
	  H[0] =  t;
	};

	function f1(x, y, z) {
	  return ((x) ^ (y) ^ (z));
	}

	function f2(x, y, z) {
	  return (((x)&(y)) | ((~x)&(z)));
	}

	function f3(x, y, z) {
	  return (((x) | (~(y))) ^ (z));
	}

	function f4(x, y, z) {
	  return (((x) & (z)) | ((y)&(~(z))));
	}

	function f5(x, y, z) {
	  return ((x) ^ ((y) |(~(z))));
	}

	function rotl(x,n) {
	  return (x<<n) | (x>>>(32-n));
	}

	function ripemd160(message) {
	  var H = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476, 0xC3D2E1F0];

	  if (typeof message == 'string')
	    message = new Buffer(message, 'utf8');

	  var m = bytesToWords(message);

	  var nBitsLeft = message.length * 8;
	  var nBitsTotal = message.length * 8;

	  // Add padding
	  m[nBitsLeft >>> 5] |= 0x80 << (24 - nBitsLeft % 32);
	  m[(((nBitsLeft + 64) >>> 9) << 4) + 14] = (
	      (((nBitsTotal << 8)  | (nBitsTotal >>> 24)) & 0x00ff00ff) |
	      (((nBitsTotal << 24) | (nBitsTotal >>> 8))  & 0xff00ff00)
	  );

	  for (var i=0 ; i<m.length; i += 16) {
	    processBlock(H, m, i);
	  }

	  // Swap endian
	  for (var i = 0; i < 5; i++) {
	      // Shortcut
	    var H_i = H[i];

	    // Swap
	    H[i] = (((H_i << 8)  | (H_i >>> 24)) & 0x00ff00ff) |
	          (((H_i << 24) | (H_i >>> 8))  & 0xff00ff00);
	  }

	  var digestbytes = wordsToBytes(H);
	  return new Buffer(digestbytes);
	}


	
	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(43).Buffer))

/***/ },
/* 92 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = function (Buffer) {

	  //prototype class for hash functions
	  function Hash (blockSize, finalSize) {
	    this._block = new Buffer(blockSize) //new Uint32Array(blockSize/4)
	    this._finalSize = finalSize
	    this._blockSize = blockSize
	    this._len = 0
	    this._s = 0
	  }

	  Hash.prototype.init = function () {
	    this._s = 0
	    this._len = 0
	  }

	  Hash.prototype.update = function (data, enc) {
	    if ("string" === typeof data) {
	      enc = enc || "utf8"
	      data = new Buffer(data, enc)
	    }

	    var l = this._len += data.length
	    var s = this._s = (this._s || 0)
	    var f = 0
	    var buffer = this._block

	    while (s < l) {
	      var t = Math.min(data.length, f + this._blockSize - (s % this._blockSize))
	      var ch = (t - f)

	      for (var i = 0; i < ch; i++) {
	        buffer[(s % this._blockSize) + i] = data[i + f]
	      }

	      s += ch
	      f += ch

	      if ((s % this._blockSize) === 0) {
	        this._update(buffer)
	      }
	    }
	    this._s = s

	    return this
	  }

	  Hash.prototype.digest = function (enc) {
	    // Suppose the length of the message M, in bits, is l
	    var l = this._len * 8

	    // Append the bit 1 to the end of the message
	    this._block[this._len % this._blockSize] = 0x80

	    // and then k zero bits, where k is the smallest non-negative solution to the equation (l + 1 + k) === finalSize mod blockSize
	    this._block.fill(0, this._len % this._blockSize + 1)

	    if (l % (this._blockSize * 8) >= this._finalSize * 8) {
	      this._update(this._block)
	      this._block.fill(0)
	    }

	    // to this append the block which is equal to the number l written in binary
	    // TODO: handle case where l is > Math.pow(2, 29)
	    this._block.writeInt32BE(l, this._blockSize - 4)

	    var hash = this._update(this._block) || this._hash()

	    return enc ? hash.toString(enc) : hash
	  }

	  Hash.prototype._update = function () {
	    throw new Error('_update must be implemented by subclass')
	  }

	  return Hash
	}


/***/ },
/* 93 */
/***/ function(module, exports, __webpack_require__) {

	/*
	 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
	 * in FIPS PUB 180-1
	 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
	 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
	 * Distributed under the BSD License
	 * See http://pajhome.org.uk/crypt/md5 for details.
	 */

	var inherits = __webpack_require__(41).inherits

	module.exports = function (Buffer, Hash) {

	  var A = 0|0
	  var B = 4|0
	  var C = 8|0
	  var D = 12|0
	  var E = 16|0

	  var W = new (typeof Int32Array === 'undefined' ? Array : Int32Array)(80)

	  var POOL = []

	  function Sha1 () {
	    if(POOL.length)
	      return POOL.pop().init()

	    if(!(this instanceof Sha1)) return new Sha1()
	    this._w = W
	    Hash.call(this, 16*4, 14*4)

	    this._h = null
	    this.init()
	  }

	  inherits(Sha1, Hash)

	  Sha1.prototype.init = function () {
	    this._a = 0x67452301
	    this._b = 0xefcdab89
	    this._c = 0x98badcfe
	    this._d = 0x10325476
	    this._e = 0xc3d2e1f0

	    Hash.prototype.init.call(this)
	    return this
	  }

	  Sha1.prototype._POOL = POOL
	  Sha1.prototype._update = function (X) {

	    var a, b, c, d, e, _a, _b, _c, _d, _e

	    a = _a = this._a
	    b = _b = this._b
	    c = _c = this._c
	    d = _d = this._d
	    e = _e = this._e

	    var w = this._w

	    for(var j = 0; j < 80; j++) {
	      var W = w[j] = j < 16 ? X.readInt32BE(j*4)
	        : rol(w[j - 3] ^ w[j -  8] ^ w[j - 14] ^ w[j - 16], 1)

	      var t = add(
	        add(rol(a, 5), sha1_ft(j, b, c, d)),
	        add(add(e, W), sha1_kt(j))
	      )

	      e = d
	      d = c
	      c = rol(b, 30)
	      b = a
	      a = t
	    }

	    this._a = add(a, _a)
	    this._b = add(b, _b)
	    this._c = add(c, _c)
	    this._d = add(d, _d)
	    this._e = add(e, _e)
	  }

	  Sha1.prototype._hash = function () {
	    if(POOL.length < 100) POOL.push(this)
	    var H = new Buffer(20)
	    //console.log(this._a|0, this._b|0, this._c|0, this._d|0, this._e|0)
	    H.writeInt32BE(this._a|0, A)
	    H.writeInt32BE(this._b|0, B)
	    H.writeInt32BE(this._c|0, C)
	    H.writeInt32BE(this._d|0, D)
	    H.writeInt32BE(this._e|0, E)
	    return H
	  }

	  /*
	   * Perform the appropriate triplet combination function for the current
	   * iteration
	   */
	  function sha1_ft(t, b, c, d) {
	    if(t < 20) return (b & c) | ((~b) & d);
	    if(t < 40) return b ^ c ^ d;
	    if(t < 60) return (b & c) | (b & d) | (c & d);
	    return b ^ c ^ d;
	  }

	  /*
	   * Determine the appropriate additive constant for the current iteration
	   */
	  function sha1_kt(t) {
	    return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
	           (t < 60) ? -1894007588 : -899497514;
	  }

	  /*
	   * Add integers, wrapping at 2^32. This uses 16-bit operations internally
	   * to work around bugs in some JS interpreters.
	   * //dominictarr: this is 10 years old, so maybe this can be dropped?)
	   *
	   */
	  function add(x, y) {
	    return (x + y ) | 0
	  //lets see how this goes on testling.
	  //  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	  //  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	  //  return (msw << 16) | (lsw & 0xFFFF);
	  }

	  /*
	   * Bitwise rotate a 32-bit number to the left.
	   */
	  function rol(num, cnt) {
	    return (num << cnt) | (num >>> (32 - cnt));
	  }

	  return Sha1
	}


/***/ },
/* 94 */
/***/ function(module, exports, __webpack_require__) {

	
	/**
	 * A JavaScript implementation of the Secure Hash Algorithm, SHA-256, as defined
	 * in FIPS 180-2
	 * Version 2.2-beta Copyright Angel Marin, Paul Johnston 2000 - 2009.
	 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
	 *
	 */

	var inherits = __webpack_require__(41).inherits

	module.exports = function (Buffer, Hash) {

	  var K = [
	      0x428A2F98, 0x71374491, 0xB5C0FBCF, 0xE9B5DBA5,
	      0x3956C25B, 0x59F111F1, 0x923F82A4, 0xAB1C5ED5,
	      0xD807AA98, 0x12835B01, 0x243185BE, 0x550C7DC3,
	      0x72BE5D74, 0x80DEB1FE, 0x9BDC06A7, 0xC19BF174,
	      0xE49B69C1, 0xEFBE4786, 0x0FC19DC6, 0x240CA1CC,
	      0x2DE92C6F, 0x4A7484AA, 0x5CB0A9DC, 0x76F988DA,
	      0x983E5152, 0xA831C66D, 0xB00327C8, 0xBF597FC7,
	      0xC6E00BF3, 0xD5A79147, 0x06CA6351, 0x14292967,
	      0x27B70A85, 0x2E1B2138, 0x4D2C6DFC, 0x53380D13,
	      0x650A7354, 0x766A0ABB, 0x81C2C92E, 0x92722C85,
	      0xA2BFE8A1, 0xA81A664B, 0xC24B8B70, 0xC76C51A3,
	      0xD192E819, 0xD6990624, 0xF40E3585, 0x106AA070,
	      0x19A4C116, 0x1E376C08, 0x2748774C, 0x34B0BCB5,
	      0x391C0CB3, 0x4ED8AA4A, 0x5B9CCA4F, 0x682E6FF3,
	      0x748F82EE, 0x78A5636F, 0x84C87814, 0x8CC70208,
	      0x90BEFFFA, 0xA4506CEB, 0xBEF9A3F7, 0xC67178F2
	    ]

	  var W = new Array(64)

	  function Sha256() {
	    this.init()

	    this._w = W //new Array(64)

	    Hash.call(this, 16*4, 14*4)
	  }

	  inherits(Sha256, Hash)

	  Sha256.prototype.init = function () {

	    this._a = 0x6a09e667|0
	    this._b = 0xbb67ae85|0
	    this._c = 0x3c6ef372|0
	    this._d = 0xa54ff53a|0
	    this._e = 0x510e527f|0
	    this._f = 0x9b05688c|0
	    this._g = 0x1f83d9ab|0
	    this._h = 0x5be0cd19|0

	    this._len = this._s = 0

	    return this
	  }

	  function S (X, n) {
	    return (X >>> n) | (X << (32 - n));
	  }

	  function R (X, n) {
	    return (X >>> n);
	  }

	  function Ch (x, y, z) {
	    return ((x & y) ^ ((~x) & z));
	  }

	  function Maj (x, y, z) {
	    return ((x & y) ^ (x & z) ^ (y & z));
	  }

	  function Sigma0256 (x) {
	    return (S(x, 2) ^ S(x, 13) ^ S(x, 22));
	  }

	  function Sigma1256 (x) {
	    return (S(x, 6) ^ S(x, 11) ^ S(x, 25));
	  }

	  function Gamma0256 (x) {
	    return (S(x, 7) ^ S(x, 18) ^ R(x, 3));
	  }

	  function Gamma1256 (x) {
	    return (S(x, 17) ^ S(x, 19) ^ R(x, 10));
	  }

	  Sha256.prototype._update = function(M) {

	    var W = this._w
	    var a, b, c, d, e, f, g, h
	    var T1, T2

	    a = this._a | 0
	    b = this._b | 0
	    c = this._c | 0
	    d = this._d | 0
	    e = this._e | 0
	    f = this._f | 0
	    g = this._g | 0
	    h = this._h | 0

	    for (var j = 0; j < 64; j++) {
	      var w = W[j] = j < 16
	        ? M.readInt32BE(j * 4)
	        : Gamma1256(W[j - 2]) + W[j - 7] + Gamma0256(W[j - 15]) + W[j - 16]

	      T1 = h + Sigma1256(e) + Ch(e, f, g) + K[j] + w

	      T2 = Sigma0256(a) + Maj(a, b, c);
	      h = g; g = f; f = e; e = d + T1; d = c; c = b; b = a; a = T1 + T2;
	    }

	    this._a = (a + this._a) | 0
	    this._b = (b + this._b) | 0
	    this._c = (c + this._c) | 0
	    this._d = (d + this._d) | 0
	    this._e = (e + this._e) | 0
	    this._f = (f + this._f) | 0
	    this._g = (g + this._g) | 0
	    this._h = (h + this._h) | 0

	  };

	  Sha256.prototype._hash = function () {
	    var H = new Buffer(32)

	    H.writeInt32BE(this._a,  0)
	    H.writeInt32BE(this._b,  4)
	    H.writeInt32BE(this._c,  8)
	    H.writeInt32BE(this._d, 12)
	    H.writeInt32BE(this._e, 16)
	    H.writeInt32BE(this._f, 20)
	    H.writeInt32BE(this._g, 24)
	    H.writeInt32BE(this._h, 28)

	    return H
	  }

	  return Sha256

	}


/***/ },
/* 95 */
/***/ function(module, exports, __webpack_require__) {

	var inherits = __webpack_require__(41).inherits

	module.exports = function (Buffer, Hash) {
	  var K = [
	    0x428a2f98, 0xd728ae22, 0x71374491, 0x23ef65cd,
	    0xb5c0fbcf, 0xec4d3b2f, 0xe9b5dba5, 0x8189dbbc,
	    0x3956c25b, 0xf348b538, 0x59f111f1, 0xb605d019,
	    0x923f82a4, 0xaf194f9b, 0xab1c5ed5, 0xda6d8118,
	    0xd807aa98, 0xa3030242, 0x12835b01, 0x45706fbe,
	    0x243185be, 0x4ee4b28c, 0x550c7dc3, 0xd5ffb4e2,
	    0x72be5d74, 0xf27b896f, 0x80deb1fe, 0x3b1696b1,
	    0x9bdc06a7, 0x25c71235, 0xc19bf174, 0xcf692694,
	    0xe49b69c1, 0x9ef14ad2, 0xefbe4786, 0x384f25e3,
	    0x0fc19dc6, 0x8b8cd5b5, 0x240ca1cc, 0x77ac9c65,
	    0x2de92c6f, 0x592b0275, 0x4a7484aa, 0x6ea6e483,
	    0x5cb0a9dc, 0xbd41fbd4, 0x76f988da, 0x831153b5,
	    0x983e5152, 0xee66dfab, 0xa831c66d, 0x2db43210,
	    0xb00327c8, 0x98fb213f, 0xbf597fc7, 0xbeef0ee4,
	    0xc6e00bf3, 0x3da88fc2, 0xd5a79147, 0x930aa725,
	    0x06ca6351, 0xe003826f, 0x14292967, 0x0a0e6e70,
	    0x27b70a85, 0x46d22ffc, 0x2e1b2138, 0x5c26c926,
	    0x4d2c6dfc, 0x5ac42aed, 0x53380d13, 0x9d95b3df,
	    0x650a7354, 0x8baf63de, 0x766a0abb, 0x3c77b2a8,
	    0x81c2c92e, 0x47edaee6, 0x92722c85, 0x1482353b,
	    0xa2bfe8a1, 0x4cf10364, 0xa81a664b, 0xbc423001,
	    0xc24b8b70, 0xd0f89791, 0xc76c51a3, 0x0654be30,
	    0xd192e819, 0xd6ef5218, 0xd6990624, 0x5565a910,
	    0xf40e3585, 0x5771202a, 0x106aa070, 0x32bbd1b8,
	    0x19a4c116, 0xb8d2d0c8, 0x1e376c08, 0x5141ab53,
	    0x2748774c, 0xdf8eeb99, 0x34b0bcb5, 0xe19b48a8,
	    0x391c0cb3, 0xc5c95a63, 0x4ed8aa4a, 0xe3418acb,
	    0x5b9cca4f, 0x7763e373, 0x682e6ff3, 0xd6b2b8a3,
	    0x748f82ee, 0x5defb2fc, 0x78a5636f, 0x43172f60,
	    0x84c87814, 0xa1f0ab72, 0x8cc70208, 0x1a6439ec,
	    0x90befffa, 0x23631e28, 0xa4506ceb, 0xde82bde9,
	    0xbef9a3f7, 0xb2c67915, 0xc67178f2, 0xe372532b,
	    0xca273ece, 0xea26619c, 0xd186b8c7, 0x21c0c207,
	    0xeada7dd6, 0xcde0eb1e, 0xf57d4f7f, 0xee6ed178,
	    0x06f067aa, 0x72176fba, 0x0a637dc5, 0xa2c898a6,
	    0x113f9804, 0xbef90dae, 0x1b710b35, 0x131c471b,
	    0x28db77f5, 0x23047d84, 0x32caab7b, 0x40c72493,
	    0x3c9ebe0a, 0x15c9bebc, 0x431d67c4, 0x9c100d4c,
	    0x4cc5d4be, 0xcb3e42b6, 0x597f299c, 0xfc657e2a,
	    0x5fcb6fab, 0x3ad6faec, 0x6c44198c, 0x4a475817
	  ]

	  var W = new Array(160)

	  function Sha512() {
	    this.init()
	    this._w = W

	    Hash.call(this, 128, 112)
	  }

	  inherits(Sha512, Hash)

	  Sha512.prototype.init = function () {

	    this._a = 0x6a09e667|0
	    this._b = 0xbb67ae85|0
	    this._c = 0x3c6ef372|0
	    this._d = 0xa54ff53a|0
	    this._e = 0x510e527f|0
	    this._f = 0x9b05688c|0
	    this._g = 0x1f83d9ab|0
	    this._h = 0x5be0cd19|0

	    this._al = 0xf3bcc908|0
	    this._bl = 0x84caa73b|0
	    this._cl = 0xfe94f82b|0
	    this._dl = 0x5f1d36f1|0
	    this._el = 0xade682d1|0
	    this._fl = 0x2b3e6c1f|0
	    this._gl = 0xfb41bd6b|0
	    this._hl = 0x137e2179|0

	    this._len = this._s = 0

	    return this
	  }

	  function S (X, Xl, n) {
	    return (X >>> n) | (Xl << (32 - n))
	  }

	  function Ch (x, y, z) {
	    return ((x & y) ^ ((~x) & z));
	  }

	  function Maj (x, y, z) {
	    return ((x & y) ^ (x & z) ^ (y & z));
	  }

	  Sha512.prototype._update = function(M) {

	    var W = this._w
	    var a, b, c, d, e, f, g, h
	    var al, bl, cl, dl, el, fl, gl, hl

	    a = this._a | 0
	    b = this._b | 0
	    c = this._c | 0
	    d = this._d | 0
	    e = this._e | 0
	    f = this._f | 0
	    g = this._g | 0
	    h = this._h | 0

	    al = this._al | 0
	    bl = this._bl | 0
	    cl = this._cl | 0
	    dl = this._dl | 0
	    el = this._el | 0
	    fl = this._fl | 0
	    gl = this._gl | 0
	    hl = this._hl | 0

	    for (var i = 0; i < 80; i++) {
	      var j = i * 2

	      var Wi, Wil

	      if (i < 16) {
	        Wi = W[j] = M.readInt32BE(j * 4)
	        Wil = W[j + 1] = M.readInt32BE(j * 4 + 4)

	      } else {
	        var x  = W[j - 15*2]
	        var xl = W[j - 15*2 + 1]
	        var gamma0  = S(x, xl, 1) ^ S(x, xl, 8) ^ (x >>> 7)
	        var gamma0l = S(xl, x, 1) ^ S(xl, x, 8) ^ S(xl, x, 7)

	        x  = W[j - 2*2]
	        xl = W[j - 2*2 + 1]
	        var gamma1  = S(x, xl, 19) ^ S(xl, x, 29) ^ (x >>> 6)
	        var gamma1l = S(xl, x, 19) ^ S(x, xl, 29) ^ S(xl, x, 6)

	        // W[i] = gamma0 + W[i - 7] + gamma1 + W[i - 16]
	        var Wi7  = W[j - 7*2]
	        var Wi7l = W[j - 7*2 + 1]

	        var Wi16  = W[j - 16*2]
	        var Wi16l = W[j - 16*2 + 1]

	        Wil = gamma0l + Wi7l
	        Wi  = gamma0  + Wi7 + ((Wil >>> 0) < (gamma0l >>> 0) ? 1 : 0)
	        Wil = Wil + gamma1l
	        Wi  = Wi  + gamma1  + ((Wil >>> 0) < (gamma1l >>> 0) ? 1 : 0)
	        Wil = Wil + Wi16l
	        Wi  = Wi  + Wi16 + ((Wil >>> 0) < (Wi16l >>> 0) ? 1 : 0)

	        W[j] = Wi
	        W[j + 1] = Wil
	      }

	      var maj = Maj(a, b, c)
	      var majl = Maj(al, bl, cl)

	      var sigma0h = S(a, al, 28) ^ S(al, a, 2) ^ S(al, a, 7)
	      var sigma0l = S(al, a, 28) ^ S(a, al, 2) ^ S(a, al, 7)
	      var sigma1h = S(e, el, 14) ^ S(e, el, 18) ^ S(el, e, 9)
	      var sigma1l = S(el, e, 14) ^ S(el, e, 18) ^ S(e, el, 9)

	      // t1 = h + sigma1 + ch + K[i] + W[i]
	      var Ki = K[j]
	      var Kil = K[j + 1]

	      var ch = Ch(e, f, g)
	      var chl = Ch(el, fl, gl)

	      var t1l = hl + sigma1l
	      var t1 = h + sigma1h + ((t1l >>> 0) < (hl >>> 0) ? 1 : 0)
	      t1l = t1l + chl
	      t1 = t1 + ch + ((t1l >>> 0) < (chl >>> 0) ? 1 : 0)
	      t1l = t1l + Kil
	      t1 = t1 + Ki + ((t1l >>> 0) < (Kil >>> 0) ? 1 : 0)
	      t1l = t1l + Wil
	      t1 = t1 + Wi + ((t1l >>> 0) < (Wil >>> 0) ? 1 : 0)

	      // t2 = sigma0 + maj
	      var t2l = sigma0l + majl
	      var t2 = sigma0h + maj + ((t2l >>> 0) < (sigma0l >>> 0) ? 1 : 0)

	      h  = g
	      hl = gl
	      g  = f
	      gl = fl
	      f  = e
	      fl = el
	      el = (dl + t1l) | 0
	      e  = (d + t1 + ((el >>> 0) < (dl >>> 0) ? 1 : 0)) | 0
	      d  = c
	      dl = cl
	      c  = b
	      cl = bl
	      b  = a
	      bl = al
	      al = (t1l + t2l) | 0
	      a  = (t1 + t2 + ((al >>> 0) < (t1l >>> 0) ? 1 : 0)) | 0
	    }

	    this._al = (this._al + al) | 0
	    this._bl = (this._bl + bl) | 0
	    this._cl = (this._cl + cl) | 0
	    this._dl = (this._dl + dl) | 0
	    this._el = (this._el + el) | 0
	    this._fl = (this._fl + fl) | 0
	    this._gl = (this._gl + gl) | 0
	    this._hl = (this._hl + hl) | 0

	    this._a = (this._a + a + ((this._al >>> 0) < (al >>> 0) ? 1 : 0)) | 0
	    this._b = (this._b + b + ((this._bl >>> 0) < (bl >>> 0) ? 1 : 0)) | 0
	    this._c = (this._c + c + ((this._cl >>> 0) < (cl >>> 0) ? 1 : 0)) | 0
	    this._d = (this._d + d + ((this._dl >>> 0) < (dl >>> 0) ? 1 : 0)) | 0
	    this._e = (this._e + e + ((this._el >>> 0) < (el >>> 0) ? 1 : 0)) | 0
	    this._f = (this._f + f + ((this._fl >>> 0) < (fl >>> 0) ? 1 : 0)) | 0
	    this._g = (this._g + g + ((this._gl >>> 0) < (gl >>> 0) ? 1 : 0)) | 0
	    this._h = (this._h + h + ((this._hl >>> 0) < (hl >>> 0) ? 1 : 0)) | 0
	  }

	  Sha512.prototype._hash = function () {
	    var H = new Buffer(64)

	    function writeInt64BE(h, l, offset) {
	      H.writeInt32BE(h, offset)
	      H.writeInt32BE(l, offset + 4)
	    }

	    writeInt64BE(this._a, this._al, 0)
	    writeInt64BE(this._b, this._bl, 8)
	    writeInt64BE(this._c, this._cl, 16)
	    writeInt64BE(this._d, this._dl, 24)
	    writeInt64BE(this._e, this._el, 32)
	    writeInt64BE(this._f, this._fl, 40)
	    writeInt64BE(this._g, this._gl, 48)
	    writeInt64BE(this._h, this._hl, 56)

	    return H
	  }

	  return Sha512

	}


/***/ }
/******/ ])